var WsApi = {
    methods:[],
    BillingCycles:[],
    ServiceStatus:[],
    DomainStatus:[],
    ClientStatus:[],
    QuoteStatus:[],
    CancelTypes:[],
    FindUsTypes:[],
    methodsList:$('#ws-api-methods'),
    methodContent:$('#ws-api-method-content'),
    methodResponse:$('#ws-api-method-response'),
    ApiToken:"",
    formData:[],
    GetMethods:function(CallBack)
    {
        $.ajax({
            url: '/acp/ApiCodes',
            type: 'GET',
            dataType: 'json',
            success: (data) => {
                CallBack(data);
            },
            error: function(jqXHR, textStatus, errorThrown) {
                console.error('Error fetching file contents:', textStatus, errorThrown);
            }
        });
    },
    Init:function()
    {
        this.GetMethods(function(obj)
        {
            WsApi.methods = obj.ApiMethods;
            WsApi.BillingCycles = obj.BillingCycles;
            WsApi.ServiceStatus = obj.ServiceStatus;
            WsApi.DomainStatus = obj.DomainStatus;
            WsApi.ClientStatus = obj.ClientStatus;
            WsApi.QuoteStatus = obj.QuoteStatus;
            WsApi.CancelTypes = obj.CancelTypes;
            WsApi.FindUsTypes = obj.FindUsTypes;
            WsApi.CreateList();
            WsApi.initMethod();
        });
    },
    CreateList:function()
    {
        let h = window.height;
        let p = h-(h*0.13);
        let s = h-(h*0.20);
        $("#ws-api-methods").css({"height":s+"px","overflow-y":"scroll"});
        $(".ws-api-method-content-div").css({"height":p+"px","overflow-y":"scroll"});
        var c = 0;
        WsApi.methods.forEach(method =>
        {
            c++;
            var n = `${method.name || ''}`;
            var t = `${method.title || ''}`;
            var ok = `${method.tested || 'NO'}`;
            var badge = ``;
            if(ok == "OK") badge = `<span class="badge bg-success pull-right">Tested</span>`;
            $('#ws-api-methods').append(`<li onclick="WsApi.ClickLi('${n}');" class="api-methods-li ami-${n}">${t} ${badge}</li>`);
        });
        var SearchValue = WsApi.getStorage("ApiMethodSearchText");
        $("#ws-api-methods-search").val(SearchValue);
        WsApi.SearchInput(SearchValue);        
    },
    ClickLi:function(mName){
        WsApi.setMethod(mName);
    },
    setStorage:function(key, val) {
        localStorage.setItem(key, val);
    },
    getStorage:function(key = "") {
        if (typeof localStorage == 'undefined' || localStorage === null) return "";
        const item = localStorage.getItem(key);
        if (typeof item == 'undefined' || item === null) return "";
        return item;
    },
    initMethod:function() {
        const methodName = this.getStorage("ApiMethodName");
        if (methodName.length > 5) this.setMethod(methodName);
    },
    setMethod:function(methodName) {
        const method = WsApi.methods.find(m => m.name === methodName);
        $('#ws-api-method-response').html("");
        $(".api-methods-li").removeClass("active");
        $(`.ami-${method.name}`).addClass("active");
        this.setStorage("ApiMethodName", method.name);
        this.displayMethodContent(method);
    },
    checkDateWordExistence:function (inputString)
    {
        const dateWordRegex = /(?:date|time)/i;      
        return dateWordRegex.test(inputString.toLowerCase());
    },
    checkTextareaWordExistence:function (inputString)
    {
        const dateWordRegex = /(?:parameters|line_items|proposal|message|announcement_text|reason|notes|custom_fields|description)/i;      
        return dateWordRegex.test(inputString.toLowerCase());
    },
    checkIdWordExistence:function (inputString)
    {
        inputString = inputString.toLowerCase();
        if(inputString.endsWith("_id")) return true;
        return false;
    },
    checkAmountWordExistence:function (inputString)
    {
        const dateWordRegex = /(?:amount|price|rate|cost)/i;      
        return dateWordRegex.test(inputString.toLowerCase());
    },
    checkPasswordWordExistence:function (inputString)
    {
        const dateWordRegex = /(?:password|pwd)/i;      
        return dateWordRegex.test(inputString.toLowerCase());
    },
    checkBillingCycleWordExistence:function (inputString)
    {
        const dateWordRegex = /(?:billing_cycle)/i;      
        return dateWordRegex.test(inputString.toLowerCase());
    },
    checkServiceStatusWordExistence:function (inputString)
    {
        const dateWordRegex = /(?:service_status|domain_status)/i;      
        return dateWordRegex.test(inputString.toLowerCase());
    },
    status_list:function(name){
        let formHtml = `<select name="${name}" class="form-control api-inps-fields api-field-${name}">`;
        // Convert object to an array and use forEach
        Object.entries(WsApi.ServiceStatus).forEach(([key, value]) => {
            formHtml += `<option value="${key}">${value}</option>`;
        });     
        formHtml += `</select>`;
        return formHtml;
    },
    billing_cycle:function(name){
        let formHtml = `<select name="${name}" class="form-control api-inps-fields api-field-${name}">`;
        // Convert object to an array and use forEach
        Object.entries(WsApi.BillingCycles).forEach(([key, value]) => {
            formHtml += `<option value="${key}">${value}</option>`;
        });     
        formHtml += `</select>`;
        return formHtml;
    },
    CreateSelect:function(field)
    {
        if('optional' in field){
            var isOptional = field.optional;
        }else{
            var isOptional = 'yes';
        }
        var name = field.key;
        var options = field.options;
        if('default' in field){
            var isDefault = field.default;
        }else{
            var isDefault = '';
        }
        var isRequired = isOptional === "no" ? "required" : "";
        let formHtml = `<select name="${name}" class="form-control api-inps-fields api-field-${field.key}" ${isRequired}>`;
        // Convert object to an array and use forEach
        Object.entries(options).forEach(([key, value]) => {
            var isSelected = isDefault === key ? " selected " : "";
            formHtml += `<option value="${key}" ${isSelected}>${value}</option>`;
        });     
        formHtml += `</select>`;
        return formHtml;
    },
    validateNumbers:function(inputValue, inputType) {
        let regex;
        switch (inputType) {
            case 'float':
            case 'decimal':
                // Allows digits with optional decimal point
                regex = /^-?\d*\.?\d*$/;
                break;
            case 'number':
            case 'int':
                // Allows only digits
                regex = /^-?\d*$/;
                break;
            default:
                // Default to allow any input
                return true;
        }

        // Test the input value against the regex
        return regex.test(inputValue);
    },
    fieldVals:function(k,v,t,n)
    {
        var l = v.length;
        if(k == "token" && l<=0)
        {
            if(t.length>=2) return t;
            return v;
        }
        if(l<=0)
        {
            var mkv = WsApi.getStorage("api-"+n+"-"+k);
            if(mkv.length>0) return mkv;
        }
        if(k == "page_num") return 1;
        if(k == "limit_num") return 25;
        if(k == "sort_order") return "asc";
        return v;
    },
    displayMethodContent:function(method)
    {
        $('#ws-api-method-content,#ws-api-method-response').empty();
        const hostname = window.location.hostname;
        const type = method.type === "POST" ? "post" : "get";
        let paramsHtml = `<h4 class="headers">Parameters</h4>
        <style>
        .capi-parameters-table{background: transparent;padding:0px!important;}
        .capi-parameters-table > .cpth {background: #006699;padding:0px!important;text-align:center;}
        .capi-parameters-table > .cpth > div {color:#fff;fot-weight:bold;padding:0px!important; border-right:1px solid #fff;}
        .capi-parameters-table > .cptb {padding:0px!important;margin-top:10px;}
        .capi-parameters-table > .cptb > div {padding:3px 0px 3px 2px!important;border-bottom:1px solid #fff;}
        .capi-parameters-table > .cptb > div > div {padding:0px!important;}
        </style>
        <div class="col-md-12 capi-parameters-table">
        <div class="col-md-12 cpth">
            <div class="col-md-3">Field</div>
            <div class="col-md-1">Type</div>
            <div class="col-md-1">Optional</div>
            <div class="col-md-7">Description</div>
        </div><div class="col-md-12 cptb">`;
        
        let formHtml = `<div class="api-info-box pre-${type} col-md-12">
            <div class="api-info col-md-12">
                <h2>${method.title}</h2>
                <p>${method.description}</p>
                <div class="clearfix"></div>
                <pre class="full-pre pre-${type}" data-type="${type}"><span class="typ typ-${type}">${method.type}</span> <span class="url">https://${hostname}/capi/${method.url}</span></pre>                
            </div>
            <div class="clearfix"></div>
            <h2 class="hide-print">Send a Sample Request</h2>
            <form id="ApiMethodForm" method="post" onsubmit="WsApi.submit(this,event);return false;">`;
            var ApiFieldToken = WsApi.getStorage("api-field-token");
            
        method.fields.forEach(field =>
        {
            if(field.key != "action")
            {
                var desc = `${field.description || 'NO'}`;
                paramsHtml += `<div class="col-md-12"><div style="font-weight:bold;color:#333;" class="col-md-3 copy-inp-text">${field.key}</div><div class="col-md-1">${field.type}</div><div class="col-md-1 text-${field.optional === "no" ? "danger" : "success"}">${field.optional === "no" ? "Required" : "Optional"}</div><div class="col-md-7 capi-table-td">${field.description || ''}</div></div>`;
                if(WsApi.checkTextareaWordExistence(field.key) === true)
                {
                    formHtml += `<div class="col-md-12">`;
                }else{
                    formHtml += `<div class="col-md-6" style="height:70px;">`;
                }
                formHtml += `<div class="col-md-12 p-0 m-0"><span class="copy-inp-text">${field.key}</span>`;
                                formHtml += `${field.optional === "no" ? "<span style=\"font-size: 19px;float: right;height: 0px;width: 20px;margin-left: 4px;color: #f44336;\">*</span>" : ""}
                                </div>`;

                let v = field.value || '';
                let d = field.default || '';                
                const o = field.optional === "no" ? 'no' : 'yes';
                if (d.length >= 2) v = d;
                v = WsApi.fieldVals(field.key,v,ApiFieldToken,method.name);
                let t = field.type;
                if (field.type === "int") t = "number";
                if (field.type === "decimal") t = "number";
                if (field.type === "float") t = "number";
                if (field.type === "string") t = "text";
                if (field.type === "bool") t = "yesno";
                if (field.type === "radio") t = "yesno";
                if (field.key === "email") t = "email";
                if (field.key === "color") t = "color";
                if (WsApi.checkDateWordExistence(field.key) === true) t = "date";
                if (WsApi.checkPasswordWordExistence(field.key) === true) t = "password";
                if(t != "number" && WsApi.checkIdWordExistence(field.key) === true) t = "number";

                if (t === "yesno")
                {
                    if (v.length < 2) v = o;
                    formHtml += `<select class="form-control api-inps-fields api-field-${field.key}" name="${field.key}" ${field.optional === "no" ? "required" : ""}>
                    <option value="yes" ${v === "yes" ? "selected" : ""} >Yes</option>
                    <option value="no" ${v === "no" ? "selected" : ""} >No</option>
                    </select>`;
                }
                else
                {
                    if(WsApi.checkBillingCycleWordExistence(field.key))
                    {
                        formHtml += WsApi.billing_cycle(field.key);
                    }else if(WsApi.checkServiceStatusWordExistence(field.key))
                    {
                        formHtml += WsApi.status_list(field.key);
                    }else{
                        var opt = `${field.options || 'NO'}`;
                        if(opt != "NO")
                        {
                            formHtml += WsApi.CreateSelect(field);
                        }else{
                            var jsf = "";
                            if(t == "number" && WsApi.checkAmountWordExistence(field.key) === true) jsf = ` step="any" `;
                            if(WsApi.checkTextareaWordExistence(field.key) === true)
                            {
                                formHtml += `<textarea name="${field.key}" ${jsf} class="form-control api-inps-fields api-field-${field.key}" autocomplete="off" rows="5" ${field.optional === "no" ? "required" : ""}>${v}</textarea><div class="clearfix"></div>`;
                            }else{
                                formHtml += `<input type="${t}" name="${field.key}" ${jsf} class="form-control api-inps-fields api-field-${field.key}" value="${v}" autocomplete="off" ${field.optional === "no" ? "required" : ""}>`;
                            }
                        }
                    }
                }
                if(desc.length>2)
                {
                formHtml += `<div class="ws-tooltip ws-ttinp" style="margin-top: -60px !important;">
                    <i class="icon-help"></i>
                    <div class="ws-tooltip-content">
                        <div class="ws-tooltip-text">${desc}</div>
                    </div>
                </div>`;
                }                
                formHtml += `</div>`;
            }
        });

        paramsHtml += `</div></div>`;
        formHtml += `<div class="clearfix"></div><br><button type="submit" class="btn btn-success pull-right WsSendRequest">Submit</button></form><div class="clearfix"></div>${paramsHtml}</div><div class="clearfix"></div>`;
        $('#ws-api-method-content').html(formHtml);
        const formData = $("#ApiMethodForm").serializeArray();
        WsApi.formData = formData;
        const formattedData = WsApi.formatDataForCurl(formData);       
        WsApi.displayCodeExamples(method, formattedData,WsApi.formatResponse(method.response,false));
    },
    submit:function(e,event)
    {
            event.preventDefault();
            ws.bloader('.ivContentbloader',1); 
            const methodName = this.getStorage("ApiMethodName");
            const method = WsApi.methods.find(m => m.name === methodName);
            WsApi.setStorage("api-field-token",$(".api-field-token").val());
            $('.api-inps-fields').each(function()
            {
              let name = $(this).attr('name');
              let value = $(this).val();
              WsApi.setStorage("api-"+methodName+"-"+name,value);
            });
            
            const hostname = window.location.hostname;
            const uri = `https://${hostname}/capi/${method.url}`;
            const formData = $(e).serializeArray();
            WsApi.formData = formData;
            const formattedData = WsApi.formatDataForCurl(formData);
            $.ajax({
                url: uri,
                type: method.type,
                data: formData,
                success: (response) => {
                    WsApi.displayCodeExamples(method, formattedData,WsApi.formatResponse(response,true),true);
                    //WsApi.scrollToResponse();
                    ws.bloader('.ivContentbloader',2);
                },
                error: (xhr) => {
                    //$('#ws-api-method-response').html(`${xhr.responseText}`);
                    WsApi.displayCodeExamples(method, formattedData,WsApi.formatResponse(xhr.response,true),true);
                    //WsApi.scrollToResponse();
                    ws.bloader('.ivContentbloader',2);
                }
            });
            return false;
    },
    scrollToResponse:function() {
        $('html, body').animate({
            scrollTop: $('#ws-api-method-response').offset().top
        }, 1000);
    },
    formatResponse:function(response,isObj=true)
    {
        let formattedHtml = '';
        if(isObj)
        {
            const obj = JSON.parse(response);
            const prettyJson = JSON.stringify(obj, null, 4);
            if(obj.status == "success")
            {
                formattedHtml = `<pre class="alert alert-success">${prettyJson}</pre>`;
            }else{
                formattedHtml = `<pre class="alert alert-danger">${prettyJson}</pre>`;
            }
        }
        else
        {
            const prettyJson = JSON.stringify(response, null, 4);
            if(response.status == "success")
            {
                formattedHtml = `<pre class="alert alert-success">${prettyJson}</pre>`;
            }else{
                formattedHtml = `<pre class="alert alert-danger">${prettyJson}</pre>`;
            }
        }
        return formattedHtml;
    },
    formatDataForCurl:function(formData) {
        return formData.map(field => `'${field.name}' => '${field.value}'`).join(', ');
    },
    displayCodeExamples:function(method, formattedData,ResponseData,AjaxResponse=false)
    {
        const hostname = window.location.hostname;
        const url = `https://${hostname}/capi/${method.url}`;
        //const url = method.url;
var fdata = WsApi.formData;
var phpArrData = "";
fdata.forEach(field => {
    phpArrData += `"${field.name}"=>"${field.value}",<br>`;
});

        const phpCode = `&lt;?php
$curl = curl_init();
curl_setopt_array($curl, array(
  CURLOPT_URL => &apos;${url}&apos;,
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => &apos;&apos;,
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 0,
  CURLOPT_FOLLOWLOCATION => true,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => &apos;POST&apos;,
  CURLOPT_POSTFIELDS =>[<br>${phpArrData}],
));

$response = curl_exec($curl);

curl_close($curl);
echo $response;
?&gt;`;

var PhpPeclCode = `&lt;?php
$client = new http\Client;
$request = new http\Client\Request;
$request->setRequestUrl('${url}');
$request->setRequestMethod('POST');
$body = new http\Message\Body;
$body->addForm([<br>${phpArrData}],[]);
$request->setBody($body);
$request->setOptions(array());

$client->enqueue($request)->send();
$response = $client->getResponse();
echo $response->getBody();`;

var csharpCode = `var client = new HttpClient();
var request = new HttpRequestMessage(HttpMethod.Post, "${url}");
var content = new MultipartFormDataContent();<br>`;
fdata.forEach(field => {
    csharpCode += `content.Add(new StringContent("${field.value}"), "${field.name}");`;
    csharpCode += '<br>';
});
csharpCode += `request.Content = content;
var response = await client.SendAsync(request);
response.EnsureSuccessStatusCode();
Console.WriteLine(await response.Content.ReadAsStringAsync());`;

var csharpRestCode = `var options = new RestClientOptions("")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("${url}", Method.Post);
request.AlwaysMultipartFormData = true;<br>`;
fdata.forEach(field => {
    csharpRestCode += `request.AddParameter("${field.name}", "${field.value}");`;
    csharpRestCode += '<br>';
});
csharpRestCode += `RestResponse response = await client.ExecuteAsync(request);<br>
Console.WriteLine(response.Content);`;


var KotlinCode = `val client = OkHttpClient()
val mediaType = "text/plain".toMediaType()
val body = MultipartBody.Builder().setType(MultipartBody.FORM)<br>`;
fdata.forEach(field => {
    KotlinCode += `  .addFormDataPart("${field.name}","${field.value}")`;
    KotlinCode += '<br>';
});
KotlinCode += `  .build()
val request = Request.Builder()
  .url("${url}")
  .post(body)
  .build()
val response = client.newCall(request).execute()`;
var NodeJsData = formattedData.replace(/' => '/g, "':'");
NodeJsData = NodeJsData.replace(/', '/g, "',<br>'");
var NodeJsCode = `var request = require('request');
var options = {
  'method': 'POST',
  'url': '${url}',
  'headers': {
  },
  formData: {<br>${NodeJsData}<br>}
};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});`;

var dartData = formattedData.replace(/' => '/g, "':'");
dartData = dartData.replace(/', '/g, "',<br>'");

var DartCode = `var data = FormData.fromMap({<br>${dartData}<br>});
var dio = Dio();
var response = await dio.request(
  '${url}',
  options: Options(
    method: 'POST',
  ),
  data: data,
);

if (response.statusCode == 200) {
  print(json.encode(response.data));
}
else {
  print(response.statusMessage);
}`;

var pythonData = formattedData.replace(/' => '/g, "':'");
pythonData = pythonData.replace(/', '/g, "',<br>'");
        const pythonCode = `import requests
url = "${url}"
payload = {<br>${pythonData}<br>}
files=[
]
headers = {}
response = requests.request("POST", url, headers=headers, data=payload, files=files)
print(response.text)
`;

var rubyData = formattedData.replace(/' => '/g, "','");
rubyData = rubyData.replace(/', '/g, "'],<br>['");
var rubyCode = `require "uri"
require "net/http"
url = URI("${url}")
https = Net::HTTP.new(url.host, url.port)
https.use_ssl = true
request = Net::HTTP::Post.new(url)
form_data = [<br>[${rubyData}]<br>]
request.set_form form_data, 'multipart/form-data'
response = https.request(request)
puts response.read_body`;



        const tabsHtml = `<h4 class="headers">Code snippets</h4><div class="clearfix"></div><div class="api-tabbable">
            <ul class="nav-tabs-component nav-justified api-nav-tabs">
                <li class="tab-link active" data-lang="php"><a>PHP (cURL)</a></li>
                <li class="tab-link" data-lang="phppecl"><a>PHP (pecl_http)</a></li>
                <li class="tab-link" data-lang="csharp"><a>C#</a></li>
                <li class="tab-link" data-lang="csharpRestSharp"><a>C# RestSharp</a></li>
                <li class="tab-link" data-lang="KotlinCode"><a>Kotlin</a></li>
                <li class="tab-link" data-lang="NodeJsCode"><a>NodeJs</a></li>
                <li class="tab-link" data-lang="python"><a>Python</a></li>
                <li class="tab-link" data-lang="ruby"><a>Ruby</a></li>
                <li class="tab-link" data-lang="DartCode"><a>Dart - dio</a></li>
            </ul>
            <div class="tabs-content api-example-box php active"><pre>${phpCode}</pre></div>
            <div class="tabs-content api-example-box phppecl"><pre>${PhpPeclCode}</pre></div>
            <div class="tabs-content api-example-box csharp"><pre>${csharpCode}</pre></div>
            <div class="tabs-content api-example-box csharpRestSharp"><pre>${csharpRestCode}</pre></div>
            <div class="tabs-content api-example-box KotlinCode"><pre>${KotlinCode}</pre></div>
            <div class="tabs-content api-example-box NodeJsCode"><pre>${NodeJsCode}</pre></div>
            <div class="tabs-content api-example-box python"><pre>${pythonCode}</pre></div>
            <div class="tabs-content api-example-box ruby"><pre>${rubyCode}</pre></div>
            <div class="tabs-content api-example-box DartCode"><pre>${DartCode}</pre></div>
            </div>`;
        $(".code-example,.code-response").remove();
        $('#ws-api-method-content').append(`
            <div class="code-response"><h4 class="headers">Response</h4><div class="req-response">${ResponseData}</div><div class="clearfix"></div></div>
            <div class="code-example">
                <button class="copy-btn">Copy Code</button>
                ${tabsHtml}
            </div>
        `);

        $('.api-nav-tabs > .tab-link').on('click', function () {
            const lang = $(this).data('lang');
            $('.tabs-content').removeClass('active');
            $('.api-nav-tabs > .tab-link').removeClass('active');
            $(`.tabs-content.${lang}`).addClass('active');
            $(this).addClass('active');
        });

        $('.copy-btn').on('click', function () {
            const activeCode = $('.tabs-content.active pre').text();
            navigator.clipboard.writeText(activeCode).then(() => {
                alert('Code copied to clipboard!');
            });
        });
        if(AjaxResponse)
        {
            $(".WsApiResponse").click();            
        }
    },
    SearchInput:function(value="") 
    {
        this.setStorage("ApiMethodSearchText",value);
        $('#ws-api-methods li').filter(function() 
        {
            $(this).toggle($(this).text().toLowerCase().indexOf(value) > -1);
        });
    }
}
$(document).ready(function () {
    WsApi.Init();    
});
$(document).ready(function() {
    $('#ws-api-methods-search').on('keyup', function()
    {
        var value = $(this).val().toLowerCase();
        WsApi.SearchInput(value);
    });
});