<?php 
use Hybridauth\Hybridauth;
use Hybridauth\HttpClient;
function twitter_config($arg=[])
{
    return array(
            "name" => "Twitter", 
            "description" => "Single Signin using Twitter",
            "version" => "1.0",
            "author" => "whasols.com",
            "author_url" => "",
            "icon"=>"fab fa-twitter",
            "class"=>"btn btn-twitter",
            "notes" => "Twitter Single Signin Required mention below fields to activate this.",
            "configs"=>[
                "id"=>["Name"=>"Your Twitter Key","Type"=>"text"],
                "secret"=>["Name"=>"Your Twitter Secret","Type"=>"text"],
            ]
    );
}
function twitter_link($arg)
{
    $id = $arg["id"];
    $secret = $arg["secret"];
    $callbackurl = $arg["callbackurl"];
    $config = [
        'callback' => $callbackurl,
        'providers' => [
            'Twitter' => [
                'enabled' => true,
                'keys' => ['key' =>$id, 'secret' =>$secret],
            ]
        ],
    ];
    try {
        $hybridauth = new Hybridauth($config);
        $adapter = $hybridauth->authenticate('Twitter');
        $tokens = $adapter->getAccessToken();
        $userProfile = $adapter->getUserProfile();
        $adapter->disconnect();
    } catch (\Exception $e) {
        return ["status"=>"error","message"=>$e->getMessage()];
    }    
    return $userProfile;
}
function twitter_activate($arg)
{
 return ['status'=>'success','message'=>"Activated"];
}
function twitter_callback($arg)
{
    $id = $arg["id"];
    $secret = $arg["secret"];
    $callbackurl = $arg["callbackurl"];
    $config = [
        'callback' => $callbackurl,
        'providers' => [
            'Twitter' => [
                'enabled' => true,
                'keys' => ['key' =>$id, 'secret' =>$secret],
            ]
        ],
    ];
    $oauth_token = $_REQUEST["oauth_token"];
    try {
        $hybridauth = new Hybridauth($config);
        $adapter = $hybridauth->authenticate('Twitter');
        $adapter->setAccessToken($oauth_token);
        $userProfile = $adapter->getUserProfile();
        $adapter->disconnect();
    } catch (\Exception $e) {
        return ["status"=>"error","message"=>$e->getMessage()];
    }
    if(empty($userProfile)) return ["status"=>"error","message"=>"Information fetching failed"];
    return ["status"=>"success","data"=>["tokens"=>$tokens,
        "identifier"=>$userProfile->identifier,"email"=>$userProfile->email,"profileURL"=>$userProfile->profileURL,"photoURL"=>$userProfile->photoURL,
        "Name"=>$userProfile->displayName,"firstName"=>$userProfile->firstName,"lastName"=>$userProfile->lastName,"gender"=>$userProfile->gender,"phone"=>$userProfile->phone,
        "age"=>$userProfile->age,"address"=>$userProfile->address,"country"=>$userProfile->country,"region"=>$userProfile->region,"city"=>$userProfile->city,
        "zip"=>$userProfile->zip,"followed_by"=>$userProfile->data["followed_by"],"follows"=>$userProfile->data["follows"],
        ]
    ];
}