<?php 
use Hybridauth\Hybridauth;
use Hybridauth\HttpClient;
function wordpress_config($arg=[])
{
    return array(
            "name" => "WordPress", 
            "description" => "Single Signin using WordPress",
            "version" => "1.0",
            "author" => "WHASOLS.com",
            "author_url" => "",
            "notes" => "WordPress Single Signin Required mention below fields to activate this.",
            "icon"=>"fab fa-wordpress",
            "class"=>"btn btn-wordpress",
            "configs"=>[
                "id"=>["Name"=>"Your WordPress Client ID","Type"=>"text"],
                //"secret"=>["Name"=>"Your WordPress App Secret","Type"=>"text"],
            ]
    );
}
function wordpress_link($arg)
{
    $id = $arg["id"];
    $callbackurl = $arg["callbackurl"];
    $config = [
        'callback' => $callbackurl,
        'providers' => [
            'WordPress' => [
                'enabled' => true,
                'keys' => ['key' =>$id],
            ]
        ],
    ];
    try {
        $hybridauth = new Hybridauth($config);
        $adapter = $hybridauth->authenticate('WordPress');
        $tokens = $adapter->getAccessToken();
        $userProfile = $adapter->getUserProfile();
        $adapter->disconnect();
    } catch (\Exception $e) {
        return ["status"=>"error","message"=>$e->getMessage()];
    }    
    return $userProfile;
}
function wordpress_activate($arg)
{
 return ['status'=>'success','message'=>"Activated"];
}
function wordpress_callback($arg)
{
    $id = $arg["id"];
    $callbackurl = $arg["callbackurl"];
    $config = [
        'callback' => $callbackurl,
        'providers' => [
            'WordPress' => [
                'enabled' => true,
                'keys' => ['key' =>$id],
            ]
        ],
    ];
    $oauth_token = $_REQUEST["code"];
    try {
        $hybridauth = new Hybridauth($config);
        $adapter = $hybridauth->authenticate('WordPress');
        $tokens = $adapter->getAccessToken();
        $adapter->setAccessToken($tokens);
        $userProfile = $adapter->getUserProfile();
        $adapter->disconnect();
    } catch (\Exception $e) {
        return ["status"=>"error","message"=>$e->getMessage()];
    }
    if(empty($userProfile)) return ["status"=>"error","message"=>"Information fetching failed"];
    return ["status"=>"success","data"=>["tokens"=>$tokens,
        "identifier"=>$userProfile->identifier,"email"=>$userProfile->email,"profileURL"=>$userProfile->profileURL,"photoURL"=>$userProfile->photoURL,
        "Name"=>$userProfile->displayName,"firstName"=>$userProfile->firstName,"lastName"=>$userProfile->lastName,"gender"=>$userProfile->gender,"phone"=>$userProfile->phone,
        "age"=>$userProfile->age,"address"=>$userProfile->address,"country"=>$userProfile->country,"region"=>$userProfile->region,"city"=>$userProfile->city,
        "zip"=>$userProfile->zip,"followed_by"=>$userProfile->data["followed_by"],"follows"=>$userProfile->data["follows"],
        ]
    ];
}