<?php
function google_config()
{
	$configarray = [
	"name" => "Google reCAPTCHA v2",
	"description" => "Google's reCAPTCHA system v2",
	"version" => "1",//Your Module Version Number
	"author" => "WHASOLS",
	"author_url" => "https://whasols.com/",
	"language" => "english",
	"configs" => [
                    "GOOGLE_SITE_KEY" => [
                    "Name" => "reCAPTCHA Site Key", 
                    "Type" =>  "text", 
                    "Description" =>'You need to register for reCAPTCHA @ <a href="https://www.google.com/recaptcha/admin" target="_blank">Click Here</a>', 
                    "Default" => "",
                    "DivColumns" => 12,
                ],
                    "GOOGLE_SECRET_KEY" => [
                    "Name" => "reCAPTCHA Secret Key", 
                    "Type" =>  "text", 
                    "Description" => "", 
                    "Default" => "",
                    "DivColumns" => 12,
                ],
	        ],
	    ];
	return $configarray;	
}
function google_generate_captcha($args=[])
{
    $eConfig = _s('captcha-configs-google', $args);
    $configurations = _jd($eConfig, true);
    $SITE_KEY = _s("GOOGLE_SITE_KEY",$configurations,"");
	$html = '<script src="https://www.google.com/recaptcha/api.js"></script>
               <div class="g-recaptcha" data-sitekey="'.$SITE_KEY.'"></div><br>';
    return $html;
}
function google_getanswer()
{
    $ans = getSession("CAPTCHA_ANS");
    return empty($ans) ? 0:$ans;
}
function google_ResetAnswer(){
    setSession("CAPTCHA_ANS",0);
}
function google_validate($args=[])
{
    $eConfig = _s('captcha-configs-google', $args);
    $configurations = _jd($eConfig, true);
    $secret = _s("GOOGLE_SECRET_KEY",$configurations,"");

    $google_url="https://www.google.com/recaptcha/api/siteverify";
    $ip=GetUserIpAddress();
    $recaptcha = _s('g-recaptcha-response', $_POST,"");
    if(empty($recaptcha)) return ['status'=>'error', 'message'=>WsLang('CaptchaReEnterPlease')];
    $url=$google_url."?secret=".$secret."&response=".$recaptcha."&remoteip=".$ip;
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_URL, $url);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_TIMEOUT, 10);
    curl_setopt($curl, CURLOPT_USERAGENT, "Mozilla/5.0 (Windows; U; Windows NT 6.1; en-US; rv:1.9.2.16) Gecko/20110319 Firefox/3.6.16");
    $res = curl_exec($curl);
    curl_close($curl);
    $res= _jd($res, true);
    if(!_s('success', $res)) return ['status'=>'error', 'message'=>WsLang('CaptchaReEnterPlease')];
	return [];
}