<?php
function gtcaptcha_config()
{
	$configarray = [
	"name" => "GeeTest Captcha (Drag & Drop)",
	"description" => "To use GeeTest Captcha you will need a Sitekey and your Account Secret",
	"version" => "1",//Your Module Version Number
	"author" => "WHASOLS",
	"author_url" => "https://whasols.com/",
	"language" => "english",
	"configs" => [
                    "captcha_id" => [
                    "Name" => "GeeTest Captcha ID", 
                    "Type" =>  "text", 
                    "Description" =>'You need to register for GeeTest Captcha @ <a href="https://geetest.com/adaptive-captcha" target="_blank">Click Here</a>', 
                    "Default" => "",
                    "DivColumns" => 12,
                ],
                    "captcha_key" => [
                    "Name" => "GeeTest Captcha Key", 
                    "Type" =>  "text", 
                    "Description" => "", 
                    "Default" => "",
                    "DivColumns" => 12,
                ],
	        ],
	    ];
	return $configarray;	
}
function gtcaptcha_generate_captcha($args=[])
{
    $eConfig = _s('captcha-configs-gtcaptcha', $args);
    $configurations = _jd($eConfig, true);
    $captcha_id = _s("captcha_id",$configurations,"");
	$html = '<script src="http://static.geetest.com/v4/gt4.js"></script>
    <script>
    initGeetest4(
  {
    captchaId: "'.$captcha_id.'",
  },
  function (captcha) {
    // call appendTo to insert CAPTCHA into an element of the page, which can be customized by you
    captcha.appendTo(".gtcaptcha");
  }
);</script>
    <div class="gtcaptcha"></div><br>';
    return $html;
}
function gtcaptcha_getanswer()
{
    $ans = getSession("CAPTCHA_ANS");
    return empty($ans) ? 0:$ans;
}
function gtcaptcha_ResetAnswer(){
    setSession("CAPTCHA_ANS",0);
}
function gtcaptcha_validate($args=[])
{
    $eConfig = _s('captcha-configs-procaptcha', $args);
    $configurations = _jd($eConfig, true);
    $SECRET_KEY = _s("SECRET_KEY",$configurations,"");   
    // cURL initialization
    $curl = curl_init();
    // Set the POST fields and options
    curl_setopt_array($curl, [
        CURLOPT_URL => "https://api.prosopo.io/siteverify",
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_POST => true,
        CURLOPT_HTTPHEADER => [
            "Content-Type: application/json",
        ],
        CURLOPT_POSTFIELDS => json_encode([
            'token' => $_POST['procaptcha-response'],
            'secret' => $SECRET_KEY
        ]),
    ]);
    // Execute the POST request
    $response = curl_exec($curl);
    // Check for any cURL errors
    if (curl_errno($curl))
    {
        $error = curl_error($curl);
        curl_close($curl);
        return ['status'=>'error', 'message'=>'cURL error: ' . $error];
    }
    // Handle the response
    $responseData = json_decode($response, true);
    curl_close($curl);
    if($responseData["verified"]) return [];
    return ['status'=>'error', 'message'=>"Captcha Verification failed"];
}