<?php
function hcaptcha_config()
{
	$configarray = [
	"name" => "hCaptcha",
	"description" => "To use hCaptcha you will need a Sitekey and your Account Secret",
	"version" => "1",//Your Module Version Number
	"author" => "WHASOLS",
	"author_url" => "https://whasols.com/",
	"language" => "english",
	"configs" => [
                    "SITE_KEY" => [
                    "Name" => "hCaptcha Site Key", 
                    "Type" =>  "text", 
                    "Description" =>'You need to register for hCaptcha @ <a href="https://hcaptcha.com" target="_blank">Click Here</a>', 
                    "Default" => "",
                    "DivColumns" => 12,
                ],
                    "SECRET_KEY" => [
                    "Name" => "hCaptcha Secret Key", 
                    "Type" =>  "text", 
                    "Description" => "", 
                    "Default" => "",
                    "DivColumns" => 12,
                ],
	        ],
	    ];
	return $configarray;	
}
function hcaptcha_generate_captcha($args=[])
{
    $eConfig = _s('captcha-configs-hcaptcha', $args);
    $configurations = _jd($eConfig, true);
    $SITE_KEY = _s("SITE_KEY",$configurations,"");
	$html = '<script src="https://www.hCaptcha.com/1/api.js" async defer></script>
    <div class="h-captcha" data-sitekey="'.$SITE_KEY.'"></div><br>';
    return $html;
}
function hcaptcha_getanswer()
{
    $ans = getSession("CAPTCHA_ANS");
    return empty($ans) ? 0:$ans;
}
function hcaptcha_ResetAnswer(){
    setSession("CAPTCHA_ANS",0);
}
function hcaptcha_validate($args=[])
{
    $eConfig = _s('captcha-configs-hcaptcha', $args);
    $configurations = _jd($eConfig, true);
    $SECRET_KEY = _s("SECRET_KEY",$configurations,"");    
    $data = array(
                'secret' => $SECRET_KEY,
                'response' => $_POST['h-captcha-response']
            );
    $verify = curl_init();
    curl_setopt($verify, CURLOPT_URL, "https://hcaptcha.com/siteverify");
    curl_setopt($verify, CURLOPT_POST, true);
    curl_setopt($verify, CURLOPT_POSTFIELDS, http_build_query($data));
    curl_setopt($verify, CURLOPT_RETURNTRANSFER, true);
    $response = curl_exec($verify);
    // var_dump($response);
    $responseData = json_decode($response);
    if($responseData->success) return [];
    return ['status'=>'error', 'message'=>"Captcha Verification failed"];
}