<?php
function icaptcha_config()
{
	$configarray = [
	"name" => "Image Captcha",
	"description" => "Image captcha based on random text which generated onload",
	"version" => "1",//Your Module Version Number
	"author" => "WHASOLS",
	"author_url" => "https://whasols.com/",
	"language" => "english",
	"configs" => [
	        ],
	    ];
	return $configarray;	
}

function icaptcha_generate_answer(): string
{
    $characters = 'ABCDEFGH0123abcdefghJKLMNOPQR456ijkmnopqrSTUVWXYZstuvwxyz789';
    $captchaText = substr(str_shuffle($characters), 0, 7);

    setSession("CAPTCHA_ANS", $captchaText);
    return $captchaText;
}


// Function to generate the CAPTCHA image and return it as a base64-encoded string
function icaptcha_generateCaptchaAsBase64()
{
    $captchaText = icaptcha_generate_answer();
    // Set the image width, height, and create a blank image with truecolor (supports transparency)
    $imageWidth = 150;
    $imageHeight = 50;
    $image = imagecreatetruecolor($imageWidth, $imageHeight);

    // Enable alpha blending (so transparency works) and save full alpha channel
    imagesavealpha($image, true);
    imagealphablending($image, false);

    // Set the transparent background color
    $transparentBackground = imagecolorallocatealpha($image, 0, 0, 0, 127); // Fully transparent
    imagefill($image, 0, 0, $transparentBackground); // Fill the background with transparency

    // Set other colors (text, lines, dots)
    $textColor = imagecolorallocate($image, 0, 0, 0); // Black text
    $lineColor = imagecolorallocate($image, 64, 64, 64); // Line color
    $dotColor = imagecolorallocate($image, 0, 0, 0); // Dot color

    // Add random lines to the image for added security
    for ($i = 0; $i < 10; $i++) {
        imageline($image, rand(0, $imageWidth), rand(0, $imageHeight), rand(0, $imageWidth), rand(0, $imageHeight), $lineColor);
    }

    // Add random dots to the image for added security
    for ($i = 0; $i < 500; $i++) {
        imagesetpixel($image, rand(0, $imageWidth), rand(0, $imageHeight), $dotColor);
    }
    $randomFont = rand(0,6);
    $founts = ["arial","Courier_New","Verdana_Bold","Arial_Bold","Verdana","Arial_Bold_Italic","arial"];
    $fontName = $founts[$randomFont];
    // Add the CAPTCHA text to the image
    $fontSize = 20; // Font size
    $fontPath = __DIR__ . '/fonts/'.$fontName.'.ttf'; // Path to a .ttf font file
    $x = 15; // X position of text
    $y = 35; // Y position of text
    imagettftext($image, $fontSize, 0, $x, $y, $textColor, $fontPath, $captchaText);

    // Capture the output into a buffer instead of outputting the image directly
    ob_start();
    imagepng($image);
    $imageData = ob_get_contents();
    ob_end_clean();

    // Free memory associated with the image
    imagedestroy($image);

    // Return the base64-encoded image
    return 'data:image/png;base64,' . base64_encode($imageData);
}
function icaptcha_generate_captcha($args=[])
{
	$cRand = icaptcha_generateCaptchaAsBase64();
	$html = '<div class="row w-100">
                    <div class="col-md-12" style="float: left;width:100%;">
                    '.(WsLang('Captcha')).' : <div class="clearfix"></div>
                        <div class="col-md-6 pull-left text-right" style="line-height: 55px;"><img src="'.$cRand.'" alt="CAPTCHA Image">
                        </div>
                        <div class="col-md-6 pull-right"><input type="text" name="captchaans" placeholder="'.(WsLang('CaptchaAnswer')).'" class="form-control" style="float: right;border: 1px solid #ccc;">
                        </div>
                    </div>
                </div>';
    return $html;
}
function icaptcha_getanswer()
{
    return getSession("CAPTCHA_ANS");
}
function icaptcha_resetanswer(){
    setSession("CAPTCHA_ANS",0);
}
function icaptcha_validate($args=[])
{
	$ans = _s("answer",$args,0);
    if(empty($ans)) $ans = _s("captchaans",$_POST,0);
	$gans = icaptcha_getanswer();
	if($ans != $gans) return ['status'=>'error', 'message'=>WsLang('CaptchaEnterValidAnswer')];
	return [];
}