<?php
function procaptcha_config()
{
	$configarray = [
	"name" => "Procaptcha ",
	"description" => "To use Procaptcha you will need a Sitekey and your Account Secret",
	"version" => "1",//Your Module Version Number
	"author" => "WHASOLS",
	"author_url" => "https://whasols.com/",
	"language" => "english",
	"configs" => [
                    "SITE_KEY" => [
                    "Name" => "Procaptcha Site Key", 
                    "Type" =>  "text", 
                    "Description" =>'You need to register for Procaptcha @ <a href="https://prosopo.io" target="_blank">Click Here</a>', 
                    "Default" => "",
                    "DivColumns" => 12,
                ],
                    "SECRET_KEY" => [
                    "Name" => "Procaptcha Secret Key", 
                    "Type" =>  "text", 
                    "Description" => "", 
                    "Default" => "",
                    "DivColumns" => 12,
                ],
	        ],
	    ];
	return $configarray;	
}
function procaptcha_generate_captcha($args=[])
{
    $eConfig = _s('captcha-configs-procaptcha', $args);
    $configurations = _jd($eConfig, true);
    $SITE_KEY = _s("SITE_KEY",$configurations,"");
	$html = '<script type="module" src="https://js.prosopo.io/js/procaptcha.bundle.js" async defer></script>
    <div class="procaptcha" data-sitekey="'.$SITE_KEY.'"></div><br>';
    return $html;
}
function procaptcha_getanswer()
{
    $ans = getSession("CAPTCHA_ANS");
    return empty($ans) ? 0:$ans;
}
function procaptcha_ResetAnswer(){
    setSession("CAPTCHA_ANS",0);
}
function procaptcha_validate($args=[])
{
    $eConfig = _s('captcha-configs-procaptcha', $args);
    $configurations = _jd($eConfig, true);
    $SECRET_KEY = _s("SECRET_KEY",$configurations,"");   
    // cURL initialization
    $curl = curl_init();
    // Set the POST fields and options
    curl_setopt_array($curl, [
        CURLOPT_URL => "https://api.prosopo.io/siteverify",
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_POST => true,
        CURLOPT_HTTPHEADER => [
            "Content-Type: application/json",
        ],
        CURLOPT_POSTFIELDS => json_encode([
            'token' => $_POST['procaptcha-response'],
            'secret' => $SECRET_KEY
        ]),
    ]);
    // Execute the POST request
    $response = curl_exec($curl);
    // Check for any cURL errors
    if (curl_errno($curl))
    {
        $error = curl_error($curl);
        curl_close($curl);
        return ['status'=>'error', 'message'=>'cURL error: ' . $error];
    }
    // Handle the response
    $responseData = json_decode($response, true);
    curl_close($curl);
    if($responseData["verified"]) return [];
    return ['status'=>'error', 'message'=>"Captcha Verification failed"];
}