<?php
if ( ! defined('WHASOLS')) exit('No direct script access allowed');
function emaillistverify_config()
{
	$configarray = [
	"name" => "Email List Verify",
	"description" => "You can verify emails within your application or website with our real-time API. Offer the best experience possible for your users and help them avoid entry or spamming mistakes.<br>Email List Verify Email Validation by <a href=\"https://emaillistverify.com/\" target=\"_blank\">Visit Here</a>",
	"version" => "1",//Your Module Version Number
	"author" => "WHASOLS",
	"author_url" => "https://whasols.com/",
	"language" => "english",
	"generate_token" => false,
	"configs" => [
            "api_key" => [ //Dropdown Select box
                    "Name" => "API Key", 
                    "Type" =>  "text", 
                    "Description" => "Please Enter API Key", 
                    "Default" => "",
                    "DivColumns" => 12,
                ],
            "email_status" => [ //Dropdown Select box
                    "Name" => "Email Status", 
                    "Type" =>  "dropdown", 
                    "Options" =>  ["valid"=>"Mark Unknown as Valid","invalid"=>"Mark Unknown as Invalid"], 
                    "Description" => "Please Enter API Key", 
                    "Default" => "",
                    "DivColumns" => 12,
                ],
            "email" => [ //Dropdown Select box
                    "Name" => "Email Address", 
                    "Type" =>  "text", 
                    "Description" => "Please Enter Email Address for verification the API", 
                    "Default" => "",
                    "DivColumns" => 12,
                ],
	        ],
	    ];
	return $configarray;
}
function emaillistverify_test($params=[])
{
    return emaillistverify_validate($params);
}
function emaillistverify_validate($params=[])
{
    $api_key = $params["api_key"];
    $email = $params["email"];
    $ip = $params["ip"];
    $email_status = $params["email_status"];
    if(empty($api_key)) return ["status"=>"error","message"=>"Please Enter API Key..."];
    try {
        $url = "https://apps.emaillistverify.com/api/verifyEmail?secret=".$api_key."&email=".urlencode($email)."&timeout=15";
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_TIMEOUT, 15); // 30 seconds
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true );
        $response = curl_exec($ch);
        curl_close($ch);
        $decodedData = json_decode($response);
        if ($decodedData !== null)
        {
            $response = json_decode($response,true);
            return ["status"=>"error","message"=>$response["message"]];
        }
        if(in_array($response,["ok","ok_for_all"])) return ["status"=>"success","message"=>"Valid Email Address"];
        if($response == "key_not_valid") return ["status"=>"error","message"=>"API Key not Valid"];
        if($response == "incorrect") return ["status"=>"error","message"=>"Email Validation failed due to Incorrect email address"];
        if($response == "fail") return ["status"=>"error","message"=>"Email Validation failed due to The supplied email address has failed one or more tests"];
        if($response == "unknown")
        {
            $remarks = "The supplied email address can not be accurately tested";
            if($email_status == "valid") return ["status"=>"success","message"=>"Valid Email Address, But ".$remarks];
            return ["status"=>"error","message"=>"Email Validation failed, Due to ".$remarks];
        }
        return ["status"=>"error","message"=>"Email Validation failed"];
    }
    catch (Exception $e)
    {
        return ["status"=>"error","message"=>"Email Validater Error: ".$e->getMessage()];
    }
}