<?php
if ( ! defined('WHASOLS')) exit('No direct script access allowed');
function listclean_config()
{
	$configarray = [
	"name" => "List Clean",
	"description" => "List Clean Email Validation by <a href=\"https://listclean.xyz/\" target=\"_blank\">Visit Here</a>",
	"version" => "1",//Your Module Version Number
	"author" => "WHASOLS",
	"author_url" => "https://whasols.com/",
	"language" => "english",
	"generate_token" => false,
	"configs" => [
            "api_key" => [ //Dropdown Select box
                    "Name" => "API Token", 
                    "Type" =>  "text", 
                    "Description" => "Please Enter API Token", 
                    "Default" => "",
                    "DivColumns" => 12,
                ],
            "email_status" => [ //Dropdown Select box
                    "Name" => "Email Status", 
                    "Type" =>  "dropdown", 
                    "Options" =>  ["valid"=>"Mark Unknown as Valid","invalid"=>"Mark Unknown as Invalid"], 
                    "Description" => "Please Enter API Key", 
                    "Default" => "",
                    "DivColumns" => 12,
                ],
            "email" => [ //Dropdown Select box
                    "Name" => "Email Address", 
                    "Type" =>  "text", 
                    "Description" => "Please Enter Email Address for verification the API", 
                    "Default" => "",
                    "DivColumns" => 12,
                ],
	        ],
	    ];
	return $configarray;
}
function listclean_test($params=[])
{
    return listclean_validate($params);
}
function listclean_validate($params=[])
{
    $api_key = $params["api_key"];
    $email = $params["email"];
    $ip = $params["ip"];
    $email_status = $params["email_status"];
    if(empty($api_key)) return ["status"=>"error","message"=>"Please Enter API Key..."];
    try {

        $url = "https://api.listclean.xyz/v1/";
        $endpoint = 'verify/email/';
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url . $endpoint . $email);
        curl_setopt($ch, CURLOPT_TIMEOUT, 15); // 30 seconds
        curl_setopt($ch, CURLOPT_HTTPHEADER, array(
            'X-AUTH-TOKEN: '. $api_key,
        ));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $response = curl_exec($ch);
        curl_close($ch);
        //var_dump($response);
        //$response = json_decode($response, true);
        $decodedData = json_decode($response);
        if ($decodedData !== null)
        {
            $response = json_decode($response,true);
            $status = $response["success"];
            if($status == 1)
            {
                $dstatus = $response["data"]["status"];
                $remarks = $response["data"]["remarks"];
                if($dstatus == "clean") return ["status"=>"success","message"=>"Valid Email Address"];
                if($dstatus == "dirty") return ["status"=>"error","message"=>$remarks];
                if($dstatus == "unknown")
                {
                    if($email_status == "valid") return ["status"=>"success","message"=>"Valid Email Address, But ".$remarks];
                    return ["status"=>"error","message"=>"Email Validation failed, Due to ".$remarks];
                }
            }else{
                $remarks = $response["message"];
                return ["status"=>"error","message"=>"Email Validation failed, Due to ".$remarks];
            }
        }
    }
    catch (Exception $e)
    {
        return ["status"=>"error","message"=>"Email Validater Error: ".$e->getMessage()];
    }
}