<?php
if ( ! defined('WHASOLS')) exit('No direct script access allowed');
function neverbounce_config()
{
	$configarray = [
	"name" => "Never Bounce",
	"description" => "Never Bounce Email Validation by <a href=\"https://neverbounce.com/\" target=\"_blank\">Visit Here</a>",
	"version" => "1",//Your Module Version Number
	"author" => "WHASOLS",
	"author_url" => "https://whasols.com/",
	"language" => "english",
	"generate_token" => false,
	"configs" => [
            "api_key" => [ //Dropdown Select box
                    "Name" => "API Key", 
                    "Type" =>  "text", 
                    "Description" => "Please Enter API Key", 
                    "Default" => "",
                    "DivColumns" => 12,
                ],
            "email_status" => [ //Dropdown Select box
                    "Name" => "Email Status", 
                    "Type" =>  "dropdown", 
                    "Options" =>  ["valid"=>"Mark Unknown as Valid","invalid"=>"Mark Unknown as Invalid"], 
                    "Description" => "Please Enter API Key", 
                    "Default" => "",
                    "DivColumns" => 12,
                ],
            "email" => [ //Dropdown Select box
                    "Name" => "Email Address", 
                    "Type" =>  "text", 
                    "Description" => "Please Enter Email Address for verification the API", 
                    "Default" => "",
                    "DivColumns" => 12,
                ],
	        ],
	    ];
	return $configarray;
}
function neverbounce_test($params=[])
{
    return neverbounce_validate($params);
}
function neverbounce_validate($params=[])
{
    $api_key = $params["api_key"];
    $email = $params["email"];
    $ip = $params["ip"];
    $email_status = $params["email_status"];
    if(empty($api_key)) return ["status"=>"error","message"=>"Please Enter API Key..."];
    try {
        $curl = curl_init();
        curl_setopt_array($curl, array(
          CURLOPT_URL => 'https://api.neverbounce.com/v4/single/check?key='.$api_key.'&email='.$email,
          CURLOPT_RETURNTRANSFER => true,
          CURLOPT_ENCODING => '',
          CURLOPT_MAXREDIRS => 10,
          CURLOPT_TIMEOUT => 15,
          CURLOPT_FOLLOWLOCATION => true,
          CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
          CURLOPT_CUSTOMREQUEST => 'GET',
        ));
        $response = curl_exec($curl);
        curl_close($curl);
        $decodedData = json_decode($response);
        if ($decodedData !== null)
        {
            $response = json_decode($response,true);
            $status = $response["status"];
            if($status == "success")
            {
                $dstatus = $response["result"];
                if($dstatus == "valid") return ["status"=>"success","message"=>"Valid Email Address"];
                if($dstatus == "unknown")
                {
                    $remarks = _s("message",$response,"");
                    if($email_status == "valid") return ["status"=>"success","message"=>"Valid Email Address, But ".$remarks];
                    return ["status"=>"error","message"=>"Email Validation failed, Due to ".$remarks];
                }
            }else{
                $remarks = _s("message",$response,"");
                return ["status"=>"error","message"=>"Email Validation failed, Due to ".$remarks];
            }
        }
    }
    catch (Exception $e)
    {
        return ["status"=>"error","message"=>"Email Validater Error: ".$e->getMessage()];
    }
}