<?php
if ( ! defined('WHASOLS')) exit('No direct script access allowed');
function zerobounce_config()
{
	$configarray = [
	"name" => "Zero Bounce",
	"description" => "Zero Bounce Email Validation by <a href=\"https://www.zerobounce.net/\" target=\"_blank\">Visit Here</a>",
	"version" => "1",//Your Module Version Number
	"author" => "WHASOLS",
	"author_url" => "https://whasols.com/",
	"language" => "english",
	"generate_token" => false,
	"configs" => [
            "api_key" => [ //Dropdown Select box
                    "Name" => "API Key", 
                    "Type" =>  "text", 
                    "Description" => "Please Enter API Key", 
                    "Default" => "",
                    "DivColumns" => 12,
                ],
            "email_status" => [ //Dropdown Select box
                    "Name" => "Email Status", 
                    "Type" =>  "dropdown", 
                    "Options" =>  ["valid"=>"Mark Unknown as Valid","invalid"=>"Mark Unknown as Invalid"], 
                    "Description" => "Please Enter API Key", 
                    "Default" => "",
                    "DivColumns" => 12,
                ],
            "email" => [ //Dropdown Select box
                    "Name" => "Email Address", 
                    "Type" =>  "text", 
                    "Description" => "Please Enter Email Address for verification the API", 
                    "Default" => "",
                    "DivColumns" => 12,
                ],
	        ],
	    ];
	return $configarray;
}
function zerobounce_test($params=[])
{
    return zerobounce_validate($params);
}
function zerobounce_validate($params=[])
{
    $api_key = $params["api_key"];
    $email = $params["email"];
    $ip = $params["ip"];
    $email_status = $params["email_status"];
    if(empty($api_key)) return ["status"=>"error","message"=>"Please Enter API Key..."];
    try {
        $curl = curl_init();
        curl_setopt_array($curl, array(
          CURLOPT_URL => 'https://api.zerobounce.net/v2/validate?api_key='.$api_key.'&email='.$email.'&ip_address='.$ip,
          CURLOPT_RETURNTRANSFER => true,
          CURLOPT_ENCODING => '',
          CURLOPT_MAXREDIRS => 10,
          CURLOPT_TIMEOUT => 15,
          CURLOPT_FOLLOWLOCATION => true,
          CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
          CURLOPT_CUSTOMREQUEST => 'GET',
        ));
        $response = curl_exec($curl);
        curl_close($curl);
        $decodedData = json_decode($response);
        if ($decodedData !== null)
        {
            $response = json_decode($response,true);
            if (array_key_exists("error", $response)) return ["status"=>"error","message"=>$response["error"]];
            $status = $response["status"];
            $mx_found = $response["mx_found"];
            if($status == "valid") return ["status"=>"success","message"=>"Valid Email Address"];
            if($status == "invalid") return ["status"=>"error","message"=>"Email Validation failed"];
            if($status == "unknown")
            {
                if($email_status == "valid") return ["status"=>"success","message"=>"Valid Email Address"];
                return ["status"=>"error","message"=>"Email Validation failed, Due to Verification status Unknown"];
            }
            if($mx_found) return ["status"=>"success","message"=>"Valid Email Address"];
        }
    }
    catch (Exception $e)
    {
        return ["status"=>"error","message"=>"Email Validater Error: ".$e->getMessage()];
    }
}