<?php
if ( ! defined('WHASOLS')) exit('No direct script access allowed');
use Carbon\Carbon;
function PostMark_config()
{
	$configarray = [
	"name" => "Post Mark",
	"description" => "The email delivery service that people actually like, Stop worrying if your emails made it to the inbox, and get back to focusing on what matters—building great products.<br><a href=\"https://postmarkapp.com/\" target=\"_blank\">Click Here to Visit Site</a>",
	"version" => "1",//Your Module Version Number
	"author" => "WHASOLS",
	"author_url" => "https://whasols.com/",
	"language" => "english",
	"configs" => [
            "api_token" => [
                "Name" => "Server API tokens",
                "Type" => "text",
                "Description" =>"Server API tokens Required from Post Mark Dashboard",
                "DivColumns" => 12,
            ],
	        ],
	    ];
	return $configarray;
}

function PostMark_test($params=[])
{
    $Subject= "Testing Email";
    $date = date('Y-m-d H:i:s');
    $Body = "Email testing using php mailer, dated:".$date;
    $ClientId = 0;
    $from_name = GetConfigs("MAIL_FROM_NAME");
    if(empty($from_name)) return ["status"=>"error","message"=>"Mail from Name empty in Mail Tab"];
    $from_email_address = GetConfigs("MAIL_FROM_EMAIL");
    if(empty($from_email_address)) return ["status"=>"error","message"=>"Mail from Email empty in Mail Tab"];
    $EmailsTos = GetConfigs("SITE_EMAIL");
    if(empty($EmailsTos)) return ["status"=>"error","message"=>"Email Address empty in General Tab"];
    $postFields = [];
    $postFields["from"] = ["address" =>$from_email_address,"name" =>$from_name];
    $postFields["subject"] = $Subject;
    $postFields["textbody"] = $Body;
    $postFields["to"][] = [
                "email_address" => [
                    "address" => $EmailsTos,
                    "name" => $from_name,
                ],
            ];
    $postFields["textbody"] = $Body;
    return PostMark_call($params,$postFields);
}
function PostMark_send($params=[], $mailData=[])
{
    $Subject= $mailData["Subject"];
    $Body= $mailData["Body"];

    $ClientId = $mailData["ClientId"];
    $From= $mailData["From"];
    $from_email_address= $From["Email"];
    $from_name= $From["Name"];

    $ReplyTo= $mailData["ReplyTo"];
    $ReplyToEmail= $ReplyTo["Email"];
    $ReplyToName= $ReplyTo["Name"];

    $tos= $mailData["AddressTo"]; //Array = Email sent to "address to", AddressTo is an Array which have Email and Name information.
    $Cc= $mailData["Cc"]; //Cc Array = Emails of CC.
    $Bcc= $mailData["Bcc"]; //BccArray = Emails of Bcc.
    $Attachments= $mailData["Attachments"]; //Attachments Array= Which have file and name information
    
    $sendmailtoken = $params["sendmailtoken"];
    $mail_format = $params["mail_format"];
    $postFields = [];
    $postFields["from"] = ["address" =>$from_email_address,"name" =>$from_name];
    $postFields["subject"] = $Subject;
    $postFields["textbody"] = $Body;
    foreach ($tos as $to) {
        $postFields["to"][] = [
            "email_address" => [
                "address" => $to["Email"],
                "name" => $to["Name"],
            ],
        ];
    }
    $ccEmails=[];
    if(!empty($Cc))
    {
        $CcList = explode(",",$Cc);
        foreach($CcList as $ce)
        {
            $cePart = explode("@",$ce);
            $postFields["cc"][] = [
                "email_address" => [
                    "address" =>$ce,
                    "name" =>$cePart[0],
                ],
            ];
        }
    }
    $bccEmails=[];
    if(!empty($Bcc))
    {
        $BccList = explode(",",$Bcc);
        foreach($BccList as $be)
        {
            $bePart = explode("@",$be);
            $postFields["bcc"][] = [
                "email_address" => [
                    "address" =>$be,
                    "name" =>$bePart[0],
                ],
            ];
        }
    }
    return PostMark_call($params,$postFields);
}
function PostMark_call($params,$postFields)
{
    $api_token = $params["api_token"];
    if(empty($api_token)) return ["status"=>"error","message"=>"Server API tokens Required"];
    try {
        $subject = $postFields["subject"];
        $textbody = $postFields["textbody"];
        $fromEmail = $postFields["from"]["address"];
        $fromName = $postFields["from"]["name"];
        $toEmail = $postFields["to"][0]["email_address"]["address"];

        $curl = curl_init();
        curl_setopt_array($curl, array(
          CURLOPT_URL => 'https://api.postmarkapp.com/email',
          CURLOPT_RETURNTRANSFER => true,
          CURLOPT_ENCODING => '',
          CURLOPT_MAXREDIRS => 10,
          CURLOPT_TIMEOUT => 15,
          CURLOPT_FOLLOWLOCATION => true,
          CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
          CURLOPT_CUSTOMREQUEST => 'POST',
          CURLOPT_POSTFIELDS =>'{
                "From": "'.$fromEmail.'",
                "To": "'.$toEmail.'",
                "Subject": "'.$subject.'",
                "HtmlBody": "'.$textbody.'",
                "MessageStream": "outbound"
              }',
          CURLOPT_HTTPHEADER => array(
            'Accept: application/json',
            'Content-Type: application/json',
            'X-Postmark-Server-Token: '.$api_token
          ),
        ));
        
        $response = curl_exec($curl);
        
        curl_close($curl);
        $response = json_decode($response,true);
        $ErrorCode = $response["ErrorCode"];
        if($ErrorCode == 0) return ["status"=>"success","message"=>"Email sent successfully"];
        $message = $response["Message"];
        return ["status"=>"error","message"=>"Email sending failed, due to ".$message];
    } catch (Exception $e)
    {
        return ["status"=>"error","message"=>'Caught exception: '. $e->getMessage()];
    }
}