<?php
function exchangerate_config()
{
	return array(
		"name" => "Exchange Rate",
		"description" => "<p></p>",
		"version" => "1.0",
		"author" => 'exchangerate.host',
		"author_url" => 'https://exchangerate.host/',
		"configs" => [
			"api_key"=>[
				"Name" => "API KEY",
				"Type" => "text",
				"Size" => "200",
				"Description" => "Enter API Key here",
				"Default" => "",
			],
			"api_plan" =>[
				"Name" => "Plan Type",
				"Type" => "radio",
				"Options" => "Free,Paid",
				"Description" => " Select Plan Type",
				"Default" => "Free",
			]
		]
	);
}
function exchangerate_call($url){
	$json = file_get_contents($url);
	return json_decode($json);	
}
function exchangerate_link($arg)
{
    $currency = isset($arg['currency']) ? $arg['currency']:'';
    $exchange = isset($arg['exchange']) ? $arg['exchange']:'';
    $app_id = isset($exchange['api_key']) ? $exchange['api_key']:'';
    $api_plan = isset($exchange['api_plan']) ? $exchange['api_plan']:'';
    $amount = isset($currency['amount']) ? $currency['amount']:0;
    $from = isset($currency['from']) ? $currency['from']:'';
    $to = isset($currency['to']) ? $currency['to']:'';
    $isSecure = $api_plan == "Free" ? "http":"https";
	$url = $isSecure."://api.exchangerate.host/live?source=".$from."&access_key=".$app_id."&currencies=".$to."&format=1";
	$result = exchangerate_call($url);
	if(!iset('success',$result)) return ['status'=>'error','message'=>iset('info',$result->error)];
	 $rates = [];
    foreach ($result->quotes as $key => $value)
    {
    	$k = str_replace($from,'',$key);
        $rates[$k] = $value;
    }
    if(empty($rates)) return ['status'=>'error','message'=>"Other Currencies Rates not found"];
	return ['status'=>'success','rates_list'=>$rates];
}
function exchangerate_test_api($arg){
	$exchange = iset('exchange',$arg);
	$app_id = iset('api_key',$exchange);
	$api_plan = iset('api_plan',$exchange);
    $isSecure = $api_plan == "Free" ? "http":"https";	
	$url = $isSecure."://api.exchangerate.host/live?source=USD&access_key=".$app_id;
	$result = exchangerate_call($url);
	if(!iset('success',$result)) return ['status'=>'error','message'=>iset('info',$result->error)];
	return ['status'=>'success'];
}