
<?php
function fcsapi_config()
{
	return array(
		"name" => "FCS API",
		"description" => "<p></p>",
		"version" => "1.0",
		"author" => 'fcsapi.com',
		"author_url" => 'https://fcsapi.com/',
		"configs" => array(
			"api_key" => array(
				"Name" => "API KEY",
				"Type" => "text",
				"Size" => "200",
				"Description" => "Enter API Key here",
				"Default" => "",
			),
			"api_plan" => array(
				"Name" => "Plan Type",
				"Type" => "radio",
				"Options" => "Free,Paid",
				"Description" => "Select Plan Type",
				"Default" => "Free",
			)
		)
	);
}

function fcsapi_call($url){
	// Open CURL session:
	$ch = curl_init($url);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	// Get the data:
	$json = curl_exec($ch);
	curl_close($ch);
	// Decode JSON response:
	return json_decode($json,true);	
}
function fcsapi_response($code){
$response = [
	200=>"Your API is working. Response successfully",
	101=>"API Key error : Your access key is wrong, Please login in your dashboard and get your API KEY.",
	102=>"Your Account is not activated.",
	103=>"Your Account is blocked.",
	104=>"API Key error : You have not set your access_key in parameters.",
	111=>"Full access is not allow with DEMO API key, so please signup and get your api key to unlock full access on FCS.",
	112=>"Data not found, it may be you set wrong values and it may be no data from our side. More error details will be send in API response.",
	113=>"Required parameters are missing, Please check api documentaion also check message in API response for more error details.",
	211=>"You have used your all monthly API request limit.",
	212=>"Your Account is expired, You need to pay your montly fee or downgrade to free version.",
	213=>"Error 213 is only for Free user, free user are not allow more than 1 request per minute.."
];
return $response[$code];
}

function fcsapi_link($arg){
	$currency = $arg['currency'];
	$exchange = $arg['exchange'];
	 $app_id = $exchange['api_key'];
	 $api_plan = $exchange['api_plan'];
	 $amount = $currency['amount'];
	 $from = $currency['from'];
	 $to = $currency['to'];
	 $otherCurrencies=[];
	 $CurrenciesList=[];
	 if(!empty($to)){
	 	$otherCurrencies = explode(",",$to);
	 	foreach ($otherCurrencies as $cur) {	 		
	 		$CurrenciesList[] = $from."/".$cur;
	 	}
	 }else{
		return ['status'=>'error','message'=>"Others Currencies required to fetch rates..."];	 	
	 }
	 $symbol = implode(",",$CurrenciesList);
	$url = "https://fcsapi.com/api-v3/forex/latest?symbol=".$symbol."&access_key=".$app_id;
	$result = fcsapi_call($url);

	if($result["code"] != 200) 
		return ['status'=>'error','message'=>fcsapi_response($result["code"])];
	$rates = [];
	foreach ($result["response"] as $res)
	{
		$symbol = $res["s"];
		$symbolParts = explode("/",$symbol);
		$rate = $res["o"];
		$rates[$symbolParts[1]]=$rate;
	}
	return ['status'=>'success','rates_list'=>$rates];
}
function fcsapi_test_api($arg){
	$currency = $arg['currency'];
	$exchange = $arg['exchange'];
	 $app_id = $exchange['api_key'];
	 $api_plan = $exchange['api_plan'];
	 $amount = $currency['amount'];
	 $from = $currency['from'];
	 $to = $currency['to'];
	 $otherCurrencies=[];
	 $CurrenciesList=[];
	 if(!empty($to)){
	 	$otherCurrencies = explode(",",$to);
	 	foreach ($otherCurrencies as $cur) {	 		
	 		$CurrenciesList[] = $from."/".$cur;
	 	}
	 }else{
		return ['status'=>'error','message'=>"Others Currencies required to fetch rates..."];	 	
	 }
	 $symbol = implode(",",$CurrenciesList);
	$url = "https://fcsapi.com/api-v3/forex/latest?symbol=".$symbol."&access_key=".$app_id;
	$result = fcsapi_call($url);
	if($result["code"] != 200) 
		return ['status'=>'error','message'=>fcsapi_response($result["code"])];
	return ['status'=>'success'];
}


?>