<?php
/**
 * WHMCS Bank Deposit Module
 * This is the Bank Deposit (EasyPaisa) Payment Module
 * @author Khawar Shahzad (hostarina.com)
 * @license MIT
 */

/**
 * Bank Deposit metaData
 *
 * Values returned here are used to determine module related capabilities and
 * settings.
 *
 * @see http://docs.whmcs.com/Gateway_Module_Meta_Data_Parameters
 *
 * @return array
 */
function bankdeposit_info()
{
    return array(
        'DisplayName' => 'Bank Deposit, Transfer',
        'APIVersion' => '1.1', // Use API Version 1.1
        'DisableLocalCredtCardInput' => true,
        'TokenisedStorage' => false,
    );
}

/**
 * Define gateway configuration options.
 *
 * The fields you define here determine the configuration options that are
 * presented to administrator users when activating and configuring your
 * payment gateway module for use.
 *
 * Supported field types include:
 * * text
 * * password
 * * yesno
 * * dropdown
 * * radio
 * * textarea
 *
 * Examples of each field type and their possible configuration parameters are
 * provided in the sample function below.
 *
 * @return array
 */
function bankdeposit_config()
{
    return array(
        // the friendly display name for a payment gateway should be
        // defined here for backwards compatibility
        'Name' => array(
            'Type' => 'System',
            'Value' => 'bankdeposit',
        ),
        'Title' => array(
            'Name' => 'Display Name',
            'Type' => 'text',
            'Size' => '50',
            'Default' => 'Bank Deposit, Transfer',
            'Description' => '',
        ),
        'method_instructions' => array(
            'Name' => 'Bank Transfer Instructions',
            'Type' => 'textarea',
            'Rows' => '5',
            'Cols' => '60',
            'Default' => '',
            'Description' => 'The instructions you want displaying to customers who choose this payment method - the invoice number will be shown underneath the text entered above ',
        )
    );
}

function bankdeposit_link($arg)
{
    return '<p>'.nl2br($arg['gateway']['method_instructions']).'</p>';
}
?>
