<?php
/**
 * whmsols CashMall Module
 * This is the CashMall (CashMall) Payment Module
 * @author Khawar Shahzad (hostarina.com)
 * @license MIT
 */

/**
 * CashMall metaData
 *
 * Values returned here are used to determine module related capabilities and
 * settings.
 *
 * @see http://docs.whmsols.com/Gateway_Module_Meta_Data_Parameters
 *
 * @return array
 */
 
 
function cashmall_info()
{
    return array(
        'DisplayName' => 'Cash Mall',
        'APIVersion' => '1.1', // Use API Version 1.1
        'DisableLocalCredtCardInput' => true,
        'TokenisedStorage' => false,
    );
}

/**
 * Define gateway configuration options.
 *
 * The fields you define here determine the configuration options that are
 * presented to administrator users when activating and configuring your
 * payment gateway module for use.
 *
 * Supported field types include:
 * * text
 * * password
 * * yesno
 * * dropdown
 * * radio
 * * textarea
 *
 * Examples of each field type and their possible configuration parameters are
 * provided in the sample function below.
 *
 * @return array
 */
function cashmall_config()
{
    return array(
        // the friendly display name for a payment gateway should be
        // defined here for backwards compatibility
        'Name' => array(
            'Type' => 'System',
            'Value' => 'cashmall',
        ),
        // a text field type allows for single line text input
        'Title' => array(
            'Name' => 'Display Name',
            'Type' => 'text',
            'Size' => '50',
            'Default' => 'Cash Mall',
            'Description' => '',
        ),
        // a text field type allows for single line text input
        'web_id' => array(
            'Name' => 'Web ID',
            'Type' => 'text',
            'Size' => '4',
            'Default' => '',
            'Description' => 'Enter your Web ID here',
        )
    );
}




/**
 * Generation of Payment link.
 *
 * @return string
 */

function cashmall_link($arg){
    // Gateway Configuration Parameters
    $web_id = $arg['gateway']['web_id'];
    $gateway_id = $arg['gateway']['id'];

    
    // Invoice Parameters
    $invoiceid = $arg['invoice']['invoiceid'];
    $description = $arg['invoice']['description'];
    $amount = $arg['invoice']['amount'];
    $currencyCode = $arg['invoice']['currency'];


    //Client Parameters
    $firstname = $arg['client']['firstname'];
    $lastname = $arg['client']['lastname'];
    $email = $arg['client']['email'];
    $address1 = $arg['client']['address1'];
    $address2 = $arg['client']['address2'];
    $city = $arg['client']['city'];
    $state = $arg['client']['state'];
    $postcode = $arg['client']['postcode'];
    $country = $arg['client']['country'];
    $phone = $arg['client']['phonenumber'];


    // System Parameters
    $companyName = $arg['system']['companyname'];
    $systemUrl = $arg['system']['systemurl'];            // System URL
    $siteurl = $arg['system']['siteurl'];            // System URL


    //Start Coding =Redirect User with POST DATA to cashmaal
    $htmlOutput = '';
    $htmlOutput .= '<form action="https://www.cashmaal.com/Pay/" method="POST">
    <div class="row">
<div class="col-md-12">
<b>Cash Mall Payment methods : </b>
<div class="col-md-8">
<label><input type="radio" name="pay_method" value="cm">Cash Maal</label>
<label><input type="radio" name="pay_method" value="pm">Perfect Money</label>
<label><input type="radio" name="pay_method" value="jca">JazzCash</label>
<label><input type="radio" name="pay_method" value="epa">EasyPaisa</label>
</div>
<div class="col-md-4">
<!-- amount (Enter Amount HERE) -->
<input type="hidden" name="amount" value="'.$amount.'">
<!-- currency (PKR,USD) -->
<input type="hidden" name="currency" value="'.$currencyCode.'">
<!-- succes_url (User will redirect if payment complete) -->
<input type="hidden" name="succes_url" value="'.$systemUrl.'/client/paytoinvoice/'.$gateway_id.'/'.$invoiceid.'">
<!-- cancel_url (User will redirect if payment Not Complete) -->
<input type="hidden" name="cancel_url" value="'.$systemUrl.'/client/paytoinvoice/'.$gateway_id.'/'.$invoiceid.'">
<!-- client_email (After Complete payment CM sent Confirmation EMail to Client) -->
<input type="hidden" name="client_email" value="'.$email.'">
<!-- web_id (Your web id you can find this on CM panel) -->
<input type="hidden" name="web_id" value="'.$web_id.'">
<!-- Unique Order Id (You will get this order id after payment success (Optional) (Max 80 Character Allowed)) -->
<input type="hidden" name="order_id" value="'.$invoiceid.'">
<!-- Additional info (additional information (you will get this value after success payment) (Optional) (Max 80 Character Allowed)) -->
<input type="hidden" name="addi_info" value="'.$description.'">
<button type="submit" class="btn btn-success"><i class="glyphicon glyphicon-credit-card"></i> Pay Now</button>
</div>
</div>
</div>
</form>';
//END Coding =Redirect User with POST DATA to cashmaal
    return $htmlOutput;
}




function cashmall_callback($arg)
{
    
    // Gateway Configuration Parameters
    $web_id = $arg['gateway']['web_id'];
    $gateway_id = $arg['gateway']['id'];
    $invoiceid = $arg['invoice']['invoiceid'];

    $htmlOutput = '';

       $gateway_variables =  GetPaymentGatewayVariables($gateway_id);
     
       $isValid =  DoInvoiceValidate($invoiceid);
        if(!$isValid){
           $htmlOutput .='<div class="alert alert-danger">Invoice Id is Invailed.....</div>'; 
        }else{

    // Invoice Parameters
    $currency = $arg['invoice']['currency'];
    $currencyCode = $arg['invoice']['currencyCode'];
    $payment_method = $arg['invoice']['payment_method'];
    $user_id = $arg['client']['id'];



        
    //Verify Transaction after redirect back user on callback URL ======

    if(!empty($_POST['CM_TID'])){ 
        $CM_TID=$_POST['CM_TID'];   // getting TID with user redirection   
        
        $url="https://www.cashmaal.com/Pay/verify_v2.php?CM_TID=".urlencode($CM_TID)."&web_id=".urlencode($web_id);
        
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_URL, $url);
        $result = curl_exec($ch);
        curl_close($ch);
        $obj = json_decode($result);

        if($obj->status == 1)
        {
            $amount_var = $currencyCode.'_amount';
            $fee_var = 'fee_in_'.$currencyCode;
            $amount = $obj->$amount_var;
           $fee = $obj->$fee_var;
                   $isValid =  DoTransactionValidate($invoiceid,$CM_TID);
            if($isValid){
                $htmlOutput .='<div class="alert alert-danger">Transaction No already exist.....</div>';
            }else{
            $payment_added = AddInvoicePayment(array('invoice_id'=>$invoiceid,'currency'=>$currency,'user_id'=>$user_id,'payment_method'=>$payment_method,'amount'=>$amount,'trno'=>$CM_TID,'fee'=>$fee,'notification'=>'YES'));
              if($payment_added['status'] == 'success'){
                  AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$result));
                header("Location: /client/view-invoice/".$invoiceid);                   
              }else{
                $htmlOutput .='<div class="alert alert-danger">Payment Confirmed but Payment entry error...'.$payment_added['message'].'</div>';
              }
            }
        }else{
        $htmlOutput .='<div class="alert alert-danger">'.$obj->error.'</div>';
        }
    
    }





    //Start Coding =Redirect User with POST DATA to cashmaal
    $htmlOutput .= '<form action="/client/paytoinvoice/'.$gateway_id.'/'.$invoiceid.'" method="POST">
    <div class="row">
<div class="col-md-12">

<div class="col-md-2"></div>
<div class="col-md-8">
<b>Cash Mall Transaction ID : </b>
<input type="text" name="CM_TID" value="" class="form-control">
<br><br>
<button type="submit" class="btn btn-success pull-right"><i class="glyphicon glyphicon-credit-card"></i> Confirm Payment</button>

</div>
<div class="col-md-2"></div>
</div>
</div>
</form>';
//END Coding =Redirect User with POST DATA to cashmaal
        }  

    return $htmlOutput;
}

?>
