<?php
if (!defined("WHASOLS")) exit("This file cannot be accessed directly");
function cashu_info()
{
    return array(
        'DisplayName' => 'CashU', // display name for client
        'APIVersion' => '1.2', 
        'DisableLocalCredtCardInput' => false,
        'TokenisedStorage' => false,
    );
}
function cashu_config()
{
    return [
        "Name" =>["Type" => "System", "Value" => "CashU"],
        "merchantid" =>["Name" => "Merchant ID", "Type" => "text", "Size" => "20", "Description" => ""],
        "encryptionkeyword" =>["Name" => "Encryption Keyword", "Type" => "text", "Size" => "20", "Description" => ""],
        "demomode" =>["Name" => "Demo Mode", "Type" => "yesno"]
    ];
}
function cashu_link($params)
{
    $token = md5($params["merchantid"] . ":" . $params["amount"] . ":" . strtolower($params["currency"]) . ":" . $params["encryptionkeyword"]);
    $code = "<form action=\"https://www.cashu.com/cgi-bin/pcashu.cgi\" method=\"post\">
    <input type=\"hidden\" name=\"merchant_id\" value=\"" . $params["merchantid"] . "\">
    <input type=\"hidden\" name=\"token\" value=\"" . $token . "\">\n<input type=\"hidden\" name=\"display_text\" value=\"" . $params["description"] . "\">
    <input type=\"hidden\" name=\"currency\" value=\"" . $params["currency"] . "\">
    <input type=\"hidden\" name=\"amount\" value=\"" . $params["amount"] . "\">\n<input type=\"hidden\" name=\"language\" value=\"en\">\n<input type=\"hidden\" name=\"email\" value=\"" . $params["clientdetails"]["email"] . "\">\n<input type=\"hidden\" name=\"session_id\" value=\"" . $params["invoiceid"] . "\">\n<input type=\"hidden\" name=\"txt1\" value=\"" . $params["description"] . "\">";
    if ($params["demomode"] == "yes") {
        $code .= "<input type=\"hidden\" name=\"test_mode\" value=\"1\">";
    }
    $code .= "\n<input type=\"submit\" value=\"" . $params["langpaynow"] . "\">\n</form>";
    return $code;
}

function cashu_callback($params)
{
    $eTitle = $params['gateway']['title'];
    $gateway_id = $params['gateway']['id'];

    $amount = $_REQUEST["amount"];
    $currency = $_REQUEST["currency"];
    $transid = $_REQUEST["trn_id"];
    $session_id = (int) $_REQUEST["session_id"];
    $verificationString = $_REQUEST["verificationString"];
    $invoiceid = ($session_id>0) ? $session_id:0;
    $Info = GetInvoiceInfo($invoiceid);
    $description = $Info["description"];
    $amount = $Info['amount'];
    $currency = $currencyCode = $Info['currency'];
    $payment_method = $Info['payment_method'];
    $user_id = $Info['user_id'];
    // System Parameters


    $REQUEST = $_REQUEST;
    $htmlOutput = '';   
    $isValid =  DoInvoiceValidate($invoiceid);
    if(!$isValid) return '<div class="alert alert-danger">Invoice Id is Invailed.....</div>'; 
    $fee = 0;
    $isValid =  DoTransactionValidate($invoiceid,$transid);
    if($isValid) return '<div class="alert alert-danger">Transaction No already exist.....</div>';
    $transactionStatus = "Unsuccessful";

    $verstr = array(strtolower($params["merchantid"]), strtolower($transid), $params["encryptionkeyword"]);
    $verstr = implode(":", $verstr);
    $verstr = sha1($verstr);
    
    if ($verstr == $verificationString)
    {
        $payment_added = AddInvoicePayment(['invoice_id'=>$invoiceid,'currency'=>$currency,'user_id'=>$user_id,'payment_method'=>$payment_method,'amount'=>$amount,'trno'=>$transid,'fee'=>$fee,'notification'=>'YES']);
        $REQUEST["TransStatus"] = "Success";
        AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$REQUEST,"message"=>"Payment Confirmed By Gateway"));
        if($payment_added['status'] != 'success') return '<div class="alert alert-danger">Payment Confirmed but Payment entry error...'.$payment_added['message'].'</div>';
        header("Location: /client/view-invoice/".$invoiceid);
        die();
    }
    $REQUEST["TransStatus"] = "Failed";
    AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$REQUEST,"message"=>"Invalid Hash"));
    return '<div class="alert alert-danger">Payment Confirmation By Gateway failed due to Invalid Hash</div>';    
}