<?php
if (!defined("WHASOLS")) exit("This file cannot be accessed directly");
function ccavenue_info()
{
    return array(
        'DisplayName' => 'CCAvenue', // display name for client
        'APIVersion' => '1.0', 
        'DisableLocalCredtCardInput' => false,
        'TokenisedStorage' => false,
    );
}
function ccavenue_config()
{
    $configarray = array(
        "Name" => array("Type" => "System", "Value" => "CCAvenue"),
        "merchantid" => array("Name" => "Merchant ID", "Type" => "text", "Size" => "20","Description"=>"Enter your User ID for CCAvenue here"),
        "workingkey" => array("Name" => "Working Key", "Type" => "text", "Size" => "20","Description"=>"Enter the Working Key here"),
        "infomsg" => array("Name" => "Information Message", "Type" => "text", "Description" =>"<br />An optional message to be displayed on the Invoice Payment client area screen informing of a manual review before the invoice is marked paid.","Default"=>""),
    );
    return $configarray;
}

function ccavenue_link($params)
{
    $eTitle = $params['gateway']['title'];
    $gateway_id = $params['gateway']['id'];
    $Redirect_Url = $arg['returnurl'];
    $Merchant_Id = $params["merchantid"];
    $Amount = sprintf("%.2f", $params["amount"]);
    $Order_Id = $params["invoiceid"] . "_" . date("YmdHis");
    $WorkingKey = $params["workingkey"];
    $Checksum = ccavenue_getCheckSum($Merchant_Id, $Amount, $Order_Id, $Redirect_Url, $WorkingKey);
    $strRet = "<form name=ccavenue method=\"post\" action=\"https://www.ccavenue.com/shopzone/cc_details.jsp\">";
    $strRet .= "<input type=hidden name=Merchant_Id value=\"" . $Merchant_Id . "\">";
    $strRet .= "<input type=hidden name=Amount value=\"" . $Amount . "\">";
    $strRet .= "<input type=hidden name=Order_Id value=\"" . $Order_Id . "\">";
    $strRet .= "<input type=hidden name=Redirect_Url value=\"" . $Redirect_Url . "\">";
    $strRet .= "<input type=hidden name=Checksum value=\"" . $Checksum . "\">";
    $strRet .= "<input type=\"hidden\" name=\"billing_cust_name\" value=\"" . $params["clientdetails"]["firstname"] . " " . $params["clientdetails"]["lastname"] . "\">";
    $strRet .= "<input type=\"hidden\" name=\"billing_cust_address\" value=\"" . $params["clientdetails"]["address1"] . "\">";
    $strRet .= "<input type=\"hidden\" name=\"billing_cust_country\" value=\"" . $params["clientdetails"]["country"] . "\">";
    $strRet .= "<input type=\"hidden\" name=\"billing_cust_tel\" value=\"" . $params["clientdetails"]["phonenumber"] . "\">";
    $strRet .= "<input type=\"hidden\" name=\"billing_cust_email\" value=\"" . $params["clientdetails"]["email"] . "\">";
    $strRet .= "<input type=\"hidden\" name=\"delivery_cust_name\" value=\"" . $params["clientdetails"]["firstname"] . " " . $params["clientdetails"]["lastname"] . "\">";
    $strRet .= "<input type=\"hidden\" name=\"delivery_cust_address\" value=\"" . $params["clientdetails"]["address1"] . "\">";
    $strRet .= "<input type=\"hidden\" name=\"delivery_cust_tel\" value=\"" . $params["clientdetails"]["phonenumber"] . "\">";
    $strRet .= "<input type=\"hidden\" name=\"delivery_cust_notes\" value=\"Invoice #" . $Order_Id . "\">";
    $strRet .= "<input type=\"submit\" value=\"Pay Now\">";
    $strRet .= "</form>";
    $strRet .= "<br />" . $params["infomsg"];
    return $strRet;
}
function ccavenue_callback($params)
{
    $eTitle = $params['gateway']['title'];
    $gateway_id = $params['gateway']['id'];

    $Order_Id = $_POST["Order_Id"];
    $WorkingKey = $params['gateway']['workingkey']; 
    $cbAmount = $_POST["Amount"];
    $AuthDesc = $_POST["AuthDesc"];
    $Checksum = $_POST["Checksum"];
    $Merchant_Id = $_POST["Merchant_Id"];
    $signup = $_POST["Merchant_Param"];
    // Invoice Parameters
    $invoiceid = $params['invoice']['invoiceid'];
    $description = $params['invoice']["description"];
    $amount = $params['invoice']['amount'];
    $currencyCode = $params['invoice']['currency'];
    $currency = $arg['invoice']['currency'];
    $payment_method = $arg['invoice']['payment_method'];
    $user_id = $arg['client']['id'];
    // System Parameters
    $companyName = $arg['system']['companyname'];
    $systemUrl = $arg['system']['systemurl'];            // System URL
    $siteurl = $arg['system']['siteurl'];            // System URL


    $REQUEST = $_REQUEST;
    $htmlOutput = '';   

    $Checksum = ccavenue_verifyChecksum($Merchant_Id, $Order_Id, $cbAmount, $AuthDesc, $Checksum, $WorkingKey);
    $invoiceParts = explode("_", $Order_Id);
    $invoiceidcb = $invoiceParts[0];

    $isValid =  DoInvoiceValidate($invoiceidcb);
    if(!$isValid) return '<div class="alert alert-danger">Invoice Id is Invailed.....</div>'; 
    if($invoiceid<>$invoiceid) return '<div class="alert alert-danger">Invoice Id is Invailed.....</div>'; 

    $transid = $Order_Id;
    $fee = 0;
    $isValid =  DoTransactionValidate($invoiceid,$transid);
    if($isValid) return '<div class="alert alert-danger">Transaction No already exist.....</div>';
    if ($Checksum == "true" && $AuthDesc == "Y")
    {
        $payment_added = AddInvoicePayment(['invoice_id'=>$invoiceid,'currency'=>$currency,'user_id'=>$user_id,'payment_method'=>$payment_method,'amount'=>$amount,'trno'=>$transid,'fee'=>$fee,'notification'=>'YES']);

        $REQUEST["TransStatus"] = "Success";
        AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$REQUEST,"message"=>"Payment Confirmed By Gateway"));

        header("Location: /client/view-invoice/".$invoiceid);
        if($payment_added['status'] != 'success') return '<div class="alert alert-danger">Payment Confirmed but Payment entry error...'.$payment_added['message'].'</div>';
        die();
    }
    $REQUEST["TransStatus"] = "Failed";
    AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$REQUEST,"message"=>"Payment Confirmation Failed By Gateway"));
    return '<div class="alert alert-danger">Payment Confirmation By Gateway failed...</div>';

}

function ccavenue_verifychecksum($MerchantId, $OrderId, $Amount, $AuthDesc, $CheckSum, $WorkingKey)
{
    $str = (string) $MerchantId . "|" . $OrderId . "|" . $Amount . "|" . $AuthDesc . "|" . $WorkingKey;
    $adler = 1;
    $adler = ccavenue_adler32($adler, $str);
    if ($adler == $CheckSum) {
        return "true";
    }
    return "false";
}
function ccavenue_getchecksum($MerchantId, $Amount, $OrderId, $URL, $WorkingKey)
{
    $str = (string) $MerchantId . "|" . $OrderId . "|" . $Amount . "|" . $URL . "|" . $WorkingKey;
    $adler = 1;
    $adler = ccavenue_adler32($adler, $str);
    return $adler;
}
function ccavenue_adler32($adler, $str)
{
    $BASE = 65521;
    $s1 = $adler & 65535;
    $s2 = $adler >> 16 & 65535;
    for ($i = 0; $i < strlen($str); $i++) {
        $s1 = ($s1 + Ord($str[$i])) % $BASE;
        $s2 = ($s2 + $s1) % $BASE;
    }
    return ccavenue_leftshift($s2, 16) + $s1;
}
function ccavenue_leftshift($str, $num)
{
    $str = DecBin($str);
    for ($i = 0; $i < 64 - strlen($str); $i++) {
        $str = "0" . $str;
    }
    for ($i = 0; $i < $num; $i++) {
        $str = $str . "0";
        $str = substr($str, 1);
    }
    return ccavenue_cdec($str);
}
function ccavenue_cdec($num)
{
    for ($n = 0; $n < strlen($num); $n++) {
        $temp = $num[$n];
        $dec = $dec + $temp * pow(2, strlen($num) - $n - 1);
    }
    return $dec;
}