<?php
if (!defined("WHASOLS")) exit("This file cannot be accessed directly");
include_once dirname(__FILE__) . "/lib/CCAvenue.php";
function ccavenuev2_info()
{
    return array(
        'DisplayName' => 'CCAvenue v2', // display name for client
        'APIVersion' => '1.0', 
        'DisableLocalCredtCardInput' => false,
        'TokenisedStorage' => false,
    );
}
function ccavenuev2_config()
{
    return array("Name" => array("Type" => "System", "Value" => "CCAvenue API v2"), "MerchantId" => array("Name" => "Merchant Id", "Type" => "text", "Description" => "Obtained from CCAvenue M.A.R.S Account under Settings -> API Keys"), "AccessCode" => array("Name" => "Access Code", "Type" => "password"), "WorkingKey" => array("Name" => "Working Key", "Type" => "password"), "TestMode" => array("Name" => "Test Mode", "Type" => "yesno", "Description" => "Tick to use CCAvenue’s Test Environment - requires a separate Test Account"));
}
function ccavenuev2_link(array $params)
{
    $url = "https://secure.ccavenue.com/transaction/transaction.do?command=initiateTransaction";
    if ($params["TestMode"] == "yes")
    {
        $url = "https://test.ccavenue.com/transaction/transaction.do?command=initiateTransaction";
    }
    $values = array();
    $values["merchant_id"] = (int) $params["MerchantId"];
    $values["order_id"] = $params["invoiceid"];
    $values["currency"] = $params["currency"];
    $values["amount"] = $params["amount"];
    $values["redirect_url"] = $params["returnurl"];
    $values["cancel_url"] = $params["returnurl"];
    $values["language"] = "EN";
    $values["billing_name"] = $params["clientdetails"]["fullname"];
    $values["billing_address"] = $params["clientdetails"]["address1"];
    $values["billing_city"] = $params["clientdetails"]["city"];
    $values["billing_state"] = $params["clientdetails"]["state"];
    $values["billing_zip"] = preg_replace("/[^a-zA-Z0-9]/", "", $params["clientdetails"]["postcode"]);
    $values["billing_country"] = $params["clientdetails"]["countryname"];
    $values["billing_tel"] = $params["clientdetails"]["phonenumber"];
    $values["billing_email"] = $params["clientdetails"]["email"];
    $data = "";
    foreach ($values as $key => $value) {
        $data .= $key . "=" . $value . "&";
    }
    try {
        $encryptedData = Whasols\Module\Gateway\CCAvenue\CCAvenue::factory($params["WorkingKey"])->encrypt($data);
        $payNow = "Pay Now";
        return "<form action=\"" . $url . "\" id=\"ccAvenuePaymentForm\" method=\"POST\">\n    <input type=\"hidden\" name=\"encRequest\" value=\"" . $encryptedData . "\" />\n    <input type=\"hidden\" name=\"access_code\" value=\"" . $params["AccessCode"] . "\" />\n    <input type=\"submit\" value=\"" . $payNow . "\">\n</form>";
    } catch (Exception $e)
    {
        return "<div class=\"alert alert-danger\">An Error Occurred - Please Contact Support</div>";
    }
}
function ccavenuev2_callback($params)
{
    $eTitle = $params['gateway']['title'];
    $gateway_id = $params['gateway']['id'];

    $passedInvoiceId = (int) $_REQUEST["orderNo"];
    $encodedResponse = $_REQUEST["encResp"];


    try {
        $decryptedResponse = Whasols\Module\Gateway\CCAvenue\CCAvenue::factory($params["WorkingKey"])->decrypt($encodedResponse);
        $returnedVariables = array();
        parse_str($decryptedResponse, $returnedVariables);
        $currency = $returnedVariables["currency"];
        $transactionId = $returnedVariables["tracking_id"];
        $amount = $returnedVariables["amount"];
        $orderStatus = $returnedVariables["order_status"];
        $invoiceId = $returnedVariables["order_id"];
        if ($invoiceId != $passedInvoiceId) return '<div class="alert alert-danger">Invailed Access Atempt.....</div>'; 
    } catch (Exception $e) 
    {
        $orderStatus = "invalid";
        $returnedVariables = array("error" => $e->getMessage());
        $amount = $currency = $invoiceId = $transactionId = 0;
    }


    $invoiceid = $params['invoice']['invoiceid'];
    $description = $params['invoice']["description"];
    $amount = $params['invoice']['amount'];
    $currencyCode = $params['invoice']['currency'];
    $currency = $arg['invoice']['currency'];
    $payment_method = $arg['invoice']['payment_method'];
    $user_id = $arg['client']['id'];
    // System Parameters
    $companyName = $arg['system']['companyname'];
    $systemUrl = $arg['system']['systemurl'];            // System URL
    $siteurl = $arg['system']['siteurl'];            // System URL


    $REQUEST = $_REQUEST;
    $htmlOutput = '';   

    if(strtolower($orderStatus) == "failure")
    {
        $REQUEST["TransStatus"] = "Failed";
        AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$returnedVariables,"message"=>"Payment Confirmation Failed By Gateway"));
        return '<div class="alert alert-danger">Payment Confirmation By Gateway failed...</div>';
    }
    if(strtolower($orderStatus) == "aborted")
    {
        $REQUEST["TransStatus"] = "Aborted";
        AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$returnedVariables,"message"=>"Payment Aborted By Gateway"));
        return '<div class="alert alert-danger">Payment Aborted By Gateway...</div>';
    }
    if(strtolower($orderStatus) != "success")
    {
        $REQUEST["TransStatus"] = "Invailed";
        AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$returnedVariables,"message"=>"Payment Invailed By Gateway"));
        return '<div class="alert alert-danger">Payment Invailed By Gateway...</div>';
    }
    $isValid =  DoInvoiceValidate($invoiceid);
    if(!$isValid) return '<div class="alert alert-danger">Invoice Id is Invailed.....</div>'; 
    if($invoiceid<>$invoiceid) return '<div class="alert alert-danger">Invoice Id is Invailed.....</div>'; 
    $transid = $transactionId;
    $fee = 0;
    $isValid =  DoTransactionValidate($invoiceid,$transid);
    if($isValid) return '<div class="alert alert-danger">Transaction No already exist.....</div>';

    $payment_added = AddInvoicePayment(['invoice_id'=>$invoiceid,'currency'=>$currency,'user_id'=>$user_id,'payment_method'=>$payment_method,'amount'=>$amount,'trno'=>$transid,'fee'=>$fee,'notification'=>'YES']);

    $REQUEST["TransStatus"] = "Success";
    AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$REQUEST,"message"=>"Payment Confirmed By Gateway"));

    header("Location: /client/view-invoice/".$invoiceid);
    if($payment_added['status'] != 'success') return '<div class="alert alert-danger">Payment Confirmed but Payment entry error...'.$payment_added['message'].'</div>';
    die();
}