<?php
if (!defined("WHASOLS")) exit("This file cannot be accessed directly");
function chronopay_info()
{
    return array(
        'DisplayName' => 'ChronoPay', // display name for client
        'APIVersion' => '1.0', 
        'DisableLocalCredtCardInput' => false,
        'TokenisedStorage' => false,
    );
}
function chronopay_config()
{
    return [
        "Name" =>["Type" => "System", "Value" => "ChronoPay"],
        "productid" =>["Name" => "Product ID", "Type" => "text", "Size" => "20", "Description" => "The product ID of a generic product in your ChronoPay Account"],
        "sharedsecret" =>["Name" => "Shared Secret", "Type" => "text", "Size" => "30", "Description" => "The shared secret is a unique code known only by ChronoPay and the Merchant"]
    ];
}
function chronopay_link($params)
{
    $operationChecksum = md5(sprintf("%s-%s-%s", $params["productid"], $params["amount"], $params["sharedsecret"]));
    $code = "\n<form action=\"https://payments.chronopay.com/\" method=\"post\">\n<input type=\"hidden\" name=\"sign\" value=\"" . $operationChecksum . "\">\n<input type=\"hidden\" name=\"product_id\" value=\"" . $params["productid"] . "\">\n<input type=\"hidden\" name=\"product_name\" value=\"" . $params["description"] . "\">\n<input type=\"hidden\" name=\"product_price\" value=\"" . $params["amount"] . "\">\n<input type=\"hidden\" name=\"product_price_currency\" value=\"" . $params["currency"] . "\">\n<input type=\"hidden\" name=\"f_name\" value=\"" . $params["clientdetails"]["firstname"] . "\">\n<input type=\"hidden\" name=\"s_name\" value=\"" . $params["clientdetails"]["lastname"] . "\">\n<input type=\"hidden\" name=\"email\" value=\"" . $params["clientdetails"]["email"] . "\">\n<input type=\"hidden\" name=\"street\" value=\"" . $params["clientdetails"]["address1"] . "\">\n<input type=\"hidden\" name=\"city\" value=\"" . $params["clientdetails"]["city"] . "\">\n<input type=\"hidden\" name=\"state\" value=\"" . $params["clientdetails"]["state"] . "\">\n<input type=\"hidden\" name=\"zip\" value=\"" . $params["clientdetails"]["postcode"] . "\">\n<input type=\"hidden\" name=\"country\" value=\"" . $params["clientdetails"]["country"] . "\">\n<input type=\"hidden\" name=\"phone\" value=\"" . $params["clientdetails"]["phonenumber"] . "\">\n<input type=\"hidden\" name=\"cs1\" value=\"" . $params["invoiceid"] . "\">\n<input type=\"hidden\" name=\"cb_url\" value=\"" . $params["returnurl"] . "\">\n<input type=\"hidden\" name=\"cb_type\" value=\"P\">\n<input type=\"hidden\" name=\"success_url\" value=\"" . $params["returnurl"] . "?paymentsuccess=true\">\n<input type=\"hidden\" name=\"decline_url\" value=\"" . $params["returnurl"] . "?paymentfailed=true\">\n<input type=\"submit\" value=\"" . $params["langpaynow"] . "\">\n</form> \n";
    return $code;
}
function chronopay_callback($params)
{
    $eTitle = $params['gateway']['title'];
    $gateway_id = $params['gateway']['id'];
    // Invoice Parameters
    $invoiceid = $params['invoice']['invoiceid'];
    $description = $params['invoice']["description"];
    $amount = $params['invoice']['amount'];
    $currency = $currencyCode = $params['invoice']['currency'];
    $payment_method = $params['invoice']['payment_method'];
    $user_id = $params['client']['id'];
    $REQUEST = $_REQUEST;
    $htmlOutput = '';   
    $isValid =  DoInvoiceValidate($invoiceid);
    if(!$isValid) return '<div class="alert alert-danger">Invoice Id is Invailed.....</div>'; 
    $postedSign = $REQUEST["sign"];
    $builtSign = md5($GATEWAY["sharedsecret"] . $REQUEST["customer_id"] . $REQUEST["transaction_id"] . $REQUEST["transaction_type"] . $REQUEST["total"]);
    $transactionStatus = "Invalid";
    if (strcasecmp($_POST["transaction_type"], "Purchase") == 0)
    {
        $transactionStatus = "Signature Error";
        if ($postedSign == $builtSign)
        {
            $transid = $_POST["transaction_id"];
            $invoiceid = $_POST["cs1"];
            $amount = $_POST["total"];
            $fee = 0;
            $isValid =  DoTransactionValidate($invoiceid,$transid);
            if($isValid) return '<div class="alert alert-danger">Transaction No already exist.....</div>';
            $payment_added = AddInvoicePayment(['invoice_id'=>$invoiceid,'currency'=>$currency,'user_id'=>$user_id,'payment_method'=>$payment_method,'amount'=>$amount,'trno'=>$transid,'fee'=>$fee,'notification'=>'YES']);
            $REQUEST["TransStatus"] = "Success";
            AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$REQUEST,"message"=>"Payment Confirmed By Gateway"));
            if($payment_added['status'] != 'success') return '<div class="alert alert-danger">Payment Confirmed but Payment entry error...'.$payment_added['message'].'</div>';
            header("Location: /client/view-invoice/".$invoiceid);
            die();
        }
        $REQUEST["TransStatus"] = "Failed";
        AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$REQUEST,"message"=>"Payment Confirmation By Gateway Failed"));
        return '<div class="alert alert-danger">Payment Confirmation By Gateway failed due Mismatch Sign Data...</div>';    
    }
    $REQUEST["TransStatus"] = "Failed";
    AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$REQUEST,"message"=>"Payment Confirmation By Gateway Failed"));
    return '<div class="alert alert-danger">Payment Confirmation By Gateway failed due to Transaction ID not found in Request...</div>';    
}