<?php
if (!defined("WHMSOLS")) exit("This file cannot be accessed directly");
function inpay_info()
{
    return array(
        'DisplayName' => 'InPay', // display name for client
        'APIVersion' => '1.0', 
        'DisableLocalCredtCardInput' => false,
        'TokenisedStorage' => false,
    );
}
function inpay_config()
{
    $configarray = array("Name" => array("Type" => "System", "Value" => "inpay"), "username" => array("Name" => "Merchant ID", "Type" => "text", "Size" => "20"), "secretkey" => array("Name" => "Secret ket", "Type" => "text", "Size" => "20"), "testmode" => array("Name" => "Test Mode", "Type" => "yesno", "Description" => "Use test gateway"));
    return $configarray;
}
function inpay_link($params)
{
    $gatewayusername = $params["username"];
    $gatewaytestmode = $params["testmode"];
    $invoiceid = $params["invoiceid"];
    $description = $params["description"];
    $amount = $params["amount"];
    $currency = $params["currency"];
    $firstname = $params["clientdetails"]["firstname"];
    $lastname = $params["clientdetails"]["lastname"];
    $email = $params["clientdetails"]["email"];
    $address1 = $params["clientdetails"]["address1"];
    $address2 = $params["clientdetails"]["address2"];
    $city = $params["clientdetails"]["city"];
    $state = $params["clientdetails"]["state"];
    $postcode = $params["clientdetails"]["postcode"];
    $country = $params["clientdetails"]["country"];
    $phone = $params["clientdetails"]["phonenumber"];
    $companyname = $params["companyname"];
    $systemurl = $params["systemurl"];
    $currency = $params["currency"];
    $params["checksum"] = calcInpayMd5Key($params);
    $url = "https://secure.inpay.com";
    if ($gatewaytestmode == "yes") {
        $url = "https://test-secure.inpay.com";
    }
    $pend_url = $ret_url = $params["returnurl"];
    $code = "<form method=\"post\" action=\"" . $url . "\">\n              <input type=\"hidden\" name=\"order_id\" value=\"" . $invoiceid . "\" />\n              <input type=\"hidden\" name=\"merchant_id\" value=\"" . $params["username"] . "\" />\n              <input type=\"hidden\" name=\"amount\" value=\"" . $amount . "\" />\n              <input type=\"hidden\" name=\"currency\" value=\"" . $currency . "\" />\n              <input type=\"hidden\" name=\"order_text\" value=\"" . $description . "\" />\n              <input type=\"hidden\" name=\"flow_layout\" value=\"multi_page\" />\n              <input type=\"hidden\" name=\"return_url\" value=\"" . $ret_url . "\" />\n              <input type=\"hidden\" name=\"pending_url\" value=\"" . $pend_url . "\" />\n              <input type=\"hidden\" name=\"checksum\" value=\"" . $params["checksum"] . "\" />\n              <input type=\"hidden\" name=\"buyer_email\" value=\"" . $email . "\" />\n              <input type=\"hidden\" name=\"buyer_name\" value=\"" . $firstname . " " . $lastname . "\" />\n              <input type=\"hidden\" name=\"buyer_address\" value=\"" . $address1 . "\" />\n              <input type=\"submit\" value=\"Pay with inpay\" />\n              </form>";
    return $code;
}
function calcInpayMd5Key($order)
{
    $sk = $order["secretkey"];
    $q = http_build_query(array("merchant_id" => $order["username"], "order_id" => $order["invoiceid"], "amount" => $order["amount"], "currency" => $order["currency"], "order_text" => $order["description"], "flow_layout" => "multi_page", "secret_key" => $sk), "", "&");
    $md5v = md5($q);
    return $md5v;
}
function inpay_callback($params)
{
    $eTitle = $params['gateway']['title'];
    $gateway_id = $params['gateway']['id'];

    // Invoice Parameters
    $invoiceid = $params['invoice']['invoiceid'];
    $description = $params['invoice']["description"];
    $amount = $params['invoice']['amount'];
    $currency = $currencyCode = $params['invoice']['currency'];
    $payment_method = $params['invoice']['payment_method'];
    $user_id = $params['client']['id'];


    $REQUEST = $_POST;
    $htmlOutput = '';   

    $result = "VERIFIED";
    $ok = true;
    if (!isset($_POST["checksum"]) || !isset($_POST["invoice_reference"]) || !isset($_POST["invoice_created_at"]) || !isset($_POST["invoice_status"]) || !isset($_POST["invoice_currency"]) || !isset($_POST["invoice_amount"]) || !isset($_POST["order_id"])) {
        $ok = false;
        $result = "missing vatiables";
    }
    if ($ok)
    {
        $sk = $params["secretkey"];
        $q = http_build_query(array("order_id" => $_POST["order_id"], "invoice_reference" => $_POST["invoice_reference"], "invoice_amount" => $_POST["invoice_amount"], "invoice_currency" => $_POST["invoice_currency"], "invoice_created_at" => $_POST["invoice_created_at"], "invoice_status" => $_POST["invoice_status"], "secret_key" => $sk), "", "&");
        $md5v = md5($q);
        if ($md5v != $_POST["checksum"]) {
            $ok = false;
            $result = "bad checksum";
        }
    }

    $approved = false;
    if ($ok)
    {
        $invoice_status = inpay_get_invoice_status($_POST,$params);
        $ok = false;
        if (($invoice_status == "pending" || $invoice_status == "created") && ($_POST["invoice_status"] == "pending" || $_POST["invoice_status"] == "created")) {
            $ok = true;
        } else {
            if ($invoice_status == "approved" && $_POST["invoice_status"] == "approved") {
                $ok = true;
                $approved = true;
            } else {
                if ($invoice_status == "sum_too_low" && $_POST["invoice_status"] == "sum_too_low") {
                    $ok = true;
                }
            }
        }
        if (!$ok) {
            $result = "Bad invoice status:" . $invoice_status;
        }
    }
    $status = $_POST["invoice_status"];
    $invoiceid = $_POST["order_id"];
    $transid = $_POST["invoice_reference"];
    $amount = $_POST["invoice_amount"];
    $fee = 0;

    $isValid =  DoInvoiceValidate($invoiceid);
    if(!$isValid) return '<div class="alert alert-danger">Invoice Id is Invailed.....</div>'; 
    $isValid =  DoTransactionValidate($invoiceid,$transid);
    if($isValid) return '<div class="alert alert-danger">Transaction No already exist.....</div>';

    if ($ok)
    {
        $payment_added = [];
        $payment_added['status'] = "error";
        if ($approved)
        {
            $payment_added = AddInvoicePayment(['invoice_id'=>$invoiceid,'currency'=>$currency,'user_id'=>$user_id,'payment_method'=>$payment_method,'amount'=>$amount,'trno'=>$transid,'fee'=>$fee,'notification'=>'YES']);
            $payment_added['message'] = "Payment Confirmed By Gateway";
        }
        else
        {
            $payment_added['message'] = "Got update from inpay. transaction Id: " . $transid . " status: " . $status;
        }
        $transactionStatus = "Successful";
        $REQUEST["TransStatus"] = "Success";
        AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$REQUEST,"message"=>$payment_added['message']));
        if($payment_added['status'] != 'success') return '<div class="alert alert-danger">'.$payment_added['message'].'</div>';
        header("Location: /client/view-invoice/".$invoiceid);
        die();
    }
    
    $REQUEST["TransStatus"] = "Failed";
    AddGatewayLogs(['invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$REQUEST,"message"=>"Payment Confirmation By Gateway Failed"]);
    return '<div class="alert alert-danger">Payment Confirmation By Gateway failed due to Transaction ID not found in Request...</div>'; 
}
function inpay_get_invoice_status($pars=[],$params=[])
{
    $calc_md5 = calc_inpay_invoice_status_md5key(array("invoice_ref" => $pars["invoice_reference"], "merchant_id" => $params["username"], "secret_key" => $params["secretkey"]));
    $q = http_build_query(array("merchant_id" => $params["username"], "invoice_ref" => $pars["invoice_reference"], "checksum" => $calc_md5), "", "&");
    $fsocket = false;
    $curl = false;
    $result = false;
    $fp = false;
    $server = "secure.inpay.com";
    if ($params["testmode"] == "yes") $server = "test-secure.inpay.com";
    if (4.3 <= PHP_VERSION && ($fp = @fsockopen("ssl://" . $server, 443, $errno, $errstr, 30))) {
        $fsocket = true;
    } else {
        if (function_exists("curl_exec")) {
            $curl = true;
        }
    }
    if ($fsocket == true) {
        $header = "POST /api/get_invoice_status HTTP/1.1" . "\r\n" . "Host: " . $server . "\r\n" . "Content-Type: application/x-www-form-urlencoded" . "\r\n" . "Content-Length: " . strlen($q) . "\r\n" . "Connection: close" . "\r\n\r\n";
        @fputs($fp, $header . $q);
        $str = "";
        while (!@feof($fp)) {
            $res = @fgets($fp, 1024);
            $str .= (string) $res;
        }
        @fclose($fp);
        $result = $str;
        $result = preg_split("/^\\r?\$/m", $result, 2);
        $result = trim($result[1]);
        $result = preg_split("/\\n/m", $result);
        if (1 < count($result)) {
            $result = trim($result[1]);
        } else {
            $result = trim($result[0]);
        }
    } else {
        if ($curl == true) {
            $ch = curl_init();
            curl_setopt($ch, CURLOPT_URL, "https://" . $server . "/api/get_invoice_status");
            curl_setopt($ch, CURLOPT_POST, true);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $q);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_HEADER, false);
            curl_setopt($ch, CURLOPT_TIMEOUT, 30);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
            $result = curl_exec($ch);
            curl_close($ch);
        }
    }
    return (string) $result;
}
function calc_inpay_invoice_status_md5key($pars)
{
    $q = http_build_query($pars, "", "&");
    $md5v = md5($q);
    error_log("BBB calc_inpay_invoice_status_md5key q=" . print_r($q, true) . " ck=" . $md5v . "\n", 3, "./ami_errors_cb.log");
    return $md5v;
}