<?php
if (!defined("WHASOLS")) exit("This file cannot be accessed directly");
function moipapi_info()
{
    return array(
        'DisplayName' => 'Pagamento Moip', // display name for client
        'APIVersion' => '4.1', 
        'DisableLocalCredtCardInput' => false,
        'TokenisedStorage' => false,
    );
}
function moipapi_config()
{
    $configarray = array("Name" => array("Type" => "System", "Value" => "Modulo Moip"),
        "username" => array("Name" => "Usuário do Sistema", "Type" => "text", "Size" => "30", "Description" => "Nome do usuário administrador"),
        "emailpd" => array("Name" => "ID*", "Type" => "text", "Size" => "30", "Description" => "ID Usuário cadastrado com o Moip"),
        "taxa_porc" => array("Name" => "Taxa %", "Type" => "text", "Size" => "5", "Description" => "Taxa adicional em porcentagem"),
        "taxa_reais" => array("Name" => "Taxa Reais", "Type" => "text", "Size" => "5", "Description" => "Taxa adicional em reais"),
        "layout" => array("Name" => "Layout", "Type" => "text", "Size" => "20", "Description" => "Insira o nome do layout criado em sua conta Moip, caso nao haja essa informação o layout utilizado sera o defalt (padrão) Moip.\n<br>Para criar ou alterar um layout acesse sua conta Moip no menu \"Meus Dados\" >> \" Preferencias \" >> \" Layout personalizado da pagina de pagamento \"."),
        "url_retorno" => array("Name" => "Url de retorno", "Type" => "text", "Size" => "20", "Description" => "Insira aqui o endereço de onde está instalado o seu WHASOLS\"."),
        "inst_boleto1" => array("Name" => "Instrução boleto #1", "Type" => "text", "Size" => "20", "Description" => "Digite aqui a instrução que deseja que seja informada na primeira linha do boleto EX: Senhor caixa, não receber após o vencimento."),
        "inst_boleto2" => array("Name" => "Instrução boleto #2", "Type" => "text", "Size" => "20", "Description" => "Digite aqui a instrução que deseja que seja informada na segunda linha do boleto EX: Senhor caixa, não receber após o vencimento."),
        "inst_boleto3" => array("Name" => "Instrução boleto #3", "Type" => "text", "Size" => "20", "Description" => "Digite aqui a instrução que deseja que seja informada na terceira linha do boleto EX: Senhor caixa, não receber após o vencimento."),
        "obs" => array("Name" => "Observações", "Type" => "textarea", "Size" => "3", "Description" => "Insira um texto na fatura, Ex: Aceitamos Apenas Boleto..."),
        "url_image" => array("Name" => "Url da imagem*", "Type" => "text", "Size" => "50", "Description" => "Insira aqui a url da imagem que deseja que seja exibida no lugar do botão pagar agora."),
        "url_logo_boleto" => array("Name" => "Url logo boleto", "Type" => "text", "Size" => "80", "Description" => "Digite a url da logo que deverá ser exibida no boleto ex: http:\\seusite.com\\logo.jpg"),
        "tp_venc" => array("Name" => "Tipo vencimento Dias", "Type" => "dropdown", "Options" => "Corridos,Uteis", "Description" => "Digite a forma como deve ser gerado o vencimento em dias úteis ou corridos."),
        "prz_venc" => array("Name" => "Prazo vencimento Dias", "Type" => "text", "Size" => "2", "Description" => "Digite O prazo para vencimento em dias."),
        "func_dbg" => array("Name" => "Ativar Debug", "Type" => "dropdown", "Options" => "Não,Sim", "Description" => "Habilita função debug."),
        "gravaDB" => array("Name" => "Retorno Automático", "Type" => "yesno", "Default" => "yes", "Description" => "Desmarque para não gravar as informações do retorno automático dos dados."),
        "habimage" => array("Name" => "Habilita Imagem", "Type" => "yesno", "Value" => "", "Description" => "Habilita trocar o botão pagar agora por uma imagem."),
        "habredir" => array("Name" => "Habilita Redirecionamento", "Type" => "yesno", "Value" => "", "Description" => "Habilita direcionar o cliente direto ao pagamento ao invés de exibir a fatura, evitando assim a necessidade do botão pagar agora"),
        "capestado" => array("Name" => "Captura estado", "Type" => "yesno", "Value" => "", "Description" => "Habilita capturar estado do cadastro do cliente e converter em sigla, pra isso o cadastro deve estar correto!.")
    );
    return $configarray;
}
function moipapiformata_data($data)
{
    list($ano, $mes, $dia) = explode("-", $data);
    $data = (string) $dia . "-" . $mes . "-" . $ano;
    return $data;
}
function moipapiformata_estado($estado)
{
    $estado = strtoupper($estado);
    $acentos = array("A" => array("Á", "À", "Â", "Ã", "Ä", "á", "à", "â", "ã", "ä"), "E" => array("É", "È", "Ê", "Ë", "é", "è", "ê", "ë"), "I" => array("Í", "Ì", "Î", "Ï", "í", "ì", "î", "ï"), "O" => array("Ó", "Ò", "Ô", "Õ", "Ö", "ó", "ò", "ô", "õ", "ö"), "U" => array("Ú", "Ù", "Û", "Ü", "ú", "ù", "û", "ü"), "misc" => array(" ", ".", ",", ":", ";", "<", ">", "\\", "/", "\"", "'", "|", "?", "!", "@", "#", "\$", "%", "&", "*", "(", ")", "[", "]", "{", "}", "Ž", "`", "~", "^", "š", "-", "_", "=", "+", "1", "2", "3", "4", "5", "6", "7", "8", "9", "0"));
    $estado = str_ireplace($acentos["A"], "A", $estado);
    $estado = str_ireplace($acentos["E"], "E", $estado);
    $estado = str_ireplace($acentos["I"], "I", $estado);
    $estado = str_ireplace($acentos["O"], "O", $estado);
    $estado = str_ireplace($acentos["U"], "U", $estado);
    $estado = str_ireplace($acentos["misc"], "", $estado);
    switch ($estado) {
        case "ACRE":
            $estado = "AC";
            break;
        case "ALAGOAS":
            $estado = "AL";
            break;
        case "AMAPA":
            $estado = "AP";
            break;
        case "AMAZONAS":
            $estado = "AM";
            break;
        case "BAHIA":
            $estado = "BA";
            break;
        case "CEARA":
            $estado = "CE";
            break;
        case "DISTRITOFEDERAL":
            $estado = "DF";
            break;
        case "ESPIRITOSANTO":
            $estado = "ES";
            break;
        case "GOIAS":
            $estado = "GO";
            break;
        case "MARANHAO":
            $estado = "MA";
            break;
        case "MATOGROSSO":
            $estado = "MT";
            break;
        case "MATOGROSSODOSUL":
            $estado = "MS";
            break;
        case "MINASGERAIS":
            $estado = "MG";
            break;
        case "PARA":
            $estado = "PA";
            break;
        case "PARAIBA":
            $estado = "PB";
            break;
        case "PARANA":
            $estado = "PR";
            break;
        case "PERNAMBUCO":
            $estado = "PE";
            break;
        case "PIAUI":
            $estado = "PI";
            break;
        case "RIODEJANEIRO":
            $estado = "RJ";
            break;
        case "RIOGRANDEDONORTE":
            $estado = "RN";
            break;
        case "RIOGRANDEDOSUL":
            $estado = "RS";
            break;
        case "RONDONIA":
            $estado = "RO";
            break;
        case "RORAIMA":
            $estado = "RR";
            break;
        case "SANTACATARINA":
            $estado = "SC";
            break;
        case "SAOPAULO":
            $estado = "SP";
            break;
        case "SERGIPE":
            $estado = "SE";
            break;
        case "TOCANTINS":
            $estado = "TO";
            break;
    }
    return $estado;
}
function moipapi_link($params)
{
    $data_vencimento = moipapiformata_data($params["duedate"]);
    $estado = moipapiformata_estado($params["clientdetails"]["state"]);
    $taxa = $params["taxa_porc"] / 100 * $params["amount"] + $params["taxa_reais"];
    $valor_total = $params["amount"] + $taxa;
    $valor_total = number_format($valor_total, "2", ".", "");
    $valor = number_format($valor_total, "2", ".", "");
    $taxa = number_format($taxa, "2", ".", "");
    $key_plata = rand(0, 1000);
    $code = "";
    if (0 < $taxa)
    {
        $code .= "<br />Para pagamentos efetuados com o Moip será cobrada uma taxa adicional de ";
        if (0 < $params["taxa_porc"]) {
            $code .= "<strong>" . $params["taxa_porc"] . "%</strong>";
            $code .= 0 < $params["taxa_reais"] ? " + " : "";
        }
        $code .= 0 < $params["taxa_reais"] ? "<strong>R\$ " . $params["taxa_reais"] . "</strong>" : "";
    }
    $descricao = $params["description"];
    $auth = "HMTE0EEQEIXZWZGTO5DHI5T4EIRTZFP9" . ":" . "GIC8GQ1F8HRYA9OBGWMDFNPTLRF8I1XZPQVKJ7LA";
    $logradouro = $params["clientdetails"]["address1"];
    $cidade = $params["clientdetails"]["city"];
    $bairro = $params["clientdetails"]["address2"];
    $telefone = str_replace(" ", "", str_replace("-", "", $params["clientdetails"]["phonenumber"]));
    $first_name = $params["clientdetails"]["firstname"];
    $nome_pagador = $params["clientdetails"]["firstname"] . " " . $params["clientdetails"]["lastname"];
    $cep = str_replace("-", "", $params["clientdetails"]["postcode"]);
    $email_pagador = $params["clientdetails"]["email"];
    $trans_id = $params["invoiceid"];
    $userid = $params["clientdetails"]["userid"];
    $numeros = explode(",", $logradouro);
    $numero = $numeros[1];
    $ct_moip = $params["emailpd"];
    $diasexp = "5";
    $btipo = $params["tp_venc"];
    $prz_venc = $params["prz_venc"];
    $instboleto1 = $params["inst_boleto1"];
    $endereco = $numeros[0];
    $companyname = $params["companyname"];
    $layout = $params["layout"];
    $inst_boleto1 = $params["inst_boleto1"];
    $inst_boleto2 = $params["inst_boleto2"];
    $inst_boleto3 = $params["inst_boleto3"];
    $url_notifica = $params["returnurl"];
    $url_retorno = rtrim($params["systemurl"],"/") . "/client/view-invoice/" . $params["invoiceid"];
    $xml = "<EnviarInstrucao>\n<InstrucaoUnica>\n<Razao>" . $companyname . " - Fatura: #" . $trans_id . " </Razao>\n<Valores><Valor moeda='BRL'>" . $valor_total . "</Valor></Valores>\n<IdProprio>Pedido: " . $trans_id . " Transação " . $userid . " " . $key_plata . "</IdProprio>\n<Pagador><Nome>" . $nome_pagador . "</Nome>\n<Email>" . $email_pagador . "</Email>\n<TelefoneCelular>" . $telefone . "</TelefoneCelular>\n<Apelido>" . $first_name . "</Apelido>\n<Identidade>111.111.111-11</Identidade>\n<EnderecoCobranca><Logradouro>" . $endereco . "</Logradouro>\n<Numero>" . $numero . "</Numero><Complemento></Complemento>\n<Bairro>" . $bairro . "</Bairro>\n<Cidade>" . $cidade . "</Cidade>\n<Estado>" . $estado . "</Estado>\n<Pais>BRA</Pais>\n<CEP>" . $cep . "</CEP>\n<TelefoneFixo>" . $telefone . "</TelefoneFixo>\n</EnderecoCobranca>\n</Pagador>\n<Mensagens>\n         <Mensagem>Pedido: " . $trans_id . " Transação " . $userid . " " . $key_plata . "</Mensagem>\n         <Mensagem>" . $companyname . "</Mensagem>\n      </Mensagens>\n<Recebedor>\n      <LoginMoIP>" . $ct_moip . "</LoginMoIP>\n      <Apelido>" . $companyname . "</Apelido>\n    </Recebedor>\n<URLRetorno>" . $url_retorno . "</URLRetorno>\n<URLNotificacao>" . $url_notifica . "</URLNotificacao>\n</InstrucaoUnica></EnviarInstrucao>\n";
    $xml2 = utf8_encode($xml);
    $header[] = "Authorization: Basic " . base64_encode($auth);
    $url = "https://www.moip.com.br/ws/alpha/EnviarInstrucao/Unica";
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_URL, $url);
    curl_setopt($curl, CURLOPT_HTTPHEADER, $header);
    curl_setopt($curl, CURLOPT_USERPWD, $auth);
    curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
    curl_setopt($curl, CURLOPT_USERAGENT, "Mozilla/4.0");
    curl_setopt($curl, CURLOPT_POST, true);
    curl_setopt($curl, CURLOPT_POSTFIELDS, $xml2);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
    $ret = curl_exec($curl);
    $err = curl_error($curl);
    curl_close($curl);
    $resposta_moip = simplexml_load_string($ret);
    $token_resposta = $res->Resposta->Token;
    $ret_sucesso = explode("Sucesso", $ret);
    $token_new = $ret_sucesso[1];
    $a = explode("<Token>", $token_new);
    $b = explode("</Token>", $a[1]);
    $token_link = $b[0];
    $resp_a = explode("<Status>", $ret);
    $resp_b = explode("</Status>", $resp_a[1]);
    $status_token = $resp_b[0];
    $erro_cod_a = explode("<Erro Codigo=\"", $ret);
    $erro_cod_b = explode("\">", $erro_cod_a[1]);
    $erro_cod = $erro_cod_b[0];
    $erro_msg_a = explode("<Erro Codigo=\"" . $erro_cod . "\">", $ret);
    $erro_msg_b = explode("</Erro>", $erro_msg_a[1]);
    $erro_msg = $erro_msg_b[0];
    $erro_msgiso = $erro_msg;
    if ($params["func_dbg"] == "Sim") {
        $code .= "erro = " . $err . ", " . $xmll . " = " . $xml2 . ", ret " . $ret . ", token= " . $token_link . " ";
    }
    if ($estado == "") {
        $erro_msg = "Cadastro do cliente com erro no campo estado";
        $erro_msgiso = "Cadastro do cliente com erro no campo estado";
    }
    $code .= "<form name=\"pagamentomoip\" action=\"https://www.moip.com.br/Instrucao.do?\" method=\"get\" accept-charset=\"ISO-8859-1\">\n<input name=\"token\" type=\"hidden\" value=\"" . $token_link . "\"> <input name=\"layout\" type=\"hidden\" value=\"" . $layout . "\">";
    if (!empty($params["obs"])) $code .= "Observações: <strong>" . $params["obs"] . "</strong>";
    $code .= "<br />Total a pagar: <strong> R\$ " . $valor_total . " </strong><br />";
    if ($erro_msg != "") {
        $code .= " <font color=#FF0000> Erro: <strong> ' " . $erro_msgiso . "; ' Volte e corrija-o, caso necessário contate o suporte da cw2.</strong> </font>";
    } else {
        if (!empty($params["habimage"]))
        {
            $code .= "<input type=\"image\" name=\"submit\" src=\"" . $params["url_image"] . "\" alt=\"Pagar\" border=\"0\">";
        } else {
            $code .= "\n <input type=\"submit\" value=\"" . $params["langpaynow"] . "\">";
        }
    }
    $code .= "\n</form>";
    $teste = $params["habredir"];
    if ($params["habredir"] == "yes")
    {
        header("Location: https://www.moip.com.br/Instrucao.do?token=" . $token_link);
    }
    return $code;
}

function moipapi_callback($params)
{
    $eTitle = $params['gateway']['title'];
    $gateway_id = $params['gateway']['id'];
    $partnerid = $params['gateway']['partnerid']; 
    $customDescription = $params['gateway']['customDescription'];
    // Invoice Parameters
    $invoiceid = $params['invoice']['invoiceid'];
    $description = $params['invoice']["description"];
    $amount = $params['invoice']['amount'];
    $currency = $currencyCode = $params['invoice']['currency'];
    $payment_method = $params['invoice']['payment_method'];
    $user_id = $params['client']['id'];

    $REQUEST = $_REQUEST;
    $id_transacao = $_POST["id_transacao"];
    $transid = $_POST["cod_moip"];
    $valor = $_POST["valor"];
    $real = substr($valor, 0, -2);
    $cent = substr($valor, -2);
    $amount = $real . "." . $cent;
    $parcelas = $_POST["parcelas"];
    $status_pagamento = $_POST["status_pagamento"];
    $email_consumidor = $_POST["email_consumidor"];
    $fee = $_POST["tipo_pagamento"];
    $data_hora = date("d/m/Y H:i:s");
    $hora = date("H:i:s");
    $transacao = explode(":", $_POST["id_transacao"]);
    $transacao_novo = $transacao[1];
    $tmp = explode("-", $transacao_novo);
    $faturaid = str_replace(" ", "", $tmp[0]);
    $varuser1 = explode(" ", $transacao_novo);


    $isValid =  DoInvoiceValidate($invoiceid);
    if(!$isValid) return '<div class="alert alert-danger">Invoice Id is Invailed.....</div>'; 
    $isValid =  DoTransactionValidate($invoiceid,$transid);
    if($isValid) return '<div class="alert alert-danger">Transaction No already exist.....</div>';
    if ($tipo_pagamento == "BoletoBancario")
    {
        $tp_pagamento = "Boleto Bancário";
        $vr_taxa = 1.39;
        $percentual = 2.9 / 100;
    }
    if ($tipo_pagamento == "DebitoBancario") {
        $tp_pagamento = "Débito Bancário";
        $vr_taxa = 0.39;
        $percentual = 2.9 / 100;
    }
    if ($tipo_pagamento == "FinanciamentoBancario"){
        $tp_pagamento = "Financiamento Bancário";
        $vr_taxa = 0.39;
        $percentual = 2.9 / 100;
    }
    if ($tipo_pagamento == "CartaoDeCredito") {
        $tp_pagamento = "CartÃ£o de Crédito";
        $vr_taxa = 0.39;
        $percentual = 7.4 / 100;
    }
    if ($tipo_pagamento == "CartaoDeDebito") {
        $tp_pagamento = "CartÃ£o de Débito";
        $vr_taxa = 0.39;
        $percentual = 7.4 / 100;
    }
    if ($tipo_pagamento == "CarteiraMoIP") {
        $tp_pagamento = "Carteira Moip";
        $vr_taxa = 0.39;
        $percentual = 2.9 / 100;
    }
    if ($tipo_pagamento == "NaoDefinida") $tp_pagamento = "NÃ£o definida";
    if (empty($tipo_pagamento)) $tp_pagamento = "Indefinida";

    $valor = $amount;
    $valor_final = $valor - $percentual * $valor;
    $amount_out = $valor_final - $vr_taxa;
    $variacao = $valor - $amount_out;



    if ($status_pagamento == "1")
    {
        $payment_added = AddInvoicePayment(['invoice_id'=>$invoiceid,'currency'=>$currency,'user_id'=>$user_id,'payment_method'=>$payment_method,'amount'=>$amount,'trno'=>$transid,'fee'=>$fee,'notification'=>'YES']);
        $REQUEST["TransStatus"] = "Success";
        AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$REQUEST,"message"=>$transid." Pagamento autorizado ".$tp_pagamento." ás ".$hora . " hs Fatura:".$amount." ".$variacao));
        if($payment_added['status'] != 'success') return '<div class="alert alert-danger">Pagamento confirmado, mas erro de entrada de pagamento</div>';
        header("Location: /client/view-invoice/".$invoiceid);
        die();
    }
   if ($status_pagamento == "2")
    {
        $msg = "Pagamento Iniciado/abandonado: via " . $tp_pagamento . " ás " . $hora . " hs Fatura: ";
        $REQUEST["TransStatus"] = "Failed";
        AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$REQUEST,"message"=>$msg." e ID da transação:".$transid));
        return '<div class="alert alert-danger">'.$msg.'</div>';
    }
    if ($status_pagamento == "3")
    {
        $transid = " Trans ID " . $transid . " Boleto Impresso ás " . $hora . " (<a href='https://www.moip.com.br/Boleto.do?id=" . $transid . "' title='2ª Via boleto'>'2ªVia boleto clique aqui' </a>)";
        $msg = "Boleto Impresso: via " . $tp_pagamento . " ás " . $hora . " hs Fatura:";
        AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$REQUEST,"message"=>$msg." ".$transid));
        return '<div class="alert alert-danger">'.$msg.' '.$transid.'</div>';
    }
    if ($status_pagamento == "4")
    {
        $msg = "Pagamento concluÃ­do: via " . $tp_pagamento . " ás " . $hora . " hs Fatura: ";
        AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$REQUEST,"message"=>$msg." e ID da transação:".$transid));
        return '<div class="alert alert-danger">'.$msg.'</div>';
    }
    if ($status_pagamento == "5") {
        $msg = "Pagamento CANCELADO: via " . $tp_pagamento . " ás " . $hora . " hs Fatura: ";
        AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$REQUEST,"message"=>$msg." e ID da transação:".$transid));
        return '<div class="alert alert-danger">'.$msg.'</div>';
    }
    if ($status_pagamento == "6") {
        $msg = "Pagamento em análise: via " . $tp_pagamento . " em " . $parcelas . " parcelas ás " . $hora . " hs Fatura: ";
        AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$REQUEST,"message"=>$msg." e ID da transação:".$transid));
        return '<div class="alert alert-danger">'.$msg.'</div>';
    }
    if ($status_pagamento == "7")
    {
        $msg = "Pagamento extornado: via " . $tp_pagamento . " em " . $parcelas . " parcelas ás " . $hora . " hs Fatura:";
        AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$REQUEST,"message"=>$msg." e ID da transação:".$transid));
        return '<div class="alert alert-danger">'.$msg.'</div>';
    }
    $msg = "Retorno desconhecido: via " . $tp_pagamento . " ás " . $hora . " hs Fatura:";
    AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$REQUEST,"message"=>$msg." e ID da transação:".$transid));
    return '<div class="alert alert-danger">'.$msg.'</div>';
}