<?php
if (!defined("WHASOLS")) exit("This file cannot be accessed directly");
function moneybookers_info()
{
    return array(
        'DisplayName' => 'Skrill Hosted Payment Solution', // display name for client
        'APIVersion' => '1.0', 
        'DisableLocalCredtCardInput' => false,
        'TokenisedStorage' => false,
    );
}
function moneybookers_config()
{
    return [
        "Name" =>["Type" => "System", "Value" => "Skrill Hosted Payment Solution"],
        "merchantemail" =>["Name" => "Merchant Email", "Type" => "text", "Size" => "50", "Description" => "The email address used to identify you to Skrill"],
        "secretword" =>["Name" => "Secret Word", "Type" => "text", "Size" => "30", "Description" => "Must match what is set in the Merchant Tools section of your Skrill Account"]
    ];
}
function moneybookers_link($params)
{
    global $WS_CONFIGS;
    $language = $WS_CONFIGS["language"];
    if ($params["clientdetails"]["language"]) {
        $language = $params["clientdetails"]["language"];
    }
    $languagecode = "EN";
    if ($language == "German") {
        $languagecode = "DE";
    }
    if ($language == "Spanish") {
        $languagecode = "ES";
    }
    if ($language == "French") {
        $languagecode = "FR";
    }
    if ($language == "Turkish") {
        $languagecode = "TR";
    }
    if ($language == "Italian") {
        $languagecode = "IT";
    }
    $code = "<form action=\"https://pay.skrill.com\" method=\"post\">\n<input type=\"hidden\" name=\"pay_to_email\" value=\"" . $params["merchantemail"] . "\">\n<input type=\"hidden\" name=\"pay_from_email\" value=\"" . $params["clientdetails"]["email"] . "\">\n<input type=\"hidden\" name=\"language\" value=\"" . $languagecode . "\">\n<input type=\"hidden\" name=\"amount\" value=\"" . $params["amount"] . "\">\n<input type=\"hidden\" name=\"currency\" value=\"" . $params["currency"] . "\">\n<input type=\"hidden\" name=\"recipient_description\" value=\"" . $params["companyname"] . "\">\n<input type=\"hidden\" name=\"detail1_description\" value=\"" . $params["description"] . "\">\n<input type=\"hidden\" name=\"detail1_text\" value=\"" . $params["invoiceid"] . "\">\n<input type=\"hidden\" name=\"return_url\" value=\"" . $params["returnurl"] . "\">\n<input type=\"hidden\" name=\"cancel_url\" value=\"" . $params["returnurl"] . "?paymentfailed=true\">\n<input type=\"hidden\" name=\"status_url\" value=\"" . $params["returnurl"] . "\">\n<input type=\"hidden\" name=\"transaction_id\" value=\"" . substr($params["invoiceid"] . time(), 0, 100) . "\">\n<input type=\"hidden\" name=\"firstname\" value=\"" . $params["clientdetails"]["firstname"] . "\">\n<input type=\"hidden\" name=\"lastname\" value=\"" . $params["clientdetails"]["lastname"] . "\">\n<input type=\"hidden\" name=\"address\" value=\"" . $params["clientdetails"]["address1"] . "\">\n<input type=\"hidden\" name=\"city\" value=\"" . $params["clientdetails"]["city"] . "\">\n<input type=\"hidden\" name=\"state\" value=\"" . $params["clientdetails"]["state"] . "\">\n<input type=\"hidden\" name=\"postal_code\" value=\"" . $params["clientdetails"]["postcode"] . "\">\n<input type=\"hidden\" name=\"merchant_fields\" value=\"platform,invoice_id\">\n<input type=\"hidden\" name=\"platform\" value=\"21477273\">\n<input type=\"hidden\" name=\"invoice_id\" value=\"" . $params["invoiceid"] . "\">\n<input type=\"submit\" value=\"" . $params["langpaynow"] . "\" class=\"btn btn-default btn-sm\">\n</form>";
    return $code;
}

function moneybookers_callback($params)
{
    $eTitle = $params['gateway']['title'];
    $gateway_id = $params['gateway']['id'];
    // Invoice Parameters
    $invoiceid = $params['invoice']['invoiceid'];
    $description = $params['invoice']["description"];
    $amount = $params['invoice']['amount'];
    $currency = $currencyCode = $params['invoice']['currency'];
    $payment_method = $params['invoice']['payment_method'];
    $user_id = $params['client']['id'];

    $invoiceid = (int) $_REQUEST["invoice_id"];
    $transactionId = $_REQUEST["transaction_id"];
    $transid = $_POST["mb_transaction_id"];
    $merchant_id = $_POST["merchant_id"];
    $mb_amount = $_POST["mb_amount"];
    $mb_currency = $_POST["mb_currency"];
    $currency = $_POST["currency"];
    $md5sig = $_POST["md5sig"];
    $status = $_POST["status"];
    $fee = 0;

    $REQUEST = $_REQUEST;
    $isValid =  DoInvoiceValidate($invoiceid);
    if(!$isValid) return '<div class="alert alert-danger">Invoice Id is Invailed.....</div>'; 
    $isValid =  DoTransactionValidate($invoiceid,$transid);
    if($isValid) return '<div class="alert alert-danger">Transaction No already exist.....</div>';
    $transactionStatus = "Unsuccessful";
    if ($params["secretword"])
    {
        $md5Secret = strtoupper(md5($params["secretword"]));
        if (strtoupper(md5($merchant_id . $transactionId . $md5Secret . $mb_amount . $mb_currency . $status)) != $md5sig)
        {
            AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$REQUEST,"message"=>"MD5 Signature Failure"));
            return '<div class="alert alert-danger">MD5 Signature Failure</div>';
        }
    }
    $transactionStatus = "Unsuccessful";
    if ($_POST["status"] == "2")
    {
        $payment_added = AddInvoicePayment(['invoice_id'=>$invoiceid,'currency'=>$currency,'user_id'=>$user_id,'payment_method'=>$payment_method,'amount'=>$amount,'trno'=>$transid,'fee'=>$fee,'notification'=>'YES']);
        $REQUEST["TransStatus"] = "Success";
        AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$REQUEST,"message"=>"Payment Confirmed By Gateway"));
        if($payment_added['status'] != 'success') return '<div class="alert alert-danger">Payment Confirmed but Payment entry error...'.$payment_added['message'].'</div>';
        header("Location: /client/view-invoice/".$invoiceid);
        die();
    }
    $REQUEST["TransStatus"] = "Failed";
    AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$REQUEST,"message"=>"Payment Confirmation By Gateway Failed"));
    return '<div class="alert alert-danger">Payment Confirmation By Gateway failed due to Transaction ID not found in Request...</div>';    
}