<?php
if (!defined("WHASOLS")) exit("This file cannot be accessed directly");
function nochex_info()
{
    return array(
        'DisplayName' => 'NoChex', // display name for client
        'APIVersion' => '1.0', 
        'DisableLocalCredtCardInput' => false,
        'TokenisedStorage' => false,
    );
}
function nochex_config()
{
    $configarray = array(
        "Name" => array("Type" => "System", "Value" => "NoChex"),
        "email" => array("Name" => "NoChex Merchant ID", "Type" => "text", "Size" => "50","Description"=>"This is the email you have registered with NoChex"),
        "hide" => array("Name" => "Hide Details", "Type" => "yesno", "Description" =>"Tick to stop customer details being repeated on Nochex payment page","Default"=>"no"),
        "testmode" => array("Name" => "Test Mode", "Type" => "yesno", "Description" =>"Tick to enable test transaction mode","Default"=>"no"));
    return $configarray;
}

function nochex_link($params)
{
    $gateway_id = $params['gateway']['id'];
    $gateway_email = $params['gateway']['email'];
    $hide = $params['gateway']['hide'];
    $testmode = $params['gateway']['testmode'];

    
    // Invoice Parameters
    $invoiceid = $params['invoice']['invoiceid'];
    $description = $params['invoice']['description'];
    $amount = $params['invoice']['amount'];
    $currencyCode = $params['invoice']['currency'];

    // System Parameters
    $companyName = $arg['system']['companyname'];
    $systemUrl = $arg['system']['systemurl'];            // System URL
    $siteurl = $arg['system']['siteurl'];            // System URL

    $code = "<form action=\"https://secure.nochex.com/\" method=\"post\">\n<input type=hidden name=merchant_id value=\"" . $gateway_email . "\">\n<input type=hidden name=amount value=\"" . $amount . "\">\n<input type=hidden name=order_id value=\"" . $invoiceid . "\">\n<input type=hidden name=description value=\"" . $description . "\">\n<input type=hidden name=billing_fullname value=\"" . $params["clientdetails"]["firstname"] . " " . $params["clientdetails"]["lastname"] . "\">\n<input type=hidden name=billing_address value=\"" . $params["clientdetails"]["address1"] . "\r\n" . $params["clientdetails"]["address2"] . "\r\n" . $params["clientdetails"]["city"] . "\r\n" . $params["clientdetails"]["state"] . "\r\n" . $params["clientdetails"]["country"] . "\">\n<input type=hidden name=billing_postcode value=\"" . $params["clientdetails"]["postcode"] . "\">\n<input type=hidden name=customer_phone_number value=\"" . $params["clientdetails"]["phonenumber"] . "\">\n<input type=hidden name=email_address value=\"" . $params["clientdetails"]["email"] . "\">\n<input type=hidden name=success_url value=\"".$systemUrl."/client/paytoinvoice/".$gateway_id."/".$invoiceid."\">\n<input type=hidden name=cancel_url value=\"".$systemUrl."/client/paytoinvoice/".$gateway_id."/".$invoiceid."\">\n<input type=hidden name=decline_url value=\"".$systemUrl."/client/paytoinvoice/".$gateway_id."/".$invoiceid."\">\n<input type=hidden name=responderurl value=\"".$systemUrl."/client/paytoinvoice/".$gateway_id."/".$invoiceid."\">\n<input type=hidden name=callback_url value=\"".$systemUrl."/client/paytoinvoice/".$gateway_id."/".$invoiceid."\">\n";
    if ($hide == "yes") {
        $code .= "<input type=hidden name=hide_billing_details value=\"true\">";
    }
    if ($testmode == "yes") {
        $code .= "<input type=hidden name=test_transaction value=\"100\">\n<input type=hidden name=test_success_url value=\"".$systemUrl."/client/paytoinvoice/".$gateway_id."/".$invoiceid."\">";
    }
    $code .= "\n<input type=\"submit\" value=\"Pay Now\">\n</form>";
    return $code;
}
function nochex_callback($params)
{
    $eTitle = $params['gateway']['title'];
    $gateway_id = $params['gateway']['id'];
    $gateway_email = $params['gateway']['email'];
    $hide = $params['gateway']['hide'];
    $testmode = $params['gateway']['testmode'];

        // Invoice Parameters
    $invoiceid = $params['invoice']['invoiceid'];
    $description = $params['invoice']["description"];
    $amount = $params['invoice']['amount'];
    $currencyCode = $params['invoice']['currency'];
    // System Parameters
    $companyName = $arg['system']['companyname'];
    $systemUrl = $arg['system']['systemurl'];            // System URL
    $siteurl = $arg['system']['siteurl'];            // System URL

    $REQUEST = [];
    $values = [];
    if (!isset(__post())) $REQUEST =& $HTTP_POST_VARS;
    if(empty($REQUEST)) $REQUEST =@$_POST;
    if(empty($REQUEST)) $REQUEST =@$_REQUEST;

    $htmlOutput = '';   
    $isValid =  DoInvoiceValidate($invoiceid);
    if(!$isValid) return '<div class="alert alert-danger">Invoice Id is Invailed.....</div>'; 

    // Invoice Parameters
    $currency = $arg['invoice']['currency'];
    $currencyCode = $arg['invoice']['currencyCode'];
    $payment_method = $arg['invoice']['payment_method'];
    $user_id = $arg['client']['id'];

    $order_id = $REQUEST["order_id"];
    $transid = $REQUEST["transaction_id"];
    $fee = urldecode($_GET["fee"]);
    $isValid =  DoTransactionValidate($order_id,$transid);
    if($isValid) return '<div class="alert alert-danger">Transaction No already exist.....</div>';
    $transactionStatus = "Unsuccessful";


    foreach ($REQUEST as $key => $value) {
        $values[] = $key . "=" . urlencode($value);
    }
    $work_string = @implode("&", $values);
    $url = "https://www.nochex.com/nochex.dll/apc/apc";
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_POSTFIELDSIZE, 0);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $work_string);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_TIMEOUT, 60);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
    $output = curl_exec($ch);
    curl_close($ch);
    $response = preg_replace("'Content-type: text/plain'si", "", $output);
    if ($response == "AUTHORISED")
    {
        $payment_added = AddInvoicePayment(['invoice_id'=>$REQUEST["order_id"],'currency'=>$currency,'user_id'=>$user_id,'payment_method'=>$payment_method,'amount'=>$amount,'trno'=>$transid,'fee'=>$fee,'notification'=>'YES']);
        if($payment_added['status'] != 'success') return '<div class="alert alert-danger">Payment Confirmed but Payment entry error...'.$payment_added['message'].'</div>';
        $REQUEST["TransStatus"] = "Success";
        AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$REQUEST));
        header("Location: /client/view-invoice/".$invoiceid);
        die();
    }
    $REQUEST["TransStatus"] = "Failed";
    AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$REQUEST));
    return '<div class="alert alert-danger">Payment Confirmation By Gateway failed due to Transaction ID not found in Request...</div>';    
}