<?php
    /**
     * PayFast Payment Gateway Pakistan
     * Developed by WHMSOLS
     * https://whmsols.com
     */
    function payfast_info() {
        return array(
            'DisplayName' => 'PayFast Payment Gateway',
            'APIVersion' => '1.1', // Use API Version 1.1
            'DisableLocalCredtCardInput' => true,
            'TokenisedStorage' => false,
        );
    }

    function payfast_config() {
        return array(
            'Name' => array(
                'Type' => 'System',
                'Value' => 'PayFast',
            ),
            'merchant_id' => array(
                'Name' => 'Merchant ID',
                'Type' => 'text',
                'Size' => '25',
                'Default' => '',
                'Description' => 'PayFast Merchant ID',
            ),
            'merchant_name' => array(
                'Name' => 'Merchant Name',
                'Type' => 'text',
                'Size' => '25',
                'Default' => '',
                'Description' => '',
            ),
            'secured_key' => array(
                'Name' => 'Secured Key',
                'Type' => 'text',
                'Size' => '25',
                'Default' => '',
                'Description' => 'PayFast Secured Key',
            ),
            'secret_word' => array(
                'Name' => 'Secret Word',
                'Type' => 'text',
                'Size' => '25',
                'Default' => '',
                'Description' => 'Secret Word (optional)',
            )
        );
    }

    function payfast_link($params) {

        // Gateway Configuration Parameters
        $merchantId = $params['merchant_id'];
        $securedKey = $params['secured_key'];

        $phonenumber = $params['clientdetails']['phonenumber'];

        if ($phonenumber == '') {
            $phonenumber = '920000000000';
        }

        // System Parameters
        $whmsolsVersion = $params['whmsolsVersion'];

        $url = 'https://ipg1.apps.net.pk/Ecommerce/api/Transaction/PostTransaction';

        $moduleName = $params['paymentmethod'];
        $systemUrl = $params['systemurl'];
        $callback = $params["returnurl"];
        //$callback = $systemUrl . '/modules/gateways/payfast/' . $moduleName . '.php?invamount=' . $params['amount'];

        $signature = md5($merchantId . $securedKey . $params['amount']);
        $token = get_apps_auth_token($merchantId, $securedKey);

        $htmlOutput = '<form action="' . $url . '" method="post">
    <input type="hidden" name="MERCHANT_ID" value="' . $merchantId . '">
        <input type="hidden" name="MERCHANT_NAME" value="' . $params['merchant_name'] . '">
    <input type="hidden" name="TOKEN" value="' . $token . '">
    <input type="hidden" name="PROCCODE" value="00" >
    <input type="hidden" name="TXNAMT" value="' . $params['amount'] . '">
    <input type="hidden" name="CUSTOMER_MOBILE_NO" value="' . $phonenumber . '">
    <input type="hidden" name="CUSTOMER_EMAIL_ADDRESS" value="' . $params['clientdetails']['email'] . '">
    <input type="hidden" name="SIGNATURE" value="' . $signature . '">
    <input type="hidden" name="VERSION" value="WHMSOLS1.0-' . $whmsolsVersion . '">
    <input type="hidden" name="TXNDESC" value="' . $params['description'] . '">
    <input type="hidden" name="CURRENCY_CODE" value="PKR">
    <input type="hidden" name="SUCCESS_URL" value="' . $callback . '">
    <input type="hidden" name="FAILURE_URL" value="' . $callback . '">
    <input type="hidden" name="BASKET_ID" value="' . $params['invoiceid'] . '">            
    <input type="hidden" name="ORDER_DATE" value="' . date('Y-m-d H:i:s', time()) . '">
    <input type="hidden" name="CHECKOUT_URL" value="' . $callback . '">
    <input type="submit" value="Pay Now">';

        $htmlOutput .= '</form>';
        return $htmlOutput;
    }

    function get_apps_auth_token($merchantid, $secret)
    {
        $token_url = "https://ipg1.apps.net.pk/Ecommerce/api/Transaction/GetAccessToken?MERCHANT_ID=%s&SECURED_KEY=%s";
        $token_url = sprintf($token_url, $merchantid, $secret);    
        $response = curl_request($token_url);
        $response_decode = json_decode($response);
        if (isset($response_decode->ACCESS_TOKEN))
        {
            return $response_decode->ACCESS_TOKEN;
        }
        return;
    }

    function curl_request($url, $data_string = '') {

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array(
            'application/json; charset=utf-8    '
        ));
    	curl_setopt($ch,CURLOPT_USERAGENT,'WHMSOLS-PayFast Prod Plugin-PHP-CURL');
        $response = curl_exec($ch);
        curl_close($ch);
        return $response;
    }
    function payfast_callback($params)
    {
        // Gateway Configuration Parameters
        $merchantId = $params['gateway']['merchant_id'];
        $securedKey = $params['gateway']['secured_key'];
        $gateway_id = $params['gateway']['id'];
        $invoiceid = $params['invoice']['invoiceid'];
        // Detect module name from filename.
        // Fetch gateway configuration parameters.
        $gateway_variables = GetPaymentGatewayVariables($gateway_id);

        $basketid = isset($_REQUEST['basket_id']) ? $_REQUEST['basket_id'] : '';
        $apps_status_msg = isset($_REQUEST['err_msg']) ? $_REQUEST['err_msg'] : '';
        $apps_transactionid = isset($_REQUEST['transaction_id']) ? $_REQUEST['transaction_id'] : '';
        $apps_statuscode = isset($_REQUEST['err_code']) ? $_REQUEST['err_code'] : '';
        $apps_rdv_key = isset($_REQUEST['Rdv_Message_Key']) ? $_REQUEST['Rdv_Message_Key'] : '';
        $response_key = isset($_REQUEST['responseKey']) ? $_REQUEST['responseKey'] : '';
        $invoice_amount = isset($_REQUEST['invamount']) ? $_REQUEST['invamount'] : '';

        $isValid =  DoInvoiceValidate($invoiceid);
        if(!$isValid) return '<div class="alert alert-danger">Invoice Id is Invailed.....</div>'; 
        $isValid =  DoTransactionValidate($invoiceid,$apps_transactionid);
        if($isValid) return '<div class="alert alert-danger">Transaction No already exist.....</div>';

        // Invoice Parameters
        $currency = $params['invoice']['currency'];
        $currencyCode = $params['invoice']['currencyCode'];
        $payment_method = $params['invoice']['payment_method'];
        $user_id = $params['client']['id'];
        $callback = $params["returnurl"];
        $systemUrl = rtrim($params["systemurl"],"/");
        $systemUrl = rtrim($systemUrl,"/client");
        $result = $_REQUEST;
        AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$result));
        if ($response_key != '')
        {
            $local_key = md5($gateway_variables['merchant_id'] . $basketid . $gateway_variables['secret_word'] . $invoice_amount . $apps_statuscode);
            if ($local_key != $response_key) {
                return '<div class="alert alert-danger">Response Key invalid.....</div>';
            }
        }

        $transactionStatus = ($apps_statuscode == '00' || $apps_statuscode == '000') ? 'Success' : 'Failure';

        if($transactionStatus == "Success")
        {
            $fee = 0;
            $payment_added = AddInvoicePayment(array('invoice_id'=>$invoiceid,'currency'=>$currency,'user_id'=>$user_id,'payment_method'=>$payment_method,'amount'=>$invoice_amount,'trno'=>$apps_transactionid,'fee'=>$fee,'notification'=>'YES'));
            if($payment_added['status'] == 'success')
            {
                header("Location: /client/view-invoice/".$invoiceid); 
                die();
            }
            return '<div class="alert alert-danger">Payment Confirmed but Payment entry error...'.$payment_added['message'].'</div>';
        }
        return '<div class="alert alert-danger">Payment Confirmation Failed by Payment Gateway</div>';
    }