<?php
if (!defined("WHMSOLS")) exit("This file cannot be accessed directly");
function paypalpaymentsproref_info()
{
    return array("DisplayName" => "PayPal Pro Reference Payments", "APIVersion" => "3.0", "TokenWorkflow" => true);
}
function paypalpaymentsproref_config()
{
    $configarray = array("Name" => array("Type" => "System", "Value" => "PayPal Pro Reference Payments"), "apiusername" => array("Name" => "API Username", "Type" => "text", "Size" => "30"), "apipassword" => array("Name" => "API Password", "Type" => "text", "Size" => "30"), "apisignature" => array("Name" => "API Signature", "Type" => "text", "Size" => "30"), "processorid" => array("Name" => "Processor ID", "Type" => "text", "Size" => "20", "Description" => "Cardinal 3D Secure Details"), "merchantid" => array("Name" => "Merchant ID", "Type" => "text", "Size" => "20"), "transpw" => array("Name" => "Transaction PW", "Type" => "text", "Size" => "20"), "sandbox" => array("Name" => "Sandbox", "Type" => "yesno"));
    return $configarray;
}
function paypalpaymentsproref_3dsecure($params)
{
    $enrolled = "N";
    $errorno = 0;
    if (!empty($params["cardnum"]) && $params["processorid"])
    {
        if ($params["sandbox"] == "yes") {
            $mapurl = "https://centineltest.cardinalcommerce.com/maps/txns.asp";
        } else {
            $mapurl = "https://paypal.cardinalcommerce.com/maps/txns.asp";
        }
        $currency = "";
        if ($params["currency"] == "USD") {
            $currency = "840";
        }
        if ($params["currency"] == "GBP") {
            $currency = "826";
        }
        if ($params["currency"] == "EUR") {
            $currency = "978";
        }
        if ($params["currency"] == "CAD") {
            $currency = "124";
        }
        $postfields = array();
        $postfields["MsgType"] = "cmpi_lookup";
        $postfields["Version"] = "1.7";
        $postfields["ProcessorId"] = $params["processorid"];
        $postfields["MerchantId"] = $params["merchantid"];
        $postfields["TransactionPwd"] = $params["transpw"];
        $postfields["UserAgent"] = $_SERVER["HTTP_USER_AGENT"];
        $postfields["BrowserHeader"] = $_SERVER["HTTP_ACCEPT"];
        $postfields["TransactionType"] = "C";
        $postfields["Amount"] = $params["amount"] * 100;
        $postfields["ShippingAmount"] = "0";
        $postfields["TaxAmount"] = "0";
        $postfields["CurrencyCode"] = $currency;
        $postfields["OrderNumber"] = $params["invoiceid"];
        $postfields["OrderDescription"] = $params["description"];
        $postfields["EMail"] = $params["clientdetails"]["email"];
        $postfields["BillingFirstName"] = $params["clientdetails"]["firstname"];
        $postfields["BillingLastName"] = $params["clientdetails"]["lastname"];
        $postfields["BillingAddress1"] = $params["clientdetails"]["address1"];
        $postfields["BillingAddress2"] = $params["clientdetails"]["address2"];
        $postfields["BillingCity"] = $params["clientdetails"]["city"];
        $postfields["BillingState"] = $params["clientdetails"]["state"];
        $postfields["BillingPostalCode"] = $params["clientdetails"]["postcode"];
        $postfields["BillingCountryCode"] = $params["clientdetails"]["country"];
        $postfields["BillingPhone"] = $params["clientdetails"]["phonenumber"];
        $postfields["ShippingFirstName"] = $params["clientdetails"]["firstname"];
        $postfields["ShippingLastName"] = $params["clientdetails"]["lastname"];
        $postfields["ShippingAddress1"] = $params["clientdetails"]["address1"];
        $postfields["ShippingAddress2"] = $params["clientdetails"]["address2"];
        $postfields["ShippingCity"] = $params["clientdetails"]["city"];
        $postfields["ShippingState"] = $params["clientdetails"]["state"];
        $postfields["ShippingPostalCode"] = $params["clientdetails"]["postcode"];
        $postfields["ShippingCountryCode"] = $params["clientdetails"]["country"];
        $postfields["ShippingPhone"] = $params["clientdetails"]["phonenumber"];
        $postfields["CardNumber"] = $params["cardnum"];
        $postfields["CardExpMonth"] = substr($params["cardexp"], 0, 2);
        $postfields["CardExpYear"] = "20" . substr($params["cardexp"], 2, 2);
        $queryString = "<CardinalMPI>\n";
        foreach ($postfields as $name => $value) {
            $queryString .= "<" . $name . ">" . $value . "</" . $name . ">\n";
        }
        $queryString .= "</CardinalMPI>";
        $data = "cmpi_msg=" . urlencode($queryString);
        $response = curlCall($mapurl, $data);
        $xmlarray = XMLtoArray($response);
        $xmlarray = $xmlarray["CARDINALMPI"];
        $errorno = $xmlarray["ERRORNO"];
        $enrolled = $xmlarray["ENROLLED"];
        $eciflag = $xmlarray["ECIFLAG"];
        $transid = $xmlarray["TRANSACTIONID"];
        $acsurl = $xmlarray["ACSURL"];
        $pareq = $xmlarray["PAYLOAD"];
        $orderid = $xmlarray["ORDERID"];
        SetInvoiceOrderData($params["invoiceid"],"order_data",["Centinel_OrderId" => $orderid, "Centinel_TransactionId" => $transid]);
    }
    if ($errorno == 0) {
        if ($enrolled == "Y")
        {
            SetInvoiceOrderData($params["invoiceid"],"Centinel_Details",["cardtype" => $params["cardtype"], "cardnum" => $params["cardnum"], "cardexp" => $params["cardexp"], "cccvv" => $params["cccvv"], "cardstart" => $params["cardstart"], "cardissuenum" => $params["cardissuenum"]]);
            $code = "<form method=\"POST\" action=\"" . $acsurl . "\">\n                <input type=hidden name=\"PaReq\" value=\"" . $pareq . "\">\n                <input type=hidden name=\"TermUrl\" value=\"" . $params["returnurl"]."\">\n                <input type=hidden name=\"MD\" value=\"" . $params["invoiceid"] . "\">\n                <noscript>\n                <center>\n                    <font color=\"red\">\n                        <h2>Processing your Payer Authentication Transaction</h2>\n                        <h3>JavaScript is currently disabled or is not supported by your browser.<br></h3>\n                        <h4>Please click Submit to continue the processing of your transaction.</h4>\n                    </font>\n                <input type=\"submit\" value=\"Submit\">\n                </center>\n                </noscript>\n            </form>";
            return $code;
        }
        $result = paypalpaymentsproref_capture($params);
        if ($result["status"] == "success")
        {
            return ["status"=>"success","transid"=>$result["transid"],"rawdata"=>$result["rawdata"]];
        }
        return ["status"=>"failed","transid"=>0,"rawdata"=>$result["rawdata"]];
    }
    else
    {
        return ["status"=>"failed","transid"=>0,"rawdata"=>"No 3D Auth"];        
    }
    return ["status"=>"declined","transid"=>0,"rawdata"=>"Declined"];        
}
function paypalpaymentsproref_capture($params)
{
    $remote_ip = $params["ip"];
    if ($params["sandbox"] == "yes")
    {
        $url = "https://api-3t.sandbox.paypal.com/nvp";
    } else {
        $url = "https://api-3t.paypal.com/nvp";
    }
    $cardtype = $params["cardtype"];
    if ($cardtype == "American Express") {
        $cardtype = "Amex";
    }
    $paymentvars = array();
    $paymentvars["VERSION"] = "3.0";
    $paymentvars["PAYMENTACTION"] = "Sale";
    $paymentvars["IPADDRESS"] = $remote_ip;
    $paymentvars["BUTTONSOURCE"] = "WHMSOLS_WPP_DP";
    $paymentvars["PWD"] = $params["apipassword"];
    $paymentvars["USER"] = $params["apiusername"];
    $paymentvars["SIGNATURE"] = $params["apisignature"];
    $paymentvars["AMT"] = $params["amount"];
    $paymentvars["FIRSTNAME"] = $params["clientdetails"]["firstname"];
    $paymentvars["LASTNAME"] = $params["clientdetails"]["lastname"];
    $paymentvars["STREET"] = $params["clientdetails"]["address1"];
    $paymentvars["CITY"] = $params["clientdetails"]["city"];
    $paymentvars["STATE"] = $params["clientdetails"]["state"];
    $paymentvars["ZIP"] = $params["clientdetails"]["postcode"];
    $paymentvars["COUNTRYCODE"] = $params["clientdetails"]["country"];
    $paymentvars["CURRENCYCODE"] = $params["currency"];
    $paymentvars["INVNUM"] = $params["invoiceid"];
    if (!$params["cardnum"] && $params["gatewayid"]) {
        $paymentvars["METHOD"] = "DoReferenceTransaction";
        $paymentvars["REFERENCEID"] = $params["gatewayid"];
    } else {
        $paymentvars["METHOD"] = "doDirectPayment";
        $paymentvars["CREDITCARDTYPE"] = $cardtype;
        $paymentvars["ACCT"] = $params["cardnum"];
        $paymentvars["EXPDATE"] = substr($params["cardexp"], 0, 2) . "20" . substr($params["cardexp"], 2, 2);
        $paymentvars["CVV2"] = $params["cccvv"];
        $paymentvars["ISSUENUMBER"] = $params["cardissuenum"];
        $paymentvars["STARTDATE"] = substr($params["cardstart"], 0, 2) . "20" . substr($params["cardstart"], 2, 2);
    }
    $fieldstring = "";
    foreach ($paymentvars as $key => $value) {
        $fieldstring .= (string) $key . "=" . urlencode($value) . "&";
    }
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $fieldstring);
    $response = curl_exec($ch);
    if (curl_errno($ch)) {
        $resArray["Curl Error Number"] = curl_errno($ch);
        $resArray["Curl Error Description"] = curl_error($ch);
    } else {
        $resArray = paypalpaymentsproref_deformatNVP($response);
    }
    curl_close($ch);
    $debugreport = "";
    foreach ($resArray as $key => $value) {
        $debugreport .= (string) $key . " => " . $value . "\n";
    }
    $ack = strtoupper($resArray["ACK"]);
    if (in_array($ack,["SUCCESS","SUCCESSWITHWARNING"]) || $resArray["PAYMENTSTATUS"] == "Completed")
    {
        return array("status" => "success", "transid" => $resArray["TRANSACTIONID"], "rawdata" => $resArray);
    }
    return array("status" => "error", "rawdata" => $resArray);
}
function paypalpaymentsproref_refund($params)
{
    if ($params["sandbox"] == "yes")
    {
        $url = "https://api-3t.sandbox.paypal.com/nvp";
    } else {
        $url = "https://api-3t.paypal.com/nvp";
    }
    $postfields = array();
    $postfields["VERSION"] = "3.0";
    $postfields["METHOD"] = "RefundTransaction";
    $postfields["BUTTONSOURCE"] = "WHMSOLS_WPP_DP";
    $postfields["USER"] = $params["apiusername"];
    $postfields["PWD"] = $params["apipassword"];
    $postfields["SIGNATURE"] = $params["apisignature"];
    $postfields["TRANSACTIONID"] = $params["transid"];
    $postfields["REFUNDTYPE"] = "Partial";
    $postfields["AMT"] = $params["amount"];
    $postfields["CURRENCYCODE"] = $params["currency"];
    $result = curlCall($url, $postfields);
    $resultsarray2 = explode("&", $result);
    foreach ($resultsarray2 as $line) {
        $line = explode("=", $line);
        $resultsarray[$line[0]] = urldecode($line[1]);
    }
    if (strtoupper($resultsarray["ACK"]) == "SUCCESS") {
        return array("status" => "success", "rawdata" => $resultsarray, "transid" => $resultsarray["REFUNDTRANSACTIONID"]);
    }
    return array("status" => "Error", "rawdata" => $resultsarray);
}
function paypalpaymentsproref_deformatNVP($nvpstr)
{
    $intial = 0;
    $nvpArray = array();
    while (strlen($nvpstr)) {
        $keypos = strpos($nvpstr, "=");
        $valuepos = strpos($nvpstr, "&") ? strpos($nvpstr, "&") : strlen($nvpstr);
        $keyval = substr($nvpstr, $intial, $keypos);
        $valval = substr($nvpstr, $keypos + 1, $valuepos - $keypos - 1);
        $nvpArray[urldecode($keyval)] = urldecode($valval);
        $nvpstr = substr($nvpstr, $valuepos + 1, strlen($nvpstr));
    }
    return $nvpArray;
}
function paypalpaymentsproref_callback($params)
{
    $eTitle = $params['gateway']['title'];
    $gateway_id = $params['gateway']['id'];

    // Invoice Parameters
    $invoiceid = $params['invoice']['invoiceid'];
    $description = $params['invoice']["description"];
    $amount = $params['invoice']['amount'];
    $currency = $currencyCode = $params['invoice']['currency'];
    $payment_method = $params['invoice']['payment_method'];
    $user_id = $params['client']['id'];


    $callbacksuccess = false;
    $pares = $_REQUEST["PaRes"];
    $invoiceid = $_REQUEST["MD"];    
    $orderData = GetInvoiceOrderData($invoiceid);
    if (strcasecmp("", $pares) != 0 && $pares != NULL && isset($orderData["Centinel_TransactionId"]))
    {
        if ($params["sandbox"] == "yes") {
            $mapurl = "https://centineltest.cardinalcommerce.com/maps/txns.asp";
        } else {
            $mapurl = "https://paypal.cardinalcommerce.com/maps/txns.asp";
        }
        $currency = "";
        if ($params["currency"] == "USD") $currency = "840";
        if ($params["currency"] == "GBP") $currency = "826";
        if ($params["currency"] == "EUR") $currency = "978";
        if ($params["currency"] == "CAD") $currency = "124";

        $postfields = array();
        $postfields["MsgType"] = "cmpi_authenticate";
        $postfields["Version"] = "1.7";
        $postfields["ProcessorId"] = $gatewayParams["processorid"];
        $postfields["MerchantId"] = $gatewayParams["merchantid"];
        $postfields["TransactionPwd"] = $gatewayParams["transpw"];
        $postfields["TransactionType"] = "C";
        $postfields["PAResPayload"] = $pares;
        $postfields["OrderId"] = $orderData["Centinel_OrderId"];
        $postfields["TransactionId"] = $orderData["Centinel_TransactionId"];
        $queryString = "<CardinalMPI>\n";
        foreach ($postfields as $name => $value) {
            $queryString .= "<" . $name . ">" . $value . "</" . $name . ">\n";
        }
        $queryString .= "</CardinalMPI>";
        $data = "cmpi_msg=" . urlencode($queryString);
        $response = curlCall($mapurl, $data);
        $xmlarray = XMLtoArray($response);
        $xmlarray = $xmlarray["CARDINALMPI"];
        $errorno = $xmlarray["ERRORNO"];
        $paresstatus = $xmlarray["PARESSTATUS"];
        $sigverification = $xmlarray["SIGNATUREVERIFICATION"];
        $cavv = $xmlarray["CAVV"];
        $eciflag = $xmlarray["ECIFLAG"];
        $xid = $xmlarray["XID"];

        if ((strcasecmp("0", $errorno) == 0 || strcasecmp("1140", $errorno) == 0) && strcasecmp("Y", $sigverification) == 0 && (strcasecmp("Y", $paresstatus) == 0 || strcasecmp("A", $paresstatus) == 0)) {
            logTransaction($gatewayParams["paymentmethod"], $_REQUEST, "Auth Passed");
            $auth = array("paresstatus" => $paresstatus, "cavv" => $cavv, "eciflag" => $eciflag, "xid" => $xid);
            $cDetails = $orderData["Centinel_Details"];
            SetInvoiceOrderData($invoiceid,"Centinel_Details",[]);
            if (!empty($cDetails))
            {
                $params["cardtype"] = $cDetails["cardtype"];
                $params["cardnum"] = $cDetails["cardnum"];
                $params["cardexp"] = $cDetails["cardexp"];
                $params["cccvv"] = $cDetails["cccvv"];
                $params["cardstart"] = $cDetails["cardstart"];
                $params["cardissuenum"] = $cDetails["cardissuenum"];
            }
            else
            {
                $getCCVariables = getCCVariables($invoiceid);
                $params["cardtype"] = $getCCVariables["cardtype"];
                $params["cardnum"] = $getCCVariables["cardnum"];
                $params["cardexp"] = $getCCVariables["cardexp"];
                $params["cccvv"] = $getCCVariables["cccvv"];
                $params["cardstart"] = $getCCVariables["cardstart"];
                $params["cardissuenum"] = $getCCVariables["cardissuenum"];                
            }
            $result = paypalpaymentsproref_capture($params, $auth);
            if($user_id<=0)
            {
                $GetInvoiceInfo = GetInvoiceInfo($invoiceid);
                $user_id = $GetInvoiceInfo["user_id"];
                $description = $GetInvoiceInfo["description"];
                $amount = $GetInvoiceInfo['amount'];
                $currencyCode = $GetInvoiceInfo['currency'];
                $payment_method = $GetInvoiceInfo['payment_method'];
            }
            if ($result["status"] == "success")
            {
                $isValid =  DoTransactionValidate($invoiceid,$result["transid"]);
                if($isValid) return '<div class="alert alert-danger">Transaction No already exist.....</div>';
                $payment_added = AddInvoicePayment(['invoice_id'=>$invoiceid,'currency'=>$currencyCode,'user_id'=>$user_id,'payment_method'=>$payment_method,'amount'=>$amount,'trno'=>$transid,'fee'=>$fee,'notification'=>'YES']);
                $REQUEST["TransStatus"] = "Success";
                sendMessage("Credit Card Payment Confirmation", $invoiceid);
                AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$result["rawdata"],"message"=>"Payment Confirmed By Gateway"));
                if($payment_added['status'] != 'success') return '<div class="alert alert-danger">Payment Confirmed but Payment entry error...'.$payment_added['message'].'</div>';
                header("Location: /client/view-invoice/".$invoiceid);
            }
            AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$result["rawdata"],"message"=>"Payment Failed"));
            return '<div class="alert alert-danger">Payment Confirmation Failed by Gateway</div>';
        }
        if (strcasecmp("N", $paresstatus) == 0)
        {
            AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$response,"message"=>"Auth Failed"));
            return '<div class="alert alert-danger">Gateway Authentication Failed</div>';
        }
        AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$_REQUEST,"message"=>"Unexpected Status, Capture Anyway"));
        $auth = array("paresstatus" => $paresstatus, "cavv" => $cavv, "eciflag" => $eciflag, "xid" => $xid);


        $cDetails = $orderData["Centinel_Details"];
        SetInvoiceOrderData($invoiceid,"Centinel_Details",[]);
        if (!empty($cDetails))
        {
            $params["cardtype"] = $cDetails["cardtype"];
            $params["cardnum"] = $cDetails["cardnum"];
            $params["cardexp"] = $cDetails["cardexp"];
            $params["cccvv"] = $cDetails["cccvv"];
            $params["cardstart"] = $cDetails["cardstart"];
            $params["cardissuenum"] = $cDetails["cardissuenum"];
        }
        else
        {
            $getCCVariables = getCCVariables($invoiceid);
            $params["cardtype"] = $getCCVariables["cardtype"];
            $params["cardnum"] = $getCCVariables["cardnum"];
            $params["cardexp"] = $getCCVariables["cardexp"];
            $params["cccvv"] = $getCCVariables["cccvv"];
            $params["cardstart"] = $getCCVariables["cardstart"];
            $params["cardissuenum"] = $getCCVariables["cardissuenum"];                
        }
        $result = paypalpaymentsproref_capture($params, $auth);
        if($user_id<=0)
        {
            $GetInvoiceInfo = GetInvoiceInfo($invoiceid);
            $user_id = $GetInvoiceInfo["user_id"];
            $description = $GetInvoiceInfo["description"];
            $amount = $GetInvoiceInfo['amount'];
            $currencyCode = $GetInvoiceInfo['currency'];
            $payment_method = $GetInvoiceInfo['payment_method'];
        }
        if ($result["status"] == "success")
        {
            $isValid =  DoTransactionValidate($invoiceid,$result["transid"]);
            if($isValid) return '<div class="alert alert-danger">Transaction No already exist.....</div>';

            $payment_added = AddInvoicePayment(['invoice_id'=>$invoiceid,'currency'=>$currencyCode,'user_id'=>$user_id,'payment_method'=>$payment_method,'amount'=>$amount,'trno'=>$result["transid"],'fee'=>$fee,'notification'=>'YES']);
            $REQUEST["TransStatus"] = "Success";
            sendMessage("Credit Card Payment Confirmation", $invoiceid);
            AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$result["rawdata"],"message"=>"Payment Confirmed By Gateway"));
            if($payment_added['status'] != 'success') return '<div class="alert alert-danger">Payment Confirmed but Payment entry error...'.$payment_added['message'].'</div>';
            header("Location: /client/view-invoice/".$invoiceid);
        }
    }
    AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$result["rawdata"],"message"=>"Payment Failed"));
    return '<div class="alert alert-danger">Payment Confirmation Failed by Gateway</div>';
}