<?php

require_once(dirname(__FILE__) . '/encdec_paytm.php');

function paytm_info()
{
    return array('DisplayName'                  => 'Paytm',
                 'APIVersion'                   => '1.1', // Use API Version 1.1
                 'DisableLocalCredtCardInput'   => true,
                 'TokenisedStorage'             => false);

} 
function paytm_config(){
    $configarray = array(
		"Name" => array("Type" => "System", "Value"=>"Paytm"),
		"merchant_id" => array("Name" => "Merchant ID", "Type" => "text", "Size" => "20", ),
		"merchant_key" => array("Name" => "Merchant Key", "Type" => "text", "Size" => "16", ),
		"transaction_url" => array("Name" => "Transaction Url", "Type" => "text", "Size" => "90", ),
		"transaction_status_url" => array("Name" => "Transaction Status Url", "Type" => "text", "Size" => "90", ),
		"website" => array("Name" => "Website name", "Type" => "text", "Size" => "20", ),
		"industry_type" => array("Name" => "Industry Name", "Type" => "text", "Size" => "20", ),
	);		
	return $configarray;
}

function paytm_link($arg) {	

    // Gateway Configuration Parameters
    $eTitle = $arg['gateway']['title'];
    $merchant_id = $arg['gateway']['merchant_id'];
    $merchant_key = $arg['gateway']['merchant_key'];
    $website = $arg['gateway']['website'];
    $industry_type = $arg['gateway']['industry_type'];
    $transaction_url = $arg['gateway']['transaction_url'];
	$channel_id="WEB";	
    $gateway_id = $arg['gateway']['id'];


    // Invoice parameters
    $invoiceId = $arg['invoice']['invoiceid'];
    $order_id = $arg['invoice']['invoiceid'];
    $description = $arg['invoice']['description'];
    $amount = $arg['invoice']['amount'];
    $currencyCode = $arg['invoice']['currency'];


        // Client parameters

        $id = $arg['client']['id'];
        $firstname = $arg['client']['firstname'];
        $lastname = $arg['client']['lastname'];
        $email = $arg['client']['email'];
        $address1 = $arg['client']['address1'];
        $address2 = $arg['client']['address2'];
        $city = $arg['client']['city'];
        $state = $arg['client']['state'];
        $postcode = $arg['client']['postcode'];
        $country = $arg['client']['country'];
        $countryCode = '';
        $phone = $arg['client']['phonenumber'];


       // System parameters
        $companyName = $arg['system']['companyname'];
        $systemUrl = $arg['system']['systemurl'];            // System URL
        $siteurl = $arg['system']['siteurl'];            // System URL


       // Cancel invoice
        $callBackLink = $systemUrl.'/client/paytoinvoice/'.$gateway_id.'/'.$invoiceId;
        $moduleName                  = $eTitle;

	
	$post_variables = Array(
          "MID" => $merchant_id,
          "ORDER_ID" => $order_id ,
          "CUST_ID" => $email,
          "TXN_AMOUNT" => $amount,
          "CHANNEL_ID" => $channel_id,
          "INDUSTRY_TYPE_ID" => $industry_type,
          "CALLBACK_URL" => $callBackLink,
          "WEBSITE" => $website
          );
	$checksum = getChecksumFromArray($post_variables, $secret_key);
	$companyname = 'paytm';

	$code='<form method="post" action='. $transaction_url .'>';
	foreach ($post_variables as $key => $value) {
		$code.='<input type="hidden" name="'.$key.'" value="'.$value. '"/>';
	}
	$code.='<input type="hidden" name="CHECKSUMHASH" value="'. $checksum . '"/>
	<br><button type="submit" class="btn btn-success"><i class="glyphicon glyphicon-credit-card"></i> Pay Now By '.$eTitle.'</button></form>';
	return $code;
}



    function paytm_callback($arg)
    {
	    // Gateway Configuration Parameters
	    $eTitle = $arg['gateway']['title'];
	    $merchant_id = $arg['gateway']['merchant_id'];
	    $merchant_key = $arg['gateway']['merchant_key'];
	    $website = $arg['gateway']['website'];
	    $industry_type = $arg['gateway']['industry_type'];
	    $transaction_url = $arg['gateway']['transaction_url'];
		$channel_id="WEB";	
	    $gateway_id = $arg['gateway']['id'];

        $htmlOutput = '';
                        

            /**
             * Validate Callback Invoice ID.
             *
             * Checks invoice ID is a valid invoice number. Note it will count an
             * invoice in any status as valid.
             *
             * Performs a die upon encountering an invalid Invoice ID.
             *
             * Returns a normalised invoice ID.
             */


             $isValid =  DoInvoiceValidate($invoiceId);
            if(!$isValid)
            {
            $htmlOutput .='<div class="alert alert-danger">Invoice Id is Invailed.....</div>'; 
            }
            else
            {

				$response = array();
				$response = $_POST;

				$txnid  = $response['ORDERID'];	
				$transactionId  = $txnid;	
				
				$status =$response['STATUS'];
				$paytm_trans_id = $response['TXNID'];
				$checksum_recv='';	
				$amount=$response['TXNAMOUNT'];
				if(isset($response['CHECKSUMHASH'])){
					$checksum_recv=$response['CHECKSUMHASH'];
				}
                
	                // Retrieve data returned in payment gateway callback.
	                $amount = $arg['invoice']['amount'];
                
                    /**
                     * Check Callback Transaction ID.
                     *
                     * Performs a check for any existing transactions with the same given
                     * transaction number.
                     *
                     * Performs a die upon encountering a duplicate.
                     */
                   $isValid =  DoTransactionValidate($invoiceId,$transactionId);
                    if($isValid)
                    {
                        $htmlOutput .='<div class="alert alert-danger">Transaction No already exist.....</div>';
                    }
                    else
                    {
                        /**
                         * Log Transaction.
                         *
                         * Add an entry to the Gateway Log for debugging purposes.
                         *
                         * The debug data can be a string or an array. In the case of an
                         * array it will be
                         *
                         * @param string $gatewayName        Display label
                         * @param string|array $debugData    Data to log
                         * @param string $transactionStatus  Status
                         */
                         
                        // Invoice Parameters
                        $currency = $arg['invoice']['currency'];
                        $currencyCode = $arg['invoice']['currencyCode'];
                        $payment_method = $arg['invoice']['payment_method'];
                        $user_id = $arg['client']['id'];
                         

 

					 	$checksum_status = verifychecksum_e($response, html_entity_decode($merchant_key), $checksum_recv);
						
						// Create an array having all required parameters for status query.
						$requestParamList = array("MID" => $merchant_id, "ORDERID" => $response['ORDERID']);
						$StatusCheckSum = getChecksumFromArray($requestParamList, html_entity_decode($merchant_key));
						$requestParamList['CHECKSUMHASH'] = $StatusCheckSum;
						
						// Call the PG's getTxnStatus() function for verifying the transaction status.
						$check_status_url = $transaction_status_url;


						if($status== 'TXN_SUCCESS' && $checksum_status == "TRUE")
						{	
							$responseParamList = callNewAPI($check_status_url, $requestParamList);
							if($responseParamList['STATUS']=='TXN_SUCCESS' && $responseParamList['TXNAMOUNT']==$response['TXNAMOUNT'])
							{

					                $transactionId = $paytm_trans_id;
					            /**
					             * Add Invoice Payment.
					             *
					             * Applies a payment transaction entry to the given invoice ID.
					             *
					             * @param int $invoiceId         Invoice ID
					             * @param string $transactionId  Transaction ID
					             * @param float $paymentAmount   Amount paid (defaults to full balance)
					             * @param float $paymentFee      Payment fee (optional)
					             * @param string $gatewayModule  Gateway module name
					             */
					             
					            $fee = 0;
					            $payment_added = AddInvoicePayment(array('invoice_id'=>$invoiceId,'currency'=>$currency,'user_id'=>$user_id,'payment_method'=>$payment_method,'amount'=>$paymentAmount,'trno'=>$transactionId,'fee'=>$fee,'notification'=>'YES'));

					            AddGatewayLogs(array('invoice_id'=>$invoiceId,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>json_encode($response),'message'=>$response['RESPMSG']));


					            if($payment_added['status'] == 'success')
					            {
					            header("Location: /client/view-invoice/".$invoiceId);                   
					            }else{
					            $htmlOutput .='<div class="alert alert-danger">Payment Confirmed but Payment entry error...'.$payment_added['message'].'</div>';
					            }
							}
							else{
								$message = "It seems some issue in server to server communication. Kindly connect with administrator.";
					            AddGatewayLogs(array('invoice_id'=>$invoiceId,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>json_encode($response),'message'=>$message));
					            $htmlOutput .= $message;
							}
						} elseif ($status == "TXN_SUCCESS" && $checksum_status != "TRUE") {
								$message = "Checksum Mismatch";
					            AddGatewayLogs(array('invoice_id'=>$invoiceId,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>json_encode($response),'message'=>$message));
					            $htmlOutput .= $message;
						}else {
					            AddGatewayLogs(array('invoice_id'=>$invoiceId,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>json_encode($response),'message'=>$response));
					            $htmlOutput .= $response;
						}
                    }
            }
        return $htmlOutput;
    }

?>