<?php
    /**
     * Perfect Money Payment Gateway
     * Developed by WHASOLS
     * https://whasols.com
     */
    function perfectmoney_info() {
        return array(
            'DisplayName' => 'Perfect Money',
            'APIVersion' => '1.1', // Use API Version 1.1
            'DisableLocalCredtCardInput' => true,
            'TokenisedStorage' => false,
        );
    }
    function perfectmoney_config() {
        return array(
            'Name' => array(
                'Type' => 'System',
                'Value' => 'Perfect Money',
            ),
            'perfectmoney_id' => array(
                'Name' => 'Perfect Money Payee Account',
                'Type' => 'text',
                'Size' => '100',
                'Default' => '',
                'Description' => 'example: U12345678',
            ),
            'perfectmoney_pass' => array(
                'Name' => 'Perfect Money Alternate PassPhrase',
                'Type' => 'text',
                'Size' => '250',
                'Default' => '',
                'Description' => 'Alternate PassPhrase can be found and set under Settings section in your PM account',
            )
        );
    }
	function perfectmoney_link($params=[]) {
		# Gateway Specific Variables
		$perfectmoney_id = $params['perfectmoney_id'];
		
		# Invoice Variables
		$invoiceid = _s('invoiceid',$params,0);
		$description = _s("description",$params,"");
		$amount = _s('amount',$params,0);
		$currency = _s('currency',$params,""); # Currency Code
	 
		# System Variables
		$companyname = _s('companyname',$params,"");
		$systemurl = _s('systemurl',$params,"");
		$currency = _s('currency',$params,"");
		$callback = _s("returnurl",$params,"");
		$code = '<form action="https://perfectmoney.com/api/step1.asp" method="post">
	<input type="hidden" name="SUGGESTED_MEMO" value="'.$description.'">
	<input type="hidden" name="PAYMENT_ID" value="'.$invoiceid.'" />
	<input type="hidden" name="PAYMENT_AMOUNT" value="'.$amount.'" />
	<input type="hidden" name="PAYEE_ACCOUNT" value="'.$perfectmoney_id.'" />
	<input type="hidden" name="PAYMENT_UNITS" value="'.$currency.'" />
	<input type="hidden" name="PAYEE_NAME" value="'.$companyname.'" />
	<input type="hidden" name="PAYMENT_URL" value="'.$callback.'" />
	<input type="hidden" name="PAYMENT_URL_METHOD" value="LINK" />
	<input type="hidden" name="NOPAYMENT_URL" value="'.$callback.'" />
	<input type="hidden" name="NOPAYMENT_URL_METHOD" value="LINK" />
	<input type="hidden" name="STATUS_URL" value="'.$callback.'" />
	<input type="submit" value="Pay Now" />
	</form>';
	return $code;
	}
    function perfectmoney_callback($params=[])
    {
        // Gateway Configuration Parameters
        $perfectmoney_id = $params['gateway']['perfectmoney_id'];
        $perfectmoney_pass = $params['gateway']['perfectmoney_pass'];
        $gateway_id = $params['gateway']['id'];
        $invoiceid = $params['invoiceid'];
        // Detect module name from filename.
        // Fetch gateway configuration parameters.
        $gatewaymodule = $gateway_id > 0 ? $gateway_id : "perfectmoney";

        $gateway_variables = GetPaymentGatewayVariables($gatewaymodule);
        $perfectmoney_pass = !empty($perfectmoney_pass) ? $perfectmoney_pass:_s("perfectmoney_pass",$gateway_variables,"");
        $perfectmoney_id = !empty($perfectmoney_id) ? $perfectmoney_id:_s("perfectmoney_id",$gateway_variables,"");

		$PAYMENT_ID = _s("PAYMENT_ID",$_POST,0);
		$PAYEE_ACCOUNT = _s("PAYEE_ACCOUNT",$_POST,0);
		$PAYMENT_AMOUNT = _s("PAYMENT_AMOUNT",$_POST,0);
		$PAYMENT_UNITS = _s("PAYMENT_UNITS",$_POST,0);
		$PAYMENT_BATCH_NUM = _s("PAYMENT_BATCH_NUM",$_POST,0);
		$PAYER_ACCOUNT = _s("PAYER_ACCOUNT",$_POST,"");
		$TIMESTAMPGMT = _s("TIMESTAMPGMT",$_POST,"");
		$V2_HASH = _s("V2_HASH",$_POST,"");
		$string = $PAYMENT_ID.':'.$PAYEE_ACCOUNT.':'.$PAYMENT_AMOUNT.':'.$PAYMENT_UNITS.':'.$PAYMENT_BATCH_NUM.':'.$PAYER_ACCOUNT.':'.strtoupper(md5($perfectmoney_pass)).':'.$TIMESTAMPGMT;
		$hash=strtoupper(md5($string));

		$invoiceid = (int)$PAYMENT_ID > 0 ? $PAYMENT_ID:$invoiceid;

        // Invoice Parameters
        $currency = $params['invoice']['currency'];
        $currencyCode = $params['invoice']['currencyCode'];
        $payment_method = $params['invoice']['payment_method'];
        $user_id = $params['client']['id'];
        $callback = $params["returnurl"];
        $systemUrl = rtrim($params["systemurl"],"/");
        $systemUrl = rtrim($systemUrl,"/client");

        $result = $_POST;
        if($PAYMENT_UNITS !=$currencyCode)
        {
			$result["message"] = "Payment Unsuccessful due to Currency not matched";
			AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$result));
			return '<div class="alert alert-danger">Payment Unsuccessful due to Currency not matched</div>'; 
        }
        if($PAYMENT_UNITS !=$perfectmoney_id)
        {
			$result["message"] = "Payment Unsuccessful due to Perfect Money ID not matched";
			AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$result));
			return '<div class="alert alert-danger">Payment Unsuccessful due to Perfect Money ID not matched</div>'; 
        }
		if($hash!=$V2_HASH)
		{
			$result["message"] = "Payment Unsuccessful due to invalid hash";
			AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$result));
			return '<div class="alert alert-danger">Payment Unsuccessful due to invalid hash</div>'; 
		}
        $isValid =  DoInvoiceValidate($invoiceid);
        if(!$isValid)
        {
			$result["message"] = "Payment Unsuccessful due to Invoice Id is Invailed";
			AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$result));
       		return '<div class="alert alert-danger">Invoice Id is Invailed.....</div>'; 
        }
        $isValid =  DoTransactionValidate($invoiceid, $PAYMENT_BATCH_NUM);
        if($isValid)
        {
			$result["message"] = "Payment Unsuccessful due to Transaction No already exist";
			AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$result));
       		return '<div class="alert alert-danger">Transaction No already exist.....</div>';
        }
        $fee = 0;
        $payment_added = AddInvoicePayment(array('invoice_id'=>$invoiceid,'currency'=>$currency,'user_id'=>$user_id,'payment_method'=>$payment_method,'amount'=>$PAYMENT_AMOUNT,'trno'=>$PAYMENT_BATCH_NUM,'fee'=>$fee,'notification'=>'YES'));
        if($payment_added['status'] == 'success')
        {
        	$result["message"] = "Payment Confirmed by gateway and marked in system";
	    	AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$result));
            header("Location: /client/view-invoice/".$invoiceid); 
            die();
        }
    	$result["message"] = "Payment Confirmed by gateway but Payment entry error";
    	AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$result));
        return '<div class="alert alert-danger">Payment Confirmed but Payment entry error...'.$payment_added['message'].'</div>';
    }