<?php
if (!defined("WHMSOLS")) exit("This file cannot be accessed directly");
function skrill_info()
{
    return array(
        'DisplayName'=>'Skrill 1-Tap',// display name for client
        'APIVersion'=>'1.2',
        'DisableLocalCredtCardInput'=>false,
        'TokenisedStorage'=>false,
    );
}
function skrill_config()
{
    return array("Name"=>array("Type"=>"System","Value"=>"Skrill 1-Tap"),"emailAddress"=>array("Name"=>"Email Address","Type"=>"text","Size"=>"30"),"apiMqiPassword"=>array("Name"=>"API/MQI Password","Type"=>"text","Size"=>"30","Description"=>"You will need to enable the MQI (merchant query interface) and API (automated payment interface)" . " and set up an MQI/API password to use 1-Tap. <a href=\"https://whmsols.com/documentation/Skrill 1-Tap\" class=\"autoLinked\">Learn more</a>"),"secretWord"=>array("Name"=>"Secret Word","Type"=>"text","Size"=>"30","Description"=>"This can be configured within your <a href=\"https://account.skrill.com/\" class=\"autoLinked\">Skrill account</a>" . " by logging in and navigating to Settings > Developer Settings > Change secret word."),"maxRecurringAmount"=>array("Name"=>"Max Recurring Amount","Type"=>"text","Size"=>"10","Description"=>"<i>Optional</i> Defaults to order total." . " Define to override the maximum amount for future payments." . " Customer's will be asked to authorize this amount when performing an initial 1-Tap payment."),"noAccount"=>array("Type"=>"info","Description"=>"<div class=\"alert alert-info\" style=\"margin-bottom: 0;\">New to Skrill? <a href=\"https://whmsols.com/go/skrill-signup\" class=\"autoLinked alert-link\">Create an account</a></div>"));
}
function skrill_nolocalcc()
{
}
function skrill_no_cc()
{
}
function skrill_Checkout(array $params)
{
    $siteurl = rtrim($params["siteurl"],"/");
    $make_payment = _s("make_payment",$_REQUEST,[]);
    $gatewayid = _s("gatewayid",$params,"");
    if (!empty($gatewayid))
    {
        $postFields = array("email"=>$params["emailAddress"],"password"=>md5($params["apiMqiPassword"]),"action"=>"prepare","amount"=>_skrill_amount($params["amount"]),"currency"=>$params["currency"],"ondemand_note"=>$params["description"],"frn_trn_id"=>$params["invoiceid"] . "-" . time(),"rec_payment_id"=>$params["gatewayid"],"merchant_fields"=>"platform,invoice_id","platform"=>"96648253","invoice_id"=>$params["invoiceid"]);
        try {
            $transaction = _skrill_one_tap_request($postFields);
            if ($transaction["STATUS"] == "-2")
            {
                $REQUEST["TransStatus"] = "Failed";
                AddGatewayLogs(array('invoice_id'=>$params["invoiceid"],'user_id'=>$params["userid"],'payment_method'=>$params["payment_method"],'response'=>$transaction,"message"=>"Declined"));
                return ["status"=>"error","message"=>"Payment failed by skrill gateway"];
            }
            if ($transaction["STATUS"] == "error") return ["status"=>"error","message"=>$transaction["message"]];
            $clientCurrency = $params["clientdetails"]["currency"];
            $amount = $transaction["AMOUNT"];
            $paymentCurrency = $params["currency"];
            $payment_added = AddInvoicePayment(['invoice_id'=>$params["invoiceid"],'currency'=>$params["currency"],'user_id'=>$params["userid"],'payment_method'=>$params["payment_method"],'amount'=>$params["amount"],'trno'=>$transaction["ID"],'fee'=>0,'notification'=>'YES']);
            $REQUEST["TransStatus"] = "Success";
            AddGatewayLogs(array('invoice_id'=>$params["invoiceid"],'user_id'=>$params["userid"],'payment_method'=>$params["payment_method"],'response'=>$transaction,"message"=>"Payment Confirmed By Gateway"));
            if($payment_added['status'] != 'success') return ["status"=>"success","message"=>"Payment Confirmed but Payment entry error...".$payment_added['message']];
            header("Location: /client/view-invoice/".$params["invoiceid"]);
            die();
        } catch (Exception $e)
        {
            AddGatewayLogs(array('invoice_id'=>$params["invoiceid"],'user_id'=>$params["userid"],'payment_method'=>$params["payment_method"],'response'=>$e->getMessage(),"message"=>"Error on Payment"));
            return ["status"=>"error","message"=>"An Error Occurred: ".$e->getMessage()];
        }
    }
    $maxAmount = $params["amount"];
    $clientCurrency = $params["clientdetails"]["currency"];
    $paymentCurrency = $params["currency"];
    $postFields = array("pay_to_email"=>$params["emailAddress"],"recipient_description" =>$params["companyname"],"return_url"=>$params["returnurl"],"return_url_target"=>"1","cancel_url"=>$params["returnurl"] . "?paymentfailed=true","cancel_url_target"=>"1","status_url"=>$params["returnurl"],"language"=>_skrill_language($params["clientdetails"]["language"]),"prepare_only"=>"1","merchant_fields"=>"platform,invoice_id","platform"=>"96648253","invoice_id"=>$params["invoiceid"],"pay_from_email"=>$params["clientdetails"]["email"],"firstname"=>$params["clientdetails"]["firstname"],"lastname"=>$params["clientdetails"]["lastname"],"address"=>$params["clientdetails"]["address1"],"phone_number"=>preg_replace("/[^0-9]/","",$params["clientdetails"]["phonenumber"]),"postal_code"=>preg_replace("/[^a-zA-Z0-9]/","",$params["clientdetails"]["postcode"]),"city"=>$params["clientdetails"]["city"],"state"=>$params["clientdetails"]["state"],"country"=>_skrill_country_code($params["clientdetails"]["countrycode"]),"amount"=>_skrill_amount($params["amount"]),"currency"=>$params["currency"],"detail1_description"=>$params["description"],"detail1_text"=>$params["invoicenum"],"ondemand_max_amount"=>number_format($maxAmount,2),"ondemand_max_currency"=>$params["currency"],"ondemand_note"=>$params["description"],"ondemand_status_url"=>$params["returnurl"]);
    $url = "https://pay.skrill.com";
    $rawResponse = curlCall($url,$postFields);
    $response = json_decode($rawResponse,true);
    if (substr($rawResponse,0,10) == "CURL Error")
    {
        AddGatewayLogs(array('invoice_id'=>$params["invoiceid"],'user_id'=>$params["userid"],'payment_method'=>$params["payment_method"],'response'=>$response,"message"=>"Error on Payment"));
        return ["status"=>"error","message"=>"An Error Occurred - Please contact Support"];
    }
    if ($response || is_array($response))
    {
        $message = _s("message",$response,"");
        AddGatewayLogs(array('invoice_id'=>$params["invoiceid"],'user_id'=>$params["userid"],'payment_method'=>$params["payment_method"],'response'=>$response,"message"=>"Error on Payment Request"));
        return ["status"=>"error","message"=>"An Error Occurred: ".$message];
    }
    $sessionId = $rawResponse;
    header("Location: " . $url . "?sid=" . $sessionId);
}
function skrill_link(array $params)
{
    $Title = $params["langpaynow"];
    $Gateway_id = $params["gateway"]["id"];
    $invoiceid = $params["invoiceid"];
    $userid = $params["userid"];
    return '<form id="frmStripePayment" method="post" action="" onsubmit="ws.gateway_actions(this,false); return false;">
                <input type="hidden" name="act" value="Checkout" />
                <input type="hidden" name="id" value="'.$invoiceid.'" />
                <input type="hidden" name="user_id" value="'.$userid.'" />
                <input type="hidden" name="gateway_id" value="'.$Gateway_id.'" />
                <button type="submit" class="btn btn-success w-100" />'.$Title.'</button>
            </form>';
}
function skrill_capture(array $params)
{
    try {
        $gatewayid = _s("gatewayid",$params,"");
        if (!$gatewayid) return ["status"=>"error","message"=>"No 1-Tap Payment Information Stored"];
        $postFields = array("email"=>$params["emailAddress"],"password"=>md5($params["apiMqiPassword"]),"action"=>"status_od","amount"=>_skrill_amount($params["amount"]),"trn_id"=>$params["gatewayid"]);
        $url = "https://www.skrill.com/app/query.pl";
        $rawResponse = curlCall($url,$postFields);
        if (substr($rawResponse,0,10) == "CURL Error") return ["status"=>"error","message"=>"CURL Error","rawdata"=>$rawResponse];
        $response = explode("\n",$rawResponse);
        $response = explode("  ",$response[1]);
        $response = explode(" ",$response[0]);
        if ($response[1] == "-1") return ["status"=>"error","message"=>"1-Tap Payment Cancelled","rawdata"=>$rawResponse];
        $postFields = array("email"=>$params["emailAddress"],"password"=>md5($params["apiMqiPassword"]),"action"=>"prepare","amount"=>_skrill_amount($params["amount"]),"currency"=>$params["currency"],"ondemand_note"=>$params["description"],"frn_trn_id"=>$params["invoiceid"] . "-" . time(),"rec_payment_id"=>$params["gatewayid"],"merchant_fields"=>"platform,invoice_id","platform"=>"96648253","invoice_id"=>$params["invoiceid"]);
        $transaction = _skrill_one_tap_request($postFields);
        if ($transaction["STATUS"] == "-2") return array("status"=>"error","message"=>"Payment Failed","rawdata"=>$transaction);
        if ($transaction["STATUS"] == "error") return array("status"=>"error","message"=>$transaction["message"],"rawdata"=>$transaction);
        return array("status"=>"success","transid"=>$transaction["ID"],"amount"=>$transaction["AMOUNT"],"rawdata"=>$transaction);
    } catch (Exception $e)
    {
        return array("status"=>"error","message"=>"Payment Failed","rawdata"=>$e->getMessage());
    }
}
function skrill_storeremote(array $params)
{
    $custom = _s("custom",$params,[]);
    $action = _s("action",$custom,"");
    if ($action == "delete")
    {
        try {
            $postFields = array("email"=>$params["emailAddress"],"password"=>md5($params["apiMqiPassword"]),"action"=>"cancel_od","amount"=>0,"trn_id"=>$params["gatewayid"]);
            $url = "https://www.skrill.com/app/query.pl";
            $rawResponse = curlCall($url,$postFields);
            if (substr($rawResponse,0,10) == "CURL Error") return ["status"=>"error","message"=>"CURL Error","rawdata"=>$rawResponse];
            $response = json_decode($rawResponse,true);
            if ($response || is_array($response)) return ["status"=>"error","message"=>"Subscription Cancellation Failed","rawdata"=>$response];
            $response = explode("\t",$rawResponse);
            $response = $response[2];
            if ($response == "OK") return array("status"=>"success","rawdata"=>array("request"=>$postFields,"response"=>$rawResponse));
            return ["status"=>"error","message"=>"Subscription Cancellation Failed","rawdata"=>$rawResponse];
        } catch (Exception $e)
        {
            return ["status"=>"error","message"=>"Exception Error","rawdata"=>$e->getMessage()];
        }
    }
    return array("status"=>"success","rawdata"=>array("info"=>"No Action Performed"));
}
function skrill_refund(array $params)
{
    try {
        $postFields = array("email"=>$params["emailAddress"],"password"=>md5($params["apiMqiPassword"]),"action"=>"prepare","amount"=>_skrill_amount($params["amount"]),"transaction_id"=>$params["transid"],"merchant_fields"=>"platform","platform"=>"96648253");
        $url = "https://www.skrill.com/app/refund.pl";
        $rawResponse = curlCall($url,$postFields);
        if (substr($rawResponse,0,10) == "CURL Error") return ["status"=>"error","message"=>"CURL Error","rawdata"=>$rawResponse];
        $response = XMLtoARRAY($rawResponse);
        $response = $response["RESPONSE"];
        if (array_key_exists("ERROR",$response)) return ["status"=>"error","message"=>$response["ERROR"]["ERROR_MSG"],"rawdata"=>$response];
        $sessionId = $response["SID"];
        $postFields = array("sid"=>$sessionId,"action"=>"refund");
        $rawResponse = curlCall($url,$postFields);
        if (substr($rawResponse,0,10) == "CURL Error") return ["status"=>"error","message"=>"CURL Error","rawdata"=>$rawResponse];
        $response = XMLtoARRAY($rawResponse);
        $response = $response["RESPONSE"];
        if (array_key_exists("ERROR",$response)) return ["status"=>"error","message"=>$response["ERROR"]["ERROR_MSG"],"rawdata"=>$response];
        if ($response["STATUS"] != 2)
        {
            if ($response["STATUS"] == -2) return ["status"=>"error","message"=>"Not Servicable","rawdata"=>$response["ERROR"]];
            return ["status"=>"error","message"=>"Refund Pending - Manual Update Required","rawdata"=>$response];
        } 
        return array("status"=>"success","rawdata"=>$response,"transid"=>$response["MB_TRANSACTION_ID"]);
    } catch (Exception $e)
    {
        return array("status"=>"error","message"=>$e->getMessage());
    }
}
function _skrill_amount($amount)
{
    return $amount + 0;
}
function _skrill_country_code($countryCode)
{
    $countries = ["AF"=>"AFG","AX"=>"ALA","AL"=>"ALB","DZ"=>"DZA","AS"=>"ASM","AD"=>"AND","AO"=>"AGO","AI"=>"AIA","AQ"=>"ATA","AG"=>"ATG","AR"=>"ARG","AM"=>"ARM","AW"=>"ABW","AU"=>"AUS","AT"=>"AUT","AZ"=>"AZE","BS"=>"BHS","BH"=>"BHR","BD"=>"BGD","BB"=>"BRB","BY"=>"BLR","BE"=>"BEL","BZ"=>"BLZ","BJ"=>"BEN","BM"=>"BMU","BT"=>"BTN","BO"=>"BOL","BQ"=>"BES","BA"=>"BIH","BW"=>"BWA","BV"=>"BVT","BR"=>"BRA","IO"=>"IOT","BN"=>"BRN","BG"=>"BGR","BF"=>"BFA","BI"=>"BDI","KH"=>"KHM","CM"=>"CMR","CA"=>"CAN","CV"=>"CPV","KY"=>"CYM","CF"=>"CAF","TD"=>"TCD","CL"=>"CHL","CN"=>"CHN","CX"=>"CXR","CC"=>"CCK","CO"=>"COL","KM"=>"COM","CG"=>"COG","CD"=>"COD","CK"=>"COK","CR"=>"CRI","CI"=>"CIV","HR"=>"HRV","CU"=>"CUB","CW"=>"CUW","CY"=>"CYP","CZ"=>"CZE","DK"=>"DNK","DJ"=>"DJI","DM"=>"DMA","DO"=>"DOM","EC"=>"ECU","EG"=>"EGY","SV"=>"SLV","GQ"=>"GNQ","ER"=>"ERI","EE"=>"EST","ET"=>"ETH","FK"=>"FLK","FO"=>"FRO","FJ"=>"FIJ","FI"=>"FIN","FR"=>"FRA","GF"=>"GUF","PF"=>"PYF","TF"=>"ATF","GA"=>"GAB","GM"=>"GMB","GE"=>"GEO","DE"=>"DEU","GH"=>"GHA","GI"=>"GIB","GR"=>"GRC","GL"=>"GRL","GD"=>"GRD","GP"=>"GLP","GU"=>"GUM","GT"=>"GTM","GG"=>"GGY","GN"=>"GIN","GW"=>"GNB","GY"=>"GUY","HT"=>"HTI","HM"=>"HMD","VA"=>"VAT","HN"=>"HND","HK"=>"HKG","HU"=>"HUN","IS"=>"ISL","IN"=>"IND","ID"=>"IDN","IR"=>"IRN","IQ"=>"IRQ","IE"=>"IRL","IM"=>"IMN","IL"=>"ISR","IT"=>"ITA","JM"=>"JAM","JP"=>"JPN","JE"=>"JEY","JO"=>"JOR","KZ"=>"KAZ","KE"=>"KEN","KI"=>"KIR","KP"=>"PRK","KR"=>"KOR","KW"=>"KWT","KG"=>"KGZ","LA"=>"LAO","LV"=>"LVA","LB"=>"LBN","LS"=>"LSO","LR"=>"LBR","LY"=>"LBY","LI"=>"LIE","LT"=>"LTU","LU"=>"LUX","MO"=>"MAC","MK"=>"MKD","MG"=>"MDG","MW"=>"MWI","MY"=>"MYS","MV"=>"MDV","ML"=>"MLI","MT"=>"MLT","MH"=>"MHL","MQ"=>"MTQ","MR"=>"MRT","MU"=>"MUS","YT"=>"MYT","MX"=>"MEX","FM"=>"FSM","MD"=>"MDA","MC"=>"MCO","MN"=>"MNG","ME"=>"MNE","MS"=>"MSR","MA"=>"MAR","MZ"=>"MOZ","MM"=>"MMR","NA"=>"NAM","NR"=>"NRU","NP"=>"NPL","NL"=>"NLD","AN"=>"ANT","NC"=>"NCL","NZ"=>"NZL","NI"=>"NIC","NE"=>"NER","NG"=>"NGA","NU"=>"NIU","NF"=>"NFK","MP"=>"MNP","NO"=>"NOR","OM"=>"OMN","PK"=>"PAK","PW"=>"PLW","PS"=>"PSE","PA"=>"PAN","PG"=>"PNG","PY"=>"PRY","PE"=>"PER","PH"=>"PHL","PN"=>"PCN","PL"=>"POL","PT"=>"PRT","PR"=>"PRI","QA"=>"QAT","RE"=>"REU","RO"=>"ROU","RU"=>"RUS","RW"=>"RWA","BL"=>"BLM","SH"=>"SHN","KN"=>"KNA","LC"=>"LCA","MF"=>"MAF","SX"=>"SXM","PM"=>"SPM","VC"=>"VCT","WS"=>"WSM","SM"=>"SMR","ST"=>"STP","SA"=>"SAU","SN"=>"SEN","RS"=>"SRB","SC"=>"SYC","SL"=>"SLE","SG"=>"SGP","SK"=>"SVK","SI"=>"SVN","SB"=>"SLB","SO"=>"SOM","ZA"=>"ZAF","GS"=>"SGS","SS"=>"SSD","ES"=>"ESP","LK"=>"LKA","SD"=>"SDN","SR"=>"SUR","SJ"=>"SJM","SZ"=>"SWZ","SE"=>"SWE","CH"=>"CHE","SY"=>"SYR","TW"=>"TWN","TJ"=>"TJK","TZ"=>"TZA","TH"=>"THA","TL"=>"TLS","TG"=>"TGO","TK"=>"TKL","TO"=>"TON","TT"=>"TTO","TN"=>"TUN","TR"=>"TUR","TM"=>"TKM","TC"=>"TCA","TV"=>"TUV","UG"=>"UGA","UA"=>"UKR","AE"=>"ARE","GB"=>"GBR","US"=>"USA","UM"=>"UMI","UY"=>"URY","UZ"=>"UZB","VU"=>"VUT","VE"=>"VEN","VN"=>"VNM","VG"=>"VGB","VI"=>"VIR","WF"=>"WLF","EH"=>"ESH","YE"=>"YEM","ZM"=>"ZMB","ZW"=>"ZWE"];
    return array_key_exists($countryCode,$countries) ? $countries[$countryCode] : $countryCode;
}
function _skrill_language($language)
{
    $language = strtolower($language);
    $languages = ["bulgarian"=>"BG","chinese"=>"ZH","czech"=>"CS","danish"=>"DA","dutch"=>"NL","english"=>"EN","finnish"=>"FI","french"=>"FR","german"=>"DE","greek"=>"EL","italian"=>"IT","japanese"=>"JA","polish"=>"PL","romanian"=>"RO","russian"=>"RU","spanish"=>"ES","swedish"=>"SV","turkish"=>"TR"];
    return array_key_exists($language,$languages) ? $languages[$language] : "EN";
}
function _skrill_one_tap_request(array $postFields)
{
    $url = "https://www.skrill.com/app/ondemand_request.pl";
    $rawResponse = curlCall($url,$postFields);
    if (substr($rawResponse,0,10) == "CURL Error")
    {
        return ["STATUS"=>"error","message"=>"CURL Error","rawResponse"=>$rawResponse];
    }
    $response = XMLtoARRAY($rawResponse);
    $response = $response["RESPONSE"];
    if (array_key_exists("ERROR",$response)) {
        if (in_array($response["ERROR"]["ERROR_MSG"],array("MAX_AMOUNT_REACHED")))
        {
            return ["STATUS"=>"error","message"=>$response["ERROR"]["ERROR_MSG"]];
        }
        if (in_array($response["ERROR"]["ERROR_MSG"],array("ONDEMAND_CANCELLED"))) {
            return ["STATUS"=>"error","message"=>$response["ERROR"]["ERROR_MSG"]];
        }
        return ["STATUS"=>"error","message"=>$response["ERROR"]["ERROR_MSG"]];
    }
    $sessionId = $response["SID"];
    $postFields = array("sid"=>$sessionId,"action"=>"request");
    $rawResponse = curlCall($url,$postFields);
    if (substr($rawResponse,0,10) == "CURL Error")
    {
        return ["STATUS"=>"error","message"=>"Curl Error","rawResponse"=>$rawResponse];
    }
    $response = XMLtoARRAY($rawResponse);
    $response = $response["RESPONSE"];
    if (array_key_exists("ERROR",$response))
    {
        return ["STATUS"=>"error","message"=>$response["ERROR"]["ERROR_MSG"]];
    }
    return $response["TRANSACTION"];
}
function skrill_callback($params)
{
    $eTitle = $params['gateway']['title'];
    $gateway_id = $params['gateway']['id'];

    // Invoice Parameters
    $invoiceid = $params['invoice']['invoiceid'];
    $description = $params['invoice']["description"];
    $amount = $params['invoice']['amount'];
    $currency = $currencyCode = $params['invoice']['currency'];
    $payment_method = $params['invoice']['payment_method'];
    $user_id = $params['client']['id'];



    $invoiceId = (int) $_REQUEST["invoice_id"];
    $merchantId = $_REQUEST["merchant_id"];
    $transactionId = $_REQUEST["transaction_id"];
    $status = $_REQUEST["status"];
    $md5sig = $_REQUEST["md5sig"];
    $recTransactionId = $_REQUEST["rec_payment_id"];


    if ($invoiceId)
    {
        try {
            $payToEmail = $_REQUEST["pay_to_email"];
            $customerEmail = $_REQUEST["pay_from_email"];
            $paymentAmount = $_REQUEST["mb_amount"];
            $paymentCurrency = $_REQUEST["mb_currency"];
            $failedCode = $_REQUEST["failed_reason_code"];
            $amount = $_REQUEST["amount"];
            $currency = $_REQUEST["currency"];
            $md5Secret = strtoupper(md5($params["secretWord"]));
            $validateSig = md5($merchantId . $transactionId . $md5Secret . $paymentAmount . $paymentCurrency . $status);
            if ($status == "-1")
            {
                $validateSig = md5($merchantId.$transactionId.$md5Secret.$status.$recTransactionId);
            }
            if (strtoupper($validateSig) != $md5sig)
            {
                return '<div class="alert alert-danger">MD5 Signature Failure</div>';
            }
            $postFields = array("email"=>$params["emailAddress"],"password"=>md5($params["apiMqiPassword"]),"action"=>"status_trn","mb_trn_id"=>$transactionId);
            $url = "https://www.skrill.com/app/query.pl";
            $rawResponse = curlCall($url,$postFields);
            if (substr($rawResponse,0,10) == "CURL Error") {
                return '<div class="alert alert-danger">Curl Error</div>';
            }
            $response = explode("\n",$rawResponse);
            $response = $response[1];
            $result = array();
            parse_str($response,$result);
            if ($amount != $result["amount"] || $currency != $result["currency"] || $status != $result["status"] || $invoiceId != $result["invoice_id"] || $payToEmail != $result["pay_to_email"] || $customerEmail != $result["pay_from_email"])
            {
                AddGatewayLogs(array('invoice_id'=>$invoiceId,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$REQUEST,"message"=>"Invalid Transaction Details"));
                return '<div class="alert alert-danger">Invalid Transaction Details</div>';
            }
            $amount = $result["amount"];
            $currency = $result["currency"];
            $status = $result["status"];
            $currencyData = getCurrencyByCode($currency);
            if (!$currencyData || $currencyData->id != $params["currencyId"])
            {
                return '<div class="alert alert-danger">Unrecognised Currency</div>';
            }
            $currencyId = $currencyData->id;
            switch ($status) {
                case -3:
                    AddGatewayLogs(array('invoice_id'=>$invoiceId,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$REQUEST,"message"=>"Payment Reversed"));
                    paymentReversed("Reverse" . $transactionId,$transactionId,$invoiceId,"skrill");
                    break;
                case -2:
                    AddGatewayLogs(array('invoice_id'=>$invoiceId,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$REQUEST,"message"=>"Payment Declined"));
                    break;
                case -1:
                    invoiceDeletePayMethod($invoiceId);
                    AddGatewayLogs(array('invoice_id'=>$invoiceId,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$REQUEST,"message"=>"1-Tap Recurring Cancelled"));
                    break;
                case 2:
                    if ($recTransactionId)
                    {
                        $GetInvoiceOrderData = GetInvoiceOrderData($params["invoiceid"]);
                        $PayMethodRemoteToken = $GetInvoiceOrderData["PayMethodRemoteToken"];
                        if ($PayMethodRemoteToken != $recTransactionId)
                        {
                            $postFields = array("email"=>$params["emailAddress"],"password"=>md5($params["apiMqiPassword"]),"action"=>"cancel_od","amount"=>0,"trn_id"=>$PayMethodRemoteToken);
                            $url = "https://www.skrill.com/app/query.pl";
                            $rawResponse = curlCall($url,$postFields);
                            AddGatewayLogs(array('invoice_id'=>$invoiceId,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$rawResponse,"message"=>"Cancel Old 1-Tap"));
                        }
                        invoiceSetPayMethodRemoteToken($params["invoiceid"],$recTransactionId);
                    }
                    $clientCurrency = $params["clientdetails"]["currency"];
                    if ($currencyId && $clientCurrency != $currencyId)
                    {
                        $amount = convertCurrency($amount,$currencyId,$clientCurrency);
                        $total = array_key_exists("baseamount",$params) ? $params["baseamount"] : $params["amount"];
                        if ($total < $amount + 1 && $amount - 1 < $total) {
                            $amount = $total;
                        }
                    }

                    $payment_added = AddInvoicePayment(['invoice_id'=>$invoiceId,'currency'=>$currency,'user_id'=>$user_id,'payment_method'=>$payment_method,'amount'=>$amount,'trno'=>$transid,'fee'=>0,'notification'=>'YES']);
                    $REQUEST["TransStatus"] = "Success";
                    AddGatewayLogs(array('invoice_id'=>$invoiceId,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$REQUEST,"message"=>"Payment Confirmed By Gateway"));
                    if($payment_added['status'] != 'success') return '<div class="alert alert-danger">Payment Confirmed but Payment entry error...'.$payment_added['message'].'</div>';
                    header("Location: /client/view-invoice/".$invoiceid);
                    break;
            }
        }catch (Exception $e)
        {
            $REQUEST["TransStatus"] = "Failed";
            AddGatewayLogs(array('invoice_id'=>$invoiceId,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$REQUEST,"message"=>$e->getMessage()));
            return '<div class="alert alert-danger">'.($e->getMessage()).'</div>';    
        }
    }
}