        // Create an instance of elements
        var elements = stripe.elements();
        var style = {
            base: {
                fontWeight: 400,
                fontFamily: 'Roboto, Open Sans, Segoe UI, sans-serif',
                fontSize: '16px',
                lineHeight: '1.8',
                color: '#555',
                padding:'12px 15px',
                borderColor: '#e5e7eb',
                borderRadius: '5px', 
                backgroundColor: '#fff',
                '::placeholder': {
                    color: '#888',
                },
            },
            invalid: {
                color: '#eb1c26',
            }
        };
        var cardElement = elements.create('cardNumber', {
            style: style
        });
        cardElement.mount('#cc-cardnumber');
        var exp = elements.create('cardExpiry', {
            'style': style
        });
        exp.mount('#cc-exp-date');
        var cvc = elements.create('cardCvc', {
            'style': style
        });
        cvc.mount('#cc-cvc');
        // Validate input of the card elements
        var resultContainer = document.getElementById('paymentResponse');
        cardElement.addEventListener('change', function(event) {
            if (event.error) {
                resultContainer.innerHTML = '<p>'+event.error.message+'</p>';
            } else {
                resultContainer.innerHTML = '';
            }
        });
        
        // Get payment form element
        var form = document.getElementById('frmStripeCheckout');
        // Create a token when the form is submitted.
        form.addEventListener('submit', function(e) {
            e.preventDefault();
            createToken();
            return false;
            //ws.gateway_actions(e,false);
        });
        // Create single-use token to charge the user
        function createToken()
        {
            stripe.createToken(cardElement).then(function(result)
            {
                if (result.error)
                {
                    // Inform the user if there was an error
                    resultContainer.innerHTML = '<p>'+result.error.message+'</p>';
                }
                else
                {
                    // Send the token to your server
                    stripeTokenHandler(result.token);
                }
            });
        }
        // Callback to handle the response from stripe
        function stripeTokenHandler(token)
        {
            $("#ccc-stripeToken").val(token.id);
            $("#btnStripePaymentCheckout").click();
        }