        var stripe = Stripe(pk_key);
        // Create an instance of elements
        var elements = stripe.elements();
        var style = {
            base: {
                fontWeight: 400,
                fontFamily: 'arial',
                fontSize: '16px',
                lineHeight: '1.8',
                color: '#555',
                padding:'12px 15px',
                borderColor: '#e5e7eb',
                borderRadius: '5px', 
                backgroundColor: '#fff',
                '::placeholder': {
                    color: '#888',
                },
            },
            invalid: {
                color: '#eb1c26',
            }
        };
        var cardElement = elements.create('cardNumber', {
            style: style
        });
        cardElement.mount('#cc-cardnumber');
        var exp = elements.create('cardExpiry', {
            'style': style
        });
        exp.mount('#cc-exp-date');
        var cvc = elements.create('cardCvc', {
            'style': style
        });
        cvc.mount('#cc-cvc');
        // Validate input of the card elements
        if ($('#frm-cc-credit-card #cc-paymentResponse').length === 0) {
            $('#frm-cc-credit-card').append('<div id="cc-paymentResponse"></div>');
        }
        var resultContainer = document.getElementById('cc-paymentResponse');
        cardElement.addEventListener('change', function(event) {
            if (event.error) {
                resultContainer.innerHTML = '<p>'+event.error.message+'</p>';
            } else {
                resultContainer.innerHTML = '';
            }
        });
        function createToken()
        {
            stripe.createToken(cardElement).then(function(result) {
                if (result.error)
                {
                    resultContainer.innerHTML = '<p>'+result.error.message+'</p>';
                }
                else
                {
                    stripeTokenHandler(result.token);
                }
            });
        }
        // Callback to handle the response from stripe
        function stripeTokenHandler(token)
        {
            $("#ccc-stripeToken").val(token.id);
            $("#btn-cc-credit-card").click();
        }
        var form = document.getElementById('frm-cc-credit-card');
        form.addEventListener('submit', function(e)
        {
            var token = $("#ccc-stripeToken").val();
            console.log(token);
            var cc_req_from = $("#cc-req-from").val();
            e.preventDefault();
            if(token.length == 0)
            {
                createToken();
            }
            else
            {
                if(cc_req_from == "ccfa")
                {
                    ws.addCreditCardSave(e.target); 
                }
                else
                {
                    ws.gateway_actions(e.target,true);
                }
                $("#ccc-stripeToken").val("");
            }
            return false;
            //ws.gateway_actions(e,false);
        });