<?php
    if (!defined("WHMSOLS")) exit("This file cannot be accessed directly");
    function tco_info()
    {
        return array(
            'DisplayName' => '2CheckOut', // display name for client
            'APIVersion' => '1.1', 
            'DisableLocalCredtCardInput' => false,
            'TokenisedStorage' => false,
        );
    }
    function tco_config()
    {
        $configarray = array("Name" => array("Type" => "System", "Value" => "2CheckOut"), "vendornumber" => array("Name" => "Vendor Account Number", "Type" => "text", "Size" => "10", "Description" => "Don't Yet Have an Account? <a href='http://whmsols.com/go/2checkout-signup' target='_blank'>Signup for a new account here</a>!"),"apiusername" => array("Name" => "API Username", "Type" => "text", "Size" => "20", "Description" => "Setup in Account > User Management section of 2CheckOut's Panel"), "apipassword" => array("Name" => "API Password", "Type" => "text", "Size" => "20", "Description" => ""), "secretword" => array("Name" => "Secret Word", "Type" => "text", "Size" => "15", "Description" => "Used to validate callbacks, found in Account > Site Management of 2CheckOut's Panel (must leave blank for demo mode testing). Required for 2CheckOut Inline"), "recurringBilling" => array("Name" => "Recurring Billing", "Type" => "dropdown", "Value" => "", "Options" => array("" => "Offer Recurring & One Time Payments", "forcerecur" => "Offer Recurring Only", "disablerecur" => "Offer One Time Only")), "skipfraudcheck" => array("Name" => "Skip 2CO Fraud Check", "Type" => "yesno", "Description" => "Tick this box to mark invoices paid as soon as payments are made and not wait for 2CheckOut's Fraud Review Pass"), "demomode" => array("Name" => "Demo Mode", "Type" => "yesno", "Description" => "Tick to perform demo transactions in Live Mode (not necessary if using Sandbox Mode)"), "UsageNotes" => array("Type" => "System", "Value" => "You must enable INS Notifications inside your 2CheckOut account." . " To do this, login to 2CheckOut and navigate to" . " <em>Notifications > Global Settings > Global URL</em>, enable all notification options" . " and enter the following Call Back URL at 2CheckOut'"));
        return $configarray;
    }
    function tco_link(array $params = array())
    {
        $code = "";
        $lang = $params["clientdetails"]["language"];
        if (!$lang) $lang = GetConfigs("language");

        $languages = array("chinese" => "zh", "danish" => "da", "dutch" => "nl", "french" => "fr", "german" => "gr", "greek" => "el", "italian" => "it", "japanese" => "jp", "norwegian" => "no", "portuguese" => "pt", "slovenian" => "sl", "spanish" => "es_la", "swedish" => "sv", "english" => "en");

        $language = strtolower($lang);
        if (array_key_exists($language,$languages))  $lang = "<input type=\"hidden\" name=\"lang\" value=\"" . $languages[$language] . "\">";

        $url = "https://www.2checkout.com/checkout";
        $receiptUrl = $params["returnurl"] . "?act=2checkout";
        $invoiceUrl = rtrim($params["systemurl"],"/")."/client/view-invoice/".$params["invoiceid"];
        $code .= "<form action=\"" . $url . "/purchase\" method=\"post\">\n    <input type=\"hidden\" name=\"x_login\" value=\"" . $params["vendornumber"] . "\">\n    <input type=\"hidden\" name=\"x_invoice_num\" value=\"" . $params["invoiceid"] . "\">\n    <input type=\"hidden\" name=\"x_amount\" value=\"" . $params["amount"] . "\">\n    <input type=\"hidden\" name=\"currency_code\" value=\"" . $params["currency"] . "\">\n    <input type=\"hidden\" name=\"c_name\" value=\"" . $params["description"] . "\">\n    <input type=\"hidden\" name=\"c_description\" value=\"" . $params["description"] . "\">\n    <input type=\"hidden\" name=\"c_price\" value=\"" . $params["amount"] . "\">\n    <input type=\"hidden\" name=\"c_tangible\" value=\"N\">\n    <input type=\"hidden\" name=\"x_First_Name\" value=\"" . $params["clientdetails"]["firstname"] . "\">\n    <input type=\"hidden\" name=\"x_Last_Name\" value=\"" . $params["clientdetails"]["lastname"] . "\">\n    <input type=\"hidden\" name=\"x_Email\" value=\"" . $params["clientdetails"]["email"] . "\">\n    <input type=\"hidden\" name=\"x_Address\" value=\"" . $params["clientdetails"]["address1"] . "\">\n    <input type=\"hidden\" name=\"x_City\" value=\"" . $params["clientdetails"]["city"] . "\">\n    <input type=\"hidden\" name=\"x_State\" value=\"" . $params["clientdetails"]["state"] . "\">\n    <input type=\"hidden\" name=\"x_Zip\" value=\"" . $params["clientdetails"]["postcode"] . "\">\n    <input type=\"hidden\" name=\"x_Country\" value=\"" . $params["clientdetails"]["country"] . "\">\n    <input type=\"hidden\" name=\"x_Phone\" value=\"" . $params["clientdetails"]["phonenumber"] . "\">\n    <input type=\"hidden\" name=\"fixed\" value=\"Y\">\n    <input type=\"hidden\" name=\"return_url\" value=\"".$invoiceUrl."\">\n    <input type=\"hidden\" name=\"return_url\" value=\"".$invoiceUrl."\">\n    " . $lang . "\n    <input type=\"hidden\" name=\"x_receipt_link_url\" value=\"" . $receiptUrl . "\">";
        if ($params["demomode"] == "yes")
        {
            $code .= "<input type=\"hidden\" name=\"demo\" value=\"Y\">";
        }
        $code .= "<input type=\"submit\" class=\"btn btn-primary\" value=\"" . \Lang::trans("invoiceoneoffpayment") . "\" />\n    </form>";
        return $code;
    }
    function tco_refund(array $params = array())
    {
        $sale_id = $params["transid"];
        $post_variables = array("sale_id" => $sale_id, "amount" => $params["amount"], "currency" => "vendor", "category" => 5, "comment" => "Cancelled");
        if (strpos($sale_id, "-")) {
            $parts = explode("-", $sale_id, 2);
            list($post_variables["sale_id"], $post_variables["invoice_id"]) = $parts;
        }
        $url = "https://www.2checkout.com/api/sales/refund_invoice";
        $query_string = http_build_query($post_variables);
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_USERPWD, $params["apiusername"] . ":" . $params["apipassword"]);
        curl_setopt($ch, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $query_string);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array("Accept: application/json"));
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
        $results = array();
        if (!($response = curl_exec($ch))) {
            $results["curl_error"] = curl_error($ch);
            curl_close($ch);
            return array("status" => "error", "rawdata" => $results);
        }
        curl_close($ch);
        if (!function_exists("json_decode")) {
             return array("status" => "error", "rawdata" =>"JSON Module Required in PHP Build for 2CheckOut Gateway");
        }
        $response = json_decode($response, true);
        if (!count($response["errors"]) && $response["response_code"] == "OK")
        {
            $results["transid"] = $params["transid"];
            $results["message"] = $response["response_message"];
            $results["status"] = "success";
            return array("status" => "success", "transid" => $results["transid"], "rawdata" => $results);
        }
        $results["status"] = "error";
        $results["error_code"] = $response["errors"][0]["code"];
        $results["message"] = $response["errors"][0]["message"];
        return array("status" => "error", "rawdata" => $results);
    }
    
    function tco_isClientCallback($request=[])
    {
        if (!empty($request["x_invoice_num"]) || !empty($request["merchant_order_id"])) return true;
        return false;
    }
    function tco_callback($params)
    {
        $eTitle = $params['gateway']['title'];
        $gateway_id = $params['gateway']['id'];
        $partnerid = $params['gateway']['partnerid']; 
        $customDescription = $params['gateway']['customDescription'];
        // Invoice Parameters
        $ginvoiceid = $params['invoice']['invoiceid'];
        $description = $params['invoice']["description"];
        $amount = $params['invoice']['amount'];
        $currency = $currencyCode = $params['invoice']['currency'];
        $payment_method = $params['invoice']['payment_method'];
        $user_id = $params['client']['id'];
        // System Parameters
        $companyName = $params['system']['companyname'];
        $systemUrl = $params['system']['systemurl'];            // System URL
        $siteurl = $params['system']['siteurl'];            // System URL

        $REQUEST = $_REQUEST;
        if (tco_isClientCallback($REQUEST))
        {
            if ($params["secretword"])
            {
                $string_to_hash = $params["secretword"] . $params["vendornumber"] . $REQUEST["x_trans_id"] . $REQUEST["x_amount"];
                $check_key = strtoupper(md5($string_to_hash));
                if (hash_equals($check_key, $REQUEST["x_MD5_Hash"]) === false)
                {
                    $REQUEST["TransStatus"] = "Failed";
                    AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$REQUEST,"message"=>"MD5 Hash Failure"));
                    return '<div class="alert alert-danger">MD5 Hash Failure</div>';
                }
            }
            $outputText = "Payment Processing Completed. However it may take a while for 2CheckOut fraud verification" . " to complete and the payment to be reflected on your account." . " Please wait while you are redirected back to the client area...";
            $responseCode = (int) $REQUEST["x_response_code"];
            $x_invoice_num = $REQUEST["x_invoice_num"];
            if ($responseCode == 1)
            {
                $isValid =  DoInvoiceValidate($x_invoice_num);
                if(!$isValid) return '<div class="alert alert-danger">Invoice Id is Invailed.....</div>';
                if ($params["skipfraudcheck"])
                {
                    header("Location: /client/view-invoice/".$x_invoice_num."?paymentsuccess=true");
                }
                else
                {
                    $REQUEST["TransStatus"] = "Pending Preview";
                    AddGatewayLogs(array('invoice_id'=>$x_invoice_num,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$REQUEST,"message"=>"Payment Pending for Review at 2CheckOut"));
                    header("Location: /client/view-invoice/".$x_invoice_num."?pendingreview=true");
                }
            }
            else
            {
                $REQUEST["TransStatus"] = "Unsuccessful";
                AddGatewayLogs(array('invoice_id'=>$x_invoice_num,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$REQUEST,"message"=>"Payment Failed"));
                return '<div class="alert alert-danger">Payment Failed</div>';
            }
        }
        else
        {
            if ($params["secretword"])
            {
                $string_to_hash = $REQUEST["sale_id"] . $params["vendornumber"] . $REQUEST["invoice_id"] . $params["secretword"];
                $check_key = strtoupper(md5($string_to_hash));
                if (hash_equals($check_key, $REQUEST["md5_hash"]) === false)
                {
                    $REQUEST["TransStatus"] = "Failed";
                    AddGatewayLogs(array('invoice_id'=>$invoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$REQUEST,"message"=>"MD5 Hash Failure"));
                    return '<div class="alert alert-danger">MD5 Hash Failure</div>';
                }
            }
            $message_type = $_POST["message_type"];
            $serviceid = $_POST["vendor_order_id"];
            $transid = $_POST["sale_id"];
            $recurringtransid = $transid . "-" . $_POST["invoice_id"];
            $cinvoiceid = $_POST["invoice_id"];
            $amount = $_POST["invoice_list_amount"] ? $_POST["invoice_list_amount"] : $_POST["item_list_amount_1"];
            $recurstatus = trim($_POST["item_rec_status_1"]);
            $invoiceid = $_POST["item_id_1"] ? $_POST["item_id_1"] : $_POST["item_id_2"];
            $currency = $_POST["list_currency"];
            $message_type = $_POST["message_type"];
            $fee = 0;
            if ($message_type == "FRAUD_STATUS_CHANGED" && !$params["skipfraudcheck"])
            {
                $fraud_status = $_POST["fraud_status"];
                if ($fraud_status == "pass")
                {

                    $REQUEST["TransStatus"] = "Fraud Status";
                    AddGatewayLogs(array('invoice_id'=>$cinvoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$REQUEST,"message"=>"Fraud Status Pass"));

                    $isValid =  DoTransactionValidate($cinvoiceid,$transid);
                    if($isValid) return '<div class="alert alert-danger">Transaction No already exist.....</div>';
                    $amount = PriceAdjustDecimals($amount, $currency);
                    $fee = PriceAdjustDecimals($fee, $currency);

                    $payment_added = AddInvoicePayment(['invoice_id'=>$cinvoiceid,'currency'=>$currencyCode,'user_id'=>$user_id,'payment_method'=>$payment_method,'amount'=>$amount,'trno'=>$transid,'fee'=>$fee,'notification'=>'YES']);
                    $REQUEST["TransStatus"] = "Success";
                    AddGatewayLogs(array('invoice_id'=>$cinvoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$REQUEST,"message"=>"Payment Confirmed By Gateway"));
                    if($payment_added['status'] != 'success') return '<div class="alert alert-danger">Payment Confirmed but Payment entry error...'.$payment_added['message'].'</div>';
                    header("Location: /client/view-invoice/".$invoiceid);
                    die();
                }
                else
                {
                    $REQUEST["TransStatus"] = "Fraud Status Fail";
                    AddGatewayLogs(array('invoice_id'=>$cinvoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$REQUEST,"message"=>"Fraud Status Fail"));
                    return '<div class="alert alert-danger">Fraud Status Fail</div>';
                }
            } else {
                if ($message_type == "ORDER_CREATED")
                {

                    $isValid =  DoTransactionValidate($cinvoiceid,$transid);
                    if($isValid) return '<div class="alert alert-danger">Transaction No already exist.....</div>';
                    $amount = PriceAdjustDecimals($amount, $currency);
                    $fee = PriceAdjustDecimals($fee, $currency);

                    $payment_added = AddInvoicePayment(['invoice_id'=>$cinvoiceid,'currency'=>$currencyCode,'user_id'=>$user_id,'payment_method'=>$payment_method,'amount'=>$amount,'trno'=>$transid,'fee'=>$fee,'notification'=>'YES']);
                    $REQUEST["TransStatus"] = "Success";
                    AddGatewayLogs(array('invoice_id'=>$cinvoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$REQUEST,"message"=>"Payment Confirmed By Gateway"));
                    if($payment_added['status'] != 'success') return '<div class="alert alert-danger">Payment Confirmed but Payment entry error...'.$payment_added['message'].'</div>';
                    header("Location: /client/view-invoice/".$cinvoiceid);
                    die();
                }
                else
                {
                    if ($message_type == "RECURRING_INSTALLMENT_SUCCESS")
                    {
                        $isValid =  DoTransactionValidate($cinvoiceid,$recurringtransid);
                        if($isValid) return '<div class="alert alert-danger">Transaction No already exist.....</div>';
                        if (!$invoiceid && !$serviceid)
                        {
                            $REQUEST["TransStatus"] = "Recurring Error";
                            AddGatewayLogs(array('invoice_id'=>$cinvoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$_POST,"message"=>"No Service ID Found in Callback"));
                            return '<div class="alert alert-danger">Recurring Error:No Service ID Found in Callback</div>';
                        }
                        else
                        {
                            if (!$invoiceid)
                            {
                                $REQUEST["TransStatus"] = "Recurring Error";
                                AddGatewayLogs(array('invoice_id'=>$cinvoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$_POST,"message"=>"No invoice match found for Service ID " . $serviceid . " or Subscription ID"));
                                return '<div class="alert alert-danger">Recurring Error:No invoice match found for Service ID '.$serviceid.' or Subscription ID</div>';
                            }
                        }

                        $amount = PriceAdjustDecimals($amount, $currency);
                        $fee = PriceAdjustDecimals($fee, $currency);
                        $payment_added = AddInvoicePayment(['invoice_id'=>$cinvoiceid,'currency'=>$currencyCode,'user_id'=>$user_id,'payment_method'=>$payment_method,'amount'=>$amount,'trno'=>$recurringtransid,'fee'=>$fee,'notification'=>'YES']);
                        $REQUEST["TransStatus"] = "Success";
                        AddGatewayLogs(array('invoice_id'=>$cinvoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$REQUEST,"message"=>"Payment Confirmed By Gateway"));
                        if($serviceid>0 && $transid) UpdateServerInfo(["sub_scription_id"=>$transid],$serviceid);
                        if($payment_added['status'] != 'success') return '<div class="alert alert-danger">Payment Confirmed but Payment entry error...'.$payment_added['message'].'</div>';
                        header("Location: /client/view-invoice/".$cinvoiceid);
                        die();
                    } else {
                        if ($message_type == "RECURRING_INSTALLMENT_FAILED")
                        {
                        $REQUEST["TransStatus"] = "Recurring Failed";
                        AddGatewayLogs(array('invoice_id'=>$cinvoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$_POST,"message"=>"Recurring Failed"));
                        return '<div class="alert alert-danger">Recurring Failed</div>';
                        }
                        else
                        {
                        $REQUEST["TransStatus"] = "Notification Only";
                        AddGatewayLogs(array('invoice_id'=>$cinvoiceid,'user_id'=>$user_id,'payment_method'=>$payment_method,'response'=>$_POST,"message"=>"Notification Only"));
                        return '<div class="alert alert-danger">Recurring Failed:Notification Only</div>';
                        }
                    }
                }
            }
        }
}
