<?php
if (!defined("WHMSOLS")){
    die("This file cannot be accessed directly");
}

use WHMSOLS\Module\Registrar\AffordableDomains\ApiClient;

require_once __DIR__ . '/lib/ApiClient.php';

 function affordabledomains_getConfig()
 {
       return array(
        "name"=>"Affordable Domains",
        "description"=>"",
        "version"=>"1.8",
        "APIVersion"=>"1.8",
        "author"=>"",
        "author_url"=>"",
        "configs"=>
        [
        'Username' => array(
            "Name"=>"User name",
            'Type' => 'text',
            'Size' => '25',
            'Default' => '',
            'Description' => 'Enter you affordable domains username',
        ),
        'Password' => array(
            "Name"=>"Password",
            'Type' => 'password',
            'Size' => '25',
            'Default' => '',
            'Description' => 'Enter you affordable domains password',
        )
    ]);
}

function affordabledomains_RegisterDomain($params) {
    $userIdentifier = $params['Username'];
    $apiKey = $params['Password'];
    $testMode = $params['TestMode'];
    $sld = $params['sld'];
    $tld = $params['tld'];
    $registrationPeriod = $params['regperiod'];

    $additionalInfo = $params['additionalfields'];

    $nameserver1 = $params['ns1'];
    $nameserver2 = $params['ns2'];
    $nameserver3 = $params['ns3'];
    $nameserver4 = $params['ns4'];
    $nameserver5 = $params['ns5'];

    $firstName = $params["firstname"];
    $lastName = $params["lastname"];
    $fullName = $params["fullname"]; // First name and last name combined
    $companyName = $params["companyname"];
    $email = $params["email"];
    $address1 = $params["address1"];
    $address2 = $params["address2"];
    $city = $params["city"];
    $state = $params["state"]; // eg. TX
    $stateFullName = $params["fullstate"]; // eg. Texas
    $postcode = $params["postcode"]; // Postcode/Zip code
    $countryCode = $params["countrycode"]; // eg. GB
    $countryName = $params["countryname"]; // eg. United Kingdom
    $phoneNumber = $params["phonenumber"]; // Phone number as the user provided it
    $phoneCountryCode = $params["phonecc"]; // Country code determined based on country
    $phoneNumberFormatted = $params["fullphonenumber"]; // Format: +CC.xxxxxxxxxxxx

    $adminFirstName = $params["adminfirstname"];
    $adminLastName = $params["adminlastname"];
    $adminFullName = $adminFirstName . " " . $adminLastName;
    $adminCompanyName = $params["admincompanyname"];
    $adminEmail = $params["adminemail"];
    $adminAddress1 = $params["adminaddress1"];
    $adminAddress2 = $params["adminaddress2"];
    $adminCity = $params["admincity"];
    $adminState = $params["adminstate"]; // eg. TX
    $adminStateFull = $params["adminfullstate"]; // eg. Texas
    $adminPostcode = $params["adminpostcode"]; // Postcode/Zip code
    $adminCountry = $params["admincountry"]; // eg. GB
    $adminPhoneNumber = $params["adminphonenumber"]; // Phone number as the user provided it
    $adminPhoneNumberFormatted = $params["adminfullphonenumber"]; // Format: +CC.xxxxxxxxxxxx
    // domain addon purchase status
//    $enableDnsManagement = (bool) $params['dnsmanagement'];
//    $enableEmailForwarding = (bool) $params['emailforwarding'];
    $enableIdProtection = (bool) $params['idprotection'];

    $postfields = array(
        'username' => $userIdentifier,
        'password' => $apiKey,
        'testmode' => 'no',
        'domain' => $sld . '.' . $tld,
        'domainDetails' => array(
            'years' => $registrationPeriod,
            'nameservers' => array(
                'ns1' => $nameserver1,
                'ns2' => $nameserver2,
                'ns3' => $nameserver3,
                'ns4' => $nameserver4,
                'ns5' => $nameserver5,
            ),
            'contacts' => array(
                'registrant' => array(
                    //'firstname' => ($companyName ? $companyFirstname : $firstName),
                    //'lastname' => ($companyName ? $companyLastname : $lastName),
                    'name' => $fullName,
                    'company' => $companyName,
                    'email' => $email,
                    'address1' => $address1,
                    'address2' => $address2,
                    'city' => $city,
                    'state' => $state,
                    'postcode' => $postcode,
                    'country' => $countryCode,
                    'phone' => $phoneNumberFormatted,
                ),
                'tech' => array(
                    //'firstname' => $adminFirstName,
                    //'lastname' => $adminLastName,
                    'name' => $adminFullName,
                    'company' => $adminCompanyName,
                    'email' => $adminEmail,
                    'address1' => $adminAddress1,
                    'address2' => $adminAddress2,
                    'city' => $adminCity,
                    'state' => $adminState,
                    'postcode' => $adminPostcode,
                    'country' => $adminCountry,
                    'phone' => $adminPhoneNumberFormatted,
                ),
                'admin' => array(
                    //'firstname' => $adminFirstName,
                    //'lastname' => $adminLastName,
                    'name' => $adminFullName,
                    'company' => $adminCompanyName,
                    'email' => $adminEmail,
                    'address1' => $adminAddress1,
                    'address2' => $adminAddress2,
                    'city' => $adminCity,
                    'state' => $adminState,
                    'postcode' => $adminPostcode,
                    'country' => $adminCountry,
                    'phone' => $adminPhoneNumberFormatted,
                )
            ),
            'idProtection' => $enableIdProtection,
            'additionalFields' => $additionalInfo
        //'dnsmanagement' => $enableDnsManagement,
        //'emailforwarding' => $enableEmailForwarding
        ),
    );
    try {
        $api = new ApiClient();
        $api->call('Register', $postfields);

        return array(
            'success' => true,
        );
    } catch (\Exception $e) {
        return array(
            'error' => $e->getMessage(),
        );
    }
}

function affordabledomains_TransferDomain($params) {
    $userIdentifier = $params['Username'];
    $apiKey = $params['Password'];
    $testMode = $params['TestMode'];

    $sld = $params['sld'];
    $tld = $params['tld'];
    $registrationPeriod = $params['regperiod'];
    $eppCode = $params['eppcode'];

    $nameserver1 = $params['ns1'];
    $nameserver2 = $params['ns2'];
    $nameserver3 = $params['ns3'];
    $nameserver4 = $params['ns4'];
    $nameserver5 = $params['ns5'];

    $firstName = $params["firstname"];
    $lastName = $params["lastname"];
    $fullName = $params["fullname"]; // First name and last name combined
    $companyName = $params["companyname"];
    $email = $params["email"];
    $address1 = $params["address1"];
    $address2 = $params["address2"];
    $city = $params["city"];
    $state = $params["state"]; // eg. TX
    $stateFullName = $params["fullstate"]; // eg. Texas
    $postcode = $params["postcode"]; // Postcode/Zip code
    $countryCode = $params["countrycode"]; // eg. GB
    $countryName = $params["countryname"]; // eg. United Kingdom
    $phoneNumber = $params["phonenumber"]; // Phone number as the user provided it
    $phoneCountryCode = $params["phonecc"]; // Country code determined based on country
    $phoneNumberFormatted = $params["fullphonenumber"]; // Format: +CC.xxxxxxxxxxxx

    $adminFirstName = $params["adminfirstname"];
    $adminLastName = $params["adminlastname"];
    $adminFullName = $adminFirstName . " " . $adminLastName;
    $adminCompanyName = $params["admincompanyname"];
    $adminEmail = $params["adminemail"];
    $adminAddress1 = $params["adminaddress1"];
    $adminAddress2 = $params["adminaddress2"];
    $adminCity = $params["admincity"];
    $adminState = $params["adminstate"]; // eg. TX
    $adminStateFull = $params["adminfullstate"]; // eg. Texas
    $adminPostcode = $params["adminpostcode"]; // Postcode/Zip code
    $adminCountry = $params["admincountry"]; // eg. GB
    $adminPhoneNumber = $params["adminphonenumber"]; // Phone number as the user provided it
    $adminPhoneNumberFormatted = $params["adminfullphonenumber"]; // Format: +CC.xxxxxxxxxxxx
//    domain addon purchase status
//    $enableDnsManagement = (bool) $params['dnsmanagement'];
//    $enableEmailForwarding = (bool) $params['emailforwarding'];
    $enableIdProtection = (bool) $params['idprotection'];

    $postfields = array(
        'username' => $userIdentifier,
        'password' => $apiKey,
        'testmode' => 'no',
        'domain' => $sld . '.' . $tld,
        'domainDetails' => array(
            'eppcode' => $eppCode,
            'years' => $registrationPeriod,
            'nameservers' => array(
                'ns1' => $nameserver1,
                'ns2' => $nameserver2,
                'ns3' => $nameserver3,
                'ns4' => $nameserver4,
                'ns5' => $nameserver5,
            ),
            'contacts' => array(
                'registrant' => array(
                    //'firstname' => ($companyName ? $companyFirstname : $firstName),
                    //'lastname' => ($companyName ? $companyLastname : $lastName),
                    'name' => $fullName,
                    'company' => $companyName,
                    'email' => $email,
                    'address1' => $address1,
                    'address2' => $address2,
                    'city' => $city,
                    'state' => $state,
                    'postcode' => $postcode,
                    'country' => $countryCode,
                    'phone' => $phoneNumberFormatted,
                ),
                'tech' => array(
                    //'firstname' => $adminFirstName,
                    //'lastname' => $adminLastName,
                    'name' => $adminFullName,
                    'company' => $adminCompanyName,
                    'email' => $adminEmail,
                    'address1' => $adminAddress1,
                    'address2' => $adminAddress2,
                    'city' => $adminCity,
                    'state' => $adminState,
                    'postcode' => $adminPostcode,
                    'country' => $adminCountry,
                    'phone' => $adminPhoneNumberFormatted,
                ),
                'admin' => array(
                    //'firstname' => $adminFirstName,
                    //'lastname' => $adminLastName,
                    'name' => $adminFullName,
                    'company' => $adminCompanyName,
                    'email' => $adminEmail,
                    'address1' => $adminAddress1,
                    'address2' => $adminAddress2,
                    'city' => $adminCity,
                    'state' => $adminState,
                    'postcode' => $adminPostcode,
                    'country' => $adminCountry,
                    'phone' => $adminPhoneNumberFormatted,
                ),
            ),
            'idProtection' => $enableIdProtection
        //'dnsmanagement' => $enableDnsManagement,
        //'emailforwarding' => $enableEmailForwarding
        ),
    );

    try {
        $api = new ApiClient();
        $api->call('Transfer', $postfields);

        return array(
            'success' => true,
        );
    } catch (\Exception $e) {
        return array(
            'error' => $e->getMessage(),
        );
    }
}

function affordabledomains_RenewDomain($params) {
    $userIdentifier = $params['Username'];
    $apiKey = $params['Password'];
    $testMode = $params['TestMode'];

    $sld = $params['sld'];
    $tld = $params['tld'];
    $registrationPeriod = $params['regperiod'];
    $enableIdProtection = (bool) $params['idprotection'];

    $postfields = array(
        'username' => $userIdentifier,
        'password' => $apiKey,
        'testmode' => 'no',
        'domain' => $sld . '.' . $tld,
        'years' => $registrationPeriod,
        'idProtection' => $enableIdProtection,
    );

    try {
        $api = new ApiClient();
        $api->call('Renew', $postfields);

        return array(
            'success' => true,
        );
    } catch (\Exception $e) {
        return array(
            'error' => $e->getMessage(),
        );
    }
}

function affordabledomains_IDProtectToggle($params) {
    $userIdentifier = $params['Username'];
    $apiKey = $params['Password'];
    $testMode = $params['TestMode'];

    $sld = $params['sld'];
    $tld = $params['tld'];

    // id protection parameter
    $protectEnable = (bool) $params['protectenable'];

    $postfields = array(
        'username' => $userIdentifier,
        'password' => $apiKey,
        'testmode' => 'no',
        'domain' => $sld . '.' . $tld,
        'idProtection' => $protectEnable
    );

    // Build post data
    try {
        $api = new ApiClient();
        if ($protectEnable) {
            $api->call('Privacy', $postfields);
        } else {
            $api->call('Privacy', $postfields);
        }
        return array(
            'success' => 'success',
        );
    } catch (\Exception $e) {
        return array(
            'error' => $e->getMessage(),
        );
    }
}

function affordabledomains_GetNameservers($params) {
    $userIdentifier = $params['Username'];
    $apiKey = $params['Password'];
    $testMode = $params['TestMode'];

    $sld = $params['sld'];
    $tld = $params['tld'];

    $postfields = array(
        'username' => $userIdentifier,
        'password' => $apiKey,
        'testmode' => 'no',
        'domain' => $sld . '.' . $tld,
    );

    try {
        $api = new ApiClient();
        $api->call('GetNameservers', $postfields);
        $nameservers = $api->getFromResponse('nameservers');

        return array(
            'success' => true,
            'ns1' => $nameservers['ns1'],
            'ns2' => $nameservers['ns2'],
            'ns3' => $nameservers['ns3'],
            'ns4' => $nameservers['ns4'],
            'ns5' => $nameservers['ns5'],
        );
    } catch (\Exception $e) {
        return array(
            'error' => $e->getMessage(),
        );
    }
}

function affordabledomains_SaveNameservers($params) {
    $userIdentifier = $params['Username'];
    $apiKey = $params['Password'];
    $testMode = $params['TestMode'];

    $sld = $params['sld'];
    $tld = $params['tld'];

    $nameserver1 = $params['ns1'];
    $nameserver2 = $params['ns2'];
    $nameserver3 = $params['ns3'];
    $nameserver4 = $params['ns4'];
    $nameserver5 = $params['ns5'];

    $postfields = array(
        'username' => $userIdentifier,
        'password' => $apiKey,
        'testmode' => 'no',
        'domain' => $sld . '.' . $tld,
        'nameservers' => array(
            $nameserver1,
            $nameserver2,
            $nameserver3,
            $nameserver4,
            $nameserver5
        )
    );

    try {
        $api = new ApiClient();
        $api->call('SetNameservers', $postfields);

        return array(
            'success' => true,
        );
    } catch (\Exception $e) {
        return array(
            'error' => $e->getMessage(),
        );
    }
}

function affordabledomains_ParseContactDetails($api) {
    $registrant = $api->getFromResponse('registrant');
    $technical = $api->getFromResponse('tech');
    $billing = $api->getFromResponse('billing');
    $admin = $api->getFromResponse('admin');

    $return = array();

    if ($registrant) {
        $return['Registrant'] = array(
            //'First Name' => $registrant['firstname'],
            //'Last Name' => $registrant['lastname'],
            'Name' => $registrant['name'],
            'Company Name' => $registrant['company'],
            'Email Address' => $registrant['email'],
            'Address 1' => $registrant['address1'],
            'Address 2' => $registrant['address2'],
            'City' => $registrant['city'],
            'State' => $registrant['state'],
            'Postcode' => $registrant['postcode'],
            'Country' => $registrant['country'],
            'Phone Number' => $registrant['phone'],
            'Fax Number' => $registrant['fax'],
        );
    }

    if ($technical) {
        $return['Technical'] = array(
            //'First Name' => $technical['firstname'],
            //'Last Name' => $technical['lastname'],
            'Name' => $technical['name'],
            'Company Name' => $technical['company'],
            'Email Address' => $technical['email'],
            'Address 1' => $technical['address1'],
            'Address 2' => $technical['address2'],
            'City' => $technical['city'],
            'State' => $technical['state'],
            'Postcode' => $technical['postcode'],
            'Country' => $technical['country'],
            'Phone Number' => $technical['phone'],
            'Fax Number' => $technical['fax'],
        );
    }

    if ($billing) {
        $return['Billing'] = array(
            //'First Name' => $billing['firstname'],
            //'Last Name' => $billing['lastname'],
            'Name' => $billing['name'],
            'Company Name' => $billing['company'],
            'Email Address' => $billing['email'],
            'Address 1' => $billing['address1'],
            'Address 2' => $billing['address2'],
            'City' => $billing['city'],
            'State' => $billing['state'],
            'Postcode' => $billing['postcode'],
            'Country' => $billing['country'],
            'Phone Number' => $billing['phone'],
            'Fax Number' => $billing['fax'],
        );
    }
    if ($admin) {
        $return['Admin'] = array(
            //'First Name' => $admin['firstname'],
            //'Last Name' => $admin['lastname'],
            'Name' => $admin['name'],
            'Company Name' => $admin['company'],
            'Email Address' => $admin['email'],
            'Address 1' => $admin['address1'],
            'Address 2' => $admin['address2'],
            'City' => $admin['city'],
            'State' => $admin['state'],
            'Postcode' => $admin['postcode'],
            'Country' => $admin['country'],
            'Phone Number' => $admin['phone'],
            'Fax Number' => $admin['fax'],
        );
    }
    return $return;
}

function affordabledomains_GetContactDetails($params) {
    $userIdentifier = $params['Username'];
    $apiKey = $params['Password'];
    $testMode = $params['TestMode'];

    $sld = $params['sld'];
    $tld = $params['tld'];

    $postfields = array(
        'username' => $userIdentifier,
        'password' => $apiKey,
        'testmode' => 'no',
        'domain' => $sld . '.' . $tld,
    );
    $api = new ApiClient();
    try {
        $api->call('GetContactDetails', $postfields);
        $return = affordabledomains_ParseContactDetails($api);

        return $return;
    } catch (\Exception $e) {
        $return = [];

        if ($e->getCode() == ApiClient::ERROR_CODES['info']) {
            session_start();
            $_SESSION['ADJS'] = "<script>" . "\n"
                    . "    $(document).ready(function (){"
                    . "        $('<div class=\"infobox\"><strong><span class=\"title\">Registrant Contact Update Pending</span></strong><br>{$e->getMessage()}</div>').insertBefore($('form').find('table').next())"
                    . "    })" . "\n"
                    . "</script>";
            $return = affordabledomains_ParseContactDetails($api);
        } elseif ($e->getCode() == ApiClient::ERROR_CODES['error']) {
            $return = array(
                'error' => $e->getMessage(),
            );
        }

        return $return;
    }
}

function affordabledomains_SaveContactDetails($params) {
    $userIdentifier = $params['Username'];
    $apiKey = $params['Password'];
    $testMode = $params['TestMode'];

    $sld = $params['sld'];
    $tld = $params['tld'];

    $contactDetails = $params['contactdetails'];

    $postfields = array(
        'username' => $userIdentifier,
        'password' => $apiKey,
        'testmode' => 'no',
        'domain' => $sld . '.' . $tld,
        'contacts' => array(
            'registrant' => array(
                //'firstname' => $contactDetails['Registrant']['First Name'],
                //'lastname' => $contactDetails['Registrant']['Last Name'],
                'name' => (isset($contactDetails['Registrant']['Name']) ? $contactDetails['Registrant']['Name'] : ($contactDetails['Registrant']['First Name'] . ' '. $contactDetails['Registrant']['Last Name'])),
                'company' => $contactDetails['Registrant']['Company Name'],
                'email' => $contactDetails['Registrant']['Email Address'],
                'address1' => $contactDetails['Registrant']['Address 1'],
                'address2' => $contactDetails['Registrant']['Address 2'],
                'city' => $contactDetails['Registrant']['City'],
                'state' => $contactDetails['Registrant']['State'],
                'postcode' => $contactDetails['Registrant']['Postcode'],
                'country' => $contactDetails['Registrant']['Country'],
                'phone' => $contactDetails['Registrant']['Phone Number'],
                'fax' => $contactDetails['Registrant']['Fax Number'],
            ),
            'tech' => array(
                //'firstname' => $contactDetails['Technical']['First Name'],
                //'lastname' => $contactDetails['Technical']['Last Name'],
                'name' => (isset($contactDetails['Technical']['Name']) ? $contactDetails['Technical']['Name'] : ($contactDetails['Technical']['First Name'] . ' '. $contactDetails['Technical']['Last Name'])),
                'company' => $contactDetails['Technical']['Company Name'],
                'email' => $contactDetails['Technical']['Email Address'],
                'address1' => $contactDetails['Technical']['Address 1'],
                'address2' => $contactDetails['Technical']['Address 2'],
                'city' => $contactDetails['Technical']['City'],
                'state' => $contactDetails['Technical']['State'],
                'postcode' => $contactDetails['Technical']['Postcode'],
                'country' => $contactDetails['Technical']['Country'],
                'phone' => $contactDetails['Technical']['Phone Number'],
                'fax' => $contactDetails['Technical']['Fax Number'],
            ),
            'admin' => array(
                //'firstname' => $contactDetails['Admin']['First Name'],
                //'lastname' => $contactDetails['Admin']['Last Name'],
                'name' => (isset($contactDetails['Admin']['Name']) ? $contactDetails['Admin']['Name'] : ($contactDetails['Admin']['First Name'] . ' '. $contactDetails['Admin']['Last Name'])),
                'company' => $contactDetails['Admin']['Company Name'],
                'email' => $contactDetails['Admin']['Email Address'],
                'address1' => $contactDetails['Admin']['Address 1'],
                'address2' => $contactDetails['Admin']['Address 2'],
                'city' => $contactDetails['Admin']['City'],
                'state' => $contactDetails['Admin']['State'],
                'postcode' => $contactDetails['Admin']['Postcode'],
                'country' => $contactDetails['Admin']['Country'],
                'phone' => $contactDetails['Admin']['Phone Number'],
                'fax' => $contactDetails['Admin']['Fax Number'],
            )
        )
    );

    if (isset($contactDetails['Billing'])) {
        $postfields['contacts']['billing'] = array(
            //'firstname' => $contactDetails['Billing']['First Name'],
            //'lastname' => $contactDetails['Billing']['Last Name'],
            'name' => (isset($contactDetails['Billing']['Name']) ? $contactDetails['Billing']['Name'] : ($contactDetails['Billing']['First Name'] . ' '. $contactDetails['Billing']['Last Name'])),
            'company' => $contactDetails['Billing']['Company Name'],
            'email' => $contactDetails['Billing']['Email Address'],
            'address1' => $contactDetails['Billing']['Address 1'],
            'address2' => $contactDetails['Billing']['Address 2'],
            'city' => $contactDetails['Billing']['City'],
            'state' => $contactDetails['Billing']['State'],
            'postcode' => $contactDetails['Billing']['Postcode'],
            'country' => $contactDetails['Billing']['Country'],
            'phone' => $contactDetails['Billing']['Phone Number'],
            'fax' => $contactDetails['Billing']['Fax Number'],
        );
    }

    try {
        $api = new ApiClient();
        $api->call('SetContactDetails', $postfields);

        return array(
            'success' => true,
        );
    } catch (\Exception $e) {
        $return = [];
        if ($e->getCode() == ApiClient::ERROR_CODES['info']) {
            session_start();
            $_SESSION['ADJS'] = "<script>" . "\n"
                    . "    $(document).ready(function (){"
                    . "        $('<div class=\"infobox\"><strong><span class=\"title\">Registrant Contact Update Pending</span></strong><br>{$e->getMessage()}</div>').insertBefore($('form').find('table').next())"
                    . "    })" . "\n"
                    . "</script>";
            $return = array(
                'success' => true,
            );
        } elseif ($e->getCode() == ApiClient::ERROR_CODES['error']) {
            $return = array(
                'error' => $e->getMessage(),
            );
        }

        return $return;
    }
}

function affordabledomains_GetRegistrarLock($params) {
    $userIdentifier = $params['Username'];
    $apiKey = $params['Password'];
    $testMode = $params['TestMode'];

    $sld = $params['sld'];
    $tld = $params['tld'];

    $postfields = array(
        'username' => $userIdentifier,
        'password' => $apiKey,
        'testmode' => 'no',
        'domain' => $sld . '.' . $tld,
    );

    try {
        $api = new ApiClient();
        $api->call('GetLockStatus', $postfields);

        if ($api->getFromResponse('lockstatus') == 'locked') {
            return 'locked';
        } else {
            return 'unlocked';
        }
    } catch (\Exception $e) {
        return array(
            'error' => $e->getMessage(),
        );
    }
}

function affordabledomains_SaveRegistrarLock($params) {
    $userIdentifier = $params['Username'];
    $apiKey = $params['Password'];
    $testMode = $params['TestMode'];

    $sld = $params['sld'];
    $tld = $params['tld'];

    $lockStatus = $params['lockenabled'];

    $postfields = array(
        'username' => $userIdentifier,
        'password' => $apiKey,
        'testmode' => 'no',
        'domain' => $sld . '.' . $tld,
        'registrarlock' => ($lockStatus == 'locked' ? 1 : 0),
    );

    try {
        $api = new ApiClient();
        $api->call('SetLockStatus', $postfields);

        return array(
            'success' => 'success',
        );
    } catch (\Exception $e) {
        return array(
            'error' => $e->getMessage(),
        );
    }
}

function affordabledomains_GetEPPCode($params) {
    $userIdentifier = $params['Username'];
    $apiKey = $params['Password'];
    $testMode = $params['TestMode'];

    $sld = $params['sld'];
    $tld = $params['tld'];

    $postfields = array(
        'username' => $userIdentifier,
        'password' => $apiKey,
        'testmode' => 'no',
        'domain' => $sld . '.' . $tld,
    );

    try {
        $api = new ApiClient();
        $api->call('RequestEPPCode', $postfields);
        if ($api->getFromResponse('eppcode')) {
            return array(
                'eppcode' => $api->getFromResponse('eppcode'),
            );
        } else {
            return array(
                'success' => 'success',
            );
        }
    } catch (\Exception $e) {
        return array(
            'error' => $e->getMessage(),
        );
    }
}

function affordabledomains_RequestDelete($params) {
    $userIdentifier = $params['Username'];
    $apiKey = $params['Password'];
    $testMode = $params['TestMode'];

    $sld = $params['sld'];
    $tld = $params['tld'];

    $postfields = array(
        'username' => $userIdentifier,
        'password' => $apiKey,
        'testmode' => 'no',
        'domain' => $sld . '.' . $tld,
    );

    try {
        $api = new ApiClient();
        $api->call('Delete', $postfields);

        return array(
            'success' => 'success',
        );
    } catch (\Exception $e) {
        return array(
            'error' => $e->getMessage(),
        );
    }
}

function affordabledomains_Sync($params) {
    $userIdentifier = $params['Username'];
    $apiKey = $params['Password'];
    $testMode = $params['TestMode'];

    $sld = $params['sld'];
    $tld = $params['tld'];

    $postfields = array(
        'username' => $userIdentifier,
        'password' => $apiKey,
        'testmode' => 'no',
        'domain' => $sld . '.' . $tld,
        'type' => 'sync'
    );

    try {
        $api = new ApiClient();
        $api->call('DomainSync', $postfields);

        return array(
            'expirydate' => $api->getFromResponse('expirydate'),
            'active' => (bool) $api->getFromResponse('active'),
            'expired' => (bool) $api->getFromResponse('expired'),
            'transferredAway' => (bool) $api->getFromResponse('transferredaway'),
        );
    } catch (\Exception $e) {
        return array(
            'error' => $e->getMessage(),
        );
    }
}

function affordabledomains_TransferSync($params) {
    $userIdentifier = $params['Username'];
    $apiKey = $params['Password'];
    $testMode = $params['TestMode'];

    $sld = $params['sld'];
    $tld = $params['tld'];

    $postfields = array(
        'username' => $userIdentifier,
        'password' => $apiKey,
        'testmode' => 'no',
        'domain' => $sld . '.' . $tld,
        'type' => 'transferSync'
    );

    try {
        $api = new ApiClient();
        $api->call('DomainSync', $postfields);

        if ($api->getFromResponse('transfercomplete')) {
            return array(
                'completed' => true,
                'expirydate' => $api->getFromResponse('expirydate'), // Format: YYYY-MM-DD
            );
        } elseif ($api->getFromResponse('transferfailed')) {
            return array(
                'failed' => true,
                'reason' => $api->getFromResponse('failurereason'), // Reason for the transfer failure if available
            );
        } else {
            return array();
        }
    } catch (\Exception $e) {
        return array(
            'error' => $e->getMessage(),
        );
    }
}

/**
 * Get DNS Records for DNS Host Record Management.
 *
 * @param array $params common module parameters
 *
 * @see https://whmsols.com/developers/guide/257-Module-Parameters
 *
 * @return array DNS Host Records
 */
function affordabledomains_GetDNS($params) {
    // user defined configuration values
    $userIdentifier = $params['Username'];
    $apiKey = $params['Password'];
    $testMode = $params['TestMode'];

    $sld = $params['sld'];
    $tld = $params['tld'];

    $postfields = array(
        'username' => $userIdentifier,
        'password' => $apiKey,
        'testmode' => 'no',
        'domain' => $sld . '.' . $tld,
    );

    try {

        $api = new ApiClient();
        $api->call('GetDNSRecords', $postfields);
        $hostRecords = array();
        foreach ($api->getFromResponse('dnsRecords') as $record) {
            if ($record['type'] != 'SOA' && $record['type'] != 'NS')
                $hostRecords[] = array(
                    "hostname" => $record['name'], // eg. www
                    "type" => $record['type'], // eg. A
                    "address" => $record['content'], // eg. 10.0.0.1
                    "priority" => $record['prio'], // eg. 10 (N/A for non-MX records)
                    "recid" => $record['id'],
                );
        }
        $api = new ApiClient();
        $api->call('GetRedirects', $postfields);
        foreach ($api->getFromResponse('redirects') as $record) {
            if ($record['uri'] == '') {
                $hostRecords[] = array(
                    "hostname" => $record['from'], // eg. www
                    "type" => 'URL', // eg. A
                    "address" => $record['to'], // eg. 10.0.0.1
                    "recid" => $record['id'],
                );
            } else {
                $hostRecords[] = array(
                    "hostname" => $record['from'], // eg. www
                    "type" => 'FRAME', // eg. A
                    "address" => $record['to'] . $record['uri'], // eg. 10.0.0.1
                    "recid" => $record['id'],
                );
            }
        }
        return $hostRecords;
    } catch (\Exception $e) {
        return array(
            'error' => $e->getMessage(),
        );
    }
}

/**
 * Update DNS Host Records.
 *
 * @param array $params common module parameters
 *
 * @see https://whmsols.com/developers/guide/257-Module-Parameters
 *
 * @return array
 */
function affordabledomains_SaveDNS($params) {
    // user defined configuration values
    $userIdentifier = $params['Username'];
    $apiKey = $params['Password'];
    $testMode = $params['TestMode'];

    $sld = $params['sld'];
    $tld = $params['tld'];
    // dns record parameters
    $dnsrecords = $params['dnsrecords'];

    $redirects = $records = [];
    foreach ($dnsrecords as $record) {
        if ($record['type'] == 'URL' || $record['type'] == 'FRAME') {
            $to = explode('/', trim($record['address'], '/'), 2);

            $redirects[] = [
                'from' => ($record['hostname'] ? "{$record['hostname']}." : '') . $sld . '.' . $tld,
                'to' => $to[0],
                'uri' => (isset($to[1]) ? "/{$to[1]}" : ''),
                'id' => $record['recid']
            ];
        } else {
            $records[] = [
                'type' => ($record['type'] == 'MXE' ? 'MX' : $record['type']),
                'name' => $record['hostname'],
                'content' => $record['address'],
                'prio' => $record['priority'],
                'id' => $record['recid'],
            ];
        }
    }
    $api = new ApiClient();

    $postfields = [
        'username' => $userIdentifier,
        'password' => $apiKey,
        'testmode' => 'no',
        'domain' => $sld . '.' . $tld,
    ];

    if (count($records) > 0) {
        $postfieldsDNS = array_merge($postfields, ['dnsrecords' => $records]);
        try {
            $api->call('SaveDNSRecord', $postfieldsDNS);
        } catch (\Exception $e) {
            $errors[] = $e->getMessage();
        }
    }

    if (count($redirects) > 0) {
        $postfieldsRedirects = array_merge($postfields, ['redirects' => $redirects]);
        try {
            $api->call('SaveRedirects', $postfieldsRedirects);
        } catch (\Exception $e) {
            $errors[] = $e->getMessage();
        }
    }

    if (count($errors) > 0) {
        return array(
            'error' => implode("\n", $errors),
        );
    } else {
        return array(
            'success' => 'success',
        );
    }
}

function affordabledomains_RegisterNameserver($params) {
    // user defined configuration values
    $userIdentifier = $params['Username'];
    $apiKey = $params['Password'];
    $testMode = $params['TestMode'];

    // domain parameters
    $sld = $params['sld'];
    $tld = $params['tld'];

    // nameserver parameters
    $nameserver = $params['nameserver'];
    $ipAddress = $params['ipaddress'];

    // Build post data
    $postfields = array(
        'username' => $userIdentifier,
        'password' => $apiKey,
        'testmode' => 'no',
        'domain' => $sld . '.' . $tld,
        'nameserver' => $nameserver,
        'ipaddress' => $ipAddress,
    );
    try {
        $api = new ApiClient();
        $api->call('RegisterNameserver', $postfields);
        return array(
            'success' => 'success',
        );
    } catch (\Exception $e) {
        return array(
            'error' => $e->getMessage(),
        );
    }
}

/**
 * Modify a Nameserver.
 *
 * Modifies the IP of a child nameserver.
 *
 * @param array $params common module parameters
 *
 * @see https://whmsols.com/developers/guide/257-Module-Parameters
 *
 * @return array
 */
function affordabledomains_ModifyNameserver($params) {
    // user defined configuration values
    $userIdentifier = $params['Username'];
    $apiKey = $params['Password'];
    $testMode = $params['TestMode'];

    // domain parameters
    $sld = $params['sld'];
    $tld = $params['tld'];

    // nameserver parameters
    $nameserver = $params['nameserver'];
    $currentIpAddress = $params['currentipaddress'];
    $newIpAddress = $params['newipaddress'];

    // Build post data
    $postfields = array(
        'username' => $userIdentifier,
        'password' => $apiKey,
        'testmode' => 'no',
        'domain' => $sld . '.' . $tld,
        'nameserver' => $nameserver,
        'currentip' => $currentIpAddress,
        'newip' => $newIpAddress,
    );
    try {
        $api = new ApiClient();
        $api->call('ModifyNameserver', $postfields);

        return array(
            'success' => 'success',
        );
    } catch (\Exception $e) {
        return array(
            'error' => $e->getMessage(),
        );
    }
}

/**
 * Delete a Nameserver.
 *
 * @param array $params common module parameters
 *
 * @see https://whmsols.com/developers/guide/257-Module-Parameters
 *
 * @return array
 */
function affordabledomains_DeleteNameserver($params) {
    // user defined configuration values
    $userIdentifier = $params['Username'];
    $apiKey = $params['Password'];
    $testMode = $params['TestMode'];

    // domain parameters
    $sld = $params['sld'];
    $tld = $params['tld'];

    // nameserver parameters
    $nameserver = $params['nameserver'];

    // Build post data
    $postfields = array(
        'username' => $userIdentifier,
        'password' => $apiKey,
        'testmode' => 'no',
        'domain' => $sld . '.' . $tld,
        'nameserver' => $nameserver,
    );
    try {
        $api = new ApiClient();
        $api->call('DeleteNameserver', $postfields);

        return array(
            'success' => 'success',
        );
    } catch (\Exception $e) {
        return array(
            'error' => $e->getMessage(),
        );
    }
}
