<?php
namespace WHMSOLS\Module\Registrar\AffordableDomains;
class ApiClient {

    const API_URL = 'https://reseller.affordabledomains.co.nz/api/new/whmcs/';
    const API_SANDBOX_URL = 'https://sandbox.affordabledomains.co.nz/api/new/whmcs/';
    
    const ERROR_CODES = [
        'success' => 200,
        'error' => 500,
        'info' => 201,
        'warning' => 403
    ];

    protected $results = array();

    public function call($action, $postfields) {
        if ($postfields['testmode'] == 'yes') {
            $url = self::API_SANDBOX_URL;
        } else {
            $url = self::API_URL;
        }

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url . $action);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($postfields));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($ch, CURLOPT_TIMEOUT, 100);
        $response = curl_exec($ch);
        if (curl_errno($ch)) {
            throw new \Exception('Connection Error: ' . curl_errno($ch) . ' - ' . curl_error($ch));
        }
        curl_close($ch);
        $this->results = $this->processResponse($response);

        logModuleCall(
                'AffordableDomains', $action, $postfields, $response, $this->results, array(
            $postfields['username'],
            $postfields['password'],
                )
        );

        if (!$this->results || $this->results === null || json_last_error() !== JSON_ERROR_NONE) {
            throw new \Exception('Bad response received from API');
        }
        
        $status = $this->getFromResponse('status');
        $status2 = ($this->getFromResponse('status2') ? $this->getFromResponse('status2') : 'success');       
        
        if ($status2 != 'success' || $status != 'success') {
            $errCode = ($status2 ? $status2 : $status);            
            throw new \Exception($this->getFromResponse('statusMsg'), (array_key_exists($errCode, self::ERROR_CODES) ? self::ERROR_CODES[$errCode] : 0));
        }

        return 'success';
    }

    public function processResponse($response) {
        return json_decode($response, true);
    }

    public function getFromResponse($key) {
        return (isset($this->results[$key]) ? $this->results[$key] : '');
    }

}
