<?php
function tododomain_getConfig()
{
    return [
        "name"=>"ToDo Notifications",
        "description"=>"This module can be used for any TLDs that have no integrated registrar",
        "version"=>"1.0",
        "author"=>"whmsols",
        "author_url"=>"https//:docs.whmsols.com/TodoDomain",
        "configs"=>[]
    ];
}
function tododomain_todo($params,$title="",$message="")
{
    $ws =& get_instance();
    $domain = $params["domainname"];
    $userid = $params["userid"];
    $domainid = $params["domainid"];
    $message .="<a href=\"/admin/client-domains/".$userid."/".$domainid."\"  target=\"_blank\">View Domain Info</a>"; 
    return $ws->Todo->TodoAddEdit(["title"=>$title,"priority"=>"High","status"=>1,"note"=>$message,"my_notes"=>"No","myday"=>"Yes","important"=>"Yes","email_notification"=>"NO"]);
}
function tododomain_GetNameservers($params)
{
    return ['status'=>'success',
        'response'=>[        
        "ns1"=>'',
        "ns2"=>'',
        "ns3"=>'',
        "ns4"=>'',
        "ns5"=>'',
        ]];
}
/**
 * Sends the passed nameservers to the defined email address
 * @param array $params The built array of data to save the nameservers
 */
function tododomain_SaveNameservers($params)
{
    $domain = $params["domainname"];
    $userid = $params["userid"];
    $domainid = $params["domainid"];
    $command = "Nameservers Changes Request for ".$domain;
    $message = 'Domain: '.$params["domainname"].'<br>Nameserver 1: '.$params["ns1"].'<br>Nameserver 2: '.$params["ns2"].'<br>Nameserver 3: '.$params["ns3"].'<br>Nameserver 4: '.$params["ns4"].'<br>Nameserver 5: '.$params["ns5"];
    return tododomain_todo($params,$command,$message);
}
function tododomain_RegisterDomain($params)
{
    $domain = $params["domainname"];
    $userid = $params["userid"];
    $domainid = $params["domainid"];
    $command = "Domain Created with Name:".$domain;
    $message = "Domain: " . $params["sld"] . "." . $params["tld"] . "<br>Registration Period: " . $params["regperiod"] . "<br>Nameserver 1: " . $params["ns1"] . "<br>Nameserver 2: " . $params["ns2"] . "<br>Nameserver 3: " . $params["ns3"] . "<br>Nameserver 4: " . $params["ns4"] . "<br>First Name: " . $params["firstname"] . "<br>Last Name: " . $params["lastname"] . "<br>Organization: " . $params["companyname"] . "<br>Address1: " . $params["address1"] . "<br>City: " . $params["city"] . "<br>State: " . $params["state"] . "<br>Country: " . $params["country"] . "<br>PostalCode: " . $params["postcode"] . "<br>Phone: " . $params["phonenumber"] . "<br>Email: " . $params["email"];
    return tododomain_todo($params,$command,$message);
}
function tododomain_TransferDomain($params)
{
    $domain = $params["domainname"];
    $command = "Transfer Domain Request ".$domain;
    $message = "Domain: ".$domain. "<br>Registration Period: " . $params["regperiod"] . "<br>Transfer Secret: " . $params["transfersecret"] . "<br>RegistrantFirstName: " . $params["firstname"] . "<br>RegistrantLastName: " . $params["lastname"] . "<br>RegistrantOrganizationName: " . $params["companyname"] . "<br>RegistrantAddress1: " . $params["address1"] . "<br>RegistrantAddress2: " . $params["address2"] . "<br>RegistrantCity: " . $params["city"] . "<br>RegistrantStateProvince: " . $params["state"] . "<br>RegistrantCountry: " . $params["country"] . "<br>RegistrantPostalCode: " . $params["postcode"] . "<br>RegistrantPhone: " . $params["phonenumber"] . "<br>RegistrantEmailAddress: " . $params["email"] . "";
    return tododomain_todo($params,$command,$message);
}
function tododomain_RenewDomain($params)
{
    $domain = $params["domainname"];
    $command = "Renew Domain Request ".$domain;
    $message = "Domain: " . $domain . "<br>Registration Period: " . $params["regperiod"];
    return tododomain_todo($params,$command,$message);
}