<?php
    function AffiliatesOverview_Config()
    {
    	return [
            'title'=>'Affiliates Overview',
            'description'=>'An overview of affiliates for the current year',
            'icon'=>'',
            'parent'=>'Reports',
            'slug'=>'',//Url if required
            'order'=>1,//Order By in numeric
            'ajax'=>false,
            'configs'=>
            [
                'table'=>true,
                'id'=>"",
                'class'=>"",
                'pagination'=>true,
                'filters'=>true
            ]
        ];
    }
    function AffiliatesOverview_Content($arg=[])
    {
        $Array = [];
		$results = full_query("select a.*,concat(c.first_name,' ',c.last_name)  as user_name,c.currency from wsam_affiliates_acct a join clients c on c.id=a.user_id where year(a.entry_date) = year(curdate())");
		$TableHeader = ["Sr#","Affiliate ID","Affiliate Name","Visitors","Last Reffer Date","Pending Commissions","Available to Withdraw","Withdrawn Amount","Last Withdrawn Date"];
		$TableBody = [];
        $i=0;
        foreach ($results as $result)
        {
        	$i++;
            $baseCurrency = getBaseCurrency(['id'=>$result->currency]);
            $bsp = $baseCurrency->symbol_position;
            $bsb = $baseCurrency->symbol;    	
            $bsc = $baseCurrency->code;    	
    
            $balance = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$result->balance,'c'=>$bsc]);
            $withdraw_inrequest = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$result->withdraw_inrequest,'c'=>$bsc]);
            $withdrawn = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$result->withdrawn,'c'=>$bsc]);
    
            $last_reffer_date = ConvertDateToFormat(['date'=>$result->last_reffer_date]);
            $last_withdraw_date = ConvertDateToFormat(['date'=>$result->last_withdraw_date]);
		    $TableBody[] =[$i,$result->affiliate_key,$result->user_name,$result->reffers,$last_reffer_date,$withdraw_inrequest,$balance,$withdrawn,$last_withdraw_date];
    	}
    	return [
    	    "filters"=>"",
    	    "header"=>$TableHeader,
    	    "body"=>$TableBody,
    	   ];
    }