<?php
    function AgingInvoices_Config()
    {
    	$Year = @$_GET["year"];
    	if(empty($Year)) $Year = date('Y');
    	return [
            'title'=>'Aging Invoices',
            'description'=>"A summary of outstanding invoices broken down into the period of which they are overdue",
            'icon'=>'',
            'parent'=>'Reports',
            'slug'=>'',//Url if required
            'order'=>1,//Order By in numeric
            'ajax'=>false,
            'configs'=>
            [
                'table'=>false,
                'id'=>"",
                'class'=>"",
                'pagination'=>true,
                'filters'=>true
            ]
        ];
    }
    function AgingInvoices_Content($arg=[])
    {

    $baseCurrency = getBaseCurrency(['id'=>0]);
    $bsp = $baseCurrency->symbol_position;
    $bsb = $baseCurrency->symbol;    	
    $bsc = $baseCurrency->code;                      

    $totals = [];
    $chartdata = [];
    $rowdata = [];
    $i=0;
    for ( $day = 0; $day < 120; $day += 30)
    {
        $i++;
        $startdate = date("Y-m-d",mktime(0, 0, 0, date("m"), (date("d") - $day), date("Y")));
        $enddate = date("Y-m-d",mktime(0, 0, 0, date("m"), (date("d") - ($day + 30)), date("Y")));
        $rowdata[$i] = "{$day} - " . ($day + 30);
        $sql = "select sum((sale_amount-paid_amount)/base_conv_rate) as amounts from invoices where status in (2,7,8) and due_date>='".$enddate."' and due_date<='".$startdate."' ";
        $sumValue = full_query($sql);
        $totals[$i] = 0;
        if(!empty($sumValue)) $totals[$i] = $sumValue[0]->amounts;
        $amount = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$totals[$i],'c'=>""]);
        $chartdata['rows'][] = [
            'c' => [
                ['v' => $rowdata[$i]],
                [
                    'v' => (int)$totals[$i],
                    'f' => $amount,
                ],
            ]
        ];
    }
    $i++;
    $rowdata[$i] = "120+";
    $sql = "select sum((sale_amount-paid_amount)/base_conv_rate) as amounts from invoices where status in (2,7,8) and due_date>'".$startdate."'";
    $sumValue = full_query($sql);
    $totals[$i] = 0;
    if(!empty($sumValue)) $totals[$i] = $sumValue[0]->amounts;
    $amount = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$totals[$i],'c'=>""]);
    $chartdata['rows'][] = [
        'c' => [
            ['v' => $rowdata[$i]],
            [
                'v' => (int)$totals[$i],
                'f' => $amount,
            ],
        ]
    ];
    $html ="";
    $chartdata = json_encode($chartdata['rows']);
    $html .='<div class="col-md-8">
    <script type="text/javascript">google.charts.load("current",{packages:["corechart"]});google.charts.setOnLoadCallback(PieCharts);
    function PieCharts(){
        var jsonData=\'{"rows":'.$chartdata.',"cols":[{"label":"Days Range","type":"string"},{"label":"Value","type":"number"}]}\';
    var data=new google.visualization.DataTable(jsonData);
    var options={legend:{position:"right"}};
    var chart=new google.visualization.PieChart(document.getElementById("PieCharts"));
    chart.draw(data,options);}</script>
<div id="PieCharts" style="width:100%;height:300px;"></div>
    </div>
    <div class="col-md-4">
    <table class="table table-border text-center">
    		<thead>
    			<tr class="customTableTh">
    				<th rowspan="2">Period</th>
    				<th rowspan="2">Amount</th>
    			</tr>
    		</thead>
    		<tbody>';
    		$gamount = 0;
    		foreach ($rowdata as $k=>$v)
    		{
    		    $amount = $totals[$k];
    		    $gamount += $amount;
    			$bal = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$amount,'c'=>""]);
    			$html .='<tr>
    				<td class="text-center">'.$v.'</td>
    				<td class="text-right">'.$bal.'</td>
    			</tr>';
    		}
			$total = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$gamount,'c'=>""]);
    			$html .='<tr>
    				<td class="text-right">Grand Total</td>
    				<td class="text-right">'.$total.'</td>
    			</tr>';
    		$html .='</tbody>
    	</table></div>';
$html .='<div class="clearfix"></div></div>';
	return [
    	    "filters"=>"",
    	    "header"=>"",
    	    "body"=>$html,
    	   ];
    }