<?php
    function AnnualIncomeReport_Config()
    {
    	$Year = @$_GET["year"];
    	if(empty($Year)) $Year = date('Y');
    	return [
            'title'=>'Annual Income Report for '.$Year,
            'description'=>"This report shows the income received broken down by month converted to the base currency using rates at the time of the transaction",
            'icon'=>'',
            'parent'=>'Reports',
            'slug'=>'',//Url if required
            'order'=>1,//Order By in numeric
            'ajax'=>false,
            'configs'=>
            [
                'table'=>false,
                'id'=>"",
                'class'=>"",
                'pagination'=>true,
                'filters'=>true
            ]
        ];
    }
    function AnnualIncomeReport_Content($arg=[])
    {
    	$Year = @$_GET["year"];
    	if(empty($Year)) $Year = date('Y');
    	$cYear = date('Y');
    	if($Year>=$cYear)
    	{
    	    $pYear= $cYear-1;
    	    $nYear= $cYear;
    	}
    	else
    	{
    	    $pYear= $Year-1;
    	    $nYear= $Year+1;
    	    $cYear= $Year;
    	}
    	$ppYear = $pYear-1;
        $Array = [];
	$btnsPagination = '<div class="row" style="padding: 0px 5px;">
		<a href="?year='.$pYear.'" class="pull-left btn btn-primary"> « '.$pYear.'</a>
		<a href="?year='.$nYear.'" class="pull-right btn btn-primary"> '.$nYear.' »</a>
	</div>';        

    $baseCurrency = getBaseCurrency(['id'=>0]);
    $bsp = $baseCurrency->symbol_position;
    $bsb = $baseCurrency->symbol;    	
    $bsc = $baseCurrency->code;                      


    $sql2 = "select date_format(p.paymet_date,'%Y-%m') as months,sum(p.amount_in/p.base_conv_rate) as amount_in,sum(p.amount_out/p.base_conv_rate) as amount_out,sum(p.fees/p.base_conv_rate) as fees
    from invoices i 
    join invoices_payments p on i.id=p.invoice_id 
    join clients c on i.user_id=c.id 
    where i.status=3 and date_format(p.paymet_date,'%Y') in ('".$pYear."','".$ppYear."','".$cYear."') group by date_format(p.paymet_date,'%Y-%m')";
    $lastYearInvoices = full_query($sql2);

    $invoicesData = [];
	$data = '';
	foreach ($lastYearInvoices as $result)
	{
	    $months = explode("-",$result->months);
	    $invoicesData[$months[1]][$months[0]] = round($result->amount_in-($result->amount_out+$result->fees),1);
	}
	foreach($invoicesData as $ivk=>$ivv)
	{
	    $monthName = date('F', strtotime($cYear."-".$ivk."-01"));
	    $cySale = _s($cYear,$ivv,0);
	    $cySale = $cySale>0 ? $cySale:0;

	    $lySale = _s($pYear,$ivv,0);
	    $lySale = $lySale>0 ? $lySale:0;

	    $plySale = _s($ppYear,$ivv,0);
	    $plySale = $plySale>0 ? $plySale:0;

	    $fcySale = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$cySale,'c'=>""]);
	    $flySale = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$lySale,'c'=>""]);
	    $fplySale = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$plySale,'c'=>""]);
        $data .= '{"c":[{"v":"'.$monthName.'"},{"v":'.$plySale.',"f":"'.$fplySale.'"},{"v":'.$lySale.',"f":"'.$flySale.'"},{"v":'.$cySale.',"f":"'.$fcySale.'"}]},';
	}
    $data = rtrim($data,',');

	    $html = '<div class="col-md-12">
	    <script type="text/javascript">
google.load("visualization", "1", {packages:["corechart"]});
google.setOnLoadCallback(drawChart);
function drawChart() {
var jsonData = \'{"rows":['.$data.'],"cols":[{"label":"Month","type":"string"},{"label":"'.$ppYear.'","type":"number"},{"label":"'.$pYear.'","type":"number"},{"label":"'.$cYear.'","type":"number"}]}\';
var data = new google.visualization.DataTable(jsonData);
var options = { legend: {position: "top"},colors:["#3070CF","#F9D88C","#cb4c30"],chartArea:{left:80,top:20,width:"90%",height:"350"}};
var chart = new google.visualization.ColumnChart(document.getElementById("line_top_x"));
chart.draw(data,options);
}
</script>
<div id="line_top_x"></div>
<style>#line_top_x {width: 100%;height: 400px;}</style>';
	    $html .= $btnsPagination;
    $sql = "select date_format(p.paymet_date,'%Y-%m') as months,sum(p.amount_in/p.base_conv_rate) as amount_in,sum(p.amount_out/p.base_conv_rate) as amount_out,sum(p.fees/p.base_conv_rate) as fees
    from invoices i 
    join invoices_payments p on i.id=p.invoice_id 
    join clients c on i.user_id=c.id 
    where i.status=3 and date_format(p.paymet_date,'%Y')='".$cYear."' group by date_format(p.paymet_date,'%Y-%m') order by date_format(p.paymet_date,'%Y-%m') asc";
    $invoices = full_query($sql);
	    
                if(!empty($invoices))
                {
                    $html .='<table class="table table-border text-center">
                    		<thead>
                    			<tr class="customTableTh">
                    				<th rowspan="2">Month</th>
                    				<th rowspan="2">Amount In</th>
                    				<th rowspan="2">Fees</th>
                    				<th rowspan="2">Amount Out</th>
                    				<th rowspan="2">Balance</th>
                    			</tr>
                    		</thead>
                    		<tbody>';
                    		$gamount_in = 0;
                    		$gamount_out = 0;
                    		$gbalance = 0;
                    		$gfees = 0;
                    		foreach ($invoices as $result) {
                    			$gamount_in +=$result->amount_in;
                    			$gamount_out +=$result->amount_out;
                    			$gfees +=$result->fees;
                    			$balance=$result->amount_in-($result->fees+$result->amount_out);
                    			$gbalance +=$balance;
                    			$amount_in = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$result->amount_in,'c'=>""]);
                    			$amount_out = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$result->amount_out,'c'=>""]);
                    			$fees = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$result->fees,'c'=>""]);
                    			$bal = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$balance,'c'=>""]);
                    			
                    			$html .='<tr>
                    				<td class="text-center">'.$result->months.'</td>
                    				<td class="text-right">'.$amount_in.'</td>
                    				<td class="text-right">'.$fees.'</td>
                    				<td class="text-right">'.$amount_out.'</td>
                    				<td class="text-right">'.$bal.'</td>
                    			</tr>';
                    		}
                    			$tin = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$gamount_in,'c'=>""]);
                    			$tfee = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$gfees,'c'=>""]);
                    			$tout = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$gamount_out,'c'=>""]);
                    			$tbal = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$gbalance,'c'=>""]);

                    			$html .='<tr>
                    				<td class="text-right">Grand Total</td>
                    				<td class="text-right">'.$tin.'</td>
                    				<td class="text-right">'.$tfee.'</td>
                    				<td class="text-right">'.$tout.'</td>
                    				<td class="text-right">'.$tbal.'</td>
                    			</tr>';
                    		$html .='</tbody>
                    	</table>';
                }else{
                    $html .=displayMsgBox("","Annual Income Report for ".$Year,"width: 100%;");
                }
$html .='<div class="clearfix"></div><br>'.$btnsPagination.'</div>';
	return [
    	    "filters"=>"",
    	    "header"=>"",
    	    "body"=>$html,
    	   ];
    }