<?php
    function AverageCustomerRetentionTime_Config()
    {
    	return [
            'title'=>'Average Customer Retention Time',
            'description'=>'This report calculates and provides you with the average lifetime of products, services, addons and domains - that is the number of days between the registration date and the termination date. Averages are displayed by product and the associated billing cycle, and are displayed both as a number of days value and a years/months value.',
            'icon'=>'',
            'parent'=>'Reports',
            'slug'=>'',//Url if required
            'order'=>1,//Order By in numeric
            'ajax'=>false,
            'configs'=>
            [
                'table'=>true,
                'id'=>"",
                'class'=>"",
                'pagination'=>true,
                'filters'=>true
            ]
        ];
    }
    function AverageCustomerRetentionTime_Content($arg=[])
    {
        $Array = [];
		$results = full_query("select p.account_type,p.gid,p.title,g.title as group_name,h.billing_cycle,ceil((select avg(datediff(termination_date,reg_date)) from hosting where gid=p.gid and billing_cycle=h.billing_cycle)) as avg_days,count(h.id) as items from products_list p join products_group g on p.gid=g.id join hosting h on h.package_id=p.id and p.gid=h.gid and p.tid=h.tid group by p.account_type,p.title,g.title,h.billing_cycle");
		$TableHeader =["Sr#","Product Name","Billing Cycle","Product Count","Average Days Active","Average Years/Months Active"];
		$TableBody = [];

        $i=0;
        $dataSet = [];
        foreach ($results as $result)
        {
    		if(!in_array($result->group_name,$dataSet)) $dataSet[$result->group_name]['Name'] = $result->group_name;
    	}
    
        foreach ($results as $result)
        {
        	$billingCycle = localAPI('GetDurationName',$result->billing_cycle);
        	$TimeAgoByDays = localAPI('GetTimeAgoByDays',$result->avg_days);
    		$dataSet[$result->group_name]['childs'][] = ['title'=>$result->title,'items'=>$result->items,'avg_days'=>round($result->avg_days),'billingCycle'=>$billingCycle,'TimeAgoByDays'=>$TimeAgoByDays];
        }        
        
    	foreach ($dataSet as $ds)
        {
            $TableBody[] =[$ds['Name']];
    	    $childs = $ds['childs'];
    	    $i=0;
    		foreach ($childs as $cds)
    	    {
    	    	$i++;
                $TableBody[] =[$i,$cds['title'],$cds['billingCycle'],$cds['items'],$cds['avg_days'],$cds['TimeAgoByDays']];
    		}
    	}        
	return [
    	    "filters"=>"",
    	    "header"=>$TableHeader,
    	    "body"=>$TableBody,
    	   ];
    }