<?php
    function ClientAccountRegisterBalance_Config()
    {
    	return [
            'title'=>'Client Account Register Balance',
            'description'=>'This report provides a statement of account for individual client accounts',
            'icon'=>'',
            'parent'=>'Reports',
            'slug'=>'',//Url if required
            'order'=>1,//Order By in numeric
            'ajax'=>false,
            'configs'=>
            [
                'table'=>true,
                'id'=>"",
                'class'=>"",
                'pagination'=>true,
                'filters'=>true
            ]
        ];
    }
    function ClientAccountRegisterBalance_Content($arg=[])
    {
        $Array = [];
		$results = full_query("select a.id,a.user_id,a.sale_amount,a.discount_amount,a.paid_amount,(a.sale_amount - (a.discount_amount + a.paid_amount)) AS balance_amount,a.last_paid_amount,a.entry_date,a.paid_date,a.payment_method,p.title AS payment_method_name,a.currency,a.base_conv_rate,b.code,b.symbol,b.symbol_position,b.decimal_mark,concat(c.first_name,' ',c.last_name) AS user_name,c.email,c.country,c.phonenumber from invoices a join currencies b on a.currency = b.id join clients c on a.user_id = c.id join payment_methods p on a.payment_method = p.id");
		$TableHeader = ["Sr#","Client","Debits","Credits","Balance","Invoice Date","Last Credit Amount"];
		$TableBody = [];
        $i=0;
        foreach ($results as $result)
        {
        	$i++;
        	$sale_amount = $result->sale_amount;
        	$paid_amount = $result->paid_amount;
        	$discount_amount = $result->discount_amount;
        	$balance_amount = $result->balance_amount;
    
        	$csp = $result->symbol_position;
        	$cs = $result->symbol;
        	$cc = $result->code;
    
        	$credit = $paid_amount+$discount_amount;
    
            $debit = AmountConvertToCurrencyFormate(['p'=>$csp,'s'=>$cs,'a'=>$sale_amount,'c'=>$cc]);
            $credit = AmountConvertToCurrencyFormate(['p'=>$csp,'s'=>$cs,'a'=>$credit,'c'=>$cc]);
            $balance = AmountConvertToCurrencyFormate(['p'=>$csp,'s'=>$cs,'a'=>$balance_amount,'c'=>$cc]);
			$TableBody[] =[$i,$result->user_name,$debit,$credit,$balance,$result->entry_date,$result->paid_date];
        }
    	return [
    	    "filters"=>"",
    	    "header"=>$TableHeader,
    	    "body"=>$TableBody,
    	   ];
    }