<?php
    function ClientsByCountry_Config()
    {
    	return [
            'title'=>'Clients by Country',
            'description'=>'This report shows the total number of active services per country, as well as total active unique clients per country in the table below',
            'icon'=>'',
            'parent'=>'Reports',
            'slug'=>'',//Url if required
            'order'=>1,//Order By in numeric
            'ajax'=>false,
            'configs'=>
            [
                'table'=>false,
                'id'=>"",
                'class'=>"",
                'pagination'=>true,
                'filters'=>true
            ]
        ];
    }
    function ClientsByCountry_Content($arg=[])
    {
        $Array = [];
		$results = full_query("select count(id) as users,country from clients where ifnull(country,'')<>'' group by country");
    	$data = '';
    	foreach ($results as $result) {
    		$country_info = GetCountryInfo($result->country);
    		$countryname = $country_info['name'];
    	$data .= '{"c":[{"v":"'.$countryname.'"},{"v":'.$result->users.'},{"v":'.$result->users.'}]},';
    	}
	
	    $data = rtrim($data,',');
	    $html = '<script type="text/javascript">
            google.load("visualization", "1", {packages:["geochart"]});
            google.setOnLoadCallback(drawChart16087059111);
            function drawChart16087059111()
            {
            var jsonData = \'{"rows":['.$data.'],"cols":[{"label":"Country","type":"string"},{"label":"Active Clients","type":"number"}]}\';
            var data = new google.visualization.DataTable(jsonData);
            var options = { legend: {position: "right"} };
            var chart = new google.visualization.GeoChart(document.getElementById("chartcont16087059111"));
            chart.draw(data,options);
        }
        </script>
        <div class="col-md-8">
            <div id="chartcont16087059111"></div>
        </div>
        <div class="col-md-4">';
$html .='<table class="table table-border">
		<thead>
			<tr>
				<th>Country</th>
				<th>Clients</th>
			</tr>
		</thead>
		<tbody>';
		foreach ($results as $result) {
			$country_info = GetCountryInfo($result->country);
			$html .='<tr>
				<td>'.$result->country.' - '.$country_info['name'].' (+'.$country_info['dialing_code'].')</td>
				<td>'.$result->users.'</td>
			</tr>';
		}
		$html .='</tbody>
	</table>';
$html .='</div>';
	return [
    	    "filters"=>"",
    	    "header"=>"",
    	    "body"=>$html,
    	   ];
    }