<?php
    function DailyPerformance_Config()
    {
    	$MonthYear = @$_GET["month_year"];
    	if(empty($MonthYear)) $MonthYear = date('Y-m');
    	$d = GetLastNextMonths($MonthYear);
    	$year = $d["Current"]["year"];
    	$month = $d["Current"]["Name"];        
    	return [
            'title'=>'Daily Performance for '.$month.' '.$year,
            'description'=>'This report shows a daily activity summary for a given month.',
            'icon'=>'',
            'parent'=>'Reports',
            'slug'=>'',//Url if required
            'order'=>1,//Order By in numeric
            'ajax'=>false,
            'configs'=>
            [
                'table'=>false,
                'id'=>"",
                'class'=>"",
                'pagination'=>true,
                'filters'=>true
            ]
        ];
    }
    function DailyPerformance_Content($arg=[])
    {

	$MonthYear = @$_GET["month_year"];
	if(empty($MonthYear)) $MonthYear = date('Y-m');
	$d = GetLastNextMonths($MonthYear);
	$year = $d["Current"]["year"];
	$month = $d["Current"]["Name"];

	$n = GetLastNextMonths($MonthYear);
	$nYear = $n["Next"]["year"];
	$nName = $n["Next"]["Name"];
	$nMonth = $n["Next"]["month"];

	$p = GetLastNextMonths($MonthYear);
	$pYear = $p["Previous"]["year"];
	$pName = $p["Previous"]["Name"];
	$pMonth = $p["Previous"]["month"];


	$btnsPagination = '<div class="row" style="padding: 0px 5px;">
		<a onclick="ws.LoadPage(\'/admin/reports/DailyPerformance?month_year='.$pYear.'-'.$pMonth.'\')" class="pull-left btn btn-primary"> « '.$pName.' '.$pYear.'</a>
		<a onclick="ws.LoadPage(\'/admin/reports/DailyPerformance?month_year='.$nYear.'-'.$nMonth.'\')" class="pull-right btn btn-primary"> '.$nName.' '.$nYear.' »</a>
	</div>';
	$html = "";
	
			$results = full_query("select a.entry_date,
(select count(id) from orders where status='active' and from_unixtime(entry_date,'%Y-%m-%d')=a.entry_date) as orders,
(select count(id) from invoices where status in (2,7) and Date_Format(entry_date,'%Y-%m-%d')=a.entry_date) as new_invoices,
(select count(id) from invoices where status=3 and Date_Format(entry_date,'%Y-%m-%d')=a.entry_date) as paid_invoices,
(select count(id) from support_tickets where  Date_Format(entry_date,'%Y-%m-%d')=a.entry_date) as open_tickets,
(select count(id) from support_tickets_replies where  Date_Format(entry_date,'%Y-%m-%d')=a.entry_date) as tickets_replies,
(select count(id) from hosting_cancel_requests where  Date_Format(created_at,'%Y-%m-%d')=a.entry_date) as cancellation_requests
 from year_month_day a where Date_Format(a.entry_date,'%Y-%m')='$MonthYear'");
	$data = '';
	foreach ($results as $result) {
	    $data .= '{"c":[{"v":"'.$result->entry_date.'"},{"v":'.$result->orders.'},{"v":'.$result->new_invoices.'},{"v":'.$result->paid_invoices.'},{"v":'.$result->open_tickets.'},{"v":'.$result->tickets_replies.'},{"v":'.$result->cancellation_requests.'}]},';
	}
    $data = rtrim($data,',');
    $html .= $btnsPagination;
    $html .= '<script type="text/javascript">
google.load("visualization", "1", {packages:["corechart"]});
google.setOnLoadCallback(drawChart);
function drawChart() {
var jsonData = \'{"rows":['.$data.'],"cols":[{"label":"Day","type":"string"},{"label":"Completed Orders","type":"number"},{"label":"New Invoices","type":"number"},{"label":"Paid Invoices","type":"number"},{"label":"Opened Tickets","type":"number"},{"label":"Ticket Replies","type":"number"},{"label":"Cancellation Requests","type":"number"}]}\';

var data = new google.visualization.DataTable(jsonData);
var options = { legend: {position: "right"} };
var chart = new google.visualization.AreaChart(document.getElementById("line_top_x"));
chart.draw(data,options);
}
</script>
<div id="line_top_x"></div>
<style>#line_top_x {width: 100%;height: 400px;}</style>';

    if(!empty($results))
    {
        $headings = ["Sr#","Date","Completed Orders","New Invoices","Paid Invoices","Opened Tickets","Ticket Replies","Cancellation Requests"];
        $i=0;
        $rows=[];
        foreach ($results as $result)
        {
            $i++;
            $rows[] =[$i,$result->entry_date,$result->orders,$result->new_invoices,$result->paid_invoices,$result->open_tickets,$result->tickets_replies,$result->cancellation_requests];
    	}
        $html .=  GenerateTable($headings,$rows);
        $html .= $btnsPagination;
    }
	return [
    	    "filters"=>"",
    	    "header"=>"",
    	    "body"=>$html,
    	   ];
    }