<?php
    function DiskSpaceAndBandwidthUsageSummary_Config()
    {
    	return [
            'title'=>'Disk Space & Bandwidth Usage Summary',
            'description'=>'This report shows the Disk Space & Bandwidth Usage Statistics for hosting accounts',
            'icon'=>'',
            'parent'=>'Reports',
            'slug'=>'',//Url if required
            'order'=>1,//Order By in numeric
            'ajax'=>false,
            'configs'=>
            [
                'table'=>false,
                'id'=>"",
                'class'=>"",
                'pagination'=>true,
                'filters'=>true
            ]
        ];
    }
    function DiskSpaceAndBandwidthUsageSummary_Content($arg=[])
    {
        $results = full_query("select a.user_id,concat(b.first_name,' ',b.last_name) as user_name,b.email,a.domain_name,a.reg_date,a.disk_usage,a.disk_limit,((a.disk_usage/a.disk_limit)*100) as disk_percentage,a.bandwidth_usage,a.bandwidth_limit,((a.bandwidth_usage/a.bandwidth_limit)*100) as bandwidth_percentage,s.name as servername,s.hostname,s.ipaddress from hosting a join clients b on a.user_id=b.id join hosting_servers s on a.server_id=s.id");
	    $html = "";
        $dataSet = [];
        if(!empty($results))
        {
            $headings = ["Sr#","Client Name","Domain","Disk Usage","Disk Limit","% Used","BW Usage","BW Limit","% Used"];
            $i=0;
            foreach ($results as $result)
            {
        		if(!in_array($result->servername,$dataSet))
    			{
    				$dataSet[$result->servername]['Name'] = $result->servername;
    				$dataSet[$result->servername]['hostname'] = $result->hostname;
    				$dataSet[$result->servername]['ipaddress'] = $result->ipaddress;
    			}
        	}
            foreach ($results as $result)
            {
        		$dataSet[$result->servername]['childs'][] = ['client'=>$result->user_name,'email'=>$result->email,'domain_name'=>$result->domain_name,'DiskUsage'=>$result->disk_usage,'DiskLimit'=>$result->disk_limit,'DiskUsed'=>$result->disk_percentage,'BWUsage'=>$result->bandwidth_usage,'BWLimit'=>$result->bandwidth_limit,'BWUsed'=>$result->bandwidth_percentage];
            }            
            
        	foreach ($dataSet as $ds)
            {
                $rows[] =[["colspan"=>9,"data"=>$ds['hostname'].' - '.$ds['ipaddress'],"rows"=>1,"classes"=>"","id"=>""]];
        	    $childs = $ds['childs'];
        	    $i=0;
        		foreach ($childs as $cds)
        	    {
        	    	$i++;
                    $rows[] =[$i,$cds['client'],$cds['domain_name'],round($cds['DiskUsage'],2).' MB',round($cds['DiskLimit'],2).' MB',round($cds['DiskUsed'],2).'%',round($cds['BWUsage'],2).' MB', round($cds['BWLimit'],2).' MB',round($cds['BWUsed'],2).'%'];
        		}
        	}
            $html .=  GenerateTable($headings,$rows);
        }
	return [
    	    "filters"=>"",
    	    "header"=>"",
    	    "body"=>$html,
    	   ];
    }