<?php
    function IncomeByProducts_Config()
    {
        $dated = date('Y-m');
    	return [
            'title'=>'Income by Product for '.date('F Y',strtotime($dated)),
            'description'=>'This report provides a breakdown per product/service of invoices paid in a given month. Please note this excludes overpayments & other payments made to deposit funds (credit), and includes invoices paid from credit added in previous months, and thus may not match the income total for the month.',
            'icon'=>'',
            'parent'=>'Reports',
            'slug'=>'',//Url if required
            'order'=>1,//Order By in numeric
            'ajax'=>false,
            'configs'=>
            [
                'table'=>false,
                'id'=>"",
                'class'=>"",
                'pagination'=>true,
                'filters'=>true
            ]
        ];
    }
    function IncomeByProducts_Content($arg=[])
    {
        $dated = date('Y-m');
		$results = full_query("select p.account_type,p.gid,p.id,p.title,g.title as group_name,sum(qty) as sold,sum(i.amount/i.base_conv_rate) as amount from products_list p join products_group g on p.gid=g.id join (select a.id,a.description,a.type,a.rate,a.qty,a.discount,(a.qty * a.rate) AS amount,b.currency,c.symbol,c.symbol_position,b.base_conv_rate,b.id AS invoice_id,b.invoice_no,b.user_id,b.payment_method,a.pid,s.title AS status,b.paid_date from invoices_details a join invoices b on b.id=a.invoice_id join currencies c on c.id=b.currency join invoices_status s on b.status=s.id) i on i.pid=p.id where i.status='Paid' and Date_Format(paid_date,'%Y-%m')='$dated' group by p.account_type,p.gid,p.id,p.title,g.title");
        $headings = ["Sr#","Product Name","Units Sold","Total Amount"];
        
        $i=0;
        $dataSet = [];
        foreach ($results as $result)
        {
    		if(!in_array($result->group_name,$dataSet)) $dataSet[$result->group_name]['Name'] = $result->group_name;
    	}
    
        foreach ($results as $result)
        {
    		$dataSet[$result->group_name]['childs'][] = ['title'=>$result->title,'sold'=>$result->sold,'amount'=>$result->amount];
        }	

	    $gtotal = 0;
	    $gsolds = 0;
	    $data = '';

        $baseCurrency = getBaseCurrency(['id'=>0]);
        $bsp = $baseCurrency->symbol_position;
        $bsb = $baseCurrency->symbol;    	
        $bsc = $baseCurrency->code;  

    	foreach ($dataSet as $ds)
        {
        	$rows[]=[$ds['Name']];
    	    $childs = $ds['childs'];
    	    $i=0;
    	    $subtotal = 0;
    	    $subsolds = 0;
    		foreach ($childs as $cds)
    	    {
    	    	$i++;
    		    $subsolds += $cds['sold'];
    		    $subtotal += $cds['amount'];
    		    $camount = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$cds['amount'],'c'=>$bsc]);
            	$rows[]=[$i,$cds['title'],$cds['sold'],$camount];
    		}
    	    $gtotal += $subtotal;
    	    $gsolds += $subsolds;
    	    $csubtotal = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$subtotal,'c'=>$bsc]);
    		$data .= '{"c":[{"v":"'.$ds['Name'].'"},{"v":'.round($subtotal,2).',"f":"'.round($subtotal,2).'"}]},';
        	$rows[]=["<b>Sub-Total</b>",$subsolds,$csubtotal];
    	}
        	$ggtotal = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$gtotal,'c'=>$bsc]);
        	$rows[]=["<b>Grand Total</b>",$gsolds,$ggtotal];
            $data = rtrim($data,',');        
            
        $table =  GenerateTable($headings,$rows);
        $html = '<script type="text/javascript">
            google.load("visualization", "1", {packages:["corechart"]});
            google.setOnLoadCallback(drawChart);
            function drawChart()
            {
                var jsonData = \'{"rows":['.$data.'],"cols":[{"label":"Days Range","type":"string"},{"label":"Value","type":"number"}]}\';
                var data = new google.visualization.DataTable(jsonData);
                var options = { legend: {position: "right"} };
                var chart = new google.visualization.PieChart(document.getElementById("drawChart"));
                chart.draw(data,options);
            }
        </script>
        <style>#drawChart{width: 100%;height: 400px;}</style>  
        <div class="col-md-7">'.$table.'</div>
        <div class="col-md-5">
        <div id="drawChart"></div>
        </div>';

	return [
    	    "filters"=>"",
    	    "header"=>"",
    	    "body"=>$html,
    	   ];
    }