<?php
    function MonthlyTransactions_Config()
    {
        $dated = date('Y-m');
    	return [
            'title'=>'Monthly Transactions Report for '.date('F Y',strtotime($dated)),
            'description'=>'This report provides a summary of daily payments activity for a given month. The Amount Out figure includes both expenditure transactions and refunds.',
            'icon'=>'',
            'parent'=>'Reports',
            'slug'=>'',//Url if required
            'order'=>1,//Order By in numeric
            'ajax'=>false,
            'configs'=>
            [
                'table'=>false,
                'id'=>"",
                'class'=>"",
                'pagination'=>true,
                'filters'=>true
            ]
        ];
    }
    function MonthlyTransactions_Content($arg=[])
    {
        $dated = date('Y-m');
		$results = full_query("select a.entry_date,ifnull(sum(p.amount_in/p.base_conv_rate),0) as amount_in,ifnull(sum(p.fees/p.base_conv_rate),0) as fees,ifnull(sum(p.amount_out/p.base_conv_rate),0) as amount_out from year_month_day a left join invoices_payments p on Date_Format(p.entry_date,'%Y-%m-%d')=a.entry_date where Date_Format(a.entry_date,'%Y-%m')='$dated' group by a.entry_date");
        $headings = ["Sr#","Date","Amount In","Fees","Amount Out","Balance"];

    	$data = '';
    	foreach ($results as $result) {
    		$date = date('jS M', strtotime($result->entry_date));
        	$data .= '{"c":[{"v":"'.$date.'"},{"v":'.round($result->amount_in,2).',"f":"'.round($result->amount_in,2).'"},{"v":'.round($result->fees,2).',"f":"'.round($result->fees,2).'"},{"v":'.round($result->amount_out,2).',"f":"'.round($result->amount_out,2).'"}]},';
    	}
        $data = rtrim($data,',');
    
        $i=0;
        $gin = 0;
        $gfee = 0;
        $gout = 0;
        $gbal = 0;
    
        	
        $baseCurrency = getBaseCurrency(['id'=>0]);
        $bsp = $baseCurrency->symbol_position;
        $bsb = $baseCurrency->symbol;    	
        $bsc = $baseCurrency->code;  
    
        foreach ($results as $result)
        {
        	$i++;
        	$in = $result->amount_in;
        	$out = $result->amount_out;
        	$fee = $result->fees;
        	$bal = $in-$out;
        
            $gin += $in;
            $gfee += $fee;
            $gout += $out;
            $gbal += $bal;
            $cin = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$in,'c'=>$bsc]);
            $cfee = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$fee,'c'=>$bsc]);
            $cout = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$out,'c'=>$bsc]);
            $cbal = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$bal,'c'=>$bsc]);
            $entry_date = ConvertDateToFormat(['date'=>$result->entry_date]);
            $rows[] =[$i,$entry_date,$cin,$cfee,$cout,$cbal];
    	}
        $gin = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$gin,'c'=>$bsc]);
        $gfee = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$gfee,'c'=>$bsc]);
        $gout = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$gout,'c'=>$bsc]);
        $gbal = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$gbal,'c'=>$bsc]);
        $rows[] =["Grand Total",$gin,$gfee,$gout,$gbal];
		    
        $html = '<script type="text/javascript">
            google.load("visualization", "1", {packages:["corechart"]});
            google.setOnLoadCallback(drawChart);
            function drawChart() {
                var jsonData = \'{"rows":['.$data.'],"cols":[{"label":"Days Range","type":"string"},{"label":"Amount In","type":"number"},{"label":"Fees","type":"number"},{"label":"Amount Out","type":"number"}]}\';
                var data = new google.visualization.DataTable(jsonData);
                var options = { legend: {position: "top"},colors: ["#80D044","#F9D88C","#CC0000"] };
                var chart = new google.visualization.AreaChart(document.getElementById("line_top_x"));
                chart.draw(data,options);
            }
        </script>
        <div id="line_top_x"></div>
        <style>#line_top_x{width: 100%;height: 400px;}</style>';
        $html .=  GenerateTable($headings,$rows);
	return [
    	    "filters"=>"",
    	    "header"=>"",
    	    "body"=>$html,
    	   ];
    }