<?php
    function PromotionsUsage_Config()
    {
        return [
            'title'=>'Promotions Usage',
            'description'=>'This report provides promotions usage related all details',
            'icon'=>'',
            'parent'=>'Reports',
            'slug'=>'',//Url if required
            'order'=>1,//Order By in numeric
            'ajax'=>false,
            'configs'=>
            [
                'table'=>false,
                'id'=>"",
                'class'=>"",
                'pagination'=>true,
                'filters'=>true
            ]
        ];
    }
    function PromotionsUsage_Content($arg=[])
    {
        $baseCurrency = getBaseCurrency(['id'=>0]);
        $bsp = $baseCurrency->symbol_position;
        $bsb = $baseCurrency->symbol;       
        $bsc = $baseCurrency->code;                      
        
        $rows=[];
        $results = full_query("select p.start_date,p.end_date,p.code,p.type,p.value,p.notes,p.uses,sum(i.sale_amount/i.base_conv_rate) as sales,sum(i.discount_amount/i.base_conv_rate) as discount,sum((i.sale_amount/i.base_conv_rate)-(i.discount_amount/i.base_conv_rate)) as profit from promotions p 
join orders o on p.code=o.coupon_code
join invoices i on o.invoice_id=i.id
group by p.code,p.type,p.value,p.notes,p.uses");
    $html = "";
    if(!empty($results))
    {
        $html .='<table class="table table-border text-center">
                <thead>
                    <tr class="customTableTh">
                        <th rowspan="2">Coupon Code</th>
                        <th rowspan="2">Discount Type</th>
                        <th rowspan="2">Value</th>
                        <th rowspan="2">Dates</th>
                        <th rowspan="2">Notes</th>
                        <th rowspan="2">Usage Count</th>
                        <th colspan="3" rowspan="1">Total Values</th>
                    </tr>
                    <tr class="customTableTh">
                        <th>Sales</th>
                        <th>Discount</th>
                        <th>Revenue</th>
                    </tr>
                </thead>
                <tbody>';
        $gsales = 0;
        $gdiscount = 0;
        $gprofit = 0;
        foreach ($results as $result)
        {
            $start_date = ConvertDateToFormat(['date'=>date('Y-m-d',strtotime($result->start_date))]);
            $end_date = ConvertDateToFormat(['date'=>date('Y-m-d',strtotime($result->end_date))]);
            $dated = $start_date." - ".$end_date;
            $sales = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$result->sales,'c'=>""]);
            $discount = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$result->discount,'c'=>""]);
            $profit = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$result->profit,'c'=>""]);
            $gsales += $result->sales;
            $gdiscount += $result->discount;
            $gprofit += $result->profit;
            
            $html .='<tr>
                    <td class="text-left">'.$result->code.'</td>
                    <td>'.$result->type.'</td>
                    <td>'.$result->value.'</td>
                    <td>'.$dated.'</td>
                    <td>'.$result->notes.'</td>
                    <td>'.$result->uses.'</td>
                    <td>'.$sales.'</td>
                    <td>'.$discount.'</td>
                    <td>'.$profit.'</td>
            </tr>';
        }
            $gsales = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$gsales,'c'=>""]);
            $gdiscount = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$gdiscount,'c'=>""]);
            $gprofit = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$gprofit,'c'=>""]);
            $html .='<tr>
                    <td class="text-right text-bold" colspan="6">Grand Total</td>
                    <td>'.$gsales.'</td>
                    <td>'.$gdiscount.'</td>
                    <td>'.$gprofit.'</td>
            </tr>';
        $html .='</tbody></table>';
    }
    return [
            "filters"=>"",
            "header"=>"",
            "body"=>$html,
           ];
    }