<?php
    function SalesByProducts_Config()
    {
        $dated = date('Y-m');
    	return [
            'title'=>'Sales by Product for '.date('F Y',strtotime($dated)),
            'description'=>'This report gives a breakdown of the number of units sold of each product per month.',
            'icon'=>'',
            'parent'=>'Reports',
            'slug'=>'',//Url if required
            'order'=>1,//Order By in numeric
            'ajax'=>false,
            'configs'=>
            [
                'table'=>false,
                'id'=>"",
                'class'=>"",
                'pagination'=>true,
                'filters'=>true
            ]
        ];
    }
    function SalesByProducts_Content($arg=[])
    {
        $dated = date('Y-m');
		$results = full_query("select p.account_type,p.gid,p.id,p.title,g.title as group_name,sum(o.rate/o.base_conv_rate) as amount,count(o.id) as sold from products_list p join products_group g on p.gid=g.id join (select a.id,a.cart_id,a.order_no,a.name,a.pid,a.sub_scription_id,a.order_type,a.cost,a.rate,a.discount,a.discount_id,a.setup_fee,a.duration,a.setup_duration,a.is_domain_free,a.parent_id,a.entry_date,a.update_date,a.hostname,a.domain_name,a.eppcode,a.root_password,a.name_server_one,a.name_server_two,a.name_server_three,a.name_server_four,c.status,c.user_name,c.password,b.invoice_id,b.currency,b.base_conv_rate,b.user_id,b.payment_method,ifnull(c.is_module_run,'NO') AS is_module_run from orders_details a join orders b on a.order_no=b.order_no left join hosting c on a.order_no=c.order_id and (a.pid=c.package_id or a.sub_scription_id=c.package_id)) o on o.pid=p.id where Date_Format(FROM_UNIXTIME(o.entry_date),'%Y-%m')='$dated' group by p.account_type,p.gid,p.id,p.title,g.title");
        $headings = ["Sr#","Product Name","Units Sold","Total Amount"];
        
        $i=0;
        $dataSet = [];
        foreach ($results as $result)
        {
    		if(!in_array($result->group_name,$dataSet)) $dataSet[$result->group_name]['Name'] = $result->group_name;
    	}
    
        foreach ($results as $result)
        {
    		$dataSet[$result->group_name]['childs'][] = ['title'=>$result->title,'sold'=>$result->sold,'amount'=>$result->amount];
        }	

	    $gtotal = 0;
	    $gsolds = 0;
	    $data = '';

        $baseCurrency = getBaseCurrency(['id'=>0]);
        $bsp = $baseCurrency->symbol_position;
        $bsb = $baseCurrency->symbol;    	
        $bsc = $baseCurrency->code;  

    	foreach ($dataSet as $ds)
        {
        	$rows[]=[$ds['Name']];
    	    $childs = $ds['childs'];
    	    $i=0;
    	    $subtotal = 0;
    	    $subsolds = 0;
    		foreach ($childs as $cds)
    	    {
    	    	$i++;
    		    $subsolds += $cds['sold'];
    		    $subtotal += $cds['amount'];
    		    $camount = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$cds['amount'],'c'=>$bsc]);
            	$rows[]=[$i,$cds['title'],$cds['sold'],$camount];
    		}
    	    $gtotal += $subtotal;
    	    $gsolds += $subsolds;
    	    $csubtotal = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$subtotal,'c'=>$bsc]);
    		$data .= '{"c":[{"v":"'.$ds['Name'].'"},{"v":'.round($subtotal,2).',"f":"'.round($subtotal,2).'"}]},';
        	$rows[]=["<b>Sub-Total</b>",$subsolds,$csubtotal];
    	}
        	$ggtotal = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$gtotal,'c'=>$bsc]);
        	$rows[]=["<b>Grand Total</b>",$gsolds,$ggtotal];
            $data = rtrim($data,',');        
            
        $table =  GenerateTable($headings,$rows);
        $html = '<script type="text/javascript">
            google.load("visualization", "1", {packages:["corechart"]});
            google.setOnLoadCallback(drawChart);
            function drawChart()
            {
                var jsonData = \'{"rows":['.$data.'],"cols":[{"label":"Days Range","type":"string"},{"label":"Value","type":"number"}]}\';
                var data = new google.visualization.DataTable(jsonData);
                var options = { legend: {position: "right"} };
                var chart = new google.visualization.PieChart(document.getElementById("drawChart"));
                chart.draw(data,options);
            }
        </script>
        <style>#drawChart{width: 100%;height: 400px;}</style>  
        <div class="col-md-7">'.$table.'</div>
        <div class="col-md-5">
        <div id="drawChart"></div>
        </div>';

	return [
    	    "filters"=>"",
    	    "header"=>"",
    	    "body"=>$html,
    	   ];
    }