<?php
    function SalesTaxLiability_Config()
    {
    	return [
            'title'=>'Sales Tax Liability',
            'description'=>"This report shows sales tax liability for the selected period",
            'icon'=>'',
            'parent'=>'Reports',
            'slug'=>'',//Url if required
            'order'=>1,//Order By in numeric
            'ajax'=>false,
            'configs'=>
            [
                'table'=>false,
                'id'=>"",
                'class'=>"",
                'pagination'=>true,
                'filters'=>true
            ]
        ];
    }
    function SalesTaxLiability_Content($arg=[])
    {
        $Array = [];
        $TaxRatesList = [];
		$TaxableCountries= full_query("SELECT distinct country from invoices where tax_amount>0");
        $country = @$_POST["country"];
        $datetime = @$_POST["datetime"];
	    $html = '<div class="col-md-12">';
	    $html .= '<form method="post" action="/admin/reports/SalesTaxLiability/1">
                    <table class=" wgmbcsBorderNone" border="0" style="width: 100%;">
                        <tbody><tr>
                            <td style="width: 300px;">
                                <label> Date</label>
                                <div class="input-group">
                                    <input type="text" class="form-control daterange-basic" name="datetime" value="'.$datetime.'">
                                    <span class="input-group-addon"><i class="icon-calendar22"></i></span>
                                </div>
                            </td>';
                            if(!empty($TaxableCountries))
                            {
                            $html .= '<td style="width: 300px;">
                                <label>Countries</label>
                                <select data-placeholder="Select Country" name="country[]" class="select select2-hidden-accessible" tabindex="-1" aria-hidden="true" multiple>';
                            	foreach ($TaxableCountries as $result)
                            	{
                            		$country_info = GetCountryInfo($result->country);
                            		$countryname = $country_info['name'];
                            		$html .= '<option value="'.$result->country.'" '.($result->country == $country ? 'selected':'').'>'.$result->country.' - '.$countryname.'</option>';
                            	}
                                $html .= '</select>
                            </td>';
                            }
                            $html .= '<td><br><button type="submit" class="btn btn-primary pull-left"><i class="icon-search4"></i> Search</button></td>
                        </tr>
                        
                    </tbody></table>                      
                </form>';
                $where = [];
                if(!empty($country))
                {
                    $country = implode("','",$country);
                    $where[] = "c.country in ('".$country."')";
                }
                if(!empty($datetime))
                {
                    //
                    $datetime = str_replace(" ","",$datetime);
                    $datetimeSeg = explode("-",$datetime);
                    $DateFrom = date("Y-m-d",strtotime($datetimeSeg[0]));
                    $DateTo = date("Y-m-d",strtotime($datetimeSeg[1]));
                    $where[] = "i.paid_date>='".$DateFrom."' and i.paid_date<='".$DateTo."' ";
                }
                $invoices = [];
                if(!empty($where))
                {
                    $sql = "select i.id,i.credit,i.entry_date,i.paid_date,i.sale_amount as totalinvoiced,i.tax_amount as totalvat,i.sale_amount/i.base_conv_rate as totalinvoicedbase,i.tax_amount/i.base_conv_rate as totalvatbase,case when i.credit>0 then i.credit/i.base_conv_rate else 0 end as creditbase,i.tax_type,i.country,r.code,r.symbol,r.symbol_position,c.first_name,c.last_name,i.user_id
                    from invoices i join clients c on i.user_id=c.id 
                    join currencies r on i.currency=r.id
                    where i.tax_amount>0 and i.status=3 and ".implode(' and ',$where)." order by i.user_id,i.entry_date asc";
                    $invoices = full_query($sql);
                }
                if(!empty($invoices))
                {
                    $baseCurrency = getBaseCurrency(['id'=>0]);
                    $bsp = $baseCurrency->symbol_position;
                    $bsb = $baseCurrency->symbol;    	
                    $bsc = $baseCurrency->code;                      
                    $html .='<table class="table table-border text-center">
                    		<thead>
                    			<tr class="customTableTh">
                    				<th rowspan="2">Invoice #</th>
                    				<th rowspan="2">Client</th>
                    				<th rowspan="2">IV.Date</th>
                    				<th rowspan="2">IV.Paid Date</th>
                    				<th colspan="4" rowspan="1">Client Currency Values</th>
                    				<th colspan="4" rowspan="1">Base Currency Values</th>
                    			</tr>
                    			<tr class="customTableTh">
                    				<th>Type</th>
                    				<th>Value</th>
                    				<th>VAT</th>
                    				<th>Credit</th>
                    				<th>Value</th>
                    				<th>Credit</th>
                    				<th>VAT</th>
                    				<th>Total</th>
                    			</tr>
                    		</thead>
                    		<tbody>';
                    		$gamount = 0;
                    		$gvat = 0;
                    		$givs = 0;
                    		$gcredit = 0;
                    		foreach ($invoices as $result) {
                    			$country_info = GetCountryInfo($result->country);
                    			$TaxRate = $TaxRatesList[$result->country];
                    			$TaxRate = $TaxRate>0 ? $TaxRate:0;
                    			$credit = $result->credit;
                    			$gamount +=$result->totalinvoicedbase;
                    			$gvat +=$result->totalvatbase;
                    			$givs +=$result->invoicecount;
                    			$bamount = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$result->totalinvoicedbase,'c'=>""]);
                    			$bvat = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$result->totalvatbase,'c'=>""]);
                    			$total = $result->totalinvoicedbase+$result->creditbase;
                    			$btotal = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$total,'c'=>""]);
                    			$bcredit = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$result->creditbase,'c'=>""]);
                    			$gcredit +=$result->creditbase;

                    			$csp = $result->symbol_position;
                    			$cs = $result->symbol;
                    			$code = $result->code;

                    			$camount = AmountConvertToCurrencyFormate(['p'=>$csp,'s'=>$cs,'a'=>$result->totalinvoiced,'c'=>""]);
                    			$cvat = AmountConvertToCurrencyFormate(['p'=>$csp,'s'=>$cs,'a'=>$result->totalvat,'c'=>""]);
                    			$ccredit = AmountConvertToCurrencyFormate(['p'=>$csp,'s'=>$cs,'a'=>$credit,'c'=>""]);
                                $entry_date = ConvertDateToFormat(['date'=>$result->entry_date]);
                                $paid_date = ConvertDateToFormat(['date'=>$result->paid_date]);
                    			$html .='<tr>
                    				<td class="text-left"><a href="/admin/invoice-edit/'.$result->id.'" target="_blank">'.$result->id.'</a></td>
                    				<td class="text-left"><a href="/admin/client-summary/'.$result->user_id.'" target="_blank">'.$result->first_name.' '.$result->last_name.'</a></td>
                    				<td class="text-left">'.$entry_date.'</td>
                    				<td class="text-left">'.$paid_date.'</td>
                    				<td>'.$result->tax_type.'</td>
                    				<td class="text-right">'.$camount.'</td>
                    				<td class="text-right">'.$cvat.'</td>
                    				<td class="text-right">'.$ccredit.'</td>
                    				<td class="text-right">'.$bamount.'</td>
                    				<td class="text-right">'.$bcredit.'</td>
                    				<td class="text-right">'.$bvat.'</td>
                    				<td class="text-right">'.$btotal.'</td>
                    			</tr>';
                    		}
                    			$tamount = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$gamount,'c'=>""]);
                    			$tvat = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$gvat,'c'=>""]);
                    			$tcredit = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$gcredit,'c'=>""]);
                    			$ttotal = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$gamount+$gcredit,'c'=>""]);

                    			$html .='<tr>
                    				<td colspan="8" class="text-right">Grand Total</td>
                    				<td class="text-right">'.$tamount.'</td>
                    				<td class="text-right">'.$tcredit.'</td>
                    				<td class="text-right">'.$tvat.'</td>
                    				<td class="text-right">'.$ttotal.'</td>
                    			</tr>';
                    		$html .='</tbody>
                    	</table>';
                }
$html .='<div class="alert alert-info">This report excludes invoices that affect a clients credit balance since this income will be counted and reported when it is applied to invoices for products/services</div></div>';
	return [
    	    "filters"=>"",
    	    "header"=>"",
    	    "body"=>$html,
    	   ];
    }