<?php
    function ServerRevenueForecasts_Config()
    {
    	return [
            'title'=>'Server Revenue Forecasts',
            'description'=>'This report shows income broken down by billing cycle for each of your servers. It then uses the monthly cost entered for each server to estimate the annual gross profit for each server.',
            'icon'=>'',
            'parent'=>'Reports',
            'slug'=>'',//Url if required
            'order'=>1,//Order By in numeric
            'ajax'=>false,
            'configs'=>
            [
                'table'=>false,
                'id'=>"",
                'class'=>"",
                'pagination'=>true,
                'filters'=>true
            ]
        ];
    }
    function ServerRevenueForecasts_Content($arg=[])
    {
    	$rows=[];
	    $headings = ["Sr#","Server Income","Monthly","Quarterly","Semi-Annual","Annual","2 Years","3 Years","4 Years","5 Years","6 Years","7 Years","8 Years","9 Years","10 Years","Monthly Costs","Gross Profit"];
        $results = full_query("select  a.server_id,a.billing_cycle,b.name as server_name,b.monthly_cost,sum(a.amount/cc.base_conv_rate) as amount FROM hosting a join hosting_servers b on a.server_id=b.id join clients c on a.user_id=c.id join currencies cc on c.currency=cc.id where a.`status`='Active' group by a.server_id,a.billing_cycle,b.name,b.monthly_cost");
        $baseCurrency = getBaseCurrency(['id'=>0]);
        $bsp = $baseCurrency->symbol_position;
        $bsb = $baseCurrency->symbol;    	
        $bsc = $baseCurrency->code;  
        
        $dataSet = [];
        foreach ($results as $result)
        {
            $dataSet[$result->server_name]['name'] = $result->server_name;
            $dataSet[$result->server_name]['cost'] = $result->monthly_cost;
            $dataSet[$result->server_name]['total'] += $result->amount ?? 0;
            $dataSet[$result->server_name][$result->billing_cycle] = round($result->amount,2);
        }
        
        $i=0;
        $totalCost = 0;
        $totalIncome = 0;
        foreach ($dataSet as $ds)
        {
        	$i++;
        	$cost = ($ds['cost'] ?? 0)*12;
        	$price_monthly_fee = $ds['price_monthly_fee'] ?? 0;
        	$price_quarterly_fee = $ds['price_quarterly_fee'] ?? 0;
        	$price_semi_annually_fee = $ds['price_semi_annually_fee'] ?? 0;
        	$price_annually_fee = $ds['price_annually_fee'] ?? 0;
        	$price_biennially_fee = $ds['price_biennially_fee'] ?? 0;
        	$price_triennially_fee = $ds['price_triennially_fee'] ?? 0;
        	$price_four_years_fee = $ds['price_four_years_fee'] ?? 0;
        	$price_five_years_fee = $ds['price_five_years_fee'] ?? 0;
        	$price_six_years_fee = $ds['price_six_years_fee'] ?? 0;
        	$price_seven_years_fee = $ds['price_seven_years_fee'] ?? 0;
        	$price_eight_years_fee = $ds['price_eight_years_fee'] ?? 0;
        	$price_nine_years_fee = $ds['price_nine_years_fee'] ?? 0;
        	$price_ten_years_fee = $ds['price_ten_years_fee'] ?? 0;
        	$total = $ds['total'] ?? 0;
        
            $totalCost +=$cost;
            $totalIncome +=$total;
        
         	$cprice_monthly_fee = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$price_monthly_fee,'c'=>$bsc]);
         	$cprice_quarterly_fee = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$price_quarterly_fee,'c'=>$bsc]);
         	$cprice_semi_annually_fee = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$price_semi_annually_fee,'c'=>$bsc]);
         	$cprice_annually_fee = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$price_annually_fee,'c'=>$bsc]);
         	$cprice_biennially_fee = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$price_biennially_fee,'c'=>$bsc]);
         	$cprice_triennially_fee = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$price_triennially_fee,'c'=>$bsc]);
         	$cprice_four_years_fee = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$price_four_years_fee,'c'=>$bsc]);
         	$cprice_five_years_fee = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$price_five_years_fee,'c'=>$bsc]);
         	$cprice_six_years_fee = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$price_six_years_fee,'c'=>$bsc]);
         	$cprice_seven_years_fee = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$price_seven_years_fee,'c'=>$bsc]);
         	$cprice_eight_years_fee = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$price_eight_years_fee,'c'=>$bsc]);
         	$cprice_nine_years_fee = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$price_nine_years_fee,'c'=>$bsc]);
         	$cprice_ten_years_fee = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$price_ten_years_fee,'c'=>$bsc]);
         	$ccost = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$cost,'c'=>$bsc]);
         	$ctotal = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$total,'c'=>$bsc]);
         	$rows[] = [$i,$ds['name'],$cprice_monthly_fee,$cprice_quarterly_fee,$cprice_semi_annually_fee,$cprice_annually_fee,$cprice_biennially_fee,$cprice_triennially_fee,$cprice_four_years_fee,$cprice_five_years_fee,$cprice_six_years_fee,$cprice_seven_years_fee,$cprice_eight_years_fee,$cprice_nine_years_fee,$cprice_ten_years_fee,$ccost,$ctotal];
        }
        $html =  GenerateTable($headings,$rows);

        $grossProfit = $totalIncome-$totalCost;
        $gtotalIncome = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$totalIncome,'c'=>$bsc]);
        $gtotalCost = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$totalCost,'c'=>$bsc]);
        $ggrossProfit = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$grossProfit,'c'=>$bsc]);

        $html .='<p>
        <strong>Total Income:</strong> '.$gtotalIncome.' <br>
        <strong>Total Expenses:</strong> '.$gtotalCost.' <br>
        <strong>Gross Profit:</strong> '.$ggrossProfit.' 
        </p>';

	return [
    	    "filters"=>"",
    	    "header"=>"",
    	    "body"=>$html,
    	   ];
    }