<?php
    function SslCertificateMonitoring_Config()
    {
    	return [
            'title'=>'SSL Certificate Monitoring',
            'description'=>'Displays a list of domains with their SSL status, if available.',
            'icon'=>'',
            'parent'=>'Reports',
            'slug'=>'',//Url if required
            'order'=>1,//Order By in numeric
            'ajax'=>false,
            'configs'=>
            [
                'table'=>false,
                'id'=>"",
                'class'=>"",
                'pagination'=>true,
                'filters'=>true
            ]
        ];
    }
    function SslCertificateMonitoring_Content($arg=[])
    {
        $results = full_query("select * from hosting_ssls_monitoring");
        $start = time();
        $dataSet = [];
        $rows = [];
        $a = 0;
        foreach ($results as $result)
        {
        	$a++;
        	$is_detected = $result->is_detected;
        	if($is_detected == 'Yes'){
        		$days = ceil(abs(strtotime($result->valid_to) - $start) / 86400);
        		if($days <=30){
        			$idays = 30;
        			$inDays = 'Expires within 30 Days';
        		}
        		if($days >30 && $days <=90){
        			$idays = 90;
        			$inDays = 'Expires within 90 Days';
        		}
        		if($days >90 && $days <=180){
        			$idays = 180;
        			$inDays = 'Expires within 180 Days';
        		}  
        		if($days >180){
        			$idays = 190;
        			$inDays = 'Expires in over 180 Days';		
        		}
        	}else{
        			$idays = 365;
        		$inDays = 'No SSL Detected';		
        	}
        
        	if(!in_array($idays,$dataSet))
        	{
        		$dataSet[$idays]['days'] =$idays;
        		$dataSet[$idays]['name'] =$inDays;
        	}
        	$dataSet[$idays]['ssls'][] = [
        		'issued_by'=>($is_detected == 'Yes') ? $result->issued_by:'-',
        		'issued_to'=>($is_detected == 'Yes') ? $result->issued_to:'-',
        		'valid_from'=>($is_detected == 'Yes') ? $result->valid_from:'-',
        		'valid_to'=>($is_detected == 'Yes') ? $result->valid_to:'-',
        		'domain_name'=>$result->domain_name,
        		'last_check_date'=>$result->last_check_date,
        		'is_detected'=>$result->is_detected];
        	//$dataSet[$inDays][$result->domain_name]['info'] = $result->info;
        
        }
        sort($dataSet);
        $headings = ["Sr#","Domain Name","Status","Issuer","Issue Date","Expiry","Last Update"];
        
        $i=0;
        $totalCost = 0;
        $totalIncome = 0;
        foreach ($dataSet as $key => $dsd)
        {
            $rows[] = [["data"=>count($dsd['ssls'])." Domains SSL ".$dsd['name'],"colspan"=>7,"classes"=>"info"]];
    	    foreach ($dsd['ssls'] as $ds)
    	    {
        		$i++;
        		if($ds['is_detected'] == 'Yes'){
        			$valid_from = '<i class="icon-lock ssl-state ssl-active"></i>';
        		}else{
        			$valid_from = '<i class="icon-lock ssl-state ssl-inactive"></i>';			
        		}
                $rows[] = [$i,
                $ds['domain_name'],
                ["data"=>$valid_from,"classes"=>'text-center'],
                $ds['issued_by'],
                ["data"=>$ds['valid_from'],"classes"=>'text-center'],
                ["data"=>$ds['valid_to'],"classes"=>'text-center'],
                ["data"=>$ds['last_check_date'],"classes"=>'text-center']
                ];
    		}
    	}
        $html = GenerateTable($headings,$rows);

	return [
    	    "filters"=>"",
    	    "header"=>"",
    	    "body"=>$html,
    	   ];
    }