<?php
    function TopClientsByIncome_Config()
    {
    	return [
            'title'=>'Top 20 Clients by Income',
            'description'=>'This report shows the 20 clients with the highest net income according to the transactions entered',
            'icon'=>'',
            'parent'=>'Reports',
            'slug'=>'',//Url if required
            'order'=>1,//Order By in numeric
            'ajax'=>false,
            'configs'=>
            [
                'table'=>false,
                'id'=>"",
                'class'=>"",
                'pagination'=>true,
                'filters'=>true
            ]
        ];
    }
    function TopClientsByIncome_Content($arg=[])
    {
        $results = full_query("select a.user_id,c.first_name,c.last_name,sum(a.amount_in/a.base_conv_rate) as amount_in,sum(a.fees/a.base_conv_rate) as fees,sum(a.amount_out/a.base_conv_rate) as amount_out from invoices_payments a join clients c on a.user_id=c.id group by a.user_id,c.first_name,c.last_name");
        $baseCurrency = getBaseCurrency();
        $bsp = $baseCurrency->symbol_position;
        $symbol = $bsb = $baseCurrency->symbol; 
        $bsc = $baseCurrency->code; 
        $data = '';
        $totalIn = 0;
        $totalOut = 0;
        $totalFee = 0;
        $totalBal = 0;	
        foreach ($results as $result)
        {
            $balance = ($result->amount_in+$result->fees)-$result->amount_out;
            $totalIn += round($result->amount_in,2);
            $totalOut += round($result->amount_out,2);
            $totalFee += round($result->fees,2);
            $totalBal += round($balance,2);
            
            $data .= '{"c":[{"v":"'.$result->first_name.' '.$result->last_name.'"},{"v":'.round($result->amount_in,2).',"f":"'.$symbol.' '.round($result->amount_in,2).'"}]},';
        }
        $data = rtrim($data,',');        
        
        
        $html ='<script type="text/javascript">
            google.load("visualization", "1", {packages:["corechart"]});
            google.setOnLoadCallback(drawChart16096129921);
            function drawChart16096129921()
            {
                var jsonData = \'{"rows":['.$data.'],"cols":[{"label":"Client","type":"string"},{"label":"Balance","type":"number"}]}\';
                var data = new google.visualization.DataTable(jsonData);
                var options = { legend: {position: "right"} };
                var chart = new google.visualization.PieChart(document.getElementById("line_top_x"));
                chart.draw(data,options);
            }
        </script>
        <div class="col-md-9"><div id="line_top_x"></div></div>
	    <div class="col-md-3">';
		$totalIn = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$totalIn,'c'=>$bsc]);
		$totalFee = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$totalFee,'c'=>$bsc]);
		$totalOut = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$totalOut,'c'=>$bsc]);
		$totalBal = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$totalBal,'c'=>$bsc]);			    	
	    $html .= GenerateTable([["data"=>"Income Stats","colspan"=>2]],
	    [
	        ["Total Amount In",$totalIn],
	        ["Total Fees",$totalFee],
	        ["Total Amount Out",$totalOut],
	        ["Total Balance",$totalBal]
	    ]);
        $html .='</div><style>#line_top_x{width: 100%;height: 400px;}</style>';
        
        $rows = [];
        $headings = ["Sr#","Client ID","Client Name","Total Amount In","Total Fees","Total Amount Out","Balance"];
        $i=0;
        foreach ($results as $result)
        {
        	$i++;
        	$balance = ($result->amount_in+$result->fees)-$result->amount_out;
        	$camount_in = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$result->amount_in,'c'=>$bsc]);
        	$cfees = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$result->fees,'c'=>$bsc]);
        	$camount_out = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$result->amount_out,'c'=>$bsc]);
        	$cbalance = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$balance,'c'=>$bsc]);
    	    $rows[] =[$i,$result->user_id,$result->first_name.' '.$result->last_name,$camount_in,$cfees,$camount_out,$cbalance];
    	}
        
        $html .= GenerateTable($headings,$rows);

	return [
    	    "filters"=>"",
    	    "header"=>"",
    	    "body"=>$html,
    	   ];
    }