<?php
    function VatMoss_Config()
    {
    	return [
            'title'=>'VAT MOSS Settlement Data',
            'description'=>"This report provides the information needed to complete a VATMOSS return Please check with your tax authority to confirm how you can upload your settlement data into the MOSS portal. You should also contact your MOSS registration country if you have any further questions in relation to the MOSS return.",
            'icon'=>'',
            'parent'=>'Reports',
            'slug'=>'',//Url if required
            'order'=>1,//Order By in numeric
            'ajax'=>false,
            'configs'=>
            [
                'table'=>false,
                'id'=>"",
                'class'=>"",
                'pagination'=>true,
                'filters'=>true
            ]
        ];
    }
    function VatMoss_Content($arg=[])
    {
        $Array = [];
        $TaxRatesList = [];
		$TaxableCountries= full_query("SELECT distinct country from invoices where tax_amount>0");
		$TaxRates= full_query("select taxrate,country from tax_rules");
		if(!empty($TaxRates))
		{
		    foreach($TaxRates as $row)
		    {
		        $TaxRatesList[$row->country] = $row->taxrate;
		    }
		}
        $country = @$_POST["country"];
        $datetime = @$_POST["datetime"];
	    $html = '<div class="col-md-12">';
	    $html .= '<form method="post" action="/admin/reports/VatMoss/1">
                    <table class=" wgmbcsBorderNone" border="0" style="width: 100%;">
                        <tbody><tr>
                            <td style="width: 300px;">
                                <label> Date</label>
                                <div class="input-group">
                                    <input type="text" class="form-control daterange-basic" name="datetime" value="'.$datetime.'">
                                    <span class="input-group-addon"><i class="icon-calendar22"></i></span>
                                </div>
                            </td>';
                            if(!empty($TaxableCountries))
                            {
                            $html .= '<td style="width: 300px;">
                                <label>Countries</label>
                                <select data-placeholder="Select Country" name="country[]" class="select select2-hidden-accessible" tabindex="-1" aria-hidden="true" multiple>';
                            	foreach ($TaxableCountries as $result)
                            	{
                            		$country_info = GetCountryInfo($result->country);
                            		$countryname = $country_info['name'];
                            		$html .= '<option value="'.$result->country.'" '.($result->country == $country ? 'selected':'').'>'.$result->country.' - '.$countryname.'</option>';
                            	}
                                $html .= '</select>
                            </td>';
                            }
                            $html .= '<td><br><button type="submit" class="btn btn-primary pull-left"><i class="icon-search4"></i> Search</button></td>
                        </tr>
                        
                    </tbody></table>                      
                </form>';
                $where = [];
                if(!empty($country))
                {
                    $country = implode("','",$country);
                    $where[] = "c.country in ('".$country."')";
                }
                if(!empty($datetime))
                {
                    //
                    $datetime = str_replace(" ","",$datetime);
                    $datetimeSeg = explode("-",$datetime);
                    $DateFrom = date("Y-m-d",strtotime($datetimeSeg[0]));
                    $DateTo = date("Y-m-d",strtotime($datetimeSeg[1]));
                    $where[] = "i.paid_date>='".$DateFrom."' and i.paid_date<='".$DateTo."' ";
                }
                $invoices = [];
                if(!empty($where))
                {
                    $sql = "select count(i.id) as invoicecount,sum(i.sale_amount) as totalinvoiced,sum(i.tax_amount) as totalvat,sum(i.sale_amount/i.base_conv_rate) as totalinvoicedbase,sum(i.tax_amount/i.base_conv_rate) as totalvatbase,i.tax_type,i.country,r.code,r.symbol,r.symbol_position
                    from invoices i join clients c on i.user_id=c.id 
                    join currencies r on i.currency=r.id
                    where i.tax_amount>0 and i.status=3 and ".implode(' and ',$where)."  group by i.tax_type,i.country,r.code,r.symbol,r.symbol_position order by c.country asc";
                    $invoices = full_query($sql);
                }
                if(!empty($invoices))
                {
                    $baseCurrency = getBaseCurrency(['id'=>0]);
                    $bsp = $baseCurrency->symbol_position;
                    $bsb = $baseCurrency->symbol;    	
                    $bsc = $baseCurrency->code;                      
                    $html .='<table class="table table-border text-center">
                    		<thead>
                    			<tr class="customTableTh">
                    				<th rowspan="1" colspan="2">Country</th>
                    				<th rowspan="1" colspan="2">VAT</th>
                    				<th rowspan="2">Invoices</th>
                    				<th colspan="2" rowspan="1">Client Currency Values</th>
                    				<th colspan="2" rowspan="1">Base Currency Values</th>
                    			</tr>
                    			<tr class="customTableTh">
                    				<th>Name</th>
                    				<th>Code</th>
                    				<th>Rate</th>
                    				<th>Type</th>
                    				<th>Value</th>
                    				<th>VAT</th>
                    				<th>Value</th>
                    				<th>VAT</th>
                    			</tr>
                    		</thead>
                    		<tbody>';
                    		$gamount = 0;
                    		$gvat = 0;
                    		$givs = 0;
                    		foreach ($invoices as $result) {
                    			$country_info = GetCountryInfo($result->country);
                    			$TaxRate = $TaxRatesList[$result->country];
                    			$TaxRate = $TaxRate>0 ? $TaxRate:0;
                    			
                    			$gamount +=$result->totalinvoicedbase;
                    			$gvat +=$result->totalvatbase;
                    			$givs +=$result->invoicecount;
                    			$bamount = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$result->totalinvoicedbase,'c'=>""]);
                    			$bvat = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$result->totalvatbase,'c'=>""]);
                    			
                    			$csp = $result->symbol_position;
                    			$cs = $result->symbol;
                    			$code = $result->code;

                    			$camount = AmountConvertToCurrencyFormate(['p'=>$csp,'s'=>$cs,'a'=>$result->totalinvoiced,'c'=>""]);
                    			$cvat = AmountConvertToCurrencyFormate(['p'=>$csp,'s'=>$cs,'a'=>$result->totalvat,'c'=>""]);

                    			$html .='<tr>
                    				<td class="text-left">'.$result->country.' - '.$country_info['name'].'</td>
                    				<td>'.$country_info['dialing_code'].'</td>
                    				<td>'.$result->tax_type.'</td>
                    				<td>'.$TaxRate.'%</td>
                    				<td>'.$result->invoicecount.'</td>
                    				<td class="text-right">'.$camount.'</td>
                    				<td class="text-right">'.$cvat.'</td>
                    				<td class="text-right">'.$bamount.'</td>
                    				<td class="text-right">'.$bvat.'</td>
                    			</tr>';
                    		}
                    			$tamount = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$gamount,'c'=>""]);
                    			$tvat = AmountConvertToCurrencyFormate(['p'=>$bsp,'s'=>$bsb,'a'=>$gvat,'c'=>""]);

                    			$html .='<tr>
                    				<td colspan="4" class="text-right">Grand Total</td>
                    				<td>'.$givs.'</td>
                    				<td colspan="2" class="text-right"></td>
                    				<td class="text-right">'.$tamount.'</td>
                    				<td class="text-right">'.$tvat.'</td>
                    			</tr>';
                    		$html .='</tbody>
                    	</table>';
                }
$html .='</div>';
	return [
    	    "filters"=>"",
    	    "header"=>"",
    	    "body"=>$html,
    	   ];
    }