<?php 
    function eotp_config($arg=[])
    {
        // the friendly display name for a payment gateway should be
        // defined here for backwards compatibility
        return array(
                "name" => "2FA Email Authentication", 
                "description" => "Get One Time Password via Email address.",
                "version" => "1.0",
                "author" => "Hostarina",
                "author_url" => "",
                "notes" => "EOTP requires that a user enter a 10 digit code that changes every 30 seconds to complete login. This works with mobile apps such as OATH Token and Google Authenticator.",
                "configs"=>[]
        );
    }
    function eotp_link($arg)
    {
        return "";
    }
    function eotp_input()
    {
         $html = '<div class="clearfix"></div>
            <style>
            .code-input{
                text-align:center;
                margin-top: 5%;
            }
            </style> 
            <div class="pull-left row">';
            for($i=0;$i<10;$i++){
                $html .='<input class="form-control p-0 code-input pull-left" name="code[]" value="" type="text" dt-len="1" dt-total="10" dt-type="S" style="width: 9%;height:35px;margin-left: 1%;text-align: center;">';     
            }
            $html .='</div><div class="clearfix"></div><br>';
            return $html;     
    }
    function eotp_send($arg)
    {
        $ws =& get_instance();
        $user_id = $arg['user_id'];
        $arg['client_id'] = $user_id;
        $email = $arg['email'];
        $full_name = $arg['user_name'];
        $first_name = $arg['first_name'];
        $last_name = $arg['last_name'];
        $ws->db->delete("email_otp",["user_id"=>$user_id]);
        $otp = strtoupper(localAPI('WsRandString',10)); // 10 as characters
        $secret = strtoupper(localAPI('WsRandString',12)); // 15 as characters
        //Email Template Info
        $TemplateInfo = localAPI('getEmailTemplate',['template'=>'onetimepassword']);
        $Message = html_entity_decode($TemplateInfo->message);; 
        $arg['otp'] = $otp;
        $subject = $TemplateInfo->subject;
        $subject = MailClientVariablesReplacement($subject,$arg);
        $Message = MailClientVariablesReplacement($Message,$arg);
        
        $isSent =  localAPI('WsMailSend',['Template'=>$TemplateInfo,'Message'=>$Message,'EmailTo'=>$email,'ClientName'=>$full_name,'ClientId'=>$user_id,'subject'=>$subject]);
        if($isSent['status'] == 'success')
        {
            $ws->db->insert(WST_OTP,["otp" => $otp,"secret" => $secret,"user_id" => $user_id,"datetime" => date("Y-m-d H:i:s"),"email" => $email]);
        } 
        $SessionInfo = $ws->Account->GetCurrentUser();
        $isAdmin = $SessionInfo->is_admin;
        $closeBtn = '';
        //if($isAdmin!=1) $closeBtn = '<button type="button" class="close" data-dismiss="modal">&times;</button>';
        $form="";
        if($isSent["status"] == "error")
        {
            $form .='<div class="modal-header">
                <h5 class="modal-title">OTP Sending Error</h5>
                '.$closeBtn.'
            </div>
            <div class="modal-body">'.$isSent["message"].', Please Contact with Website Support Team.</div>';
        }
        else
        {
            $form .='<div class="modal-header"><h5 class="modal-title">Check your Email Inbox/Spambox</h5>'.$closeBtn.'</div>
                    <div class="modal-body">                            
                      <div class="col-md-12 pull-left google_two_auth_qrcode_form" style="padding:0px;">
                        <p>Dear '.$full_name.', please check your email inbox/spambox, One Time Password sent at your email address : '.$email.'</p>
                        <hr>
                        <form action="" method="post" onsubmit="ws.two_auth_activate(this); return false;">
                           <input type="hidden" name="secret" class="form-control" value="'.$secret.'">
                           <input type="hidden" name="module" class="form-control" value="eotp">
                           <input type="hidden" name="user_id" class="form-control" value="'.$user_id.'">
                            <div class="col-md-12 pull-left" style="padding:0px;">
                                <div class="col-md-12 pull-left" style="padding:0px;">
                                Enter the 10-digit code that the application generates to verify and complete setup.
                            </div>
                            <div class="col-md-12 pull-left row">';
                            for($i=0;$i<10;$i++){
                                $form .='<input class="form-control p-0 code-input pull-left" name="code[]" value="" type="text" dt-len="1" dt-total="10" dt-type="S" style="width: 9%;height: 35px;margin-left: 1%;margin-top: 5%;text-align: center;">';     
                            }
                            $form .='<div class="clearfix"></div><br>
                                </div>
                                <div class="col-md-12 pull-left">
                                    <button type="submit" class="btn btn-primary pull-right">Verify OTP</button>
                                </div>
                            </div>
                        </form>
                      </div>
                 </div>
                      <div class="clearfix"></div><br>';
        }
    return $form;
    }
    function eotp_activate($arg)
    {
        $ws =& get_instance();
        $module = $arg['module'];
        $secret = $arg['secret'];
        $secretEncrypt = $arg['secretEncrypt'];
        $backupCode = $arg['backupCode'];
        $backupCodeEncoded = $arg['backupCodeEncrypt'];
        $user_id = $arg['user_id'];
        $code = $arg['code'];
        if(is_array($code)) $code = implode("",$code);
        $result = full_query("select * from email_otp where user_id='$user_id'");
        $otpCode = $result[0]->otp;
        if($otpCode !=$code) return ['status'=>'error','message'=>'OTP code is not valid'];
           $isUpdated = $ws->db->update(WST_CLIENTS,['two_fa_auth_enable'=>'YES','two_fa_auth_key'=>$secretEncrypt,'two_fa_auth_backup_code'=>$backupCodeEncoded,'two_fa_auth_module'=>$module],['id'=>$user_id]);
        if(!$isUpdated)  return ['status'=>'error','message'=>'OTP Activation Failed...'];
        $SessionInfo = $ws->Account->GetCurrentUser();
        $isAdmin = $SessionInfo->is_admin;
        $closeBtn = '';
        $closeBtn = '<button type="button" class="close" data-dismiss="modal">&times;</button>';
             $form='<div class="modal-header">
                      <h5 class="modal-title">Enable Two-Factor Authentication</h5>
                      '.$closeBtn.'
                  </div>
                <div class="modal-body">                            
                  <div class="col-md-12 pull-left google_two_auth_qrcode_form">
                    <div class="alert alert-success text-center"> Two-Factor Authentication is now enabled</div>
                    <h3 style="margin-top:25px;">Backup Code</h3>
                    <p>The backup code is needed to access your account in the event you cannot complete two-factor authentication.</p>
                    <div style="margin: 20px auto;padding: 10px;background-color: #efefef;color: #444;text-align: center;">
                            Your Backup Code is    <span style="display:block;font-family:monospace;font-size:1.6em;">
                                '.(chunk_split($backupCode, 4, ' ')).'    </span>
                    </div>
                    <p>Treat the backup code the same as you would your password. We recommend saving it with a password manager.</p>                              
                  </div>
               </div>
              <div class="clearfix"></div><br><br>';
     return ['status'=>'success','message'=>$form];
    }
    function eotp_verification($arg)
    {
        $ws =& get_instance();
        $user_id = $arg['user_id'];
        $arg['client_id'] = $user_id;
        $email = $arg['email'];
        $full_name = $arg['user_name'];
        $first_name = $arg['first_name'];
        $last_name = $arg['last_name'];
        $ws->db->delete(WST_OTP,["user_id"=>$user_id]);
        $otp = strtoupper(localAPI('WsRandString',10)); // 10 as characters
        $secret = strtoupper(localAPI('WsRandString',12)); // 15 as characters
        //Email Template Info
        $TemplateInfo = localAPI('getEmailTemplate',['template'=>'onetimepassword']);
        $Message = html_entity_decode($TemplateInfo->message);; 
        $arg['otp'] = $otp;
        $subject = $TemplateInfo->subject;
        $subject = MailClientVariablesReplacement($subject,$arg);
        $Message = MailClientVariablesReplacement($Message,$arg);
        $isSent =  localAPI('WsMailSend',['Template'=>$TemplateInfo,'Message'=>$Message,'EmailTo'=>$email,'ClientName'=>$full_name,'ClientId'=>$user_id,'subject'=>$subject]);
        if($isSent['status'] == 'success')
        {
            $ws->db->insert(WST_OTP,["otp" => $otp,"secret" => $secret,"user_id" => $user_id,"datetime" => date("Y-m-d H:i:s"),"email" => $email]);
        } 
        $error = ($isSent['status']) ? ' Sent ':'sending failed ';
        return 'Dear '.$full_name.', Email sent at email address: '.$email.'. please enter your One Time Password below';    
    }
    function eotp_verified($arg)
    {
        $user_id = $arg['user_id'];
        $email = $arg['email'];
        $full_name = $arg['user_name'];
        $first_name = $arg['first_name'];
        $last_name = $arg['last_name'];
        $code = $arg['code'];
        if(is_array($code)) $code = implode("",$code);
        $result = full_query("select * from email_otp where user_id='$user_id'");
        $otpCode = !empty($result) ? $result[0]->otp:"";
        if($otpCode !=$code) return ['status'=>'error','message'=>'OTP code is not valid'];
        return ['status'=>'success','message'=>'OTP Verified Successfully......'];
    }