<?php 
    function otp_config($arg=[])
    {
        // the friendly display name for a payment gateway should be
        // defined here for backwards compatibility
        return array(
                "name" => "2FA SMS Authentication", 
                "description" => "Send a 6 digit Code to your mobile phone.",
                "version" => "1.0",
                "author" => "Hostarina",
                "author_url" => "",
                "notes" => "6 digits One Time Password requires that a user enter for complete login using Mobile SMS.",
                "configs"=>array()
        );
    }
    function otp_link($arg)
    {
        return "";
    }
    function otp_input()
    {
         $html = '<div class="clearfix"></div>
            <style>
            .code-input{
                text-align:center;
                width:90%!important;
            }
            </style> 
            <div class="pull-left row">';
            for($i=0;$i<6;$i++){
                $html .='<div class="col-md-2 p-0">
                    <input class="form-control digit-input code-input" name="code[]" value="" type="text" dt-len="1" dt-total="6" dt-type="N">
                </div>';
            }
            $html .='</div><div class="clearfix"></div><br>';
            return $html;     
    }    
    function otp_send($arg)
    {
        $ws =& get_instance();
        $user_id = $arg['user_id'];
        $user_name = $arg['user_name'];
        $first_name = $arg['first_name'];
        $last_name = $arg['last_name'];
        $isSent = $ws->Sms->otp_send($arg);
        $error = ($isSent["status"] == "success") ? ' Sent ':'sending failed ';
        $SessionInfo = $ws->Account->GetCurrentUser();
        $isAdmin = $SessionInfo->is_admin;
        $closeBtn = '';
        if($isAdmin!=1) $closeBtn = '<button type="button" class="close" data-dismiss="modal">&times;</button>';
        $form="";
        if($isSent["status"] == "error")
        {
            $form .='<div class="modal-header">
                <h5 class="modal-title">OTP Sending Error</h5>
                '.$closeBtn.'
            </div>
            <div class="modal-body">'.$isSent["message"];
            if($isAdmin!=1) $form .='Please Contact with Website Support Team.';
            $form .='</div>';
        }
        else
        {
            $phonenumber = $arg['phonenumber'];
            $phonenumber = str_repeat('*', strlen($phonenumber) - 4) . substr($phonenumber, -4);

            $form .='<div class="modal-header">
                <h5 class="modal-title">Check your Mobile phone</h5>
                '.$closeBtn.'
            </div>
            <div class="modal-body" style="padding:0px;">                            
              <div class="col-md-12 pull-left google_two_auth_qrcode_form">
                <p>Dear '.$arg['user_name'].', please check your mobile, One Time Password sent at your mobile no : <b>'.$phonenumber.'</b></p>
                <form action="" method="post" onsubmit="ws.two_auth_activate(this); return false;">
                   <input type="hidden" name="module" class="form-control" value="otp">
                   <input type="hidden" name="user_id" class="form-control" value="'.$user_id.'">
                    <div class="col-md-12 pull-left">
                        <div class="clearfix"></div><br>
                        <div class="col-md-12 pull-left">Enter the 6-digit code that the application generates to verify and complete setup.
                        </div>
                        <style>
                        .code-input{
                            padding:0px;
                            text-align:center;
                            height:35px;
                            width:90%!important;
                        }
                        </style>    
                            <div class="col-md-12 pull-left row">';
                            for($i=0;$i<6;$i++){
                                $form .='<div class="col-md-2 p-0">
                                    <input class="form-control digit-input code-input" name="code[]" value="" type="text" dt-len="1" dt-total="6" dt-type="N">
                                </div>';
                            }
                                $form .='<div class="clearfix"></div><br>
                            </div>
                        <div class="col-md-12 pull-left">
                            <button type="submit" class="btn btn-primary pull-right">Verify</button>
                        </div>
                    </div>
                </form>
              </div>
            </div>
            <div class="clearfix"></div><br><br>';
        }
    return $form;
  }
    function otp_activate($arg)
    {
        $ws =& get_instance();
        $module = $arg['module'];
        $secret = $arg['secret'];
        $secretEncrypt = $arg['secretEncrypt'];
        $backupCode = $arg['backupCode'];
        $backupCodeEncoded = $arg['backupCodeEncrypt'];
        $user_id = $arg['user_id'];
        $code = $arg['code'];
        if(is_array($code)) $code = implode("",$code);
        $result = $ws->Sms->getUnverifiedOTP($user_id);
        $otpCode = $result->otp;
        if($otpCode !=$code) return ['status'=>'error','message'=>'OTP code is not valid'];
        $isUpdated = update_query(WST_CLIENTS,['two_fa_auth_enable'=>'YES','two_fa_auth_key'=>$secretEncrypt,'two_fa_auth_backup_code'=>$backupCodeEncoded,'two_fa_auth_module'=>$module],['id'=>$user_id]);
        if(!$isUpdated)  return ['status'=>'error','message'=>'OTP Activation Failed...'];
        $SessionInfo = $ws->Account->GetCurrentUser();
        $isAdmin = $SessionInfo->is_admin;
        $closeBtn = '';
        $closeBtn = '<button type="button" class="close" data-dismiss="modal">&times;</button>';
         $form='<div class="modal-header">
                  <h5 class="modal-title">Enable Two-Factor Authentication</h5>
                  '.$closeBtn.'
              </div>
            <div class="modal-body">                            
              <div class="col-md-12 pull-left google_two_auth_qrcode_form">
                <div class="alert alert-success text-center"> Two-Factor Authentication is now enabled</div>
                <h3 style="margin-top:25px;">Backup Code</h3>
                <p>The backup code is needed to access your account in the event you cannot complete two-factor authentication.</p>
                <div style="margin: 20px auto;padding: 10px;background-color: #efefef;color: #444;text-align: center;">
                        Your Backup Code is    <span style="display:block;font-family:monospace;font-size:1.6em;">
                            '.(chunk_split($backupCode, 4, ' ')).'    </span>
                </div>
                <p>Treat the backup code the same as you would your password. We recommend saving it with a password manager.</p>                              
              </div>
           </div>
              <div class="clearfix"></div><br><br>';
     return ['status'=>'success','message'=>$form];
  }
  function otp_verification($arg)
  {
    $ws =& get_instance();
    $user_id = $arg['user_id'];
    $user_name = $arg['user_name'];
    $first_name = $arg['first_name'];
    $last_name = $arg['last_name'];
    $isSent = $ws->Sms->otp_send($arg);
    $error = ($isSent) ? ' Sent ':'sending failed ';
    return 'Dear '.$arg['user_name'].', please check your mobile, One Time Password '.$error.' at your mobile no : '.$arg['phonenumber'];
  }
  function otp_verified($arg)
  {
    $ws =& get_instance();
    $user_id = $arg['user_id'];
    $user_name = $arg['user_name'];
    $first_name = $arg['first_name'];
    $last_name = $arg['last_name'];
    $code = $arg['code'];
    if(is_array($code)) $code = implode("",$code);
    $result = $ws->Sms->getUnverifiedOTP($user_id);
    $otpCode = $result->otp;
    if($otpCode !=$code) return ['status'=>'error','message'=>'OTP code is not valid'];
     return ['status'=>'success','message'=>'OTP Verified Successfully......'];
  }