<?php 
    function tbt_config($arg=[])
    {
        return array(
                "name" => "Time Based Tokens", 
                "description" => "Get codes from an app like Google Authenticator or Duo.",
                "version" => "1.0",
                "author" => "WHASOLS",
                "author_url" => "",
                "notes" => "TOTP requires that a user enter a 6 digit code that changes every 30 seconds to complete login. This works with mobile apps such as OATH Token and Google Authenticator.",
                "configs"=>array()
        );
    }
    function tbt_link($arg)
    {
        return "";
    }
    function tbt_qr_img($qrCodeUrl)
    {
        include_once('phpqrcode.php');        
        // Start output buffering to capture the QR code output
        ob_start();
        QRcode::png($qrCodeUrl, false, 6, 5);  // Generate QR code to output buffer
        $imageData = ob_get_contents();  // Get the image data from the buffer
        ob_end_clean();  // End output buffering

        // Encode the image data in base64
        return "data:image/png;base64,".base64_encode($imageData);
    }
    function tbt_input()
    {
         $html = '<div class="clearfix"></div>
            <style>
            .code-input{
                text-align:center;
                width:90%!important;
            }
            </style> 
            <div class="pull-left row">';
            for($i=0;$i<6;$i++){
                $html .='<div class="col-md-2 p-0">
                    <input class="form-control digit-input code-input" name="code[]" value="" type="text" dt-len="1" dt-total="6" dt-type="N">
                </div>';
            }
            $html .='</div><div class="clearfix"></div><br>';
            return $html;     
    }
    function tbt_send($arg)
    {
        $ws =& get_instance();
        $user_id = $arg['user_id'];
        $email = $arg['email'];
        $user_name = $arg['user_name'];
        $first_name = $arg['first_name'];
        $last_name = $arg['last_name'];
        include_once('google2fa.php');
        $ga = new GoogleAuthenticator();
        $secret = $ga->createSecret();
        $SITE_NAME = GetConfigs('SITE_NAME');   
        $qrCodeUrl = $ga->getQRCodeGoogleUrl($email, $secret,$SITE_NAME);
        $qrCodeUrl = tbt_qr_img($qrCodeUrl);

        $SessionInfo = $ws->Account->GetCurrentUser();
        $isAdmin = $SessionInfo->is_admin;
        $closeBtn = '';
        //if($isAdmin!=1) $closeBtn = '<button type="button" class="close" data-dismiss="modal">&times;</button>';
       $form='<div class="modal-header">            
            <h5 class="modal-title">Connect your app</h5>
            '.$closeBtn.'
        </div>
          <div class="modal-body">                            
            <div class="col-md-12 pull-left two_auth_activate_form">
            <p>
            Using an authenticator app like Google Authenticator or Duo, scan the QR code below.
            Having trouble scanning the code? Enter the code manually in App:<b>'.$secret.'</b></p>
              <form action="" method="post" onsubmit="ws.two_auth_activate(this); return false;">
                 <input type="hidden" name="secret" class="form-control" value="'.$secret.'">
                 <input type="hidden" name="module" class="form-control" value="tbt">
                 <input type="hidden" name="user_id" class="form-control" value="'.$user_id.'">
                      <div class="col-md-12 pull-left">
                        <div class="clearfix"></div><br>
                          <div class="col-md-5 pull-left">
                              <img src="'.$qrCodeUrl.'" style="border: 1px solid #ccc;border-radius: 4px;margin:15px 0;">
                          </div>    
                          <div class="col-md-6 pull-right">
                          <div class="clearfix"></div><br><br>
                              Enter the 6-digit code that the application generates to verify and complete setup.
                            <style>
                            .code-input{
                                padding:0px;
                                text-align:center;
                                height:35px;
                                width:90%!important;
                            }
                            </style> 
                            <div class="pull-left row">';
                            for($i=0;$i<6;$i++){
                                $form .='<div class="col-md-2 p-0">
                                    <input class="form-control digit-input code-input" name="code[]" value="" type="text" dt-len="1" dt-total="6" dt-type="N">
                                </div>';
                            }
                                $form .='</div><div class="clearfix"></div><br>
                              <button type="submit" class="btn btn-primary pull-right">Submit</button>
                          </div>
                      </div>
              </form>
            </div></div>
            <div class="clearfix"></div><br><br>';
    return $form;
    }
    function tbt_activate($arg)
    {
        $ws =& get_instance();
        $module = $arg['module'];
        $secret = $arg['secret'];
        $secretEncrypt = $arg['secretEncrypt'];
        $backupCode = $arg['backupCode'];
        $backupCodeEncoded = $arg['backupCodeEncrypt'];
        $user_id = $arg['user_id'];
        $code = $arg['code'];
        if(is_array($code)) $code = implode("",$code);
        include_once('google2fa.php');
        $ga = new GoogleAuthenticator();
        $checkResult = $ga->verifyCode($secret, $code, 2);    // 2 = 2*30sec clock tolerance
        if($checkResult)
        {
            $isUpdated = update_query(WST_CLIENTS,['two_fa_auth_enable'=>'YES','two_fa_auth_key'=>$secretEncrypt,'two_fa_auth_backup_code'=>$backupCodeEncoded,'two_fa_auth_module'=>$module],['id'=>$user_id]);
            $SessionInfo = $ws->Account->GetCurrentUser();
            $isAdmin = $SessionInfo->is_admin;
            $closeBtn = '';
            $closeBtn = '<button type="button" class="close" data-dismiss="modal">&times;</button>';
             $form='<div class="modal-header">
                      <h5 class="modal-title">Enable Two-Factor Authentication</h5>
                      '.$closeBtn.'
                  </div>
                <div class="modal-body">                            
                  <div class="col-md-12 pull-left google_two_auth_qrcode_form">
                    <div class="alert alert-success text-center"> Two-Factor Authentication is now enabled</div>
                    <h3 style="margin-top:25px;">Backup Code</h3>
                    <p>The backup code is needed to access your account in the event you cannot complete two-factor authentication.</p>
                    <div style="margin: 20px auto;padding: 10px;background-color: #efefef;color: #444;text-align: center;">
                            Your Backup Code is    <span style="display:block;font-family:monospace;font-size:1.6em;">
                                '.(chunk_split($backupCode, 4, ' ')).'    </span>
                    </div>
                    <p>Treat the backup code the same as you would your password. We recommend saving it with a password manager.</p>                              
                  </div>
               </div>
               <div class="clearfix"></div><br><br>';
            return array('status'=>'success','message'=>$form);            
        }
        return array('status'=>'error','message'=>'QR Code Validation Failed');
    }  
    function tbt_verification($arg)
    {
        $user_id = $arg['user_id'];
        $user_name = $arg['user_name'];
        $first_name = $arg['first_name'];
        $last_name = $arg['last_name'];
        return 'Dear '.$arg['user_name'].', please enter your One Time Password below';
    }
    function tbt_verified($arg)
    {
        $user_id = $arg['user_id'];
        $user_name = $arg['user_name'];
        $first_name = $arg['first_name'];
        $last_name = $arg['last_name'];
        $code = $arg['code'];
        if(is_array($code)) $code = implode("",$code);
        $secret = $arg['secret'];
        $secretEncrypt = $arg['secretEncrypt'];
        include_once('google2fa.php');
        $ga = new GoogleAuthenticator();
        $checkResult = $ga->verifyCode($secretEncrypt, $code, 2);    // 2 = 2*30sec clock tolerance
        if(!$checkResult) return ['status'=>'error','message'=>'2FA Code Validation Failed...'];
         return ['status'=>'success','message'=>'2FA Validated Successfully....'];
    }