<?php
function yubico_class_load()
{
    require_once __DIR__ . "/lib/Auth/Otp.php";
}
function yubico_config($arg=[])
{
    return [
        "name" => "Yubico",
        "description" => "Yubico is a hardware based solution which requires each of your users to use a YubiKey to authenticate and complete the login process.",
        "version" => "1.0",
        "author" => "WHASOLS",
        "author_url" => "", 
        "configs"=>[       
            "clientid" => ["Name" => "Client ID", "Type" => "text", "Size" => "10", "Description" => "Setup Your YubiKey if you haven't already @ https://upgrade.yubico.com/getapikey/"],
            "secretkey" => ["Name" => "Secret Key", "Type" => "text", "Size" => "50", "Description" => ""]
        ]
    ];
}
function yubico_link($arg)
{
    return "";
}
function yubico_input()
{
     $html = '<div class="clearfix"></div>
        <style>
        .code-input{
            text-align:center;
            width:90%!important;
        }
        </style> 
        <div class="pull-left row">
            <div class="col-md-2 p-0">
                <input class="form-control" name="code" type="text">
            </div>
        </div><div class="clearfix"></div><br>';
        return $html;     
}
function yubico_send($arg)
{
    $ws =& get_instance();
    yubico_class_load();
    $apiID = (int) $arg["clientid"];
    $signatureKey = $arg["secretkey"];
    $verifyError = isset($arg["verifyError"]) ? $arg["verifyError"] : "";
    $SessionInfo = $ws->Account->GetCurrentUser();
    $isAdmin = $SessionInfo->is_admin;
    $closeBtn = '';
    $closeBtn = '<button type="button" class="close" data-dismiss="modal">&times;</button>';
     $form='<div class="modal-header">
              <h5 class="modal-title">Enable Two-Factor Authentication</h5>
              '.$closeBtn.'
          </div>
        <div class="modal-body">    
            <p>To associate your Yubico Key with your account, simply click into the text field below and press the button on your Yubico Key USB Device.  The system will detect and validate your key upon submission to the next step.</p><div class="clearfix"></div><br>'.($verifyError ? "<div class=\"alert alert-danger\">".$verifyError . "</div>" : "").'
                <div class="col-md-12"><b>Yubico Key</b><br>
                    <input type="password" name="code" size="50" id="yubicoprefix" class="form-control" placeholder="Click Here & Activate Yubico Key" autofocus>
                </div>
                 <div class="col-md-12">
                 <div class="clearfix"></div><br>
                     <p align="center">
                        <input type="submit" value="Activate &raquo;" class="btn btn-primary"/>
                     </p>
                </div>
        </div>
        <div class="clearfix"></div><br><br>';
        return $form; 
}
function yubico_activate($arg)
{
    $ws =& get_instance();
    yubico_class_load();
    $apiID = (int) $arg["clientid"];
    $signatureKey = $arg["secretkey"];
    $otp = isset($arg["post_vars"]["secret"]) ? $arg["post_vars"]["secret"] : "";
    $invalid = false;
    $otp = trim(trim($otp, "\""));
    $optToLog = substr($otp, 0, 3) . str_repeat("*", strlen($otp) - 6) . substr($otp, -3);
    $token = new Yubico\Auth\Otp($apiID, $signatureKey);
    try {
        $verifySuccess = $token->verify($otp, true, false, NULL, 20);
        logModuleCall("yubico", "activate", array("otp" => $optToLog), $token->getLastResponse());
    } catch (Exception $e)
    {
        $verifySuccess = false;
    }
    if (!$verifySuccess) return array('status'=>'error','message'=>'The YubiKey value entered could not be validated successfully. Please try again.');
    $module = $arg['module'];
    $user_id = $arg['user_id'];
    $backupCode = $arg['backupCode'];
    $backupCodeEncoded = $arg['backupCodeEncrypt']; 
    $secretEncrypt = $arg['secretEncrypt'];
    $backupCode = substr($otp, 0, 12);
    $isUpdated = update_query(WST_CLIENTS,['two_fa_auth_enable'=>'YES','two_fa_auth_key'=>$secretEncrypt,'two_fa_auth_backup_code'=>$backupCode,'two_fa_auth_module'=>$module],['id'=>$user_id]);
    $SessionInfo = $ws->Account->GetCurrentUser();
    $isAdmin = $SessionInfo->is_admin;
    $closeBtn = '';
    $closeBtn = '<button type="button" class="close" data-dismiss="modal">&times;</button>';
     $form='<div class="modal-header">
              <h5 class="modal-title">Enable Two-Factor Authentication</h5>
              '.$closeBtn.'
          </div>
        <div class="modal-body">                            
          <div class="col-md-12 pull-left google_two_auth_qrcode_form">
            <div class="alert alert-success text-center"> Two-Factor Authentication is now enabled</div>
            <h3 style="margin-top:25px;">Backup Code</h3>
            <p>The backup code is needed to access your account in the event you cannot complete two-factor authentication.</p>
            <div style="margin: 20px auto;padding: 10px;background-color: #efefef;color: #444;text-align: center;">
                    Your Backup Code is    <span style="display:block;font-family:monospace;font-size:1.6em;">
                        '.(chunk_split($backupCode, 4, ' ')).'    </span>
            </div>
            <p>Treat the backup code the same as you would your password. We recommend saving it with a password manager.</p>                              
          </div>
       </div>
       <div class="clearfix"></div><br><br>';
    return array('status'=>'success','message'=>$form); 
}
function yubico_verification($arg)
{
    $user_id = $arg['user_id'];
    $user_name = $arg['user_name'];
    $first_name = $arg['first_name'];
    $last_name = $arg['last_name'];
    return 'Dear '.$arg['user_name'].', please enter your Yubico One Time Password below';
}
function yubico_verify($arg)
{
    yubico_class_load();
    $user_id = $arg['user_id'];
    $UserInfo = getUserInfoById($user_id);
    $yubicoprefix = isset($UserInfo->two_fa_auth_backup_code) ? $UserInfo->two_fa_auth_backup_code:"";
    $apiID = (int) $arg["clientid"];
    $signatureKey = $arg["secretkey"];
    $otp = $arg['code'];
    if(is_array($otp)) $otp = implode("",$otp);
    $otp = trim(trim($otp, "\""));
    $optToLog = substr($otp, 0, 3) . str_repeat("*", strlen($otp) - 6) . substr($otp, -3);
    $token = new Yubico\Auth\Otp($apiID, $signatureKey);
    if ($token->verify($otp, true, false, NULL, 20))
    {
        logModuleCall("yubico", "verify", array("otp" => $optToLog), $token->getLastResponse());
        if (substr($otp, 0, 12) == $yubicoprefix) return ['status'=>'success','message'=>'2FA Yubico Validated Successfully....'];
        return ['status'=>'error','message'=>'2FA Yubico Validation Failed...'];
    }
    logModuleCall("yubico", "verify", array("otp" => $optToLog), $token->getLastResponse());
    return ['status'=>'error','message'=>'2FA Yubico Validation Failed...'];
}