<?php
/***************************************************************************
// *                                                                       *
// * Autorelease Provisioning (v1.0).                                      *
// * This Provisioning module enables you to manage VPS & Dedicated Servers*
//   which managed by third party and third party have no api.             *
// * For assistance on how to use and setup Autorelease, visit             *
//   @see https://dev.whasols.com/provisioning-modules/parameters/         *
// *                                                                       *
// *************************************************************************
// *                                                                       *
// * Contributed by: modulesarena                                          *
// * Website: https://modulesarena.com                                     *
// *                                                                       *
// *************************************************************************/
function autorelease_config()
{
    $depts = [];
    $depts[0] = "Select Department";
    $result = GetSupportDepartments();
    foreach($result as $data) $depts[$data->id] =ucfirst($data->name);
    $adminUsers = [];
    $adminUsers[0] = "Select Admin";
    $admins = GetAdminsList();
    foreach ($admins as $admin)
    {
        $id = $admin["id"];
        $adminUsers[$id] = $id." | ".$admin["full_name"]." (".$admin["username"].")";
    }
    $options = ["None"=>"None","Todo"=>"Add To-Do List Item","Ticket"=>"Create Support Ticket"];
    return [
        "name" => "Auto Release",
        "version" => "1.0",
        "configs"=>[
        "CreateAction" => ["Name"=>"Create Action","Type" => "dropdown", "Options" =>$options],
        "SuspendAction" => ["Name"=>"Suspend Action","Type" => "dropdown", "Options" =>$options],
        "UnsuspendAction" => ["Name"=>"Unsuspend Action","Type" => "dropdown", "Options" =>$options],
        "TerminateAction" => ["Name"=>"Terminate Action","Type" => "dropdown", "Options" =>$options],
        "RenewAction"=>["Name"=>"Renew Action","Type" => "dropdown", "Options" =>$options],
        "SupportDeptId" => ["Name"=>"Support Dept ID","Type" => "dropdown", "Options" => $depts],
        "AdminId" => ["Name"=>"Admin ID","Type" => "dropdown", "Options" => $adminUsers, "Description" => " Select the Admin User the API commands will be run as"]
        ]
    ];
}
function autorelease_AddTicket($params)
{
    $ws =& get_instance();
    $user_id = $params["clientsdetails"]["userid"];
    $name = $params["clientsdetails"]["username"];
    $email = $params["clientsdetails"]["email"];
    $department = $params['product']['configurations']["SupportDeptId"];
    $name = $params["title"];
    $message = $params["description"];
    if($department<1) return "Select a Support Department in the product Module Settings";
    $isDone = $ws->Support->support_tickets_creation('ADMIN', $user_id, $name, $email, $subject, $department,"Low","", $message,"NO");
    if($isDone[0] == 1) return "success";
    return "An Error Occurred communicating with the API:".$isDone[1]; 
}
function autorelease_AddTodo($params)
{
    $ws =& get_instance();
    $AdminId = $params['product']['configurations']["AdminId"];
    if($AdminId<1) return "Please select a Admin ID in the product Module Settings";
    return $ws->Todo->TodoAddEdit(["title"=>$params["title"],"note"=>$params["description"],"date"=>date('Y-m-d'),"admin_id"=>$AdminId]);
}
function autorelease_CreateAccount($params)
{
    $action = "autorelease_Add".$params['product']['configurations']["CreateAction"];
    if($action == "autorelease_AddNone") return "success";
    $params["title"] = "Service Provisioned";
    $params["description"] = "Service ID # " . $params["serviceid"] . " was just auto provisioned";
    return $action($params);
}
function autorelease_SuspendAccount($params)
{
    $action = "autorelease_Add".$params['product']['configurations']["SuspendAction"];
    if($action == "autorelease_AddNone") return "success";
    $params["title"] = "Service Suspension";
    $params["description"] = "Service ID # " . $params["serviceid"] . " requires suspension";
    return $action($params);
}
function autorelease_UnsuspendAccount($params)
{
    $action = "autorelease_Add".$params['product']['configurations']["UnsuspendAction"];
    if($action == "autorelease_AddNone") return "success";
    $params["title"] = "Service Reactivation";
    $params["description"] = "Service ID # " . $params["serviceid"] . " requires unsuspending";
    return $action($params);
}
function autorelease_TerminateAccount($params)
{
    $action = "autorelease_Add".$params['product']['configurations']["TerminateAction"];
    if($action == "autorelease_AddNone") return "success";
    $params["title"] = "Service Termination";
    $params["description"] = "Service ID # " . $params["serviceid"] . " requires termination";
    return $action($params);
}
function autorelease_Renew($params)
{
    $action = "autorelease_Add".$params['product']['configurations']["RenewAction"];
    if($action == "autorelease_AddNone") return "success";
    $params["title"] = "Service Renewal";
    $params["description"] = "Service ID # " . $params["serviceid"] . " was just renewed";
    return $action($params);
}