<?php
function interworx_config($params=[])
{
    return array(
        "name" => "InterWorx",
        "description" => "cpanel Hosting control panel",
        "version" => "1.0",
        "author" => "WHMSOLS",
        "author_url"=>"https://whmsols.com",
        "RequiresServer"=>true,//true or false
        "AutoGenerateUsernameAndPassword"=>true,//true or false
        "DefaultNonSSLPort"=>'2080',
        "DefaultSSLPort"=>'2443',
        "WebmailSSLPort"=>'',
        "WebmailNonSSLPort"=>'',
        "ServiceSingleSignOnLabel"=>'',
        "AdminSingleSignOnLabel"=>'',
        //"PackagesLoader"=>'PackagesLoader',
        "configs" => [
            "configoption1" => ["Name"=>"Package Name","Type" => "text", "Size" => "25"],
            "configoption2" => ["Name"=>"Theme","Type" => "text", "Size" => "25"],
            "configoption3"=>["Name"=>"Disk & BW Overselling","Type" => "yesno", "Description" => "If reseller, tick to allow"]
        ]);
}
function interworx_ClientArea($params)
{
    $serverhost = $params["serverhostname"] ?: $params["serverip"];
    if ($params["type"] == "reseller")
    {
        $form = sprintf("<form action=\"%s%s:%s/nodeworx/index.php?action=login\" method=\"post\" target=\"_blank\">" . "<input type=\"hidden\" name=\"email\" value=\"%s\" />" . "<input type=\"hidden\" name=\"password\" value=\"%s\" />" . "<input type=\"submit\" value=\"%s\" class=\"button\" />" . "</form>", $params["serversecure"],$serverhost,$params["serverport"],$params["username"],$params["password"],"Login To Panel");
    }
    else
    {
        $form = sprintf("<form action=\"%s%s:%s/siteworx/index.php?action=login\" method=\"post\" target=\"_blank\">" . "<input type=\"hidden\" name=\"email\" value=\"%s\" />" . "<input type=\"hidden\" name=\"password\" value=\"%s\" />" . "<input type=\"hidden\" name=\"domain\" value=\"%s\" />" . "<input type=\"submit\" value=\"%s\" class=\"button\" />" . "</form>", $params["serversecure"],$serverhost,$params["serverport"],$params["client"]["email"],$params["password"],$params["domain"],"Login To Panel");
    }
    return $form;
}
function interworx_AdminLink($params)
{
    $serverhost = $params["serverhostname"] ?: $params["serverip"];
    $form = sprintf("<form action=\"%s://%s:%s/nodeworx/\" method=\"post\" target=\"_blank\">" . "<input type=\"submit\" value=\"%s\" />" . "</form>", $params["serverhttpprefix"],$serverhost, $params["serverport"], "InterWorx Panel");
    return $form;
}
function interworx__getSoapClient($params)
{
    if ($params["serverhostname"])
    {
        $serverhost = $params["serverhostname"];
        $soapParams = array();
    }
    else
    {
        $serverhost = $params["serverip"];
        $opts = array("ssl" => array("verify_peer" => false, "verify_peer_name" => false));
        $soapParams = array("stream_context" => stream_context_create($opts));
    }
    $wsdl = $params["serverhttpprefix"] . "://" . $serverhost . ":" . $params["serverport"] . "/nodeworx/soap?wsdl";
    return new SoapClient($wsdl, $soapParams);
}
function interworx_CreateAccount($params)
{
    $product = $params["product"];
    $configurations = $product["configurations"];
    $key = $params["serveraccesshash"];
    $api_controller = "/nodeworx/siteworx";
    $input = array();
    if ($params["configoptions"]["Dedicated IP"])
    {
        $action = "listDedicatedFreeIps";
        $client = interworx__getsoapclient($params);
        $result = $client->route($key, $api_controller, $action, $input);
        logModuleCall("interworx", $action, $input, $result);
        if ($result["status"]) return ["status"=>"error","message"=>$result["status"] . " - " . $result["payload"]];
    }
    else
    {
        $action = "listFreeIps";
        $client = interworx__getsoapclient($params);
        $result = $client->route($key, $api_controller, $action, $input);
        logModuleCall("interworx", $action, $input, $result);
        if ($result["status"]) return ["status"=>"error","message"=>$result["status"] . " - " . $result["payload"]];
    }
    $ipaddress = $result["payload"][0][0];
    if ($params["type"] == "reseller") {
        $overselling = $params["configoption3"] ? "1" : "0";
        $api_controller = "/nodeworx/reseller";
        $action = "add";
        $input = array("nickname" => strtolower($params["client"]["firstname"] . $params["client"]["lastname"]), "email" => $params["client"]["email"], "password" => $params["password"], "confirm_password" => $params["password"], "language" => "en-us", "theme" => $configurations["configoption2"], "billing_day" => "1", "status" => "active", "packagetemplate" => $configurations["configoption1"], "RSL_OPT_OVERSELL_STORAGE" => $overselling, "RSL_OPT_OVERSELL_BANDWIDTH" => $overselling, "ips" => $ipaddress, "database_servers" => "localhost");
        UpdateServiceInfo(["user_name" => $params["client"]["email"]],$params["serviceid"]);
    } else {
        $action = "add";
        $input = array("domainname" => $params["domain"], "ipaddress" => $ipaddress, "uniqname" => $params["username"], "nickname" => strtolower($params["client"]["firstname"] . $params["client"]["lastname"]), "email" => $params["client"]["email"], "password" => $params["password"], "confirm_password" => $params["password"], "language" => "en-us", "theme" => $configurations["configoption2"], "packagetemplate" => $configurations["configoption1"]);
    }
    $client = interworx__getsoapclient($params);
    $result = $client->route($key, $api_controller, $action, $input);
    logModuleCall("interworx", $action, $input, $result);
    if ($result["status"]) return ["status"=>"error","message"=>$result["status"] . " - " . $result["payload"]];
    return ["status"=>"success","message"=>"Account Created Successfully"];
}
function interworx_TerminateAccount($params)
{
    $key = $params["serveraccesshash"];
    if ($params["type"] == "reseller")
    {
        $resellers = interworx_GetResellers($params);
        $email = $params["client"]["email"];
        $resellerid = $resellers[$email];
        if (!$resellerid) return ["status"=>"error","message"=>"Reseller ID Not Found"];

        $api_controller = "/nodeworx/reseller";
        $action = "delete";
        $input = array("reseller_id" => $resellerid);
    } else {
        $api_controller = "/nodeworx/siteworx";
        $action = "delete";
        $input = array("domain" => $params["domain"], "confirm_action" => "1");
    }
    $client = interworx__getsoapclient($params);
    $result = $client->route($key, $api_controller, $action, $input);
    logModuleCall("interworx", $action, $input, $result);
    if ($result["status"]) return ["status"=>"error","message"=>$result["status"] . " - " . $result["payload"]];
    return ["status"=>"success","message"=>"Account Terminated Successfully"];
}
function interworx_SuspendAccount($params)
{
    $key = $params["serveraccesshash"];
    if ($params["type"] == "reseller")
    {
        $resellers = interworx_GetResellers($params);
        $email = $params["client"]["email"];
        $resellerid = $resellers[$email];
        if (!$resellerid) return ["status"=>"error","message"=>"Reseller ID Not Found"];
        $api_controller = "/nodeworx/reseller";
        $action = "edit";
        $input = array("reseller_id" => $resellerid, "status" => "inactive");
    } else {
        $api_controller = "/nodeworx/siteworx";
        $action = "edit";
        $input = array("domain" => $params["domain"], "status" => "0");
    }
    $client = interworx__getsoapclient($params);
    $result = $client->route($key, $api_controller, $action, $input);
    logModuleCall("interworx", $action, $input, $result);
    if ($result["status"]) return ["status"=>"error","message"=>$result["status"] . " - " . $result["payload"]];
    return ["status"=>"success","message"=>"Account Suspended Successfully"];
}
function interworx_UnsuspendAccount($params)
{
    $key = $params["serveraccesshash"];
    if ($params["type"] == "reseller") {
        $resellers = interworx_GetResellers($params);
        $email = $params["client"]["email"];
        $resellerid = $resellers[$email];
        if (!$resellerid) return ["status"=>"error","message"=>"Reseller ID Not Found"];
        $api_controller = "/nodeworx/reseller";
        $action = "edit";
        $input = array("reseller_id" => $resellerid, "status" => "active");
    } else {
        $api_controller = "/nodeworx/siteworx";
        $action = "edit";
        $input = array("domain" => $params["domain"], "status" => "1");
    }
    $client = interworx__getsoapclient($params);
    $result = $client->route($key, $api_controller, $action, $input);
    logModuleCall("interworx", $action, $input, $result);
    if ($result["status"]) return ["status"=>"error","message"=>$result["status"] . " - " . $result["payload"]];
    return ["status"=>"success","message"=>"Account UnSuspended Successfully"];
}
function interworx_ChangePassword($params)
{
    $key = $params["serveraccesshash"];
    if ($params["type"] == "reseller") {
        $resellers = interworx_GetResellers($params);
        $email = $params["client"]["email"];
        $resellerid = $resellers[$email];
        if (!$resellerid) return ["status"=>"error","message"=>"Reseller ID Not Found"];
        $api_controller = "/nodeworx/reseller";
        $action = "edit";
        $input = array("reseller_id" => $resellerid, "password" => $params["password"], "confirm_password" => $params["password"]);
    } else {
        $api_controller = "/nodeworx/siteworx";
        $action = "edit";
        $input = array("domain" => $params["domain"], "password" => $params["password"], "confirm_password" => $params["password"]);
    }
    $client = interworx__getsoapclient($params);
    $result = $client->route($key, $api_controller, $action, $input);
    logModuleCall("interworx", $action, $input, $result);
    if ($result["status"]) return ["status"=>"error","message"=>$result["status"] . " - " . $result["payload"]];
    return ["status"=>"success","message"=>"Account Password Changed Successfully"];
}
function interworx_ChangePackage($params)
{
    $product = $params["product"];
    $configurations = $product["configurations"];    
    $key = $params["serveraccesshash"];
    if ($params["type"] == "reseller") {
        $resellers = interworx_GetResellers($params);
        $email = $params["client"]["email"];
        $resellerid = $resellers[$email];
        if (!$resellerid) return ["status"=>"error","message"=>"Reseller ID Not Found"];
        $overselling = $params["configoption3"] ? "1" : "0";
        $api_controller = "/nodeworx/reseller";
        $action = "edit";
        $input = array("reseller_id" => $resellerid, "package_template" => $configurations["configoption1"], "RSL_OPT_OVERSELL_STORAGE" => $overselling, "RSL_OPT_OVERSELL_BANDWIDTH" => $overselling);
    } else {
        $api_controller = "/nodeworx/siteworx";
        $action = "edit";
        $input = array("domain" => $params["domain"], "package_template" => $params["configoption1"]);
    }
    $client = interworx__getsoapclient($params);
    $result = $client->route($key, $api_controller, $action, $input);
    logModuleCall("interworx", $action, $input, $result);
    if ($result["status"]) return ["status"=>"error","message"=>$result["status"] . " - " . $result["payload"]];
    return ["status"=>"success","message"=>"Account Package Changed Successfully"];
}
function interworx_GetResellers($params)
{
    $key = $params["serveraccesshash"];
    $api_controller = "/nodeworx/reseller";
    $action = "listIds";
    $input = array();
    $client = interworx__getsoapclient($params);
    $result = $client->route($key, $api_controller, $action, $input);
    logModuleCall("interworx", $action, $input, $result);
    $resellers = array();
    foreach ($result["payload"] as $reseller)
    {
        list($resellerid, $reselleremail) = $reseller;
        $reselleremail = explode("(", $reselleremail, 2);
        $reselleremail = $reselleremail[1];
        $reselleremail = substr($reselleremail, 0, -1);
        $resellers[$reselleremail] = $resellerid;
    }
    return $resellers;
}

function interworx_UsageUpdate($params)
{
    $key = $params["serveraccesshash"];
    $api_controller = "/nodeworx/siteworx";
    $action = "listBandwidthAndStorageInMB";
    $input = array();
    $client = interworx__getsoapclient($params);
    $result = $client->route($key, $api_controller, $action, $input);
    logModuleCall("interworx", $action, $input, $result);
    $domainsdata = $result["payload"];
    $serverid = $params["serverid"];
    $count = 0;
    foreach ($domainsdata as $data)
    {
        $domain = $data["domain"];
        $bandwidth_used = $data["bandwidth_used"];
        $bandwidth = $data["bandwidth"];
        $storage_used = $data["storage_used"];
        $storage = $data["storage"];
       $isUpdated =  UpdateServiceInfo([
          "disk_usage"=>Ws_SizeConvertToMb($storage_used),
          "disk_limit"=>Ws_SizeConvertToMb($storage),
          "bandwidth_usage"=>Ws_SizeConvertToMb($bandwidth_used),
          "bandwidth_limit"=>Ws_SizeConvertToMb($bandwidth),
          "email_accounts_limit"=>0,
          "domains_limit"=>0,
          "sub_domains_limit"=>0,
          "parked_domains_limit"=>0,
          "databases_limit"=>'',
          "databases_disk_limit"=>'',
          "databases_disk_usage"=>'',
          "databases_usage"=>'',
          "parked_domains_usage"=>'',
          "sub_domains_usage"=>'',
          "domains_usage"=>'',
          "email_accounts_usage"=>'',
          "last_update"=>Carbon::now()->format('Y-m-d h:i:s'),
        ],["server_id"=>$serverid, "domain_name"=>$domain,"status"=>"Active"]);
        if($isUpdated) $count++;
    }
    if($serverid > 0)
    {
        UpdateServerInfo(['remote_acct_usage'=>$count,'up_status'=>'Up','last_check_date'=>Carbon::now()->format('Y-m-d h:i:s')],['id'=>$serverid]);
    }
    if($count>0) return array('status'=>'success','message'=>$count.' Accounts Stats Updated....');
    return ["status"=>"error","message"=>"Account Stats Updation failed"];
}