<?php
if (!defined("WHMSOLS")) exit("This file cannot be accessed directly");
function mediacp_config($params=[])
{
    $configarray = [
        "configoption1" => ["Name"=>"Auth","Type" => "text", "Size" => "60", "Description" => "<br />You can find this in Cast-Control Administration -> API Key"],
        "configoption2" => ["Name"=>"System Path","Type" => "text", "Size" => "60", "Description" => "<br />The Full URL to the MediaCP. Example: http://mydomain.com/cast/"],
        "configoption3" => ["Name"=>"Service Type","Type" => "dropdown", "Options" => "shoutcast198,shoutcast2,icecast,windowsMediaServices,WowzaMedia,NoService", "Description" => "<br />Select the Media Service Type."],
        "configoption4" => ["Name"=>"Wowza Media Type","Type" => "dropdown", "Options" => ",Live Streaming,Ondemand Streaming,Shoutcast Restream", "Description" => "For Wowza Media Service Type ONLY."],
        "configoption5" => ["Name"=>"Max Users","Type" => "text", "Size" => "5", "Description" => "Maximum Number of Listeners/Viewers for this service."],
        "configoption6" => ["Name"=>"Max Bit Rate","Type" => "dropdown", "Options" => "24,32,40,48,56,64,80,96,112,128,160,192,224,256,320,400,480,560,640,720,800,920,1024,1280,1536,1792,99999", "Description" => "Maximum Bitrate Allowed by this service."],
        "configoption7" => ["Name"=>"Bandwidth","Type" => "text", "Size" => "5", "Description" => "MB - Data Transfer allowed per month (0 for unlimited)"],
        "configoption8" => ["Name"=>"Source","Type" => "dropdown", "Options" => ",sctransv1,sctransv2,ices04,ices20,streamTranscoderV3", "Description" => "Configure Source/AutoDJ Service.<br />Must be applied before creation or may break."],
        "configoption9" => ["Name"=>"Quota","Type" => "text", "Size" => "6", "Description" => "MB - Maximum Media File Storage Space for this service."],
        "configoption10" =>["Name"=>"SystemID","Type" => "text", "Size" => 5, "Description" => "Leave blank for default"],
        "configoption11" =>["Name"=>"Port 80 Proxy","Type" => "dropdown", "Options" => "Disabled,Enabled", "Description" => "Uses additional system resources."],
        "configoption12" => ["Name"=>"Messenger Controller","Type" => "dropdown", "Options" => "enabled", "Description" => "Messenger Controller is now always included with service."],
        "configoption13" => ["Name"=>"Trial Service?","Type" => "dropdown", "Description" => "Automatically expire after trial period.", "Options" => "disabled,+1 days,+2 days,+3 days,+4 days,+5 days,+6 days,+7 days,+8 days,+9 days,+10 days,+11 days,+12 days,+13 days,+14 days,+15 days,+20 days,+25 days,+30 days"],
        "configoption14" => ["Name"=>"Stream Auth","Type" => "dropdown", "Options" => "disabled,enabled", "Description" => "Currently only supports Shoutcast services."],
        "configoption15" => ["Name"=>"Assign as Reseller","Type" => "text", "Size" => "2", "Description" => "Enter a Plan ID from MediaCP or leave blank to create normal account."],
        "configoption16" => ["Name"=>"Create Media Service","Type" => "dropdown", "Description" => "Set to No for Reseller Accounts.", "Options" => "Yes,No"],
        "configoption17" => ["Name"=>"Additional Custom Fields","Type" => "dropdown", "Options" => "disabled,enabled", "Description" => "<br />Automatically fill out custom fields. Windows Media Services ONLY.<br />Create Custom Fields in WHMCS Tab above: <br />Publish Point Name<br />Service Type<br />Public Hostname / IP and Port (Pull Only)<br />Broadcasting Username<br />Broadcasting Password"]
    ];
    return array(
        "name" => "MediaCP",
        "description" => "MediaCP is a streaming platform for internet radio services.",
        "version" => "1.0",
        "author" => "WHMSOLS",
        "author_url"=>"https://whmsols.com",
        "RequiresServer"=>false,//true or false
        "AutoGenerateUsernameAndPassword"=>true,//true or false
        "DefaultNonSSLPort"=>'',
        "DefaultSSLPort"=>'',
        "WebmailSSLPort"=>'',
        "WebmailNonSSLPort"=>'',
        "ServiceSingleSignOnLabel"=>'',
        "AdminSingleSignOnLabel"=>'',
//        "PackagesLoader"=>'PackagesLoader',
        "configs" =>$configarray);
}
function mcp_generatePassword($length = 8)
{
    $password = "";
    $possible = "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUV";
    $i = 0;
    while ($i < $length) {
        $char = substr($possible, mt_rand(0, strlen($possible) - 1), 1);
        if (!strstr($password, $char)) {
            $password .= $char;
            $i++;
        }
    }
    return $password;
}
function mcp_getClientPassword($params=[], $update = false)
{
    $serviceid = $params["serviceid"];
    $userid = $params["userid"];
    $Results = full_query("select * from mediacp_castcontrol where user_id='$userid' and service_id='$serviceid'");
    if (empty($Results))
    {
        $password = mcp_generatepassword();
        insert_query("mediacp_castcontrol",["user_id" => $userid,"service_id" => $serviceid, "reference" => encrypt($password)]);
    }
    else
    {
        $password = decrypt($Results[0]->reference);
    }
    if ($update)
    {
        update_query("mediacp_castcontrol",["reference" => encrypt($password)],["user_id" =>$userid,"service_id" => $serviceid]);
    }
    return $password;
}
function mediacp_LoginLink($params)
{
    $product = $params["product"];
    $configurations = $product["configurations"];
    $code = sprintf("<a href=\"%s/?page=login\">%s</a>", $configurations["configoption2"], "Login to Cast-Control");
    return $code;
}
function mediacp_CreateAccount($params)
{
    global $debug;
    $product = $params["product"];
    $configurations = $product["configurations"];    
    $updateData = array();

    if (!empty($params["domain"]) && is_numeric($params["domain"]))
    {
        $api["args"]["portbase"] = $params["domain"];
        $api["args"]["unique_id"] = $params["domain"];
    }
    if (!strstr($params["domain"], "terminated") && !empty($params["domain"]))
        return ["status"=>"error","message"=>"You have already created the account, Please Terminate the account first"];

    $api["path"] = $configurations["configoption2"];
    $api["rpc"] = "admin.user_create";
    $api["args"]["auth"] = $configurations["configoption1"];
    $api["args"]["username"] = trim($params["client"]["email"]);
    $api["args"]["hash"] = SHA1($api["args"]["username"] . mcp_getclientpassword($params));
    $api["args"]["user_email"] = trim($params["client"]["email"]);
    if (is_numeric($configurations["configoption15"])) $api["args"]["reseller_plan"] = $configurations["configoption15"];
    $return = mediacp_api($api);
    if ($return["status"] != "success" && $return["error"] != "User account already exists")
    {
        return ["status"=>"error","message"=>$return["error"]];
    }
    $___url = parse_url($configurations["configoption2"]);
    $updateData["user_name"] = $api["args"]["username"];
    $updateData["password"] = mcp_getclientpassword($params);
    UpdateServiceInfo($updateData,$params["serviceid"]);
    if ($configurations["configoption16"] == "No") return ["status"=>"success","message"=>"Account Created Successfully"];

    if ($configurations["configoption4"] != "") $api["args"]["customfields"]["servicetype"] = $configurations["configoption4"];

    $result3 = full_query("select a.id,a.relid,a.optionid,a.qty,c.title as ctitle,b.title as btitle from hosting_config_options a join products_config_groups_options_childs c on a.optionid=c.id join products_config_groups_options b on c.cid=b.id where a.relid=".$params["serviceid"]);
    foreach($result3 as $data3)
    {
        $optionid = $data3["optionid"];
        $configid = $data3["configid"];
        $optionvalue = $data3["ctitle"];
        $optionname = $data3["btitle"];

        $optionvalue = str_replace("MB", "", $optionvalue);
        $optionvalue = str_replace("KB", "", $optionvalue);
        $optionvalue = str_replace("Kbps", "", $optionvalue);
        $optionvalue = trim($optionvalue);
        if ($optionvalue == "Yes") {
            $optionvalue = "enabled";
        } else {
            if ($optionvalue == "No") {
                $optionvalue = "disabled";
            } else {
                if (strtolower($optionvalue) == "unlimited") {
                    $optionvalue = "0";
                }
            }
        }
        if ($optionname == "Maximum Users") {
            $params["product"]["configurations"]["configoption5"] = $optionvalue;
        } else {
            if ($optionname == "Maximum Bit Rate" || $optionname == "Maximum Bitrate") {
                $params["product"]["configurations"]["configoption6"] = $optionvalue;
            } else {
                if ($optionname == "Bandwidth") {
                    if (strstr($optionvalue, "GB")) {
                        $optionvalue = str_replace("GB", "", $optionvalue * 1024);
                    }
                    if (strstr($optionvalue, "TB")) {
                        $optionvalue = str_replace("TB", "", $optionvalue * 1024 * 1024);
                    }
                    $params["product"]["configurations"]["configoption7"] = $optionvalue;
                } else {
                    if ($optionname == "Service Type") {
                        if ($optionvalue == "Disabled" || $optionvalue == "") {
                            $optionvalue == "";
                        }
                        if (strtolower($optionvalue) == "shoutcast") {
                            $optionvalue = "shoutcast198";
                        }
                        if (strtolower($optionvalue) == "icecast") {
                            $optionvalue = "icecast";
                        }
                        if (strstr($optionvalue, "Wowza Media Server")) {
                            $optionvalue = "WowzaMedia";
                        }
                        if (strstr($optionvalue, "Windows Media Service")) {
                            $optionvalue = "WowzaMedia";
                        }
                        if (strstr($optionvalue, "CDS Service")) {
                            $optionvalue = "NoService";
                        }
                        $params["product"]["configurations"]["configoption5"] = $optionvalue;
                    } else {
                        if ($optionname == "Source") {
                            if ($optionvalue == "Disabled" || $optionvalue == "") {
                                $optionvalue == "";
                            }
                            $params["product"]["configurations"]["configoption8"] = $optionvalue;
                        } else {
                            if ($optionname == "Quota" || strstr($optionname, "Disk Quota")) {
                                if (strstr($optionvalue, "MB")) {
                                    $optionvalue = str_replace("MB", "", $optionvalue);
                                }
                                if (strstr($optionvalue, "GB")) {
                                    $optionvalue = str_replace("GB", "", $optionvalue * 1024);
                                }
                                if (strstr($optionvalue, "TB")) {
                                    $optionvalue = str_replace("TB", "", $optionvalue * 1024 * 1024);
                                }
                                $params["product"]["configurations"]["configoption9"] = $optionvalue;
                            } else {
                                if ($optionname == "Port 80 Proxy") {
                                    $params["product"]["configurations"]["configoption11"] = $optionvalue;
                                } else {
                                    if ($optionname == "MSN Service Control" || $optionname == "Messenger Service Control") {
                                        $params["product"]["configurations"]["configoption12"] = $optionvalue;
                                    } else {
                                        if ($optionname == "Wowza Media Type" || $optionname == "Flash Media Type") {
                                            if (strpos($optionvalue, "Shoutcast") !== false)
                                            {
                                                $api["args"]["customfields"]["servicetype"] = "Shoutcast";
                                            }
                                            else
                                            {
                                                $api["args"]["customfields"]["servicetype"] = $optionvalue;
                                            }
                                        } else {
                                            if ($optionname == "Source Reencode") {
                                                $api["args"]["customfields"]["ices_reencode"] = $optionvalue;
                                            } else {
                                                if ($optionname == "Permit Ondemand" || $optionname == "Ondemand Service") {
                                                    $api["args"]["customfields"]["permit_ondemand"] = $optionvalue;
                                                } else {
                                                    if ($optionname == "Ondemand Service") {
                                                        $api["args"]["customfields"]["permit_ondemand"] = strtolower($optionvalue) == "allowed" ? 1 : 0;
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    $product = $params["product"];
    $configurations = $product["configurations"];    
    $api["path"] = $configurations["configoption2"];
    $api["rpc"] = "admin.service_create";
    $api["args"]["rpc_extra"] = 1;
    $api["args"]["auth"] = $configurations["configoption1"];
    $api["args"]["plan"] = false;
    $api["args"]["userid"] = $return["id"];
    $api["args"]["password"] = mcp_getclientpassword($params);
    $api["args"]["adminpassword"] = mcp_getclientpassword($params);
    $api["args"]["plugin"] = $configurations["configoption3"];
    $api["args"]["maxuser"] = $configurations["configoption5"];
    $api["args"]["bitrate"] = $configurations["configoption6"];
    $api["args"]["bandwidth"] = $configurations["configoption7"];
    $api["args"]["sourceplugin"] = $configurations["configoption8"];
    $api["args"]["quota"] = $configurations["configoption9"];
    $api["args"]["proxy"] = $configurations["configoption11"];
    $api["args"]["messengercontrol"] = $configurations["configoption12"];
    $api["args"]["streamauth"] = $configurations["configoption14"];
    $__PPN = "Publish Point Name";
    $__POP = "Service Type";
    $__SL = "Public Hostname / IP and Port (Pull Only)";
    $__SUN = "Broadcasting Username";
    $__SPW = "Broadcasting Password";
    $SCLocation = "Shoutcast Address";
    if (isset($params["customfields"][$SCLocation])) {
        $api["args"]["customfields"]["shoutcast_address"] = $params["customfields"][$SCLocation];
    }
    if (isset($params["customfields"][$__PPN]) && 4 < strlen($params["customfields"][$__PPN])) {
        $api["args"]["customfields"]["publish_name"] = $params["customfields"][$__PPN];
        $api["args"]["unique_id"] = $params["customfields"][$__PPN];
    }
    if (isset($params["customfields"][$__POP]) && strtolower($params["customfields"][$__POP]) == "pull" && isset($params["customfields"][$__SL]) && (substr($params["customfields"][$__SL], 0, 6) == "mms://" || substr($params["customfields"][$__SL], 0, 7) == "http://")) {
        $api["args"]["customfields"]["sourcelocation"] = $params["customfields"][$__SL];
    }
    if (isset($params["customfields"][$__POP]) && strtolower($params["customfields"][$__POP]) == "ondemand") {
        $api["args"]["customfields"]["sourcelocation"] = "Ondemand:";
        $api["args"]["customfields"]["permit_ondemand"] = 1;
    }
    if (!empty($configurations["configoption13"]) && $configurations["configoption13"] != "disabled") {
        $api["args"]["expire"] = strtotime($configurations["configoption13"]);
    }
    if (!empty($configurations["configoption10"])) {
        $api["args"]["systemid"] = $configurations["configoption10"];
        $api["args"]["system_id"] = $configurations["configoption10"];
    }
    $return = mediacp_api($api);
    if ($return["status"] != "success") return ["status"=>"error","message"=>$return["error"]];

    $updateData = array();
    if ($configurations["configoption17"] == "enabled")
    {
        $pid = $params["pid"];
        $relid = $params["serviceid"];
        CreateCustomFields(["relid"=>$pid,"type"=>$params["type"],"fieldname"=>$__PPN,"fieldtitle"=>$__PPN,"description"=>$__PPN,"fieldtype"=>"text"]);
        CreateCustomFields(["relid"=>$relid,"type"=>$params["type"],"fieldname"=>$__SUN,"fieldtitle"=>$__SUN,"description"=>$__SUN,"fieldtype"=>"text"]);
        CreateCustomFields(["relid"=>$relid,"type"=>$params["type"],"fieldname"=>$__SPW,"fieldtitle"=>$__SPW,"description"=>$__SPW,"fieldtype"=>"text"]);
        AddCustomFields(["pid"=>$pid,"relid"=>$relid,"field"=>[$__PPN=>$return["serverData"]["publish_name"]]]);
        AddCustomFields(["pid"=>$pid,"relid"=>$relid,"field"=>[$__SUN=>$return["serverData"]["windows_username"]]]);
        AddCustomFields(["pid"=>$pid,"relid"=>$relid,"field"=>[$__SPW=>$return["serverData"]["password"]]]);
    }    
    UpdateServiceInfo(["domain_name"=>$___url["host"] . ":" . $return["portbase"]],$relid);
    return ["status"=>"success","message"=>"Account Created Successfully"];
}
function mediacp_TerminateAccount($params)
{
    global $debug;
    $PortBaseArray = explode(":", $params["domain"]);
    $PortBase = $PortBaseArray[1];
    $api["args"]["auth"] = $params["configoption1"];
    $api["path"] = $params["configoption2"];
    $api["rpc"] = "admin.service_remove";
    $api["args"]["unique_id"] = trim($PortBase);
    $return = mediacp_api($api);
    if ($return["status"] != "success" && $return["error"] != "Could not locate service") {
        return $return["error"];
    }
    $params["model"]->serviceProperties->save(array("domain" => $params["domain"] . ":terminated"));
    return "success";
}
function mediacp_SuspendAccount($params)
{
    global $debug;
    $product = $params["product"];
    $configurations = $product["configurations"];    
    $PortBaseArray = explode(":", $params["domain"]);
    $PortBase = $PortBaseArray[1];
    $api["args"]["auth"] = $configurations["configoption1"];
    $api["path"] = $configurations["configoption2"];
    $api["rpc"] = "admin.service_suspend";
    $api["args"]["unique_id"] = trim($PortBase);
    $api["args"]["Reason"] = "Suspended indefinitely by billing system";
    $api["args"]["Days"] = 9999999999999.0;
    $return = mediacp_api($api);
    if ($return["status"] != "success") return ["status"=>"error","message"=>$return["error"]];
    return ["status"=>"success","message"=>"Suspended Successfully"];
}
function mediacp_UnsuspendAccount($params)
{
    global $debug;
    $product = $params["product"];
    $configurations = $product["configurations"];    
    $PortBaseArray = explode(":", $params["domain"]);
    $PortBase = $PortBaseArray[1];
    $api["args"]["auth"] = $configurations["configoption1"];
    $api["path"] = $configurations["configoption2"];
    $api["rpc"] = "admin.service_unsuspend";
    $api["args"]["unique_id"] = trim($PortBase);
    $api["start"] = true;
    $return = mediacp_api($api);
    if ($return["status"] != "success") return ["status"=>"error","message"=>$return["error"]];
    return ["status"=>"success","message"=>"UnSuspended Successfully"];
}
function mediacp_AdminCustomButtonArray()
{
    $buttonarray = array("Start" => "start", "Stop" => "stop", "Update Package" => "ChangePackage");
    return $buttonarray;
}
function mediacp_start($params)
{
    global $debug;
    $product = $params["product"];
    $configurations = $product["configurations"];    
    $PortBaseArray = explode(":", $params["domain"]);
    $PortBase = $PortBaseArray[1];
    $api["args"]["auth"] = $configurations["configoption1"];
    $api["path"] = $configurations["configoption2"];
    $api["rpc"] = "service.start";
    $api["args"]["unique_id"] = trim($PortBase);
    $return = mediacp_api($api);
    if ($return["status"] != "success") return ["status"=>"error","message"=>$return["error"]];
    return ["status"=>"success","message"=>"Started Successfully"];
}
function mediacp_stop($params)
{
    global $debug;
    $product = $params["product"];
    $configurations = $product["configurations"];    
    $PortBaseArray = explode(":", $params["domain"]);
    $PortBase = $PortBaseArray[1];
    $api["args"]["auth"] = $configurations["configoption1"];
    $api["path"] = $configurations["configoption2"];
    $api["rpc"] = "service.stop";
    $api["args"]["unique_id"] = trim($PortBase);
    $return = mediacp_api($api);
    if ($return["status"] != "success") return ["status"=>"error","message"=>$return["error"]];
    return ["status"=>"success","message"=>"Stopped Successfully"];
}
function mediacp_ChangePassword($params)
{
    $userid = $params["userid"];
    $serviceid = $params["serviceid"];
    $product = $params["product"];
    $configurations = $product["configurations"];    
    $api["args"]["auth"] = $configurations["configoption1"];
    $api["path"] = $configurations["configoption2"];
    $api["rpc"] = "admin.user_update";
    $api["args"]["username"] = trim($params["client"]["email"]);
    $api["args"]["hash"] = SHA1($api["args"]["username"] . $params["password"]);
    $return = mediacp_api($api);
    if ($return["status"] != "success") return ["status"=>"error","message"=>$return["error"]];
    update_query("mediacp_castcontrol",["reference" => encrypt($params["password"])],["user_id" =>$userid,"service_id" => $serviceid]);
    return ["status"=>"success","message"=>"Password Changed Successfully"];
}
function mediacp_ClientArea($params)
{
    $product = $params["product"];
    $configurations = $product["configurations"];    
    $form = sprintf("<form action=\"%s/?page=login\" method=\"post\" target=\"_blank\">" . "<input type=\"hidden\" name=\"username\" value=\"%s\" />" . "<input type=\"hidden\" name=\"user_password\" value=\"%s\" />" . "<input type=\"submit\" name=\"login_submit\" value=\"%s\" />" . "</form>", $configurations["configoption2"],$params["username"],$params["password"], "Login to Control Panel");
    return $form;
}
function mediacp_ChangePackage($params)
{
    $product = $params["product"];
    $configurations = $product["configurations"];    
    $PortBaseArray = explode(":", $params["domain"]);
    $PortBase = $PortBaseArray[1];
    $api["args"]["auth"] = $configurations["configoption1"];
    $api["path"] = $configurations["configoption2"];
    $api["rpc"] = "admin.service_update";
    $api["args"]["unique_id"] = trim($PortBase);
    $api["args"]["maxuser"] = $params["configoption4"];
    $api["args"]["bitrate"] = $params["configoption5"];
    $api["args"]["bandwidth"] = $params["configoption6"];
    $api["args"]["sourceplugin"] = $params["configoption7"];
    $api["args"]["quota"] = $params["configoption8"];
    $api["args"]["proxy"] = $params["configoption10"];
    $api["args"]["messengercontrol"] = $params["configoption11"];
    $api["args"]["system_id"] = $params["configoption9"];
    $return = mediacp_api($api);
    if ($return["status"] != "success") return ["status"=>"error","message"=>$return["error"]];
    return ["status"=>"success","message"=>"Package Changed Successfully"];
}
function mediacp_ClientAreaCustomButtonArray()
{
    $servercustombuttons = array("stop" => "stop", "start" => "start");
    return $servercustombuttons;
}
function mediacp_api($api)
{
    include_once "XMLRPC.class.php";
    $client = new IXR_Client($api["path"] . "/system/rpc.php");
    if (isset($_GET["debug"]))
    {
        $client->debug = true;
        echo "Integration Version: " . date("d-m-Y.", filemtime(__FILE__)) . "<br />\n";
        print_r($api);
        echo "<br />\n";
    }
    if (!$client->query($api["rpc"], $api["args"])) return ["status"=>"error","error"=>"An error occurred - " . $client->getErrorCode() . ":" . $client->getErrorMessage()];
    return $client->getResponse();
}