<?php
use Carbon\Carbon;
    function plesk_config($params=[])
    {
        $resellerSimpleMode = _s("producttype",$params,"reseller");
        $configarray = array(
            "configoption1" => array("Name" =>"Plan Name", "Type" => "text", "Size" => "25","SimpleMode" => true),
            "configoption2" => array("Name" =>"Reseller Plan Name", "Type" => "text", "Size" => "25","SimpleMode" => $resellerSimpleMode),
            "configoption3" => array("Name" =>"IP Address", "Type" => "dropdown", "Options" => "IPv4 shared; IPv6 none,IPv4 dedicated; IPv6 none,IPv4 none; IPv6 shared,IPv4 none; IPv6 dedicated,IPv4 shared; IPv6 shared,IPv4 shared; IPv6 dedicated,IPv4 dedicated; IPv6 shared,IPv4 dedicated; IPv6 dedicated", "Default" => "IPv4 shared; IPv6 none", "Description" => "", "SimpleMode" => true),
            "configoption4" => array("Name" =>"Power Mode", "Type" => "yesno", "Description" =>"Power Mode of plesk")
            );

        return array(
            "name" => "Plesk",
            "description" => "This provisioning module allows you to create (maintain) Plesk's Panel accounts",
            "version" => "1.0",
            "author" => "WHMSOLS",
            "author_url"=>"https://whmsols.com",
            "RequiresServer"=>true,//true or false
            "AutoGenerateUsernameAndPassword"=>true,//true or false
            "DefaultNonSSLPort"=>'',
            "DefaultSSLPort"=>'',
            "WebmailSSLPort"=>'',
            "WebmailNonSSLPort"=>'',
            "ServiceSingleSignOnLabel"=>'',
            "AdminSingleSignOnLabel"=>'',
            "ListAccountsUniqueIdentifierDisplayName"=>'Domain',
            "ListAccountsUniqueIdentifierField"=>'domain',
            "ListAccountsProductField"=>'configoption1',
            "PasswordGenerationSpecialCharacters"=>'!@#\$%^&*?_~',
            "PackagesLoader"=>'PackagesLoader',
            "configs" =>$configarray);
    }
    function plesk_AdminLink($params)
    {
        $address = $params["serverhostname"] ? $params["serverhostname"] : $params["serverip"];
        $port = $params["serveraccesshash"] ? $params["serveraccesshash"] : "8443";
        $secure = $params["serversecure"];
        if (empty($address)) return "";
        $form = sprintf("<form action=\"%s%s:%s/login_up.php3\" method=\"post\" target=\"_blank\">" . "<input type=\"hidden\" name=\"login_name\" value=\"%s\" />" . "<input type=\"hidden\" name=\"passwd\" value=\"%s\" />" . "<input type=\"submit\" value=\"%s\">" . "</form>", $secure,$address,$port,$params["serverusername"],$params["serverpassword"], "Login to panel");
        return $form;
    }
    function plesk_ClientArea($params)
    {
        return array(
            'templatefile' => 'overview.tpl',
            'templatepath' => 'modules/servers/plesk/',
            'vars' => array(
                'test1' => 'hello',
                'test2' => 'world',
            ),
        );    
    }    
    function plesk_call($params,$post = [],$command="",$method="POST")
    {
        $serveraccesshash = $params["serveraccesshash"];
        $serverhostname = $params["serverhostname"];
        $serverport = $params["serverport"];
        $serverusername = $params["serverusername"];
        $serverpassword = $params["serverpassword"];
        $serveraccesshash = base64_encode($serverusername.":".$serverpassword);
        if(empty($serverhostname)) return ["status"=>"error","message"=>"API Hostname Missing"];
        if(empty($serverport)) return ["status"=>"error","message"=>"API Port Missing"];
//        if(empty($serveraccesshash)) return ["status"=>"error","message"=>"API Token Missing"];
        $sUrl = "https://".$params["serverhostname"].":". $params['serverport'] ."/api/v2/".$command;
        $curl = curl_init();
        curl_setopt_array($curl, array(
          CURLOPT_URL => $sUrl,
          CURLOPT_RETURNTRANSFER => true,
          CURLOPT_ENCODING => '',
          CURLOPT_MAXREDIRS => 10,
          CURLOPT_TIMEOUT => 0,
          CURLOPT_FOLLOWLOCATION => true,
          CURLOPT_SSL_VERIFYHOST => 0,
          CURLOPT_SSL_VERIFYPEER => 0,
          CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
          CURLOPT_CUSTOMREQUEST => $method,
          CURLOPT_POSTFIELDS =>json_encode($post),
          CURLOPT_HTTPHEADER => array(
            'Authorization: Basic '.$serveraccesshash,
            'Content-Type: application/json',
          ),
        ));
        $response = curl_exec($curl);
        if (curl_errno($curl)) return ["status"=>"error","message"=>curl_error($curl)];
        curl_close($curl);
        $response = json_decode($response,true);
        return $response;
    }    
    function plesk_types($type="")
    {
        if(empty($type)) return "customer";
        if($type == "hosting") return "customer";
        return "reseller";
        
    }
    function plesk_customer_info($params)
    {
        $id = 0;
        $account = Illuminate\Database\Capsule\Manager::table("mod_pleskaccounts")->where("userid", $params["client"]["userid"])->where("usertype",$params["type"])->first();
        if(!empty($account)) $id = $account->panelexternalid;
        return $id;
    }
    function plesk_customer_add($params)
    {
        $panelExternalId = plesk_customer_info($params);
        if($panelExternalId == 0)
        {
            $type = plesk_types($params["type"]);
            $postParameters = [
                "name"=>$params["client"]["username"],
                "company"=>$params["client"]["companyname"],
                "login"=>$params["username"],
                "status"=>0,
                "email"=>$params["client"]["email"],
                "locale"=>"en-US",
                "owner_login"=>$params["serverusername"],
                "external_id"=>"whmsols_".$params["client"]["uuid"],
                "description"=>"Client Name:".$params["client"]["username"]." From ".$params["client"]["country"]." ".$params["client"]["state"]." ".$params["client"]["city"],
                "password"=>$params["password"],
                "type"=>$type,
                ];
            $result = plesk_call($params,$postParameters,"clients","POST");
            if(array_key_exists("id",$result))
            {
                $id = $result["id"];
                $guid = $result["guid"];
                $panelExternalId = $id.":".$guid;
                Illuminate\Database\Capsule\Manager::table("mod_pleskaccounts")->insert(array("userid" => $params["client"]["userid"], "usertype" => $params["type"], "panelexternalid" => $panelExternalId));
                return ["status"=>"success","message"=>"Customer Added Successfully"];
            }
            return ["status"=>"error","message"=>$result["message"].": ".json_encode($result["errors"])];
        }
        return ["status"=>"success","message"=>"Customer Already Exist"];
    }
    function plesk_customer_status_change($params)
    {
        $statusName = ($params["plesk_status"] == 1) ? 'Suspended':'Unsuspended';
        $accountId = plesk_customer_info($params);
        $CustomerId = explode(":",$accountId);
        if($CustomerId[0]>0)
        {
            $type = plesk_types($params["type"]);
            $postParameters = [
                "name"=>$params["client"]["username"],
                "company"=>$params["client"]["companyname"],
                "login"=>$params["username"],
                "status"=>$params["plesk_status"],
                "email"=>$params["client"]["email"],
                "owner_login"=>$params["serverusername"],
                "external_id"=>"whmsols_".$params["client"]["uuid"],
                "description"=>"Client Name:".$params["client"]["username"]." From ".$params["client"]["country"]." ".$params["client"]["state"]." ".$params["client"]["city"],
                ];
            $result = plesk_call($params,$postParameters,"clients/".$CustomerId[0],"PUT");
            if(array_key_exists("id",$result))
            {
                $id = $result["id"];
                $guid = $result["guid"];
                $panelExternalId = $id.":".$guid;
                return ["status"=>"success","message"=>"Account ".$statusName." Successfully"];
            }
            return ["status"=>"error","message"=>$result["message"].": ".json_encode($result["errors"])];
        }
        return ["status"=>"success","message"=>"Customer doesn't Exist"];
    }
    function plesk_site_add($params)
    {
        $accountId = plesk_customer_info($params);
        $CustomerId = explode(":",$accountId);
        $ftp_user = $params["username"]."_main";
        $postParameters = [
            "name"=>$params["domain"],
            "description"=>$params["client"]["companyname"],
            "hosting_type"=>"virtual",
            "hosting_settings"=>["ftp_login"=>$ftp_user,"ftp_password"=>$params["password"]],
            "owner_client"=>["id"=>$CustomerId[0],"login"=>$params["username"],"guid"=>$CustomerId[1],"external_id"=>$CustomerId[1]],
            "ipv4"=>[$params["serveripaddress"]],
            "plan"=>["name"=>$params["product"]["package"]]
            ];
        $result = plesk_call($params,$postParameters,"domains","POST");
        if(array_key_exists("id",$result))
        {
            $id = $result["id"];
            $guid = $result["guid"];
            $panelExternalId = $id.":".$guid;
            $isFieldExist = GetCustomFieldInfo($params["pid"],"PleskExternelId");
            if(empty($isFieldExist))
            {
                $CreateCustomFields = [
                    "relid"=>$params["pid"],
                    "type"=>$params["type"],
                    "fieldtype"=>$params["text"],
                    "order"=>1,
                    "fieldname"=>"PleskExternelId",
                    "fieldtitle"=>"Plesk Externel ID",
                    "description"=>"Plesk Externel ID",
                ];
                CreateCustomFields($CreateCustomFields);
            }
            AddCustomFields(["pid"=>$params["pid"],"relid"=>$params["serviceid"],"field"=>["PleskExternelId"=>$panelExternalId]]);
            return ["status"=>"success","message"=>"Site Added Successfully"];
        }
        return ["status"=>"error","message"=>$result["message"].": ".json_encode($result["errors"])];
    }
    function plesk_CreateAccount($params)
    {
        $isCustomerAdded = plesk_customer_add($params);
        if($isCustomerAdded["status"] == "error") return $isCustomerAdded;
        $accountId = plesk_customer_info($params);
        $CustomerId = explode(":",$accountId);
        $isSiteAdded = plesk_site_add($params);
        if($isSiteAdded["status"] == "error") return $isSiteAdded;
        return ["status"=>"success","message"=>"Account Created Successfully"];
    }
function plesk_SuspendAccount($params)
{
    $params["plesk_status"]=1;
    return plesk_customer_status_change($params);
}
function plesk_UnsuspendAccount($params)
{
    $params["plesk_status"]=0;
    return plesk_customer_status_change($params);
}
function plesk_TerminateAccount($params)
{
    $accountId = plesk_customer_info($params);
    $CustomerId = explode(":",$accountId);
    $postParameters=[];
    $result = plesk_call($params,$postParameters,"clients/".$CustomerId[0],"DELETE");
    if(array_key_exists("id",$result))
    {
        $panelExternalId = $CustomerId[0].":".$CustomerId[1];
        delete_query("mod_pleskaccounts",["userid" => $params["client"]["userid"], "panelexternalid" => $panelExternalId]);
        return ["status"=>"success","message"=>"Account Terminated Successfully"];
    }
    return ["status"=>"error","message"=>$result["message"].": ".json_encode($result["errors"])];
}
function plesk_ChangePassword($params)
{
    $accountId = plesk_customer_info($params);
    $CustomerId = explode(":",$accountId);
    $postParameters = ["login"=>$params["username"],"password"=>$params["password"]];
    $result = plesk_call($params,$postParameters,"clients/".$CustomerId[0],"PUT");
    if(array_key_exists("id",$result))
    {
        return ["status"=>"success","message"=>"Account Password Changed Successfully"];
    }
    return ["status"=>"error","message"=>$result["message"].": ".json_encode($result["errors"])];
}
function plesk_ChangePackage($params)
{
    $params["product"]["package"];
    $accountId = plesk_customer_info($params);
    $CustomerId = explode(":",$accountId);
    if($CustomerId[0]>0)
    {
        $isFieldExist = GetCustomFieldValue($params["serviceid"],"PleskExternelId");
        if(empty($isFieldExist)) return ["status"=>"error","message"=>"Account Relation id with plesk not found"];
        $SiteId = explode(":",$isFieldExist->value);
        $postParameters = [
            "name"=>$params["domain"],
            "owner_client"=>["id"=>$CustomerId[0],"login"=>$params["username"],"guid"=>$CustomerId[1],"external_id"=>$CustomerId[1]],
            "plan"=>["name"=>$params["product"]["package"]],
            ];
        $result = plesk_call($params,$postParameters,"domains/".$SiteId[0],"PUT");
        if(array_key_exists("id",$result))
        {
            return ["status"=>"success","message"=>"Account Package Changed Successfully"];
        }
        return ["status"=>"error","message"=>$result["message"].": ".json_encode($result)];
    }
    return ["status"=>"success","message"=>"Customer doesn't Exist"];
}
function plesk_AdminServicesTabFields($params)
{
    //$data = http_build_query(array("userid" => $params["userid"], "id" => $params["serviceid"], "modop" => "custom", "ac" => "DetermineUserState", "token" => generate_token("plain")));
    //$javascript = "<div id=\"pleskUserState\"></div>\n<script>\n    const targetElement = jQuery(\"div#pleskUserState\");\n    jQuery(document).ready(function() {\n        WHMCS.http.jqClient.jsonPost({\n            url: \"clientsservices.php\",\n            data: \"" . $data . "\",\n            success: function(data) {\n                targetElement.text(data.string);\n            }\n        });\n    });\n</script>";
   // return array("" => $javascript);
}
function plesk_TestConnection($params)
{
    $postParameters = [];
    $result = plesk_call($params,$postParameters,"server","GET");
    if(array_key_exists("guid",$result)) return ["status"=>"success"];
    return ["status"=>"error","message"=>$result["message"].": ".json_encode($result)];
}

    function plesk_ListAccounts($params)
    {
        $postParameters = [];
        $results = plesk_call($params,$postParameters,"clients","GET");
        if (array_key_exists("code", $results)) return ["status"=>"error","message"=>$resellerAccountsUsage["message"]];
        $count = 0;
        $accounts = [];
        if(!empty($results))
        {
            foreach ($results as $row)
            {
                $serviseid = str_replace('whmsols_','',@$row["external_id"]);
                if($serviseid > 0)
                {
                    $count++;
                    $login = $row["login"];
                    $GetServiceInfo = Illuminate\Database\Capsule\Manager::table("hosting")->where("user_name",$login)->first();
                    $GetItemInfo = Illuminate\Database\Capsule\Manager::table("products_list")->where("id",$GetServiceInfo->package_id)->first();
                    $status = "Active";
                    if ($row["status"] == 1) $status = "Suspended";
                    $accounts[] = [
                        "name" => $row["name"],
                        "email" => $row["email"],
                        "username" =>$GetServiceInfo->user_name,
                        "domain" => $GetServiceInfo->domain_name,
                        "uniqueIdentifier" =>$GetServiceInfo->domain_name,
                        "product" =>$GetItemInfo->server_package_name,
                        "primaryip" => $params["serverip"],
                        "created" =>date('Y-m-d',strtotime($row["created"])),
                        "status" => $status
                    ];
                }
            }
            return ["status"=>"success","accounts" => $accounts];
        }
        return ["status"=>"error","message"=>"Account not found"];
    }
function plesk_GetUserCount(array $params)
{
    $totalCount = $ownedAccounts = 0;
    $postParameters = [];
    $resellerAccountsUsage = plesk_call($params,$postParameters,"clients","GET");
    if (array_key_exists("code", $resellerAccountsUsage)) return ["status"=>"error","message"=>$resellerAccountsUsage["message"]];
    if(!empty($resellerAccountsUsage))
    {
        foreach ($resellerAccountsUsage as $usage)
        {
            $type = $usage["type"];
            $serviseid = str_replace('whmsols_','',@$usage["external_id"]);
            if ($serviseid>0)
            {
                $totalCount++;
                if($type == "customer") $ownedAccounts++;
            }
        }
    }
    return ["status"=>"success","totalAccounts"=>$totalCount,"ownedAccounts"=>$ownedAccounts];
}
function plesk_UsageUpdate($params)
{
    $serverid = $params["serverid"];
    $count = 0;
    $postParameters = [];
    $resellerAccountsUsage = plesk_call($params,$postParameters,"clients","GET");
    if(!empty($resellerAccountsUsage))
    {
        foreach ($resellerAccountsUsage as $usage)
        {
            $serviseid = str_replace('whmsols_','',@$usage["external_id"]);
            if ($serviseid>0)
            {
                $isUpdated =  UpdateServiceInfo([
                "disk_usage" =>0,
                "disk_limit" =>0,
                "bandwidth_usage" =>0,
                "bandwidth_limit" =>0,
                "email_accounts_limit"=>0,
                "domains_limit"=>0,
                "sub_domains_limit"=>0,
                "parked_domains_limit"=>0,
                "databases_limit"=>'',
                "databases_disk_limit"=>'',
                "databases_disk_usage"=>'',
                "databases_usage"=>'',
                "parked_domains_usage"=>'',
                "sub_domains_usage"=>'',
                "domains_usage"=>'',
                "email_accounts_usage"=>'',
                "last_update"=>Carbon::now()->format('Y-m-d h:i:s')],["id"=>$serviseid]);
                if($isUpdated) $count++;
            }
        }
    }

    if($serverid > 0)
    {
        UpdateServerInfo(['remote_acct_usage'=>$count,'up_status'=>'Up','last_check_date'=>Carbon::now()->format('Y-m-d h:i:s')],['id'=>$serverid]);
    }
    if($count>0) return array('status'=>'success','message'=>$count.' Accounts Stats Updated....');
    return ["status"=>"error","message"=>"Account Stats Updation failed"];
}
function plesk_GetRemoteMetaData(array $params)
{
    $version = "-";
    $loads = array("fifteen" => "0", "five" => "0", "one" => "0");
    $maxUsers = "0";
    return ["status"=>"success","version"=>$version,"load"=>$loads,"max_accounts"=>$maxUsers];
}
function plesk_RenderRemoteMetaData(array $params)
{
    $metaData = $arg["remoteData"];
    if ($metaData) {
        $version = "Unknown";
        $loadOne = $loadFive = $loadFifteen = 0;
        $maxAccounts = "Unlimited";
        if (array_key_exists("version", $metaData)) {
            $version = $metaData["version"];
        }
        if (array_key_exists("load", $metaData)) {
            $loadOne = $metaData["load"]["one"];
            $loadFive = $metaData["load"]["five"];
            $loadFifteen = $metaData["load"]["fifteen"];
        }
        if (array_key_exists("max_accounts", $metaData) && 0 < $metaData["max_accounts"]) {
            $maxAccounts = $metaData["max_accounts"];
        }
        return "Plesk Version: " . $version . "<br>\nLoad Averages: " . $loadOne . " " . $loadFive . " " . $loadFifteen . "<br>\nLicense Max # of Accounts: " . $maxAccounts;
    }
    return "";
}