<?php
function tcadmin_config($params=[])
{
    return array(
        "name" => "TCAdmin",
        "description" => "A game hosting control panel supporting game and voice.",
        "version" => "1.0",
        "author" => "WHMSOLS",
        "author_url"=>"https://whmsols.com",
        "RequiresServer"=>false,//true or false
        "AutoGenerateUsernameAndPassword"=>true,//true or false
        "DefaultNonSSLPort"=>'',
        "DefaultSSLPort"=>'',
        "WebmailSSLPort"=>'',
        "WebmailNonSSLPort"=>'',
        "ServiceSingleSignOnLabel"=>'',
        "AdminSingleSignOnLabel"=>'',
//        "PackagesLoader"=>'PackagesLoader',
        "configs" => [
            "configoption1" =>["Name"=>"Game ID","Type" => "text", "Size" => "25", "Description" => "Leave blank for none"],
            "configoption2" =>["Name"=>"Game Slots","Type" => "text", "Size" => "10", "Description" => ""],
            "configoption3" =>["Name"=>"Game Private","Type" => "yesno", "Description" => "Tick if Private"],
            "configoption4" =>["Name"=>"Game Additional Slots","Type" => "text", "Size" => "10"],
            "configoption5" =>["Name"=>"Game Is Branded","Type" => "yesno", "Description" => "Tick for Branded"],
            "configoption6" =>["Name"=>"Additional Arguments","Type" => "text", "Size" => "25"],
            "configoption7" =>["Name"=>"Voice ID","Type" => "text", "Size" => "25", "Description" => "Leave blank for none"],
            "configoption8" =>["Name"=>"Voice Slots","Type" => "text", "Size" => "25"],
            "configoption9" =>["Name"=>"Voice Private","Type" => "yesno", "Description" => "Tick if Private"],
            "configoption10" => ["Name"=>"Voice Additional Slots","Type" => "text", "Size" => "10"],
            "configoption11" =>["Name"=>"Game Datacenter","Type" => "text", "Size" => "20", "Description" => "Only required for automatic installation"]
        ]);
}
function tcadmin_CreateAccount($params)
{
    $product = $params["product"];
    $configurations = $product["configurations"];

    $datacenter = $configurations["configoption11"];
    if ($params["configoptions"]["Game Slots"]) {
        $params["product"]["configurations"]["configoption2"] = $params["configoptions"]["Game Slots"];
    }
    if ($params["configoptions"]["Game Private"]) {
        $params["product"]["configurations"]["configoption3"] = $params["configoptions"]["Game Private"];
    }
    if ($params["configoptions"]["Game Additional Slots"]) {
        $params["product"]["configurations"]["configoption4"] = $params["configoptions"]["Game Additional Slots"];
    }
    if ($params["configoptions"]["Game Branded"]) {
        $params["product"]["configurations"]["configoption5"] = $params["configoptions"]["Game Branded"];
    }
    if ($params["configoptions"]["Voice Slots"]) {
        $params["product"]["configurations"]["configoption8"] = $params["configoptions"]["Voice Slots"];
    }
    if ($params["configoptions"]["Voice Private"]) {
        $params["product"]["configurations"]["configoption9"] = $params["configoptions"]["Voice Private"];
    }
    if ($params["configoptions"]["Voice Additional Slots"]) {
        $params["product"]["configurations"]["configoption10"] = $params["configoptions"]["Voice Additional Slots"];
    }
    if ($params["customfields"]["Username"]) {
        $params["username"] = $params["customfields"]["Username"];
    }
    if ($params["customfields"]["Password"]) {
        $params["password"] = $params["customfields"]["Password"];
    }
    if ($params["customfields"]["Datacenter"]) {
        $datacenter = $params["customfields"]["Datacenter"];
    }
    if ($params["customfields"]["Host Name"]) {
        $hostname = $params["customfields"]["Host Name"];
    }
    if ($params["customfields"]["RCON Password"]) {
        $rconpw = $params["customfields"]["RCON Password"];
    }
    if ($params["customfields"]["Private Password"]) {
        $privatepw = $params["customfields"]["Private Password"];
    }
    if ($params["customfields"]["Voice Host Name"]) {
        $voicehostname = $params["customfields"]["Voice Host Name"];
    }
    if ($params["customfields"]["Voice RCON Password"]) {
        $voicerconpw = $params["customfields"]["Voice RCON Password"];
    }
    if ($params["customfields"]["Voice Private Password"]) {
        $voiceprivatepw = $params["customfields"]["Voice Private Password"];
    }
    if ($params["customfields"]["Game ID"]) {
        $params["product"]["configurations"]["configoption1"] = $params["customfields"]["Game ID"];
    }
    if ($params["customfields"]["Voice ID"]) {
        $params["product"]["configurations"]["configoption7"] = $params["customfields"]["Voice ID"];
    }
    if ($params["configoption7"] && !$params["configoption8"]) {
        $params["product"]["configurations"]["configoption8"] = $params["configoption2"];
    }
    $configurations = $params["product"]["configurations"];
    $userid = $params["client"]["userid"];
    $command = "tcadmin_username=" . $params["serverusername"] . "&";
    $command .= "tcadmin_password=" . $params["serverpassword"] . "&";
    $command .= "function=AddPendingSetup&";
    $command .= "response_type=XML&";
    $command .= "game_package_id=" . $params["serviceid"] . "&";
    $command .= "voice_package_id=" . $params["serviceid"] . "&";
    $command .= "client_id=" . $userid . "&";
    $command .= "user_email=" . $params["client"]["email"] . "&";
    $command .= "user_fname=" . $params["client"]["firstname"] . "&";
    $command .= "user_lname=" . $params["client"]["lastname"] . "&";
    $command .= "user_address1=" . $params["client"]["address1"] . "&";
    $command .= "user_address2=" . $params["client"]["address2"] . "&";
    $command .= "user_city=" . $params["client"]["city"] . "&";
    $command .= "user_state=" . $params["client"]["state"] . "&";
    $command .= "user_zip=" . $params["client"]["postcode"] . "&";
    $command .= "user_country=" . $params["client"]["country"] . "&";
    $command .= "user_phone1=" . $params["client"]["phonenumber"] . "&";
    $command .= "user_name=" . $params["username"] . "&";
    $command .= "user_password=" . $params["password"] . "&";
    if ($configurations["configoption3"]) {
        $params["product"]["configurations"]["configoption3"] = 1;
    } else {
        $params["product"]["configurations"]["configoption3"] = 0;
    }
    if ($configurations["configoption5"]) {
        $params["product"]["configurations"]["configoption5"] = 1;
    } else {
        $params["product"]["configurations"]["configoption5"] = 0;
    }
    if ($configurations["configoption9"]) {
        $params["product"]["configurations"]["configoption9"] = 1;
    } else {
        $params["product"]["configurations"]["configoption9"] = 0;
    }
    $configurations = $params["product"]["configurations"];
    $command .= "game_id=" . $configurations["configoption1"] . "&";
    $command .= "game_slots=" . $configurations["configoption2"] . "&";
    $command .= "game_private=" . $configurations["configoption3"] . "&";
    $command .= "game_additional_slots=" . $configurations["configoption4"] . "&";
    $command .= "game_branded=" . $configurations["configoption5"] . "&";
    $command .= "game_additional_arguments=" .$configurations["configoption6"] . "&";
    $command .= "voice_id=" . $configurations["configoption7"] . "&";
    $command .= "voice_slots=" . $configurations["configoption8"] . "&";
    $command .= "voice_private=" . $configurations["configoption9"] . "&";
    $command .= "voice_additional_slots=" . $configurations["configoption10"] . "&";
    if ($datacenter) {
        $command .= "skip_page=1&";
        $command .= "game_datacenter=" . $datacenter . "&";
        $command .= "game_hostname=" . $hostname . "&";
        $command .= "game_rcon_password=" . $rconpw . "&";
        $command .= "game_private_password=" . $privatepw . "&";
        $command .= "voice_hostname=" . $voicehostname . "&";
        $command .= "voice_rcon_password=" . $voicerconpw . "&";
        $command .= "voice_private_password=" . $voiceprivatepw . "&";
    } else {
        $command .= "skip_page=0&";
    }
    if ($params["serverhostname"]) {
        $domain = $params["serverhostname"];
    } else {
        $domain = $params["serverip"];
    }
    $retval = tcadminsendrequest($domain, $command);
    if (!isset($retval["RESULTS"]["ERRORCODE"])) {
        $result = "An unknown error occurred while connecting";
    } else {
        if ($retval["RESULTS"]["ERRORCODE"] != 0) {
            $result = $retval["RESULTS"]["ERRORCODE"] . " - " . $retval["RESULTS"]["ERRORTEXT"];
        } else {
            $result = "success";
        }
    }
    if($result != "success") return ["status"=>"error","message"=>$result];
    return ["status"=>"success","message"=>"Account Created Successfully"];
}
function tcadmin_SuspendAccount($params)
{
    $command = "tcadmin_username=" . $params["serverusername"] . "&";
    $command .= "tcadmin_password=" . $params["serverpassword"] . "&";
    $command .= "function=SuspendGameAndVoiceByBillingID&";
    $command .= "response_type=XML&";
    $command .= "client_package_id=" . $params["serviceid"] . "&";
    if ($params["serverhostname"]) {
        $domain = $params["serverhostname"];
    } else {
        $domain = $params["serverip"];
    }
    $retval = tcadminsendrequest($domain, $command);
    if (!isset($retval["RESULTS"]["ERRORCODE"])) {
        $result = "An unknown error occurred while connecting";
    } else {
        if ($retval["RESULTS"]["ERRORCODE"] != 0) {
            $result = $retval["RESULTS"]["ERRORCODE"] . " - " . $retval["RESULTS"]["ERRORTEXT"];
        } else {
            $result = "success";
        }
    }
    if($result != "success") return ["status"=>"error","message"=>$result];
    return ["status"=>"success","message"=>"Account Suspended Successfully"];
}
function tcadmin_UnsuspendAccount($params)
{
    $command = "tcadmin_username=" . $params["serverusername"] . "&";
    $command .= "tcadmin_password=" . $params["serverpassword"] . "&";
    $command .= "function=UnSuspendGameAndVoiceByBillingID&";
    $command .= "response_type=XML&";
    $command .= "client_package_id=" . $params["serviceid"] . "&";
    if ($params["serverhostname"]) {
        $domain = $params["serverhostname"];
    } else {
        $domain = $params["serverip"];
    }
    $retval = tcadminsendrequest($domain, $command);
    if (!isset($retval["RESULTS"]["ERRORCODE"])) {
        $result = "An unknown error occurred while connecting";
    } else {
        if ($retval["RESULTS"]["ERRORCODE"] != 0) {
            $result = $retval["RESULTS"]["ERRORCODE"] . " - " . $retval["RESULTS"]["ERRORTEXT"];
        } else {
            $result = "success";
        }
    }
    if($result != "success") return ["status"=>"error","message"=>$result];
    return ["status"=>"success","message"=>"Account UnSuspended Successfully"];
}
function tcadmin_TerminateAccount($params)
{
    $command = "tcadmin_username=" . $params["serverusername"] . "&";
    $command .= "tcadmin_password=" . $params["serverpassword"] . "&";
    $command .= "function=DeleteGameAndVoiceByBillingID&";
    $command .= "response_type=XML&";
    $command .= "client_package_id=" . $params["serviceid"] . "&";
    if ($params["serverhostname"]) {
        $domain = $params["serverhostname"];
    } else {
        $domain = $params["serverip"];
    }
    $retval = tcadminsendrequest($domain, $command);
    if (!isset($retval["RESULTS"]["ERRORCODE"])) {
        $result = "An unknown error occurred while connecting";
    } else {
        if ($retval["RESULTS"]["ERRORCODE"] != 0) {
            $result = $retval["RESULTS"]["ERRORCODE"] . " - " . $retval["RESULTS"]["ERRORTEXT"];
        } else {
            $result = "success";
        }
    }
    if($result != "success") return ["status"=>"error","message"=>$result];
    return ["status"=>"success","message"=>"Account Terminated Successfully"];
}
function tcadminsendrequest($url, $command)
{
    $url = "http://" . $url . "/billingapi.aspx";
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_TIMEOUT, 100);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $command);
    $retval = curl_exec($ch);
    if (curl_errno($ch)) {
        $result["RESULTS"]["ERRORCODE"] = "1";
        $result["RESULTS"]["ERRORTEXT"] = "Curl Error: " . curl_error($ch);
    } else {
        if ($retval) {
            $result = XMLtoARRAY($retval);
        } else {
            $result["RESULTS"]["ERRORCODE"] = "99";
            $result["RESULTS"]["ERRORTEXT"] = "No response received";
        }
    }
    curl_close($ch);
    if ($result["H1"]) {
        $result["RESULTS"]["ERRORCODE"] = "1";
        $result["RESULTS"]["ERRORTEXT"] = "Billing API File Not Found - Check Server IP Address";
    }
    $action = explode("function=", $command);
    $action = $action[1];
    $action = explode("&", $action);
    $action = $action[0];
    logModuleCall("tcadmin", $action, $command, $retval, $result);
    return $result;
}