<?php
function websitepanel_config($params=[])
{
    $soap_check_msg = "";
    if (!class_exists("SoapClient"))
    {
        $soap_check_msg = " This module requires the PHP SOAP extension which is not currently compiled into your PHP build.";
    }

    return array(
        "name" => "WebsitePanel",
        "description" => "A Windows hosting control panel for MSP's and hosting providers.",
        "version" => "1.0",
        "author" => "WHMSOLS",
        "author_url"=>"",
        "RequiresServer"=>true,//true or false
        "AutoGenerateUsernameAndPassword"=>true,//true or false
        "DefaultNonSSLPort"=>'',
        "DefaultSSLPort"=>'',
        "WebmailSSLPort"=>'',
        "WebmailNonSSLPort"=>'',
        "ServiceSingleSignOnLabel"=>'',
        "AdminSingleSignOnLabel"=>'',
//        "PackagesLoader"=>'PackagesLoader',
        "configs" => [
            "configoption1" =>["Name"=>"Package Name","Type" => "text", "Size" => "25", "Description" => $soap_check_msg],
            "configoption2" =>["Name"=>"Web Space Quota","Type" => "text", "Size" => "5", "Description" => "MB"],
            "configoption3" =>["Name"=>"Bandwidth Limit","Type" => "text", "Size" => "5", "Description" => "MB"],
            "configoption4" =>["Name"=>"PlanID","Type" => "text", "Size" => "3", "Description" => " *DNP Hosting Plan ID"],
            "configoption5" =>["Name"=>"Parent SpaceId","Type" => "text", "Size" => "3", "Description" => "* SpaceID that all accounts are created under"],
            "configoption6"=>["Name"=>"Enterprise Server Port","Type" => "text", "Size" => "5", "Description" => "* Required"],
            "configoption7" =>["Name"=>"Different Potal URL","Type" => "yesno", "Description" => "Tick if portal address is different to server address"],
            "configoption8" =>["Name"=>"Portal URL","Type" => "text", "Size" => "25", "Description" => "Portal URL, with http://, no trailing slash"],
            "configoption9" => ["Name"=>"Send DNP Account Summary email","Type" => "yesno", "Description" => "Tick to send DNP Account Summary"],
            "configoption10" =>["Name"=>"Send DNP Hosting Space Summary email","Type" => "yesno", "Description" => "Tick to send Hosting Space Summary"],
            "configoption11" => ["Name"=>"Create Mail account","Type" => "yesno", "Description" => "Tick to create mail account"],
            "configoption12" => ["Name"=>"Create FTP account","Type" => "yesno", "Description" => "Tick to create FTP account"],
            "configoption13" => ["Name"=>"Temporary domain","Type" => "yesno", "Description" => "Tick to create a temp domain"],
            "configoption14" => ["Name"=>"HTML email","Type" => "yesno", "Description" => "Tick enable HTML email from DNP"],
            "configoption15" => ["Name"=>"Create Website","Type" => "yesno", "Description" => "Tick to create Website"],
            "configoption16" => ["Name"=>"Count Bandwidth/Diskspace","Type" => "yesno", "Description" => "Tick to update diskpace/bandwidth in WHMSOLS"]
        ]);
}

function websitepanel_CreateAccount($params)
{
    $product = $params["product"];
    $configurations = $product["configurations"];    
    $serverip = $params["serverip"];
    $serverusername = $params["serverusername"];
    $serverpassword = $params["serverpassword"];
    $secure = $params["serversecure"];
    $domain = $params["domain"];
    $packagetype = $params["type"];
    $username = $params["username"];
    $password = $params["password"];
    $accountid = $params["accountid"];
    $packageid = $params["packageid"];
    $clientsdetails = $params["client"];
    $planId = $configurations["configoption4"];
    $parentPackageId = $configurations["configoption5"];
    $esport = $configurations["configoption6"];
    if ($configurations["configoption11"] == "yes") {
        $createMailAccount = true;
    } else {
        $createMailAccount = false;
    }
    if ($configurations["configoption9"] == "yes") {
        $sendAccountLetter = true;
    } else {
        $sendAccountLetter = false;
    }
    if ($configurations["configoption10"] == "yes") {
        $sendPackageLetter = true;
    } else {
        $sendPackageLetter = false;
    }
    if ($configurations["configoption13"] == "yes") {
        $tempDomain = true;
    } else {
        $tempDomain = false;
    }
    if ($configurations["configoption12"] == "yes") {
        $createFtpAccount = true;
    } else {
        $createFtpAccount = false;
    }
    if ($configurations["configoption14"] == "yes") {
        $htmlMail = true;
    } else {
        $htmlMail = false;
    }
    if ($configurations["configoption15"] == "yes") {
        $website = true;
    } else {
        $website = false;
    }
    $roleid = ($packagetype == "reseller") ? 2:3;

    $param = array("parentPackageId" => $parentPackageId, "username" => $username, "password" => $password, "roleId" => $roleid, "firstName" => $clientsdetails["firstname"], "lastName" => $clientsdetails["lastname"], "email" => $clientsdetails["email"], "htmlMail" => $htmlMail, "sendAccountLetter" => $sendAccountLetter, "createPackage" => true, "planId" => $planId, "sendPackageLetter" => $sendPackageLetter, "domainName" => $domain, "tempDomain" => $tempDomain, "createWebSite" => $website, "createFtpAccount" => $createFtpAccount, "ftpAccountName" => $username, "createMailAccount" => $createMailAccount);
    $result = websitepanel_call($params, "CreateUserWizard", $param);
    if($result !="success") return ["status"=>"error","message"=>$result];
    return ["status"=>"success","message"=>"Account Created Successfully"];
}
function websitepanel_call($params, $func, $param, $retdata = "")
{
    $wsdlfile = "esusers";
    if ($func == "CreateUserWizard" || $func == "GetMyPackages" || $func == "UpdatePackageLiteral" || $func == "GetPackageBandwidth" || $func == "GetPackageDiskspace") {
        $wsdlfile = "espackages";
    }
    $http = $params["serversecure"];
    $serverip = $params["serverip"];
    $serverusername = $params["serverusername"];
    $serverpassword = $params["serverpassword"];
    $esport = $params["configoption6"];
    $soapaddress = $http . $serverip . ":" . $esport . "/" . $wsdlfile . ".asmx?WSDL";
    if (!class_exists("SoapClient")) {
        return "SOAP is missing. Please recompile PHP with the SOAP module included.";
    }
    try {
        $client = new SoapClient($soapaddress, array("login" => $serverusername, "password" => $serverpassword));
        $result = (array) $client->{$func}($param);
    } catch (Exception $e) {
        logModuleCall("websitepanel", $func, $param, $e->getMessage());
        return "Caught exception: " . $e->getMessage();
    }
    logModuleCall("websitepanel", $func, $param, $result);
    if ($retdata) {
        return $result[$func . "Result"];
    }
    if (is_soap_fault($result)) {
        return "SOAP Fault Code: " . $result->faultcode . " - Error: " . $result->faultstring;
    }
    $returnCode = $result[$func . "Result"];
    if (0 <= $returnCode) {
        return "success";
    }
    if ($returnCode == "-1100") {
        return "User account with the specified username already exists on the server";
    }
    if ($returnCode == "-700") {
        return "Specified mail domain already exists on the service";
    }
    if ($returnCode == "-701") {
        return "Mail resource is unavailable for the selected hosting space";
    }
    if ($returnCode == "-502") {
        return "Specified domain already exists";
    }
    if ($returnCode == "-301") {
        return "The hosting space could not be deleted because it has child spaces";
    }
    return "WebsitePanel API Error Code: " . $returnCode;
}
function websitepanel_TerminateAccount($params)
{
    $wspuserid = websitepanel_getuserid($params);
    if (!$wspuserid) return ["status"=>"error","message"=>"Username '" . $params["username"] . "' not found in WebsitePanel"];
    $param = array("userId" => $wspuserid);
    $result = websitepanel_call($params, "DeleteUser", $param);
    if($result !="success") return ["status"=>"error","message"=>$result];
    return ["status"=>"success","message"=>"Account Terminated Successfully"];
}
function websitepanel_SuspendAccount($params)
{
    $wspuserid = websitepanel_getuserid($params);
    if (!$wspuserid) return ["status"=>"error","message"=>"Username '" . $params["username"] . "' not found in WebsitePanel"];
    $param = array("userId" => $wspuserid, "status" => "Suspended");
    $result = websitepanel_call($params, "ChangeUserStatus", $param);
    if($result !="success") return ["status"=>"error","message"=>$result];
    return ["status"=>"success","message"=>"Account Suspended Successfully"];
}
function websitepanel_UnsuspendAccount($params)
{
    $wspuserid = websitepanel_getuserid($params);
    if (!$wspuserid) return ["status"=>"error","message"=>"Username '" . $params["username"] . "' not found in WebsitePanel"];
    $param = array("userId" => $wspuserid, "status" => "Active");
    $result = websitepanel_call($params, "ChangeUserStatus", $param);
    if($result !="success") return ["status"=>"error","message"=>$result];
    return ["status"=>"success","message"=>"Account UnSuspended Successfully"];
}
function websitepanel_ChangePassword($params)
{
    $wspuserid = websitepanel_getuserid($params);
    if (!$wspuserid) return ["status"=>"error","message"=>"Username '" . $params["username"] . "' not found in WebsitePanel"];
    $param = array("userId" => $wspuserid, "password" => $params["password"]);
    $result = websitepanel_call($params, "ChangeUserPassword", $param);
    if($result !="success") return ["status"=>"error","message"=>$result];
    return ["status"=>"success","message"=>"Password Changed Successfully"];
}
function websitepanel_ChangePackage($params)
{
    $wspuserid = websitepanel_getuserid($params);
    if (!$wspuserid) return ["status"=>"error","message"=>"Username '" . $params["username"] . "' not found in WebsitePanel"];
    $param = array("packageId" => websitepanel_getpackageid($params, $wspuserid), "statusId" => 1, "planId" => $params["configoption4"], "purchaseDate" => date("c"), "packageName" => $params["configoption1"], "packageComments" => "");
    $result = websitepanel_call($params, "UpdatePackageLiteral", $param);
    if($result !="success") return ["status"=>"error","message"=>$result];
    return ["status"=>"success","message"=>"Package Changed Successfully"];
}
function websitepanel_ClientArea($params)
{
    $product = $params["product"];
    $configurations = $product["configurations"];    

    $username = $params["username"];
    $url = $configurations["configoption7"];
    $urladdress = $configurations["configoption8"];
    if (!$url)
    {
        $domain = $params["serverhostname"] ? $params["serverhostname"] : $params["serverip"];
        $urladdress = $params["serversecure"].$domain;
    }
    $form = sprintf("<form method=\"post\" action=\"%s/Default.aspx\" target=\"_blank\">" . "<input type=\"hidden\" name=\"pid\" value=\"Login\" />" . "<input type=\"hidden\" name=\"user\" value=\"%s\" />" . "<input type=\"hidden\" name=\"password\" value=\"%s\" />" . "<input type=\"submit\" value=\"%s\" />" . "</form>", $urladdress,$params["username"],$params["password"],"WebSitePanel Login");
    return $form;
}
function websitepanel_AdminLink($params)
{
    $product = $params["product"];
    $configurations = $product["configurations"];    
    $serverip = $params["serverip"];    
    $serverid = $params["serverid"];
    $url = $configurations["configoption7"];
    $urladdress = $configurations["configoption8"];
    if (!$url) {
        $domain = $params["serverhostname"] ? $params["serverhostname"] : $params["serverip"];
        $urladdress = $params["serversecure"].$domain;
    }
    $form = sprintf("<form method=\"post\" action=\"%s/Default.aspx\" target=\"_blank\">" . "<input type=\"hidden\" name=\"pid\" value=\"Login\" />" . "<input type=\"hidden\" name=\"user\" value=\"%s\" />" . "<input type=\"hidden\" name=\"password\" value=\"%s\" />" . "<input type=\"submit\" value=\"%s\" />" . "</form>", $urladdress,$params["serverusername"],$params["serverpassword"], "Login to Control Panel");
    return $form;
}
function websitepanel_LoginLink($params)
{
    $product = $params["product"];
    $configurations = $product["configurations"];    
    $pid = $params["pid"];
    $username = $params["username"];
    $url = $configurations["configoption7"];
    $urladdress = $configurations["configoption8"];
    if (!$url) {
        $domain = $params["serverhostname"] ? $params["serverhostname"] : $params["serverip"];
        $urladdress = $params["serversecure"].$domain;
    }
    $code = sprintf("<a href=\"%s/Default.aspx?pid=Login&user=%s&password=%s\" target=\"_blank\" class=\"moduleloginlink\">%s</a>", $urladdress,$params["username"],$params["password"], "login to control panel");
    return $code;
}
function websitepanel_getuserid($params)
{
    $param = array("username" => $params["username"]);
    $result = websitepanel_call($params, "GetUserByUsername", $param, true);
    return $result->UserId;
}
function websitepanel_getpackageid($params, $user)
{
    $param = array("userId" => $user);
    $result = websitepanel_call($params, "GetMyPackages", $param, true);
    return $result->PackageInfo->PackageId;
}
function websitepanel_UsageUpdate($params)
{
    $serverid = $params["serverid"];
    $serverip = $params["serverip"];
    $serverusername = $params["serverusername"];
    $serverpassword = $params["serverpassword"];
    $accounts = GetServicesByServerId($serverid);
    $count = 0;
    foreach ($accounts as $row)
    {
        $sid = $row->id;
        $username = $row->user_name;
        $userId = $row->user_id;
        $configurations = json_decode($row->module_configurations,true);
        if ($configurations["configoption16"] == "yes")
        {
            $esPort = $configurations["configoption6"];
            $dsLimit = $configurations["configoption2"];
            $bwLimit = $configurations["configoption3"];
            $params["configoption6"] = $esPort;
            $params["username"] = $username;
            $userId = websitepanel_getuserid($params);
            $packageId = websitepanel_getpackageid($params, $userId);
            $startDate = websitepanel_calculateDate($row->reg_date);
            $bandwidth = websitepanel_getBandwidth($params, $packageId, $startDate);
            $diskSpace = websitepanel_getDiskspace($params, $packageId);
            $isUpdated =  UpdateServiceInfo([
                "disk_usage" => $diskSpace,
                "disk_limit" => $dsLimit,
                "bandwidth_usage" => $bandwidth,
                "bandwidth_limit" => $bwLimit,
                "email_accounts_limit"=>0,
                "domains_limit"=>0,
                "sub_domains_limit"=>0,
                "parked_domains_limit"=>0,
                "databases_limit"=>'',
                "databases_disk_limit"=>'',
                "databases_disk_usage"=>'',
                "databases_usage"=>'',
                "parked_domains_usage"=>'',
                "sub_domains_usage"=>'',
                "domains_usage"=>'',
                "email_accounts_usage"=>'',
                "last_update"=>Carbon::now()->format('Y-m-d h:i:s')],["server_id"=>$serverid, "id"=>$sid]);
            if($isUpdated) $count++;
        }
    }
    if($serverid > 0)
    {
        UpdateServerInfo(['remote_acct_usage'=>$count,'up_status'=>'Up','last_check_date'=>Carbon::now()->format('Y-m-d h:i:s')],['id'=>$serverid]);
    }
    if($count>0) return array('status'=>'success','message'=>$count.' Accounts Stats Updated....');
    return ["status"=>"error","message"=>"Account Stats Updation failed"];
}
function websitepanel_getBandwidth($params, $packageID, $startDate)
{
    $param = array("packageId" => $packageID, "startDate" => $startDate, "endDate" => date("Y-m-d", time()));
    $result = websitepanel_call($params, "GetPackageBandwidth", $param, true);
    $xml = simplexml_load_string($result->any);
    $total = 0;
    foreach ($xml->NewDataSet->Table as $Table) {
        $total = $total + $Table->MegaBytesTotal;
    }
    return $total;
}
function websitepanel_getDiskspace($params, $packageID)
{
    $param = array("packageId" => $packageID);
    $result = websitepanel_call($params, "GetPackageDiskspace", $param, true);
    $xml = simplexml_load_string($result->any);
    $total = 0;
    foreach ($xml->NewDataSet->Table as $Table) {
        $total = $total + $Table->Diskspace;
    }
    return $total;
}
function websitepanel_calculateDate($date)
{
    $dateexplode = explode("-", $date);
    $currentyear = date("Y");
    $currentmonth = date("m");
    $newdate = $currentyear . "-" . $currentmonth . "-" . $dateexplode[2];
    $dateDiff = time() - strtotime("+1 hour", strtotime($newdate));
    $fullDays = floor($dateDiff / (60 * 60 * 24));
    if ($fullDays < 0) {
        return date("Y-m-d", strtotime("-1 month", strtotime($newdate)));
    }
    return $newdate;
}