<?php 
class branded_sms{
	private $timeout = 10; // set to zero for no timeout
	private $userAgent = 'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1)'; 
	private $gsmnumber	= '';
	private $from = '';
	private $message = '';
	private $url = '';
	private $credit_url = '';
	private $delivery_url = '';
	private $email = '';
	private $apikey = '';
	private $senderid = '';
	private $debug = '';

	function __construct($data=[]) {		
        $configurations = isset($data["configurations"]) ? $data["configurations"]:[];
		$this->gsmnumber= isset($data['to']) ? $data['to']:'';
		$this->message = isset($data['msg']) ? $data['msg']:'';
		$this->email = isset($configurations["email"]) ? $configurations["email"]:'';
		$this->apikey = isset($configurations["apikey"]) ? $configurations["apikey"]:'';
		$this->senderid = isset($configurations["senderid"]) ? $configurations["senderid"]:'';
		$this->debug = isset($configurations["debug_mode"]) ? $configurations["debug_mode"]:'';
	}
	
	function configs(){
		return [
			'name'=>'Branded SMS',
			'description'=>'',
			'url'=>'https://brandedsmspakistan.com/',
			'country'=>'Pakistan',
			'version'=>'',
			"configs"=>array(
                "email" => array (
                                    "Name" => "Email Address",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter Email Address", 
                                    "Default" => ""
                                    ),
                "apikey" => array (
                                    "Name" => "API Key",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter API Key", 
                                    "Default" => ""
                                    ),
                "senderid" => array (
                                    "Name" => "Sender ID/Masking",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter Sender ID/Masking", 
                                    "Default" => ""
                                    ),
                "debug_mode" => array (
                    "Name" => "Enable Debug Mode?", 
                    "Type" =>  "yesno", 
                    "Size" => "55", 
                    "Description" => "Enable debug mode to log and display errors ", 
                    "Default" => "yes", 
                ),
                            )
		];
	}


 function send()
    {
        $messageSent = false;
        $mask = urlencode($this->senderid);
        $message = urlencode($this->message);
        $data = "email=".$this->email."&key=".$this->apikey."&mask=".$mask."&to=".$this->gsmnumber."&message=".$message;
        // Sending the POST Request with cURL to Branded SMS Pakistan Server
        $ch = curl_init('https://secure.h3techs.com/sms/api/send');
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $result = curl_exec($ch); // Result from Branded SMS Pakistan including Return ID
        curl_close($ch);
        $array = json_decode($result);
        if($array->sms->code == 000){
            $messageSent = true;
            $error = $array->sms->response;
        }else{
            $error = $array->sms->response;
        }
        return ['status'=>$messageSent,'msg'=>$error];
    }



	function credit(){
         $url = "https://secure.h3techs.com/sms/api/balance?email=".$this->email."&key=".$this->apikey;
        $result = file_get_contents($url);
        $result = preg_replace('/,/', '', $result);
        $result = preg_replace('/\D/', '', $result);
        if ($result >=0)
        {
            return $result;
        }else {
            return 0;
        }
	}
	function validate(){
         $url = "https://secure.h3techs.com/sms/api/balance?email=".$this->email."&key=".$this->apikey;
        $results = file_get_contents($url);
        $result = preg_replace('/,/', '', $results);
        $result = preg_replace('/\D/', '', $result);
        if ($result >=0)
        {
           return ['valid'=>'YES','error'=>$result];
        }else {
            return ['valid'=>'NO','error'=>$results];
        }
	}
}