<?php 
class branded_sms_pk{
	private $timeout = 10; // set to zero for no timeout
	private $userAgent = 'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1)'; 
	private $gsmnumber	= '';
	private $from = '';
	private $message = '';
	private $url = '';
	private $credit_url = '';
	private $delivery_url = '';
	private $id = '';
	private $number = '';
	private $apikey = '';
	private $senderid = '';
	private $debug = '';

	function __construct($data=[]) {
        $info = isset($data["gateway"]) ? $data["gateway"]:[];
		$this->gsmnumber= isset($data['to']) ? $data['to']:'';
		$this->message = isset($data['msg']) ? $data['msg']:'';
		$this->id = isset($info->id) ? $info->id:'';
		$this->apikey = isset($info->apikey) ? $info->apikey:'';
		$this->number = isset($info->number) ? $info->number:'';
		$this->senderid = isset($info->senderid) ? $info->senderid:'';
		$this->debug = isset($info->debug_mode) ? $info->debug_mode:'';
	}
	
	function configs(){
		return [
			'name'=>'Branded SMS PK',
			'description'=>'',
			'url'=>'https://brandedsms.pk/',
			'country'=>'Pakistan',
			'version'=>'',
			"configs"=>array(
                "id" => array (
                                    "Name" => "ID",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter ID", 
                                    "Default" => ""
                                    ),
                "apikey" => array (
                                    "Name" => "API Key",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter API Key", 
                                    "Default" => ""
                                    ),
                "number" => array (
                                    "Name" => "Your Mobile Number",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter Your Mobile Number", 
                                    "Default" => ""
                                    ),
                "senderid" => array (
                                    "Name" => "Sender ID/Masking",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter Sender ID/Masking", 
                                    "Default" => ""
                                    ),
                "debug_mode" => array (
                    "Name" => "Enable Debug Mode?", 
                    "Type" =>  "yesno", 
                    "Size" => "55", 
                    "Description" => "Enable debug mode to log and display errors ", 
                    "Default" => "yes", 
                ),
                            )
		];
	}


 function send()
    {
        $messageSent = false;
        $mask = urlencode($this->senderid);
        $message = urlencode($this->message);
      
             // Configuration variables
            $id = $this->id;
            $key  = $this->apikey;
            $mask = $mask;
            // Data for text message
            $to = $this->gsmnumber;
            // must URL encode to safely send all characters to the API URL
            // English = en  , Urdu = ur
            $lang = "en";
            // Prepare data for POST request
            $data = "id=".$id."&key=".$key."&mask=".$mask."&to=".$to."&msg=".$message."&lang=".$lang;
            // Send the POST request with cURL
            $ch = curl_init('http://brandedsms.pk/api/sendsms.php');
            curl_setopt($ch, CURLOPT_POST, true);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            $result = curl_exec($ch);
            //This is the result from Branded SMS (JSON Object)
            curl_close($ch);
            $array = json_decode($result,true);
            $type = $array["type"];
            $id = $array["id"];
            $response = $array["response"];
            $code = $array["code"];
            if($type == "success") $messageSent = true;
            $error = $response;
        return ['status'=>$messageSent,'msg'=>$error];
    }



	function credit(){
         $url = "https://secure.h3techs.com/sms/api/balance?email=".$this->email."&key=".$this->apikey;
        $result = file_get_contents($url);
        $result = preg_replace('/,/', '', $result);
        $result = preg_replace('/\D/', '', $result);
        if ($result >=0)
        {
            return $result;
        }else {
            return 0;
        }
	}
	function validate(){
        $mask = urlencode($this->senderid);
        $message = "SMS Gateway Validation SMS";
             // Configuration variables
            $id = $this->id;
            $key  = $this->apikey;
            $mask = $mask;
            // Data for text message
            $to = $this->number;
            // must URL encode to safely send all characters to the API URL
            $message = urlencode($message);
            // English = en  , Urdu = ur
            $lang = "en";
            // Prepare data for POST request
            $data = "id=".$id."&key=".$key."&mask=".$mask."&to=".$to."&msg=".$message."&lang=".$lang;
            // Send the POST request with cURL
            $ch = curl_init('http://brandedsms.pk/api/sendsms.php');
            curl_setopt($ch, CURLOPT_POST, true);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            $result = curl_exec($ch);
            //This is the result from Branded SMS (JSON Object)
            curl_close($ch);
            $array = json_decode($result,true);
            $type = $array["type"];
            $id = $array["id"];
            $response = $array["response"];
            $code = $array["code"];
            if($type == "success"){
               return ['valid'=>'YES','error'=>$response];
            }else {
                return ['valid'=>'NO','error'=>$response];
            }
	}
}