<?php
class bulk_sms_com {
	private $timeout = 10; // set to zero for no timeout
	private $userAgent = 'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1)'; 
	private $to	= '';
	private $from = '';
	private $debug = '';
	private $message = '';
	private $url = 'https://api.bulksms.com/v1/messages';
	private $credit_url = 'https://api.bulksms.com/v1/messages';
	private $delivery_url = '';
	private $api_user = '';
	private $api_pass = '';

	function __construct($data=[]){
        $configurations = isset($data["configurations"]) ? $data["configurations"]:[];
		$this->to= isset($data['to']) ? $data['to']:'';
		$this->message = isset($data['msg']) ? $data['msg']:'';
		$this->from = isset($configurations["masking"]) ? $configurations["masking"]:'';
		$this->api_user = isset($configurations["username"]) ? $configurations["username"]:'';
		$this->api_pass = isset($configurations["password"]) ? $configurations["password"]:'';
		$this->debug = isset($configurations["debug_mode"]) ? $configurations["debug_mode"]:'';
	}
	
	function configs(){
		return [
			'name'=>'bulksms.com',
			'description'=>'BulkSMS is a leading SMS messaging service provider offering two-way SMS communication services from your internet enabled computer. The BulkSMS gateway reaches across borders and connects to over 800 mobile network operators world-wide.',
			'url'=>'https://www.bulksms.com/',
			'country'=>'Worldwide',
			'version'=>'',
			"configs"=>array(
                "username" => array (
                                    "Name" => "Username",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter Username", 
                                    "Default" => ""
                                    ),
                "password" => array (
                                    "Name" => "Password",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter Password", 
                                    "Default" => ""
                                    ),
                "masking" => array (
                                    "Name" => "Masking",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter Masking", 
                                    "Default" => ""
                                    ),
                "debug_mode" => array (
                    "Name" => "Enable Debug Mode?", 
                    "Type" =>  "yesno", 
                    "Size" => "55", 
                    "Description" => "Enable debug mode to log and display errors ", 
                    "Default" => "yes", 
                ),
                            )
		];
	}

	function send(){
        $messages = json_encode([['to'=>$this->to,'body'=>$this->message]]);
        $headers = ['Content-Type:application/json','Authorization:Basic '. base64_encode("$this->$api_user:$this->api_pass")];

	    $ch = curl_init();
	    $conn_timeout = 10; // Wait 10 seconds while trying to connect
	    $exec_timeout = 10; // Allow cUrl functions 20 seconds to execute
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
	    curl_setopt($ch, CURLOPT_URL,$this->url);
	    curl_setopt($ch, CURLOPT_POST, 1);
	    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	    curl_setopt($ch, CURLOPT_AUTOREFERER, TRUE);
	    curl_setopt($ch, CURLOPT_HEADER, 0);
	    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);       
	    curl_setopt($ch, CURLOPT_POSTFIELDS,$messages);
	    curl_setopt ($ch, CURLOPT_TIMEOUT, $exec_timeout );
	    curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $conn_timeout);
	    $server_response = curl_exec( $ch );
	    $curl_info = curl_getinfo( $ch );
	    $status = $curl_info['http_code'];
	    $error = curl_error($ch);
	    curl_close( $ch );

        if($status == 200 || $status == 201 || $status == 202)
        {
          $isJson =  json_decode($server_response);
           $type =$isJson[0]->type;
			if($type == "SENT")
			{
        	return ['status'=>true,'msg'=>json_encode($server_response)];
            }else{
        	return ['status'=>false,'msg'=>json_encode($server_response)];
            }
        }else{
        	return ['status'=>false,'msg'=>json_encode($server_response)];
        }	    
	}

	function credit(){
/*
	    $ch = curl_init();
	    $timeout = 10; // set to zero for no timeout
	    curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1)');
	    curl_setopt($ch, CURLOPT_URL,$url);
	    curl_setopt($ch, CURLOPT_POST, 1);
	    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	    curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
	    $result = curl_exec($ch); 
	    */
	    return 0;        
	}

	function validate(){
        $messages = array(array('to'=>$this->to, 'body'=>urlencode($this->message)));
        $isHeaders = array('Content-Type:application/json','Authorization:Basic '. base64_encode("$this->api_user:$this->api_pass"));

	    $ch = curl_init();
	    $conn_timeout = 10; // Wait 10 seconds while trying to connect
	    $exec_timeout = 10; // Allow cUrl functions 20 seconds to execute
        curl_setopt($ch, CURLOPT_HTTPHEADER, 1);
	    curl_setopt($ch, CURLOPT_URL,$this->credit_url);
	    curl_setopt($ch, CURLOPT_POST, 1);
	    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	    curl_setopt($ch, CURLOPT_AUTOREFERER, TRUE);
	    curl_setopt($ch, CURLOPT_HEADER, 0);
	    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);       
	    curl_setopt($ch, CURLOPT_POSTFIELDS,json_encode($messages));
	    curl_setopt ($ch, CURLOPT_TIMEOUT, $exec_timeout );
	    curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $conn_timeout);
	    $server_response = curl_exec( $ch );
	    $curl_info = curl_getinfo( $ch );
	    $http_status = $curl_info['http_code'];
	    $error = curl_error($ch);
	    $obj = json_decode($server_response);
	    curl_close( $ch );
		return ['valid'=>($http_status == 201) ? 'YES':'NO','error'=>$obj->detail];
	}




}