<?php
class clickatell {
	private $timeout = 10; // set to zero for no timeout
	private $userAgent = 'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1)'; 
	private $to	= '';
	private $from = '';
	private $message = '';
	private $url = 'https://sendpk.com/api/sms.php';
	private $credit_url = 'https://sendpk.com/api/balance.php';
	private $delivery_url = 'https://sendpk.com/api/delivery.php?username=[username]&password=[password]&id=[MessageID]';
	private $api_user = '';
	private $api_pass = '';
	private $debug = '';
	private $apiid = '';

	function __construct($data=[]) {
        $configurations = isset($data["configurations"]) ? $data["configurations"]:[];
		$this->to= isset($data['to']) ? $data['to']:'';
		$this->message = isset($data['msg']) ? $data['msg']:'';
		$this->from = isset($configurations["masking"]) ? $configurations["masking"]:'';
		$this->api_user = isset($configurations["username"]) ? $configurations["username"]:'';
		$this->api_pass = isset($configurations["password"]) ? $configurations["password"]:'';
		$this->debug = isset($configurations["debug_mode"]) ? $configurations["debug_mode"]:'';
		$this->apiid = isset($configurations["apiid"]) ? $configurations["apiid"]:0;
	}
	
	function configs(){
		return [
			'name'=>'clickatell.com',
			'description'=>'',
			'url'=>'http://clickatell.com/',
			'country'=>'Global',
			'version'=>'',
			"configs"=>array(
                "username" => array (
                                    "Name" => "Username",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter Username", 
                                    "Default" => ""
                                    ),
                "password" => array (
                                    "Name" => "Password",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter Password", 
                                    "Default" => ""
                                    ),
                "apiid" => array (
                                    "Name" => "API ID",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter API ID", 
                                    "Default" => ""
                                    ),
                "masking" => array (
                                    "Name" => "Masking",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter Masking", 
                                    "Default" => ""
                                    ),
                "debug_mode" => array (
                    "Name" => "Enable Debug Mode?", 
                    "Type" =>  "yesno", 
                    "Size" => "55", 
                    "Description" => "Enable debug mode to log and display errors ", 
                    "Default" => "yes", 
                ),
                            )
		];
	}
	
	
    function send(){
        $baseurl = "http://api.clickatell.com";
        $url = "$baseurl/http/auth?user=$this->api_user&password=$this->api_pass&api_id=$this->apiid&from=$this->from";
        $ret = file($url);
        $answer = is_array($ret) ? json_encode($ret) : $ret;
        $sess = explode(":", $ret[0]);
        if ($sess[0] == "OK") {

            $sess_id = trim($sess[1]); // remove any whitespace
            $url = "$baseurl/http/sendmsg?session_id=$sess_id&to=$this->to&text=$this->message&from=$this->from";

            $ret = file($url);
            $send = explode(":", $ret[0]);

            if ($send[0] == "ID") {
                	return ['status'=>true,'msg'=>'Message Sent'];
            } else {
                $answer = is_array($ret) ? json_encode($ret) : $ret;
                return ['status'=>false,'msg'=>"Message could not sent. Error: $answer"];
            }
        } else {
            $answer = is_array($ret) ? json_encode($ret) : $ret;
            return ['status'=>false,'msg'=>"Message could not sent. Error: $answer"];
        }
    }

    function balance()
    {
        if ($this->api_user && $this->api_pass && $this->apiid) {
            $url = "http://api.clickatell.com/http/getbalance?api_id=$this->apiid&user=$this->api_user&password=$this->api_pass";
            $result = file_get_contents($url);
            $result = explode(" ", $result);
            $cvp = $result[1];
            if ($cvp == 001) {
                return ($balance>0) ? $balance:0;
            } else {
                return ($cvp>0) ? $cvp:0;
            }
        } else {
            return 0;
        }
    }
    
    function validate(){
        return $this->balance();
    }
}