<?php

class life_time_sms {
	private $timeout = 10; // set to zero for no timeout
	private $userAgent = 'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1)'; 
	private $to	= '';
	private $from = '';
	private $message = '';
	private $url = 'https://lifetimesms.com/json';
	private $credit_url = 'https://lifetimesms.com/balance-inquiry';
	private $delivery_url = '';
	private $api_token = '';
	private $api_secret = '';
	private $debug = '';

	function __construct($data=[]) {		
	    $info = isset($data['gateway']) ? $data['gateway']:[];
		$this->to	= isset($data['to']) ? $data['to']:'';
		$this->message = isset($data['msg']) ? $data['msg']:'';
		$this->from = isset($info->masking) ? $info->masking:'';
		$this->api_token = isset($info->api_token) ? $info->api_token:'';
		$this->api_secret = isset($info->api_secret) ? $info->api_secret:'';
		$this->debug = isset($info->debug_mode) ? $info->debug_mode:'';
	}
	
	function configs(){
		return [
			'name'=>'lifetimesms.com',
			'description'=>'Lifetime SMS offers a very unique unlimited free credit services, tailored to give you the most experience without the burden of extravagant costs. This system is like no other as it allows you to maximize your advertisement plans without worrying about financing.',
			'url'=>'http://lifetimesms.com/',
			'country'=>'Pakistan',
			'version'=>'',
			"configs"=>array(
                "api_token" => array (
                                    "Name" => "API Token",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter API Token here", 
                                    "Default" => ""
                                    ),
                "api_secret" => array (
                                    "Name" => "API Secret",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter API Secret here", 
                                    "Default" => ""
                                    ),
                "masking" => array (
                                    "Name" => "Masking",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter Masking", 
                                    "Default" => ""
                                    ),
                "debug_mode" => array (
                    "Name" => "Enable Debug Mode?", 
                    "Type" =>  "yesno", 
                    "Size" => "55", 
                    "Description" => "Enable debug mode to log and display errors ", 
                    "Default" => "yes", 
                ),
                            )
		];
	}

	function send(){
	    
    $parameters = [
        "api_token" => $this->api_token,
        "api_secret" => $this->api_secret,
        "to" => $this->to,
        "from" => $this->from,
        "message" => $this->message,
    ];

    $ch = curl_init();
    $timeout  =  30;
    curl_setopt($ch, CURLOPT_URL, $this->url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_HEADER, 0);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST,  2);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $parameters);
    curl_setopt($ch, CURLOPT_TIMEOUT, $timeout);
    $response = curl_exec($ch);
    curl_close($ch);
    $response = json_decode($response,true);
    $status = $response["messages"][0]["status"];
    if($status == 1) 	return ['status'=>true,'msg'=>json_encode($response)];
	return ['status'=>false,'msg'=>json_encode($response)];

	}

	function credit(){
    $parameters = [
        "api_token" => $this->api_token,
        "api_secret" => $this->api_secret,
    ];

    $ch = curl_init();
    $timeout  =  30;
    curl_setopt($ch, CURLOPT_URL, $this->credit_url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_HEADER, 0);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST,  2);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $parameters);
    curl_setopt($ch, CURLOPT_TIMEOUT, $timeout);
    $response = curl_exec($ch);
    curl_close($ch);
    $response = json_decode($response,true);
    
    
    $status = $response["status"];
    $credits = $response["sms"];
    return ($status>0) ? $credits:0;
    
	}

	function validate(){
    $parameters = [
        "api_token" => $this->api_token,
        "api_secret" => $this->api_secret,
    ];

    $ch = curl_init();
    $timeout  =  30;
    curl_setopt($ch, CURLOPT_URL, $this->credit_url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_HEADER, 0);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST,  2);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $parameters);
    curl_setopt($ch, CURLOPT_TIMEOUT, $timeout);
    $response = curl_exec($ch);
    curl_close($ch);
    $response = json_decode($response,true);
    
    $status = $response["status"];
    if($status == 1) return ["valid"=>"YES","error"=>""];
    $error = $response["messages"][0]["error"];
	return ['valid'=>'NO','error'=>$error];
	}




}