<?php
class masterit_pk {
	private $timeout = 10; // set to zero for no timeout
	private $userAgent = 'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1)'; 
	private $to	= '';
	private $from = '';
	private $message = '';
	private $url = 'https://sms.masterit.pk/api/sendsms.php';
	private $credit_url = 'https://api.bulksms.com/v1/messages';
	private $delivery_url = '';
	private $apikey = '';

	function __construct($data=[]) {
        $configurations = isset($data["configurations"]) ? $data["configurations"]:[];
		$this->to= isset($data['to']) ? $data['to']:'';
		$this->message = isset($data['msg']) ? $data['msg']:'';
		$this->from = isset($configurations["masking"]) ? $configurations["masking"]:'';
		$this->apikey = isset($configurations["apikey"]) ? $configurations["apikey"]:'';
		$this->debug = isset($configurations["debug_mode"]) ? $configurations["debug_mode"]:'';
	}
	
	function configs(){
		return [
			'name'=>'masterit.pk',
			'description'=>'Master IT Provides SMS, MMS, WhatsApp Messaging and Voice Mail Solutions. to promote your SMS Business and Branding a Root Promotion. Our Services Smooth and Fully Programable with your Already Build Applications and Software’s',
			'url'=>'https://www.masterit.pk/',
			'country'=>'Pakistan',
			'version'=>'',
			"configs"=>array(
                "apikey" => array (
                                    "Name" => "API Key",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter API Key", 
                                    "Default" => ""
                                    ),
                "masking" => array (
                                    "Name" => "Masking",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter Masking", 
                                    "Default" => ""
                                    ),
                "debug_mode" => array (
                    "Name" => "Enable Debug Mode?", 
                    "Type" =>  "yesno", 
                    "Size" => "55", 
                    "Description" => "Enable debug mode to log and display errors ", 
                    "Default" => "yes", 
                ),
                            )
		];
	}
    
	function send(){
            $api   =   $this->apikey;           //  Master IT SMS account API
            $number =   $this->to;                           //  Mobile Number
            $mask   =   ($this->from == 'Test') ? 'Master IT':$this->from;                             //  Registered Mask Name
            $text   =   $this->message;                     //  Message Content
            $oper   =   0;                                      //  If Number is Ported to telenor
            
            $text = preg_replace('/\s+/', '%20', $text);
            $mask = preg_replace('/\s+/', '%20', $mask);
            $api = preg_replace('/\s+/', '%20', $api);
            
             $url = 'https://sms.masterit.pk/api/sendsms.php?apikey='.$api.'&phone='.$number.'&sender='.$mask.'&message='.$text.'&operator='.$oper;
            $ch = curl_init();
            curl_setopt($ch, CURLOPT_URL,$url);
            curl_setopt($ch,CURLOPT_RETURNTRANSFER,1);
            curl_setopt($ch, CURLOPT_HEADER, 0);
            $result = curl_exec ($ch);
            curl_close($ch);

            $segment = explode('|',$result);
            $res = preg_replace('/\D/', '', $segment[1]);

        if ($res > 0){
            	return ['status'=>true,'msg'=>json_encode($result)];
        }else{
            	return ['status'=>false,'msg'=>json_encode($result)];
        }
	}    

	function credit(){
        $url = 'https://sms.masterit.pk/api/sms-credit.php?apikey='.$this->apikey;
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL,$url);
        curl_setopt($ch,CURLOPT_RETURNTRANSFER,1);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        $balance = curl_exec ($ch);
        return ($balance>0) ? $balance:0;
	}

	function validate(){
        $url = 'https://sms.masterit.pk/api/sms-credit.php?apikey='.$this->apikey;
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL,$url);
        curl_setopt($ch,CURLOPT_RETURNTRANSFER,1);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        $balance = curl_exec ($ch);
 		return ['valid'=>(is_numeric($balance)) ? 'YES':'NO','error'=>$balance];
	}




}