<?php

class msg_nineteen_one {
	private $timeout = 10; // set to zero for no timeout
	private $userAgent = 'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1)'; 
	private $gsmnumber	= '';
	private $from = '';
	private $message = '';
	private $url = '';
	private $credit_url = '';
	private $delivery_url = '';
	private $route = '';
	private $authkey = '';
	private $senderid = '';
	private $flash = '';
	private $unicode = '';
	private $ignoreNdnc = '';
	private $debug = '';

	function __construct($data=[])
	{
        $configurations = isset($data["configurations"]) ? $data["configurations"]:[];
		$this->gsmnumber= isset($data['to']) ? $data['to']:'';
		$this->message = isset($data['msg']) ? $data['msg']:'';
		$this->route = isset($configurations["route"]) ? $configurations["route"]:'';
		$this->authkey = isset($configurations["authkey"]) ? $configurations["authkey"]:'';
		$this->senderid = isset($configurations["senderid"]) ? $configurations["senderid"]:'';
		$this->flash = isset($configurations["flash"]) ? $configurations["flash"]:'';
		$this->unicode = isset($configurations["unicode"]) ? $configurations["unicode"]:'';
		$this->ignoreNdnc = isset($configurations["ignoreNdnc"]) ? $configurations["ignoreNdnc"]:'';
		$this->debug = isset($configurations["debug_mode"]) ? $configurations["debug_mode"]:'';
		$this->flash = $this->flash == 'yes' ? 1:0;
		$this->unicode = $this->unicode == 'yes' ? 1:0;
		$this->ignoreNdnc = $this->ignoreNdnc == 'yes' ? 1:0;
	}
	
	function configs(){
		return [
			'name'=>'MSG91',
			'description'=>'',
			'url'=>'https://www.msg91.com/',
			'country'=>'India',
			'version'=>'',
			"configs"=>array(
                "authkey" => array (
                                    "Name" => "Authentication Key",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter Authentication Key", 
                                    "Default" => ""
                                    ),
                "senderid" => array (
                                    "Name" => "Sender ID/Title",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter Sender ID/Title", 
                                    "Default" => ""
                                    ),
                "route" => array (
                                    "Name" => "SMS Delivery Route (e.g: 4)",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter SMS Delivery Route (e.g: 4)", 
                                    "Default" => ""
                                    ),
                "flash" => array (
                    "Name" => "Flash SMS ", 
                    "Type" =>  "yesno", 
                    "Size" => "55", 
                    "Description" => "Enable Flash SMS Yes/No", 
                    "Default" => "yes", 
                ),
                "unicode" => array (
                    "Name" => "Unicode SMS ", 
                    "Type" =>  "yesno", 
                    "Size" => "55", 
                    "Description" => "Enable Unicode SMS Yes/No ", 
                    "Default" => "yes", 
                ),
                "ignoreNdnc" => array (
                    "Name" => "Ignore NDNC Numbers? ", 
                    "Type" =>  "yesno", 
                    "Size" => "55", 
                    "Description" => "Enable Ignore NDNC Numbers? ", 
                    "Default" => "yes", 
                ),
                "debug_mode" => array (
                    "Name" => "Enable Debug Mode?", 
                    "Type" =>  "yesno", 
                    "Size" => "55", 
                    "Description" => "Enable debug mode to log and display errors ", 
                    "Default" => "yes", 
                ),
                            )
		];
	}


 function send()
    {
        $messageSent = false;
        if ($this->gsmnumber == "numbererror") {
            $error="Number format error." . $this->gsmnumber;
             return ['status'=>$messageSent,'msg'=>$error];
        }

        //Your authentication key (Go to https://control.msg91.com/apidoc/)
        $authKey = $this->authkey;

        //Base URL
        //Composed of initial common portion of URL of SMS Gateway Provider
        $baseurl = "https://control.msg91.com";

        //Sender ID, While using route 4 sender id should be 6 characters long.
        $senderId = trim($this->senderid);
        $senderId = substr($senderId, 0, 6);

        //Define route (SMS Delivery)
        //If route = 1 (Route 1 is Normal Route does not send sms to National Do Not Call registry(NDNC) Numbers and only before 9PM IST)
        //If route = 4 (Route 4 is Informative Route - 24 hours open)
        if (ctype_digit($this->route)) {
            $smsRoute = $this->route;
        } else {
            $smsRoute = 1;            //Using Default route 1 if undefined in settings
        }

        //Define Message Type
        // Send Unicode Message
        // Yes = 1 / No = 0 (if No, Default is English)
        if (ctype_digit($this->unicode)) {
            $unicodeSupport = $this->unicode;
        } else {
            $unicodeSupport = 0;            //Unicode support is disbaled if not defined in settings
        }

        // Send Flash Message (Dispay SMS directly on mobile screen)
        // Yes = 1 / No = 0
        if (ctype_digit($this->flash)) {
            $flashSupport = $this->flash;
        } else {
            $flashSupport = 0;            //Flash SMS support is disabled by default if undefined in settings
        }

        // Ignore NDNC
        // Yes = 1 / No = 0
        // ignoreNdnc=1 (if you want system to ignore all NDNC Numbers, useful while using route 4)
        if (ctype_digit($this->ignoreNdnc)) {
            $ignoreNdnc = $this->ignoreNdnc;
        } else {
            $ignoreNdnc = 1;
        }

        $text = urlencode($this->message);
        $to = $this->gsmnumber;

        // Validation of connection to SMS Gateway Server
        $url = "$baseurl/api/validate.php?authkey=$authKey&type=$smsRoute"; //verify connetion to gateway server
        $ret = file($url);
        $error = "Response returned from the server: " . $ret;

        $sess = explode(",", $ret[0]);
        if ($sess[0] == "Valid") 
        {

            $url = "$baseurl/api/sendhttp.php?authkey=$authKey&mobiles=$to&message=$text&sender=$senderId&route=$smsRoute&unicode=$unicodeSupport&flash=$flashSupport";
            $ret = file($url);
            $send = array_map('trim', explode(":", $ret[0]));

            if ($send[0] != "CODE" && $send[0] != "Please") {
            $messageSent = true;
                $error = "Message sent!";
            } else {
                $error="An error occurred while sending the message. Error: $ret";
            }
        } else {
            $error="Authentication failed. $ret[0] ";
        }
        return ['status'=>$messageSent,'msg'=>$error];
    }



	function credit(){
	    
        if ($this->authkey && $this->route) {
            $baseurl = "https://control.msg91.com";
            $url = "$baseurl/api/balance.php?authkey=$this->authkey&type=$this->route";
            $result = file_get_contents($url);
            $result = array_map('trim', explode(":", $result));
            $cvp = $result[1];
            $balance = $result[0];
            if ($cvp == 001 || $cvp == 002) {
                return ($balance>0) ? $balance:0;
            } else {
                return ($balance>0) ? $balance:0;
            }
        } else {
            return 0;
        }
	}

	function validate(){
        if ($this->authkey && $this->route) {
            $baseurl = "https://control.msg91.com";
            $url = "$baseurl/api/balance.php?authkey=$this->authkey&type=$this->route";
            $result = file_get_contents($url);
            $result = array_map('trim', explode(":", $result));
            $cvp = $result[1];
            $balance = $result[0];
            if ($cvp == 001 || $cvp == 002) {
                	return ['valid'=>'NO','error'=>$cvp];
            } else {
                	return ['valid'=>'YES','error'=>$cvp];
            }
        } else {
            	return ['valid'=>'NO','error'=>'Authentication Key or Route not define....'];
        }
	}
}