<?php
class netgsm {
	private $timeout = 10; // set to zero for no timeout
	private $userAgent = 'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1)'; 
	private $to	= '';
	private $from = '';
	private $message = '';
	private $url = '';
	private $credit_url = '';
	private $delivery_url = '';
	private $api_user = '';
	private $api_pass = '';
	private $debug = '';

	function __construct($data=[])
	{
        $configurations = isset($data["configurations"]) ? $data["configurations"]:[];
		$this->to= isset($data['to']) ? $data['to']:'';
		$this->message = isset($data['msg']) ? $data['msg']:'';
		$this->from = isset($configurations["masking"]) ? $configurations["masking"]:'';
		$this->api_user = isset($configurations["username"]) ? $configurations["username"]:'';
		$this->api_pass = isset($configurations["password"]) ? $configurations["password"]:'';
		$this->debug = isset($configurations["debug_mode"]) ? $configurations["debug_mode"]:'';
	}
	
	function configs(){
		return [
			'name'=>'netgsm.com.tr',
			'description'=>'',
			'url'=>'http://netgsm.com.tr/',
			'country'=>'Turkey',
			'version'=>'',
			"configs"=>array(
                "username" => array (
                                    "Name" => "Username",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter Username", 
                                    "Default" => ""
                                    ),
                "password" => array (
                                    "Name" => "Password",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter Password", 
                                    "Default" => ""
                                    ),
                "masking" => array (
                                    "Name" => "Masking",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter Masking", 
                                    "Default" => ""
                                    ),
                "debug_mode" => array (
                    "Name" => "Enable Debug Mode?", 
                    "Type" =>  "yesno", 
                    "Size" => "55", 
                    "Description" => "Enable debug mode to log and display errors ", 
                    "Default" => "yes", 
                ),
                            )
		];
	}
	
	
    function send(){
       $url = "http://api.netgsm.com.tr/bulkhttppost.asp?usercode=".$this->api_user."&password=".$this->api_pass."&gsmno=".$this->to."&message=".$this->message."&msgheader=".$this->from;
        $log[] = "Request url: " . $url;
        $result = file_get_contents($url);
        $result = explode(" ", $result);
        if ($result[0] == "00" || $result[0] == "01" || $result[0] == "02") {
            return ['status'=>true,'msg'=>'Message Sent'.$result[1]];
        } elseif ($result[0] == "10") {
            return ['status'=>false,'msg'=>"Mesaj gönderilemedi. Hata: Telefon numarası hatalı"];
        } elseif ($result[0] == "20") {
            return ['status'=>false,'msg'=>"Mesaj gönderilemedi. Hata: mesaj metni boş veya çok uzun"];
        } elseif ($result[0] == "30") {
            return ['status'=>false,'msg'=>"Mesaj gönderilemedi. Hata: Kullanıcı bilgisi bulunamadı"];
        } elseif ($result[0] == "40") {
            return ['status'=>false,'msg'=>"Mesaj gönderilemedi. Hata: Geçersiz mesaj başlığı"];
        } elseif ($result[0] == "50") {
            return ['status'=>false,'msg'=>"Mesaj gönderilemedi. Hata: Kullanıcının kredisi yok"];
        } elseif ($result[0] == "60") {
            return ['status'=>false,'msg'=>"Mesaj gönderilemedi. Hata: Telefon numarası hiç tanımlanmamış"];
        } elseif ($result[0] == "70") {
            return ['status'=>false,'msg'=>"Mesaj gönderilemedi. Hata: Mesaj başlığı hatalı"];
        } else {
            return ['status'=>false,'msg'=>"Mesaj gönderilirken hata oluştu. Hata: $return"];
        }
    }
    function balance()
    {
          $postUrl = "https://api.netgsm.com.tr/xmlpaketkampanya.asp";
            $xmlString = "<mainbody><header><company>Netgsm</company><usercode>$this->api_user</usercode><password>$this->api_pass</password><stip>1</stip></header></mainbody>";
            // Kalan SMS Adedi Sorgula
            $fields = $xmlString;
            $ch = curl_init();
            curl_setopt($ch, CURLOPT_URL, $postUrl);
            curl_setopt($ch, CURLOPT_POST, 1);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $fields);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
            $result = curl_exec($ch);
            curl_close($ch);
            preg_match_all('/([\d]+)/', $result, $match);
            $balance = $match[0]; 
            return ($balance>0) ? $balance:0;
    }
    function credit(){
        return $this->balance();
    }
    function validate(){
        $data = $this->balance();
        return ['valid'=>($data>=0) ? 'YES':'NO','error'=>"Gateway validation failed, due to credentials or credit balance at SMS Gateway"];
    }
}