<?php

class routesms {
	private $timeout = 10; // set to zero for no timeout
	private $userAgent = 'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1)'; 
	private $gsmnumber	= '';
	private $from = '';
	private $message = '';
	private $url = '';
	private $credit_url = '';
	private $delivery_url = '';
	private $user = '';
	private $pass = '';
	private $senderid = '';
	private $debug = '';

	function __construct($data=[])
	{
        $configurations = isset($data["configurations"]) ? $data["configurations"]:[];
		$this->gsmnumber= isset($data['to']) ? $data['to']:'';
		$this->message = isset($data['msg']) ? $data['msg']:'';
		$this->senderid = isset($configurations["senderid"]) ? $configurations["senderid"]:'';
		$this->user = isset($configurations["user"]) ? $configurations["user"]:'';
		$this->pass = isset($configurations["pass"]) ? $configurations["pass"]:'';
		$this->debug = isset($configurations["debug_mode"]) ? $configurations["debug_mode"]:'';
	}
	
	function configs(){
		return [
			'name'=>'Route SMS',
			'description'=>'',
			'url'=>'https://www.routesms.com/',
			'country'=>'India',
			'version'=>'',
			"configs"=>array(
                "user" => array (
                                    "Name" => "Username",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter Username", 
                                    "Default" => ""
                                    ),
                "pass" => array (
                                    "Name" => "Password",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter Password", 
                                    "Default" => ""
                                    ),
                "senderid" => array (
                                    "Name" => "Sender ID/Title",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter Sender ID/Title", 
                                    "Default" => ""
                                    ),
                "debug_mode" => array (
                    "Name" => "Enable Debug Mode?", 
                    "Type" =>  "yesno", 
                    "Size" => "55", 
                    "Description" => "Enable debug mode to log and display errors ", 
                    "Default" => "yes", 
                ),
                            )
		];
	}


 function send()
    {
        $messageSent = false;
        if ($this->gsmnumber == "numbererror") {
            $error="Number format error." . $this->gsmnumber;
             return ['status'=>$messageSent,'msg'=>$error];
        }

        $url = "http://api.rmlconnect.net/bulksms/bulksms?username=$this->user&password=$this->pass&type=1&dlr=0&destination=$this->gsmnumber&source=$this->senderid&message=" . urlencode($this->message) . "";
        $result = file_get_contents($url);

        $result = explode("|", $result);
        if ($result[0] == "1701") {
            $messageSent = true;            
            $error = "Message id: " . $msgid;
        } elseif ($result[0] == "1702") {
            $error = "Invalid URL Error, one of the parameters was not provided or left blank";
        } elseif ($result[0] == "1703") {
            $error = "Invalid value in username or password field ";
        } elseif ($result[0] == "1704") {
            $error = "Invalid value in type field ";
        } elseif ($result[0] == "1705") {
            $error = "Invalid message";
        } elseif ($result[0] == "1706") {
            $error = "Invalid Destination ";
        } elseif ($result[0] == "1707") {
            $error = ":Invalid Source (Sender) ";
        } elseif ($result[0] == "1708") {
            $error = "Invalid value for dlr field ";
        } elseif ($result[0] == "1709") {
            $error = "User validation failed ";
        } elseif ($result[0] == "1710") {
            $error = "Internal Error ";
        } elseif ($result[0] == "1025") {
            $error = "Insufficient Credit ";
        } else {
            $error = "Mesaj gönderilirken hata oluştu. Hata: $return";
        }
        return ['status'=>$messageSent,'msg'=>$error];
    }



	function credit(){
         $url = "https://api.rmlconnect.net/CreditCheck/checkcredits?username=$this->user&password=".$this->pass;
        $result = file_get_contents($url);
        $result = explode(":", $result);
        if ($result[1] >=0)
        {
            return $result[1];
        }else {
            return 0;
        }
	}
	function validate(){
         $url = "https://api.rmlconnect.net/CreditCheck/checkcredits?username=$this->user&password=".$this->pass;
        $result = file_get_contents($url);
        $result = explode(":", $result);
        if ($result[1] >=0)
        {
            return ['valid'=>'YES','error'=>$result];
        }else {
            return ['valid'=>'NO','error'=>$result];
        }
	}
}