<?php

class send_pk {
	private $timeout = 10; // set to zero for no timeout
	private $userAgent = 'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1)'; 
	private $to	= '';
	private $from = '';
	private $message = '';
	private $debug = '';
	private $url = 'https://sendpk.com/api/sms.php';
	private $credit_url = 'https://sendpk.com/api/balance.php';
	private $delivery_url = 'https://sendpk.com/api/delivery.php?username=[username]&password=[password]&id=[MessageID]';
	private $api_user = '';
	private $api_pass = '';
	private $apikey = '';

	function __construct($data=[]) {
        $configurations = isset($data["configurations"]) ? $data["configurations"]:[];
		$this->to= isset($data['to']) ? $data['to']:'';
		$this->message = isset($data['msg']) ? $data['msg']:'';
		$this->from = isset($configurations["masking"]) ? $configurations["masking"]:'';
		$this->api_user = isset($configurations["username"]) ? $configurations["username"]:'';
		$this->api_pass = isset($configurations["password"]) ? $configurations["password"]:'';
		$this->debug = isset($configurations["debug_mode"]) ? $configurations["debug_mode"]:'';
		$this->apikey = isset($configurations["apikey"]) ? $configurations["apikey"]:'';
	}
	
	function configs(){
		return [
			'name'=>'sendpk.com',
			'description'=>'We Are Offering Direct Route To Send Bulk SMS With Your Brand Name With High Periority Direct Route. We Are Directly Connected Many Network Operator In The Worldwide Level To Provide World Best SMS Services.',
			'url'=>'http://sendpk.com/',
			'country'=>'Worldwide',
			'version'=>'',
			"configs"=>array(
                "username" => array (
                                    "Name" => "Username",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter Username", 
                                    "Default" => ""
                                    ),
                "password" => array (
                                    "Name" => "Password",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter Password", 
                                    "Default" => ""
                                    ),
                "apikey" => array (
                                    "Name" => "API Key",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter API Key", 
                                    "Default" => ""
                                    ),
                "masking" => array (
                                    "Name" => "Masking",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter Masking", 
                                    "Default" => ""
                                    ),
                "debug_mode" => array (
                    "Name" => "Enable Debug Mode?", 
                    "Type" =>  "yesno", 
                    "Size" => "55", 
                    "Description" => "Enable debug mode to log and display errors ", 
                    "Default" => "yes", 
                ),
                            )
		];
	}

	function send(){
	    $ch = curl_init();
	    $conn_timeout = 10; // Wait 10 seconds while trying to connect
	    $exec_timeout = 10; // Allow cUrl functions 20 seconds to execute
        curl_setopt($ch, CURLOPT_HTTPHEADER, 1);
	    curl_setopt($ch, CURLOPT_URL,$this->url.'?api_key='.$this->apikey);
	    curl_setopt($ch, CURLOPT_POST, 1);
	    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	    curl_setopt($ch, CURLOPT_AUTOREFERER, TRUE);
	    curl_setopt($ch, CURLOPT_HEADER, 0);
	    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);       
	    curl_setopt($ch, CURLOPT_POSTFIELDS,"sender=".$this->from."&mobile=".$this->to."&message=".$this->message);
	    curl_setopt ($ch, CURLOPT_TIMEOUT, $exec_timeout );
	    curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $conn_timeout);
	    $server_response = curl_exec( $ch );
	    $curl_info = curl_getinfo( $ch );
	    $status = $curl_info['http_code'];
	    $error = curl_error($ch);
	    curl_close( $ch );

        if($status == 200 || $status == 201 || $status == 202)
        {
          $parts = explode(':',$server_response);
            if($parts[0] == "OK ID"){
        	return ['status'=>true,'msg'=>$parts[1]];
            }else{
        	return ['status'=>false,'msg'=>json_encode($server_response)];
            }
        }else{
        	return ['status'=>false,'msg'=>json_encode($server_response)];
        }	    
	}

	function credit(){
	    $ch = curl_init();
	    if(!empty($this->userAgent))
	    	curl_setopt($ch, CURLOPT_USERAGENT,$this->userAgent);
		    curl_setopt($ch, CURLOPT_URL,$this->credit_url.'?api_key='.$this->apikey.'&username='.$this->api_user.'&password='.$this->api_pass);
		    curl_setopt($ch, CURLOPT_POST, 1);
		    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		    curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $this->timeout);
		    $data = curl_exec($ch);
            $part = explode(":",$data);
            $data2 = json_decode($data);
		return ($data>=0) ? $data:0;
	}

	function validate(){
	    $ch = curl_init();
	    if(!empty($this->userAgent))
	    	curl_setopt($ch, CURLOPT_USERAGENT,$this->userAgent);
		    curl_setopt($ch, CURLOPT_URL,$this->credit_url.'?api_key='.$this->apikey.'&username='.$this->api_user.'&password='.$this->api_pass);
		    curl_setopt($ch, CURLOPT_POST, 1);
		    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		    curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $this->timeout);
		    $data = curl_exec($ch);
            $part = explode(":",$data);
            $data2 = json_decode($data);
		return ['valid'=>($data>=0) ? 'YES':'NO','error'=>$data2->results];
	}
}