<?php 
class sendsms_ro {
	private $timeout = 10; // set to zero for no timeout
	private $userAgent = 'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1)'; 
	private $gsmnumber	= '';
	private $from = '';
	private $message = '';
	private $url = '';
	private $credit_url = '';
	private $delivery_url = '';
	private $user = '';
	private $pass = '';
	private $senderid = '';
	private $debug = '';

	function __construct($data=[]) {
        $configurations = isset($data["configurations"]) ? $data["configurations"]:[];
		$this->gsmnumber= isset($data['to']) ? $data['to']:'';
		$this->message = isset($data['msg']) ? $data['msg']:'';
		$this->senderid = isset($configurations["senderid"]) ? $configurations["senderid"]:'';
		$this->user = isset($configurations["user"]) ? $configurations["user"]:'';
		$this->pass = isset($configurations["pass"]) ? $configurations["pass"]:'';
		$this->debug = isset($configurations["debug_mode"]) ? $configurations["debug_mode"]:'';
	}
	
	function configs(){
		return [
			'name'=>'Send SMS',
			'description'=>'',
			'url'=>'https://www.sendsms.ro/',
			'country'=>'Romania, Global',
			'version'=>'',
			"configs"=>array(
                "user" => array (
                                    "Name" => "Username",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter Username", 
                                    "Default" => ""
                                    ),
                "pass" => array (
                                    "Name" => "Password",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter Password", 
                                    "Default" => ""
                                    ),
                "senderid" => array (
                                    "Name" => "Sender ID/Title",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter Sender ID/Title", 
                                    "Default" => ""
                                    ),
                "debug_mode" => array (
                    "Name" => "Enable Debug Mode?", 
                    "Type" =>  "yesno", 
                    "Size" => "55", 
                    "Description" => "Enable debug mode to log and display errors ", 
                    "Default" => "yes", 
                ),
                            )
		];
	}


 function send()
    {
        $messageSent = false;
        if ($this->gsmnumber == "numbererror") {
            $error="Number format error." . $this->gsmnumber;
             return ['status'=>$messageSent,'msg'=>$error];
        }
        $url = "http://api.sendsms.ro/json?action=message_send&username={$this->user}&password={$this->pass}&to={$this->gsmnumber}&text=" . urlencode($this->message) . "&from=$this->senderid";
        $result = file_get_contents($url);
        $result = json_decode($result, true);
        if (isset($result['status']) && $result['status'] == 1) {
            $messageSent = true;       
            $error = $result['details'];
        } else {
            $error = "ERROR: " . $result['message'];
        }
        return ['status'=>$messageSent,'msg'=>$error];
    }



	function credit(){
        $url = "https://api.sendsms.ro/json?action=user_get_balance&username=$this->user&password=".$this->pass;
        $result = file_get_contents($url);
        $result = json_decode($result, true);
        if (isset($result['status']) && $result['status'] == 0) {
            return $result['details'];
        } else {
            return 0;
        }
	}
	function validate(){
        $url = "https://api.sendsms.ro/json?action=user_get_balance&username=$this->user&password=".$this->pass;
        $result = file_get_contents($url);
        $result = json_decode($result, true);
        if (isset($result['status']) && $result['status'] == 0) {
            return ['valid'=>'YES','error'=>$result['details']];
        } else {
            return ['valid'=>'NO','error'=>$result['details']];
        }
	}
}