<?php
class smart_sms_pk {
	private $timeout = 10; // set to zero for no timeout
	private $userAgent = 'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1)'; 
	private $to	= '';
	private $from = '';
	private $message = '';
	private $url = 'http://smartsms.pk/json';
	private $credit_url = 'http://smartsms.pk/balance-inquiry';
	private $delivery_url = 'http://smartsms.pk/delivery?api_token=[username]&api_secret=[password]&messageid=[MessageID]';
	private $apitoken = '';
	private $apisecret = '';
	private $debug = '';

	function __construct($data=[])
	{
        $configurations = isset($data["configurations"]) ? $data["configurations"]:[];
		$this->to= isset($data['to']) ? $data['to']:'';
		$this->message = isset($data['msg']) ? $data['msg']:'';
		$this->from = isset($configurations["masking"]) ? $configurations["masking"]:'';
		$this->apitoken = isset($configurations["apitoken"]) ? $configurations["apitoken"]:'';
		$this->apisecret = isset($configurations["apisecret"]) ? $configurations["apisecret"]:'';
		$this->debug = isset($configurations["debug_mode"]) ? $configurations["debug_mode"]:'';
	}
	
	function configs(){
		return [
			'name'=>'smartsms.pk',
			'description'=>'SmartSMS.pk is here to ensure your experience with mobile marketing is a positive one. As local mobile marketing experts, we know that your business has its own unique interests and needs and this gives us the upper hand. This means taking the time to understand your goals and objectives and helping you use mobile marketing in a way thats right for your business, so that you can see a GOOD return on your investment.',
			'url'=>'http://smartsms.pk/',
			'country'=>'Pakistan',
			'version'=>'',
			"configs"=>array(
                "apitoken" => array (
                                    "Name" => "API Token",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter API Token", 
                                    "Default" => ""
                                    ),
                "apisecret" => array (
                                    "Name" => "API Secret",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter API Secret", 
                                    "Default" => ""
                                    ),
                "masking" => array (
                                    "Name" => "Masking",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter Masking", 
                                    "Default" => ""
                                    ),
                "debug_mode" => array (
                    "Name" => "Enable Debug Mode?", 
                    "Type" =>  "yesno", 
                    "Size" => "55", 
                    "Description" => "Enable debug mode to log and display errors ", 
                    "Default" => "yes", 
                ),
                            )
		];
	}

	function send(){
	    $ch = curl_init();
	    $conn_timeout = 10; // Wait 10 seconds while trying to connect
	    $exec_timeout = 10; // Allow cUrl functions 20 seconds to execute
        curl_setopt($ch, CURLOPT_HTTPHEADER, 1);
	    curl_setopt($ch, CURLOPT_URL,$this->url.'?api_token='.$this->apitoken.'&api_secret='.$this->apisecret);
	    curl_setopt($ch, CURLOPT_POST, 1);
	    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	    curl_setopt($ch, CURLOPT_AUTOREFERER, TRUE);
	    curl_setopt($ch, CURLOPT_HEADER, 0);
	    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);       
	    curl_setopt($ch, CURLOPT_POSTFIELDS,"from=".$this->from."&to=".$this->to."&message=".$this->message);
	    curl_setopt ($ch, CURLOPT_TIMEOUT, $exec_timeout );
	    curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $conn_timeout);
	    $server_response = curl_exec( $ch );
	    $curl_info = curl_getinfo( $ch );
	    $status = $curl_info['http_code'];
	    $error = curl_error($ch);
	    curl_close( $ch );

        if($status == 200 || $status == 201 || $status == 202)
        {
        $data = json_decode($server_response);
        $status = $data->status;
        if($status == 1){
        	return ['status'=>true,'msg'=>$server_response];
            }else{
        	return ['status'=>false,'msg'=>$server_response];
            }
        }else{
        	return ['status'=>false,'msg'=>$server_response];
        }	    
	    
	}

	function credit(){
	    $ch = curl_init();
	    if(!empty($this->userAgent))
	    	curl_setopt($ch, CURLOPT_USERAGENT,$this->userAgent);
		    curl_setopt($ch, CURLOPT_URL,$this->credit_url.'?api_token='.$this->apitoken.'&api_secret='.$this->apisecret);
		    curl_setopt($ch, CURLOPT_POST, 1);
		    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		    curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $this->timeout);
		    $data = curl_exec($ch);
            $credits = json_decode($data);
			return ($credits->sms>=0) ? $credits->sms:0;
	}

	function validate(){
	    $ch = curl_init();
	    if(!empty($this->userAgent))
	    	curl_setopt($ch, CURLOPT_USERAGENT,$this->userAgent);
		    curl_setopt($ch, CURLOPT_URL,$this->credit_url.'?api_token='.$this->apitoken.'&api_secret='.$this->apisecret);
		    curl_setopt($ch, CURLOPT_POST, 1);
		    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		    curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $this->timeout);
		    $data = curl_exec($ch);         
            $data2 = json_decode($data);
		return ['valid'=>($data2->status>0) ? 'YES':'NO','error'=>$data2->error];
	}




}