<?php
include_once('TMRestClient.php');
class textmarketer {
	private $timeout = 10; // set to zero for no timeout
	private $userAgent = 'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1)'; 
	private $to	= '';
	private $from = '';
	private $message = '';
	private $url = 'https://api.textmarketer.co.uk/services/rest/sms';
	private $credit_url = 'http://api.textmarketer.co.uk/services/rest/credits';
	private $delivery_url = '';
	private $api_user = '';
	private $api_pass = '';
	private $debug = '';
	
    private $message_id,$credits_used;	

	function __construct($data=[]) {
        $configurations = isset($data["configurations"]) ? $data["configurations"]:[];
		$this->to= isset($data['to']) ? $data['to']:'';
		$this->message = isset($data['msg']) ? $data['msg']:'';
		$this->from = isset($configurations["masking"]) ? $configurations["masking"]:'';
		$this->api_user = isset($configurations["username"]) ? $configurations["username"]:'';
		$this->api_pass = isset($configurations["password"]) ? $configurations["password"]:'';
		$this->debug = isset($configurations["debug_mode"]) ? $configurations["debug_mode"]:'';
	}
	
    public function getMessageID()
    {
        return $this->message_id;
    }
    public function getCreditsUsed()
    {
        return $this->credits_used;
    }	
	
	function configs(){
		return [
			'name'=>'textmarketer.co.uk',
			'description'=>'Sending SMS is a breeze with our low cost, top-notch tools through to our high quality gateway. With Text Marketer, bulk SMS is effortless. There are no set-up fees, contracts or software to download and heaps of valuable features all wrapped up in a low cost package that blows the competition out of the water.',
			'url'=>'https://www.textmarketer.co.uk/',
			'country'=>'UK',
			'version'=>'',
			"configs"=>array(
                "username" => array (
                                    "Name" => "Username",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter Username", 
                                    "Default" => ""
                                    ),
                "password" => array (
                                    "Name" => "Password",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter Password", 
                                    "Default" => ""
                                    ),
                "masking" => array (
                                    "Name" => "Masking",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter Masking", 
                                    "Default" => ""
                                    ),
                "debug_mode" => array (
                    "Name" => "Enable Debug Mode?", 
                    "Type" =>  "yesno", 
                    "Size" => "55", 
                    "Description" => "Enable debug mode to log and display errors ", 
                    "Default" => "yes", 
                ),
                            )
		];
	}
    
    
  // public function to commit the send
    public function send()
    {
        $tmClient = new TMRestClient($this->api_user,$this->api_pass, 'production');
        try {
            $sent = $tmClient->sendSMS($this->message, $this->to,$this->from);
            return ['status'=>true,'msg'=>json_encode($sent)];
        } catch (Exception $ex) {
            $errors = $tmClient->getLastErrors();
            return ['status'=>false,'msg'=>json_encode($errors)];
        }        
    }

    public function credit()
    {
        $tmClient = new TMRestClient($this->api_user,$this->api_pass, 'production');
        try {
            $credits = $tmClient->getCredits();
            return ($credits>0) ? $credits:0;
        } catch (Exception $ex) {
            $errors = $tmClient->getLastErrors();
            return 0;
        }        
    }

    public function validate()
    {
        $tmClient = new TMRestClient($this->api_user,$this->api_pass, 'production');
        try {
            $credits = $tmClient->getCredits();
            return ($credits>0) ? $credits:0;
        } catch (Exception $ex) {
            $errors = $tmClient->getLastErrors();
            return 0;
        }        
    }
}