<?php

class the_texting {
	private $timeout = 10; // set to zero for no timeout
	private $userAgent = 'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1)'; 
	private $to	= '';
	private $from = '';
	private $message = '';
	private $url = 'https://www.thetexting.com/rest/sms/json/message/send';
	private $credit_url = 'https://www.thetexting.com/rest/sms/json/account/getbalance';
	private $delivery_url = '';
	private $apikey = '';
	private $apisecret = '';
	private $debug = '';

	function __construct($data=[])
	{
        $configurations = isset($data["configurations"]) ? $data["configurations"]:[];
		$this->to= isset($data['to']) ? $data['to']:'';
		$this->message = isset($data['msg']) ? $data['msg']:'';
		$this->from = isset($configurations["masking"]) ? $configurations["masking"]:'';
		$this->apikey = isset($configurations["apikey"]) ? $configurations["apikey"]:'';
		$this->apisecret = isset($configurations["apisecret"]) ? $configurations["apisecret"]:'';
		$this->debug = isset($configurations["debug_mode"]) ? $configurations["debug_mode"]:'';
	}
	
	function configs(){
		return [
			'name'=>'The Texting',
			'description'=>'We are covering 100% of United States and Canada both via Long code text messaging service as well as Short code texting service. Not only limited to this, We can now deliver globally.',
			'url'=>'https://www.thetexting.com/',
			'country'=>'World Wide',
			'version'=>'',
			"configs"=>array(
                "apikey" => array (
                                    "Name" => "API Key",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter API Key", 
                                    "Default" => ""
                                    ),
                "apisecret" => array (
                                    "Name" => "API Secret",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter API Secret", 
                                    "Default" => ""
                                    ),
                "masking" => array (
                                    "Name" => "Masking",
                                    "Type" => "text",
                                    "Size" => "100",
                                    "DivColumns"=>"12",
                                    "Description" => "Enter Masking", 
                                    "Default" => ""
                                    ),
                "debug_mode" => array (
                    "Name" => "Enable Debug Mode?", 
                    "Type" =>  "yesno", 
                    "Size" => "55", 
                    "Description" => "Enable debug mode to log and display errors ", 
                    "Default" => "yes", 
                ),
                            )
		];
	}

	function send(){
	    $ch = curl_init();
	    if(!empty($this->userAgent))
	    	curl_setopt($ch, CURLOPT_USERAGENT,$this->userAgent);
		    curl_setopt($ch, CURLOPT_URL,$this->credit_url.'?api_key='.$this->apikey.'&api_secret='.$this->apisecret.'&from='.$this->from.'&to='.$this->to.'&text='.$this->message);
		    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		    curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $this->timeout);
		    $data = curl_exec($ch); 
		    $data2 = json_decode($data);
		    $Status =  $data2->Response->Status; 
		    $balance =  $data2->Response->balance; 
		    $message_id =  $data2->Response->message_id; 
		    $ErrorMessage =  $data2->Response->ErrorMessage; 

	        if($Status == 0)
	        {
	        	return ['status'=>true,'msg'=>$message_id];
            }else{
    	    	return ['status'=>false,'msg'=>json_encode($data2)];
            }
	}

	function credit(){
	    $ch = curl_init();
	    if(!empty($this->userAgent))
	    	curl_setopt($ch, CURLOPT_USERAGENT,$this->userAgent);
		    curl_setopt($ch, CURLOPT_URL,$this->credit_url.'?api_key='.$this->apikey.'&api_secret='.$this->apisecret);
		    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		    curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $this->timeout);
		    $data = curl_exec($ch); 
		    $data2 = json_decode($data);
		    $Status =  $data2->Response->Status; 
		    $balance =  $data2->Response->balance; 
		    $ErrorMessage =  $data2->Response->ErrorMessage; 
			return ($balance>0) ? $balance:0;
	}

	function validate(){
	    $ch = curl_init();
	    if(!empty($this->userAgent))
	    	curl_setopt($ch, CURLOPT_USERAGENT,$this->userAgent);
		    curl_setopt($ch, CURLOPT_URL,$this->credit_url.'?api_key='.$this->apikey.'&api_secret='.$this->apisecret);
		    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		    curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $this->timeout);
		    $data = curl_exec($ch); 
		    $data2 = json_decode($data);
		    $Status =  $data2->Response->Status; 
		    $balance =  $data2->Response->balance; 
		    $ErrorMessage =  $data2->Response->ErrorMessage; 
		return ['valid'=>($Status == 0) ? 'YES':'NO','error'=>$ErrorMessage];
	}




}