<?php 
class Widget_Chat_Ratings
{
    function Output()
    {
    	$cYear = date('Y');
        $sql2 = "select a.rating,a.comments,a.datetime from support_tickets_feedback a join support_tickets b on a.ticket_id=b.id  and b.type='CHAT' order by a.datetime desc limit 20";
        $ResponseData = full_query($sql2);
    	$RatingsTickets = '<table class="table table-bordered table-striped table-hover"><thead class="customTableTh"><tr><th>Rating</th><th>Message</th><th>Date</th></tr></thead><tbody>';
    	if(!empty($ResponseData))
    	{
        	foreach ($ResponseData as $result)
        	{
        	    $rating = Devide($result->rating,2);
        	    $ratingParts = explode(".",$rating);
        	    $StartRate = isset($ratingParts[0]) ? $ratingParts[0]:0;
        	    $LastRate = isset($ratingParts[1]) ? $ratingParts[1]:0;
        	    $RatingsStars = "";
        	    if($StartRate>0)
        	    {
            	    for($i=0;$i<$rating;$i++)
            	    {
            	        $RatingsStars .='<i class="icon-star-full2" style="color:#006699;"></i>';
            	    }
        	    }
        	    if($LastRate>0)
        	    {
            	    $RatingsStars .='<i class="icon-star-half" style="color:#006699;"></i>';
        	    }
        	    $RatingsTickets .= '<tr><td nowrap>'.$RatingsStars.'</td><td>'.$result->comments.'</td><td nowrap>'.GetTimeAgo($result->datetime).'</td></tr>';
        	}
        $RatingsTickets .='</tbody></table>';
    	}else{
            $RatingsTickets = infoBox("Live Chats Rating","Live Chats Ratings not found","info");
    	}

        $sql2 = "select a.clientname,a.entries from (select a.closed_by,concat(c.first_name,' ',c.last_name) as clientname,count(a.id) as entries from support_tickets a join clients c on a.closed_by=c.id and a.type='CHAT' group by a.closed_by,concat(c.first_name,' ',c.last_name)) a where a.entries>0 order by a.entries desc limit 20";
        $ResponseData = full_query($sql2);
    	$headers = ["Name","Solved"];
    	$rows = [];
    	$TopTicketsSolvers = '<table class="table table-bordered table-striped table-hover"><thead class="customTableTh"><tr><th>Name</th><th>Solved</th></tr></thead><tbody>';
    	if(!empty($ResponseData))
    	{
        	foreach ($ResponseData as $result)
        	{
        	    $TopTicketsSolvers .= '<tr><td nowrap>'.$result->clientname.'</td><td>'.$result->entries.'</td></tr>';
        	}
        $TopTicketsSolvers .='</tbody></table>';
    	}else{
            $TopTicketsSolvers = infoBox("Top Tickets Solvers","Top Tickets Solvers not found","info");
    	}

$html = '<style>
    .tableFixHead {
    overflow-y: auto; /* make the table scrollable if height is more than 200 px  */
    height: 267px; /* gives an initial height of 200px to the table */
    }
    .tableFixHead thead th {
        position: sticky; /* make the table heads sticky */
        top: 0px; /* table head will be placed from the top of the table and sticks to it */
    }
</style>
<div class="tabbable">
    <ul class="nav nav-tabs nav-tabs-component nav-justified">
        <li class="active"><a href="#iv-Recent-Ratings" data-toggle="tab" aria-expanded="true">Recent Ratings</a></li>
        <li class=""><a href="#iv-Tickets-Solvers" data-toggle="tab" aria-expanded="false">Top Chat Solvers</a></li>
    </ul>
    <div class="tab-content">
        <div class="tab-pane active" id="iv-Recent-Ratings">
            <div class="tableFixHead">'.$RatingsTickets.'</div>
        </div>
        <div class="tab-pane" id="iv-Tickets-Solvers">
            <div class="tableFixHead">'.$TopTicketsSolvers.'</div>
        </div>
    </div>
</div>';
	return [
        'id'=>7,
        'title'=>'Chats requiring attention In '.$cYear,
        'description'=>'Top 10 Oldest Unassigned Chats',
        'weight'=>9,
        'columns'=>6,
        'DisplayTitle'=>false,
        'WidgetOwnLayout'=>true,
        'content'=>$html
    ];
    }
}