<?php 
class Widget_Domains_TopShares
{
    function Output()
    {
    	$cYear = date('Y');
        $Array = [];
    $baseCurrency = getBaseCurrency(['id'=>0]);
    $bsp = $baseCurrency->symbol_position;
    $bsb = $baseCurrency->symbol;    	
    $bsc = $baseCurrency->code;                      
    $sql2 = "select a.months,a.itemname,a.sales from (select a.months,a.itemname,sum(a.amount) as sales from (
select DATE_FORMAT(iv.entry_date,'%Y-%m') as months,a.pid as id,p.name as itemname,sum((i.qty*i.rate)/i.base_conv_rate) as amount
from domains a 
join domains_tlds p on p.id=a.pid
join invoices_details i on i.user_id=a.user_id and i.pid=a.id and i.type=a.type
join invoices iv on i.invoice_id=iv.id and YEAR(iv.entry_date) = YEAR(CURDATE())
    join (select distinct z.id from (select id from (select x.pid as id,count(x.id) as entries from domains x where x.status='Active' group by x.pid) z where z.entries>0 order by z.entries desc limit 10) z) tp on p.id=tp.id
where a.status='Active' group by DATE_FORMAT(iv.entry_date,'%Y-%m'),a.pid,p.name
) a where a.amount>0 group by a.months,a.itemname) a order by a.sales desc";
    $ProductsSales = full_query($sql2);
    $invoicesData = [];
	$data = "";
	$headers = [];
	foreach($ProductsSales as $row)
	{
	    $headers[$row->itemname] = $row->itemname;
	}
	$data .= "['Month','".(implode("','",$headers))."'],";
    $months = [];
    for($i=1;$i<=12;$i++)
    {
        $m = ($i<=9) ? '0'.$i:$i;
        $months[] = $cYear."-".$m;
    }
    sort($months);  
    foreach($months as $name)
    {
    	foreach($ProductsSales as $row)
    	{
            $invoicesData[$name][$row->itemname] = 0;
    	}
    }
	foreach ($ProductsSales as $result)
	{
	    $invoicesData[$result->months][$result->itemname] = $result->sales;
	}


	foreach($invoicesData as $month=>$items)
	{
	    $monthName = date('M', strtotime($month."-01"));
        $idata = "['".$monthName."',";
    	foreach($items as $in=>$iv)
    	{
    	    $idata .= round($iv,2).",";
    	}
    	$idata = rtrim($idata,",");
        $data .= $idata."],";
	}
    $data = rtrim($data,',');
    if(!empty($ProductsSales))
    {
        $html = '<script type="text/javascript">
              google.charts.load("current", {"packages":["corechart"]});
              google.charts.setOnLoadCallback(drawChart);
              function drawChart() {
                var data = google.visualization.arrayToDataTable(['.$data.']);
        
                var options = {
                  curveType: "function",
                  legend: { position: "top"}
                };
                var chart = new google.visualization.LineChart(document.getElementById("ProductsShareInSales"));
                chart.draw(data, options);
              }
            </script>
        <div id="ProductsShareInSales"></div>
        <style>#ProductsShareInSales {width: 100%;height: 300px;}</style>';
    }else{
        $html = '<div id="ProductsShareInSales">
            <div class="card-body text-center" style="padding-top: 100px;">
                <h6 class="font-weight-semibold">Top 10 TLDs Share in Sales</h6>
                <p class="text-muted">Top 10 TLDs sales share not found in current year.</p>
            </div>
        </div>
        <style>#ProductsShareInSales {width: 100%;height: 300px;}</style>';
    }
	return [
            'id'=>7,
            'title'=>'Top 10 TLDs Share in Sales',
            'description'=>'Top 10 TLDs Share in Sales.',
            'weight'=>6,
            'columns'=>12,
            'DisplayTitle'=>true,
            'WidgetOwnLayout'=>false,
            'content'=>$html
        ];
    }
}