<?php 
class Widget_Fas_GrossNet_Working_Capital
{
    function Output()
    {
        $ws =& get_instance();
        $SITE_FY_START_DATE = $ws->Config->getConfig("SITE_FY_START_DATE");
        $Parts = explode("-",$SITE_FY_START_DATE);
        $Month = $Parts[1];
        $Day = $Parts[2];
        $cDate = date('Y-m-d');
        $date=date_create($cDate);
        $fy = (date_format($date,"m") >= $Month) ? (date_format($date,"Y")) . '-' . (date_format($date,"Y")+1) : (date_format($date,"Y")-1) . '-' . date_format($date,"Y");
        $yParts = explode("-",$fy);
        $datedFrom = $yParts[0]."-".$Month."-".$Day;
        $datedTo = $yParts[1]."-".$Month."-".$Day;
        $cMonth = date('Y-m');
        $months = [];
        for($i=1;$i<=12;$i++)
        {
            $m = ($i<=9) ? '0'.$i:$i;
            if($i >= $Month)
            {
                $months[] = date_format($date,"Y")."-".$m;
            }else{
                $months[] = (date_format($date,"Y")+1)."-".$m;
            }
        }
        sort($months);         
    //Cash,Accounts Receivable,Inventory,Short-term Investments
    $sql2 = "select months,sum(assets) as assets,sum(liabilities) as liabilities,sum(assets-liabilities) as nwc from (
    select DATE_FORMAT(dated,'%Y-%m') as months,sum(debit-credit) as assets,0 as liabilities from fas_ledger where left(code,4) in (1001,1002) and DATE_FORMAT(dated,'%Y-%m-%d') between '".$datedFrom."' and '".$datedTo."' group by DATE_FORMAT(dated,'%Y-%m')
    union all 
    select DATE_FORMAT(dated,'%Y-%m') as months,0 as assets,sum(credit-debit) as liabilities from fas_ledger where left(code,4)=2001 and DATE_FORMAT(dated,'%Y-%m-%d') between '".$datedFrom."' and '".$datedTo."' group by DATE_FORMAT(dated,'%Y-%m')) a";
    $ResponseData = full_query($sql2);
    
    $ResponseDataSet = [];
	$NWCvsGWC = "['Month', 'Net Working Capital', 'Gross Working Capital'],";
    foreach($months as $name)
    {
        $ResponseDataSet[$name] = ["n"=>0,"g"=>0];
    }
	foreach ($ResponseData as $result)
	{
	    $m = $result->months;
	    $assets = $result->assets;
	    $nwc = $result->nwc;
	    $ResponseDataSet[$m] = ["n"=>$nwc,"g"=>$assets];
	}
	foreach($ResponseDataSet as $ivk=>$ivv)
	{
	    $monthName = date('M', strtotime($ivk."-01"));
        $NWCvsGWC .= "['".$monthName."',".$ivv["n"].",".$ivv["g"]."],";
	}
    $NWCvsGWC = rtrim($NWCvsGWC,',');
    
    
    $sql2 = "select months,sum(incomes) as incomes,sum(expenses) as expenses,sum(otherexpenses) as otherexpenses,sum(incomes-expenses) as gp,sum(incomes-(expenses+otherexpenses)) as np from (
    select DATE_FORMAT(dated,'%Y-%m') as months,sum(credit-debit) as incomes,0 as expenses,0 as otherexpenses from fas_ledger where left(code,2)=40 and code not in (400102) and DATE_FORMAT(dated,'%Y-%m-%d') between '".$datedFrom."' and '".$datedTo."' group by DATE_FORMAT(dated,'%Y-%m')
    union all 
    select DATE_FORMAT(dated,'%Y-%m') as months,0 as incomes,sum(debit-credit) as expenses,0 as otherexpenses from fas_ledger where left(code,4)=5001 and DATE_FORMAT(dated,'%Y-%m-%d') between '".$datedFrom."' and '".$datedTo."' group by DATE_FORMAT(dated,'%Y-%m')
    union all 
    select DATE_FORMAT(dated,'%Y-%m') as months,0 as incomes,0 as expenses,sum(debit-credit) as otherexpenses from fas_ledger where left(code,4)=5002 and DATE_FORMAT(dated,'%Y-%m-%d') between '".$datedFrom."' and '".$datedTo."' group by DATE_FORMAT(dated,'%Y-%m')
) a";
    $ResponseData = full_query($sql2);
    
    $ResponseDataSet = [];
	$ProfitLossSummary = "['Month', 'Income', 'Cost of Goods', 'Gross Profit', 'Other Expenses','Net Profit'],";
    foreach($months as $name)
    {
        $ResponseDataSet[$name] = ["i"=>0,"c"=>0,"g"=>0,"o"=>0,"n"=>0];
    }
	foreach ($ResponseData as $result)
	{
	    $m = $result->months;
	    $incomes = $result->incomes;
	    $expenses = $result->expenses;
	    $gp = $result->gp;
	    $otherexpenses = $result->otherexpenses;
	    $np = $result->np;
	    $ResponseDataSet[$m] = ["i"=>$incomes,"c"=>$expenses,"g"=>$gp,"o"=>$otherexpenses,"n"=>$np];
	}
	foreach($ResponseDataSet as $ivk=>$ivv)
	{
	    $monthName = date('M', strtotime($ivk."-01"));
        $ProfitLossSummary .= "['".$monthName."',".$ivv["i"].",".$ivv["c"].",".$ivv["g"].",".$ivv["o"].",".$ivv["n"]."],";
	}
    $ProfitLossSummary = rtrim($ProfitLossSummary,',');    
    

    $sql2 = "select DATE_FORMAT(dated,'%Y-%m') as months,sum(debit) as debit,sum(credit) as credit,sum(debit-credit) as amount from fas_ledger where left(code,4)=1001 and DATE_FORMAT(dated,'%Y-%m-%d') between '".$datedFrom."' and '".$datedTo."' group by DATE_FORMAT(dated,'%Y-%m')";
    $ResponseData = full_query($sql2);
    
    $ResponseDataSet = [];
	$CashBalanceEndOfMonth = "['Month','Debit','Credit','Balance'],";
    foreach($months as $name)
    {
        $ResponseDataSet[$name] = ["d"=>0,"c"=>0,"b"=>0];
    }
	foreach ($ResponseData as $result)
	{
	    $m = $result->months;
	    $cBalance = $result->amount;
	    $cDebit = $result->debit;
	    $cCredit = $result->credit;
	    $ResponseDataSet[$m] = ["d"=>$cDebit,"c"=>$cCredit,"b"=>$cBalance];
	}
	foreach($ResponseDataSet as $ivk=>$ivv)
	{
	    $monthName = date('M', strtotime($ivk."-01"));
        $CashBalanceEndOfMonth .= "['".$monthName."',".$ivv["d"].",".$ivv["c"].",".$ivv["b"]."],";
	}
    $CashBalanceEndOfMonth = rtrim($CashBalanceEndOfMonth,',');    

    $sql2 = "select code,name from fas_chart_of_accounts where left(code,4)=1001 order by code";
    $ChartOfAccounts = full_query($sql2);
    $rDataSetHeads = [];
    $rDataSetHeads[] = "Month";
    foreach($ChartOfAccounts as $coa)
    {
        $code = $coa->code;
        $cname = $coa->name;
        $rDataSetHeads[] = $cname;
    }
    $ResponseDataSet = [];

    foreach($months as $name)
    {
        foreach($ChartOfAccounts as $coa)
        {
            $ResponseDataSet[$name][$coa->code] = 0;
        }
    }
    foreach($ChartOfAccounts as $coa)
    {
        $code = $coa->code;
        $sql2 = "select DATE_FORMAT(dated,'%Y-%m') as months,sum(debit-credit) as amount from fas_ledger where code=".$code." and DATE_FORMAT(dated,'%Y-%m-%d') between '".$datedFrom."' and '".$datedTo."' group by DATE_FORMAT(dated,'%Y-%m')";
        $ResponseData = full_query($sql2);
    	foreach ($ResponseData as $result)
    	{
    	    $m = $result->months;
    	    $amount = $result->amount;
            $ResponseDataSet[$m][$code] = $amount;
        }
    }
    $CashBankBalanceEndOfMonth = "[";
	foreach($rDataSetHeads as $v)
	{
        $CashBankBalanceEndOfMonth .= "'".$v."',";
	}
    $CashBankBalanceEndOfMonth = rtrim($CashBankBalanceEndOfMonth,',');
    $CashBankBalanceEndOfMonth .= "],";
	foreach($ResponseDataSet as $ivk=>$ivv)
	{
	    $monthName = date('M', strtotime($ivk."-01"));
        $cbbeom = "['".$monthName."',";
    	foreach($ivv as $cvk=>$cvv)
    	{
            $cbbeom .= $cvv.",";
    	}
    	$cbbeom = rtrim($cbbeom,',');
    	$cbbeom .= "],";
    	$CashBankBalanceEndOfMonth .= $cbbeom;
	}
    $CashBankBalanceEndOfMonth = rtrim($CashBankBalanceEndOfMonth,',');    

	    $html = '<div class="tabbable FasTabsCharts1" style="margin-top: 35px;">
    <ul class="nav nav-tabs nav-tabs-component nav-justified" style="margin-top: -37px;">
        <li class="active"><a href="#iv-fas-NWCvsGWC" data-toggle="tab" aria-expanded="true">NWC vs GWC</a></li>
        <li class=""><a href="#iv-fas-ProfitLossSum" data-toggle="tab" aria-expanded="false">Profit & Loss Summary</a></li>
        <li class=""><a href="#iv-fas-CashEndOfMonth" data-toggle="tab" aria-expanded="false">Cash | at end of month</a></li>
        <li class=""><a href="#iv-fas-CashBankEndOfMonth" data-toggle="tab" aria-expanded="false">Cash & Bank Balances</a></li>
    </ul>
    <div class="tab-content">
        <script type="text/javascript">
            function DrawNWCvsGWC()
            {
              google.charts.load("current", {"packages":["corechart"]});
              google.charts.setOnLoadCallback(function(){
                    var chart = new google.visualization.LineChart(document.getElementById("Fas_NWCvsGWC"));
                    chart.draw(google.visualization.arrayToDataTable(['.$NWCvsGWC.']), {curveType: "function",legend: { position: "top", maxLines: 5 }});
                });
            }
            function DrawProfitLossSummary()
            {
              google.charts.load("current", {"packages":["corechart"]});
              google.charts.setOnLoadCallback(function(){
                    var chart = new google.visualization.LineChart(document.getElementById("Fas_ProfitLossSum"));
                    chart.draw(google.visualization.arrayToDataTable(['.$ProfitLossSummary.']),{curveType: "function",legend: { position: "top", maxLines: 5 },bar: { groupWidth: "75%" },isStacked: true});
                });
            }
            function DrawCashBalanceEndOfMonth()
            {
              google.charts.load("current", {"packages":["corechart"]});
              google.charts.setOnLoadCallback(function(){
                    var chart = new google.visualization.LineChart(document.getElementById("Fas_CashEndOfMonth"));
                    chart.draw(google.visualization.arrayToDataTable(['.$CashBalanceEndOfMonth.']),{curveType: "function",legend: { position: "top", maxLines: 5 },bar: { groupWidth: "75%" },isStacked: true});
                });
            }
            function DrawCashBankEndOfMonth()
            {
              google.charts.load("current", {"packages":["corechart"]});
              google.charts.setOnLoadCallback(function(){
                    var chart = new google.visualization.BarChart(document.getElementById("Fas_CashBankEndOfMonth"));
                    chart.draw(google.visualization.arrayToDataTable(['.$CashBankBalanceEndOfMonth.']),{curveType: "function",legend: { position: "top", maxLines: 5 },bar: { groupWidth: "75%" },isStacked: true});
                });
            }
        </script>
        <div class="tab-pane active" id="iv-fas-NWCvsGWC">
            <div id="Fas_NWCvsGWC"></div>
            <style>#Fas_NWCvsGWC {width: 100%;height: 300px;padding:10px;}</style>            
        </div>
        <div class="tab-pane" id="iv-fas-ProfitLossSum">
            <div id="Fas_ProfitLossSum"></div>
            <style>#Fas_ProfitLossSum {width: 100%;height: 300px;padding:10px;}</style>            
        </div>
        <div class="tab-pane" id="iv-fas-CashEndOfMonth">
            <div id="Fas_CashEndOfMonth"></div>
            <style>#Fas_CashEndOfMonth {width: 100%;height: 300px;padding:10px;}</style>            
        </div>
        <div class="tab-pane" id="iv-fas-CashBankEndOfMonth">
            <div id="Fas_CashBankEndOfMonth"></div>
            <style>#Fas_CashBankEndOfMonth {width: 100%;height: 300px;padding:10px;}</style>            
        </div>
    </div>
    <script>
        function ReDrawCharts1(id="")
        {
            if (id === "#iv-fas-NWCvsGWC") {
                DrawNWCvsGWC();
            }
            if (id === "#iv-fas-ProfitLossSum") {
                DrawProfitLossSummary();
            }
            if (id === "#iv-fas-CashEndOfMonth") {
                DrawCashBalanceEndOfMonth();
            }
            if (id === "#iv-fas-CashBankEndOfMonth") {
                DrawCashBankEndOfMonth();
            }
        }
        $(document).ready(function(){
            var activeTabId = $(".FasTabsCharts1 li.active a").attr("href");
            ReDrawCharts1(activeTabId);
        });
        $(".FasTabsCharts1 a").on("shown.bs.tab", function (e) {
            ReDrawCharts1(e.target.hash);
        });
    </script>     
</div>';
	return [
        'id'=>7,
        'title'=>'Net Working Capital Vs Gross Working Capital in (FY '.$fy.")",
        'description'=>'Net Working Capital Vs Gross Working Capital',
        'weight'=>4,
        'columns'=>6,
        'DisplayTitle'=>false,
        'WidgetOwnLayout'=>true,
        'content'=>$html
    ];
    }
}