<?php 
class Widget_General_Automation_Summary
{
    function Output()
    {
    $ws = & get_instance();
    $res = $ws->Automation->RunStats();
    $alertMsg = $res["msg"];
    $alertStatus = $res["class"];
    $LastRunDate = $res["date"];
    $mins = $res["mins"];
    if(empty($LastRunDate)) $LastRunDate=$mins." Minutes ago";
    $dated = date('Y-m-d');
    $DataSets = $ws->Automation->GetStats($dated);
    function chartToStrings()
    {
      $string = [];
      for($i=0;$i<8;$i++)
      {
          $string[]= mt_rand(0,9);
      }
      return implode(",",$string);
    }
    
    $invoicesCreatedToday=0;
    if(isset($DataSets["GeneratedInvoicesAutomation"]))
    {
        $GI = $DataSets["GeneratedInvoicesAutomation"];
        $invoicesCreatedToday = $GI["counts"] ?? 0;
    }
    if($invoicesCreatedToday>0 && empty($_SESSION["invoicesCreatedString"])) $_SESSION["invoicesCreatedString"]=chartToStrings();
    if($invoicesCreatedToday == 0) $_SESSION["invoicesCreatedString"] = "";
    $invoicesCreatedString = $_SESSION["invoicesCreatedString"];
    
    $overdueSuspensionsToday=0;
    if(isset($DataSets["OverdueSuspensionsAutomation"]))
    {
        $OS = $DataSets["OverdueSuspensionsAutomation"];
        $overdueSuspensionsToday = $OS["counts"] ?? 0;
    }
    if($overdueSuspensionsToday>0 && empty($_SESSION["overdueSuspensionsString"])) $_SESSION["overdueSuspensionsString"]=chartToStrings();
    if($overdueSuspensionsToday == 0) $_SESSION["overdueSuspensionsString"] = "";
    $overdueSuspensionsString = $_SESSION["overdueSuspensionsString"];
    
    $closedTicketsToday=0;
    if(isset($DataSets["ClosedInactiveTicketsAutomation"]))
    {
        $CIT = $DataSets["ClosedInactiveTicketsAutomation"];
        $closedTicketsToday = $CIT["counts"] ?? 0;
    }
    if($closedTicketsToday>0 && empty($_SESSION["closedTicketsString"])) $_SESSION["closedTicketsString"]=chartToStrings();
    if($closedTicketsToday == 0) $_SESSION["closedTicketsString"] = "";
    $closedTicketsString = $_SESSION["closedTicketsString"];
    
    $overdueRemindersToday=0;
    if(isset($DataSets["InvoiceOverdueRemindersAutomation"]))
    {
        $SIOR = $DataSets["InvoiceOverdueRemindersAutomation"];
        $overdueRemindersToday = $SIOR["counts"] ?? 0;
    }
    if($overdueRemindersToday>0 && empty($_SESSION["overdueRemindersString"])) $_SESSION["overdueRemindersString"]=chartToStrings();
    if($overdueRemindersToday == 0) $_SESSION["overdueRemindersString"] = "";
    $overdueRemindersString = $_SESSION["overdueRemindersString"];

    $cancellationsToday=0;
    if(isset($DataSets["ProcessedCancellationsAutomation"]))
    {
        $PC = $DataSets["ProcessedCancellationsAutomation"];
        $cancellationsToday = $PC["counts"] ?? 0;
    }
    if($cancellationsToday>0 && empty($_SESSION["cancellationsString"])) $_SESSION["cancellationsString"]=chartToStrings();
    if($cancellationsToday == 0) $_SESSION["cancellationsString"] = "";
    $cancellationsString = $_SESSION["cancellationsString"];
    
    $ccCapturesToday=0;
    if(isset($DataSets["CreditCardCharges"]))
    {
        $CCC = $DataSets["CreditCardCharges"];
        $ccCapturesToday = $CCC["counts"] ?? 0;
    }
    if($ccCapturesToday>0 && empty($_SESSION["ccCapturesString"])) $_SESSION["ccCapturesString"]=chartToStrings();
    if($ccCapturesToday == 0) $_SESSION["ccCapturesString"] = "";
    $ccCapturesString = $_SESSION["ccCapturesString"];

      $date = date('Y-m-d');
    	$output ='<div class="widget-content-padded widget-automation" style="height: 310px;
    overflow: hidden;">
<div class="row">
    <div class="col-sm-6" onclick="ws.GetAutomationStatusLogs(\'InvoicesAutoGeneration\',\''.$date.'\',true);">
        <div class="mini-chart">
            <a class="wsAmStatusCheck" wst="GeneratedInvoices" wsd="'.$date.'">
                <span class="peity-line" data-peity=\'{ "fill": "rgba(64, 186, 189, 0.2)", "stroke": "rgba(64, 186, 189, 0.7)", "strokeWidth": 2, "width": 150}\'>'.$invoicesCreatedString.'</span>
            </a>
        </div>
        <h4 class="item-title">
            <span class="title-text">Invoices Created</span>
        </h4>
        <p class="item-figure color-blue">'.$invoicesCreatedToday.'</p>
    </div>
    <div class="col-sm-6">
        <div class="mini-chart">
            <a class="wsAmStatusCheck" wst="CreditCardCharges" wsd="'.$date.'">
                <span class="peity-line" data-peity=\'{ "fill": "rgba(132, 217, 145, 0.2)", "stroke": "rgba(132, 217, 145, 0.7)", "strokeWidth": 2, "width": 150}\'>'.$ccCapturesString.'</span>
            </a>
        </div>
        <h4 class="item-title">
            <span class="title-text">Credit Card Captures</span>
        </h4>
        <p class="item-figure color-green">'.$ccCapturesToday.'</p>
    </div>
    <div class="col-sm-6" onclick="ws.GetAutomationStatusLogs(\'OverdueSuspensions\',\''.$date.'\',true);">
        <div class="mini-chart">
            <a class="wsAmStatusCheck" wst="OverdueSuspensions" wsd="'.$date.'">
                <span class="peity-line" data-peity=\{ "fill": "rgba(248, 161, 63, 0.2)", "stroke": "rgba(248, 161, 63, 0.7)", "strokeWidth": 2, "width": 150}\'>'.$overdueSuspensionsString.'</span>
            </a>
        </div>
        <h4 class="item-title">
            <span class="title-text">Overdue Suspensions</span>
        </h4>
        <p class="item-figure color-orange">'.$overdueSuspensionsToday.'</p>
    </div>
    <div class="col-sm-6" onclick="ws.GetAutomationStatusLogs(\'ClosedInactiveTickets\',\''.$date.'\',true);">
        <div class="mini-chart">
            <a class="wsAmStatusCheck" wst="ClosedInactiveTickets" wsd="'.$date.'">
                <span class="peity-line" data-peity=\'{ "fill": "rgba(234, 83, 149, 0.2)", "stroke": "rgba(234, 83, 149, 0.7)", "strokeWidth": 2, "width": 150}\'>'.$closedTicketsString.'</span>
            </a>
        </div>
        <h4 class="item-title">
            <span class="title-text">Inactive Tickets Closed</span>
        </h4>
        <p class="item-figure color-pink">'.$closedTicketsToday.'</p>
    </div>
    <div class="col-sm-6" onclick="ws.GetAutomationStatusLogs(\'InvoiceOverdueReminders\',\''.$date.'\',true);">
        <div class="mini-chart">
            <a class="wsAmStatusCheck" wst="SentInvoiceOverdueReminders" wsd="'.$date.'">
                <span class="peity-line" data-peity=\'{ "fill": "rgba(30, 30, 30, 0.2)", "stroke": "rgba(30, 30, 30, 0.4)", "strokeWidth": 2, "width": 150}\'>'.$overdueRemindersString.'</span>
            </a>
        </div>
        <h4 class="item-title">
            <span class="title-text">Overdue Reminders</span>
        </h4>
        <p class="item-figure color-grey">'.$overdueRemindersToday.'</p>
    </div>
    <div class="col-sm-6" onclick="ws.GetAutomationStatusLogs(\'ProcessedCancellations\',\''.$date.'\',true);">
        <div class="mini-chart">
            <a class="wsAmStatusCheck" wst="ProcessedCancellations" wsd="'.$date.'">
                <span class="peity-line" data-peity=\'{ "fill": "rgba(144, 31, 197, 0.2)", "stroke": "rgba(144, 31, 197, 0.7)", "strokeWidth": 2, "width": 150}\'>'.$cancellationsString.'</span>
            </a>
        </div>
        <h4 class="item-title">
            <span class="title-text">Cancellations Processed</span>
        </h4>
        <p class="item-figure color-purple">'.$cancellationsToday.'</p>
    </div>
    <div class="col-sm-12 text-footer">
        <i class="fas fa-check-circle fa-fw"></i>';
        $output .='Last Automation Run: '.$LastRunDate;
        if($mins>60) $output .='<a href="/admin/automation-settings" class="wsLoadPageLink ml-20 label label-danger">Needs Attention</a>';
    $output .='</div>
</div> 

<script>
$(document).ready(function() {
    $.fn.peity.defaults.line = {
        delimiter: ",",
        fill: "#92d1d2",
        height: 32,
        max: null,
        min: 0,
        stroke: "#40babd",
        strokeWidth: 2,
        width: 150
    }
    $(".peity-line").peity("line");
});
</script>

<style>
.widget-automation .mini-chart {
    text-align: center;
}
.widget-automation h4 {
    margin: 0;
}
.widget-automation h4 .title-text {
    display: block;
    margin-top: 2px;
    font-size: 13px;
    color: #a2a6af;
    font-weight: 300;
    text-align: center;
}
.widget-automation .text-footer {
    text-align: left;
    font-size: 12px;
    margin: 5px 10px;
    color: #999;
}
.widget-automation p {
    margin: 0;
    font-size: 1.6em;
    font-weight: 400;
    text-align: center;
}
.widget-automation {
    font-weight: 300;
}
</style>
    </div>';
		return [
			'id'=>6,
            'title'=>'Automation Overview',
            'description'=>'An overview of system automation.',
            'weight'=>2,
            'columns'=>4,
            'DisplayTitle'=>true,
            'WidgetOwnLayout'=>false,
            'content'=>$output
        ];
    }
}