<?php 
class Widget_General_StatsCounts
{
    function Output()
    {
        $ci =& get_instance();
        $dated = date('Y-m-d');
        $user_id = "";
        $qCancellation = $ci->db->from(WST_HOST_CANCEL)->where("status='Pending'")->count_all_results();
        //$overAmount = $ci->db->select('ifnull(sum(sale_amount-paid_amount),0) as sale_amount')->where($user_id." status=7 ")->limit(1)->get(WST_INV)->row();
        //$unpaidAmount = $ci->db->select('ifnull(sum(sale_amount-paid_amount),0) as sale_amount')->where($user_id." status=2 ")->limit(1)->get(WST_INV)->row();
        //$qOthers = $ci->db->select('ifnull(sum(amount_out*base_conv_rate),0) as amount_out,ifnull(sum(fees*base_conv_rate),0) as fees,ifnull(sum(amount_in*base_conv_rate),0) as amount_in')->where($user_id." user_id > 0 ")->limit(1)->get(WST_INV_PAY)->row();
        $isNearSql = full_query("select f.symbol,sum(a.amount/e.base_conv_rate) as amount from hosting a join clients c on a.user_id=c.id join currencies e on c.currency=e.id join currencies f on f.is_default='YES' where a.status='Active' and datediff(NOW() ,a.next_due_date)>0 and datediff(NOW() ,a.next_due_date) <= 15 group by f.symbol");
        $NearToExpAmount = 0;
        $NearToExpAmountSymbol = "";
        if(!empty(@$isNearSql[0]))
        {
            $NearToExpAmount = $isNearSql[0]->amount>0 ? $isNearSql[0]->amount:0;
            $NearToExpAmountSymbol = $isNearSql[0]->amount>0 ? $isNearSql[0]->symbol:"";
        }
        $NewClients = $ci->db->from('clients')->where("date_created BETWEEN CURDATE() - INTERVAL 15 DAY AND CURDATE()")->count_all_results();
        $NewSuspension = $ci->db->from('hosting')->where("status='Suspended' and update_date BETWEEN CURDATE() - INTERVAL 1 DAY AND CURDATE()")->count_all_results();
        $SmsSents = $ci->db->from('mobile_sms_messages')->where("datetime BETWEEN CURDATE() - INTERVAL 1 DAY AND CURDATE()")->count_all_results();
       $summary = array(
        array('tooltip'=>"Pending Cancellation Requests from clients, So plz check and perform action, If action not taken by admin then as per Automation Products/Serives automatically suspended.",'columns'=>2,'class'=>'bg-success','Count'=>$qCancellation,'Icon'=>' icon-bell-cross text-white','Title'=>WsLang('Cancellations').' Requests','link'=>'/admin/cancellation-requests','jsFunction'=>'','css'=>'padding-left:0px;cursor:pointer;'),
        array('tooltip'=>"Near To Expiry Product/Services based on Due Date and Showing amount related to expiry within 15 days.",'columns'=>3,'class'=>'bg-info','Count'=>$NearToExpAmountSymbol." ".number_format($NearToExpAmount,2),'Icon'=>'icon-calendar2 text-white','Title'=>WsLang('NearExpiryProductsAmount'),'link'=>'','jsFunction'=>'','css'=>'padding-left:0px;'),
        array('tooltip'=>"Today Suspended Products/Services due to overdue payments.",'columns'=>3,'class'=>'bg-danger','Count'=>$NewSuspension ,'Icon'=>' icon-alarm-cancel text-white','Title'=>'Overdue '.WsLang('Suspensions'),'link'=>'','jsFunction'=>'ws.GetAutomationStatusLogs(\'InvoiceOverdueReminders\',\''.$dated.'\',true);','css'=>'padding-left:0px;cursor:pointer;'),
        array('tooltip'=>"New Clients Signups count with in last 15 days.",'columns'=>2,'class'=>'bg-primary','Count'=>$NewClients ,'Icon'=>' icon-users2  text-white','Title'=>'New Clients','link'=>'','jsFunction'=>'','css'=>'padding-left:0px;'),
        array('tooltip'=>"Total SMS sents today to clients and admins.",'columns'=>2,'class'=>'bg-warning','Count'=>$SmsSents ,'Icon'=>'  icon-bubble-lines4 text-white','Title'=>'Sent Messages','link'=>'','jsFunction'=>'','css'=>'padding-left:0px;padding-right:0px;')
        );

       $output = '<div class="col-md-12 clearfix">';
       foreach ($summary as $item) {
        $clickAble = '';
        $onClickCss = 'style="'.$item["css"].'"';
        $jsFunction = $item["jsFunction"];
        $tooltip = $item["tooltip"];
      if(!empty($item["link"])) $clickAble = 'onclick="window.location=\''.$item["link"].'\';" ';
           	$onClickjsFunction = "";
           	if(!empty($jsFunction))
           	{
           	    $onClickjsFunction = "onclick=".$jsFunction;
           	}

       $output .= '<div class="col-sm-6 col-md-'.$item["columns"].'" '.$clickAble.' '.$onClickCss.' '.$onClickjsFunction.'>
                    <div class="panel panel-body '.$item["class"].'" style="padding: 5px 10px;">
                        <div class="media no-margin">
                            <div class="media-left media-middle" style="position: absolute;height: 70px;width: 70px;font-size: 22px;padding: 15px;top: -25px;left: -25px;background-color: rgba(255, 255, 255, 0.15);line-height: 60px;text-align: right;border-radius: 50%;">
                                <i class="'.$item["Icon"].' icon-2x" style="left: 0px;top: -5px;"></i>
                            </div>
                            <div class="media-body" style="padding-left: 55px;">
                                <h3 class="no-margin" style="font-size: 25px;font-weight:bold;">'.$item["Count"].'</h3>
                                <span  style="font-size: 12px;margin-left: -40px;float: left;padding-top: 5px;">'.$item["Title"].'</span>
                            </div>
                        </div>';
            if(!empty($tooltip))
            {
                $output .= '<div class="ws-tooltip" style="margin-top: -68px;margin-right: -9px;">
                    <i class="icon-help"></i>
                    <div class="ws-tooltip-content" style="top: -24.6181px;">
                        <div class="ws-tooltip-text">'.$tooltip.'</div>
                    </div>
                </div>';
            }            
                $output .= '</div>
                </div>';
       }
       $output .= '</div>';
		return [
            'id'=>1,
            'title'=>'States Counts',
            'description'=>'An overview of staff.',
            'weight'=>0,
            'columns'=>12,
            'DisplayTitle'=>false,
            'WidgetOwnLayout'=>true,
            'content'=>$output
        ];
    }
}