<?php 
class Widget_Sales_ProfitLossStatement
{
    function Output()
    {
        $ws =& get_instance();
        
        $SITE_FY_START_DATE = $ws->Config->getConfig("SITE_FY_START_DATE");
        $Parts = explode("-",$SITE_FY_START_DATE);
        $Month = $Parts[1];
        $Day = $Parts[2];
        $cDate = date('Y-m-d');
        $date=date_create($cDate);
        $fy = (date_format($date,"m") >= $Month) ? (date_format($date,"Y")) . '-' . (date_format($date,"Y")+1) : (date_format($date,"Y")-1) . '-' . date_format($date,"Y");
        $yParts = explode("-",$fy);
        $datedFrom = $yParts[0]."-".$Month."-".$Day;
        $datedTo = $yParts[1]."-".$Month."-".$Day;

        $where = [];
        if(!empty($datedFrom)) $where[] = " date(create_at)>='".$datedFrom."' ";
        if(!empty($datedTo)) $where[] = " date(create_at)<'".$datedTo."' ";
        $excludeCodes = "100203,100204,400102";

        $Result = full_query("select sum(ifnull(debit,0)-ifnull(credit,0)) as expenses from fas_ledger where LEFT(code, 2)=50 and left(code,4)=5001 and code not in (".$excludeCodes.") and ".implode(" and ",$where));
        $data["Expenses"] = 0;
        if(!empty(@$Result[0])) $data["Expenses"] = $Result[0]->expenses <>0 ? $Result[0]->expenses:0;

        $Result = full_query("select sum(ifnull(debit,0)-ifnull(credit,0)) as expenses from fas_ledger where LEFT(code, 2)=50 and left(code,4)<>5001 and code not in (".$excludeCodes.") and ".implode(" and ",$where));
        $data["OtherExpenses"] = 0;
        if(!empty(@$Result[0])) $data["OtherExpenses"] = $Result[0]->expenses <>0 ? $Result[0]->expenses:0;

        $Result = full_query("select sum(ifnull(credit,0)-ifnull(debit,0)) as Income from fas_ledger where LEFT(code, 2)=40 and code not in (".$excludeCodes.") and ".implode(" and ",$where));
        $data["Income"] = 0;
        if(!empty(@$Result[0])) $data["Income"] = $Result[0]->Income <>0 ? $Result[0]->Income:0;

        $data["GpProfit"] = ($data["Income"]-$data["Expenses"]) <> 0 ? $data["Income"]-$data["Expenses"]:0;
        $TotalExpenses = $data["Expenses"]+$data["OtherExpenses"];
        $data["TotalExpenses"] = $TotalExpenses<>0 ? $TotalExpenses:0;
        $data["NetProfit"] = ($data["Income"]-$TotalExpenses)<>0 ? $data["Income"]-$TotalExpenses:0;

        $Currency = $ws->Currency->getBaseCurrency(0);
$output ="<style>#chart-container {
  position: relative;
  height: 375px;
  overflow: hidden;
}
</style>";
$output .='<div id="profitlossstatement" style="width: 100%; height: 375px;"></div>
   <script type="text/javascript">
      google.charts.load(\'current\', {\'packages\':[\'corechart\']});
      google.charts.setOnLoadCallback(drawChart);

      function drawChart()
      {
        var data = google.visualization.arrayToDataTable([
          [\'Task\', \'Hours per Day\'],
          [\'Income\','.$data["Income"].'],
          [\'Cost of Goods\','.$data["Expenses"].'],
          [\'Gross Profit\','.$data["GpProfit"].'],
          [\'Other Expense\','.$data["OtherExpenses"].'],
          [\'Net Profit\','.$data["NetProfit"].']
          ]);
        var chart = new google.visualization.PieChart(document.getElementById(\'profitlossstatement\'));
        var options = {
          is3D: true,
          legend: { position: \'top\', alignment: \'center\',maxLines: 5},
          chartArea: {
            height: \'100%\',
            width: \'100%\',
            top: \'10%\'
          },
          pieStartAngle: 100
        };      
        chart.draw(data, options);
      }
    </script>';
  return [
            'id'=>4,
            'title'=>'Profit & Loss Statement (FY '.$fy.')',
            'description'=>'An overview of Profit & Loss Statement.',
            'weight'=>4,
            'columns'=>4,
            'DisplayTitle'=>true,
            'WidgetOwnLayout'=>false,
            'content'=>$output
        ];
    }
}