<?php 
class Widget_Support_AvgResponseTime
{
    function Output()
    {
    $ci =& get_instance();
    $admin_id = getSession("userid");
    $LastMonthResponse = get_one("select CONCAT(avg_response_time DIV 60,':',avg_response_time % 60) as avg_response_time from (
    select avg(avg_response_time*60) as avg_response_time from (
    SELECT a.ticket_id,TIMESTAMPDIFF(HOUR,min(a.entry_date),max(a.entry_date)) AS avg_response_time
FROM support_tickets_replies a join support_tickets b on a.ticket_id=b.id  and b.type='TICKET'
WHERE a.entry_date >= DATE_FORMAT( CURRENT_DATE - INTERVAL 1 MONTH, '%Y/%m/01' )
  AND a.entry_date < DATE_FORMAT( CURRENT_DATE, '%Y/%m/01' ) group by ticket_id) a) b");
    $lrt =  _s("avg_response_time",$LastMonthResponse,"");
    $lrtp = _ex(".",$lrt);
    $lrt = $lrtp[0];

    $CurrentMonthResponse = get_one("select CONCAT(avg_response_time DIV 60,':',avg_response_time % 60) as avg_response_time from (select avg(avg_response_time*60) as avg_response_time from (SELECT ticket_id,TIMESTAMPDIFF(HOUR,min(entry_date),max(entry_date)) AS avg_response_time
FROM support_tickets_replies 
WHERE entry_date >= DATE_FORMAT( CURRENT_DATE, '%Y/%m/01' ) group by ticket_id) a) b");
    $crt =  _s("avg_response_time",$CurrentMonthResponse,"");
    $crtp = _ex(".",$crt);
    $crt = $crtp[0];
    
    // Split the times into hours and minutes
    $lrtParts = explode(":", $lrt);
    $crtParts = explode(":", $crt);
    $hours1 = 0;
    $minutes1 = 0;
    if(isset($lrtParts[0])) $hours1=$lrtParts[0];
    if(isset($lrtParts[1])) $minutes1=$lrtParts[1];
    $hours1 = $hours1>0 ? $hours1:0;
    $minutes1 = $minutes1>0 ? $minutes1:0;
    
    $hours2 = 0;
    $minutes2 = 0;
    if(isset($crtParts[0])) $hours2=$crtParts[0];
    if(isset($crtParts[1])) $minutes2=$crtParts[1];
    
    $hours2 = $hours2>0 ? $hours2:0;
    $minutes2 = $minutes2>0 ? $minutes2:0;
    
    // Convert the times to minutes since midnight
    $total_minutes1 = ($hours1 * 60) + $minutes1;
    $total_minutes2 = ($hours2 * 60) + $minutes2;
    
    // Calculate the absolute difference in minutes
    $minute_difference = $total_minutes1-$total_minutes2;
    // Calculate the difference in hours and minutes
    $hours_difference = floor($minute_difference / 60);
    $minutes_difference = $minute_difference % 60;
    $isUp = ($hours_difference>0) ? true:false;
    $formatted_result = sprintf('%02d:%02d', $hours_difference, abs($minutes_difference));
    $LastMonthCreate = get_one("select count(id) as tickets FROM support_tickets WHERE entry_date >= DATE_FORMAT(CURRENT_DATE - INTERVAL 1 MONTH, '%Y/%m/01' ) AND entry_date < DATE_FORMAT(CURRENT_DATE, '%Y/%m/01') and type='TICKET'");
    $lmo =  _s("tickets",$LastMonthCreate,0);

    $CurrentMonthCreate = get_one("select count(id) as tickets FROM support_tickets WHERE entry_date >= DATE_FORMAT(CURRENT_DATE, '%Y/%m/01') and type='TICKET'");
    $cmo =  _s("tickets",$CurrentMonthCreate,0);
    $diffCreation = $lmo-$cmo;

    $LastMonthClosed = get_one("select count(id) as tickets FROM support_tickets WHERE entry_date >= DATE_FORMAT(CURRENT_DATE - INTERVAL 1 MONTH, '%Y/%m/01' ) AND entry_date < DATE_FORMAT(CURRENT_DATE, '%Y/%m/01') and status='Closed' and type='TICKET'");
    $lmc =  _s("tickets",$LastMonthClosed,0);

    $CurrentMonthClosed = get_one("select count(id) as tickets FROM support_tickets WHERE entry_date >= DATE_FORMAT(CURRENT_DATE, '%Y/%m/01') and status='Closed' and type='TICKET'");
    $cmc =  _s("tickets",$CurrentMonthClosed,0);
    $diffClosed = $lmc-$cmc;

  $output ='<div class="container-fluid" style="padding:0px!important;">
                <div class="col-md-12" style="padding:0px!important;">
                    <div class="col-md-4 text-left" style="margin-top:10px;">
                        <div class="col-md-12 bg-info" style="padding: 10px;border-radius: 5px;">
                            <div class="col-md-12" style="font-size: 20px;">Average Response Time</div>
                            <div class="col-md-4">
                                <div style="font-size: 22px;">'.$lrt.' hr</div>
                                <small>Last Month</small>
                            </div>
                            <div class="col-md-4">
                                <div style="font-size: 22px;">'.$crt.' hr</div>
                                <small>Current Month</small>
                            </div>
                            <div class="col-md-3 text-center" style="'.(($isUp) ? 'background: #00ff0082;border: 1px solid #5af75a;':'background: #f4433669;border: 1px solid #F44336;').'position: absolute;top: 15%;right: 6px;">
                                <i class="icon-arrow-'.(($isUp) ? 'up':'down').'5" style="font-size: 40px;"></i>
                                <div style="font-size: 18px;">'.$formatted_result.' hr</div>
                            </div>
                        </div>
                    </div>

                    <div class="col-md-4 text-left" style="margin-top:10px;">
                        <div class="col-md-12 bg-indigo" style="padding: 10px;border-radius: 5px;">
                            <div class="col-md-12" style="font-size: 20px;">Tickets Created</div>
                            <div class="col-md-4">
                                <div style="font-size: 22px;">'.$lmo.'</div>
                                <small>Last Month</small>
                            </div>
                            <div class="col-md-4">
                                <div style="font-size: 22px;">'.$cmo.'</div>
                                <small>Current Month</small>
                            </div>
                            <div class="col-md-3 text-center" style="'.(($diffCreation>0) ? 'background: #00ff0082;border: 1px solid #5af75a;':'background: #f4433669;border: 1px solid #F44336;').'position: absolute;top: 15%;right: 6px;">
                                <i class="icon-arrow-'.(($diffCreation>0) ? 'up':'down').'5" style="font-size: 40px;"></i>
                                <div style="font-size: 18px;">'.$diffCreation.'</div>
                            </div>
                        </div>
                    </div>

                    <div class="col-md-4 text-left" style="margin-top:10px;">
                        <div class="col-md-12 bg-warning" style="padding: 10px;border-radius: 5px;">
                            <div class="col-md-12" style="font-size: 20px;">Tickets Closed</div>
                            <div class="col-md-4">
                                <div style="font-size: 22px;">'.$lmc.'</div>
                                <small>Last Month</small>
                            </div>
                            <div class="col-md-4">
                                <div style="font-size: 22px;">'.$cmc.'</div>
                                <small>Current Month</small>
                            </div>
                            <div class="col-md-3 text-center" style="'.(($diffClosed>0) ? 'background: #00ff0082;border: 1px solid #5af75a;':'background: #f4433669;border: 1px solid #F44336;').'position: absolute;top: 15%;right: 6px;">
                                <i class="icon-arrow-'.(($diffCreation>0) ? 'up':'down').'5" style="font-size: 40px;"></i>
                                <div style="font-size: 18px;">'.$diffClosed.'</div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>';
		return [
            'id'=>7,
            'title'=>'Avg',
            'description'=>'An overview of staff.',
            'weight'=>1,
            'columns'=>12,
            'DisplayTitle'=>false,
            'WidgetOwnLayout'=>true,
            'content'=>$output
        ];
    }
}