{if $CartSummary.totalItems == 0}
  <div class="w-100 ws-bg-white" style="padding: 5px;margin-top:20%;">
    <center><h6>{"ThemeCheckoutCartEmpty"|Lang} </h6></center>
  </div>
{/if}
{if $CartSummary.totalItems>0}
      <div class="mini-cart-summary p-0 w-100 ws-bg-white">
        <h6 class="mcs-title"> <i class="fas fa-shoppingcart mr-5"></i> {"ThemeOrderSummary"|Lang} </h6>
        <div class="mini-cart-items">
        {foreach from=$CartSummary.Items item=$items}
          <dl class="subtotal">
            <dt>
              <b>{$items.name}</b>
            </dt>
            {if {$items.renewal_rate|regex_replace:'/\D/':0} > 0 && {$items.renewal_rate|regex_replace:'/\D/':0}!={$items.rate|regex_replace:'/\D/':0}}
            <dd><div class="price"><span>{$items.renewal_rate}</span><b class="mp-orange">{$items.rate}</b></div></dd>
            {else}
            <dd>{$items.rate}</dd>
            {/if}
            {if $items.setup>0}
              <dt style="padding-left: 15px;">+ {"ThemeCheckoutSetupFee"|Lang}</dt>
              <dd>{$items.setup}</dd>
            {/if}
            {if !empty($items.configs)}
              {foreach from=$items.configs item=$Config}
                <dt style="padding-left: 15px;"> »  {$Config.name}</dt>
                <dd>{$Config.rate}</dd>
              {/foreach}
            {/if}
            {if !empty($items.addons)}
              {foreach from=$items.addons item=$Addon}
                <dt style="padding-left: 15px;"> »  {$Addon.name}</dt>
                <dd>{$Addon.rate}</dd>
              {/foreach}
            {/if}
          </dl>
        {/foreach}
    </div>
    <dl class="subtotal mp-bold" style="border: 0px;margin: 0;padding: 2px 10px 2px 10px;">
      <dt>{"ThemeCheckoutSubtotal"|Lang}</dt>
      <dd>{$CartSummary.summary.Subtotal}</dd>
      {if {$CartSummary.summary.ConfigsAmount|regex_replace:'/\D/':0} > 0}
      <dt>{"ThemeCheckoutConfigurableOptions"|Lang}</dt>
      <dd>{$CartSummary.summary.ConfigsAmount}</dd>
      {/if}
      {if {$CartSummary.summary.addonsAmount|regex_replace:'/\D/':0} > 0}
      <dt>{"ThemeCheckoutAddons"|Lang}</dt>
      <dd>{$CartSummary.summary.addonsAmount}</dd>
      {/if}
      {if {$CartSummary.summary.SetupFee|regex_replace:'/\D/':0} > 0}
      <dt>{"ThemeCheckoutSetupFee"|Lang}</dt>
      <dd>{$CartSummary.summary.SetupFee}</dd>
      {/if}
      {if {$CartSummary.summary.Discount|regex_replace:'/\D/':0} > 0}
      <dt class="mp-orange">{"ThemeDiscount"|Lang}</dt>
      <dd class="mp-orange">{$CartSummary.summary.Discount}</dd>
      {/if}
      {if {$CartSummary.summary.TaxAmount|regex_replace:'/\D/':0} > 0}
      <dt>{"ThemeCheckoutTaxAmount"|Lang}</dt>
      <dd>{$CartSummary.summary.TaxAmount}</dd>
      {/if}
    </dl>
    <div class="total mp-bold" style="border: 0px;">
      <span>{"ThemeGrandTotal"|Lang}</span>
      <dd>{$CartSummary.summary.GrandTotal}</dd>
       {if empty($CartSummary.errors)}
        <div class="form-group clearfix fs-15 mt-20">
            <small>{"ThemeEnterPromoHere"|Lang}</small>
            <div class="input-group">
                <input type="text" class="form-control validate_promo_code" placeholder="{"ThemeEnterPromoHere"|Lang}" value="{$CartSummary.promotionCode}">
                <a class="btn btn-success" onclick="ws.validate_promo_code();">
                    <i class="fas fa-check"></i>
                    <div class="mp-btn-loader mp-btn-loader-code hide"><span class="button-loader"><i class="spinner"></i></span></div>
                </a>
            </div> 
            <div class="col-md-12 WsPromoErrors mt-2"></div>
        </div>
        {/if}
    </div>
  </div>   
  <div class="summary-content-footer mt-5">
{if empty($CartSummary.errors)}
    {if $CurrentItemId>0}
      <a href="/client/cart" class="ma-btn btn btn-sm btn-primary cart-order-product product-order-now w-100" style="height: 50px;line-height: 44px;font-size: 20px;font-weight: normal;">{"ThemeViewCart"|Lang} <i class="fas fa-arrow-right"></i></a>
    {else}
      <a href="/client/checkout" class="ma-btn btn btn-sm btn-primary cart-order-product product-order-now w-100" style="height: 50px;line-height: 44px;font-size: 20px;font-weight: normal;">{"ThemeCheckout"|Lang} <i class="fas fa-arrow-right"></i></a>
    {/if}
{else}
 {include file="{$template}/includes/alert.tpl" type="info" msg="{"ThemeCheckouteMsg"|Lang}"}
{/if}
  </div>
{/if}