<?php 
/**
 * ClientAreaCustomSettings Hook Function
 *
 * Please refer to the documentation @ https://docs.whasols.com/Hooks for more information
 * The code in this hook is commented out by default. Uncomment to use.
 *
 * @package    WHASOLS
 * @author     WHASOLS Limited <development@whasols.com>
 * @copyright  Copyright (c) WHASOLS Limited 2021
 * @license    https://www.whasols.com/license/ WHASOLS Eula
 * @version    $Id$
 * @link       https://www.whasols.com/
 */
if ( ! defined('WHASOLS')) exit('No direct script access allowed');
add_hook('ClientAreaCustomSettings', 1, function($arg)
{
    $uri1 = $arg["uri1"];
    $uri2 = $arg["uri2"];
    $client = $arg["client"];    
    $clientId = (!empty($client)) ? $client->id:0;
    $array = [];
    $array["SideBarBtnShow"] = false;
    if($clientId>0)
    {
        if(in_array($uri1,['client']))
        {
            $array["SideBarBtnShow"] = true;
	        if(in_array($uri2,['cart','store','checkout','register-domain','transfer-domain','Announcements','Knowledgebase','index']))
	        {
	            $array["SideBarBtnShow"] = false;
	        }
	        if(empty($uri2))
	        {
	            $array["SideBarBtnShow"] = false;
	        }
        }
    }
    $array["PoliciesLinks"]["Policies"] = [
        ["Name"=>"Terms of services", "Link"=>"/company/terms-of-services"],
        ["Name"=>"Privacy Policy", "Link"=>"/company/privacy-policy"],
        ["Name"=>"Refund Policy", "Link"=>"/company/refund-policy"],
        ["Name"=>"Abuse Policy", "Link"=>"/company/anti-spam-policy"],
        ["Name"=>"Acceptable Use Policy", "Link"=>"/company/acceptable-use-policy"],
        ["Name"=>"Unlimited Policy", "Link"=>"/company/unlimited-policy"],
        ["Name"=>"Cookies Policy", "Link"=>"/company/Cookies-policy"],
    ];
    $array["PoliciesLinks"]["Agreements"] = [
        ["Name"=>"Affiliate Program Agreement", "Link"=>"/company/Affiliate-Program-Agreement"],
        ["Name"=>"Change of Registrant Agreement", "Link"=>"/company/Change-of-Registrant-Agreement"],
        ["Name"=>"Domain Registration Agreement", "Link"=>"/company/Domain-Registration-Agreement"],
        ["Name"=>"Domain Transfer Agreement", "Link"=>"/company/Domain-Transfer-Agreement"],
        ["Name"=>"Domain Dispute Resolution", "Link"=>"/company/domain-name-dispute-resolution"],
        ["Name"=>"Hosting Agreement", "Link"=>"/company/Hosting-Agreement"],
        //["Name"=>"Referral Program Agreement", "Link"=>"/company/Referral-Program-Agreement"],
        ["Name"=>"Reseller Agreement", "Link"=>"/company/Reseller-Agreement"],
    ];
    return $array;
});
