<?php 
/**
 * ClientAreaHomepagePanels Hook Function
 *
 * Please refer to the documentation @ https://docs.whasols.com/Hooks for more information
 * The code in this hook is commented out by default. Uncomment to use.
 *
 * @package    WHASOLS
 * @author     WHASOLS Limited <development@whasols.com>
 * @copyright  Copyright (c) WHASOLS Limited 2021
 * @license    https://www.whasols.com/license/ WHASOLS Eula
 * @version    $Id$
 * @link       https://www.whasols.com/
 */
if ( ! defined('WHASOLS')) exit('No direct script access allowed');
    if (!function_exists('removeAfterLastSpace')) {
        function removeAfterLastSpace($str)
        {
            // Find the position of the last space
            $lastSpacePos = strrpos($str, ' ');

            // If no space is found, return the original string
            if ($lastSpacePos === false) {
                return $str;
            }
            // Return the part of the string before the last space
            return substr($str, 0, $lastSpacePos);
        }
    }
    add_hook('ClientAreaHomepagePanels', 1, function($arg)
    {
        $client = $arg["client"];
        $clientid = $client->id;
        $Services = localAPI('GetClientServices', ['clientid'=>$clientid]);
        $Domains = localAPI('GetClientDomains', ['clientid'=>$clientid,'status'=>""]);
        $content = '';
        if(!empty($Domains) && !empty($Services))
        {
        $content .= '<div class="card">
                <div class="card-body">
                    <div class="hstack justify-content-between mb-4 pb-">';
            if(!empty($Services))
            {
                $content .= '<div>
                                <h5 class="mb-1">'.WsLang('ThemeActiveServiceDomains').'</h5>
                                <span class="fs-12 text-muted">'.WsLang('ThemeActiveServiceDomainDesc').'</span>
                            </div>
                            <div class="btn-group">
                            <a href="/client/My-Services" class="btn btn-light-brand">'.WsLang('ThemeViewServices').'</a>
                            <a href="/client/my-domains" class="btn btn-light-brand">'.WsLang('ThemeViewDomains').'</a>
                            </div>
                        </div>
                        <div class="row g-4">';
                foreach($Services as $item)
                {
                    $id = _s('id',$item);
                    $plan_name = _s('plan_name',$item);
                    $group_name = _s('group_name',$item);
                    $status = _s('status',$item);
                    $reg_date = removeAfterLastSpace(_s('reg_date',$item));
                    $next_due_date = _s('next_due_date',$item);
                    $ns1 = _s('ns1',$item);
                    $ns1ip = _s('ns1ip',$item);
                    $ns2 = _s('ns2',$item);
                    $ns2ip = _s('ns2ip',$item);
                    $user_name = _s('user_name',$item);
                    $password = _s('password',$item);

                    if($status == "Active")
                    {
                        $content .= '<div class="col-xxl-6 col-md-6">
                            <div class="card-body border border-dashed border-gray-5 rounded-3 position-relative">
                                <div class="hstack justify-content-between w-100">
                                    <div class="w-100">
                                        <h6 class="fs-14 text-truncate-1-line">'.$plan_name.' - '.$group_name.' <a class="btn btn-primary btn-sm pull-right" href="/client/my-service/'.$id.'">'.WsLang('ThemeManage').'</a></h6>
                                        <div class="fs-12 text-muted">';
                                            $content .= '<div class="col-md-12 pull-left text-dark fw-medium">
                                            <span class="pull-left"><b>'.WsLang('ThemeRenewDate').':</b> '.$next_due_date.'</span>
                                            <span class="pull-right"><b>'.WsLang('ThemeRegDate').':</b> '.$reg_date.'</span>
                                            </div>';

                                            if(!empty($ns1))
                                            {
                                                $content .= '<div class="col-md-12 pull-left text-dark fw-medium"><b>'.WsLang('ThemeNameServers').':</b> '.$ns1.', '.$ns2.'</div>';
                                            }
                                            if(!empty($user_name))
                                            {
                                                $content .= '<div class="col-md-12 pull-left text-dark fw-medium">
                                                <span class="pull-left"><b>'.WsLang('ThemeUsername').':</b> '.$user_name.'</span>
                                                <span class="pull-right"><b>'.WsLang('ThemePassword').':</b> '.$password.'</span>
                                                </div>';
                                            }
                                        $content .= '</div>
                                    </div>
                                </div>
                                <div class="badge bg-gray-200 text-dark project-mini-card-badge">'.WsLang('ThemeService').'</div>
                            </div>
                        </div>';
                    }
                }
            }
            $Domains = _jd($Domains,true);        
            if(!empty($Domains))
            {
                $global_date_format = $arg['SITE_CLIENT_DATE_FORMAT'];
                foreach($Domains as $item)
                {

                    $id = _s('id',$item);
                    $plan_name = _s('domain',$item);
                    $group_name = _s('group_name',$item);
                    $status = _s('status',$item);
                    $reg_date = ConvertDateToFormat(['date'=>date('Y-m-d',strtotime($item["registrationdate"])), 'format'=>$global_date_format]);
                    $next_due_date = ConvertDateToFormat(['date'=>date('Y-m-d',strtotime($item["nextduedate"])), 'format'=>$global_date_format]);
                    $name_servers = _jd(_s('name_servers',$item),true);
                    $ns1 = _s('ns1',$name_servers);
                    $ns2 = _s('ns2',$name_servers);

                    if($status == "Active")
                    {
                        $content .= '<div class="col-xxl-6 col-md-6">
                            <div class="card-body border border-dashed border-gray-5 rounded-3 position-relative">
                                <div class="hstack justify-content-between w-100">
                                    <div class="w-100">
                                        <h6 class="fs-14 text-truncate-1-line">'.$plan_name.' <a class="btn btn-primary btn-sm pull-right" href="/client/domain-details/'.$id.'/di">'.WsLang('ThemeManage').'</a></h6>
                                        <div class="fs-12 text-muted">';
                                            $content .= '<div class="col-md-12 pull-left text-dark fw-medium">
                                            <span class="pull-left"><b>'.WsLang('ThemeRenewDate').':</b> '.$next_due_date.'</span>
                                            <span class="pull-right"><b>'.WsLang('ThemeRegDate').':</b> '.$reg_date.'</span>
                                            </div>';

                                            if(!empty($ns1))
                                            {
                                                $content .= '<div class="col-md-12 pull-left text-dark fw-medium"><b>'.WsLang('ThemeNameServers').':</b> '.$ns1.', '.$ns2.'</div>';
                                            }
                                        $content .= '</div>
                                    </div>
                                </div>
                                <div class="badge bg-gray-200 text-dark project-mini-card-badge">'.WsLang('ThemeDomain').'</div>
                            </div>
                        </div>';
                    }
                }
            }
        $content .= '</div>
                </div>
            </div>';
        }else{
            $content .='<div class="alert alert-info text-center">'.WsLang('ThemeServices').'/'.WsLang('ThemeDomains').' not ordered yet, <a href="/client/store">Order Now</a></div>';
        }

        return["Title"=>WsLang('ThemeRecentSupportTickets'), "Classes"=>"com-md-12", "Icon"=>"", "Content"=>$content, "btn"=>'<div class="pull-right">
                                    <a href="/client/Open-Ticket" class="btn btn-primary btn-sm"><i class="fas fa-plus mr-2"></i> Open New Ticket</a></div>',"Layout"=>"Custom"];
    });

    add_hook('ClientAreaHomepagePanels', 3, function($arg)
    {
            $client = $arg["client"];
            $clientid = $client->id;
            $ClientTickets = json_decode(localAPI('GetTickets', ['clientid'=>$clientid]));
            $heads = [WsLang('ThemeSubject'),WsLang('ThemePriority'),WsLang('ThemeStatus'),WsLang('ThemeTicketDate')];
            $status = ["open"=>"success", "closed"=>"danger", "warning"=>"warning"];
            $Tickets = '<div class="table-responsive tickets-items-wrapper">
                            <table class="table table-hover mb-0">
                                <thead>
                                    <tr>
                                        <th>#</th>
                                        <th>Ticket</th>
                                    </tr>
                                </thead>
                                <tbody>';
            if(!empty($ClientTickets->tickets))
            {
                foreach ($ClientTickets->tickets as $ticket)
                {
                    $sclass = $status[strtolower($ticket->status)];
                    $Tickets .='<tr>
                                    <td>
                                        <a>#'.$ticket->id.'</a>
                                    </td>
                                    <td>
                                        <a>'.$ticket->subject.'</a>
                                        <p class="fs-12 text-muted text-truncate-1-line tickets-sort-desc">'.$ticket->message.'</p>
                                        <div class="tickets-list-action d-flex align-items-center gap-3">
                                            <a href="/client/support-ticket-reply/'.$ticket->id.'">View</a>
                                            <span>|</span>
                                            <a href="javascript:void(0);"><span class="badge badge-'.(!empty($sclass) ? $sclass:'warning').' pull-right">'.$ticket->status.'</span></a>
                                            <span>|</span>
                                            <a href="javascript:void(0);">'.WsLang('ThemeLastUpdated').': '.ConvertDateToShort($ticket->lastreply,'d M Y').'</a>
                                        </div>
                                    </td>
                                </tr>';
                }
            }
            else
            {
                $Tickets .= "<tr>";
                $Tickets .= '<td colspan="2" class="text-center"><small class="display-block">'.WsLang('ThemeTicketsNotFound').'</small></td>';
                $Tickets .= '</tr>';
            }
                $Tickets .= '</tbody>
                        </table>
                    </div>';
            return["Title"=>WsLang('ThemeRecentSupportTickets'), "Classes"=>"col-xxl-6 col-lg-6", "Icon"=>"", "Content"=>$Tickets, "btn"=>'<div class="pull-right">
                                    <a href="/client/Open-Ticket" class="btn btn-primary btn-sm"><i class="fas fa-plus mr-2"></i> Open New Ticket</a></div>'];
    });
    add_hook('ClientAreaHomepagePanels', 4, function($arg)
    {
        $client = $arg["client"];
        $clientid = $client->id;
        
            $ClientAnnouncements = json_decode(localAPI('GetAnnouncements', []));
            $Announcements ='<ul class="list-group list-group-flush">';
            if(!empty($ClientAnnouncements))
            {
                foreach ($ClientAnnouncements as $announcement)
                {
                $Announcements .='<li class="list-group-item"  id="ClientAreaHomePagePanels-Recent_News-'.$announcement->id.'">
                                        <div class="d-sm-flex justify-content-between">
                                            <div class="hstack gap-3">
                                                <div class="ht-60 wd-60 border bg-gray-200 rounded-3 d-flex flex-column justify-content-center text-center">
                                                    <span class="fs-18 fw-bolder text-dark">'.$announcement->views.'</span>
                                                    <span class="fs-10 text-uppercase">'.WsLang('ThemeViews').'</span>
                                                </div>
                                                <div class="me-4">
                                                    <p class="fs-12 fw-medium text-muted mb-2">'.WsLang('ThemeLastUpdated').':</b> '.ConvertDateToShort($announcement->date).'</p>
                                                    <a href="/client/announcement/'.$announcement->id.'/'.(str_replace([' ','_'],['',''], $announcement->title)).'" class="fw-bold text-truncate-1-line">'.$announcement->title.'</a>
                                                </div>
                                            </div>
                                        </div>
                                    </li>';
                }
            }
            else
            {
                $Announcements .='<li class="list-group-item"><p class="text-center"><small class="display-block">'.WsLang('ThemeAnnouncementNotFound').'</small></p></li>';
            }
            $Announcements .='</ul>';
            return ["Title"=>WsLang('ThemeRecentAnnouncements'), "Classes"=>"col-xxl-6 col-lg-6", "Icon"=>"", "Content"=>$Announcements, "btn"=>'<div class="pull-right">
                                    <a href="/client/announcements" class="btn btn-primary btn-sm"><i class="fas fa-arrow-right mr-2"></i>View All</a></div>'];
    });
    add_hook('ClientAreaHomepagePanels', 2, function($arg)
    {
        $client = $arg["client"];
        $clientid = $client->id;
        
            $ClientInvoices = json_decode(localAPI('GetInvoices', ['pageno'=>1, 'clientid'=>$clientid, 'status'=>2]));
            $Invoices = '<div class="p-3">';
            if(!empty($ClientInvoices->invoices))
            {
                foreach ($ClientInvoices->invoices as $invoice)
                {
                $Invoices .= '<div class="d-flex align-items-center">
                                    <div class="me-4">
                                        <h2 class="fs-16 fw-bold mb-0">'.AmountConvertToCurrencyFormate(['p'=>$invoice->symbol_position,'s'=>$invoice->symbol,'a'=>$invoice->sale_amount]).'</h2>
                                    </div>
                                    <div class="d-flex align-items-center justify-content-between border-3 border-start border-danger rounded w-100">
                                        <div class="mx-3">
                                            <a class="fw-semibold mb-1 text-truncate-1-line"><b>'.WsLang('ThemeInvoiceNo').':</b>'.$invoice->invoice_no.'</a>
                                            <div class="fs-12 fw-normal text-muted text-truncate-1-line">'.WsLang('ThemeDueDate').':</b> '.ConvertDateToShort($invoice->due_date,'d M Y').'</div>
                                        </div>
                                        <a href="/client/view-invoice/'.$invoice->id.'" class="badge bg-soft-primary text-primary">'.WsLang('ViewInvoice').'</a>
                                    </div>
                                </div>
                                <hr class="border-dashed my-3">';
                }
            }
            else
            {
                $Invoices .= '<div class="d-flex align-items-center"><small class="display-block">'.WsLang('ThemeUnpaidNotFound').'</small></div>';
            }
            $Invoices .='</div>';
            return ["Title"=>WsLang('ThemeUnPaidInvoices'), "Classes"=>"col-xxl-6 col-lg-6", "Icon"=>"", "Content"=>$Invoices, "btn"=>'<div class="pull-right">
                                    <a onclick="ws.masspayment('.$clientid.');" class="btn btn btn-danger btn-sm"><i class="fas fa-arrow-right mr-2"></i> Pay Now All</a></div>'];
    });
    add_hook('ClientAreaHomepagePanels', 5, function($arg)
    {
        $client = $arg["client"];
        $clientid = $client->id;
        
            $ClientDownloadableFiles = localAPI('GetClientDownloadableFiles', ['clientid'=>$clientid]);
            $heads = [WsLang('ThemeFileName'),WsLang('ThemeSize'),WsLang('ThemeFileType'),WsLang('ThemeDate')];
            $Downables = '<div class="table-responsive">
                            <table class="table">
                                <thead>
                                    <tr>
                                        <th scope="col">'.WsLang('ThemeFileName').'</th>
                                        <th scope="col">'.WsLang('ThemeSize').'</th>
                                        <th scope="col">'.WsLang('ThemeDate').'</th>
                                    </tr>
                                </thead>
                                <tbody>';
            if(!empty($ClientDownloadableFiles))
            {
                foreach ($ClientDownloadableFiles as $file)
                {
                    $filePath = $file->file_path;
                    $filePath = rtrim($filePath,"/");
                    $filePath .= "/".$file->file_name;
                    $finfo = json_encode(["file"=>$filePath,"uid"=>$clientid,"title"=>$file->title,"time"=>time(),"type"=>"url","source_tab"=>$file->source_tab]);
                    $filePath = encrypt($finfo);
                    
                $Downables .= '<tr id="ClientAreaHomePagePanels-files-'.$file->id.'">
                                <td>
                                    <div class="d-flex align-items-center gap-3">
                                        <img src="./../assets/images/file-icons/html.png" class="img-fluid rounded wd-30" alt="">
                                        <a onclick="ws.download(\''.$filePath.'\');">'.$file->title.'</a>
                                    </div>
                                </td>
                                <td>'.$file->file_size.'</td>
                                <td>'.ConvertDateToShort($file->datetime,'d M Y').'</td>
                            </tr>';
                }
            }
            else
            {
                $Downables .= '<tr class="text-center"><td colspan="3"><small class="display-block">'.WsLang('ThemeFilesNotFound').'</small></td></tr>';
            }
            $Downables .='</tbody>
                    </table>
                </div>';
            return ["Title"=>WsLang('ThemeAttachedFiles'), "Classes"=>"col-lg-6 col-md-6 col-sm-12", "Icon"=>"", "Content"=>$Downables, "btn"=>""];
        });