<?php 
/**
 * ClientAreaHomepageStats Hook Function
 *
 * Please refer to the documentation @ https://docs.whasols.com/Hooks for more information
 * The code in this hook is commented out by default. Uncomment to use.
 *
 * @package    WHASOLS
 * @author     WHASOLS Limited <development@WHASOLS.com>
 * @copyright  Copyright (c) WHASOLS Limited 2021
 * @license    https://www.whasols.com/license/ WHASOLS Eula
 * @version    $Id$
 * @link       https://www.whasols.com/
 */
if ( ! defined('WHASOLS')) exit('No direct script access allowed');
add_hook('ClientArea_services_index', 1, function($arg)
{
    $client = $arg["client"];
    $clientid = _s("id",$client,0);
	$ClientSummariesCounts = localAPI('GetClientSummariesCounts', ['clientid'=>$clientid]);
	$ClientStats = json_decode($ClientSummariesCounts);
	$stats = [];
	$stats['AnswerableTickets'] = ["Title"=>WsLang('ThemeTickets'), "Icon"=>'feather-mail','Img'=>'','Value'=>$ClientStats->answerableTickets,'Classes'=>'card bg-soft-teal border-teal text-teal border-dashed','link'=>'/client/my-tickets','Show'=>true];
	$stats['UnpaidInvoices'] = ["Title"=>WsLang('ThemeInvoices'), "Icon"=>'feather-dollar-sign','Img'=>'','Value'=>$ClientStats->unpaidInvoices,'Classes'=>'card bg-soft-success border-success text-success border-dashed','link'=>'/client/my-invoices/2','Show'=>true];
	$stats['Cancellations'] = ["Title"=>WsLang('ThemeCancellations'), "Icon"=>'feather-layers','Img'=>'','Value'=>$ClientStats->cancellationRequests,'Classes'=>'card bg-soft-indigo border-indigo text-indigo border-dashed','link'=>'','Show'=>true];
	$stats['Services'] = ["Title"=>WsLang('ThemeServices'), "Icon"=>'feather-cpu','Img'=>'','Value'=>$ClientStats->activeServices,'Classes'=>'card bg-soft-warning border-warning text-warning border-dashed','link'=>'/client/my-services','Show'=>true];
	$stats['Domains'] = ["Title"=>WsLang('ThemeDomains'), "Icon"=>'feather-globe','Img'=>'','Value'=>$ClientStats->activeDomains,'Classes'=>'card bg-soft-danger border-danger text-danger border-dashed','link'=>'/client/my-domains','Show'=>true];
	$return = [];
	$return["HomePageStats"] = $stats;
	return $return;
});