<div class="main-content">
    <div class="content-area ps--active-y">
        <div class="content-area-body p-0">
        {include file="{$template}/includes/top-page-header.tpl" pagetitle="{"ThemeNetworkStatus"|Lang}" tagline="{"ThemeNetworkInformation"|Lang}"}
            <div class="card mb-5 p-0 ws-transparent ws-border-none ws-shadow-none">
                <div class="card-body p-0">
                    <div class="mb-3">
                        <div class="row">
                            {if empty($NetworkIssuesList)} 
                            <section class="cr-hero-section bg-primary-gradient ptb-40">
                                <div class="container">
                                    <div class="row justify-content-center">
                                        <br>
                                        <h4 class="text-center content-group-lg">
                                            {"ThemeNetworkStatusNF"|Lang}<br>
                                            <small class="display-block">{"ThemeNetworkInformationNf"|Lang}</small>
                                        </h4>
                                    </div>
                                </div>
                            </section>
                            {else}
                            <div class="row note-has-grid" id="note-full-container">
                                {foreach from=$NetworkIssuesList item=$issue}
                                <!--! BEGIN: [Single Note Item] !-->
                                <div class="col-xxl-4 col-xl-6 col-lg-4 col-sm-6 single-note-item all-category note-important note-tasks">
                                    <div class="card card-body mb-4 stretch stretch-full">
                                        <span class="side-stick"></span>
                                        <h5 class="note-title text-truncate w-75 mb-1">{$issue.title}</h5>
                                        <p class="fs-11 text-muted note-date">{$issue.start_date}</p>
                                        <div class="note-content flex-grow-1">
                                            <p class="text-muted note-inner-content text-truncate-3-line">{$issue.description|html|strip_tags}</p>
                                        </div>
                                        <div class="col-md-12 d-flex">
                                            <div class="col-md-4">
                                                <a data-bs-toggle="offcanvas" data-bs-target="#Ws-Issue-{$issue.id}" class="btn btn-primary btn-sm">{"ThemeViewMore"|Lang}</a>
                                            </div>
                                            <div class="col-md-8">
                                                <span class="bg-{if $issue.priority == 'Low'}secondary{elseif $issue.priority == 'High'}danger{else}warning{/if} text-white px-2 py-1 rounded pull-right"><strong>{"ThemePriority"|Lang}: </strong>{$issue.priority}</span>
                                                <span class="bg-{if $issue.status == 'Resolved'}success{else}danger{/if} text-white px-2 py-1 rounded pull-right mr-3"><strong>{"ThemeStatus"|Lang}: </strong>{$issue.status}</span>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                {/foreach}
                            </div> 
                            {/if}
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
{if !empty($NetworkIssuesList)} 
    {foreach from=$NetworkIssuesList item=$issue}
    <div class="offcanvas offcanvas-end topics-details-offcanvas" tabindex="-1" id="Ws-Issue-{$issue.id}" aria-labelledby="Ws-Issue-{$issue.id}">
        <div class="offcanvas-header border-bottom px-4">
            <div class="d-flex">
                <a href="javascript:void(0);">{$issue.title}</a>
            </div>
            <button type="button" class="btn-close text-reset" data-bs-dismiss="offcanvas" aria-label="Close"></button>
        </div>
        <div class="offcanvas-body">
            <div class="help-center details-content-body">
                {$issue.description|html}
                <div class="col-md-12 mt-5 d-flex">
                    <div class="col-md-12">
                        <span class="job-type d-block text-end mb-1 pull-right">{"Last Updated"|Lang} {$issue.update_date}</span>
                    </div>
                </div>
            </div>
        </div>
    </div> 
    {/foreach}
{/if}