<div class="col-md-12 mp-50">
    <div class="col-md-6"><h4>Environment Checks</h4></div>
    <div class="col-md-6"><h4>.INI file settings</h4></div>
    {if !empty($CheckList)}
    <div class="col-md-6">
    <table id="wslmContents" class="table table-striped table-bordered" style="width:100%">
        <thead class="customTableTh">
            <tr class="wslmTableTr">
                <th>Name</th>
                <th>Recommended</th>
                <th>Current</th>
                <th>Status</th>
            </tr>
        </thead>
        <tbody>
            {foreach from=$CheckList item=$row}
                <tr>
                    <td nowrap>{$row.name}</td>
                    <td nowrap>{$row.recommended}</td>
                    <td nowrap>{$row.current}</td>
                    <td nowrap><div class="badge bg-{if $row.status == 'Y'}success{else}danger{/if}"><i class="icon-{if $row.status == 'Y'}checkmark2{else}cross2{/if}"></i></div></td>
                </tr>
            {/foreach}
        </tbody>
    </table>
    </div>
    <div class="col-md-6">
    <div class="clearfix"></div>
    <div class="alert alert-warning">Note: If any changes won't work then please contact with your hosting services provider to solve the issue which you are facing.</div>
    <div class="clearfix"></div>        
        <div class="customBorder" style="position: relative;">
            <div class="fwTextLinks">
                <span class="fwTextAlerts"></span>
                <a onclick="Firewall.copy('fwIniText');" class="pull-right">Copy INI Text</a>
            </div>
            
            <div class="clearfix"></div>
            
<textarea class="form-control" name="ini_data" id="fwIniText" rows="25" style="padding: 15px 0px 0px 5px;border: 0px;">
;PHP Display errors should off if application in production other wise set as On
display_errors = Off

;max_execution_time — This sets the maximum time in seconds a script is allowed to run before it is terminated
max_execution_time = {$CheckList["max_execution_time"]["value"]}

;max_input_time — This sets the maximum time in seconds a script is allowed to parse input data, like POST and GET. This is usually increased to allow for larger file uploads.
max_input_time = {$CheckList["max_input_time"]["value"]}

;max_input_vars is a setting managed through the PHP setting file (php. ini) which limits the number of inputs you can set when posting forms
max_input_vars = {$CheckList["max_input_vars"]["value"]}

;The PHP memory_limit is the maximum amount of server memory that each PHP script is allowed to consume
memory_limit = {$CheckList["memory_limit"]["value"]}

;Maximum post size means how much data write on disk at your hosting
;for example if you are uploading/or posting data in size of 100MB and your hosting ini settings showing 50MB then data will not write on disk/db
post_max_size = {$CheckList["post_max_size"]["value"]}

;session. gc_maxlifetime specifies the number of seconds after which data will be seen as 'garbage' and potentially cleaned up. Garbage collection may occur during session start
session.gc_maxlifetime = 1440

;session. save_path defines the argument which is passed to the save handler. If you choose the default files handler, this is the path where the files are created.
session.save_path = "{$SessionPath}"

;upload_max_filesize is a maximum size only for files that are posted. Other types of POST body data are not subject to this limit. In short, if you want to upload large files, you must increase both limits.
upload_max_filesize = {$CheckList["upload_max_filesize"]["value"]}

;zlib. output_compression, when enabled, compresses all responses in Apache. We use PHP to compress the page and store the compressed page in a file to be accessed directly from Apache so we don't have to build the page anymore. That's the difference.
zlib.output_compression = On

;zlib.output_compression_level int. Compression level used for transparent output compression. Specify a value between 0 (no compression) to 9 (most compression)
zlib.output_compression_level = 6

;expose_php bool. Exposes to the world that PHP is installed on the server, which includes the PHP version within the HTTP header (e.g., X-Powered-By: PHP/5.3. 7). disable_functions string. This directive allows you to disable certain functions.
expose_php = Off

;Safe mode is a software or operating system mode where most fixes are done
safe_mode = On</textarea>
        </div>        
    </div>
    {else}
        <div class="gracefulexit">Environment Checks not found</div>
    {/if}
</div>
<div class="clearfix"></div><br><br><br>