    <div class="panel panel-flat">
        <div class="panel-heading">
            <div class="btn-group pull-right">
                <a onclick="Firewall.IpWhiteForm();" class="btn btn-default">Add IP Address</a>
            </div>
            <h5 class="panel-title">Whitelisted IPs</h5>
            <div class="clearfix"></div>
            <p>Now Possible to whitelist an IP address or Complete IP Set.</p>
            <div class="clearfix"></div>
        </div>
        <div class="panel-body">
            <div class="col-md-12">
            {if empty($IpsWhiteList.others)} 
            <br><br><h4 class="text-center content-group-lg">
            Whitelisted IPs
            <small class="display-block">Whitelisted IPs Not Found...</small>
            </h4>
            {else}
            <h4>Whitelisted IPs By SignIn</h4>
            <p>IP Addresses which automatically added by system based on successful SignIn.</p>
            <table class="table table-striped table-bordered" width="100%">
                <thead>
                    <tr class="customTableTh">
                        <th style="width:150px;">IP Address</th>
                        <th>Reason</th>
                        <th style="width:100px;">Dated</th>
                        <th style="width:100px;">Expires In</th>
                        <th style="width:30px;"></th>
                    </tr>
                </thead>
                <tbody>
                {foreach from=$IpsWhiteList.others item=$ip}
                <tr>
                <td>{$ip->ip}</td>
                <td>{$ip->reason}</td>
                <td nowrap>{$ip->time|date:'Y-m-d h:i:s'}</td>
                <td nowrap>{round((($ip->time+7200)-time())/60)} Minutes</td>
                <td><a onclick="ws.DelWhiteIp({$ip->id});" class="text-danger"><i class="icon-trash"></i></a></td>
                </tr>
                {/foreach}
                </tbody>
            </table>
            {/if}
            </div>
            <div class="col-md-12">
            {if empty($IpsWhiteList.system)} 
            <br><br><h4 class="text-center content-group-lg">
            Whitelisted IPs
            <small class="display-block">Whitelisted IPs Not Found...</small>
            </h4>
            {else}
            <h4>Whitelisted IPs</h4>
            <b>IP Addresses exempt from being banned for invalid login attempts</b>
            <table class="table table-striped table-bordered" width="100%">
                <thead>
                    <tr class="customTableTh">
                        <th style="width:150px;">IP Address</th>
                        <th>Reason</th>
                        <th style="width:100px;">Dated</th>
                        <th style="width:70px;"></th>
                    </tr>
                </thead>
                <tbody>
                {foreach from=$IpsWhiteList.system item=$ip}
                <tr>
                <td>{$ip->ip}</td>
                <td>{$ip->reason}</td>
                <td>{$ip->time|date:'Y-m-d h:i:s'}</td>
                <td><a onclick="ws.DelWhiteIp({$ip->id});" class="text-danger"><i class="icon-trash"></i></a></td>
                </tr>
                {/foreach}
                </tbody>
            </table>
            {/if}
            </div>
            
            <div class="col-md-12">
            {if empty($IpsWhiteList.api)} 
            <br><br><h4 class="text-center content-group-lg">
            API Access IPs
            <small class="display-block">API Access IPs Not Found...</small>
            </h4>
            {else}
            <h4>API Access IPs</h4>
            <b>IP Addresses allowed to connect to the WHASOLS API</b>
            <table class="table table-striped table-bordered" width="100%">
                <thead>
                    <tr class="customTableTh">
                        <th style="width:150px;">IP Address</th>
                        <th>Reason</th>
                        <th style="width:100px;">Dated</th>
                        <th style="width:70px;"></th>
                    </tr>
                </thead>
                <tbody>
                {foreach from=$IpsWhiteList["api"] item=$ip}
                <tr>
                <td>{$ip->ip}</td>
                <td>{$ip->reason}</td>
                <td>{$ip->time|date:'Y-m-d h:i:s'}</td>
                <td><a onclick="ws.DelWhiteIp({$ip->id});" class="text-danger"><i class="icon-trash"></i></a></td>
                </tr>
                {/foreach}
                </tbody>
            </table>
            {/if}
            </div>                
    </div>
</div>
