{if $form_posted == 0}
<div class="modal-header">
      <button type="button" class="close" data-dismiss="modal">&times;</button>
      <h5 class="modal-title">Domain DNS Lookups</h5>
  </div>
<div class="modal-body"> 
{/if}
<style>
table.tabular {
    border: none!important;
    background: #c4d5de!important;
    line-height: 15px!important;
    width: 100%!important;
}
table.tabular th {
    padding: 7px!important;
    font-weight: bold!important;
    font-size: 12px!important;
}
table.tabular td {
    background-color: #fff!important;
    padding: 7px!important;
}
</style>
<div class="col-md-12 p-0 {if $form_posted == 1}mt-20{/if}">
    {if $status == "error"}
        {include file="$template/includes/alert.tpl" type="danger" title="" msg="{$message}"}
    {else}
    <div class="row">
    {if $form_posted == 0}<h5>Domain Name: {$response.WWW.domain}</h5>{/if}
<table width="99%" cellspacing="1" class="table table-bordered tabular">
            <thead>
              <tr>
                <th scope="col">Category</th>
                <th scope="col">Status</th>
                <th scope="col">Test name</th>
                <th scope="col">Information</th>
              </tr>
            </thead>
            <tbody>
            <!-- Parent Checks start -->
            <tr>
              <td rowspan="4" scope="row" style="vertical-align: top;">Parent</td>
                <td class="icon"><img src="/public/assets/images/info.gif" alt="Info"></td>
                <td>Domain NS records</td>
                <td>Nameserver records returned by the parent servers are:<br>
                {foreach $response.Parent.Info as $ns}
                <br>{$ns.target}.&nbsp;&nbsp;['{implode("','",$ns.ip)}']&nbsp;&nbsp;[TTL={$ns.ttl}]
                {/foreach}
                <br><br>                
                <strong>Nameserver</strong> was kind enough to give us that information.
              </td>
            </tr>
            <tr>
                <td class="icon"><img src="/public/assets/images/pass.gif" alt="Pass"></td>
                <td>Your nameservers are listed</td>
                <td>Good. The parent server has your nameservers listed. This is a must if you want to be found as anyone that does not know your DNS servers will first ask the parent nameservers.</td>
            </tr>                
            <tr>
                <td class="icon"><img src="/public/assets/images/pass.gif" alt="Pass"></td>
                <td>DNS Parent sent Glue</td>
                <td>Good. The parent nameserver sent GLUE, meaning he sent your nameservers as well as the IPs of your nameservers. Glue records are A records that are associated with NS records to
                provide "bootstrapping" information to the nameserver.(see RFC 1912 section 2.3)</td>
            </tr>
            <tr>
                <td class="icon"><img src="/public/assets/images/pass.gif" alt="Pass"></td>
                <td>Nameservers A records</td>
                <td>{$response.Parent.NameserversArecords}</td>
            </tr>
            <!-- Parent Checks end -->
            <tr>
                <td class="static" rowspan="11" scope="row" style="vertical-align: top;">NS</td>
                <td class="icon"><img src="/public/assets/images/info.gif" alt="Info"></td>
                <td>NS records from your nameservers</td><td>NS records got from your nameservers listed at the parent NS are:<br><br>
                {foreach $response.NS.Info as $ns}
                {$ns.target}.&nbsp;&nbsp;['{implode("','",$ns.ip)}']&nbsp;&nbsp;[TTL={$ns.ttl}]<br>
                {/foreach}                
                <br><br>
              </td>
            </tr>
            <tr>
                <td class="icon"><img src="/public/assets/images/{if $response.NS.MismatchedRecords == 1}pass{else}warn{/if}.gif" alt="Pass"></td>
                <td>Mismatched NS records</td>
                <td>{if $response.NS.MismatchedRecords == 1}OK. The NS records at all your nameservers are identical.{else}WARNING. The NS records at all your nameservers are not identical.{/if}</td>
            </tr>            
            <tr>
                <td class="icon"><img src="/public/assets/images/{if empty($response.NS.NameOfNameserversAreValid)}pass{else}warn{/if}.gif" alt="Pass"></td>
                <td>Name of nameservers are valid</td>
                <td>{if empty($response.NS.NameOfNameserversAreValid)}OK. All of the NS records that your nameservers report seem valid.{else} WARNING. NS records that your nameservers report seem invalid{/if}</td>                
            </tr>
            <tr>
                 <td class="icon"><img src="/public/assets/images/{if $response.NS.MultipleNameservers>1}pass{else}warn{/if}.gif" alt="Pass"></td>
                <td>Multiple Nameservers</td>
                <td>{if $response.NS.MultipleNameservers>1}Good. You have multiple nameservers. According to RFC2182 section 5 you must have at least 3 nameservers, and no more than 7. Having {$response.NS.MultipleNameservers} nameservers is also ok by me.{else}WARNING. You have one nameservers. According to RFC2182 section 5 you must have at least 3 nameservers, and no more than 7. Having {$response.NS.MultipleNameservers} nameservers is not ok by me.{/if}</td>
            </tr>
            <tr>
                <td class="icon"><img src="/public/assets/images/{if empty($response.NS.NameserversAreLame)}pass{else}warn{/if}.gif" alt="Pass"></td>
                <td>Nameservers are lame</td>
                <td>{if empty($response.NS.NameserversAreLame)}OK. All the nameservers listed at the parent servers answer authoritatively for your domain.{else}WARNING.{$response.NS.NameserversAreLame}{/if}</td>
            </tr>            
            <tr>
                <td class="icon"><img src="/public/assets/images/{$response.NS.DomainCNAMEs.status}.gif" alt="Pass"></td>
                <td>Domain CNAMEs</td>
                <td>{$response.NS.DomainCNAMEs.text}</td>
            </tr>
            <tr class="warn">
                 <td class="icon"><img src="/public/assets/images/{$response.NS.DifferentSubnets.status}.gif" alt="Warn"></td>
                <td>Different subnets</td>
                <td>{$response.NS.DifferentSubnets.text}</td>
            </tr>
            <tr>
                <td class="icon"><img src="/public/assets/images/pass.gif" alt="Pass"></td>
                <td>IPs of nameservers are public</td>
                <td>{$response.NS.IPsOfNameserversArePublic}</td>
            </tr>
            <tr>
                <td class="icon"><img src="/public/assets/images/pass.gif" alt="Pass"></td>
                <td>DNS servers allow TCP connection</td>
                <td>{$response.NS.DNSAllowTCPconnection}</td>
            </tr>
            <tr class="warn">
                 <td class="icon"><img src="/public/assets/images/{$response.NS.DifferentAutonomousSystems.status}.gif" alt="Warn"></td>
                <td>Different autonomous systems</td>
                <td>{$response.NS.DifferentAutonomousSystems.text}</td>
            </tr>
            <tr>
                <td class="icon"><img src="/public/assets/images/pass.gif" alt="Pass"></td>
                <td>Stealth NS records sent </td>
                <td>{$response.NS.StealthNsRecordsSent}</td>
            </tr>
            <!-- NS Checks start -->            
            <!-- SOA Checks -->            
            <tr>                
                <td class="static" rowspan="8" scope="row" style="vertical-align: top;">SOA</td>
                <td class="icon"><img src="/public/assets/images/info.gif" alt="Info"></td>
                <td>SOA record</td><td>The SOA record is:<br>
                {foreach $response.SOA.Info as $soa}
                Primary nameserver: <strong>{$soa.mname}</strong><br>
                Hostmaster E-mail address: <strong>{$soa.rname}</strong><br>
                Serial #: <strong>{$soa.serial}</strong> <br>
                Refresh: <strong>{$soa.refresh}</strong> <br>
                Retry: <strong>{$soa.retry}</strong><br>
                Expire: <strong>{$soa.expire} &nbsp; {$soa.days} Days</strong><br>
                Default TTL: <strong>{$soa["minimum-ttl"]}</strong> <br>
                {/foreach}                
                </td>
            </tr>            
            <tr>
                <td class="icon"><img src="/public/assets/images/pass.gif" alt="Pass"></td>
                <td>NSs have same SOA serial</td>
                <td>OK. All your nameservers agree that your SOA serial number is <strong>{$response.SOA.Info[1].serial}</strong>. </td>
            </tr>
            <tr>
                 <td class="icon"><img src="/public/assets/images/pass.gif" alt="Pass"></td>
                <td>SOA MNAME entry</td>
                <td>OK. <strong>{$response.SOA.Info[1].mname}</strong> That server is listed at the parent servers.</td>
            </tr>            
            <tr>
                 <td class="icon"><img src="/public/assets/images/{if $response.SOA.Info[1].serial_valid == 1}pass{else}warn{/if}.gif" alt="Pass"></td>
                <td>SOA Serial</td>
                <td>Your SOA serial number is: <strong>{$response.SOA.Info[1].serial}</strong>.
                {if $response.SOA.Info[1].serial_valid == 1}This appears to be in the recommended format of YYYYMMDDnn.{else}This can be ok if you know what you are doing{/if}
                </td>
            </tr>            
            <tr>
                 <td class="icon"><img src="/public/assets/images/pass.gif" alt="Pass"></td>
                <td>SOA REFRESH</td>
                <td>OK. Your SOA REFRESH interval is: <strong>{$response.SOA.Info[1].refresh}</strong>.  That is OK</td>
            </tr>            
            <tr>
                <td class="icon"><img src="/public/assets/images/pass.gif" alt="Pass"></td>
                <td>SOA RETRY</td>
                <td>Your SOA RETRY value is: <strong>{$response.SOA.Info[1].retry}</strong>. Looks ok</td>
            </tr>
            <tr>
                <td class="icon"><img src="/public/assets/images/pass.gif" alt="Pass"></td>
                <td>SOA EXPIRE</td>
                <td>Your SOA EXPIRE number is: <strong>{$response.SOA.Info[1].expire}</strong>.Looks ok</td>
            </tr>
            <tr>
                <td class="icon"><img src="/public/assets/images/pass.gif" alt="Pass"></td>
                <td>SOA MINIMUM TTL</td>
                <td>Your SOA MINIMUM TTL is: <strong>{$response.SOA.Info[1]["minimum-ttl"]}</strong>. This value was used to serve as a default TTL for records without a given TTL value and now is used for negative caching (indicates how long a resolver may cache the negative answer). RFC2308 recommends a value of 1-3 hours. Your value of <strong>{$response.SOA.Info[1]["minimum-ttl"]}</strong> is OK.</td>
            </tr>
            <!-- MX Checks -->            
            <tr>
                <td rowspan="11" scope="row" style="vertical-align: top;">MX</td>
                <td class="icon"><img src="/public/assets/images/info.gif" alt="Info"></td>
                <td>MX Records</td><td>Your MX records that were reported by your nameservers are:<br>
                {foreach $response.MX.entries as $mx}
                <br>{$mx.pri} &nbsp; {$mx.target} &nbsp; {$mx.ip}
                {/foreach}                
                <br><br>[These are all the MX records that I found. If there are some non common MX records at your nameservers you should see them below. ]
              </td>
            </tr>            
            <tr>
                <td class="icon"><img src="/public/assets/images/pass.gif" alt="Pass"></td>
                <td>Different MX records at nameservers</td>
                <td>Good. Looks like all your nameservers have the same set of MX records. This tests to see if there are
                any MX records not reported by all your nameservers and also MX records that have the same hostname but different IPs</td>
            </tr>
            <tr>
                <td class="icon"><img src="/public/assets/images/{if $response.MX.MxNameValidity == 0}pass{else}warn{/if}.gif" alt="Pass"></td>
                <td>MX name validity</td>
                <td>{if $response.MX.MxNameValidity == 0}Good. I did not detect any invalid hostnames for your MX records.{else}WARNING. I detected {$response.MX.MxNameValidity} invalid hostnames for your MX records.{/if}
                </td>
            </tr>
            <tr>
                <td class="icon"><img src="/public/assets/images/{if $response.MX.MxPublicIps == 0}pass{else}warn{/if}.gif" alt="Pass"></td>
                <td>MX IPs are public</td>
                <td>{if $response.MX.MxPublicIps == 0}OK. All of your MX records appear to use public IPs.{else}WARNING. your {$response.MX.MxPublicIps} MX records appear to use private IPs.{/if}</td>
            </tr>
            <tr>
                <td class="icon"><img src="/public/assets/images/{if $response.MX.MxCnameCheck>0}pass{else}warn{/if}.gif" alt="Pass"></td>
                <td>MX CNAME Check</td>
                <td>{if $response.MX.MxCnameCheck>0}OK. No problems here.{else}WARNING. MX CNAME Check problem{/if}</td>
            </tr>
            <tr>
                <td class="icon"><img src="/public/assets/images/{if $response.MX.MxArequestReturnsCname>0}pass{else}warn{/if}.gif" alt="Pass"></td>
                <td>MX A request returns CNAME</td>
                <td>{if $response.MX.MxArequestReturnsCname>0}OK. No CNAMEs returned for A records lookups.{else}WARNING.CNAMEs returned for A records lookups.{/if}</td>
            </tr>
            <tr>
                <td class="icon"><img src="/public/assets/images/{if $response.MX.MxIsNotIp == 0}pass{else}warn{/if}.gif" alt="Pass"></td>
                <td>MX is not IP</td>
                <td>{if $response.MX.MxIsNotIp == 0}OK. All of your MX records are host names.{else}WARNING. Your {$response.MX.MxIsNotIp} MX records are not hostnames{/if}</td>
            </tr>
            <tr>
                <td class="icon"><img src="/public/assets/images/{if $response.MX.MxNumberOfRecords>1}pass{else}info{/if}.gif" alt="Pass"></td>
                <td>Number of MX records</td>
                <td>
                {if $response.MX.MxNumberOfRecords>1}
                Good. Looks like you have multiple MX records at all your nameservers. This is a good thing and will help in preventing loss of mail.
                {else}
                OK. Looks like you only have one MX record at your nameservers. You should be careful about what you are doing since you have a single point of failure that can lead to mail being lost if the server is down for a long time.
                {/if}
                </td>
            </tr>
            <tr>
                <td class="icon"><img src="/public/assets/images/pass.gif" alt="Pass"></td>
                <td>Mismatched MX A</td>
                <td>OK. I did not detect differing IPs for your MX records.</td>
            </tr>
            <tr>
                <td class="icon"><img src="/public/assets/images/pass.gif" alt="Pass"></td>
                <td>Duplicate MX A records </td>
                <td>
                {if $response.MX.DuplicateMxArecords>0}
                OK. You have some duplicate MX records (MX records with the same IPs). This is not that good but if you know what you are doing than it's ok.
                {else}
                OK. I have not found duplicate IP(s) for your MX records. This is a good thing.
                {/if}
                </td>
            </tr>
            <tr>
                <td class="icon"><img src="/public/assets/images/{if !empty($response.MX.ReverseMxArecords)}pass{else}warn{/if}.gif" alt="Pass"></td>
                <td>Reverse MX A records (PTR)</td>
                <td>Your reverse (PTR) record:<br>
                {if !empty($response.MX.ReverseMxArecords)}
                {foreach $response.MX.ReverseMxArecords as $mx}
                    <strong>{$mx.ptr}</strong>&nbsp;-&gt; &nbsp;<strong>{$mx.host}</strong><br>
                {/foreach}
                <br>
                You have reverse (PTR) records for all your IPs, that is a good thing.
                {else}
                You don't have (PTR) record, that's not good.
                {/if}
                </td>
            </tr>
            <!-- SMTP Checks --> 
            {if empty($response.WWW.aRecord)}
            <tr class="Info">
                <td rowspan="3" scope="row" style="vertical-align: top; background-color: #ffffff;">WWW</td>
                <td class="icon"><img src="/public/assets/images/info.gif" alt="Info"></td>
                <td>WWW A Record</td>
                <td>We can't find CNAME record against your www.{$response.WWW.domain} domain.</td>
            </tr>
            {else}
            <!-- WWW Checks -->            
            <tr class="Info">
                <td rowspan="3" scope="row" style="vertical-align: top; background-color: #ffffff;">WWW</td>
                <td class="icon"><img src="/public/assets/images/info.gif" alt="Info"></td>
                <td>WWW A Record</td>
                <td>
                    Your www.{$response.WWW.domain} A record is:<br>
                    {$response.WWW.aRecord}
                    <br><br> [Looks like you have CNAME's]
                </td>
            </tr>
            <tr>
                <td class="icon"><img src="/public/assets/images/{if $response.WWW.IpsArePublic == "Public"}pass{else}warn{/if}.gif" alt="Pass"></td>
                <td>IPs are public</td>
                <td>{if $response.WWW.IpsArePublic == "Public"}
                OK. All of your WWW IPs appear to be public IPs.
                {else}
                WARNING.Your WWW IPs apread to be private IPs.
                {/if}
                </td>
            </tr> 
            <tr>
                <td class="icon"><img src="/public/assets/images/pass.gif" alt="Pass"></td>
                <td>WWW CNAME</td>
                <td>{if $response.WWW.CNAME == 1}
                OK. You do have a CNAME record for www.{$response.WWW.domain}.Your CNAME entry also returns the A record for the CNAME entry, which is good.
                {else}
                OK. You don't have a CNAME record for www.{$response.WWW.domain}.
                {/if}
                </td>
            </tr>
            {/if}
            </tbody>
        </table>
    </div>
    {/if}
</div>
{if $form_posted == 0}
</div>
{/if}