var ws = {
        set:function(key,val)
        {
            localStorage.setItem(key,val);
        },
        get:function(key="")
        {
            if (typeof localStorage == 'undefined' || localStorage === null)  return "";
            var item = localStorage.getItem(key);
            if (typeof item == 'undefined' || item === null) return "";
            return item;
        },
        typingTimer : 0,
        doneTypingInterval : 500,
        updateSettingsBT : function (n,v)
        {
            clearTimeout(ws.typingTimer);
            if (v){ws.typingTimer = setTimeout(function(){ws.updateAutomationSettings(n,v);}, ws.doneTypingInterval); }
        },
        updateSettings : function (n,v){
            ws.updateAutomationSettings(n,v);
        },
        TabClickableObj:"",
        print : function (printdivname){
        var headstr = "<html><head><title>Print Preview</title></head><body>";
        var footstr = "</body>";
        var newstr = document.getElementById(printdivname).innerHTML;
        var oldstr = document.body.innerHTML;
        document.body.innerHTML = headstr+newstr+footstr;
        window.print();
        document.body.innerHTML = oldstr;
        return false;
        },
        isNumber : function (elem) {
         var val = elem.value;
         var max = elem.max;
         if(isNaN(val)){
                 val = val.replace(/[^0-9\.]/g,'');
                 if(val.split('.').length>2) 
                     val =val.replace(/\.+$/,"");
            }
            if(max > 0 && val > 0){
                 
                if((val-max) > 0){
                  val=max;  
              } 
            }
            elem.value=val; 
        },
        s: function (textStatus) {
            var msg = "";
            if (textStatus != 200)
            {
                if (textStatus == "error") {
                    msg = "<p>The request had undefined error.</p>";
                }
                if (textStatus == 400) {
                    msg = "<p>The request had bad syntax or was inherently impossible to be satisfied.</p>";
                }
                if (textStatus == 401) {
                    msg = "The parameter to this message gives a specification of authorization schemes which are acceptable. The client should retry the request with a suitable Authorization header.</p>";
                }
                if (textStatus == 402) {
                    msg = "<p>The parameter to this message gives a specification of charging schemes acceptable. The client may retry the request with a suitable ChargeTo header.</p>";
                }
                if (textStatus == 403) {
                    msg = "<p>The request is for something forbidden. Authorization will not help.</p>";
                }
                if (textStatus == 404) {
                    msg = "<p>The server has not found anything matching the URI given</p>";
                }
                if (textStatus == 500) {
                    msg = "<p>The server encountered an unexpected condition which prevented it from fulfilling the request.</p>";
                }
                if (textStatus == 501) {
                    msg = "<p>The server does not support the facility required.</p>";
                }
                if (textStatus == 502) {
                    msg = "<p>The server cannot process the request due to a high load (whether HTTP servicing or other requests). The implication is that this is a temporary condition which maybe alleviated at other times.</p>";
                }
                if (textStatus == 503) {
                    msg = "<p>This is equivalent to Internal Error 500, but in the case of a server which is in turn accessing some other service, this indicates that the respose from the other service did not return within a time that the gateway was prepared to wait. As from the point of view of the clientand the HTTP transaction the other service is hidden within the server, this maybe treated identically to Internal error 500, but has more diagnostic value.</p>";
                }
                if(msg.length == 0) return textStatus;
            }
            return msg;
        },
        isReqInprocess: false,
        e:function(p="",textStatus="",xhr="")
        {
            //let doc = new DOMParser().parseFromString(xhr.responseText, "text/html");
            //let errorMessage = Array.from(doc.querySelectorAll(".error-message p")).map(p => p.textContent.trim()).join("<br>");
            let errorMessage = xhr.responseText;
            errorMessage = errorMessage.split("\n").filter(line => line.trim() !== "").join("\n");
            errorMessage = errorMessage.replace(/\n/g, "<br>"); // Replace newlines with <br>
            var e = ws.s(textStatus);
            var el = e.length;
            if (el > 10) console.log("Requested URL:" + p,e);
            ws.isReqInprocess = false;
            ws.swal({ title: "Request Error",text:errorMessage, confirmButtonColor: "#2196F3", type: "error","textDisplay":"left"});
            var isLoaderExist = $(".wivbloader").length;
            if(isLoaderExist > 0) $('.wivbloader').remove();
        },
        ajax: function (p, c)
        {
            $.ajax({
                url: p,
                type: 'GET',
                timeout: 30000, // 10 seconds timeout
                beforeSend: function (xhr) {
                    xhr.setRequestHeader("X-Ajax-Request", "true"); // Add the custom header
                },
                success: function (data) {
                    ws.isReqInprocess = false;
                    c(data);
                },
                error: function (xhr, textStatus, errorThrown) {
                    ws.isReqInprocess = false;
                    ws.e(p, textStatus,xhr);
                    // Optional: Retry mechanism
                    // setTimeout(function () { ws.ajax(p, c) }, 2000);
                }
            }); 
        },
        a: function (p, c)
        {
            if (!ws.isReqInprocess)
            {
                ws.isReqInprocess = true;
                $.ajax({
                    url: p,
                    type: 'GET',
                    timeout: 30000, // 10 seconds timeout
                    beforeSend: function (xhr) {
                        xhr.setRequestHeader("X-Ajax-Request", "true"); // Add the custom header
                    },
                    success: function (data) {
                        ws.isReqInprocess = false;
                        c(data);
                    },
                    error: function (xhr, textStatus, errorThrown) {
                        ws.isReqInprocess = false;
                        ws.e(p, textStatus, xhr);
                        // Optional: Retry mechanism
                        // setTimeout(function () { ws.ajax(p, c) }, 2000);
                    }
                }); 
            }
            else {
                //setTimeout(function () { ws.ajax(p, c) }, 2000);
            }
        },
        ar: function (p, c)
        {
            if (!ws.isReqInprocess)
            {
                ws.isReqInprocess = true;
                $.ajax({
                    url: p,
                    type: 'GET',
                    timeout: 30000, // 10 seconds timeout
                    beforeSend: function (xhr) {
                        xhr.setRequestHeader("X-Ajax-Request", "true"); // Add the custom header
                    },
                    success: function (data) {
                        ws.isReqInprocess = false;
                        c(data);
                    },
                    error: function (xhr, textStatus, errorThrown) {
                        ws.isReqInprocess = false;
                        ws.e(p, textStatus, xhr);
                        // Optional: Retry mechanism
                        // setTimeout(function () { ws.ajax(p, c) }, 2000);
                    }
                }); 
            }
            else {
                //setTimeout(function () { ws.ajax(p, c) }, 2000);
            }
        },
        f : function (u,e,c)
        {
            var formData = new FormData(e);
            $.ajax({
                type:'POST',
                url: u,
                data:formData,
                cache:false,
                contentType: false,
                processData: false,
               success: function(returnValue){                                    
                    c(returnValue); 
                    console.log(returnValue);
                },
                error: function(request,error) {
                    ws.e(u,error);
                    //ws.f(u,e,c);
                }
            });
        },
        fs : function (u,e,c)
        {
            $.ajax({
                url: u,
                type: 'POST',
                contentType: 'application/x-www-form-urlencoded',
                data: e.serialize(),
                success: function(data, textStatus, jqXHR) {
                    c(data); 
                    console.log(data);
                },
                error: function(request,error) {
                    ws.e(u,error);
                    //ws.fs(u,e,c);
                }
            });
        },
        loading : function (e,t){
            if(t.length > 5){
            $(e).html('<img src="/backend/assets/images/load.gif" style="width:62px;height:62px;"  title="loader" alt="loader"> '+t);
        }else{
            $(e).html('');                        
        }
        },
        ShowHideDiv:function(ic="",act=false)
        {
            if(act)
            {
                $("."+ic).addClass("hide");
            }
            else
            {
                $("."+ic).removeClass("hide");
            }
        },
        ShowHideDivs:function(hDiv="",sDiv="",inputs=false)
        {
            $(hDiv).addClass("hide");
            $(sDiv).removeClass("hide");
            if(inputs)
            {
                $(hDiv).each(function() {
                    var elements = $(this).find('input, select, textarea, :radio, :checkbox');
                    elements.each(function() {
                      $(this).prop('disabled', true);
                      $(this).removeAttr('required');
                    });
                });
                $(sDiv).each(function() {
                    var elements = $(this).find('input, select, textarea, :radio, :checkbox');
                    elements.each(function(){
                        $(this).prop('disabled', false);
                        var isOptional = $(this).hasClass("optional");
                        if(isOptional)
                        {
                            $(this).attr('required',false);
                        }else{
                            $(this).attr('required',true);
                        }
                    });
                });
            }
        },
        ActivityIdleTime:0,
        ActivitySignoutTime:0,
        ActivityIdleTimeSpent:0,
        ActivityNoticeCheckTimer:0,
        ActivityNoticeAutoSignoutTimer:0,
        TimeRemainToAutoSignout:0,
        ActivityNoticeDisplay:false,
        ActivitySignoutUser:function()
        {
            if (ws.ActivityNoticeDisplay)
            {
                window.location="/admin/logout";
            }
        },
        ActivityNoticeStatus:function(){
            // Check if the popup is still open
            if (!ws.ActivityNoticeDisplay)
            {
                // Popup closed, reset inactivity timer
                clearTimeout(ws.ActivityNoticeAutoSignoutTimer);
                clearInterval(ws.ActivityNoticeCheckTimer);
                ws.TimeRemainToAutoSignout = ws.ActivitySignoutTime/1000;
            }
            else
            {
                ws.TimeRemainToAutoSignout = ws.TimeRemainToAutoSignout-1;
                if(ws.TimeRemainToAutoSignout<0) ws.TimeRemainToAutoSignout=0;
                $(".ws-activity-notice-timer").html(ws.TimeRemainToAutoSignout);
                // Popup still open, start logout process after 30 seconds
                ws.ActivityNoticeAutoSignoutTimer = setTimeout(ws.ActivitySignoutUser,ws.ActivitySignoutTime);
            }            
        },
        ActivityNoticeClose:function(){
            $('.ws-notice-modal-close').click();
            ws.ActivityNoticeDisplay = false;
            clearTimeout(ws.ActivityNoticeAutoSignoutTimer);
            clearInterval(ws.ActivityNoticeCheckTimer);
        },
        ActivityNotice:function()
        {
            if(!ws.ActivityNoticeDisplay)
            {
                ws.ajax('/acp/activity-notice-form/',function (data)
                {
                    ws.ActivityNoticeDisplay = true;
                    if (data.length > 100)
                    {
                        ws.modal(data, 'S');
                        ws.TimeRemainToAutoSignout = ws.ActivitySignoutTime/1000;
                        ws.ActivityNoticeCheckTimer = setInterval(ws.ActivityNoticeStatus, 1000);
                    }
                });
            }
        },
        ActivityResetTime:function()
        {
            // Clear the existing timeout (if any)
            //clearInterval(ws.ActivityNoticeCheckTimer);
            //clearTimeout(ws.ActivityNoticeAutoSignoutTimer);
            clearTimeout(ws.ActivityIdleTimeSpent);
            // Set a new timeout for the specified idle time threshold
            ws.ActivityIdleTimeSpent = setTimeout(function ()
            {
                ws.ActivityNotice();
            }, ws.ActivityIdleTime);
        },
        ActivityCheck:function(allow,tout,sout)
        {
            if(allow == "YES")
            {
                console.log("Activity Check");
                this.ActivityIdleTime = tout;
                this.ActivitySignoutTime = sout;
                this.TimeRemainToAutoSignout = sout/1000;
                document.addEventListener('mousemove', ws.ActivityResetTime);
                document.addEventListener('keydown', ws.ActivityResetTime);                
            }
        },
        ChatShowHideDivs:function(hDiv="",sDiv="",mClass="",e)
        {
            var rid = e.getAttribute('rid');
            $(mClass+'-'+rid+' '+hDiv).addClass("hide");
            $(mClass+'-'+rid+' '+sDiv).removeClass("hide");
            $(mClass+'-'+rid+' '+hDiv).each(function()
            {
                var elements = $(this).find('input, select, textarea, :radio, :checkbox');
                elements.each(function() {
                  $(this).prop('disabled', true);
                  $(this).removeAttr('required');
                });
            });
            $(mClass+'-'+rid+' '+sDiv).each(function() {
                var elements = $(this).find('input, select, textarea, :radio, :checkbox');
                elements.each(function()
                {
                    $(this).prop('disabled', false);
                    $(this).attr('required',true);
                });
            });
        },
        DivsCounts : 0,
        ChatRowRemove:function(cClass,e)
        {
            var rid = e.getAttribute('rid');
            var len = $(cClass).length;
            if(len>1)
            {
                $(cClass+'-'+rid).remove();
            }
        },
        DivsDuplications:function(source="",Target="")
        {
            ws.DivsCounts++;
            var htmlContent = $(source).html();
            var nsrc = source.replace('.', '');
            var nsrci = nsrc+'-'+ws.DivsCounts;
            $(Target).append('<div class="col-md-12 '+nsrc+'" rid="0" style="padding:0px;border-bottom: 2px solid #ccc;margin-bottom: 5px;padding-bottom: 5px;">'+htmlContent+'</div>');
            var $lastElement = $(source).last();
            $lastElement.attr("rid",ws.DivsCounts);

            $(source).each(function()
            {
                var rid = $(this).attr("rid");
                var hClass = source.replace('.', '');
                hClass = hClass+'-'+rid;
                var eClass = $(this).hasClass(hClass);
                if(!eClass)
                {
                    $(this).addClass(hClass);
                }
                $('.'+hClass).each(function()
                {
                    var elements = $(this).find('input, select, textarea, :radio, :checkbox,a');
                    elements.each(function()
                    {
                      $(this).attr('rid',rid);
                    });
                });
            });
        },
        loading2 : function (e,t){
            if(t.length > 5){
            $(e).html('<img src="/backend/assets/images/load.gif" style="width:62px;height:62px;"  title="loader" alt="loader"> '+t);
            $('.whmbcsllIBox').show();
        }else{
            $('.whmbcsllIBox').hide();
            $(e).html('');                        
        }
        },
        openPopupWindow : function (u,h,w,isFull=false)
        {
            var winLeft = (screen.width - w) / 2;
            if(isFull)
            {
                w = screen.width-200;
                winLeft = (screen.width-w)/2;
            }
            var winTop = (screen.height - h) / 2;
            var winProperties = 'height='+h+',width='+w+',top=' + winTop + ',left=' + winLeft + ',directories=no,titlebar=no,toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=no,visible=false';
            win = window.open(u, 'Domain Pricing', winProperties);
            if (parseInt(navigator.appVersion) >= 4)
            {
                win.window.focus();
            }
            var timer = setInterval(function() { 
                if(win.closed) {
                    clearInterval(timer);
                    location.reload();
                }
            }, 1000);
        },
        CopyToClipboard : function (containerid) {
            if (window.getSelection) {
                if (window.getSelection().empty) { // Chrome
                    window.getSelection().empty();
                } else if (window.getSelection().removeAllRanges) { // Firefox
                    window.getSelection().removeAllRanges();
                }
            } else if (document.selection) { // IE?
                document.selection.empty();
            }

            if (document.selection) {
                var range = document.body.createTextRange();
                range.moveToElementText(document.getElementById(containerid));
                range.select().createTextRange();
                document.execCommand("copy");
            } else if (window.getSelection) {
                var range = document.createRange();
                range.selectNode(document.getElementById(containerid));
                window.getSelection().addRange(range);
                document.execCommand("copy");
            }
        },                    
        errors : function (eobj,etype,emsg,etime=2000){
            var html='';
            html = '<div class="whmbcs_errors" style="padding: 0px 10px;">';
            if(etype == 'danger') html += '<div class="alert alert-danger">'+emsg+'</div>';                            
            if(etype == 'success') html += '<div class="alert alert-success">'+emsg+'</div>';                            
            html += '</div>';  
            $(eobj).html(html);
            setTimeout(function() {$(eobj).html('');}, etime); // <-- time in milliseconds
        },
        bloader : function (ivbloader,type=2,LoaderText=' Request inprocess, Please Wait')
        {
            var element = $(ivbloader);
            if(element.length == 0)
            {
                var start = ivbloader.charAt(0);
                var text = ivbloader.substring(1);
                if(start == "#")
                {
                    $('body').append('<div id="'+text+'"></div>');
                }else{
                    $('body').append('<div class="'+text+'"></div>');
                }
            }

            var isLoaderExist = $(".wivbloader").length;
            if(isLoaderExist == 0)
            {
                //var LoaderIcon ='<i class="icon-spinner9 spinner"></i>';
                var LoaderIcon ='<img src="/backend/assets/images/load.gif" style="width:62px;height:62px;"  title="loader" alt="loader">';
                var html = '<span class="wivbloader">';
                html += '<div class="blockUI blockOverlay" style="z-index: 10001; border: none; margin: 0px; padding: 0px; width: 100%; height: 100%; top: 0px; left: 0px; background-color: rgb(255, 255, 255,.4);position: fixed;"></div>';
                html += '<div class="blockUI blockMsg blockElement" style="position: fixed;padding: 0px;margin: 0px;width: 50%;top: 50%;left: 25%;text-align: center;color: #006699;background: #fff;border: 3px solid #ccc;border-radius: 10px;z-index: 10020;font-weight: bold;">'+LoaderIcon+' '+LoaderText+'</div>';
                html += '</span>';
                if(type == 1) $(ivbloader).append(html);
            }
             if(type == 2) setTimeout(function() {$('.wivbloader').remove();}, 500); 
             /*
             var light_6 = $(this).parent();
            $(light_6).block({
                message: '<i class="icon-spinner9 spinner"></i>',
                overlayCSS: {
                    backgroundColor: '#fff',
                    opacity: 0.8,
                    cursor: 'wait'
                },
                css: {
                    border: 0,
                    padding: 0,
                    backgroundColor: 'none'C
                }
            });
            window.setTimeout(function () { 
                $(light_6).unblock();
            }, 2000);*/
        }, 
        radio_checks: function(){
            // Default initialization
            $(".styled, .multiselect-container input, input[type=radio]").uniform({
                radioClass: 'choice'
            });
        },
        textarea_t_editors : function (ic)
        { 
            //$(ic).summernote({height: 300});
            // Default initialization
            $(ic).wysihtml5({
            parserRules:  wysihtml5ParserRules,
            "emphasis": true, // Italics, bold, etc. Default true
            "lists": true, // (Un)ordered lists, e.g. Bullets, Numbers. Default true
            "html": false, // Button which allows you to edit the generated HTML. Default false
            "link": true, // Button to insert a link. Default true
            "image": true, // Button to insert an image. Default true,
            "action": false, // Undo / Redo buttons,
            "color": true // Button to change color of font
            });
        },                  
        notify : function (e,t){
                    noty({
                    width: 200,
                    text: t,
                    type: e,
                    dismissQueue: true,
                    timeout: 4000,
                    layout: 'bottomRight',
                    buttons: (e != 'confirm') ? false : [
                        {
                            addClass: 'btn btn-primary btn-xs',
                            text: 'Ok',
                            onClick: function ($noty) { //this = button element, $noty = $noty element
                                $noty.close();
                                noty({
                                    force: true,
                                    text: 'You clicked "Ok" button',
                                    type: 'success',
                                    layout: 'bottomRight'
                                });
                            }
                        },
                        {
                            addClass: 'btn btn-danger btn-xs',
                            text: 'Cancel',
                            onClick: function ($noty) {
                                $noty.close();
                                noty({
                                    force: true,
                                    text: 'You clicked "Cancel" button',
                                    type: 'error',
                                    layout: 'bottomRight'
                                });
                            }
                        }
                    ]
                });
        },
        cmodal:function(html='',bigOrSmall='S')
        {
            if(bigOrSmall == "N")
            {
                $('.WsModal').addClass("hide");
            }
            else
            {
                $('.WsModal').removeClass("hide");
                if(bigOrSmall == "L")
                {
                    $('.WsModal-container').addClass('WsModal-lg');
                    $('.WsModal-container').removeClass('WsModal-md');
                }
                if(bigOrSmall == "M")
                {
                    $('.WsModal-container').removeClass('WsModal-lg');
                    $('.WsModal-container').addClass('WsModal-md');
                }
                if(bigOrSmall == "S")
                {
                    $('.WsModal-container').removeClass('WsModal-lg');
                    $('.WsModal-container').removeClass('WsModal-md');
                }
                if(html != '') $(".WsModal-container").html(html); 
                ws.radio_checks();
                $('.select').wsSelect();
                //if($('.tokenfield').length > 0) $('.tokenfield').tokenfield();
                daterange_singles();
                if($('#editor-full').length > 0)
                {
                    ws.textarea_t_editors('#editor-full');
                    //$('#editor-full').summernote({height: 300});
                }
                if (typeof ws.TabClickableObj !== 'undefined' && ws.TabClickableObj !== null) 
                {
                    $(ws.TabClickableObj).click();
                    ws.TabClickableObj = "";
                }
            }
        },
        modal:function(html='',bigOrSmall='S')
        {
            ws.cmodal(html,bigOrSmall);
        },
        minMaxValue : function(obj, min, max) {
            val = obj.value;
            if(!isNaN(val)){
                obj.value=val > max ? max : val < min ? min : val;                            
            }else{
                obj.value=min;
            }
        },
        swalTimeoutId:0,
        swalCbFun : "",
        swal:function(obj="",cb="")
        {
            $(".ws-alert-modal").remove();
            //title: part.message, confirmButtonColor: "#2196F3", type: part.status
            var modType = "default";
            if(obj.type!="")
            {
                if(obj.type == "error") modType = "danger";   
                if(obj.type == 2) modType = "danger";   
                if(obj.type == "danger") modType = "danger";   
                if(obj.type == 1) modType = "success";   
                if(obj.type == "success") modType = "success";   
                if(obj.type == "info") modType = "info";   
                if(obj.type == "warning") modType = "warning";   
            }
            var textAlign = "center";
            if (obj.hasOwnProperty("textDisplay"))
            {
                textAlign = obj.textDisplay;
            }
            var ShowCloseBtn = "show";
            if(typeof cb === 'function')
            {
                ShowCloseBtn = "hide";
            }
            //if(obj.hidetime>0) ShowCloseBtn = "hide";
            
            var pos = "center";//bottom,center,right
            if(obj.position == "center") pos = "center";
            if(obj.position == "top-right") pos = "right";
            var overlay = "";
            if(typeof cb === 'function') overlay = "ws-alert-overlay";
        var modal = '<div class="ws-alert-modal ws-alert-modal-'+pos+' '+overlay+'" id="ws-alert-modal">'
            +'<div class="ws-alert-modal-content ws-alert-'+modType+'">';
          var CloseTime = 0;
        if (obj && typeof obj.hidetime === 'number' && obj.hidetime > 0) CloseTime=obj.hidetime;
        if(typeof cb !== 'function' && CloseTime == 0) CloseTime=3000;
        if(CloseTime>0 && modType == 'danger' && typeof cb !== 'function')
        {
            ShowCloseBtn="show";
            CloseTime = 0;
        }
        if(CloseTime == 0) clearTimeout(ws.swalTimeoutId);
            if(ShowCloseBtn == "show")
            {
                if(CloseTime == 0)
                {
                    modal +='<span class="close-btn" onclick="ws.swalClose();">&times;</span>';
                }else{
                    modal +='<span class="close-btn" style="font-size:10px;color:#333;font-weight:bold;">Auto Close</span>';
                }
            }
            modal +='<div class="ws-alert-message text-'+textAlign+'">';
            var title = obj.title;
            var text = obj.text;
            if (obj && title !=='' && title !== null && title !==undefined && text !== undefined && text !== null && text !== '')
            {
                modal +='<h3 style="margin-top:0px;">'+title+'</h3>';
                modal +='<p>'+text+'</p>';
            }else if (obj && title !=='' && title !== null && title !==undefined && (text == undefined || text == null || text == ''))
            {
                modal +='<p>'+title+'</p>';
            }else
            {
                if (obj && text !== undefined && text !== null && text !== '')
                {
                    modal +='<p>'+text+'</p>';
                }
            }
            //{'title':'Email Failed','text':part[1],'type':'error'}
    
             modal +='</div>';
             if(typeof cb === 'function')
             {
                 ws.swalCbFun = cb;
                 modal +='<div class="btn-group pull-right">';
                 modal +='<button class="btn btn-danger" onclick="ws.swalClose();">Cancel</button>';
                 modal +='<button class="btn btn-success" onclick="ws.swalConfirm();">OK</button>';
                 modal +='</div>';
             }
            modal +='</div>'
          +'</div>';
          var exist = $('body').hasClass("ws-alert-modal");
          if(!exist)
          {
                $('body').append(modal);
                $(".ws-alert-modal").show();
                if(CloseTime>0) ws.swalClose(CloseTime);
          }
        },
        swalConfirm:function()
        {
            ws.swalCbFun();
        },
        swalClose:function(t=0)
        {
            if(t > 0)
            {
                ws.swalTimeoutId = setTimeout(function () {$(".ws-alert-modal").hide();}, t); // <-- time in milliseconds
            }else{
                $(".ws-alert-modal").hide();
            }
        },
        remove_client_upload_file : function (i){
         ws.swal({
                    title: "Delete File",
                    text: "Click at OK button to process Deletion Request",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "#ff0000",
                    showLoaderOnConfirm: true
                },
                function() {
                     ws.bloader('.ivContentbloader',1);  
                        ws.ajax('/acp/client_files_delete/'+i,function(res){
                        var part = JSON.parse(res);
                        ws.swal({ title: "File Deletion",text:part.message, confirmButtonColor: "#2196F3", type: part.status });
                         if(part.status == 'success'){
                            location.reload();
                        }
                        ws.bloader('.ivContentbloader',2);  
                        });
                });                        
        },
        checkPage:function(word="")
        {
            var currentUrl = window.location.href;
            if (currentUrl.includes(word)){
                return true;
            }
            return false;
        },
        NotificationMark : function (i=0)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/mark_notifications/'+i,function (data)
            {
                var part = JSON.parse(data);
                ws.swal({ title: "Notification",text:part.message, confirmButtonColor: "#2196F3", type: part.status });
                ws.bloader('.ivContentbloader',2);  
                ws.GetNotificationsCount();
            });
        },
        GetNotificationsCount : function (){
            if(ws.checkPage("signin"))
            {
                return;
            }
            ws.ajax('/acp/get_notifications/count',function (data)
            {
                var part = JSON.parse(data);
                if(part.status == "success")
                {
                    $(".NotificationMainLi").removeClass("hide");
                }
                else
                {
                    $(".NotificationMainLi").addClass("hide");
                }
                $("#notification_count").html(part.data);
            });
        },
        GetNotifications : function ()
        {
            $(".NotificationsContent").html("");
            var counts = $("#notification_count").text();
            if(counts>0)
            {   
                var opened = $(".NotificationMainLi").hasClass("open");
                if(opened) return;

                $("#notificationContainer").removeClass("hide");
                ws.loading2('.NotificationsContent',"Notifications Loading...");  
                ws.ajax('/acp/get_notifications/list',function (data)
                {
                    var part = JSON.parse(data);
                    ws.loading2('.whmbcsloaderIcons',"");  
                    $(".NotificationsContent").html(part.data);
                    let height = screen.height-98;
                    $("#notificationContainer,#notificationsBody").css("height",height+"px");
                });
            }else{
                $("#notificationContainer").addClass("hide");
            }
        },
        uploadModule : function(i)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.f('/acp/addons_upload_module',i,function(res){
                var part = JSON.parse(res);
                ws.swal({title:"Upload/Install Module",text:part.message,type: part.status});
                ws.bloader('.ivContentbloader',2);  
                if(part.status == 'success')
                {
                    location.reload();
                }
            });
            return false;
        },
        mobile_gateways_init : function (){
            $(".mobile_gateways_load > li > a").each(function () {
               var page =  $(this).attr('page');
               var isTrue =  $(this).attr('aria-expanded');                          
                if(isTrue == 'true'){
                    ws.mobile_gateways_load(page);
                } 
            });
        },
        mobile_gateways_load : function (page){
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/mobile_gateways_load/'+page,function (data){
                $(".mobileGatewayContets").html(data);
                ws.bloader('.ivContentbloader',2);  
                });
        },
        mobile_gateways_credits : function (page){
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/mobile_gateways_credits/',function (data){
                ws.mobile_gateways_load(page);
                ws.bloader('.ivContentbloader',2);  
                });
        },
        mobile_template_activation : function (i,s)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/mobile_template_activation/'+i+'/'+s,function(res){
            var part = JSON.parse(res);
            ws.swal({ title: "Gateway",text:part.message, confirmButtonColor: "#2196F3", type: part.status });
             if(part.status == 'success'){
                ws.mobile_gateways_init();
            }
            });
        },
        mobile_gateway_activation : function (i){
        var $this = $('.mga-'+i);
        var isHasClass = $this.hasClass("isactive");
           if(isHasClass == true){
            var isActive=2;
            }else{
            var isActive=1;
            }
        var gid = $this.attr("gid");
        ws.bloader('.ivContentbloader',1);  
        $(".GatewayActivation").removeClass("isactive").addClass("isinactive").prop("checked", false);
                ws.ajax('/acp/mobile_gateway_activation/'+i+'/'+isActive,function(res)
                {
                    var part = JSON.parse(res);
                    ws.swal({ title: "Gateway",text:part.message, confirmButtonColor: "#2196F3", type: part.status });
                   if(part.status == 'success')
                   {
                       if(isHasClass == true){
                        var isActive=2;
                            $($this).removeClass("isactive").addClass("isinactive").prop("checked", false); 
                        }else{
                        var isActive=1;
                            $($this).removeClass("isinactive").addClass("isactive").prop("checked", true);                
                        }
                    }
                    ws.bloader('.ivContentbloader',2); 
                  ws.mobile_gateways_init();
                });
        },
        mobile_gateway_edit_form : function (i){
                $(".modal-body").html("");  
                $(".modal-title").text("Edit Gateway");
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/mobile_gateway_edit_form/'+i,function(res){
                    $(".modal-body").html(res);  
                    ws.bloader('.ivContentbloader',2);  
                });
        },
        mobile_gateway_info_save : function(i)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.f('/acp/mobile_gateway_info_save',i,function(res){
                var part = JSON.parse(res);
                ws.swal({title:"Gateway",text:part.message,type: part.status});
                ws.bloader('.ivContentbloader',2);  
                if(part.status == 'success'){
                 ws.mobile_gateways_init();
                }
            });
            return false;
        },
        mobile_template_edit_form : function (i){
                $(".modal-body").html("");  
                $(".modal-title").text("Edit Template");
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/mobile_template_edit_form/'+i,function(res)
                {
                    ws.bloader('.ivContentbloader',2);  
                    $(".modal-body").html(res);  
                });
        },
        send_custom_email_form : function (i)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/send-custom-email-form/'+i,function (data){
                ws.bloader('.ivContentbloader',2);  
                ws.modal(data,'L');
            });
        },
        send_custom_email : function(i)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.f('/acp/send-custom-email',i,function(res)
            {
                var part = JSON.parse(res);
                ws.swal({title:"Email",text:part.message, type:part.status});
                if(part.status == "success")
                {
                    ws.modal('','N');
                }
                ws.bloader('.ivContentbloader',2);  
            });
            return false;
        },
        GeteMailValidaterForm : function (m){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/GetMailValidaterForm/'+m,function(res)
            {
                 ws.modal(res,'S');
                 ws.bloader('.ivContentbloader',2);
                //$(".GetMailerForm").html(res);  
                ws.radio_checks();
            });
        },
        eMailValidateInfoSave : function(i)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.f('/acp/email_validater_info_save',i,function(res){
                var part = JSON.parse(res);
                ws.swal({title:"Email Validater",text:part.message, type:part.status});
                ws.bloader('.ivContentbloader',2);  
            });
            return false;
        },
        GetMailerForm : function (m){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/GetMailerForm/'+m,function(res)
            {
                 ws.modal(res,'S');
                 ws.bloader('.ivContentbloader',2);
                //$(".GetMailerForm").html(res);  
                ws.radio_checks();
            });
        },
        GetCaptchaForm : function (m){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/GetCaptchaForm/'+m,function(res)
            {
                 ws.modal(res,'S');
                 ws.bloader('.ivContentbloader',2);
                //$(".GetMailerForm").html(res);  
                ws.radio_checks();
            });
        },
        CaptchaInfoSave : function(i)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.f('/acp/captcha_info_save',i,function(res){
                var part = JSON.parse(res);
                ws.swal({title:"Captcha Provider",text:part.message,type:part.status});
                ws.bloader('.ivContentbloader',2);  
            });
            return false;
        },
        mail_generate_access : function (){
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/mail_generate_access/',function(res)
                {
                    var part = JSON.parse(res);
                    ws.swal({title:"Auth Generation",text:part.message, type:part.status});
                    if(part.status == 'success') window.setTimeout(function(){window.location=part.url;}, 1000);
                    ws.bloader('.ivContentbloader',2); 
                });
        },
        testEmailer : function (){
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/test_emailer/',function(res)
                {
                    var part = JSON.parse(res);
                    ws.swal({title:"Gateway",text:part.message,type:part.status});
                    ws.bloader('.ivContentbloader',2); 
                });
        },
        MailerInfoSave : function(i)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.f('/acp/mailer_info_save',i,function(res){
                var part = JSON.parse(res);
                ws.swal({title:"Mailer",text:part.message,type:part.status});
                var eAct = $("#eMailerAct").val();
                if(eAct == "Token")
                {
                    if(part.status == 'success') window.setTimeout(function(){window.location=part.url;}, 1000);
                }
                ws.bloader('.ivContentbloader',2);  
            });
            return false;
        },
        mobile_template_save_info : function (e,i){
                var value = e.value;
                var name = e.name;
                clearTimeout(ws.typingTimer);
                ws.typingTimer = setTimeout(function()
                {
                    ws.bloader('.ivContentbloader',1);  
                    ws.ajax('/acp/mobile_template_save_info?id='+i+'&n='+name+'&v='+value,function(res){
                        ws.bloader('.ivContentbloader',2);  
                    var part = JSON.parse(res);
                    if(part.status == 'success'){
                     $(".errorMsg").removeClass('alert-danger').removeClass('alert-success').addClass('alert-success').html(part.message);
                    }else{
                     $(".errorMsg").removeClass('alert-danger').removeClass('alert-success').addClass('alert-danger').html(part.message);
                    }
                    });

                }, ws.doneTypingInterval); 
        },
        mobile_check_connection : function(i)
        {
            ws.bloader('.ivContentbloader',1);             
            ws.ajax('/acp/mobile_gateway_check_connection/'+i,function(res)
            {
                ws.bloader('.ivContentbloader',2);
                var v = "";
                var r =  JSON.parse(res);
                 if(r.valid == 'YES'){
                    v="1";
                    ws.swal({title:"Gateway API",text:"Gateway API Connection Done",type:"success"});
                    ws.ajax('/acp/mobile_gateway_activation/'+i+'/'+v,function(res)
                    {
                         ws.mobile_gateways_init();
                    });
                 }else{
                    v="2";
                    ws.swal({title:"Gateway API",text:r.error,type:"error"});
                 }
            });
        },
        db_optimize_tables : function(){
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/db_optimize_tables/',function (data){
                var part = JSON.parse(data);
                    ws.swal({
                            type: part[0],
                            title: part[1],
                            confirmButtonColor: "#2196F3"
                        });   
                ws.db_tables();                                                                    
                ws.bloader('.ivContentbloader',2);  
                });
        },
        db_create_backup : function(){
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/db_create_backup/',function (data){
                var part = JSON.parse(data);
                    ws.swal({
                            type: part[0],
                            title: part[1],
                            confirmButtonColor: "#2196F3"
                        });   
                ws.db_backups();                                                                    
                ws.bloader('.ivContentbloader',2);  
                });
        },
        db_tables : function(){
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/db_tables/',function (data){
                $("#Database-Tables").html(data);
                ws.bloader('.ivContentbloader',2);  
                });
        },
        db_backups : function(){
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/db_backups/',function (data){
                $("#Database-Backups").html(data);
                ws.bloader('.ivContentbloader',2);  
                });
        },
        db_cleanup : function(){
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/db_cleanup/',function (data){
                $("#db_cleanup").html(data);
                daterange_singles();
                ws.bloader('.ivContentbloader',2);  
                });
        },
        db_table_clean : function(i)
        {
             ws.swal({
                    title: "Remove Data",
                    text: "Click at OK button to Remove Data",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                ws.bloader('.ivContentbloader',1);  
                ws.f('/acp/db_table_clean',i,function(data){
                var part = JSON.parse(data);
                ws.swal({
                        type: part[0],
                        title: part[1],
                        confirmButtonColor: "#2196F3"
                    });   
                ws.db_cleanup();                                                                    
                ws.bloader('.ivContentbloader',2);  
                });
            });
        },
        dbs_backup_delete : function(i)
        {
             ws.swal({
                    title: "Delete",
                    text: "Click at OK button to Delete",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                ws.bloader('.ivContentbloader',1);  
                ws.f('/acp/dbs_backup_delete',i,function(data){
                var part = JSON.parse(data);
                ws.swal({
                        type: part[0],
                        title: part[1],
                        confirmButtonColor: "#2196F3"
                    });   
                ws.db_backups();        
                ws.bloader('.ivContentbloader',2);  
                });
            });
        },
        db_backup_delete : function(i)
        {
             ws.swal({
                    title: "Delete",
                    text: "Click at OK button to Delete",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {            
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/db_backup_delete/'+i,function (data){
                var part = JSON.parse(data);
                    ws.swal({
                            type: part[0],
                            title: part[1],
                            confirmButtonColor: "#2196F3"
                        });   
                ws.db_backups();                                                                    
                ws.bloader('.ivContentbloader',2);  
                });
            });
        },    
        IpWhiteForm : function(type=""){
            ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/apps/firewall/IpWhiteForm/'+type,function (data){
            ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'S');
            });
        },
        IpWhiteSave : function(e)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.f('/acp/apps/firewall/IpWhiteSave',e,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == "success") location.reload();
                 ws.bloader('.ivContentbloader',2);  
            });        
        },    
        ThemeChangeForm : function(theme=""){
            ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/apps/clientarea/ThemeChangeForm/'+theme,function (data){
            ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'S');
            });
        },
        ThemeChangeSave : function(e)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.f('/acp/apps/clientarea/ThemeChangeSave',e,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == "success") location.reload();
                 ws.bloader('.ivContentbloader',2);  
            });        
        },
        DelWhiteIp : function(i){
            ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/apps/firewall/IpRemoveFromWhitelist/'+i,function (data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == "success") location.reload();
                ws.bloader('.ivContentbloader',2);
            });
        },
        AddLinkTrackingForm : function (type=""){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/AddLinkTrackingForm/'+type,function (data)
            {
                ws.bloader('.ivContentbloader',2);  
                ws.modal(data,'S');
            });
        },
        DelLinkTracking : function (id=""){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/DelLinkTracking/'+id,function (data)
            {
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == 'success') window.setTimeout(function(){location.reload();}, 1000);
                ws.bloader('.ivContentbloader',2);  
            });
        },
        AddLinkTrackingSave : function (e){
            ws.bloader('.ivContentbloader',1);
            ws.f('/acp/AddLinkTrackingSave',e,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == 'success') window.setTimeout(function(){location.reload();}, 1000);
                ws.bloader('.ivContentbloader',2);  
             });
             return false;
        },
        MigratorConnection : function (e){
            ws.bloader('.ivContentbloader',1);
            ws.f('/acp/MigratorConnection',e,function(data)
            {
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == 'success')
                {
                    $(".step-btn-continue-check").click();
                    ws.MigratorChecks();
                }
                ws.bloader('.ivContentbloader',2);  
             });
             return false;
        },
        MigratorChecks : function ()
        {
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/MigratorChecks/',function (data)
            {
                $(".MigratorChecks").html(data);
                ws.bloader('.ivContentbloader',2);  
            });
        },
        MigratorCompleted : function ()
        {
            ws.ajax('/acp/MigratorCompleted/',function (data)
            {
                var part = JSON.parse(data);
                if(part.status == "success") window.location="/admin";
                    $('.imp-loader').addClass("hide"); 
            });
        },
        MigratorNextRequest : function()
        {
            setTimeout(function(){ws.MigratorProgress();},5000);
        },
        MigratorProgress : function ()
        {
            $.get("/acp/MigratorProgress/", function(data)
            {
                var part = JSON.parse(data);
                $(".import-stats-area").html(part.response);
                $(".imp-totals-tables").text(part.totals);
                $(".imp-migrated-tables").text(part.completed);
                $(".imp-inprocess-tables").text(part.inprocess);
                $(".ImpNextTableInprocess").text(part.nexttable);
                $('.import-stats-area').animate({scrollTop: $('.import-stats-area').prop('scrollHeight')}, 2000);
                if(part.pending == 1)
                {
                    $('.imp-loader').removeClass("hide");                      
                    ws.MigratorNextRequest();  
                }else{
                    $('.imp-loader').addClass("hide"); 
                    $(".step-btn-completed").click();
                    ws.MigratorCompleted();
                }
            }).fail(function(data, textStatus, xhr)
            {
                //alert(textStatus);
                if(textStatus!=200)
                {
                    var msg = "";
                    if(textStatus == "error")
                    {
                        msg = "<p>The request had undefined error.</p>";
                    }
                    if(textStatus == 400)
                    {
                        msg = "<p>The request had bad syntax or was inherently impossible to be satisfied.</p>";
                    }
                    if(textStatus == 401)
                    {
                        msg = "The parameter to this message gives a specification of authorization schemes which are acceptable. The client should retry the request with a suitable Authorization header.</p>";
                    }
                    if(textStatus == 402)
                    {
                        msg = "<p>The parameter to this message gives a specification of charging schemes acceptable. The client may retry the request with a suitable ChargeTo header.</p>";
                    }
                    if(textStatus == 403)
                    {
                        msg = "<p>The request is for something forbidden. Authorization will not help.</p>";
                    }
                    if(textStatus == 404)
                    {
                        msg = "<p>The server has not found anything matching the URI given</p>";
                    }
                    if(textStatus == 500)
                    {
                        msg = "<p>The server encountered an unexpected condition which prevented it from fulfilling the request.</p>";
                    }
                    if(textStatus == 501)
                    {
                        msg = "<p>The server does not support the facility required.</p>";
                    }
                    if(textStatus == 502)
                    {
                        msg = "<p>The server cannot process the request due to a high load (whether HTTP servicing or other requests). The implication is that this is a temporary condition which maybe alleviated at other times.</p>";
                    }
                    if(textStatus == 503)
                    {
                        msg = "<p>This is equivalent to Internal Error 500, but in the case of a server which is in turn accessing some other service, this indicates that the respose from the other service did not return within a time that the gateway was prepared to wait. As from the point of view of the clientand the HTTP transaction the other service is hidden within the server, this maybe treated identically to Internal error 500, but has more diagnostic value.</p>";
                    }
                    $(".import-stats-elogs-area").append(msg);
                    $('.import-stats-elogs-area').animate({scrollTop: $('.import-stats-elogs-area').prop('scrollHeight')}, 2000);
                }
                ws.MigratorNextRequest();  
            });
        },
        MigratorStart : function ()
        {
            $('.imp-loader').removeClass("hide");  
            ws.ajax('/acp/MigratorStart/',function (data)
            {
                var part = JSON.parse(data);
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == "success") ws.MigratorProgress();  
            });
        },
        MigratorTable : function (t="")
        {
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/MigratorTable/'+t,function (data)
            {
                var part = JSON.parse(data);
                if(part.status == 'success'){$(".Imp-"+t).html(part.message);}
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                ws.bloader('.ivContentbloader',2);  
            });
        },
        AddEmailCampaignsForm : function (type=""){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/AddEmailCampaignsForm/'+type,function (data)
            {
                ws.bloader('.ivContentbloader',2);  
                ws.modal(data,'L');
            });
        },
        GetEmailCampaignsProgress : function (id=0){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/GetEmailCampaignsProgress/'+id,function (data)
            {
                ws.bloader('.ivContentbloader',2);  
                ws.modal(data,'S');
            });
        },
        DelEmailCampaigns : function (id=""){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/DelEmailCampaigns/'+id,function (data)
            {
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == 'success') window.setTimeout(function(){location.reload();}, 1000);
                ws.bloader('.ivContentbloader',2);  
            });
        },
        EmailCampaignsActs : function (id="",act=""){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/EmailCampaignsActs/'+id+'/'+act,function (data)
            {
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == 'success') window.setTimeout(function(){location.reload();}, 1000);
                ws.bloader('.ivContentbloader',2);  
            });
        },
        AddEmailCampaignsSave : function (e){
            ws.bloader('.ivContentbloader',1);
            ws.f('/acp/AddEmailCampaignsSave',e,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == 'success') window.setTimeout(function(){window.location="/admin/email-campaigns-compose/"+part.id;}, 1000);
                ws.bloader('.ivContentbloader',2);  
             });
             return false;
        },
        AddEmailCampaignsComposeSave : function (e){
            ws.bloader('.ivContentbloader',1);
            ws.f('/acp/AddEmailCampaignsComposeSave',e,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == 'success') window.setTimeout(function(){window.location="/admin/email-campaigns/";}, 1000);
                ws.bloader('.ivContentbloader',2);  
             });
             return false;
        },
        BulkPricesUpdatersFetch : function (e)
        {
            var act = $("#BpuActionInp").val();
            ws.bloader('.ivContentbloader',1);  
            ws.f('/acp/BulkPricesUpdatersFetch',e,function(data)
            {
                if(act == "UpdatePrices")
                {
                    var part = JSON.parse(data);
                    ws.swal({title:"Bulk Pricing",text:part.message,type:part.status});
                    ws.bloader('.ivContentbloader',2);  
                }
                else
                {
                    $("#BulkPricesUpdatersFetch").html(data);
                    ws.bloader('.ivContentbloader',2);  
                }
            });
            return false;
        },
        automation_status : function(d=""){
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/automation_status/'+d,function (data){
                $("#automation_status").html(data);
                daterange_singles();
                ws.bloader('.ivContentbloader',2);  
                });
        },
        AutomationTaskName : "",
        AutomationTaskDate : "",
        AutomationTaskTf : "",
        GetAutomationStatusLogs : function (t,d,tf=false)
        {
            ws.AutomationTaskName=t;
            ws.AutomationTaskDate=d;
            ws.AutomationTaskTf=tf;
            ws.bloader('.ivContentbloader',1);                        
            ws.ajax('/acp/getautomationstatuslogs/'+t+'/'+d,function (data){
            ws.bloader('.ivContentbloader',2); 
             if(tf)
             {
                 ws.modal(data,'L');
             }else{
                 ws.modal(data,'M');
             }
            });
        },
        TaskEnableDisable : function (i)
        {
            ws.bloader('.ivContentbloader',1);                        
            ws.ajax('/acp/task-enable-disable/'+i,function (data)
            {
                ws.bloader('.ivContentbloader',2); 
                var part = JSON.parse(data);
                ws.swal({title:"Cron Task",text:part.message,type:part.status});
                var n = ws.AutomationTaskName;
                var d = ws.AutomationTaskDate;
                var tf = ws.AutomationTaskTf;
                ws.TabClickableObj = ".iv-Configure-Tasks";
                ws.GetAutomationStatusLogs(n,d,tf);
            });
        },
        TaskExecute : function (i)
        {
            ws.bloader('.ivContentbloader',1);                        
            ws.ajax('/acp/task-execute/'+i,function (data)
            {
                ws.bloader('.ivContentbloader',2); 
                var part = JSON.parse(data);
                ws.swal({title:"Task Execution",text:part.message,type:part.status});
            });
        },
        mail_preview : function (i){
             //this.loading('.domain_spotlights','Domain TLDs Loading.....');
              ws.bloader('.ivContentbloader',1);                        
            ws.ajax('/acp/mail-preview/'+i,function (data){
             ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'L');
            });
        },
        fraud_mod_form : function (m)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/fraud_mod_form/'+m,function (data){
             ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'S');
            });
        },
        fraud_mod_recheck : function (u=0,o=0)
        {
             ws.swal({
                    title: "Fraud Check",
                    text: "Click at OK button to Fraud Check",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                    ws.bloader('.ivContentbloader',1);  
                    ws.ajax('/acp/fraud_mod_recheck/'+u+'/'+o,function (res){
                        ws.bloader('.ivContentbloader',2);  
                        var part = JSON.parse(res);
                        ws.swal({title:"Fraud Module",text:part.message,type:part.status});
                        window.setTimeout(function(){location.reload();}, 3000);
                    });
            });
        },
        fraud_mod_report : function (u=0,o=0,f=false)
        {
            var _f = f ? 1:0;
             ws.swal({
                    title: "Fraud Report",
                    text: "Click at OK button to Fraud Report",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                ws.bloader('.ivContentbloader',1);
                ws.ajax('/acp/fraud_mod_report/'+u+'/'+o+'/'+_f,function (res){
                    ws.bloader('.ivContentbloader',2);
                    if(_f == 1){
                        ws.modal(res,'S');                        
                        ws.swal({title:"Fraud Module",text:"",type:"info"});
                    }else{
                        var part = JSON.parse(res);
                        ws.swal({title:"Fraud Module",text:part.message,type:part.status});                        
                    }
                });
            });
        },
        fraud_mod_reported : function (i)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.f('/acp/fraud_mod_report',i,function(res)
            {
                ws.bloader('.ivContentbloader',2); 
                var part = JSON.parse(res);
                ws.swal({title:"Fraud Module",text:part.message,type:part.status});
            });
            return false;
        },
        fraud_mod_save : function (i)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.f('/acp/fraud_mod_save',i,function(res)
            {
                var part = JSON.parse(res);
                ws.swal({title:"Fraud Module",text:part.message,type:part.status});
                if(part.status == 'success'){
                    location.reload();
                }
            });
            return false;
        },
        sso_auth_form : function (m)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/sso_auth_form/'+m,function (data){
             ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'S');
            });
        },
        sso_auth_save : function (i)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.f('/acp/sso_auth_save',i,function(res)
            {
                var part = JSON.parse(res);
                ws.swal({title:"SSO Module",text:part.message,type:part.status});
                if(part.status == 'success'){
                 location.reload();
                }
            });
            return false;
        },
        two_factor_auth_form : function (m)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/two_factor_auth_form/'+m,function (data){
             ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'S');
            });
        },
        empty : function( val )
        {
            if (val === undefined) return true;
            if (typeof (val) == 'function' || typeof (val) == 'number' || typeof (val) == 'boolean' || Object.prototype.toString.call(val) === '[object Date]') return false;
            if (val == null || val.length === 0) return true;
            if (typeof (val) == "object")
            {
                var r = true;
                for (var f in val)
                    r = false;
                return r;
            }
            return false;
    },
    verifypin: function (i) {
        ws.bloader('.ivContentbloader', 1);
        ws.f('/acp/verifypin', i, function (res) {
            var part = JSON.parse(res);
            ws.swal({title:"Pin Verification",text:part.message,type:part.status});
            ws.bloader('.ivContentbloader', 2);
            if (part.status == 'success')
            {
                location.reload();
            }
        });
        return false;
    },
        dosignin : function (i)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.f('/acp/dosignin',i,function(res){
                var part = JSON.parse(res);
                ws.swal({title:"Signin",text:part.message,type:part.status});
                ws.bloader('.ivContentbloader',2);  
                if(part.status == 'success')
                {
                    var redurl = part.redirect;
                    if(ws.empty(redurl))
                    {
                        window.location="/admin/";
                    }
                    else
                    {
                        if(redurl.length>10)
                        {
                            window.location=redurl;
                        }
                        else
                        {
                            window.location="/admin/";
                        }
                    }
                }
            });
            return false;
        },
        two_factor_auth_save : function (i)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.f('/acp/two_factor_auth_save',i,function(res){
                var part = JSON.parse(res);
                ws.swal({title:"Security Module",text:part.message,type:part.status});
                if(part.status == 'success'){
                 location.reload();
                }
            });
            return false;
        },
        two_factor_auth_global_save : function (i)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.f('/acp/two_factor_auth_global_save',i,function(res){
                var part = JSON.parse(res);
                ws.swal({title:"Security Module",text:part.message,type:part.status});
                if(part.status == 'success'){
                 location.reload();
                }
            });
            return false;
        },
        two_auth_check_form : function (){
            ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/two_auth_check/',function (data){
                //$(".whmbcs-model-content").html(data);
                if (data.length > 100)
                {
                    ws.modal(data, 'S');
                }
                ws.bloader('.ivContentbloader',2);  
                ws.radio_checks();
            });
        },
        two_auth_send : function (e){
             ws.bloader('.ivContentbloader',1);
             ws.f('/acp/two_auth_send',e,function(data){
                 $(".whmbcs-model-content").html(data);
                 ws.bloader('.ivContentbloader',2);  
             });
        },
        two_auth_activate : function (e){
             ws.bloader('.ivContentbloader',1);
             ws.f('/acp/two_auth_activate',e,function(data){
                var part = JSON.parse(data);                           
                if(part.status == 'success')
                {
                    $(".whmbcs-model-content").html(part.message);
                }else{
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                }
                 ws.bloader('.ivContentbloader',2);  
             });
        },
        SupportDepartmentAddUpForm : function (i=0){
            ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/SupportDepartmentAddUpForm/'+i,function (data){
            ws.modal(data,'L');
             ws.bloader('.ivContentbloader',2);  
              ws.radio_checks();
            });
        },
        SupportDepartmentAddUpSave : function (e){
             ws.bloader('.ivContentbloader',1);
             ws.f('/acp/SupportDepartmentAddUpSave',e,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                 ws.bloader('.ivContentbloader',2);  
             });
        },
        BasicSetupConfigForm : function (){
            ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/BasicSetupConfigForm/',function (data){
           ws.modal(data,'S');
             ws.bloader('.ivContentbloader',2);  
              ws.radio_checks();
            });
        },
        cp_server_sync_accounts : function (s){
             ws.bloader('.ivContentbloader',1);
             ws.ajax('/acp/cp_server_sync_accounts/'+s,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == 'success') window.setTimeout(function(){location.reload();}, 2000);
                 ws.bloader('.ivContentbloader',2);  
             });
        },
        cp_account_stats_update : function (s){
             ws.bloader('.ivContentbloader',1);
             ws.ajax('/acp/cp_account_stats_update/'+s,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == 'success') window.setTimeout(function(){location.reload();}, 2000);
                 ws.bloader('.ivContentbloader',2);  
             });
        },
        domain_delete : function (u=0,i=0,d=0)
        {
             ws.swal({
                    title: "Delete",
                    text: "Click at OK button to Delete",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {            
                     ws.bloader('.ivContentbloader',1);
                     ws.ajax('/acp/domain_delete/'+i,function(data){
                        var part = JSON.parse(data);                           
                        ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                        if(part.status == "success")
                        {
                            if(d>0)
                            {
                                 window.setTimeout(function(){window.location="/admin/client-summary/"+u;}, 2000);
                            }else{
                                window.setTimeout(function(){location.reload();}, 2000);
                            }
                        }
                        ws.bloader('.ivContentbloader',2);  
                     });
             });
        },
        service_delete : function (u=0,i=0,d=0)
        {
             ws.swal({
                    title: "Delete",
                    text: "Click at OK button to Delete",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {            
                     ws.bloader('.ivContentbloader',1);
                     ws.ajax('/acp/service_delete/'+i,function(data){
                        var part = JSON.parse(data);                           
                        ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                        if(part.status == "success")
                        {
                            if(d>0)
                            {
                                 window.setTimeout(function(){window.location="/admin/client-summary/"+u;}, 2000);
                            }else{
                                window.setTimeout(function(){location.reload();}, 2000);
                            }
                        }
                        ws.bloader('.ivContentbloader',2);  
                     });
             });
        },
        cp_login_to_cp : function (i=0){
             ws.bloader('.ivContentbloader',1);
             ws.ajax('/acp/cp_account_login_to_cp/'+i,function(data){
                var part = JSON.parse(data);                           
                if(part.status == 'success'){
                    window.open(part.url, '_blank').focus();
                }else{
                    ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});                                
                }
                 ws.bloader('.ivContentbloader',2);  
             });
        },
        cp_server_login_form : function (i)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/cp_server_login_form/'+i,function (data)
            {
                ws.bloader('.ivContentbloader',2);  
                ws.modal(data,'S');
            });
        },
        cp_server_login : function (e){
             ws.bloader('.ivContentbloader',1);
             ws.f('/acp/cp_server_login/',e,function(data){
                var part = JSON.parse(data);                           
                if(part.status == 'success'){
                    window.open(part.url, '_blank').focus();
                }else{
                    ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});                                
                }
                 ws.bloader('.ivContentbloader',2);  
             });
        },
        cp_account_suspend_form : function (i)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/cp_account_suspend_form/'+i,function (data){
             ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'S');
            });
        },
        cp_account_suspend : function (e){
             ws.bloader('.ivContentbloader',1);
             ws.f('/acp/cp_account_suspend',e,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == 'success') window.setTimeout(function(){location.reload();}, 2000);
                 ws.bloader('.ivContentbloader',2);  
             });
        },
        cp_account_un_suspend_form : function (i)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/cp_account_un_suspend_form/'+i,function (data){
             ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'S');
            });
        },
        cp_account_un_suspend : function (e){
             ws.bloader('.ivContentbloader',1);
             ws.f('/acp/cp_account_un_suspend',e,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == 'success') window.setTimeout(function(){location.reload();}, 2000);
                 ws.bloader('.ivContentbloader',2);  
             });
        },
        cp_account_terminate_form : function (i)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/cp_account_terminate_form/'+i,function (data){
             ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'S');
            });
        },
        cp_account_terminate : function (e){
             ws.bloader('.ivContentbloader',1);
             ws.f('/acp/cp_account_terminate',e,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == 'success') window.setTimeout(function(){location.reload();}, 2000);
                 ws.bloader('.ivContentbloader',2);  
             });
        },
        cp_account_create_form : function (i)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/cp_account_create_form/'+i,function (data){
             ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'S');
            });
        },
        cp_account_ssl_form : function (i)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/cp_account_ssl_form/'+i,function (data){
             ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'M');
            });
        },
        cp_account_ssl_steps : function (i=0,s=1)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/cp_account_ssl_steps/'+i+'/'+s,function (data){
             ws.bloader('.ivContentbloader',2);  
                $(".ssl-steps-body").html(data);
            });
        },
        cp_account_ssl_steps_save : function (e){
             ws.bloader('.ivContentbloader',1);
             ws.f('/acp/cp_account_ssl_steps_save',e,function(data)
             {
                $(".ssl-steps-body").html(data);
                //var part = JSON.parse(data);                           
                //ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                //if(part.status == 'success') ws.cp_account_ssl_steptwo_save();
                 ws.bloader('.ivContentbloader',2);  
             });
        },
        cp_account_custom_call : function (a,i)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/cp_account_custom_call/'+a+'/'+i,function (data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == 'success') window.setTimeout(function(){location.reload();}, 2000);
                 ws.bloader('.ivContentbloader',2);  
            });
        },
        cp_account_create : function (e){
             ws.bloader('.ivContentbloader',1);
             ws.f('/acp/cp_account_create',e,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == 'success') window.setTimeout(function(){location.reload();}, 2000);
                 ws.bloader('.ivContentbloader',2);  
             });
        },
        cp_account_info_save : function (e){
             ws.bloader('.ivContentbloader',1);
             ws.f('/acp/cp_account_info_save',e,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == 'success') window.setTimeout(function(){location.reload();}, 2000);
                 ws.bloader('.ivContentbloader',2);  
             });
        },
        cp_account_upgrade_downgrade_form : function (i){
             //this.loading('.domain_spotlights','Domain TLDs Loading.....');
            ws.bloader('.ivContentbloader',1);                        
            ws.ajax('/acp/cp_account_upgrade_downgrade_form/'+i,function (data){
            ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'S');
            ws.cp_account_upgrade_downgrade_calculations(i);
            });
        },
        AddOrderNoteForm : function (u=0,o=0){
            ws.bloader('.ivContentbloader',1);                        
            ws.ajax('/acp/AddOrderNoteForm/'+u+'/'+o,function (data){
                ws.bloader('.ivContentbloader',2);  
                ws.modal(data,'S');
            });
        },
        AddOrderNoteSave : function (e)
        {
            ws.bloader('.ivContentbloader',1,'Request Inprocess......');
            ws.f('/acp/AddOrderNoteSave/',e,function (data){
                 var part = JSON.parse(data); 
                if(part.status != 'error'){
                    ws.notify('success',part.message); 
                    ws.modal('','N');
                    window.setTimeout(function(){location.reload();}, 1000);
                }else{
                    ws.notify('error',part.message);                                                                
                }                            
                ws.bloader('.ivContentbloader',2,'');
            });         
        },
        AssigneAffiliateSearch : function (v){
             clearTimeout(ws.typingTimer);
            if (v){ws.typingTimer = setTimeout(function(){
            ws.loading('.clients_list_to_transfer','Clients Searching .....');                      
            ws.ajax('/acp/AssigneAffiliateSearch/'+v,function (data){
            $('.clients_list_to_transfer').html(data).show();
            });
            }, ws.doneTypingInterval); }else{
                $('.clients_list_to_transfer').html('').hide();
            }
        },
        AssigneAffiliateForm : function (u=0){
          ws.bloader('.ivContentbloader',1);                        
            ws.ajax('/acp/AssigneAffiliateForm/'+u,function (data){
             ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'S');
            });
        },
        AssigneAffiliateSave : function (u=0)
        {
            var i = $("input[name='aff_client_id']").val();
             ws.swal({
                    title: "Assigne Affiliate",
                    text: "Click at OK button to Assigne Affiliate",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                    ws.bloader('.ivContentbloader',1);  
                    ws.ajax('/acp/AssigneAffiliateSave/'+i+'/'+u,function (data){
                    var part = JSON.parse(data);
                    if(part.status == 'success')
                    {
                      ws.modal('','N');
                    }
                    ws.swal({  type: part.status,
                            title: part.message,
                            confirmButtonColor: "#2196F3"
                        }); 
                    location.reload();                                                              
                    ws.bloader('.ivContentbloader',2);  
                    });
            });
        },
        client_account_merge_form : function (i){
          ws.bloader('.ivContentbloader',1);                        
            ws.ajax('/acp/client_account_merge_form/'+i,function (data){
             ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'S');
            });
        },
        client_account_statement : function (i){
          ws.bloader('.ivContentbloader',1);                        
            ws.ajax('/acp/client_account_statement/'+i,function (data){
             ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'L');
            });
        },
        client_account_search_clients : function (v,f="client_account_merge"){
             clearTimeout(ws.typingTimer);
            if (v){ws.typingTimer = setTimeout(function(){
            ws.loading('.clients_list_to_transfer','Clients Searching .....');                      
            ws.ajax('/acp/client_account_search_clients/'+v+'/'+f,function (data){
            $('.clients_list_to_transfer').html(data).show();
            });
            }, ws.doneTypingInterval); }else{
                $('.clients_list_to_transfer').html('').hide();
            }
        },
        client_account_merge : function (t)
        {
        var i = $("input[name='client_merge_id']").val();
        var m = $("input[name='client_merge_method']:checked").val();
        if ($("input[name='client_merge_method']").is(':checked'))
        {
             ws.swal({
                    title: "Merge Clients",
                    text: "Click at OK button to Merge Clients",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                    ws.bloader('.ivContentbloader',1);  
                    ws.ajax('/acp/client_account_merge/'+i+'/'+t+'/'+m,function (data){
                    var part = JSON.parse(data);
                    if(part.status == 'success'){
                      ws.modal('','N');
                    }
                        ws.swal({  type: part.status,
                                title: part.message,
                                confirmButtonColor: "#2196F3"
                            }); 
                            location.reload();                                                              
                    ws.bloader('.ivContentbloader',2);  
                    });
            });
        }else{
            ws.swal({  type: "error",
                title: "Please select Merge to First Client / Merge to Second Client",
                confirmButtonColor: "#2196F3"
            }); 
            
        }
        },
        client_account_close : function (i){
             ws.swal({
                    title: "Close Account",
                    text: "Are you sure you want to close this client?  This will set all packages and unpaid invoices to Cancelled.",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                    ws.bloader('.ivContentbloader',1);  
                    ws.ajax('/acp/client_account_close/'+i,function (data){
                    var part = JSON.parse(data);
                        ws.swal({  type: part.status,
                                title: part.message,
                                confirmButtonColor: "#2196F3"
                            }); 
                    location.reload();                                                              
                    ws.bloader('.ivContentbloader',2);  
                    });
            });
        },
        client_account_delete : function (i){
             ws.swal({
                    title: "Delete Account",
                    text: "Are you sure you want to delete this client?",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                    ws.bloader('.ivContentbloader',1);  
                    ws.ajax('/acp/client_account_delete/'+i,function (data){
                    var part = JSON.parse(data);
                        ws.swal({  type: part.status,
                                title: part.message,
                                confirmButtonColor: "#2196F3"
                            }); 
                    if(part.status == "success") window.location="/admin/client-list";
                    ws.bloader('.ivContentbloader',2);  
                    });
            });
        },
        client_accounts_delete : function(e)
        {
            ws.swal({
                title: "Delete",
                text: "Click at OK button to Delete Clients Accounts",
                type: "error",
                showCancelButton: true,
                closeOnConfirm: false,
                confirmButtonColor: "green",
                showLoaderOnConfirm: true
            },
            function() {            
                ws.bloader('.ivContentbloader',1,'Request Inprocess......');
                ws.f('/acp/client_accounts_delete',e,function(data){
                var part = JSON.parse(data);
                ws.swal({
                        title: part.message,
                        confirmButtonColor: "#2196F3"
                    });
                if(part.status == "success") location.reload();
                ws.bloader('.ivContentbloader',2,'');
                });
            });
        },
        generate_overdue_invoices : function (i,t=0){
            var title = "Overdue";
            if(t == 0) title = "Due";
             ws.swal({
                    title: "Generate Invoices",
                    text: "Are you sure you want to Generate "+title+" Invoices for this client",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                    ws.bloader('.ivContentbloader',1);  
                    ws.ajax('/acp/generate_overdue_invoices/'+i+'/'+t,function (data){
                    var part = JSON.parse(data);
                        ws.swal({  type: part.status,
                                title: part.message,
                                confirmButtonColor: "#2196F3"
                            }); 
                    if(part.status == "success") location.reload();                                                              
                    ws.bloader('.ivContentbloader',2);  
                    });
            });
        },
        client_export_data : function (i){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/client_export_data/'+i,function (data){
            var part = JSON.parse(data);
                ws.swal({  type: part.status,
                        title: part.message,
                        confirmButtonColor: "#2196F3"
                    }); 
            ws.bloader('.ivContentbloader',2);  
            });
        },
        client_configs_change : function (i,f){
                    ws.bloader('.ivContentbloader',1);  
                    ws.ajax('/acp/client_configs_change/'+i+'/'+f,function (data){
                    var part = JSON.parse(data);
                        ws.swal({  type: part.status,
                                title: part.message,
                                confirmButtonColor: "#2196F3"
                            }); 
                        if(part.status == 'success'){
                            if(part.response == 'YES'){
                                $('.ws-'+f).removeClass('textred').addClass('textgreen').text('Yes');                                            
                            }else{
                                $('.ws-'+f).removeClass('textgreen').addClass('textred').text('No');                                        
                            }
                        }
                    ws.bloader('.ivContentbloader',2);  
                    });
        },
        CreditCardValidate:function(id="")
        {
            var val = $("#"+id).val();
            var type = $("#"+id).attr("wst");
            var vlen = val.length;
            if(type == "sd" || type == "ed")
            {
                var m = $("#"+id).attr("wsm");
                var y = $("#"+id).attr("wsy");
                var iy = val.slice(-2);
                var im = val.substring(0,2);
                if(vlen == 2) $("#"+id).val(val+"/");
                if(vlen == 2 && val>12) $("#"+id).val("");
                $("#"+id).css("border","1px solid #dddddd"); 
                if(vlen < 5) $("#"+id).css("border","1px solid #ff0000"); 
            }
            if(type == "sd")
            {
                if(vlen == 5)
                {
                    if(Number(iy)>Number(y)) $("#"+id).val(val.substring(0,3));
                    if(Number(im)>12) $("#"+id).val("");
                    if(Number(iy) == Number(y) && Number(im)>Number(m)) $("#"+id).val("");
                }
            }
            if(type == "ed")
            {
                if(vlen == 5)
                {
                    if(Number(y)>Number(iy)) $("#"+id).val(val.substring(0,3));
                    if(Number(im)>12) $("#"+id).val("");
                    if(Number(iy) == Number(y) && Number(m)>Number(im)) $("#"+id).val("");
                }
            }
            if(type == "cvv")
            {
                $("#"+id).css("border","1px solid #dddddd"); 
                if(vlen < 3) $("#"+id).css("border","1px solid #ff0000"); 
            }
        },
        addCreditCardForm : function (u=0,i=0)
        {
            ws.bloader('.ivContentbloader',1);                        
            ws.ajax('/acp/add-credit-card-form/'+u+'/'+i,function (data){
             ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'S');
            });
        },
        addCreditCardGatewayForm : function (client_id=0,gateway_id=0,card_id=0)
        {
            ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/add-credit-card-gateway-form/'+client_id+'/'+gateway_id+'/'+card_id,function (data)
            {
                $(".GatewayCcFields").html(data);
                ws.bloader('.ivContentbloader',2);
            });
        },
        addCreditCardSave : function (f)
        {
            ws.bloader('.ivContentbloader',1);                        
            ws.f('/acp/save-credit-card/',f,function(res){
                var part = JSON.parse(res);
                ws.swal({title:"Credit Card",text:part.message,type:part.status});
                ws.bloader('.ivContentbloader',2);
                if(part.status == 'success')
                {
                    if (part.hasOwnProperty('url'))
                    {
                        window.location=part.url;
                    }
                    else
                    {
                        location.reload(); 
                    }
                }
            });
        },
        delCreditCard : function (i,u){
             ws.swal({
                    title: "Delete Credit Card",
                    text: "Click at OK button to Delete Credit Card",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {

                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/delete-credit-card/'+i+'/'+u,function (data){
                var part = JSON.parse(data);
                ws.swal({  type: part.status,
                    title: part.message,
                    confirmButtonColor: "#2196F3"
                }); 
                if(part.status == 'success') location.reload();
                ws.bloader('.ivContentbloader',2);  
                });
            });
        },
        cp_account_transfer_ownership_form : function (i){
             //this.loading('.domain_spotlights','Domain TLDs Loading.....');
              ws.bloader('.ivContentbloader',1);                        
            ws.ajax('/acp/cp_account_transfer_ownership_form/'+i,function (data){
            ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'S');
            });
        },
        cp_account_transfer_ownership : function (i,c){
             ws.swal({
                    title: "Transfer Ownership",
                    text: "Click at OK button to Transfer Ownership",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {

                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/cp_account_transfir_ownership/'+i+'/'+c,function (data){
                var part = JSON.parse(data);
                if(part.status == 'success'){
                  ws.modal('','N');
                }
                    ws.swal({  type: part.status,
                            title: part.message,
                            confirmButtonColor: "#2196F3"
                        }); 
                        location.reload();                                                              
                ws.bloader('.ivContentbloader',2);  
                });
                });
        },
        cp_domain_search_clients : function (i,v){
             clearTimeout(ws.typingTimer);
            if (v){ws.typingTimer = setTimeout(function(){
            ws.loading('.clients_list_to_transfer','Clients Searching .....');                      
            ws.ajax('/acp/cp_domain_search_clients/'+i+'/'+v,function (data){
            $('.clients_list_to_transfer').html(data).show();
            });
            }, ws.doneTypingInterval); }else{
                $('.clients_list_to_transfer').html('').hide();
            }
        },
        cp_domain_transfer_ownership_form : function (i){
             //this.loading('.domain_spotlights','Domain TLDs Loading.....');
              ws.bloader('.ivContentbloader',1);                        
            ws.ajax('/acp/cp_domain_transfer_ownership_form/'+i,function (data){
             ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'S');
            });
        },
        cp_domain_transfer_ownership : function (i,c){
             ws.swal({
                    title: "Transfer Ownership",
                    text: "Click at OK button to Transfer Ownership",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {

                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/cp_domain_transfer_ownership/'+i+'/'+c,function (data){
                var part = JSON.parse(data);
                if(part.status == 'success'){
                  ws.modal('','N');
                }
                    ws.swal({  type: part.status,
                            title: part.message,
                            confirmButtonColor: "#2196F3"
                        }); 
                        location.reload();                                                              
                ws.bloader('.ivContentbloader',2);  
                });
                });
        },
        email_add_in_queue : function (m,i,t){
             ws.swal({
                    title: "Send Email",
                    text: "Click at OK button to Send Email",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/email_add_in_queue/'+i+'/'+t+'/'+m,function (data){
                var part = JSON.parse(data);
                    ws.swal({  type: part.status,
                            title: part.message,
                            confirmButtonColor: "#2196F3"
                        }); 
                ws.bloader('.ivContentbloader',2);  
                });
                });
        },
        product_info_edit : function(f,i){
            ws.f('/acp/product_info_edit/'+i,f,function(res){
                var part = JSON.parse(res);
                ws.swal({title:"Service/Product",text:part.message,type:part.status});
                if(part.status == 'success'){
                    location.reload();
                }
            });
            return false;
        },
        ProductType:"",
        ProductId:0,
        GetProductCustomFields : function (i,t)
        {
            ws.ProductType = t;
            ws.ProductId = i;
            ws.bloader('.ivContentbloader',1);  
            this.loading('.GetProductCustomFields','Custom Fields Loading.....');
            ws.ajax('/acp/GetProductCustomFields/'+i+'/'+t,function (data){
            $('.GetProductCustomFields').html(data);
            ws.bloader('.ivContentbloader',2);  
            });
        },
        GetProductFieldForm : function (i=0,t="")
        {
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/GetProductFieldForm/'+i+'/'+t,function (data){
             ws.bloader('.ivContentbloader',2);  
             ws.modal(data,'M');
            });
        },
        deleteProductCustomField : function (i){
             ws.swal({
                    title: "Delete Field",
                    text: "Click at OK button to Delete Custom Field",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/deleteProductCustomField/'+i,function (data){
                var part = JSON.parse(data);
                    ws.swal({  type: part.status,
                            title: part.message,
                            confirmButtonColor: "#2196F3"
                        }); 
                    ws.GetProductCustomFields(ws.ProductId,ws.ProductType);
                ws.bloader('.ivContentbloader',2);  
                });
                });
        },
        DoSaveProductField : function(f,p=0)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.f('/acp/DoSaveProductField/',f,function(res){
                var part = JSON.parse(res);
                ws.swal({title:"Service/Product Field",text:part.message,type:part.status});
                ws.bloader('.ivContentbloader',2);  
                if(part.status == 'success')
                {
                    var nextNum = $(".ws-input-orderby").val();
                    nextNum++;
                    $(".ws-input-orderby").val(nextNum);                    
                    ws.GetProductCustomFields(p,ws.ProductType);
                }
            });
            return false;
        },
        GetProductFeaturesList : function (i)
        {
            ws.bloader('.ivContentbloader',1);  
            this.loading('.GetProductFeaturesList','Features List Loading.....');
            ws.ajax('/acp/GetProductFeaturesList/'+i,function (data){
            $('.GetProductFeaturesList').html(data);
            ws.bloader('.ivContentbloader',2);  
            });
        },
        GetProductFeatureForm : function (i,p=0)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/GetProductFeatureForm/'+i+'/'+p,function (data){
             ws.bloader('.ivContentbloader',2);  
             ws.modal(data,'S');
            });
        },
        getDecimalCount:function(input)
        {
            const inputStr = String(input);
            const decimalCount = (inputStr.match(/\./g) || []).length;
            return decimalCount+1;            
        },    
        DoDelProductFeature : function (i=0,p=0)
        {
             ws.swal({
                    title: "Delete Feature",
                    text: "Click at OK button to Delete "+ws.getDecimalCount(i)+" Feature",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {            
                    ws.bloader('.ivContentbloader',1);  
                    ws.ajax('/acp/DoDelProductFeature/'+i+'/'+p,function (res){
                        var part = JSON.parse(res);
                        ws.swal({title:"Service/Product Feature",text:part.message,type:part.status});
                        if(part.status == 'success')
                        {
                            ws.GetProductFeaturesList(p);
                        }                
                     ws.bloader('.ivContentbloader',2);  
                    });
            });
        },
        DoSaveProductFeature : function(f,p=0)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.f('/acp/DoSaveProductFeature/',f,function(res){
                var part = JSON.parse(res);
                ws.swal({title:"Service/Product Feature",text:part.message,type:part.status});
                ws.bloader('.ivContentbloader',2);  
                if(part.status == 'success')
                {
                    var fid = $(".ws-input-fid").val();
                    if(fid == 0){
                        var nextNum = $(".ws-input-orderby").val();
                        nextNum++;
                        $(".ws-input-orderby").val(nextNum);
                    }
                    ws.GetProductFeaturesList(p);
                }
            });
            return false;
        },
        addon_info_edit : function(f,i)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.f('/acp/addon_info_edit/'+i,f,function(res){
                var part = JSON.parse(res);
                ws.swal({title:"Addon",text:part.message,type:part.status});
                ws.bloader('.ivContentbloader',2);  
                if(part.status == 'success'){
                    window.location="/admin/products-addons-create/"+part.id;
                }
            });
            return false;
        },
        cp_account_search_clients : function (i,v){
             clearTimeout(ws.typingTimer);
            if (v){ws.typingTimer = setTimeout(function(){
            ws.loading('.clients_list_to_transfer','Clients Searching .....');                      
            ws.ajax('/acp/cp_account_search_clients/'+i+'/'+v,function (data){
            $('.clients_list_to_transfer').html(data).show();
            });
            }, ws.doneTypingInterval); }else{
                $('.clients_list_to_transfer').html('').hide();
            }
        },
        cp_account_upgrade_downgrade_calculations : function (i){
            var plan = $('.newProductServicePlan').val();
            var promo = $('.newProductServicePromo').val();
            this.loading('.newProductServiceCaculations','Calculations Loading.....');                      
            ws.ajax('/acp/cp_account_upgrade_downgrade_calculation/'+i+'/'+plan+'/'+promo,function (data){
            $('.newProductServiceCaculations').html(data);
            });
        },
        cp_account_upgrade_downgrade_order : function (e){
             ws.bloader('.ivContentbloader',1);
             ws.f('/acp/cp_account_upgrade_downgrade_order',e,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == 'success') window.setTimeout(function(){location.reload();}, 2000);
                 ws.bloader('.ivContentbloader',2);  
             });
        },
        cp_account_ssl_check : function (){
            var domain = $('.idomain_name').val();               
            this.loading('.cp_account_ssl_check','SSL Checking.....');                      
            ws.ajax('/acp/cp_account_ssl_check?domain='+domain,function (data){
            $('.cp_account_ssl_check').html(data);
            $('[data-popup="popover"]').popover();
            });
        },
        re_validate_ssls : function (){
             ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/cp_ssl_cheking',function (data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == 'success') window.setTimeout(function(){location.reload();}, 2000);
                 ws.bloader('.ivContentbloader',2);  
            });
        },
        cp_account_change_pkg_form : function (i)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/cp_account_change_pkg_form/'+i,function (data){
             ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'S');
            });
        },
        cp_account_change_pkg : function (e){
             ws.bloader('.ivContentbloader',1);
             ws.f('/acp/cp_account_change_pkg',e,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == 'success') window.setTimeout(function(){location.reload();}, 2000);
                 ws.bloader('.ivContentbloader',2);  
             });
        },
        cp_account_change_pwd : function (i){
             ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/cp_account_change_pwd/'+i,function (data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == 'success') window.setTimeout(function(){location.reload();}, 2000);
             ws.bloader('.ivContentbloader',2);  
            });
        },
        ActionsInQueueForm : function (i=0){
            ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/ActionsInQueueForm/'+i,function (data){
            ws.modal(data,'L');
             ws.bloader('.ivContentbloader',2);  
            });
        },
        module_queue_action : function (i,t)
        {
            if(t == "resolved")
            {
             ws.swal({
                    title: "Mark as Resolved",
                    text: "Click at OK button to Marked as Resolved",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                    ws.bloader('.ivContentbloader',1);
                    ws.ajax('/acp/module_queue_action/'+i+'/'+t,function (data){
                        var part = JSON.parse(data);                           
                        ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                        if(part.status == 'success')
                        {
                            $("#queue-"+i).remove();
                        }
                     ws.bloader('.ivContentbloader',2);  
                    });
                });
            }else{
            ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/module_queue_action/'+i+'/'+t,function (data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == 'success')
                {
                    $("#queue-"+i).remove();
                }
             ws.bloader('.ivContentbloader',2);  
            });
            }
        },
        affiliate_commission_delete : function(i)
        {
             ws.swal({
                    title: "Delete",
                    text: "Click at OK button to Delete",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                 ws.bloader('.ivContentbloader',1);
                 ws.ajax('/acp/affiliate_commission_delete/'+i,function(data){
                    var part = JSON.parse(data);                           
                    ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                    if(part.status == 'success') window.setTimeout(function(){location.reload();}, 2000);
                     ws.bloader('.ivContentbloader',2);  
                 });
            });
        },
        affiliate_widthrawal_add : function (e){
             ws.bloader('.ivContentbloader',1);
             ws.f('/acp/affiliate_widthrawal_add',e,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == 'success') window.setTimeout(function(){location.reload();}, 2000);
                 ws.bloader('.ivContentbloader',2);  
             });
        },
        affiliate_manual_commission_add : function (e){
             ws.bloader('.ivContentbloader',1);
             ws.f('/acp/affiliate_manual_commission_add',e,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == 'success') window.setTimeout(function(){location.reload();}, 2000);
                 ws.bloader('.ivContentbloader',2);  
             });
        },
        affiliate_user_setings : function (e){
             ws.bloader('.ivContentbloader',1);
             ws.f('/acp/affiliate_user_setings',e,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == 'success') window.setTimeout(function(){location.reload();}, 2000);
                 ws.bloader('.ivContentbloader',2);  
             });
        },
        affiliate_application_verification : function (e){
             ws.bloader('.ivContentbloader',1);
             ws.f('/acp/affiliate_application_verification',e,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == 'success') window.setTimeout(function(){location.reload();}, 2000);
                 ws.bloader('.ivContentbloader',2);  
             });
        },
        cart_user_id:0,
        cart_init : function (user){
            this.cart_user_id=user;
        },
        get_cart_summary : function(user){                
             ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/get_cart_summary/'+user,function (data){
                $('.get_cart_summary').html(data);
             ws.bloader('.ivContentbloader',2);  
            });
        },
        get_cart_items : function(user){                
             ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/get_cart_items/'+user,function (data)
            {
                $('.get_cart_items').html(data);
             ws.bloader('.ivContentbloader',2);  
            });
        },
        cart_validate_promo_code : function(i){
             ws.bloader('.ivContentbloader',1);  
             if(i){
            ws.ajax('/acp/cart_validate_promo_code/'+ws.cart_user_id+'/'+i,function (data){
                var part = JSON.parse(data);    
                    ws.notify('info',part.message);                                                        
                    ws.get_cart_summary(ws.cart_user_id);
                    ws.get_cart_items(ws.cart_user_id);
                    ws.bloader('.ivContentbloader',2);  
            });
            }
        },
        cart_update_payment_method : function(i){
             ws.bloader('.ivContentbloader',1);  
             if(i){
            ws.ajax('/acp/cart_update_payment_method/'+ws.cart_user_id+'/'+i,function (data){
                var part = JSON.parse(data);    
                    ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                    ws.bloader('.ivContentbloader',2);  
            });
            }
        },
        cart_domain_additional_info_save : function (e){
             ws.bloader('.ivContentbloader',1);
             ws.f('/client/ajax?action=cart_domain_additional_info_save',e,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == 'success') ws.get_cart_items(ws.cart_user_id);
                 ws.bloader('.ivContentbloader',2);
             });
        },
        cart_place_order : function (){
            var moc = ($('#mailOrderConfirm:checked').val() == 'YES') ? 'YES':'NO';
            var gi = ($('#generateInvoice:checked').val() == 'YES') ? 'YES':'NO';
            var mis = ($('#mailInvoice:checked').val() == 'YES') ? 'YES':'NO';
            var pmo = $('#paymentOrderMethod :selected').val();
            ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/cart_place_order/'+ws.cart_user_id+'/'+moc+'/'+gi+'/'+mis+'/'+pmo,function (data){
                var part = JSON.parse(data);    
                    ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});   
                    if(part.status == 'success') window.setTimeout(function(){window.location='/admin/orders-view/'+part.order_no;}, 1000);
                    ws.bloader('.ivContentbloader',2);  
            });
        },
        cart_process_order : function (e){
             ws.bloader('.ivContentbloader',1);
             ws.f('/acp/cart_process_order',e,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == 'success') window.setTimeout(function(){location.reload();}, 1000);
                 ws.bloader('.ivContentbloader',2);  
             });
        },
        cart_ip_baned : function (ip){
            ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/do_ip_baned/'+ip,function (data){
                var part = JSON.parse(data);    
                    ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});   
                    ws.bloader('.ivContentbloader',2);  
            });
        },
        cart_product_duration : function (u,i){
            $("#ConfigOtherOptions, #ProductDurationOptions").html('');
            this.loading2('.whmbcsloaderIcons','Request Inprocess......');
            ws.ajax('/acp/cart-product-duration/'+i+'/'+u,function (data){
                $("#ProductDurationOptions").html(data);
                var optionCount = $('#ProductDurationOptions option').length;
                if(optionCount == 1)
                {
                    $("#ws-billing-cycles-id").attr("href","/admin/products-edit/"+i);
                    $(".ws-billing-cycles").removeClass("hide");
                    $(".ws-billing-cycle-section").addClass("hide");
                }else{
                    $(".ws-billing-cycles").addClass("hide");
                    $(".ws-billing-cycle-section").removeClass("hide");                    
                }
                ws.loading2('.whmbcsloaderIcons','');
            });
        },
        cart_config_options : function (u,d){
            var i = $('#ProductOptions').val();
            this.loading2('.whmbcsloaderIcons','Request Inprocess......');
            ws.ajax('/acp/cart-config-options/'+u+'/'+i+'/'+d,function (data){                           
                $("#ConfigOtherOptions").html(data);
                ws.loading2('.whmbcsloaderIcons','');
            });
        },
        update_cart_billing_cycle : function (i,c){
             ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/cart_update_billing_cycle/'+ws.cart_user_id+'/'+i+'/'+c,function (data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
//                            ws.validate_promo_code();   
                ws.get_cart_summary(ws.cart_user_id);
                ws.get_cart_items(ws.cart_user_id);
                ws.bloader('.ivContentbloader',2);  
            });
        },
        update_cart_domain : function (i,d){
             ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/cart_update_domain/'+ws.cart_user_id+'/'+i+'/'+d,function (data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
//                            ws.validate_promo_code();   
                ws.get_cart_summary(ws.cart_user_id);
                ws.get_cart_items(ws.cart_user_id);
                ws.bloader('.ivContentbloader',2);  
            });
        },
        update_cart_server_configs : function (e){
             ws.bloader('.ivContentbloader',1);
             ws.f('/acp/cart_update_server_configs',e,function(data){
                var part = JSON.parse(data);                           
                    ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                ws.get_cart_summary(ws.cart_user_id);
                ws.get_cart_items(ws.cart_user_id);
                 ws.bloader('.ivContentbloader',2);  
             });
        },
        domain_info_save : function (e){
             ws.bloader('.ivContentbloader',1);
             ws.f('/acp/domain_info_save',e,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == 'success') window.setTimeout(function(){location.reload();}, 2000);
                 ws.bloader('.ivContentbloader',2);  
             });
        },
        domain_spotlights : function (d,i){
            this.loading('.domain_spotlights','Domain TLDs Loading.....');
            ws.ajax('/acp/cart_domain_spotlights/'+ws.cart_user_id+'/'+d+'/'+i,function (data){
                $('.domain_spotlights').html(data);   
            });
        },
        cart_product_id : 0,
        product_id_for_domain : function (i){
            ws.cart_product_id=i;
            ws.cart_add_domain_form(i);
        },
        domain_register : function (e){
            $('.domain_spotlights,.domain-status').html(''); 
             ws.bloader('.ivContentbloader',1);
             ws.f('/acp/cart_domain_register',e,function(data){
                   $('.domain-status').html(data);
                    ws.domain_spotlights($('#rdomain').val(),$('#rhosting').val());
                    ws.bloader('.ivContentbloader',2);
             });
        },
        cart_add_domain_form:function(i=0)
        {
            ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/cart_add_domain_form/'+ws.cart_user_id+'/'+i,function (data)
            {
                ws.modal(data,'M');
                ws.bloader('.ivContentbloader',2);
            });
        },
        cart_add_domain : function (d,i){
            if(i == 0) i=ws.cart_product_id;
            ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/cart_add_domain/'+ws.cart_user_id+'/'+d+'/'+i,function (data){
                var part = JSON.parse(data);                           
                    ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                    if(part.status == 'success')
                    {
                        ws.cart_product_id=0;
                        ws.get_cart_summary(ws.cart_user_id);
                        ws.get_cart_items(ws.cart_user_id);
                        ws.modal('','N');
                    }
                    ws.bloader('.ivContentbloader',2);
            });
        },
        domain_reseller_module_save : function (e)
        {
             ws.bloader('.ivContentbloader',1);
             ws.f('/acp/domain_reseller_module_save',e,function(data)
             {
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == "success")
                {
                    window.setTimeout(function()
                    {
                        ws.modal("","N");
                        $(".domain-reseller-module-form-btn").click();
                    }, 2000);
                }
                ws.bloader('.ivContentbloader',2);
             });
        },
        product_reseller_module_save : function (e)
        {
             ws.bloader('.ivContentbloader',1);
             ws.f('/acp/product_reseller_module_save',e,function(data)
             {
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == "success")
                {
                    window.setTimeout(function()
                    {
                        ws.modal("","N");
                        $(".product-reseller-module-form-btn").click();
                    }, 2000);
                }
                ws.bloader('.ivContentbloader',2);
             });
        },
        cart_tfr_domain_form:function(i=0)
        {
            ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/cart_tfr_domain_form/'+ws.cart_user_id+'/'+i,function (data)
            {
                ws.modal(data,'M');
                ws.bloader('.ivContentbloader',2);
            });
        },
        cart_domain_transfer : function (e){
             ws.bloader('.ivContentbloader',1);
             ws.f('/acp/cart_domain_transfer',e,function(data){
                    $('.domain-transfer-status').html(data);
                    ws.bloader('.ivContentbloader',2);
             });
        },
        domain_transfer_to_us : function (e){
             ws.bloader('.ivContentbloader',1);
             ws.f('/acp/domain_transfer_to_us',e,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status=='success'){
                    ws.modal('','N');
                    ws.get_cart_summary(ws.cart_user_id);
                    ws.get_cart_items(ws.cart_user_id);
                }    
                ws.bloader('.ivContentbloader',2);                            
             });
        },
        cart_add_item_form:function(i=0)
        {
            ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/cart_add_item_form/'+ws.cart_user_id,function (data)
            {
                ws.modal(data,'M');
                ws.bloader('.ivContentbloader',2);
            });
        },
        cart_add_item_save : function (e){
             ws.bloader('.ivContentbloader',1);
             ws.f('/acp/cart_add_item_save',e,function(data){
                var part = JSON.parse(data);                           
                    ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status=='success')
                {
                    ws.modal('','N');
                    ws.get_cart_summary(ws.cart_user_id);
                    ws.get_cart_items(ws.cart_user_id);
                    ws.product_id_for_domain(part.id);
                }    
                ws.bloader('.ivContentbloader',2);  
             });
             return false;
        },
        update_cart_config_options : function (i,g,c){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/cart_update_config_options/'+ws.cart_user_id+'/'+i+'/'+g+'/'+c,function (data){
                var part = JSON.parse(data);                           
                    ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                    ws.get_cart_summary(ws.cart_user_id);
                    ws.get_cart_items(ws.cart_user_id);
                    ws.bloader('.ivContentbloader',2);  
            });
        },
        update_cart_addons_options : function (i,g,c){
             var addRemove = (c.checked) ? 'Add':'Del';
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/update_cart_addons_options/'+ws.cart_user_id+'/'+i+'/'+g+'/'+addRemove,function (data){
                var part = JSON.parse(data);                           
                    ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                    ws.get_cart_summary(ws.cart_user_id);
                    ws.get_cart_items(ws.cart_user_id);
                    ws.bloader('.ivContentbloader',2);  
            });
        },
        del_cart_item : function(i)
        {
         ws.swal({
                    title: "Delete",
                    text: "Click at OK button to Delete",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "#ff0000",
                    showLoaderOnConfirm: true
                },
                function() {
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/cart_del_item/'+i,function (data){
                    var part = JSON.parse(data);                           
                    ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                    ws.get_cart_summary(ws.cart_user_id);
                    ws.get_cart_items(ws.cart_user_id);
                    ws.bloader('.ivContentbloader',2);  
                });
            });
        },
        get_products_from_cart : function(){                
             ws.bloader('.ivContentbloader',1);  
            ws.ajax('get_products_from_cart',function (data){
                $('.get_cart_notification').html(data);
             ws.bloader('.ivContentbloader',2);  
            });
        },
        dashboard_url :"",
        admin_dashboard : function (aAction="")
        {
            if(aAction.length<1) aAction = ws.get("aAction");
            if(aAction.length<1) aAction = "General";
            ws.set("aAction",aAction);
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/dashboards/'+aAction,function (data)
            {
                $(".ws-admin-dashboards").html(data);
                ws.bloader('.ivContentbloader',2);
            });
        },
        support_predifined_reply_categories : function(){
             ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/support_predifined_reply_categories/',function (data){
                $('.support_predifined_reply_categories').html(data);
                var id = location.hash;
                var itemId = id.substring(1, id.length);
                ws.support_predifined_reply_list(itemId);
             ws.bloader('.ivContentbloader',2);  
            });
        },
        support_predifined_reply_cat_form : function (i)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/support_predifined_reply_cat_form/'+i,function (data){
             ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'S');
            });
        },
        support_predifined_reply_cat_delete : function(i){
         ws.swal({
                    title: "Delete Category",
                    text: "Click at OK button to Delete Category",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "#ff0000",
                    showLoaderOnConfirm: true
                },
                function() {
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/support_predifined_reply_cat_delete/'+i,function (data){
                var part = JSON.parse(data);
                if(part[0] == 1){
                 location.hash = i;
                }
                    ws.support_predifined_reply_categories();                                                                
                    ws.swal({
                            type:part.status,
                            title: part[1],
                            confirmButtonColor: "#2196F3"
                        });
                ws.bloader('.ivContentbloader',2);  
                });
                });
        },
        support_predifined_reply_categories_ordering : function (){
            var cat_ids = $('.kb-row-cat').map(function(){return $(this).attr('did');}).get(); 
             ws.bloader('.ivContentbloader',1);
            var e = $('<form/>').append($('<input/>', {name: 'Ordering'}).val(cat_ids));
            ws.fs('/acp/support_predifined_reply_categories_ordering/',e,function(data){
                var part = JSON.parse(data);
                if(part[0] == 1){
                    ws.support_predifined_reply_categories();
                }
                ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});                            
                ws.bloader('.ivContentbloader',2);
            });
        },                                        
        support_predifined_reply_article_form : function (i){
            var hash = document.URL.substr(document.URL.indexOf('#')+1);
            var catId = (Number(hash)>0) ? Number(hash):0;
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/support_predifined_reply_article_form/'+i+'/'+catId,function (data){
             ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'L');
            });
        },
        support_predifined_reply_cat_add_edit : function (e){
             ws.bloader('.ivContentbloader',1);
             ws.fs('/acp/support_predifined_reply_cat_add_edit/',$(e),function(data){
                var part = JSON.parse(data);
                if(part[0] == 1){
                    ws.modal('','N');  
                        ws.support_predifined_reply_categories();
                    $("#whmbcs-clear-form").click();                                   
                }
                ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});
                 ws.bloader('.ivContentbloader',2);
            });
        },
        support_predifined_reply_article_add_edit : function (e){
             ws.bloader('.ivContentbloader',1);
             ws.fs('/acp/support_predifined_reply_article_add_edit/',$(e),function(data){
                var part = JSON.parse(data);
                if(part[0] == 1){
                    ws.modal('','N');  
                        ws.support_predifined_reply_categories();
                    $("#whmbcs-clear-form").click();                                   
                }
                ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});                            
                 ws.bloader('.ivContentbloader',2);
            });
        },
        support_predifined_reply_article_delete : function(i){
         ws.swal({
                    title: "Delete Article",
                    text: "Click at OK button to Delete Article",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "#ff0000",
                    showLoaderOnConfirm: true
                },
                function() {

                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/support_predifined_reply_article_delete/'+i,function (data){
                var part = JSON.parse(data);
                ws.support_predifined_reply_categories();
                    ws.swal({
                            title: part[1],
                            confirmButtonColor: "#2196F3"
                        });                                                               

                ws.bloader('.ivContentbloader',2);  
                });
                });
        },

        support_predifined_reply_list : function(i){
            $(".kb-row-cat").removeClass('active');
            $(".kb-row-"+i).addClass('active');
            location.hash = i;
            if(i>0){
                $(".ws-add-new-reply-btn").removeClass('hide');
            }else{
                $(".ws-add-new-reply-btn").addClass('hide');
            }                        
             ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/support_predifined_reply_list/'+i,function (data){
                $('.support_predifined_reply_list').html(data);
             ws.bloader('.ivContentbloader',2);  
            });
        },
        support_predifined_articles_ordering : function (){
            var article_ids = $('.article-rows').map(function(){return $(this).attr('did');}).get(); 
             ws.bloader('.ivContentbloader',1);
            var e = $('<form/>').append($('<input/>', {name: 'Ordering'}).val(article_ids));
            ws.fs('/acp/support_predifined_articles_ordering/',e,function(data){
                var part = JSON.parse(data);
                if(part[0] == 1){
                    ws.support_knowledgebase_categories();
                }
                ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});                            
                 ws.bloader('.ivContentbloader',2);
            });
        },                                        
        support_knowledgebase_categories : function(){
             ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/support_knowledgebase_categories/',function (data){
                $('.support_knowledgebase_categories').html(data);
                var id = location.hash;
                var itemId = id.substring(1, id.length);
                ws.support_knowledgebase_list(itemId);
             ws.bloader('.ivContentbloader',2);  
            });
        },
        support_knowledgebase_list : function(i){
            $(".kb-row-cat").removeClass('active');
            $(".kb-row-"+i).addClass('active');
            location.hash = i;
            if(i>0){
                $(".ws-add-article-btn").removeClass('hide');
            }else{
                $(".ws-add-article-btn").addClass('hide');
            }
             ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/support_knowledgebase_list/'+i,function (data){
                $('.support_knowledgebase_list').html(data);
             ws.bloader('.ivContentbloader',2);  
            });
        },
        support_knowledgebase_cat_form : function (i)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/support_knowledgebase_cat_form/'+i,function (data){
             ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'S');
            });
        },
        support_knowledgebase_cat_add_edit : function (e){
             ws.bloader('.ivContentbloader',1);
             ws.fs('/acp/support_knowledgebase_cat_add_edit/',$(e),function(data){
                var part = JSON.parse(data);
                if(part[0] == 1){
                    ws.modal('','N');  
                        ws.support_knowledgebase_categories();
                    $("#whmbcs-clear-form").click();                                   
                }
                ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});                            
                 ws.bloader('.ivContentbloader',2);
            });
        },
        support_knowledgebase_cat_delete : function(i){
         ws.swal({
                    title: "Delete Category",
                    text: "Click at OK button to Delete Category",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "#ff0000",
                    showLoaderOnConfirm: true
                },
                function() {

                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/support_knowledgebase_cat_delete/'+i,function (data){
                var part = JSON.parse(data);
                if(part[0] == 1){
                 location.hash = i;
                }
                    ws.support_knowledgebase_categories();                                                                
                    ws.swal({
                            title: part[1],
                            confirmButtonColor: "#2196F3"
                        });                                                               

                ws.bloader('.ivContentbloader',2);  
                });
                });
        },
        support_knowledgebase_articles_ordering : function (){
            var article_ids = $('.article-rows').map(function(){return $(this).attr('did');}).get(); 
             ws.bloader('.ivContentbloader',1);
            var e = $('<form/>').append($('<input/>', {name: 'Ordering'}).val(article_ids));
            ws.fs('/acp/support_knowledgebase_articles_ordering/',e,function(data){
                var part = JSON.parse(data);
                if(part[0] == 1){                                    
                    ws.support_knowledgebase_categories();
                }
                ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});                            
                 ws.bloader('.ivContentbloader',2);
            });
        },
        support_knowledgebase_categories_ordering : function (){
            var cat_ids = $('.kb-row-cat').map(function(){return $(this).attr('did');}).get();
             ws.bloader('.ivContentbloader',1);
            var e = $('<form/>').append($('<input/>', {name: 'Ordering'}).val(cat_ids));
            ws.fs('/acp/support_knowledgebase_categories_ordering/',e,function(data){
                var part = JSON.parse(data);
                if(part[0] == 1){                                    
                    ws.support_knowledgebase_categories();
                }
                ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});                            
                 ws.bloader('.ivContentbloader',2);
            });
        },
        support_knowledgebase_article_form : function (i){
            //var hash = window.location.hash;
            var hash = document.URL.substr(document.URL.indexOf('#')+1);
            var catId = (Number(hash)>0) ? Number(hash):0;
             ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/support_knowledgebase_article_form/'+i+'/'+catId,function (data){
             ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'L');
            });
        },
        support_knowledgebase_article_add_edit : function(e){
             ws.bloader('.ivContentbloader',1);
             $("#editor-full").val($(".note-editable").html());
             ws.fs('/acp/support_knowledgebase_article_add_edit/',$(e),function(data){
                var part = JSON.parse(data);
                if(part[0] == 1){                                    
                    ws.modal('','N');  
                        ws.support_knowledgebase_categories();
                    $("#whmbcs-clear-form").click();                                   
                }
                ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});                            
                 ws.bloader('.ivContentbloader',2);
            });
        },
        support_knowledgebase_article_delete : function(i){
         ws.swal({
                    title: "Delete Article",
                    text: "Click at OK button to Delete Article",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "#ff0000",
                    showLoaderOnConfirm: true
                },
                function() {
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/support_knowledgebase_article_delete/'+i,function (data){
                    var part = JSON.parse(data);
                    ws.support_knowledgebase_categories();
                    ws.swal({
                            title: part[1],
                            confirmButtonColor: "#2196F3"
                    });
                    ws.bloader('.ivContentbloader',2);  
                });
            });
        },                                        
        support_downloads_categories : function(){
             ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/support_downloads_categories/',function (data){
                $('.support_downloads_categories').html(data);
                var id = location.hash;
                var itemId = id.substring(1, id.length);
                ws.support_downloads_list(itemId);
             ws.bloader('.ivContentbloader',2);  
            });
        },
        support_downloads_list : function(i){
            $(".kb-row-cat").removeClass('active');
            $(".kb-row-"+i).addClass('active');
            location.hash = i;
             ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/support_downloads_list/'+i,function (data){
                $('.support_downloads_list').html(data);
             ws.bloader('.ivContentbloader',2);  
            });
        },
        support_downloads_cat_form : function (i)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/support_downloads_cat_form/'+i,function (data){
             ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'S');
            });
        },
        support_downloads_cat_add_edit : function (e){
             ws.bloader('.ivContentbloader',1);
             ws.fs('/acp/support_downloads_cat_add_edit/',$(e),function(data){
                var part = JSON.parse(data);
                if(part.status == 'success'){
                        $(".whmbcs-model-content > .modal-header > .close").click();
                        //ws.modal('','N');  
                        ws.support_downloads_categories();
                        $("#whmbcs-clear-form").click();                                   
                }
                 ws.bloader('.ivContentbloader',2);
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});                            
            });
        },
        support_downloads_cat_delete : function(i){
         ws.swal({
                    title: "Delete Category",
                    text: "Click at OK button to Delete Category",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "#ff0000",
                    showLoaderOnConfirm: true
                },
                function() {
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/support_downloads_cat_delete/'+i,function (data){
                var part = JSON.parse(data);
                if(part[0] == 1){
                 location.hash = i;
                }
                    ws.support_downloads_categories();                                                                
                    ws.swal({
                            title: part[1],
                            confirmButtonColor: "#2196F3"
                        });
                ws.bloader('.ivContentbloader',2);  
                });
                });
        },
        support_downloads_file_ordering : function (){
            var article_ids = $('.article-rows').map(function(){return $(this).attr('did');}).get();
             ws.bloader('.ivContentbloader',1);
            var e = $('<form/>').append($('<input/>', {name: 'Ordering'}).val(article_ids));
            ws.fs('/acp/support_downloads_file_ordering/',e,function(data){
                var part = JSON.parse(data);
                if(part[0] == 1){                                    
                    ws.support_downloads_categories();
                }
                ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});                            
                 ws.bloader('.ivContentbloader',2);
            });
        },
        support_downloads_categories_ordering : function (){
            var cat_ids = $('.kb-row-cat').map(function(){return $(this).attr('did');}).get();
             ws.bloader('.ivContentbloader',1);
            var e = $('<form/>').append($('<input/>', {name: 'Ordering'}).val(cat_ids));
            ws.fs('/acp/support_downloads_categories_ordering/',e,function(data){            
                var part = JSON.parse(data);
                if(part[0] == 1){                                    
                    ws.support_downloads_categories();
                }
                ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});                            
                 ws.bloader('.ivContentbloader',2);
            });
        },
        support_downloads_file_form : function (i){
             ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/support_downloads_file_form/'+i,function (data){
             ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'L');
            });
        },
        support_downloads_file_add_edit : function(){
            var bar = $('#bar');
                var percent = $('#percent');
                $('#upload_downloads_file').ajaxForm({
                    beforeSubmit: function() {
                        document.getElementById("progress_div").style.display="block";
                        var percentVal = '0%';
                        bar.width(percentVal)
                        percent.html(percentVal);
                    },
                    uploadProgress: function(event, position, total, percentComplete) {
                        var percentVal = percentComplete + '%';
                        bar.width(percentVal)
                        percent.html('uploading '+percentVal);
                    },
                    success: function() {
                        var percentVal = '100%';
                        bar.width(percentVal)
                        percent.html(percentVal);
                    },
                    complete: function(xhr) {
                        if(xhr.responseText)
                        {
                            var part = JSON.parse(xhr.responseText);
                            ws.swal({ title: "Downloads File",text:part[1], confirmButtonColor: "#2196F3", type: (part[0] == 1) ? 'success':'error' });
                            if(part[0] == 1)
                                {
                                    ws.support_downloads_categories();
                                    ws.modal('','N');
                                }
                        }
                    }
                });                          
        },
        support_downloads_file_delete : function(i){
         ws.swal({
                    title: "Delete File",
                    text: "Click at OK button to Delete File",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "#ff0000",
                    showLoaderOnConfirm: true
                },
                function() {

                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/support_downloads_file_delete/'+i,function (data){
                var part = JSON.parse(data);
                ws.support_downloads_categories();
                    ws.swal({
                            title: part[1],
                            confirmButtonColor: "#2196F3"
                        });
                    if(part[0] == 1){ws.support_downloads_categories();}
                ws.bloader('.ivContentbloader',2);  
                });
                });
        },
        support_announcements : function(){
             ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/support_announcements_list/',function (data){
                $('.support_announcements_list').html(data);
             ws.bloader('.ivContentbloader',2);  
            });
        },
        support_announcements_form : function (i)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/support_announcements_form/'+i,function (data){
             ws.bloader('.ivContentbloader',2);  
             ws.modal(data,'L');
            });
        },
        support_announcements_view : function (i)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/support_announcements_view/'+i+'/',function (data){
             ws.bloader('.ivContentbloader',2);  
             ws.modal(data,'L');
            });
        },
        support_announcements_add_edit : function(e){
             ws.bloader('.ivContentbloader',1);
             $("#editor-full").val($(".note-editable").html());
             ws.fs('/acp/support_announcements_add_edit/',$(e),function(data){
                var part = JSON.parse(data);
                if(part[0] == 1){                                    
                    ws.modal('','N');  
                        ws.support_announcements();
                    $("#whmbcs-clear-form").click();                                   
                }
                ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});                            
                 ws.bloader('.ivContentbloader',2);
            });
        },
        support_announcements_delete : function(i){
         ws.swal({
                    title: "Delete Announcement",
                    text: "Click at OK button to Delete Announcement",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "#ff0000",
                    showLoaderOnConfirm: true
                },
                function() {

                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/support_announcements_delete/'+i,function (data){
                var part = JSON.parse(data);
                if(part[0] == 1){
                    ws.support_announcements();                                                                
                }
                    ws.swal({
                            title: part[1],
                            confirmButtonColor: "#2196F3"
                        });                                                               

                ws.bloader('.ivContentbloader',2);  
                });
                });
        },
        support_network_issues : function(){
             ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/support_network_issues_list/',function (data){
                $('.support_network_issues_list').html(data);
             ws.bloader('.ivContentbloader',2);  
            });
        },
        support_network_issues_form : function (i)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/support_network_issues_form/'+i,function (data){
             ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'L');
            });
        },
        support_network_issues_view : function (i)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/support_network_issues_view/'+i+'/',function (data){
             ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'L');
            });
        },
        support_network_issues_add_edit : function(e){
             ws.bloader('.ivContentbloader',1);
             $("#editor-full").val($(".note-editable").html());
             ws.fs('/acp/support_network_issues_add_edit/',$(e),function(data){
                var part = JSON.parse(data);
                if(part[0] == 1){                                    
                    ws.modal('','N');  
                        ws.support_network_issues();
                    $("#whmbcs-clear-form").click();                                   
                }
                ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});                            
                 ws.bloader('.ivContentbloader',2);
            });
        },
        support_network_issues_delete : function(i){
         ws.swal({
                    title: "Delete Network Issue",
                    text: "Click at OK button to Delete Network Issue",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "#ff0000",
                    showLoaderOnConfirm: true
                },
                function() {

                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/support_network_issues_delete/'+i,function (data){
                var part = JSON.parse(data);
                if(part[0] == 1){
                    ws.support_network_issues();                                                                
                }
                    ws.swal({
                            title: part[1],
                            confirmButtonColor: "#2196F3"
                        });                                                               

                ws.bloader('.ivContentbloader',2);  
                });
                });
        },
        ConfigurableGroupOptionDelete : function (i)
        {
             ws.swal({
                    title: "Delete",
                    text: "Click at OK button to Delete",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                    ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/ConfigurableGroupOptionDelete/'+i,function (data)
                {
                    var part = JSON.parse(data);
                    ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
    
                    if(part.status == "success")
                    {
                        $(".ws-group-option-row-"+i).remove();
                    }                            
                     ws.bloader('.ivContentbloader',2);
                });
            });
        },
        ConfigurableGroupOptionChildDelete : function (i)
        {
             ws.swal({
                    title: "Delete",
                    text: "Click at OK button to Delete",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                    ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/ConfigurableGroupOptionChildDelete/'+i,function (data)
                {
                    var part = JSON.parse(data);
                    ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
    
                    if(part.status == "success") location.reload();    
                     ws.bloader('.ivContentbloader',2);
                });
            });
        },
        ConfigurableGroupDelete : function (i)
        {
             ws.swal({
                    title: "Delete",
                    text: "Click at OK button to Delete",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                    ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/ConfigurableGroupDelete/'+i,function (data)
                {
                    var part = JSON.parse(data);
                    ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                    if(part.status == "success")
                    {
                        $(".ws-group-row-"+i).remove();
                    }                            
                     ws.bloader('.ivContentbloader',2);
                });
            });
        },
        ConfigurableGroupForm : function (i){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/ConfigurableGroupForm/'+i,function (data)
            {
                 ws.bloader('.ivContentbloader',2);  
                ws.modal(data,'S');
            });
        },
        ConfigurableGroupSave : function (e){
            ws.bloader('.ivContentbloader',1);
            ws.f('/acp/ConfigurableGroupSave',e,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                ws.bloader('.ivContentbloader',2);  
                if(part.status=="success") location.reload();
             });
             return false;
        },
        ConfigurableGroupDuplicateForm : function (i){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/ConfigurableGroupDuplicateForm/'+i,function (data)
            {
                 ws.bloader('.ivContentbloader',2);  
                ws.modal(data,'L');
            });
        },
        ConfigurableGroupDuplicateSave : function (e){
            ws.bloader('.ivContentbloader',1);
            ws.f('/acp/ConfigurableGroupDuplicateSave',e,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                ws.bloader('.ivContentbloader',2);  
                if(part.status=="success") location.reload();
             });
             return false;
        },
        ConfigurableGroupOptionForm : function (g,o){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/ConfigurableGroupOptionForm/'+g+'/'+o,function (data)
            {
                 ws.bloader('.ivContentbloader',2);  
                ws.modal(data,'S');
            });
        },
        ConfigurableGroupOptionSave : function (e){
            ws.bloader('.ivContentbloader',1);
            ws.f('/acp/ConfigurableGroupOptionSave',e,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                ws.bloader('.ivContentbloader',2);  
                if(part.status=="success") location.reload();
             });
             return false;
        },
        ConfigurableGroupOptionChildForm : function (o,c){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/ConfigurableGroupOptionChildForm/'+o+'/'+c,function (data)
            {
                 ws.bloader('.ivContentbloader',2);  
                ws.modal(data,'S');
            });
        },
        ConfigurableGroupOptionChildSave : function (e){
            ws.bloader('.ivContentbloader',1);
            ws.f('/acp/ConfigurableGroupOptionChildSave',e,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                ws.bloader('.ivContentbloader',2);  
                if(part.status=="success") location.reload();
             });
             return false;
        },
        ConfigurableGroupOptionPricingForm : function (g,o){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/ConfigurableGroupOptionPricingForm/'+g+'/'+o,function (data)
            {
                 ws.bloader('.ivContentbloader',2);  
                ws.modal(data,'L');
            });
        },
        LicenseInformationForm : function (){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/LicenseInformationForm/',function (data)
            {
                 ws.bloader('.ivContentbloader',2);  
                ws.modal(data,'S');
            });
        },
        DisableTwoFaForm : function (){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/disable_two_fa_form/',function (data)
            {
                 ws.bloader('.ivContentbloader',2);  
                ws.modal(data,'S');
            });
        },
        MyAccountForm : function (){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/my_account_form/',function (data)
            {
                 ws.bloader('.ivContentbloader',2);  
                ws.modal(data,'S');
            });
        },
        Signout : function (){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/logout',function (data)
            {
                ws.bloader('.ivContentbloader',2);  
                if(data == "success") window.location="/admin/signin";
            });
        },
        disable_two_fa_save : function (e){
            ws.bloader('.ivContentbloader',1);
            $(".WsSubmitBtn").hide();
            ws.f('/acp/disable_two_fa_save',e,function(data){
                var part = JSON.parse(data);
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                $(".WsSubmitBtn").show();
                ws.bloader('.ivContentbloader',2);
                if(part.status == "success") ws.modal("",'N');  
             });
             return false;
        },
        MyAccountSave : function (e){
            ws.bloader('.ivContentbloader',1);
            $(".MyAccountSave").hide();
            ws.f('/acp/MyAccountSave',e,function(data){
                var part = JSON.parse(data);
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                $(".MyAccountSave").show();
                ws.bloader('.ivContentbloader',2);  
             });
             return false;
        },
        ProductSlabType:"SERVICES",
        ProductPricesSlabs : function (t="SERVICES")
        {
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/ProductPricesSlabs/'+t,function (data)
            {
                 ws.bloader('.ivContentbloader',2);  
                ws.modal(data,'S');
            });
        },
        ProductPricesSlabsForm : function (i=0,t="SERVICES")
        {
            this.ProductSlabType=t;
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/ProductPricesSlabsForm/'+i+'/'+t,function (data)
            {
                 ws.bloader('.ivContentbloader',2);  
                ws.modal(data,'S');
            });
        },
        ProductPricesSlabsSave : function (e)
        {
            ws.bloader('.ivContentbloader',1);
            ws.f('/acp/ProductPricesSlabsSave',e,function(data)
            {
                var part = JSON.parse(data);
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == "success")
                {
                    ws.modal('','N');
                    ws.ProductPricesSlabs(ws.ProductSlabType);
                }
                ws.bloader('.ivContentbloader',2);  
             });
             return false;
        },
        ProductPricesSlabsDelete : function (i=0,t="SERVICES")
        {
             ws.swal({
                    title: "Delete",
                    text: "Click at OK button to Delete",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function()
                {
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/ProductPricesSlabsDelete/'+i,function (data)
                {
                    var part = JSON.parse(data);                           
                    ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                    if(part.status == "success")
                    {
                        ws.modal('','N');
                        ws.ProductPricesSlabs(t);
                    }
                    ws.bloader('.ivContentbloader',2);
                });
            });
        },
        ProductGroupForm : function (g=0){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/ProductGroupForm/'+g,function (data)
            {
                 ws.bloader('.ivContentbloader',2);  
                ws.modal(data,'S');
            });
        },
        ProductGroupSave : function (e){
            ws.bloader('.ivContentbloader',1);
            ws.f('/acp/ProductGroupSave',e,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == "success") window.setTimeout(function(){window.location="/admin/products-services/";}, 1000);
                ws.bloader('.ivContentbloader',2);  
             });
             return false;
        },
        ProductGroupDelete : function (g=0)
        {
             ws.swal({
                    title: "Delete",
                    text: "Click at OK button to Delete",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/ProductGroupDelete/'+g,function (data)
                {
                    var part = JSON.parse(data);                           
                    ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                    if(part.status == "success"){
                        window.setTimeout(function(){window.location="/admin/products-services/";}, 1000);
                    }
                    ws.bloader('.ivContentbloader',2);
                });
            });
        },
        NewProductForm : function (p=0){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/NewProductForm/'+p,function (data)
            {
                ws.bloader('.ivContentbloader',2);  
                ws.modal(data,'S');
            });
        },
        NewProductSave : function (e){
            ws.bloader('.ivContentbloader',1);
            ws.f('/acp/NewProductSave',e,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == "success") window.setTimeout(function(){window.location="/admin/products-edit/"+part.id;}, 1000);
                ws.bloader('.ivContentbloader',2);  
             });
             return false;
        },
        DuplicateProductForm : function (p=0){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/DuplicateProductForm/'+p,function (data)
            {
                 ws.bloader('.ivContentbloader',2);  
                ws.modal(data,'S');
            });
        },
        DuplicateProductSave : function (e){
            ws.bloader('.ivContentbloader',1);
            ws.f('/acp/DuplicateProductSave',e,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == "success") window.setTimeout(function(){window.location="/admin/products-edit/"+part.id;}, 1000);
                ws.bloader('.ivContentbloader',2);  
             });
             return false;
        },
        deleteProduct : function (p=0)
        {
             ws.swal({
                    title: "Delete",
                    text: "Click at OK button to Delete",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/deleteProduct/'+p,function (data)
                {
                    var part = JSON.parse(data);                           
                    ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                    if(part.status == "success"){
                        window.setTimeout(function(){window.location="/admin/products-services/";}, 1000);
                    }
                    ws.bloader('.ivContentbloader',2);
                });
            });
        },
        ConfigurableGroupOptionPricingSave : function (e){
            ws.bloader('.ivContentbloader',1);
            ws.f('/acp/ConfigurableGroupOptionPricingSave',e,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                ws.bloader('.ivContentbloader',2);  
             });
             return false;
        },
        addons_activate : function (a){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/addons_activate/'+a,function (data){
                var part = JSON.parse(data);
                if(part[0] == 1){                                
                    MpLoadApps(); 
                        //ws.currencies_grid();
                    $("#whmbcs-clear-form").click();                                   
                }
                ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});                            
                 ws.bloader('.ivContentbloader',2);
            });
        },
        addons_deactivate : function (a){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/addons_deactivate/'+a,function (data){
                var part = JSON.parse(data);
                if(part[0] == 1){                                
                    MpLoadApps(); 
                        //ws.currencies_grid();
                    $("#whmbcs-clear-form").click();                                   
                }
                ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});                            
                 ws.bloader('.ivContentbloader',2);
            });
        },
        addons_upload_form : function (){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/addons_upload_form/',function (data){
             ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'S');
            });
        },
        provision_configure_form : function (a){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/provision_configure_form/'+a,function (data){
             ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'S');
            });
        },
        provision_configured : function(e){
             ws.bloader('.ivContentbloader',1);
             ws.f('/acp/provision_configured/',e,function(data){
                var part = JSON.parse(data);
                if(part.status == "success"){                                    
                    ws.modal('','N');  
                    $(".mp-tab-installed-apps > a").click();
                    //location.reload();
                }
                ws.swal({title: part.message,type: part.status,confirmButtonColor: "#2196F3"});                            
                 ws.bloader('.ivContentbloader',2);
            });
        },
        addons_configure_form : function (a){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/addons_configure_form/'+a,function (data){
             ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'S');
            });
        },
        addons_configured : function(e){
             ws.bloader('.ivContentbloader',1);
             ws.fs('/acp/addons_configured/',$(e),function(data){
                var part = JSON.parse(data);
                if(part[0] == 1){                                    
                    ws.modal('','N');  
                    $("#whmbcs-clear-form").click();
                    location.reload();
                }
                ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});                            
                 ws.bloader('.ivContentbloader',2);
            });
        },
        registrar_activate : function (a){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/registrar_activate/'+a,function (data){
                var part = JSON.parse(data);
                ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});
                if(part[0] == 1){
                    MpLoadApps();
                }                            
                 ws.bloader('.ivContentbloader',2);
            });
        },
        registrar_deactivate : function (a){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/registrar_deactivate/'+a,function (data){
                var part = JSON.parse(data);
                ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});
                if(part[0] == 1){
                    MpLoadApps();
                }                            
                 ws.bloader('.ivContentbloader',2);
            });
        },
        registrar_upload_form : function (){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/registrar_upload_form/',function (data){
             ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'S');
            });
        },
        registrar_configure_form : function (a){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/registrar_configure_form/'+a,function (data){
             ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'S');
            });
        },
        registrar_configured : function(e){
             ws.bloader('.ivContentbloader',1);
             ws.fs('/acp/registrar_configured/',$(e),function(data){
                var part = JSON.parse(data);
                if(part[0] == 1){                                    
                    ws.modal('','N');  
                    $("#whmbcs-clear-form").click();
                    location.reload();
                }
                ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});                            
                 ws.bloader('.ivContentbloader',2);
            });
        },
        registrar_eppcode_info : function (i)
        {
            ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/registrar_eppcode_info/'+i,function (data){
            ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'S');
            });
        },
        registrar_auto_renew : function (i,s){
             ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/registrar_auto_renew/'+i+'/'+s,function (data){
                    var part = JSON.parse(data);
                    if(part.status == 'success'){
                        ws.notify('success',part.message);
                        location.reload();
                    }else{
                       ws.notify('error',part.message);                                                             
                    }                            
                     ws.bloader('.ivContentbloader',2);
            });
        },
        registrar_lock : function (i,s){
             ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/registrar_lock/'+i+'/'+s,function (data){
                    var part = JSON.parse(data);
                    if(part.status == 'success'){
                        ws.notify('success',part.message);
                        location.reload();
                    }else{
                       ws.notify('error',part.message);                                                             
                    }                            
                     ws.bloader('.ivContentbloader',2);
            });
        },
        registrar_dns_management : function (i,s){
             ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/registrar_dns_management/'+i+'/'+s,function (data){
                    var part = JSON.parse(data);
                    if(part.status == 'success'){
                        ws.notify('success',part.message);
                        location.reload();
                    }else{
                       ws.notify('error',part.message);                                                             
                    }                            
                     ws.bloader('.ivContentbloader',2);
            });
        },
        registrar_deletion_request : function (i){
             ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/registrar_deletion_request/'+i,function (data){
                    var part = JSON.parse(data);
                    if(part.status == 'success'){
                        ws.notify('success',part.message);
                        location.reload();
                    }else{
                       ws.notify('error',part.message);                                                             
                    }                            
                     ws.bloader('.ivContentbloader',2);
            });
        },
        registrar_reset_dns : function (i){
             ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/registrar_reset_dns/'+i,function (data){
                    var part = JSON.parse(data);
                    if(part.status == 'success'){
                        ws.notify('success',part.message);
                        location.reload();
                    }else{
                       ws.notify('error',part.message);                                                             
                    }                            
                     ws.bloader('.ivContentbloader',2);
            });
        },
        registrar_emailforwarding : function (i,s){
             ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/registrar_emailforwarding/'+i+'/'+s,function (data){
                    var part = JSON.parse(data);
                    if(part.status == 'success'){
                        ws.notify('success',part.message);
                        location.reload();
                    }else{
                       ws.notify('error',part.message);                                                             
                    }                            
                     ws.bloader('.ivContentbloader',2);
            });
        },
        registrar_modify_details_form : function (i){
             ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/registrar_modify_details_form/'+i,function (data){
             ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'S');
            });
        },
        registrar_modify_details : function (e){
             ws.bloader('.ivContentbloader',1);
             ws.fs('/acp/registrar_modify_details/',$(e),function(data){
                var part = JSON.parse(data);
                if(part.status == 'success'){
                    ws.notify('success',part.message);
                   // ws.modal('','N');  
                }else{
                   ws.notify('error',part.message);                                                             
                }                            
                 ws.bloader('.ivContentbloader',2);
            });
        },
        registrar_register_form : function (i,t){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/registrar_register_form/'+i+'/'+t,function (data){
             ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'S');
            });
        },
        registrar_register_transfer_renew : function (e)
        {
             ws.swal({
                    title: "Domain Request",
                    text: "Click at OK button to Process Domain Request",
                    type: "info",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                ws.bloader('.ivContentbloader',1);
                ws.fs('/acp/registrar_register_transfer_renew/',$(e),function(data){
                    var part = JSON.parse(data);
                    ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                    if(part.status == 'success')
                    {
                        ws.notify('success',part.message);
                       // ws.modal('','N');  
                    }else{
                       ws.notify('error',part.message);                                                             
                    }                            
                     ws.bloader('.ivContentbloader',2);
                });
            });
        },
        gateway_activation_form : function (g){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/gateway_activation_form/'+g,function (data){
             ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'S');
            });
        },
        gateway_activate : function(e,home){
             ws.bloader('.ivContentbloader',1);
            ws.fs('/acp/gateway_activate/',$(e),function(data){
                var part = JSON.parse(data);
                ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});
                if(part[0] == 1){
                    ws.modal('','N');
                    if (typeof MpLoadApps === "function") MpLoadApps();
                }                            
                 ws.bloader('.ivContentbloader',2);
            });
        },
        currencies_grid_for_setup : function(){
             ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/currencies_grid_for_setup/',function (data){
                $('.currencies_list').html(data);
             ws.bloader('.ivContentbloader',2);  
            });
        },
        basic_setup_completed_for_setup : function (){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/basic_setup_completed_for_setup/',function (data){
                var part = JSON.parse(data);
                ws.bloader('.ivContentbloader',2);  
                $(".basicSetupCloseBtn").click();
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                ws.admin_dashboard();
            });
        },
        currency_form_for_setup : function (i)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/currency_form_for_setup/'+i+'/',function (data){
             ws.bloader('.ivContentbloader',2);  
            $(".currency_btn_form_for_setup").addClass("hide");
            $(".currency_form_for_setup").html(data).removeClass("hide");
            });
        },
        currencies_delete_for_setup : function(i){
         ws.swal({
                    title: "Delete Currency",
                    text: "Click at OK button to Delete Currency",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "#ff0000",
                    showLoaderOnConfirm: true
                },
                function() {

                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/currencies_delete/'+i,function (data){
                var part = JSON.parse(data);
                if(part[0] == 1){
                    ws.currencies_grid_for_setup();                                                                
                }
                    ws.swal({
                            type:part[0],
                            title: part[1],
                            confirmButtonColor: "#2196F3"
                        });                                                               

                ws.bloader('.ivContentbloader',2);  
                });
                });
        },
        currency_form_hide_for_setup:function(){
            $(".currency_form_for_setup").html("");
            $(".currency_form_for_setup").addClass("hide");
            $(".currency_btn_form_for_setup").removeClass("hide");
        },
        currency_add_edit_for_setup : function(e,home){
             ws.bloader('.ivContentbloader',1);
            ws.fs('/acp/currency_add_edit/',$(e),function(data){
                var part = JSON.parse(data);
                if(part[0] == 1){                                    
                        ws.currencies_grid_for_setup();
                        $(".currency_form_for_setup").html("");
                        $(".currency_btn_form_for_setup").removeClass("hide");
                }
                ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});                            
                 ws.bloader('.ivContentbloader',2);
            });
        },
        save_general_info_for_setup:function(e){
            ws.bloader('.ivContentbloader',1);
            ws.fs('/acp/save_general_info_for_setup/',$(e),function(data){
                var part = JSON.parse(data);
                if(part.status == 'success')
                {                                    
                    $(".steps-btn-3").click();
                }
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});                            
                 ws.bloader('.ivContentbloader',2);
            });                        
        },
        currency_check_for_setup:function(){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/currency_check_for_setup/',function (data){
                var part = JSON.parse(data);
                if(part.status == 'success'){                                    
                    $(".steps-btn-4").click();
                }else{
                    ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                }
                ws.bloader('.ivContentbloader',2);  
            });
        },
        payment_gateway_check_for_setup:function(){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/payment_gateway_check_for_setup/',function (data){
                var part = JSON.parse(data);
                if(part.status == 'success'){                                    
                    $(".steps-btn-5").click();
                }else{
                    ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                }
                ws.bloader('.ivContentbloader',2);  
            });
        },
        goto_payment_apps: function(){
        ws.set("mpUrl","browse-apps-10");
        window.location="/admin/apps/marketplace";
        },
        currencies_grid : function(){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/currencies_grid/',function (data){
                $('.currencies_list').html(data);
                var rowCount = $('.currencies_list tbody tr').length;
                if(rowCount>1)
                {
                    $(".cuer-btn").removeClass("hide");    
                }else{
                    $(".cuer-btn").addClass("hide");
                }
                ws.bloader('.ivContentbloader',2); 
            });
        },
        currency_form : function (i){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/currency_form/'+i+'/',function (data){
             ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'S');
            });
        },
        currency_add_edit : function(e,home){
             ws.bloader('.ivContentbloader',1);
            ws.fs('/acp/currency_add_edit/',$(e),function(data){
                var part = JSON.parse(data);
                if(part[0] == 1){                                    
                    ws.modal('','N');  
                        ws.currencies_grid();
                    $("#whmbcs-clear-form").click();                                   
                }
                ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});                            
                 ws.bloader('.ivContentbloader',2);
            });
        },
        currencies_delete : function(i){
         ws.swal({
                    title: "Delete Currency",
                    text: "Click at OK button to Delete Currency",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "#ff0000",
                    showLoaderOnConfirm: true
                },
                function() {
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/currencies_delete/'+i,function (data){
                var part = JSON.parse(data);
                if(part[0] == 1){
                    ws.currencies_grid();                                                                
                }
                    ws.swal({
                            title: part[1],
                            confirmButtonColor: "#2196F3"
                        });
                ws.bloader('.ivContentbloader',2);  
                });
                });
        },
        currency_api_form : function (i){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/currency_api_form/'+i+'/',function (data){
             ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'S');
            });
        },
        currency_api_enable : function (i){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/currency_api_enable/'+i+'/',function (data){
                var part = JSON.parse(data);
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == "success"){
                    MpLoadApps();
                }
                 ws.bloader('.ivContentbloader',2);                                
            });
        },
        currency_api_disable : function (i){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/currency_api_disable/'+i+'/',function (data){
                var part = JSON.parse(data);
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == "success"){
                    MpLoadApps();
                }
                 ws.bloader('.ivContentbloader',2);                                
            });
        },
        currency_api_update : function(e,home){
             ws.bloader('.ivContentbloader',1);
            $(".mp-alert-box").addClass("hide");
            ws.fs('/acp/currency_api_update/',$(e),function(data){
                var part = JSON.parse(data);
                if(part.status == "success"){
                    ws.modal('','N');  
                    $(".mp-alert-box").removeClass("hide").addClass("alert-success").html(part.message);
                }else{
                    $(".mp-alert-box").removeClass("hide").addClass("alert-danger").html(part.message);
                }
                 ws.bloader('.ivContentbloader',2);                                
            });
        },
        currencies_update_exchange_rate : function(){
         ws.swal({
                    title: "Update Exchange Rates",
                    text: "Click at OK button to Update Exchange Rates",
                    type: "info",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "#2196F3",
                    showLoaderOnConfirm: true
                },
                function() {

                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/currencies_update_exchange_rate/',function (data){
                var part = JSON.parse(data);
                if(part[0] == 1){
                    ws.currencies_grid();                                                                
                }
                    ws.swal({
                            type:part[0],
                            title: part[1],
                            confirmButtonColor: "#2196F3"
                        });                                                               

                ws.bloader('.ivContentbloader',2);  
                });
                });
        },
        currencies_update_items_rate : function(){
         ws.swal({
                    title: "Update Products Prices",
                    text: "Click at OK button to Update Products Prices",
                    type: "info",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "#2196F3",
                    showLoaderOnConfirm: true
                },
                function() {

                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/currencies_update_items_rate/',function (data){
                var part = JSON.parse(data);
                if(part[0] == 1){
                    ws.currencies_grid();                                                                
                }
                    ws.swal({
                            title: part[1],
                            confirmButtonColor: "#2196F3"
                        });                                                               

                ws.bloader('.ivContentbloader',2);  
                });
                });
        },
        home_todo_list : function(){
             ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/home_todo_list/',function (data){
                $('.home_todo_list_content').html(data);
             ws.bloader('.ivContentbloader',2);  
            });
        },
        home_todo_marked : function(i){
         ws.swal({
                    title: "To-Do Marked Resolved",
                    text: "Click at OK button to Marked To-Do as Resolved",
                    type: "info",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "#2196F3",
                    showLoaderOnConfirm: true
                },
                function() {

                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/todo_status_change/'+i+'/3',function (data){
                var part = JSON.parse(data);
                if(part.status == "success"){
                    ws.home_todo_list();
                }
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});                            
                    ws.bloader('.ivContentbloader',2);  
                });
                });
        },
        home_billing_summaries : function(){
             ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/home_billing_summaries/',function (data){
                $('.home_billing_summaries').html(data);
             ws.bloader('.ivContentbloader',2);  
            });
        },
        home_support_panel : function(){
             ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/home_support_summaries/',function (data){
                $('.home_support_panel').html(data);
             ws.bloader('.ivContentbloader',2);  
            });
        },
        home_payments_stats : function(){
             ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/home_payments_stats/',function (data){
                $('.home_payments_stats').html(data);
             ws.bloader('.ivContentbloader',2);  
            });
        },
        home_servers_status : function(){
             ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/home_servers_status/',function (data){
                $('.home_servers_status').html(data);
             ws.bloader('.ivContentbloader',2);  
            });
        },
        home_users_activity : function(){
             ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/home_users_activity/',function (data){
                $('.home_users_activity').html(data);
             ws.bloader('.ivContentbloader',2);  
            });
        },
        home_staff_activity : function(){
             ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/home_staff_activity/',function (data){
                $('.home_staff_activity').html(data);
             ws.bloader('.ivContentbloader',2);  
            });
        },
        home : function(){
             ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/home/',function (data){
                var part = JSON.parse(data);
                alert(part.ClientsActivity.totalclients);
             ws.bloader('.ivContentbloader',2);  
            });
        },
        settings_addup : function (e){
             ws.bloader('.ivContentbloader',1);
            ws.f('/acp/settings_addup/',e,function(data){
                var part = JSON.parse(data);
                    ws.notify('success',part.msg);
                 ws.bloader('.ivContentbloader',2);
            });
        },
        tax_setup_addup : function (e){
             ws.bloader('.ivContentbloader',1);
            ws.f('/acp/tax_setup_addup/',e,function(data){
                var part = JSON.parse(data);
                    ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                 ws.bloader('.ivContentbloader',2);
            });
        },
        SpamControlForm : function (){
             ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/SpamControlForm/',function (data){
            ws.modal(data,'S');
             ws.bloader('.ivContentbloader',2);  
            });
        },
        SpamControlSave : function (e){
            ws.bloader('.ivContentbloader',1);
            ws.f('/acp/SpamControlSave',e,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == "success") location.reload();
                ws.bloader('.ivContentbloader',2);  
             });
             return false;
        },
        SpamControlDelete : function (i=0)
        {
             ws.swal({
                    title: "Delete",
                    text: "Click at OK button to Delete",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/SpamControlDelete/'+i,function (data)
                {
                    var part = JSON.parse(data);                           
                    ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                    if(part.status == "success") location.reload();
                    ws.bloader('.ivContentbloader',2);
                });
            });
        },
        SecurityQuestionForm : function (){
             ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/SecurityQuestionForm/',function (data){
            ws.modal(data,'S');
             ws.bloader('.ivContentbloader',2);  
            });
        },
        SecurityQuestionSave : function (e){
            ws.bloader('.ivContentbloader',1);
            ws.f('/acp/SecurityQuestionSave',e,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == "success") location.reload();
                ws.bloader('.ivContentbloader',2);  
             });
             return false;
        },
        SecurityQuestionDelete : function (i=0)
        {
             ws.swal({
                    title: "Delete",
                    text: "Click at OK button to Delete",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/SecurityQuestionDelete/'+i,function (data)
                {
                    var part = JSON.parse(data);                           
                    ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                    if(part.status == "success") location.reload();
                    ws.bloader('.ivContentbloader',2);
                });
            });
        },
        AllowMailForm : function (){
             ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/AllowMailForm/',function (data){
            ws.modal(data,'S');
             ws.bloader('.ivContentbloader',2);  
            });
        },
        AllowMailSave : function (e){
            ws.bloader('.ivContentbloader',1);
            ws.f('/acp/AllowMailSave',e,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == "success") location.reload();
                ws.bloader('.ivContentbloader',2);  
             });
             return false;
        },
        AllowMailDelete : function (i=0)
        {
             ws.swal({
                    title: "Delete",
                    text: "Click at OK button to Delete",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/AllowMailDelete/'+i,function (data)
                {
                    var part = JSON.parse(data);                           
                    ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                    if(part.status == "success") location.reload();
                    ws.bloader('.ivContentbloader',2);
                });
            });
        },
        BanMailForm : function (){
             ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/BanMailForm/',function (data){
            ws.modal(data,'S');
             ws.bloader('.ivContentbloader',2);  
            });
        },
        BanMailSave : function (e){
            ws.bloader('.ivContentbloader',1);
            ws.f('/acp/BanMailSave',e,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == "success") location.reload();
                ws.bloader('.ivContentbloader',2);  
             });
             return false;
        },
        BanMailDelete : function (i=0)
        {
             ws.swal({
                    title: "Delete",
                    text: "Click at OK button to Delete",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/BanMailDelete/'+i,function (data)
                {
                    var part = JSON.parse(data);                           
                    ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                    if(part.status == "success") location.reload();
                    ws.bloader('.ivContentbloader',2);
                });
            });
        },
        ClientRolesForm : function (i=0){
             ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/ClientRolesForm/'+i,function (data){
            ws.modal(data,'M');
             ws.bloader('.ivContentbloader',2);  
            });
        },
        ClientRolesSave : function (e){
            ws.bloader('.ivContentbloader',1);
            ws.f('/acp/ClientRolesSave',e,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == "success") location.reload();
                ws.bloader('.ivContentbloader',2);  
             });
             return false;
        },
        ClientRolesDelete : function (i=0)
        {
             ws.swal({
                    title: "Delete",
                    text: "Click at OK button to Delete",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/ClientRolesDelete/'+i,function (data)
                {
                    var part = JSON.parse(data);                           
                    ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                    if(part.status == "success") location.reload();
                    ws.bloader('.ivContentbloader',2);
                });
            });
        },
        SupportStatusForm : function (i=0){
             ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/SupportStatusForm/'+i,function (data){
            ws.modal(data,'S');
             ws.bloader('.ivContentbloader',2);  
            });
        },
        SupportStatusSave : function (e){
            ws.bloader('.ivContentbloader',1);
            ws.f('/acp/SupportStatusSave',e,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == "success") location.reload();
                ws.bloader('.ivContentbloader',2);  
             });
             return false;
        },
        SupportStatusDelete : function (i=0)
        {
             ws.swal({
                    title: "Delete",
                    text: "Click at OK button to Delete",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/SupportStatusDelete/'+i,function (data)
                {
                    var part = JSON.parse(data);                           
                    ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                    if(part.status == "success") location.reload();
                    ws.bloader('.ivContentbloader',2);
                });
            });
        },
        ServerForm : function (g=0,i=0){
             ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/ServerForm/'+g+'/'+i,function (data){
            ws.modal(data,'M');
             ws.bloader('.ivContentbloader',2);  
            });
        },
        ServerSave : function (e){
            ws.bloader('.ivContentbloader',1);
            ws.f('/acp/ServerSave',e,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == "success") location.reload();
                ws.bloader('.ivContentbloader',2);  
             });
             return false;
        },
        ServerDelete : function (i=0)
        {
             ws.swal({
                    title: "Delete",
                    text: "Click at OK button to Delete",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/ServerDelete/'+i,function (data)
                {
                    var part = JSON.parse(data);                           
                    ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                    if(part.status == "success") location.reload();
                    ws.bloader('.ivContentbloader',2);
                });
            });
        },
        ServerGroupForm : function (i=0){
             ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/ServerGroupForm/'+i,function (data){
            ws.modal(data,'S');
             ws.bloader('.ivContentbloader',2);  
            });
        },
        ServerGroupSave : function (e){
            ws.bloader('.ivContentbloader',1);
            ws.f('/acp/ServerGroupSave',e,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == "success") location.reload();
                ws.bloader('.ivContentbloader',2);  
             });
             return false;
        },
        ServerGroupDelete : function (i=0)
        {
             ws.swal({
                    title: "Delete",
                    text: "Click at OK button to Delete",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/ServerGroupDelete/'+i,function (data)
                {
                    var part = JSON.parse(data);                           
                    ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                    if(part.status == "success") location.reload();
                    ws.bloader('.ivContentbloader',2);
                });
            });
        },
        tax_rules_addup : function (e){
             ws.bloader('.ivContentbloader',1);
            ws.f('/acp/tax_rules_addup/',e,function(data){
                var part = JSON.parse(data);
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                ws.tax_rules_list();
                ws.modal('','N');
                 ws.bloader('.ivContentbloader',2);
            });
        },
        tax_rules_auto_addup : function (e){
             ws.bloader('.ivContentbloader',1);
            ws.f('/acp/tax_rules_auto_addup/',e,function(data){
                var part = JSON.parse(data);
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                ws.tax_rules_list();
                ws.modal('','N');
                 ws.bloader('.ivContentbloader',2);
            });
        },
        tax_rules_form : function (){
             ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/tax_rules_form/',function (data){
            ws.modal(data,'S');
             ws.bloader('.ivContentbloader',2);  
            });
        },
        tax_rules_auto_form : function (){
             ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/tax_rules_auto_form/',function (data){
            ws.modal(data,'S');
             ws.bloader('.ivContentbloader',2);  
            });
        },
        tax_rules_delete_all : function (e)
        {
             ws.swal({
                    title: "Delete",
                    text: "Click at OK button to Delete",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                    ws.bloader('.ivContentbloader',1);  
                    ws.f('/acp/tax_rules_delete_all',e,function(res){
                        var part = JSON.parse(res);
                        ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                        if(part.status == 'success') ws.tax_rules_list();
                        ws.bloader('.ivContentbloader',2);
                    });
                });
            return false;
        },
        tax_rules_delete : function (i)
        {
             ws.swal({
                    title: "Delete",
                    text: "Click at OK button to Delete",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                ws.bloader('.ivContentbloader',1);
                ws.ajax('/acp/tax_rules_delete/'+i,function (data){
                    var part = JSON.parse(data);
                    if(part.status == 'success') ws.tax_rules_list();
                 ws.bloader('.ivContentbloader',2);  
                });
            });
        },
        tax_rules_list : function (){
             ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/tax_rules_list/',function (data){
             ws.bloader('.ivContentbloader',2);  
            $('.taxRulesList').html(data);
            });
        },
        client_addup : function (e){
             ws.bloader('.ivContentbloader',1);
            ws.f('/acp/client_addup/',e,function(data){
                var part = JSON.parse(data);
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == "success") window.location="/admin/client-summary/"+part.id;
                 ws.bloader('.ivContentbloader',2);
            });
        },
        AdminUserDelete : function (i)
        {
             ws.swal({
                    title: "Delete",
                    text: "Click at OK button to Delete",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/AdminUserDelete/'+i,function (data){
                    var part = JSON.parse(data);
                    ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                    if(part.status=='success') location.reload();
                     ws.bloader('.ivContentbloader',2);
                });
            });
        },
        AddClientNoteForm : function (u=0,i=0){
            ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/AddClientNoteForm/'+u+'/'+i,function (data)
            {
                ws.modal(data,'M');
                ws.bloader('.ivContentbloader',2);
            });
        },
        AddUpClientNote : function (e){
            ws.bloader('.ivContentbloader',1);
            ws.f('/acp/AddUpClientNote/',e,function (data)
            {
                var part = JSON.parse(data);
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status=='success') location.reload();
                ws.bloader('.ivContentbloader',2);
            });
        },
        DelClientNote : function (u,i)
        {
             ws.swal({
                    title: "Delete",
                    text: "Click at OK button to Delete Note",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/DelClientNote/'+u+'/'+i,function (data){
                        var part = JSON.parse(data);
                        ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                        if(part.status=='success') location.reload();
                         ws.bloader('.ivContentbloader',2);
                });
            });
        },
        AddNewClient : function (){
            ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/AddNewClientForm/',function (data)
            {
                ws.modal(data,'L');
                ws.bloader('.ivContentbloader',2);
            });
        },
        AdminUserAddUpForm : function (i=0){
            ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/AdminUserAddUpForm/'+i,function (data){
            ws.modal(data,'L');
             ws.bloader('.ivContentbloader',2);  
            });
        },
        AdminUserAddUpSave : function (e){
             ws.bloader('.ivContentbloader',1);
            ws.f('/acp/AdminUserAddUpSave/',e,function(data){
                var part = JSON.parse(data);
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == 'success' && part.id>0) window.location="/admin/admin-users";
                 ws.bloader('.ivContentbloader',2);
            });
        },
        AdminRoleDelete : function (i)
        {
             ws.swal({
                    title: "Delete",
                    text: "Click at OK button to Delete",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/AdminRoleDelete/'+i,function (data){
                        var part = JSON.parse(data);
                        ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                        if(part.status=='success') location.reload();
                         ws.bloader('.ivContentbloader',2);
                });
            });
        },
        AdminRoleAddUpForm : function (i=0){
            ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/AdminRoleAddUpForm/'+i,function (data){
            ws.modal(data,'L');
             ws.bloader('.ivContentbloader',2);  
            });
        },
        AdminRoleAddUpSave : function (e){
             ws.bloader('.ivContentbloader',1);
            ws.f('/acp/AdminRoleAddUpSave/',e,function(data){
                var part = JSON.parse(data);
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.id > 0) location.reload();
                 ws.bloader('.ivContentbloader',2);
            });
        },
        ApiCredentialDelete : function (i)
        {
             ws.swal({
                    title: "Delete",
                    text: "Click at OK button to Delete",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/ApiCredentialDelete/'+i,function (data){
                        var part = JSON.parse(data);
                        ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                        if(part.status=='success') location.reload();
                         ws.bloader('.ivContentbloader',2);
                });
            });
        },
        ApiCredentialGrant : function (i=0,s=0)
        {
            var t = (s == 1) ? "Enable":"Disable";
            var ts = (s == 1) ? "error":"success";
             ws.swal({
                    title: t+" Reseller Access",
                    text: "Click at OK button to "+t+" Reseller Access",
                    type: ""+ts,
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/ApiCredentialGrant/'+i+'/'+s,function (data){
                        var part = JSON.parse(data);
                        ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                        if(part.status=='success') location.reload();
                         ws.bloader('.ivContentbloader',2);
                });
            });
        },
        ApiCredentialAddUpForm : function (i=0,u=0){
            ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/ApiCredentialAddUpForm/'+i+'/'+u,function (data){
            ws.modal(data,'L');
             ws.bloader('.ivContentbloader',2);  
            });
        },
        ApiCredentialAddUpSave : function (e){
             ws.bloader('.ivContentbloader',1);
            ws.f('/acp/ApiCredentialAddUpSave/',e,function(data){
                var part = JSON.parse(data);
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.id > 0) location.reload();
                 ws.bloader('.ivContentbloader',2);
            });
        },
        ChatBadWordDelete : function (i)
        {
             ws.swal({
                    title: "Delete",
                    text: "Click at OK button to Delete",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/ChatBadWordDelete/'+i,function (data){
                        var part = JSON.parse(data);
                        ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                        if(part.status=='success') location.reload();
                         ws.bloader('.ivContentbloader',2);
                });
            });
        },
        ChatBadWordAddUpForm : function (i=0){
            ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/ChatBadWordAddUpForm/'+i,function (data){
            ws.modal(data,'S');
             ws.bloader('.ivContentbloader',2);  
            });
        },
        ChatBadWordAddUpSave : function (e){
             ws.bloader('.ivContentbloader',1);
            ws.f('/acp/ChatBadWordAddUpSave/',e,function(data){
                var part = JSON.parse(data);
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == "success") location.reload();
                 ws.bloader('.ivContentbloader',2);
            });
        },
        SmiliesDelete : function (i)
        {
             ws.swal({
                    title: "Delete",
                    text: "Click at OK button to Delete",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/SmiliesDelete/'+i,function (data){
                        var part = JSON.parse(data);
                        ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                        if(part.status=='success') $(".ws-smily-main-"+i).remove();
                         ws.bloader('.ivContentbloader',2);
                });
            });
        },
        SmiliesAddUpForm : function (i=0){
            ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/SmiliesAddUpForm/'+i,function (data){
            ws.modal(data,'S');
             ws.bloader('.ivContentbloader',2);  
            });
        },
        SmiliesAddUpSave : function (e){
             ws.bloader('.ivContentbloader',1);
            ws.f('/acp/SmiliesAddUpSave/',e,function(data){
                var part = JSON.parse(data);
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == "success")
                {
                    $(".ws-smily-row-"+part.id+" > img").attr("title",part.name);
                    if(part.image.length>5) $(".ws-smily-row-"+part.id+" > img").attr("src",part.image);
                }
                 ws.bloader('.ivContentbloader',2);
            });
        },
        ChatTriggerDelete : function (i)
        {
             ws.swal({
                    title: "Delete",
                    text: "Click at OK button to Delete",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/ChatTriggerDelete/'+i,function (data){
                        var part = JSON.parse(data);
                        ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                        if(part.status=='success') $(".ws-chat-trigger-row-"+i).remove();
                         ws.bloader('.ivContentbloader',2);
                });
            });
        },
        ChatTriggerAddUpForm : function (i=0){
            ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/ChatTriggerAddUpForm/'+i,function (data){
            ws.modal(data,'M');
             ws.bloader('.ivContentbloader',2);  
            });
        },
        ChatTriggerAddUpSave : function (e){
             ws.bloader('.ivContentbloader',1);
            ws.f('/acp/ChatTriggerAddUpSave/',e,function(data){
                var part = JSON.parse(data);
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status=='success') location.reload();
                 ws.bloader('.ivContentbloader',2);
            });
        },
        LoadPage : function (event,u)
        {
            //const currentPath = window.location.pathname;
            //history.replaceState(null, null, u);
            //$(".content-wrapper").html("");
            if (event.ctrlKey || event.metaKey)
            {
                window.open(u, '_blank');
            } else {
                window.location = u;
            /*
                ws.bloader('.ivContentbloader',1);
                ws.ajax(u,(data)=>{
                     ws.bloader('.ivContentbloader',2);  
                    $(".content-wrapper").html(data);
                    $(document).trigger('contentLoaded');
                    setTimeout(()=>{
                    $('.select').wsSelect();
                    ws.radio_checks();
                    daterange_singles();
                    }, 100);
                    //$('#WsSearchForm, #support_tickets_form').submit();
                });
                */
            }
        },
        LoadModalPage : function (u="",ms="M")
        {
            ws.bloader('.ivContentbloader',1);
            ws.ajax(u,(data)=>{
                 ws.bloader('.ivContentbloader',2);  
                ws.modal(data,ms);
                $(document).trigger('contentLoaded');
                setTimeout(()=>{
                $('.select').wsSelect();
                ws.radio_checks();
                daterange_singles();
                }, 100);
            });
        },
        executeScripts: function(callback) {
                alert();
                    // Call the provided callback function
                    callback();
        },
        AjaxSearch : function (t="f",e="")
        {
            var fm = $('#WsSearchForm');
            if(t == "p")
            {
                $(".WsCurrentPage").val(e);
                fm.submit();
            }else if(t == "s")
            {
                $(".WsCurrentPage").val(1);
                $(".WsSortPage").val(e);
                fm.submit();
            }else if(t == "f")
            {
                fm.submit();
            }
            else
            {
                var u = fm.attr('action');
                ws.bloader('.ivContentbloader',1);
                ws.f(u,e,function(data)
                {
                    $("#WsRptContent").html(data);
                     ws.bloader('.ivContentbloader',2);
                });
            }
        },
        ContactAddUpSave : function (e)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.f('/acp/ContactAddUpSave',e,function(res){
                var part = JSON.parse(res);
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == "success")
                {
                    var uid = $("#ws-user-id").val();
                    var cid = $("#ws-contact-id").val();
                    if(cid == 0 && part.id>0)
                    {
                        window.location="/admin/client-contacts/"+uid+"/"+part.id;
                    }
                }
                ws.bloader('.ivContentbloader',2);
            });
            return false;
        },
        ContactDelete : function (u,i)
        {
             ws.swal({
                    title: "Delete",
                    text: "Click at OK button to Delete",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/ContactDelete/'+u+'/'+i,function (data){
                    var part = JSON.parse(data);
                    ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                    if(part.status=='success') window.location="/admin/client-contacts/"+u;
                     ws.bloader('.ivContentbloader',2);
                });
            });
        },
        ClientAddUpSave : function (i,e){
            ws.bloader('.ivContentbloader',1);  
            ws.f('/acp/ClientAddUpSave/'+i,e,function(res){
                var part = JSON.parse(res);
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                ws.bloader('.ivContentbloader',2);
            });
            return false;
        },
        PromotionAddupForm : function (i=0,t='New'){
             ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/PromotionAddupForm/'+i+'/'+t,function (data){
            ws.modal(data,'L');
             ws.bloader('.ivContentbloader',2);  
            });
        },
        PromotionAddUpSave : function (e){
             ws.bloader('.ivContentbloader',1);
            ws.f('/acp/PromotionAddUpSave/',e,function(data){
                var part = JSON.parse(data);
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == 'success') window.location="/admin/promotions";
                 ws.bloader('.ivContentbloader',2);
            });
        },
        promotion_delete : function (i)
        {
             ws.swal({
                    title: "Delete",
                    text: "Click at OK button to Delete",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/promotion_delete/'+i,function (data){
                    var part = JSON.parse(data);
                    ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                    if(part.status=='success') location.reload();
                     ws.bloader('.ivContentbloader',2);
                });
            });
        },
        promotion_expire : function (i){
             ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/promotion_expire/'+i,function (data){
                    var part = JSON.parse(data);
                    ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                    if(part.status=='success') location.reload();
                     ws.bloader('.ivContentbloader',2);
            });
        },
        support_tickets_list : function (e){
             ws.bloader('.ivContentbloader',1);
            ws.fs('/acp/support_tickets_list/',$(e),function(data){
                 var part = JSON.parse(data);
                $(".tickets-pagination").html(part.pagination);
                $(".support_tickets_list").html(part.tickets);
                ws.radio_checks();
                 ws.bloader('.ivContentbloader',2);
            });
        },
        support_tickets_selection : function (i){
            if(i.checked){
                $(".selectionBox").prop( "checked", true ).parent().addClass('checked');
            }else{
                $(".selectionBox").prop( "checked", false ).parent().removeClass('checked');
            }
        },
        support_tickets_actions : function (i){                        
            var ids = $('.selectionBox:checked').map(function(){return $(this).val();}).get();
             ws.bloader('.ivContentbloader',1);
            var e = $('<form/>').append($('<input/>', {name: 'ticket_ids'}).val(ids));
            ws.fs('/acp/support_tickets_actions/'+i,e,function(data){
                var part = JSON.parse(data);
                if(part[0] == 1){                                    
                    $('#support_tickets_form').submit();
                }
                ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});                            
                 ws.bloader('.ivContentbloader',2);
            });
        },
        support_tickets_status_change : function (i,s){
             ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/support_tickets_status_changes/'+i+'/'+s,function (data){
                    var part = JSON.parse(data);
                    if(part[0] == 1){                                    
                        location.reload();
                    }
                    ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});                            
                     ws.bloader('.ivContentbloader',2);
            });
        },
        support_tickets_flag : function (i,f){  
             ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/support_tickets_flag/'+i+'/'+f,function (data){
                    var part = JSON.parse(data);
                    if(part[0] == 1){                                    
                        $('#support_tickets_form').submit();
                    }
                    ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});                            
                     ws.bloader('.ivContentbloader',2);
            });
        },
        support_tickets_beat : function (t){
            setInterval(function (){$('#support_tickets_form').submit();},t);
        },
        support_tickets_add : function (e){
             ws.bloader('.ivContentbloader',1);
            ws.f('/acp/support_tickets_add/',e,function(data){
                var part = JSON.parse(data);
                if(part[0] == 1){                                    
                    window.location='/admin/support-ticket-reply/'+part[2];
                }
                ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});                            
                 ws.bloader('.ivContentbloader',2);
            });
        },
        support_tickets_add_reply : function (e,i,t){
             ws.bloader('.ivContentbloader',1);
            ws.f('/acp/support_tickets_add_reply/'+t,e,function(data){
                var part = JSON.parse(data);
                if(part[0] == 1){                                    
                    ws.support_ticket_replies(i);
                }
                ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});                            
                 ws.bloader('.ivContentbloader',2);
            });
        },
        support_tickets_option_update : function (e){
             ws.bloader('.ivContentbloader',1);
            ws.f('/acp/support_tickets_option_update/',e,function(data){
                var part = JSON.parse(data);
                if(part[0] == 1){                                    
                     setTimeout(function() {location.reload();}, 2000);
                }
                ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});                            
                 ws.bloader('.ivContentbloader',2);
            });
        },
        support_tickets_append_text : function(textBox,textClass){
            var text = $(textClass).html();
            var wysihtml5Editor = $('#editor_full').data("wysihtml5").editor;
            wysihtml5Editor.focus();
            wysihtml5Editor.composer.commands.exec("insertHTML", text);
        //CKEDITOR.instances.editor_full.insertHtml(text);
//                    $('#editor-full').summernote('pasteHTML',text);

            ws.modal('','N');
        },
        support_tickets_insert_pr_link : function (){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/support_predifined_reply_list_by_cat',function (data){
                $(".note-editable").focus();
                ws.bloader('.ivContentbloader',2);  
                ws.modal(data,'M');
            });
        },
        support_tickets_insert_kb_link : function (i){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/support_kb_list_by_cat',function (data){
             ws.bloader('.ivContentbloader',2); 
             if(i == 0){
                 ws.modal(data,'M');
             }else{
                 $(".whmbcs-model-content").html(data);
             }
            });
        },
        support_knowledgebase_list_by_id : function (i){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/support_knowledgebase_list_by_id/'+i,function (data){
            $(".whmbcs-model-content").html(data);
             ws.bloader('.ivContentbloader',2);  
            });
        },
        support_ticket_replies : function(i){
             ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/support_ticket_replies/'+i,function (data){
                $('#Support-repliesTicket').html(data);
             ws.bloader('.ivContentbloader',2);  
            });
        },
        support_ticket_reply_delete : function(t,i)
        {
             ws.swal({
                    title: "Delete",
                    text: "Click at OK button to Delete",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/support_ticket_reply_delete/'+i,function (data){
                   ws.support_ticket_replies(t);
                    var part = JSON.parse(data);
                     ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});  
                 ws.bloader('.ivContentbloader',2);  
                });
            });
        },
        support_ticket_logs : function(i){
             ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/support_ticket_logs/'+i,function (data){
                $('#Support-ticketLogs').html(data);
             ws.bloader('.ivContentbloader',2);  
            });
        },
        support_tickets_list_by_client : function(i,cti,p){
             ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/support_tickets_list_by_client/'+i+'/'+cti+'/'+p,function (data){
                $('#Support-otherTickets').html(data);
             ws.bloader('.ivContentbloader',2);  
            });
        },
        todo_form_open : 0,
        todo_id : 0,
        todo_cat_list : function (){
            var id = location.hash;
            var itemId = id.substring(1, id.length);                                        
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/todo_cat_list/',function (data){
                $(".to_do_cat_list").html(data);
                ws.todo_list(itemId);                                         
             ws.bloader('.ivContentbloader',2);  
            });

        },
        todo_list : function(t){
            $(".task-row-cat").removeClass('active');
            $(".task-row-"+t).addClass('active');
            location.hash = t;
             ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/to_do_content/'+t,function (data){
                $("#to-do-contents").html(data);
             ws.bloader('.ivContentbloader',2);  
            });
        },
        todo_important : function(i){
            var obj = $('.taskIIconId-'+i);
            var imp = obj.attr('imp'); 
            var act = obj.attr('act'); 
             ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/todo_important_change/'+i+'/'+imp,function (data){
                var part = JSON.parse(data);
                if(part.status == "success")
                {
                     ws.todo_cat_list();
                    if(imp == 'Yes'){
                        obj.attr('imp','No').removeClass('icon-star-empty3').addClass('icon-star-full2');
                    }else{
                        obj.attr('imp','Yes').addClass('icon-star-empty3').removeClass('icon-star-full2');
                    }                                                                                                
                }
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});                            
             ws.bloader('.ivContentbloader',2);  
            });
        },
        todo_add_edit : function(e,home){
             ws.bloader('.ivContentbloader',1);
            ws.fs('/acp/todo_add_edit/',$(e),function(data){
                var part = JSON.parse(data);
                if(part.status == "success"){
                    ws.modal('','N');  
                    if(home == 'home'){
                        ws.home_todo_list();
                    }else{
                    ws.todo_cat_list();                                         
                    }
                    $("#whmbcs-clear-form").click();                                   
                }
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});                           
                 ws.bloader('.ivContentbloader',2);
            });
        },
        todo_marked : function(i){
            var obj = $('.taskRIconId-'+i);
            var objT = $('.taskTitleId-'+i);
            var status = obj.attr('status'); 
             ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/todo_status_change/'+i+'/'+status,function (data){
                var part = JSON.parse(data);
                if(part.status == "success"){
                    if(status == 3){
                        objT.addClass('task-resolved');
                        obj.attr('status',2).addClass('icon-checkmark-circle').removeClass('icon-circle');
                    }else{
                        objT.removeClass('task-resolved');
                        obj.attr('status',3).removeClass('icon-checkmark-circle').addClass('icon-circle');
                    }                                                                                                
                }
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});                            
             ws.bloader('.ivContentbloader',2);  
            });
        },
        todo_form : function (i,home){
            ws.todo_id = i;
            var l = location.hash;
            l = l.substring(1, l.length);
            ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/to_do_form/'+i+'/'+home+'/'+l,function (data){
             ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'S');
            daterange_singles();
            ws.todo_form_open = 1;
            });

        },
        account_reset_and_send_pwd : function (i){                        
         ws.swal({
                    title: "Reset Client Password",
                    text: "Click at OK button to Reset Client Password",
                    type: "info",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "#2196F3",
                    showLoaderOnConfirm: true
                },
                function() {
                     ws.bloader('.ivContentbloader',1);  
                    ws.ajax('/acp/reset-and-send-pwd/'+i,function (data){
                    var part = JSON.parse(data);
                    ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});
                     ws.bloader('.ivContentbloader',2);  
                    });
                });
        },
        account_login_as_client : function (i){                        
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/account_login_as_client/'+i,function (data){
            var part = JSON.parse(data);
            if(part.status == 'success'){
                window.location="/client";
            }                            
             ws.bloader('.ivContentbloader',2);  
            });
        },
        send_email_for_verification : function (i){                        
         ws.swal({
                    title: "Email Verification",
                    text: "Click at OK button to Send Email For Verification",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "#2196F3",
                    showLoaderOnConfirm: true
                },
                function() {
                     ws.bloader('.ivContentbloader',1);  
                    ws.ajax('/acp/send_email_for_verification/'+i,function (data){
                    var part = JSON.parse(data);
                    ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});
                     ws.bloader('.ivContentbloader',2);  
                    });
                });
        },
        generate_support_pin : function (i){                        
         ws.swal({
                    title: "Support Pin",
                    text: "Click at OK button to Generate Support Pin",
                    type: "info",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "#2196F3",
                    showLoaderOnConfirm: true
                },
                function() {
                     ws.bloader('.ivContentbloader',1);  
                    ws.ajax('/acp/generate_support_pin/'+i,function (data){
                    var part = JSON.parse(data);
                     ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                     ws.bloader('.ivContentbloader',2);  
                    });
                });
        },
        quote_client_show_hide : function (i){
            if(i == 'YES'){
                $(".existingClientInfo").removeClass('hide');
                $(".newClientInfo").addClass('hide');
            }else if(i == 'NO'){
                $(".existingClientInfo").addClass('hide');
                $(".newClientInfo").removeClass('hide');
            }else{
                $(".existingClientInfo,.newClientInfo").removeClass('hide');
                $(".existingClientInfo,.newClientInfo").addClass('hide');
            }
        },
        invoice_id : 0,
        reload_aca : 0, 
        invoice_init : function (i,s,c){
            this.invoice_id = i; 
//                        this.quote_client_show_hide(s); 
            this.invoice_items();                      
           /// this.quote_link_change(c);                      
        },
        invoice_header : function (){
            var stats,due,paid,balance;

             ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/invoice-header/'+ws.invoice_id,function (data){                            
               var part = JSON.parse(data);
               $("#iv-no").text(part.invoice_no);
               $("#iv-ed").text(part.entry_date);
               $("#iv-dd").text(part.due_date);
               $("#iv-pd").text(part.paid_date);
               $("#iv-sa").text(part.Amount.With_Symbol.sale_amount);
               $("#iv-pa").text(part.Amount.With_Symbol.paid_amount);
               $("#iv-ba").text(part.Amount.With_Symbol.balance);
               $("#iv-cb").text(part.Amount.With_Symbol.available_credits);
               $("#iv-ib").text(part.Amount.With_Symbol.invoice_credits);
               if(part.Amount.WithOut_Symbol.available_credits < 1)
                {
                    $('#iv-cadd').addClass('hide');
                    $('#iv-caa').val('');
                }
               if(part.Amount.WithOut_Symbol.available_credits > 0)
               {
                 $('#iv-cadd').removeClass('hide');
                  $('#iv-caa').val(part.Amount.WithOut_Symbol.available_credits);
               }
               if(part.Amount.WithOut_Symbol.invoice_credits < 1)
                {
                    $('#iv-cdel').addClass('hide');
                    $('#iv-cad').val('');
                }
               if(part.Amount.WithOut_Symbol.invoice_credits > 0)
               {
                 $('#iv-cdel').removeClass('hide');
                  $('#iv-cad').val(part.Amount.WithOut_Symbol.invoice_credits);
               }
               $("#iv-status").css('color',part.status_color).text(part.status_name);
               
               if(part.status_id == 3){
                   $("#iv-btu,#iv-btc").removeClass('hide');
                   $("#iv-btp, #iv-btdp").addClass('hide');
               }
               else if(part.status_id == 2){
                   $("#iv-btu, #iv-btdp").addClass('hide');
                   $("#iv-btc,#iv-btp").removeClass('hide');
               }else if(part.status_id == 1){
                   $("#iv-btp").addClass('hide');
                   $("#iv-btc,#iv-btu, #iv-btdp").removeClass('hide');
               }else if(part.status_id == 4){
                   $("#iv-btu,#iv-btp").removeClass('hide');
                   $("#iv-btc, #iv-btdp").addClass('hide');
               }else{
                $("#iv-btu,#iv-btc,#iv-btp, #iv-btdp").addClass('hide');
               }
                 ws.bloader('.ivContentbloader',2);  
               
            });
        },
        invoice_status_change : function (i){
         ws.swal({
                    title: "Invoice Status",
                    text: "Click at OK button to process for Status Changes Request",
                    type: "info",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "#2196F3",
                    showLoaderOnConfirm: true
                },
                function() {
                 ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/invoice-status-change/'+ws.invoice_id+'/'+i,function (data){
                        var part = JSON.parse(data);
                        if(part[0] == 1){
                            ws.invoice_items();
                        }
                        ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});
                         ws.bloader('.ivContentbloader',2); 
                });
            });
        },
        invoice_payment_capture : function (i){
         ws.swal({
                    title: "Payment Capture",
                    text: "Click at OK button to process for Payment Capture Request",
                    type: "info",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "#2196F3",
                    showLoaderOnConfirm: true
                },
                function() {
                 ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/invoice-payment-capture/'+i,function (data){
                        var part = JSON.parse(data);
                        if(part.status == "success")
                        {
                            location.reload();    
                        }
                        ws.swal({title: part.message,type: part.status,confirmButtonColor: "#2196F3"});
                         ws.bloader('.ivContentbloader',2); 
                });
            });
        },
        invoice_create : function (i){
         ws.swal({
                    title: "Invoice Creation",
                    text: "Click at OK button to process Invoice Creation Request",
                    type: "info",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "#2196F3",
                    showLoaderOnConfirm: true
                },
                function() {
                     ws.bloader('.ivContentbloader',1);  
                    ws.ajax('/acp/invoice-create/'+i,function (data){
                        var part = JSON.parse(data);
                        ws.swal({
                            type: part[0],
                            title: part[1],
                            confirmButtonColor: "#2196F3"
                        });
                        window.location="/admin/invoice-edit/"+part[2];
                         ws.bloader('.ivContentbloader',2);  
                    });
                });
        },
        invoice_items : function (){
             ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/invoice-items/'+ws.invoice_id,function (data){
                $("#invoiceitems").html(data);
                ws.invoice_header();
                 ws.bloader('.ivContentbloader',2);  
            });
        },
        invoice_del_item : function (i)
        {
         ws.swal({
                    title: "Delete Item",
                    text: "Click at OK button to process Deletion Request",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "#ff0000",
                    showLoaderOnConfirm: true
                },
                function() {
                     ws.bloader('.ivContentbloader',1);  
                    ws.ajax('/acp/invoice-item-delete/'+ws.invoice_id+'/'+i,function (data){
                        var part = JSON.parse(data);
                        ws.swal({
                            type: part[0],
                            title: part[1],
                            confirmButtonColor: "#2196F3"
                        });
                        ws.invoice_items();
                         ws.bloader('.ivContentbloader',2);  
                    });
                });
        },
        invoice_item_form : function(e){
             ws.bloader('.ivContentbloader',1);
            ws.fs('/acp/invoice-item-add/',$(e),function(data){
                var part = JSON.parse(data);
                if(part[0] == 1){
                    ws.invoice_items(); 
                }
                ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});                            
                 ws.bloader('.ivContentbloader',2);
            });
        },
        invoice_add_payment_form : function(e){
            ws.bloader('.ivContentbloader',1);
            ws.fs('/acp/invoice-add-payment/',$(e),function(data){
                var part = JSON.parse(data);
                if(part[0] == 1){
                    ws.invoice_items();                                   
                }
                ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});                            
                ws.bloader('.ivContentbloader',2);
            });
        },
        invoice_options_form : function(e){
            ws.bloader('.ivContentbloader',1);
            ws.fs('/acp/invoice-options/',$(e),function(data){
                var part = JSON.parse(data);
                if(part[0] == 1){
                    ws.invoice_items(); 
                }
                ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});                            
                ws.bloader('.ivContentbloader',2);
            });
        },
        invoice_notes_form : function(e){
            ws.bloader('.ivContentbloader',1);
            ws.fs('/acp/invoice-notes/',$(e),function(data){
                var part = JSON.parse(data);
                ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});
                ws.bloader('.ivContentbloader',2);
            });
        },
        addInvoiceItemForm : function (i){
             ws.bloader('.ivContentbloader',1);
             ws.ajax('/acp/addInvoiceItemForm/'+i,function(data){
                 ws.bloader('.ivContentbloader',2);
                 ws.modal(data,'M');
            });
            return false;
        },
        splitInvoiceForm : function (i){
             ws.bloader('.ivContentbloader',1);
             ws.ajax('/acp/splitInvoiceForm/'+i,function(data){
                 ws.bloader('.ivContentbloader',2);
                 ws.modal(data,'M');
            });
            return false;
        },
        split_invoice_create : function(e){
            ws.bloader('.ivContentbloader',1);
            ws.fs('/acp/split-invoice-create',$(e),function(data)
            {
                var part = JSON.parse(data);
                ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});
                if(part[0] == 1)
                {
                    var rd = part[3];
                    if(rd == "Old")
                    {
                        location.reload();    
                    }
                    else
                    {
                        window.location="/admin/invoice-edit/"+part[2];
                    }
                }
                ws.bloader('.ivContentbloader',2);
            });
        },
        invoice_predefine_item_form : function(e){
            ws.bloader('.ivContentbloader',1);
            ws.fs('/acp/invoice-predefine-item-add/',$(e),function(data){
                var part = JSON.parse(data);
                if(part[0] == 1){                                        
                    ws.invoice_items(); 
                    $("#ConfigOtherOptions").html('');                                   
                    $("#ProductDurationOptions").html('');                                   
                    $("#ProductOptions").val('');                                   
                }
                ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});                            
               ws.bloader('.ivContentbloader',2);
            });
        },
        invoice_client_item_form : function(e){
            ws.bloader('.ivContentbloader',1);
            ws.fs('/acp/invoice-client-item-add/',$(e),function(data){
                var part = JSON.parse(data);
                if(part[0] == 1){                                        
                    ws.invoice_items(); 
                    $("#ConfigOtherOptionsByService").html(''); 
                    $("#ProductOptionsByService").val('');                                   
                }
                ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});                            
               ws.bloader('.ivContentbloader',2);
            });
        },
        invoice_product_duration : function (i){
            this.product_id=i;
             ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/invoice-product-duration/'+ws.invoice_id+'/'+i,function (data){
                $("#ProductDurationOptions").html(data);
                 ws.bloader('.ivContentbloader',2);  
            });
        },
        invoice_config_options : function (i){
             ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/invoice-config-options-by-product/'+ws.invoice_id+'/'+ws.product_id+'/'+i+'/0',function (data){
                $("#ConfigOtherOptions").html(data);
                 ws.bloader('.ivContentbloader',2);  
            });
        },
        invoice_config_options_by_service : function (p,i,s){
             ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/invoice-config-options-by-service/'+ws.invoice_id+'/'+p+'/'+i+'/'+s,function (data)
            {
                $("#ConfigOtherOptionsByService").html(data);
                 ws.bloader('.ivContentbloader',2);  
            });
        },
        invoice_download_pdf : function ()
        {
            ws.ajax('/acp/invoice_download_pdf/'+ws.invoice_id,function (data){
            });
        },
        invoice_delete : function (ids=0)
        {
        var ivs =ws.getDecimalCount(ids);
        var idsList = ws.invoice_id>0 ? ws.invoice_id:ids;                
         ws.swal({
                    title: "Delete Invoice",
                    text: "Click at OK button to Delete "+ivs+" Invoice",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "#ff0000",
                    showLoaderOnConfirm: true
                },
                function() {
                     ws.bloader('.ivContentbloader',1);  
                    ws.ajax('/acp/invoice-delete/'+idsList,function (data){
                    var part = JSON.parse(data);
                    if(part[0] == 1){
                        if(ivs>1){
                            location.reload();
                        }else{
                            if(part[2].length > 2)
                            {
                                window.location=part[2];
                            }
                        }
                    }
                    ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});                            
                     ws.bloader('.ivContentbloader',2);  
                    });
                });
        },
        invoice_del_pay_entry : function (i,t){                        
         ws.swal({
                    title: "Delete Payment Transaction",
                    text: "Click at OK button to Delete Payment Transaction",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "#ff0000",
                    showLoaderOnConfirm: true
                },
                function() {
                     ws.bloader('.ivContentbloader',1);  
                    ws.ajax('/acp/invoice-delete-payment-transaction/'+ws.invoice_id+'/'+i+'/'+t,function (data){
                    var part = JSON.parse(data);
                    if(part[0] == 1){
                        ws.invoice_items();
                    }
                    ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});                            
                     ws.bloader('.ivContentbloader',2);  
                    });
                });
        },
        credits_delete : function (u,i){                        
         ws.swal({
                    title: "Delete Credit",
                    text: "Click at OK button to Delete Credit Entry",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "#ff0000",
                    showLoaderOnConfirm: true
                },
                function() {
                     ws.bloader('.ivContentbloader',1);  
                    ws.ajax('/acp/client-credit-delete/'+u+'/'+i,function (data){
                    var part = JSON.parse(data);
                    if(part[0] == 1){                                     
                        location.reload();
                    }
                    ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});                            
                     ws.bloader('.ivContentbloader',2);  
                    });
                });
        },
        invoice_credit_add : function (e){                        
            ws.bloader('.ivContentbloader',1);
            ws.fs('/acp/invoice-credit-add/',$(e),function(data){
                var part = JSON.parse(data);
                if(part[0] == 1){
                   ws.invoice_items();
                }
                ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});                            
               ws.bloader('.ivContentbloader',2);
            });
        },
        invoice_credit_remove : function (e)
        {
            ws.swal({
                title: "Delete",
                text: "Click at OK button to Delete",
                type: "error",
                showCancelButton: true,
                closeOnConfirm: false,
                confirmButtonColor: "green",
                showLoaderOnConfirm: true
            },
            function() {            
                ws.bloader('.ivContentbloader',1);
                ws.fs('/acp/invoice-credit-remove/',$(e),function(data){
                    var part = JSON.parse(data);
                    if(part[0] == 1){
                       ws.invoice_items();
                    }
                    ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});                            
                    ws.bloader('.ivContentbloader',2);
                });
            });
        },
        GetTransactionInfo : function (i=0){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/GetTransactionInfo/'+i,function (data){
            ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'S');
            });
        },
        credit_form : function (i,t,r){
            ws.reload_aca=r;
             ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/credit-form/'+i+'/'+t,function (data){
             ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'S');
            });
        },
        invoice_funds_create_form : function (i){
             ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/invoice-funds-create-form/'+i,function (data){
             ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'S');
             daterange_singles();
            });
        },
        invoice_funds_added : function (e){                        
            ws.bloader('.ivContentbloader',1);
            ws.fs('/acp/invoice-funds-added/',$(e),function(data){
                var part = JSON.parse(data);
                if(part[0] == 1){
                     
                    ws.modal('','N');  
                    $("#whmbcs-clear-form").click(); 
                    ws.swal({
                        title: part[1],
                        type: part[0],
                        confirmButtonColor: "#2196F3"
                    });
                    window.location="/admin/invoice-edit/"+part[2];
                }else{
                    ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});                                                                      
                }                            
               ws.bloader('.ivContentbloader',2);
            });
        },
        invoice_refund_form : function (i){
             ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/invoice-refund-form/'+ws.invoice_id+'/'+i,function (data){
             ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'S');
             daterange_singles();
            });
        },
        invoice_refunded : function (e){                        
            ws.bloader('.ivContentbloader',1);
            ws.fs('/acp/invoice-refunded/',$(e),function(data){
                var part = JSON.parse(data);
                if(part[0] == 1){                                     
                    ws.modal('','N');  
                    $("#whmbcs-clear-form").click(); 
                        ws.invoice_items();
                }
                ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});                            
                ws.bloader('.ivContentbloader',2);
            });
        },
        client_credit_add : function (e){                        
            ws.bloader('.ivContentbloader',1);
            ws.fs('/acp/client-credit-add/',$(e),function(data){
                var part = JSON.parse(data);
                if(part[0] == 1){                                     
                    ws.modal('','N');  
                    $("#whmbcs-clear-form").click(); 
                    if(ws.reload_aca == 1){
                        location.reload();
                    }else{
                        ws.invoice_header();
                    }                                  
                }
                ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});                            
                ws.bloader('.ivContentbloader',2);
            });
        },
        client_credit_remove : function (e)
        {
            ws.swal({
                title: "Delete",
                text: "Click at OK button to Delete",
                type: "error",
                showCancelButton: true,
                closeOnConfirm: false,
                confirmButtonColor: "green",
                showLoaderOnConfirm: true
            },
            function() {            
                ws.bloader('.ivContentbloader',1);
                ws.fs('/acp/client-credit-remove/',$(e),function(data){
                    var part = JSON.parse(data);
                    if(part[0] == 1){
                         
                        ws.modal('','N'); 
                        $("#whmbcs-clear-form").click();                                   
                        if(ws.reload_aca == 1){
                            location.reload();
                        }else{
                            ws.invoice_header();
                        }                                  
                    }
                    ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});                            
                    ws.bloader('.ivContentbloader',2);
                });
            });
        },                    
        quote_id : 0,
        product_id : 0,
        quote_init : function (i,s,c){
            this.quote_id = i; 
            this.quote_client_show_hide(s); 
            this.quote_items();                      
            this.quote_link_change(c);                      
        },
        quote_invoices_count : function (i){
            if(i == 1){
                $('.quoteSingleInvoice').removeClass('hide');
                $('.quoteMoreInvoice').addClass('hide');
            }
            else if(i == 2){
                $('.quoteSingleInvoice').addClass('hide');
                $('.quoteMoreInvoice').removeClass('hide');
            }else{
                $('.quoteSingleInvoice, .quoteMoreInvoice').addClass('hide');                            
            }

        },
        quote_link_change : function (i){
            $('#qCp').html('<a href="/admin/client-profile/'+i+'" class="wsLoadPageLink btn btn-default" target="_blank">Client Profile</a>');
        },                    
        quote_download_pdf : function (){
            ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/quote_download_pdf/'+ws.quote_id,function (data){
                 $("#quote-pdf-content").html(data);
                ws.bloader('.ivContentbloader',2);
            });
        },
        quote_items : function (){
            ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/quote-items/'+ws.quote_id,function (data){
                $("#quoteitems").html(data);
                ws.bloader('.ivContentbloader',2);
            });
        },
        quote_product_duration : function (i){
            $(".ws-quote-modal-loader").removeClass('hide');
            this.product_id=i;
            ws.ajax('/acp/quote-product-duration/'+ws.quote_id+'/'+i,function (data){
                $("#ProductDurationOptions").html(data);
                $(".ws-quote-modal-loader").addClass('hide');
            });
        },
        quote_config_options : function (i){
            $(".ws-quote-modal-loader").removeClass('hide');
            ws.ajax('/acp/config-options-by-product/'+ws.quote_id+'/'+ws.product_id+'/'+i,function (data){
                $("#ConfigOtherOptions").html(data);
                $(".ws-quote-modal-loader").addClass('hide');
            });
        },
        quote_del_item : function (i){                        
         ws.swal({
                    title: "Delete Item",
                    text: "Click at OK button to process Deletion Request",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "#ff0000",
                    showLoaderOnConfirm: true
                },
                function() {
                    ws.ajax('/acp/quote-item-delete/'+ws.quote_id+'/'+i,function (data){
                        var part = JSON.parse(data);
                        ws.swal({
                            title: part[1],
                            confirmButtonColor: "#2196F3"
                        });
                        ws.quote_items();
                    });
                });
        },
        quote_duplicate : function (i){                        
         ws.swal({
                    title: "Duplicate Quote",
                    text: "Click at OK button to process for Duplicate Quote Generation",
                    type: "info",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "#2196F3",
                    showLoaderOnConfirm: true
                },
                function() {
                    ws.ajax('/acp/quote-duplicate/'+ws.quote_id,function (data){
                    var part = JSON.parse(data);
                    if(part[0] == 1){
                         
                        if(part[2].length > 2){
                            window.location=part[2];
                        }
                    }
                    ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});                            

                    });
                });
        },
        quote_delete : function (i){                        
         ws.swal({
                    title: "Delete Quote",
                    text: "Click at OK button to Delete Quote",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "#ff0000",
                    showLoaderOnConfirm: true
                },
                function() {
                    ws.bloader('.ivContentbloader',1);  
                    ws.ajax('/acp/quote-delete/'+ws.quote_id,function (data){
                    var part = JSON.parse(data);
                    if(part[0] == 1){
                         
                        if(part[2].length > 2){
                            window.location=part[2];
                        }
                    }
                    ws.bloader('.ivContentbloader',2);  
                    ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});
                    });
                });
        },
        quote_convert_to_invoice_form : function(e){
                ws.bloader('.ivContentbloader',1);
                ws.fs('/acp/quote-convert-to-invoice/',$(e),function(data){
                var part = JSON.parse(data);
                if(part[0] == 1){
                     
                    $('#quote-convert-to-invoice').modal('toggle');
                    $("#quote-convert-to-invoice-clear-form").click();                                   
                   if(part[2] > 0){
                        window.location='/admin/invoice-edit/'+part[2];
                    }
                }
                ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});                            
                ws.bloader('.ivContentbloader',2);
            });
        },
        quote_item_form : function(e){
                $(".ws-quote-modal-loader").removeClass('hide');
                ws.fs('/acp/quote-item-add/',$(e),function(data){
                var part = JSON.parse(data);
                if(part[0] == 1){
                     
                    ws.quote_items(); 
                    $('#quote-custom-item-add').modal('toggle');
                    $("#quote-clear-form").click();                                   
                }
                ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});                            
                $(".ws-quote-modal-loader").addClass('hide');
            });
        },
        quote_predefine_item_form : function(e){
                ws.bloader('.ivContentbloader',1);
                ws.fs('/acp/quote-predefine-item-add/',$(e),function(data){
                var part = JSON.parse(data);
                if(part[0] == 1){
                     
                    ws.quote_items(); 
                    $('#quote-predifine-item-add').modal('toggle');
                    $("#quote-predifine-clear-form").click();                                   
                    $("#ConfigOtherOptions").html('');                                   
                    $("#ProductDurationOptions").html('');                                   
                    $("#ProductOptions").val('');                                   
                }
                ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});                            
                ws.bloader('.ivContentbloader',2);
            });
        },
        quote_form : function(e){
            ws.bloader('.ivContentbloader',1);
            ws.fs('/acp/quote-add-update/',$(e),function(data){
                var part = JSON.parse(data);
                if(part[0] == 1){
                     
                    if(part[2].length > 2){
                        window.location=part[2];
                    }
                    ws.quote_items();                                    
                }
                ws.swal({title: part[1],type: part[0],confirmButtonColor: "#2196F3"});
                ws.bloader('.ivContentbloader',2);
            });
        },
        DomainDnsChecks : function(domain){
            ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/apps/helper_tools/DoDomainDetails/'+domain,function (data){
                ws.modal(data,'L');
                ws.bloader('.ivContentbloader',2);
            });
        },
        UpdatesCheckForm : function(e){
            ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/UpdatesCheckForm/',function (data){
                ws.modal(data,'S');
                ws.bloader('.ivContentbloader',2);
            });
        },
        UpdateStart : function(e){
            ws.bloader('.ivContentbloader',1);
            $(".ws-upgrade-box").removeClass("alert-warning alert-danger alert-success").html("");
            ws.f('/acp/UpdateStart/',e,function(data){
                var part = JSON.parse(data);
                ws.swal({title: part.message,type: part.status,confirmButtonColor: "#2196F3"});
                ws.bloader('.ivContentbloader',2);
            });
            return false;
        },
        ChangeLicense : function(e){
            ws.bloader('.ivContentbloader',1);
            ws.f('/acp/ChangeLicense/',e,function(data){
                var part = JSON.parse(data);
                ws.swal({title: part.message,type: part.status,confirmButtonColor: "#2196F3"});
                ws.bloader('.ivContentbloader',2);
            });
            return false;
        },
        SearchAreaForm : function(e){
            ws.bloader('.ivContentbloader',1);
            ws.ajax('/acp/SearchAreaForm/',function (data){
                ws.modal(data,'S');
                ws.bloader('.ivContentbloader',2);
            });
        },
        SearchStart : function(e){
            ws.bloader('.ivContentbloader',1);
            ws.f('/acp/SearchStart/',e,function(data)
            {
                $(".ws-search-content").html(data);
                ws.bloader('.ivContentbloader',2);
            });
            return false;
        },
        server_connect : function (i){
            ws.loading('#whmbcs_errors','Connection  Checking Request Inprocess......');
            ws.ajax('/acp/server-connect/'+i,function (data){
                var part = JSON.parse(data);
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"}); 
                ws.loading('#whmbcs_errors','');
            });
        },
        mod_name : "",
        mod_svr_grp_id : 0,
        mod_item_id : 0,
        mod_pkg_name : "",
        packages_options : function (i){
            ws.mod_svr_grp_id = i;
            ws.server_groups(ws.mod_name,ws.mod_svr_grp_id,ws.mod_item_id,ws.mod_pkg_name);
        },
        server_groups : function (i,s,t,p){
            ws.mod_name = i;
            ws.mod_svr_grp_id = s;
            ws.mod_item_id = t;
            ws.mod_pkg_name = p;
            ws.bloader('.ivContentbloader',1,'Module Configuration Loading......');
            ws.ajax('/acp/server_groups/'+i+'/'+s+'/'+t+'/'+p,function (data){
                $(".module_content_section").html(data);
                 ws.radio_checks();
                ws.bloader('.ivContentbloader',2);
            });
        },
        domain_tld_sync_form : function (){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/domain_tld_sync_form/',function (data){
            ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'L');
            });
        },
        selected_registrar:"",
        domain_tld_sync_prices : function (i)
        {
            ws.selected_registrar=i;
            ws.loading('.domain_tld_sync_prices',"Your Request is being in process");  
            ws.ajax('/acp/domain_tld_sync_prices/'+i,function (data){
            $(".domain_tld_sync_prices").html(data);
            });
        },
        domain_tld_sync_save : function(e)
        {
            $(".ws-mod-btn").addClass("hide");
            this.loading('.domain_tld_sync_loader','Request Inprocess......');
            ws.f('/acp/domain_tld_sync_save/',e,function (data){
                 var part = JSON.parse(data); 
                if(part.status != 'error'){
                    ws.notify('success',part.message);
                    ws.domain_tld_sync_prices(ws.selected_registrar);
                }else{
                    ws.notify('error',part.message);                                                                
                }                            
                ws.loading('.domain_tld_sync_loader','');
                $(".ws-mod-btn").removeClass("hide");
            });                        
        },
        domain_vouchers_save : function(e)
        {
            ws.bloader('.ivContentbloader',1);
            ws.f('/acp/domain_vouchers_save/',e,function (data){
                var part = JSON.parse(data); 
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == 'success') location.reload();
                ws.bloader('.ivContentbloader',2);
            });                        
        },
        domain_vouchers_delete : function(e)
        {
            ws.bloader('.ivContentbloader',1);
            ws.f('/acp/domain_vouchers_delete/',e,function (data){
                var part = JSON.parse(data); 
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == 'success') location.reload();
                ws.bloader('.ivContentbloader',2);
            });                        
        },
        domain_tld_bulk_days_form : function (i){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/domain_tld_bulk_days_form/'+i,function (data)
            {
            ws.bloader('.ivContentbloader',2);  
                ws.modal(data,'L');
            });
        },
        domain_tld_bulk_days_save : function(e){
            ws.bloader('.ivContentbloader',1,'Request Inprocess......');
            ws.f('/acp/domain_tld_bulk_days_save/',e,function (data){
                 var part = JSON.parse(data); 
                if(part.status != 'error'){
                    ws.notify('success',part.message); 
                    ws.modal('','N');
                }else{
                    ws.notify('error',part.message);                                                                
                }                            
                ws.bloader('.ivContentbloader',2,'');
            });                        
        },
        domain_tld_pricings_form : function (i)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/domain_tld_pricings_form/'+i,function (data){
             ws.bloader('.ivContentbloader',2);  
            ws.modal(data,'S');
            });
        },
        domain_tld_pricings_save : function(e){
            ws.bloader('.ivContentbloader',1,'Request Inprocess......');
            ws.f('/acp/domain_tld_pricings_save/',e,function (data){
                 var part = JSON.parse(data); 
                if(part.status != 'error'){
                    ws.notify('success',part.message); 
                    ws.modal('','N');
                }else{
                    ws.notify('error',part.message);                                                                
                }                            
                ws.bloader('.ivContentbloader',2,'');
            });                        
        },
        domain_tld_info_config : function(i)
        {
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/domain_tld_info_config/'+i,function (data){
             ws.bloader('.ivContentbloader',2);  
             ws.modal(data,'S');
            });
        },
        domain_tld_change_options : function(i=0,t=0,s=0,o=[])
        {
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/domain_tld_change_options/'+i+'/'+t+'/'+s,function (data)
            {
                var part = JSON.parse(data); 
                if(part.status == 'success')
                {
                    if(s == 1)
                    {
                        o.attr("ts","0");
                        o.find("i").css("color","#ff0000");
                        if(t == 6)
                        {
                            o.find("i").addClass("whmbcsSuggested");
                        }
                        else if(t == 7)
                        {
                            o.find("i").addClass("whmbcsSpoted");
                        }else{
                            o.find("i").removeClass("icon-checkmark-circle").addClass("icon-cancel-circle2");
                        }
                    }
                    else
                    {
                        o.attr("ts","1");
                        o.find("i").css("color","#6ec462");
                        if(t == 6)
                        {
                            o.find("i").removeClass("whmbcsSuggested");
                        }
                        else if(t == 7)
                        {
                            o.find("i").removeClass("whmbcsSpoted");
                        }else{
                            o.find("i").removeClass("icon-cancel-circle2").addClass("icon-checkmark-circle");
                        }
                    }
                    ws.notify('success',part.message); 
                    ws.domain_tld_spots_list(true);
                }
                else
                {
                    ws.notify('error',part.message);                                                                
                }
                ws.bloader('.ivContentbloader',2);  
            });
        },
        domain_delete_tld : function (i)
        {
             ws.swal({
                    title: "Delete",
                    text: "Click at OK button to Delete",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                ws.bloader('.ivContentbloader',1);
                ws.ajax('/acp/domain_delete_tld/'+i,function (data){
                     var part = JSON.parse(data);
                     ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                    if(part.status == 'success')
                    {
                        ws.domain_tld_list();
                        ws.domain_tld_spots_list(false);
                    }
                    ws.bloader('.ivContentbloader',2);  
                });
            });
        },
        domain_tlds_delete : function ()
        {
             ws.swal({
                    title: "Delete",
                    text: "Click at OK button to Delete",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                ws.bloader('.ivContentbloader',1);
                var checkedCheckboxes = $('.ws-cbox-select:checked'); // Get all checked checkboxes
                var checkedValues = checkedCheckboxes.map(function() {
                    return $(this).val(); // Get values of checked checkboxes
                }).get();                
                 ws.bloader('.ivContentbloader',1);
                var e = $('<form/>').append($('<input/>', {name: 'tlds'}).val(checkedValues));                
                ws.fs('/acp/domain_tlds_delete',e,function(data){
                     var part = JSON.parse(data);
                     ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                    if(part.status == 'success')
                    {
                        ws.domain_tld_list();
                        ws.domain_tld_spots_list(false);
                    }
                    ws.bloader('.ivContentbloader',2);  
                });
            });
        },
        domain_tld_info_save : function (e){
             ws.bloader('.ivContentbloader',1,'Request Inprocess......');
             ws.f('/acp/domain_tld_info_save',e,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == 'success'){
                    ws.modal('','N');
                }
                 ws.bloader('.ivContentbloader',2,'');
             });
        },
        domain_tld_list : function (){
             ws.bloader('.ivContentbloader',1,'Request Inprocess......');
            ws.ajax('/acp/domain_tld_list/',function (data){
                $(".domainTldsList").html(data);
             ws.bloader('.ivContentbloader',2);  
            });                        
        },
        domain_tld_spots_list : function (isLoader=true){
            if(isLoader=true)
            {
                ws.bloader('.ivContentbloader',1,'Request Inprocess......');
            }
            ws.ajax('/acp/domain_tld_spots_list/',function (data){
                $(".whmbcsSpotLightsTlds").html(data);
                if(isLoader=true)
                {
                    ws.bloader('.ivContentbloader',2);  
                }
            });                        
        },
        domain_tld_delete_spotlight : function (i)
        {
             ws.swal({
                    title: "Delete",
                    text: "Click at OK button to Delete",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                ws.bloader('.ivContentbloader',1);  
                ws.ajax('/acp/domain_tld_delete_spotlight/'+i,function (data){
                    var part = JSON.parse(data);                           
                    ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                    if(part.status == 'success'){
                        ws.domain_tld_list();
                        ws.domain_tld_spots_list(false);
                    }
                ws.bloader('.ivContentbloader',2);  
                });
            });
        },
        ShowRegistrars:function(ishide=false)
        {
            if(ishide)
            {
                $(".ShowRegistrars").removeClass("hide");
            }
            else
            {
                $(".ShowRegistrars").addClass("hide");
            }
        },
        domain_lookup_providers_config : function(){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/domain_lookup_providers_config/',function (data){
                ws.bloader('.ivContentbloader',2); 
                ws.modal(data,'L');
            });
        },
        domain_lookup_providers_config_save : function(e){
             ws.bloader('.ivContentbloader',1,'Request Inprocess......');
             ws.f('/acp/domain_lookup_providers_config_save',e,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status == 'success'){
                    ws.modal('','N');
                }
                 ws.bloader('.ivContentbloader',2,'');
             });
        },
        domain_addons_config : function(){
            ws.bloader('.ivContentbloader',1);  
            ws.ajax('/acp/domain_addons_config/',function (data){
             ws.modal(data,'S');
            ws.bloader('.ivContentbloader',2);  
            });
        },
        domain_addons_config_save : function(e){
             ws.bloader('.ivContentbloader',1,'Request Inprocess......');
             ws.f('/acp/domain_addons_config_save',e,function(data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                if(part.status != 'error'){
                    ws.modal('','N');
                }
                 ws.bloader('.ivContentbloader',2,'');
             });
        },
        updateAutomationSettings : function (i,v){
            this.loading2('.whmbcsloaderIcons','Request Inprocess......');
            var e = $('<form/>').append($('<input/>', {name: i}).val(v));
            ws.fs('/acp/update-automation-settings-info/',e,function(data){
                var part = JSON.parse(data);
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                ws.loading2('.whmbcsloaderIcons','');
            });
        },
        updateTldOrdering : function (ids){
            this.loading2('.whmbcsloaderIcons','Request Inprocess......');
            var e = $('<form/>').append($('<input/>', {name: 'Ordering'}).val(ids));
            ws.fs('/acp/update-tld-Ordering/',e,function(data){
                var part = JSON.parse(data);
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                ws.loading2('.whmbcsloaderIcons','');
            });
        },
        updateServicesOrdering : function (ids){
            this.loading2('.whmbcsloaderIcons','Request Inprocess......');
            var e = $('<form/>').append($('<input/>', {name: 'Ordering'}).val(ids));
            ws.fs('/acp/update-services-ordering/',e,function(data){
                var part = JSON.parse(data);
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                ws.loading2('.whmbcsloaderIcons','');
            });
        },
        updateConfigGroupOrdering : function (ids){
            this.loading2('.whmbcsloaderIcons','Request Inprocess......');
            var e = $('<form/>').append($('<input/>', {name: 'Ordering'}).val(ids));
            ws.fs('/acp/update-config-group-ordering/',e,function(data){
                var part = JSON.parse(data);
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                ws.loading2('.whmbcsloaderIcons','');
            });
        },
        updateSupportDptOrdering : function (ids){
            this.loading2('.whmbcsloaderIcons','Request Inprocess......');
            var e = $('<form/>').append($('<input/>', {name: 'Ordering'}).val(ids));
            ws.fs('/acp/update-support-departments-ordering/',e,function(data){
                var part = JSON.parse(data);
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                ws.loading2('.whmbcsloaderIcons','');
            });
        },
        updateSupportStatusOrdering : function (ids){
            this.loading2('.whmbcsloaderIcons','Request Inprocess......');
            var e = $('<form/>').append($('<input/>', {name: 'Ordering'}).val(ids));
            ws.fs('/acp/update-support-status-ordering/',e,function(data){
                var part = JSON.parse(data);
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                ws.loading2('.whmbcsloaderIcons','');
            });
        },
        sall:function(all=true)
        {
            var ct = $('.ws-cbox-select').length;
            if(all)
            {
                $('.ws-cbox-select').prop('checked', $('.ws-cbox-all').is(":checked"));
            }
            else
            {
                var cl=$('.ws-cbox-select:checked').length;
                if (cl == ct)
                {
                    $('.ws-cbox-all').prop('checked',true);
                }
                else
                {
                    $('.ws-cbox-all').prop('checked',false);
                }
            }
            var cl=$('.ws-cbox-select:checked').length;
            if(cl>0)
            {
                 $(".ws-mod-btn").removeClass("hide");
            }
            else
            {
                $(".ws-mod-btn").addClass("hide");
            }
        },
        calendarFeeds : '',
        calendarInit : 0,
        eCalendarStartDate : '',
        eCalendarEndDate : '',
        eCalendarMonthDate : '',
        calendarInitialize : function(){
            ws.calendarInit=0;
            ws.ajax('/acp/get-calendar-configs',function (data){
            var part = JSON.parse(data);
            ws.eCalendarMonthDate = part.month;
            ws.eCalendarStartDate = part.from;
            ws.eCalendarEndDate = part.to;
            ws.loading2('.whmbcsloaderIcons','');
            var eventCalendar = '';
            $.each($(".calendarCheckBoxes:checked"), function(){
            eventCalendar += $(this). val()+'-';
            });
            ws.set('eventCalendar',eventCalendar);
            ws.eventCalendar();
            });
        },
        eventCalendarSetFeeds : function (){
            var eventCalendar = '';
            $.each($(".calendarCheckBoxes:checked"), function(){
            eventCalendar += $(this). val()+'-';
            });
            ws.set('eventCalendar',eventCalendar);
            ws.eventCalendar();
        },
        eventCalendarAddEdit : function (e){
            this.loading2('.whmbcsloaderIcons','Request Inprocess......');
            ws.fs('/acp/calendar-event-add-update/',$(e),function(data){
                var part = JSON.parse(data);   
                if(part.status == 'success'){                                     
                    ws.eventCalendarEmpty(0,'','','','',false);
                    ws.calendarInitialize();
                }
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});                            
                ws.loading2('.whmbcsloaderIcons','');
            });
        },
        eventCalendarDelete : function ()
        {
             ws.swal({
                    title: "Delete",
                    text: "Click at OK button to Delete",
                    type: "error",
                    showCancelButton: true,
                    closeOnConfirm: false,
                    confirmButtonColor: "green",
                    showLoaderOnConfirm: true
                },
                function() {
                ws.loading2('.whmbcsloaderIcons','Request Inprocess......');
                ws.ajax('/acp/calendar-event-delete/'+$('.whmbcsi').val(),function (data){
                    var part = JSON.parse(data);
                     if(part.status == 'success'){                                                
                        ws.eventCalendarEmpty(0,'','','','',false);
                        ws.calendarInitialize();
                    }
                    ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});                            
                    ws.loading2('.whmbcsloaderIcons','');
                });
            });
        },
        eventCalendarEmpty : function (id,title,description,start,end,allDay){
           $('#modal_small').modal('toggle');
           $('.whmbcst').val(title);
           $('.whmbcsi').val(id);
           $('.whmbcsd').val(description);
           $('.whmbcsdf').val(start);
           $('.whmbcsdt').val(end);                                         
           if( allDay == true){
                $('.whmbcsadc > label > div > span').addClass('checked');
                $('.whmbcsad').prop( "checked", true );
            }else{
                $('.whmbcsadc > label > div > span').removeClass('checked');
                $('.whmbcsad').prop( "checked", false );                                            
            }                                                 
        },
        eventCalendar : function (){                        
              // Event background colors
             this.loading2('.whmbcsloaderIcons','Request Inprocess......');
            
            $('#event-calendar').fullCalendar('destroy');
            $('#event-calendar').fullCalendar({
             header: {left: 'prev,next',center: 'title',right: 'month,agendaWeek,agendaDay'},
            //defaultDate: today,
            //timeZone: 'local',
            height: $(window).height() - 210,
            defaultDate: moment(ws.eCalendarMonthDate),                        
            selectable: true,
            selectHelper: true,
            editable: true,
            weekends: false,
            refetchResourcesOnNavigate: false,
            eventLimit: true, // allow "more" link when too many events
            eventClick: function (event, jsEvent, view) {
               var start =  moment(event.start).format("YYYY-MM-DD");
               var end = '';
               if(event.allDay == true){
                end = start;
               }else{
               end =  moment(event.end).format("YYYY-MM-DD");                           
               }
                ws.eventCalendarEmpty(event.id,event.title,event.description,start,end,event.allDay);
            },
            select: function(start, end) {
                ws.eventCalendarEmpty(0,'','',start.format(),start.format(),false);
            },
            events: function(start, end, timezone, callback) {
                var starts = start.format();
                var ends = end.format();
                var months = $("#event-calendar").fullCalendar('getDate').month();
                 ws.loading2('.whmbcsloaderIcons','Request Inprocess......');
                if(ws.calendarInit == 0){
                    ws.calendarInit +=1;
                    starts =ws.eCalendarStartDate;
                    ends = ws.eCalendarEndDate;
                }
                ws.ajax('/acp/get-calendar-feeds/'+starts+'/'+ends+'/'+ws.get('eventCalendar'),function (data)
                {
                    var res = JSON.parse(data);
                    callback(res);
                    //$('#event-calendar').fullCalendar('refetchEvents');
                    ws.loading2('.whmbcsloaderIcons','');
                });
            }
            });
        }
    }                
var Firewall = {
    url:"/acp/apps/firewall/",
    copy : function (i){
      let textarea = document.getElementById(i);
      textarea.select();
      document.execCommand("copy");
      $(".fwTextAlerts").html("Copied Text");
    },
    SetUrl: function(name)
    {
        ws.set("FwUrl",name);
        Firewall.LoadApps();
    },
    LoadApps: function (){
        var name = ws.get("FwUrl");
        if (name === null) {
         ws.set("FwUrl","Fw-apps");
        }    
        name = ws.get("FwUrl");
        $(".Firewall-tabs-li").removeClass("active");
        $(".Firewall-tabs-li").find("a").attr("aria-expanded",false);
        $(".TabFw"+name).addClass("active");
        $(".TabFw"+name).find("a").attr("aria-expanded",true);
    
        var str_pos = name.indexOf("browse-apps");
        if(str_pos > -1){
        $(".fw-tab-browse-apps").addClass("active");
        $(".fw-tab-browse-apps").find("a").attr("aria-expanded",true);        
        }
        ws.bloader(".ivContentbloader",1);
        $.ajax({
               type: "GET",
               url: Firewall.url+""+name,
               success: function(returnValue){
                $(".apps-content").html(returnValue);
                 ws.bloader(".ivContentbloader",2);
                },
                error: function(request,error) {
                     console.log(request, error);
                 ws.bloader(".ivContentbloader",2);
                }
        });
    
    },    
    SystemHealth : function(i){
        ws.bloader('.ivContentbloader',1);
        ws.ajax(Firewall.url+'SystemHealth/',function (data){
        ws.bloader('.ivContentbloader',2);  
        ws.modal(data,'L');
        });
    },    
    AddEditBotForm : function(i){
        ws.bloader('.ivContentbloader',1);
        ws.ajax(Firewall.url+'AddEditBotForm/'+i,function (data){
        ws.bloader('.ivContentbloader',2);  
        ws.modal(data,'S');
        });
    },
    AddEditBotSave : function(e){
        ws.bloader('.ivContentbloader',1);  
        ws.f(Firewall.url+'AddEditBotSave',e,function(data){
            var part = JSON.parse(data);                           
            ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
            Firewall.LoadApps();
             ws.bloader('.ivContentbloader',2);  
        });        
    },    
    AddEditRuleForm : function(i){
        ws.bloader('.ivContentbloader',1);
        ws.ajax(Firewall.url+'AddEditRuleForm/'+i,function (data){
        ws.bloader('.ivContentbloader',2);  
        ws.modal(data,'S');
        });
    },
    AddEditRuleSave : function(e){
        ws.bloader('.ivContentbloader',1);  
        ws.f(Firewall.url+'AddEditRuleSave',e,function(data){
            var part = JSON.parse(data);                           
            ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
            Firewall.LoadApps();
             ws.bloader('.ivContentbloader',2);  
        });        
    },
    SaveConfigurations : function(e){
        ws.bloader('.ivContentbloader',1);  
        ws.f(Firewall.url+'SaveConfigurations',e,function(data){
            var part = JSON.parse(data);                           
            ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
            Firewall.LoadApps();
             ws.bloader('.ivContentbloader',2);  
        });        
    },
    DeleteCustomBot : function(i)
    {
         ws.swal({
                title: "Delete",
                text: "Click at OK button to Delete",
                type: "error",
                showCancelButton: true,
                closeOnConfirm: false,
                confirmButtonColor: "green",
                showLoaderOnConfirm: true
            },
            function() {
            ws.bloader('.ivContentbloader',1);
            ws.ajax(Firewall.url+'DeleteCustomBot/'+i,function (data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                ws.bloader('.ivContentbloader',2);  
               Firewall.LoadApps();
            });
        });
    },    
    IpWhiteForm : function(type=""){
        ws.bloader('.ivContentbloader',1);
        ws.ajax(Firewall.url+'IpWhiteForm/'+type,function (data){
        ws.bloader('.ivContentbloader',2);  
        ws.modal(data,'S');
        });
    },
    IpWhiteSave : function(e)
    {
        ws.bloader('.ivContentbloader',1);  
        ws.f(Firewall.url+'IpWhiteSave',e,function(data){
            var part = JSON.parse(data);                           
            ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
            Firewall.LoadApps();
             ws.bloader('.ivContentbloader',2);  
        });        
    },    
    IpBlockForm : function(ip="",reason=""){
        ws.bloader('.ivContentbloader',1);
        ws.ajax(Firewall.url+'IpBlockForm/',function (data){
        ws.bloader('.ivContentbloader',2);  
            ws.modal(data, 'S');
            $("input[name='ip']").val(ip);
            $("textarea[name='reason']").val(reason);
        });
    },
    IpBlockSave : function(e){
        ws.f(Firewall.url+'IpBlockSave',e,function(data){
            var part = JSON.parse(data);                           
            ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
            Firewall.LoadApps();
             ws.bloader('.ivContentbloader',2);  
        });        
    },    
    IpHitsHistory : function(i){
        ws.bloader('.ivContentbloader',1);
        ws.ajax(Firewall.url+'IpHitsHistory/'+i,function (data){
        ws.bloader('.ivContentbloader',2);  
        ws.modal(data,'L');
        });
    },
    IpHitsHistoryClear : function(i){
        ws.bloader('.ivContentbloader',1);
        ws.ajax(Firewall.url+'IpHitsHistoryClear/'+i,function (data){
            var part = JSON.parse(data);                           
            ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
            ws.bloader('.ivContentbloader',2);  
           Firewall.LoadApps();
        });
    },
    IpRemoveFromWhitelist : function(i)
    {
        ws.swal({
            title: "Delete",
            text: "Click at OK button to Delete",
            type: "error",
            showCancelButton: true,
            closeOnConfirm: false,
            confirmButtonColor: "green",
            showLoaderOnConfirm: true
        },
        function() {            
            ws.bloader('.ivContentbloader',1);
            ws.ajax(Firewall.url+'IpRemoveFromWhitelist/'+i,function (data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                ws.bloader('.ivContentbloader',2);  
               Firewall.LoadApps();
            });
        });
    },
    IpRemove : function(i)
    {
        ws.swal({
            title: "Delete",
            text: "Click at OK button to Delete",
            type: "error",
            showCancelButton: true,
            closeOnConfirm: false,
            confirmButtonColor: "green",
            showLoaderOnConfirm: true
        },
        function(){
            ws.bloader('.ivContentbloader',1);
            ws.ajax(Firewall.url+'IpRemove/'+i,function (data){
                var part = JSON.parse(data);                           
                ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
                ws.bloader('.ivContentbloader',2);  
               Firewall.LoadApps();
            });
        });
    },
    CategoryDocumentForm : function(i)
    {
        $(".TabDmDocumentations").click();
        $(".TabDmDocumentations").removeClass("hide");
        ws.bloader('.ivContentbloader',1);
        ws.ajax(Firewall.url+'CategoryDocumentForm/'+i,function (data){
        ws.bloader('.ivContentbloader',2);  
        $(".apps-content").html(data);
        
        });
    },
    DocContentSaveChanges : function(e)
    {
        ws.bloader('.ivContentbloader',1);  
        ws.f(Firewall.url+'DocContentSaveChanges',e,function(data){
            var part = JSON.parse(data);                           
            ws.swal({title: part.message,type:part.status,confirmButtonColor: "#2196F3"});
            ws.bloader('.ivContentbloader',2);  
        });        
    }
}
$(document).ready(function()
{
    //ws.GetNotificationsCount();
    $('a[data-toggle="tab"]').on('show.bs.tab', function(e) {
          ws.set('activeTab', $(e.target).attr('href'));
    });
    var activeTab = ws.get('activeTab');
    if(activeTab){
        $('.tabbable a[href="' + activeTab + '"]').tab('show');
    }
});

function daterange_singles (){
  $('.daterange-single').daterangepicker( {
            autoUpdateInput: false,
            singleDatePicker: true,
            showDropdowns: true,
            editable: false,
            maxYear: 2050,
            ranges: {
                'Today': [moment(), moment()],
                'Yesterday': [moment().subtract(1, 'days'), moment().subtract(1, 'days')],
                'Last 7 Days': [moment().subtract(6, 'days'), moment()],
                'Last 30 Days': [moment().subtract(29, 'days'), moment()],
                'This Month': [moment().startOf('month'), moment().endOf('month')],
                'Last Month': [moment().subtract(1, 'month').startOf('month'), moment().subtract(1, 'month').endOf('month')]
            },
            
            applyClass: 'btn-small bg-slate-600',
            cancelClass: 'btn-small btn-default'
        },
        function(start, end) {
            $('.daterange-ranges span').html(start.format('MMMM D, YYYY'));
        }).on('apply.daterangepicker', function(ev, picker) {
      $(this).val(picker.startDate.format('MM/DD/YYYY'));
  }).on('cancel.daterangepicker', function(ev, picker) {
      $(this).val('');
  });
  $('.daterange-basic').daterangepicker( {
            autoUpdateInput: false,
            showDropdowns: true,
            editable: false,
            ranges: {
                'Today': [moment(), moment()],
                'Yesterday': [moment().subtract(1, 'days'), moment().subtract(1, 'days')],
                'Last 7 Days': [moment().subtract(6, 'days'), moment()],
                'Last 30 Days': [moment().subtract(29, 'days'), moment()],
                'This Month': [moment().startOf('month'), moment().endOf('month')],
                'Last Month': [moment().subtract(1, 'month').startOf('month'), moment().subtract(1, 'month').endOf('month')]
            },
            
            applyClass: 'btn-small bg-slate-600',
            cancelClass: 'btn-small btn-default'
        },
        function(start, end) {
            $('.daterange-ranges span').html(start.format('MMMM D, YYYY') + ' &nbsp; - &nbsp; ' + end.format('MMMM D, YYYY'));
        }).on('apply.daterangepicker', function(ev, picker) {
      $(this).val(picker.startDate.format('MM/DD/YYYY') + ' - ' + picker.endDate.format('MM/DD/YYYY'));
  }).on('cancel.daterangepicker', function(ev, picker) {
      $(this).val('');
  });
}



    $(function() {
    // Date range picker
    // ------------------------------
    // Basic initialization
    ws.radio_checks();
daterange_singles();
 $('.daterange-singles').daterangepicker({
    singleDatePicker: true,
    showDropdowns: true,
    minYear: 1901,
    maxYear: parseInt(moment().format('YYYY'),10),
    autoUpdateInput: false,
      locale: {
          cancelLabel: 'Clear'
      }
  }).on('cancel.daterangepicker', function(ev, picker) {
      $(this).val('');
  });    
  });
    $(document).on("mouseover",".taskResolvedCircle",function()
    {
        $(this).addClass('icon-checkmark-circle').removeClass('icon-circle');
    }).on("mouseout",".taskResolvedCircle",function(){  
        $(this).removeClass('icon-checkmark-circle').addClass('icon-circle');
    });
    $(document).on("change",".wsir-sbase-inp-rates",function()
    {  
        var i = $(this).attr("irc");
        var m = $(this).attr("im");
        var v = $(this).val();
            v = (v > 0) ? v:0;
            m = (m > 0) ? m:1;
        var lc=i;
        lc++;
        for (l=lc; l <= 14; l++)
        {
            $(".wsirc-sbase-"+l).val(v);
        }
        lc--;
        for (l=lc; l <= 14; l++)
        {
            var c = ".wsirc-sother-"+l;
            var v = $(".wsirc-sbase-"+l).val();
                v = (v > 0) ? v:0;
            var b = $(c).attr("ib");
            var t = v*b;
                t = (t > 0) ? t.toFixed(0):0;
            $(c).val(t);
        }
    });
    $(document).on("change",".wsir-dbase-inp-rates",function()
    {  
        var i = $(this).attr("irc");
        var m = $(this).attr("im");
        var v = $(this).val();
        v = (v > 0) ? v:0;
        m = (m > 0) ? m:1;
        var lc=i;
        lc++;
        for (l=lc; l <= 14; l++)
        {
            var cm = $(".wsirc-dbase-"+l).attr("im");
                cm = (cm > 0) ? cm:0;
            var t = (v/m)*cm;
                t = (t > 0) ? t.toFixed(2):0;
            $(".wsirc-dbase-"+l).val(t);
        }
        lc--;
        for (l=lc; l <= 14; l++)
        {
            var c = ".wsirc-dother-"+l;
            var v = $(".wsirc-dbase-"+l).val();
                v = (v > 0) ? v:0;
            var b = $(c).attr("ib");
            var t = v*b;
                t = (t > 0) ? t.toFixed(0):0;
            $(c).val(t);
        }
    });
    $(document).on("change",".wsir-base-inp-rates",function()
    {  
        var i = $(this).attr("irc");
        var m = $(this).attr("im");
        var v = $(this).val();
            v = (v > 0) ? v:0;
            m = (m > 0) ? m:1;
        var lc=i;
        lc++;
        for (l=lc; l <= 14; l++)
        {
            var cm = $(".wsirc-base-"+l).attr("im");
                cm = (cm > 0) ? cm:0;
            var t = (v/m)*cm;
                t = (t > 0) ? t.toFixed(2):0;
            $(".wsirc-base-"+l).val(t);
        }
        lc--;
        for (l=lc; l <= 14; l++)
        {
            var c = ".wsirc-other-"+l;
            var v = $(".wsirc-base-"+l).val();
                v = (v > 0) ? v:0;
            var b = $(c).attr("ib");
            var t = v*b;
                t = (t > 0) ? t.toFixed(0):0;
            $(c).val(t);
        }
    });  
$(function() {
   dragula([document.getElementById('panels-target-left')]);
});
$(document).on("click",".ws-cbox-all",function()
{
    ws.sall();
});
$(document).on("click",".ws-tld-all",function()
{
    var act = $(this).attr("act");
    if(act == 0)
    {
        $(this).attr("act",1);
        $('.ws-tld-select').prop('checked',true);
    } 
    else
    {
        $(this).attr("act",0);
        $('.ws-tld-select').prop('checked',false);
    }
    var ct = $('.ws-tld-select').length;
    var cl=$('.ws-tld-select:checked').length;
    $(".ws-tld-imp").text(cl);
    if (cl == ct)
    {
        $(this).text("Selected All TLDs");
    }
    else
    {
        $(this).text("Select All TLDs");
    }
});
$(document).on("click",".ws-tld-select",function()
{
    var ct = $('.ws-tld-select').length;
    var cl=$('.ws-tld-select:checked').length;
    $(".ws-tld-imp").text(cl);
    if (cl == ct)
    {
        $('.ws-tld-all').attr("act",1).text("Selected All TLDs");
    }
    else
    {
        $('.ws-tld-all').attr("act",0).text("Select All TLDs");
    }
});
$(document).on("click",".wsLoadPageLink",function(event)
{
    //$(".content-wrapper").html("");
    event.preventDefault();
    var t = $(this).attr("target");
    var u = $(this).attr("href");
    if(t == "_blank")
    {
        //history.replaceState(null, null, u);
        window.open(u, '_blank');
    }else{
        ws.LoadPage(event,u);        
    }
});
$(document).on("click",".wsLoadModal",function(event)
{
    event.preventDefault();
    var t = $(this).attr("target");
    var u = $(this).attr("href");
    var ms = $(this).attr("ms");
    ws.LoadModalPage(u,ms);
});
$(document).on("click",".ws-reg-all",function()
{
    var reg = $(this).attr("reg");
    var act = $(this).attr("act");
    $('.ws-tld-'+reg).prop('checked',true);
    var ct = $('.ws-tld-select').length;
    var cl=$('.ws-tld-select:checked').length;
    var ctr = $('.ws-tld-'+reg).length;
    var clr=$('.ws-tld-'+reg+':checked').length;
    $(".ws-tld-imp").text(cl);
    if(ctr>0)
    {
        if (clr == ctr)
        {
            $('.ws-reg-all').attr("act",1).text("Selected TLDs associated with Registrar");
        }
        else
        {
            $('.ws-reg-all').attr("act",0).text("Select TLDs associated with Registrar");
        }
    }
    if (cl == ct)
    {
        $('.ws-tld-all').attr("act",1).text("Selected All TLDs");
    }
    else
    {
        $('.ws-tld-all').attr("act",0).text("Select All TLDs");
    }
});

/*
        tld_select:function(registrar="")
        {
            var ct = $('.ws-tld-select').length;
            if(registrar.length>0)
            {
                $('.ws-tld-select').prop('checked', $('.ws-tld-all').is(":checked"));
            }
            else
            {
                var cl=$('.ws-tld-select:checked').length;
                if (cl == ct)
                {
                    $('.ws-tld-all-text').text("Selected All TLDs");
                    $('.ws-tld-all').prop('checked',true);
                }
                else
                {
                    $('.ws-tld-all-text').text("Select All TLDs");
                    $('.ws-tld-all').prop('checked',false);
                }
            }
            var cl=$('.ws-tld-select:checked').length;
            if(cl>0)
            {
                 $(".ws-mod-btn").removeClass("hide");
            }
            else
            {
                $(".ws-mod-btn").addClass("hide");
            }

*/
$(document).ready(function() {
  $('.copy-inp-text').on('click', function()
  {

    var isInp = false;
    if ($(this).is('input')) isInp = true;
    if ($(this).is('textarea')) isInp = true;
    if(isInp)
    {
        $(this).select();
        try
        {
          // Copy the selected text to the clipboard
          document.execCommand('copy');
          ws.notify('success','Text copied to clipboard');
        }
        catch (err)
        {
          ws.notify('danger','Unable to copy text to clipboard');
          console.error('Unable to copy text to clipboard', err);
        }
    }else{
        var text = $(this).text();    
        navigator.clipboard.writeText(text).then(function()
        {
            ws.notify('success','Text copied to clipboard');
        }).catch(function(err) {
            ws.notify('danger','Unable to copy text to clipboard');
            console.error('Failed to copy text: ', err);
        });
    }
  });
});
$(document).on("click",".ws-cbox-select",function ()
{
    ws.sall(false);
});
$(document).on("click",".ws-mod-del-feature",function ()
{
    var checkedValues = $('.ws-cbox-select:checked').map(function() {
        return $(this).val();}).get(); // Convert the jQuery object to a standard array
    // Parse the values into feature IDs and item IDs
    var itemFeatures = {}; // Object to hold unique item IDs and their associated features
    checkedValues.forEach(function(value) {
        var [featureId, itemId] = value.split('.'); // Split the value into feature and item IDs
        if (!itemFeatures[itemId]) {
            itemFeatures[itemId] = [];
        }
        itemFeatures[itemId].push(featureId);
    });
    // Build the result
    var uniqueItems = Object.keys(itemFeatures); // Unique item IDs
    var featureString = Object.values(itemFeatures)
        .map(features => features.join('.')) // Join feature IDs for each item
        .join('.');
    ws.DoDelProductFeature(featureString,uniqueItems.join(', '));
});
$(document).on("click",".ws-mod-del-invoices",function ()
{
    var values = $('.ws-cbox-select:checked').map(function(){return $(this).val();}).get();
    var ids = String(values).replace(/,/g, '.');
    ws.invoice_delete(ids);
});
$(document).on("click",".domain_tld_change_options",function ()
{
    var t = $(this);
    var ti = t.attr("ti");
    var to = t.attr("to");
    var ts = t.attr("ts");
    ws.domain_tld_change_options(ti,to,ts,t);
});
$(document).on("click",".WsModal-container>.modal-header>.close,.modal-header>.close",function ()
{
    $('.WsModal').addClass("hide");
    $('.WsModal-container').removeClass('WsModal-lg');
    $(".WsModal-container").html(""); 
});

    // Handle input event
    // Prevent digits from being entered
    $(document).on('keypress','.digit-input', function(e) {
        // Get the character code of the key pressed
        var charCode = e.which ? e.which : e.keyCode;
        // Check if the key pressed is a digit (0-9)
        if (charCode < 48 || charCode > 57) e.preventDefault(); // Prevent input if it's a digit
    });
    $(document).on('input','.digit-input,.code-input', function(e) {
        // Allow only digits
        var v = this.value;
        if($(this).is('[dt-len]'))
        {
            var il = $(this).attr("dt-len");
            this.value = this.value.slice(0,il);  // Keep only the first digit
        }else{
            this.value=v;
        }
    });
    // Handle paste event
    $(document).on('paste','.digit-input', function(e) {
        var pasteData = (e.originalEvent || e).clipboardData.getData('text');
        // Prevent pasting if non-digits are included
        if (/\D/.test(pasteData)) {
            e.preventDefault();
        }
    });
    // Handle code paste event
    $(document).on('paste','.code-input', function(e)
    {
        var pasteData = (e.originalEvent || e).clipboardData.getData('text');
        var tlen = Number($(this).attr("dt-total"));
        var typ = $(this).attr("dt-type");
        // Check if the pasted data is exactly 6 digits
        if (typ == "N")
        {
            if(new RegExp("^\\d{" + tlen + "}$").test(pasteData)){
                // Prevent default paste action
                e.preventDefault();
                // Split the pasted data into an array of digits
                var digits = pasteData.split('');
                // Loop through each input field with the class 'digit-input'
                $('.code-input').each(function(index) {
                    // Assign each digit to the corresponding input field
                    $(this).val(digits[index]);
                });                
            }
        }
        if (pasteData.length === tlen && typ == "S")
        {
            // Prevent default paste action
            e.preventDefault();
            // Split the pasted data into an array of digits
            var digits = pasteData.split('');
            // Loop through each input field with the class 'digit-input'
            $('.code-input').each(function(index) {
                // Assign each digit to the corresponding input field
                $(this).val(digits[index]);
            });                
        }
    });
    let typingTimer; // Timer identifier
    const typingDelay = 800; // Time in milliseconds (e.g., 300ms)
    function WsAutoCalculatePrice(inputElement,classes)
    {
        let parts = classes.split(' '); // Split the class name by dashes
        let className = parts[parts.length - 1]; // Get the second-to-last part
        var table = "ws-tab-price-" + inputElement.attr("it");
        let columnIndex = inputElement.parent().index(); // Column index of current input
        let v = parseFloat(inputElement.val()) || 0;
        let im = parseFloat(inputElement.attr("im")) || 0;
        let ib = parseFloat(inputElement.attr("ib")) || 0;
        // Clear the timer on every keyup to debounce
        clearTimeout(typingTimer);
        // Set a new timer to fire the update after typing ends
        typingTimer = setTimeout(function() {
            // User has stopped typing, fire update logic
            $('.' + table + ' tr').each(function() {
                let inputs = $(this).find('.' + className);
                inputs.each(function(index) {
                    if (index >= columnIndex-1)
                    {
                        let cm = parseFloat($(this).attr("im")) || 0;
                        let cb = parseFloat($(this).attr("ib")) || 0;
                        let t = ((v * cb) * (cm / im));
                        t = (t > 0) ? t.toFixed(2) : 0;
                        $(this).val(t); // Update subsequent inputs
                    }
                });
            });
        }, typingDelay);
    }
    function WsAutoCalculatePriceTiers(inputElement,classes)
    {
        let parts = classes.split(' '); // Split the class name by dashes
        let className = parts[parts.length - 1]; // Get the second-to-last part        
        // Assuming the input element with the specific attribute
        let inputAttrValue = parseInt(inputElement.attr("it")) || 0; // Get the value of the 'attr' attribute from input        
        var table = "ws-tab-price-" + inputAttrValue;

        // Find all classes matching the pattern 'ws-tab-price-X'
        let matchingClasses = [];
        // Find all classes matching the pattern 'ws-tab-price-X'
        let allClasses = [];
        $('*[class*="ws-tab-price-"]').each(function() {
            // Loop through each element with classes containing "ws-tab-price-"
            let classes = $(this).attr('class').split(' ');
            classes.forEach(function(className) {
                let match = className.match(/^ws-tab-price-(\d+)$/); // Regex to find 'ws-tab-price-X'
                if (match) {
                    let lastDigit = parseInt(match[1]); // Extract the digit from the class
                    allClasses.push(className);// Add to the list if the last digit is greater
                    if (lastDigit > inputAttrValue)
                    {
                        matchingClasses.push(className); // Add to the list if the last digit is greater
                    }
                }
            });
        });
        // Loop through each row of the current table
        $(`.${table} tr`).each(function (rowIndex) {
            // Loop through each input in the current row
            $(this).find('input').each(function (inputIndex) {
                let inputValue = $(this).val(); // Get the value of the input

                // Set the input value in the same row and column of matching tables
                matchingClasses.forEach(function (tableClass) {
                    $(`.${tableClass} tr`).eq(rowIndex) // Select the same row in the matching table
                        .find('input') // Get all inputs in the row
                        .eq(inputIndex) // Select the corresponding input
                        .val(inputValue); // Set the value
                });
            });
        });
    }

    $(document).on('keyup', 'input[class*="ws-inputs-setup-prices-inp"],input[class*="ws-inputs-old-prices-inp"],input[class*="ws-inputs-rates-prices-inp"]', function() {
        let inputElement = $(this); // Save reference to the input
        let classes = $(this).attr('class'); // Get the full class name
        let oCheck = $(".WsAutoCalculatePriceOther").is(':checked');
        let dCheck = $('.WsAutoCalculatePrice').is(':checked');        
        if(dCheck) WsAutoCalculatePrice(inputElement,classes);
        if(oCheck) setTimeout(function(){WsAutoCalculatePriceTiers(inputElement,classes)},500);
    });



    $(document).on('keyup','.ws-update-prices-from-Register,.ws-update-prices-from-Transfer,.ws-update-prices-from-Renewal', function(e)
    {
        var mcheck = $(".tld-AutoCalculatePrice-Minus").is(':checked');
        if ($('.tld-AutoCalculatePrice').is(':checked'))
        {
            var did = $(this).attr("did");
            var val = $(this).val();
            let matchedClass = '';
            if ($(this).hasClass('ws-update-prices-from-Register')) {
                matchedClass = 'Register';
            } else if ($(this).hasClass('ws-update-prices-from-Transfer')) {
                matchedClass = 'Transfer';
            } else{
                matchedClass = 'Renewal';
            }        
            $('.ws-update-prices-to-'+matchedClass).each(function() 
            {
                var dyears = $(this).attr("dyears");
                var dbase = $(this).attr("dbase");
                var cv = $(this).val();
                var v = (val*dbase)*dyears;
                if(cv>0)
                {
                    $(this).val(v.toFixed(2));                    
                }else{
                    if(mcheck)
                    {
                        $(this).val(v.toFixed(2));
                    }else{
                        $(this).val('-1');                        
                    }
                }
            });
        }
    });

    $(document).on('keyup', 'input[class*="ws-update-prices-slab-from"]', function()
    {
        var mcheck = $(".tld-AutoCalculatePrice-Minus").is(':checked');
        if ($('.tld-AutoCalculatePrice').is(':checked'))
        {        
            let className = $(this).attr('class'); // Get the full class name
            let parts = className.split('-'); // Split the class name by dashes
            let matchedClass = parts[parts.length - 2]+'-'+parts[parts.length - 1]; // Get the second-to-last part
            var did = $(this).attr("did");
            var val = $(this).val();
            $('.ws-update-prices-slab-to-'+matchedClass).each(function() 
            {
                var dyears = $(this).attr("dyears");
                var dbase = $(this).attr("dbase");
                var cv = $(this).val();
                var v = (val*dbase)*dyears;
                if(cv>0)
                {
                    $(this).val(v.toFixed(2));                    
                }else{
                    if(mcheck)
                    {
                        $(this).val(v.toFixed(2));
                    }else{
                        $(this).val('-1');                        
                    }
                }
            });            
        }
    });